var AttachmentController = (function (AttachmentController) {
    var self = AttachmentController;

    self.drawList = function (listId, attachments) {
        var html = "";
        if (attachments && attachments.length > 0) {
            var IMAGES = ["png", "jpg", "gif", "jpeg"];
            var DOCUMENTS = ["doc", "pdf", "txt", "xls", "ppt", "docx", "xlsx", "log", "docm"];
            var ZIPS = ["zip", "tar", "rar", "gzip", "7z"];
            var MEDIA = ["mp3", "aac", "mp2", "wma", "m4a", "mp4", "wav"];
            var description;
            var owner;
            var date;
            var attachType;
            var attachClass;
            var docIcon = '<i class="fa fa-file-o fa-3x"></i>';
            for (var i = 0; i < attachments.length; i++) {
                for (var j = 0; j < attachments[i].files.length; j++) {
                    if (attachments[i].files[j].file_description) {
                        description = attachments[i].files[j].file_description;
                    } else {
                        description = "";
                    }
                    if (attachments[i].files[j].file_creator != null && attachments[i].files[j].file_creationDate != null) {
                        owner = 'By: ' + ALL_USERS[attachments[i].files[j].file_creator].name;
                        date = dateFormat(new Date(attachments[i].files[j].file_creationDate));
                    }

                    attachType = attachments[i].files[j].type_info;
                    attachClass = "other";
                    if (IMAGES.indexOf(attachType) != -1) {
                        attachClass = "attachment-image";
                    } else if (DOCUMENTS.indexOf(attachType) != -1) {
                        attachClass = "attachment-document";
                        switch (attachType) {
                            case "doc":
                            case "docx":
                                docIcon = '<i class="fa fa-file-word-o fa-3x"></i>';
                                break;
                            case "pdf":
                                docIcon = '<i class="fa fa-file-pdf-o fa-3x"></i>';
                                break;
                            case "xls":
                            case "xlsx":
                                docIcon = '<i class="fa fa-file-excel-o fa-3x"></i>';
                                break;
                            case "ppt":
                                docIcon = '<i class="fa fa-file-powerpoint-o fa-3x"></i>';
                                break;
                        }
                    } else if (MEDIA.indexOf(attachType) != -1) {
                        attachClass = "attachment-music";
                        docIcon = '<i class="fa fa-music fa-3x"></i>';
                    } else if (ZIPS.indexOf(attachType) != -1) {
                        attachClass = "attachment-zip";
                        docIcon = '<i class="fa fa-file-archive-o fa-3x"></i>';
                    }
                    if (attachClass == "attachment-image") {
                        var fileName = attachments[i].files[j].file_name;
                        var fileUrl = ClientAPI.rootURL + '/api/db/getfilattchmnt?objId=' + encodeURIComponent(attachments[i].id) + '&attachmentName=' + encodeURIComponent(fileName);

                        html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" parentId="' + attachments[i].id + '" attachmentId="' + attachments[i].files[j].file_id + '" attachmentName="' + attachments[i].files[j].file_name + '">'
                                + '<div class="content-left" attachmentName="' + attachments[i].files[j].file_name + '">'
                                + '<div class="content-left-avatar" style="padding: 0px 10px;"><div class="content-avatar" style="background-image: url(' + fileUrl + ')"></div></div>'
                                + '</div>'
                                + '<div class="content-center" style="padding:10px 40px;">'
                                + '<div class="subject truncate">' + description + '</div>'
                                + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                + '<div class="attach-date">' + date + '</div>'
                                + '</div>'
                                + '</a>'
                                + '<a href="" class="delete-item" parentId="' + attachments[i].id + '" attachmentName="' + attachments[i].files[j].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';

                    } else {
                        html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" parentId="' + attachments[i].id + '"attachmentId="' + attachments[i].files[j].file_id + '" attachmentName="' + attachments[i].files[j].file_name + '">'
                                + '<div class="content-left" style="padding: 0px 10px;text-indent:0px; margin-left:10px;">'
                                + docIcon
                                + '</div>'
                                + '<div class="content-center" style="padding-left:40px;">'
                                + '<div class="subject truncate">' + description + '</div>'
                                + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                + '<div class="attach-date">' + date + '</div>'
                                + '</div>'
                                + '</a>'
                                + '<a href="" class="delete-item" parentId="' + attachments[i].id + '" attachmentName="' + attachments[i].files[j].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                    }
                }
            }
            if (html != "") {
                $(listId).empty().append(html);
            }
        } else {
            $(listId).empty().append("<li class='center empty-list'>Empty list</li>");
        }
    };

    self.deleteAttachment = function (id, fileName, controller) {
        showActionDialog('Are you sure you want to remove this attachment?', 'Yes', function () {
            if (connection) {
                ClientAPI.deleteFileAttachment(id, fileName, function (err, data) {
                    controller.init();
                });
            }
            window.resolveLocalFileSystemURI(window.localStorage.getItem('folderPath') + fileName, function (fileEntry) {
                fileEntry.remove(function (entry) {
                    console.log("fileSystem remove success!");
                }, function (error) {
                    console.log("fileSystem remove error " + error.code);
                });
            }, function (error) {
                console.log("resolveLocalFileSystemURI error " + error.code);
            });
        }, "No", function () {
        });
    };

    self.openAttachment = function (url, id, name) {
        if (url != null && url != "") {
            if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                window.open(url, '_blank', 'location=yes');
            } else {
                window.plugins.FileOpener.openFile(url);
            }
        } else {
            if (id != null && name != null) {
                ViewNoteFunctions.openAttachment(id, name);
            }
        }
    };

    self.takePhoto = function (view, id, list , textLink , controller) {
          var permissions = cordova.plugins.permissions;
          if (permissions) {
            permissions.hasPermission(permissions.CAMERA, function(status){
                  if(!status.hasPermission) {
                    var errorCallback = function() {
                       alert('Camera permission is not turned on');
                     }
                     permissions.requestPermission(permissions.CAMERA, function(status) {
                        if(!status.hasPermission) {
                          errorCallback();
                        } else {
                            self.takePhotoImage(view, id, list , textLink , controller);
                        }
                     }, errorCallback);
                  } else {
                    self.takePhotoImage(view, id, list , textLink , controller);
                  }
            }, null);
          }
    }


    self.takePhotoImage = function (view, id, list , textLink ,controller) {
        console.log("AttachmentController -- takePhoto");
        $(view + " .popup-menu-backdrop" ).hide();
        $(view + " .attach-advanced-menu").hide();
        var pictureQuality = window.localStorage.getItem("pictureQuality");
        if (!pictureQuality) {
            window.localStorage.setItem("pictureQuality", "75");
            pictureQuality = "75";
        }
        var interval = setInterval(function () {
            navigator.camera.getPicture(function (mediaFiles) {
                showPromptDialog("Add description for attachment!", "Prompt", "Add", function () {
                    var attachDesc = $("#prompt-text-input-popup-field").val();
                    if (attachDesc != "") {
                        getAF(function (err, af) {
                            var splitovano = mediaFiles.split("/");
                            var name = splitovano[splitovano.length - 1].split(".")[0];
                            var type = splitovano[splitovano.length - 1].split(".")[1];

                            var params = {};
                            params['_af'] = af;
                            params['objId'] = id;
                            params['typeInfo'] = type;
                            params['description'] = attachDesc;

                            var options = new FileUploadOptions();
                            options.fileKey = "attachment";
                            options.fileName = name + "." + type;
                            options.mimeType = "image/jpeg";
                            options.chunkedMode = false;
                            options.params = params;

                            var url = encodeURI(ClientAPI.rootURL + "/api/db/attachfile");
                            var ft = new FileTransfer();
                            ft.upload(mediaFiles, url, function (r) {
                                alert("Attachment is successfully uploaded!");
                                var setDraw = setInterval(function () {
                                    controller.getAttachmentCount(function (count, attachment) {
                                        $(textLink).text("(" + count + ")");
                                        self.drawList(list, attachment);
                                        clearInterval(setDraw);
                                    });
                                }, 100);
                            }, function (error) {
                                alert("Error uploading picture!");
                                console.log("An error has occurred: Code = " + error.code);
                                console.log("upload error source " + error.source);
                                console.log("upload error target " + error.target);
                            }, options, true);
                        });
                    } else {
                        alert("Please add description!");
                    }
                }, "Cancel", function () {

                });
            }, function (e) {
                alert(e);
            }, {quality: pictureQuality, cameraDirection: Camera.Direction.BACK});
            clearInterval(interval);
        }, 100);
    };

    return self;
}(AttachmentController || {}));
