var DealCategoryController = (function (DealCategoryController)
{
    var self = DealCategoryController;
    var typeObject = "Deal";
    var table = models.dealCategoriesDBModel.name;

    self.synchronization = function (callback) {
        if (connection) {
            ClientAPI.getCategoriesForObjectType(typeObject, function (err, items) {
                if (items) {
                    db.deleteAllFromTable(table);
                    self.encode(items, function (results) {
                        dealCategories = results;
                        db.insertMultiple(table, [results], function (data) {
                        });
                        if (callback != null && typeof callback == "function") {
                            callback(results);
                        }
                    });
                } else {
                    if (callback != null && typeof callback == "function") {
                        callback();
                    }
                }
            });
        }
    };

    self.encode = function (items, callback) {
        var result = [];
        if (items != null) {
            if (items.length != null && items.length > 0) {
                for (var i = 0, max = items.length; i < max; i++) {
                    var resultItem = self.encodeItem(items[i]);
                    if (resultItem != null) {
                        result.push(resultItem);
                    }
                }
                if (callback != null && typeof callback == "function") {
                    callback(result);
                }
            } else {
                var resultItem = self.encodeItem(items);
                if (resultItem != null) {
                    result.push(resultItem);
                }
                if (callback != null && typeof callback == "function") {
                    callback(result);
                }
            }
        }
    };

    self.encodeItem = function (item) {
        if (item["_id"] != null) {

            var result = new Object();
            result['account-id'] = getTextTypeObject(item['_id'], 'text');
            result['color'] = "000000";
            result['created-at'] = getTextTypeObject(item['creationDate'], 'datetime');
            result['updated-at'] = getTextTypeObject(item['modificationDate'], 'datetime');
            result['elements-count'] = getTextTypeObject('0', 'integer');
            result['id'] = getTextTypeObject(item['_id'], 'integer');
            result['name'] = item['name'];

            return result;
        } else {
            return undefined;
        }
    };

    return self;
}(DealCategoryController || {}));