var DomainController = (function (DomainController)
{
    var self = DomainController;
    var table = models.domainDBModel.name;

    self.save = function (domain, callback) {
        db.insert(table, [domain], function () {
            if (callback != null && typeof callback == "function") {
                callback();
            }
        });
    };

    self.remove = function (id, callback) {
        db.deleteObject(table, "id", id, function () {
            if (callback != null && typeof callback == "function") {
                callback();
            }
        });
    };

    self.findAll = function (callback) {
        db.selectAll(table, function (data) {
            if (callback != null && typeof callback == "function") {
                var result = [];
                for (index in data) {
                    result.push(data[index].domain);
                }
                callback(result);
            }
        });
    };

    self.findByColumn = function (id, column, callback) {
        db.selectByColumn(table, column, id, function (data) {
            if (callback != null && typeof callback == "function") {
                var result = [];
                for (index in data) {
                    result.push(data[index].domain);
                }
                callback(result);
            }
        });
    };

    return self;
}(DomainController || {}));