var DraftController = (function (DraftController) {
    var self = DraftController;


    self.findAll = function(callback) {
        db.selectByQuery("SELECT * FROM draft ORDER BY [updated-at] DESC", [], "draft", function (data) {
            if (callback != null && typeof callback == "function") {
                callback(data);
            }
        });
    }

    self.deleteDraft = function (draftId, callback) {
        if (draftId) {
            db.deleteObject("draft", "id", draftId, function () {
                if(callback && typeof callback){
                    callback();
                }
            });
        } else {
            if(callback && typeof callback){
                callback();
            }
        }
    };

    self.deleteAllDraft = function (callback) {
        db.deleteAllFromTable("draft", function () {
            if(callback && typeof callback){
                callback();
            }
        });
    }

    self.draftCount = function (callback) {
        db.selectByQuery("SELECT count(*) FROM draft", [], "draft", function (data) {
          if(callback && typeof callback){
              callback(data);
          }
        });
    };

    self.checkIfNoteObjectExists = function (noteId, callback) {
        db.selectByQuery("SELECT * FROM draft WHERE [objectId] = ?", [noteId], "draft", function (data) {
            if(data && data[0]){
                callback(true);
            } else {
                callback(false);
            }
        });
    };

    return self;
}(DraftController || {}));
DraftController.deleteAllDraft
