var FeedController = (function (FeedController)
{
    var self = FeedController;
    self.findTime = null;
    self.getFeed = function (ids, start, end, callback) {
        if (connection) {
            var query = {};
            if (ids) {
              query.user_id = {$in: ids};
            }
            ClientAPI.getFeed(query, [['eventDate', -1]], start, end, function (err, data) {
                if (!err) {
                    if (callback != null && typeof callback == 'function') {
                        callback(data);
                    }
                }
            });
        }
    };

    self.search = function (search, ids, start, end, callback) {
        if (self.findTime) {
            clearTimeout(self.findTime);
        }

        self.findTime = setTimeout(function () {
            if (search.length > 0) {
                var pattern = new RegExp(search.trim().replace(' ', '|'), "i");
                var query  = {searchKeywords: pattern};
                if (connection) {
                    if (ids) {
                      query.user_id = {$in: ids};
                    }
                    ClientAPI.getFeed(query, [['eventDate', -1]], start, end, function (err, data) {
                        if (!err) {
                            if (callback != null && typeof callback == 'function') {
                                callback(data);
                            }
                        }
                    });
                }
            } else {
                if (callback != null && typeof callback == 'function') {
                    callback();
                }
            }
        }, 300);
    };
    return self;
}(FeedController || {}));
