var FeedListController = (function (FeedListController)
{
    var self = FeedListController;

    self.drawFeed = function(listDiv, data, append){
        showLoadingIndikator();
        var html = "";
        var $dashboardListMessage = $('#dashboard-list-message');

        for (var i = 0, max = data.length; i < max; i++) {
          var attachmentName = "";
          if (data[i].customData && data[i].customData !== "") {
              attachmentName = 'attachmentname="' + data[i].customData + '"';
          }
          // debugger;
          html += '<li style="min-height: 60px;">'
              + '<a class="list-elem" ' + attachmentName + ' immediateid="'
                  + data[i].immediateParent + '" refId="' + data[i].objectId + '" subjectType="' + data[i].objectType + '" userId="' + data[i].user_id + '">'
              + self.drawAvatar(data[i].user_id)
              + '<div class="content-center" style="padding-left: 45px;">'
              + self.drawEventType(data[i])
              + '</div>'
              + '</a></li>';
        }
        if (!append) {
          listDiv.empty();
        }
        listDiv.append(html);

        if ($("li", listDiv).length == 0) {
          $dashboardListMessage.show();
        } else {
          $dashboardListMessage.hide();
        }
        hideLoadingIndikator();
    };



    self.drawEventType = function(item) {
      var html =  "";
      switch (item.eventType) {
        case "Update":
              var createOrUpdateText  = item.objectType === "Note" ?
                Messages.Dashboard.isAddedOn : Messages.Dashboard.isUpdatedOn;
              html = self.drawTitleCreatedOrUpdatedItem(item, createOrUpdateText);
          break;
        case "Create":
              var createOrUpdateText  = item.objectType === "Note" ?
                Messages.Dashboard.isAddedOn : Messages.Dashboard.isCreatedOn;
              html = self.drawTitleCreatedOrUpdatedItem(item, createOrUpdateText);
          break;
        case "GrantedAccess":
            html = self.drawTitleGrantedAccess(item);
          break;
        case "NewFileAttachment":
            html = self.drawTitleAttachment(item);
          break;
        case "StatusTransition":
          html = self.drawTitleStatusTransition(item);
          break;
        case "OwnerChanged":
          html = self.drawOwnerChanged(item);
          break;
        default:
          console.log("OBRADITI : "  + item.eventType);
      }

      return html;
    }

    self.drawOwnerChanged = function(item) {
      var objectType = item.objectType === "Deal" ? "Oppportunity" : item.objectType;
      var html =  '<div>'
           + '<span class="bold">' + Messages.Dashboard.newOwner + ' </span>'
           + '<span class="title-color-blue bold">' + item.info + '</span>'
           + '<span>' + " " + Messages.Dashboard.isAssignedOn + " " + '</span>'
           + '<span>' + self.printDate(new Date(item.eventDate)) + '</span>'
       + '</div>'
       + '<div>'
           + '<span>' + objectType + ': </span>'
           + '<span class="title-color-blue">' + item.displayText + '</span>'
       + '</div>'
       + '<div>'
           + '<span>' + Messages.Dashboard.assignedBy + ': </span>'
           + '<span>' + item.user_name + '</span>'
       + '</div>';
       return html;
    }


    self.drawTitleAttachment = function(item) {
      var type = Messages.Dashboard.attachment;
      var objectType = item.objectType === "Deal" ? "Oppportunity" : item.objectType;
      var limit  = 20;
      if (objectType == "Note") {
        limit = 120;
      }
      var html =  '<div>'
           + '<span class="bold">' + type + ': </span>'
           + '<span class="title-color-blue bold">' + self.stripHTML(item.customData, limit) + '</span>'
           + '<span>' + " " + Messages.Dashboard.isAddedOn + " " + '</span>'
           + '<span>' + self.printDate(new Date(item.eventDate)) + '</span>'
       + '</div>'
       + '<div>'
            + '<span>'+ Messages.Dashboard.description + ': </span>'
            + '<span class="bold">' + (item.info || "") + '</span>'
        + '</div>'
       + '<div>'
            + '<span>'+ objectType + ': </span>'
            + '<span class="bold">' + item.displayText + '</span>'
        + '</div>'
       + '<div>'
            + '<span>'+ Messages.Dashboard.addedBy + ': </span>'
            + '<span class="bold">' + item.user_name + '</span>'
        + '</div>'

       return html;
    };

    self.drawTitleGrantedAccess = function(item) {
      var objectType = item.objectType === "Deal" ? "Oppportunity" : item.objectType;
      var parentObjectType = item.immediateParentObjectType === "Deal" ? "Oppportunity" : item.immediateParentObjectType;
      var entityId = "";

      if (item.refObject && item.refObject[0] && item.refObject[0].entityId) {
        entityId = " (" + item.refObject[0].entityId + ") ";
      }
      var info = "";
      if (item.info) {
        info = item.info.replaceAll(";", "");
      }

      var html =  '<div>'
           + '<span class="bold">' + objectType + ': </span>'
           + '<span class="blue-title">' + entityId + htmlStrip(item.displayText)+ '</span>'
           + '<span>' + " " + Messages.Dashboard.grantedAccessTo + " " + '</span>'
           + '<span>' + self.printDate(new Date(item.eventDate)) + '</span>'
       + '</div>'
       + '<div>'
        + '<span>Created by:</span>'
        + '<span>' + item.user_name + '</span>'
       + '</div>'
       + '<div>'
        + '<span class="bold">Access granted to: </span>'
        + '<span>' + info + '</span>'
       + '</div>';
        return html;
    };

    self.drawTitleStatusTransition = function(item) {
      var type = Messages.Dashboard.attachment + ":";
      var type = item.objectType === "Deal" ? "Oppportunity" : item.objectType;
      var html =  '<div>'
           + '<span class="bold">' + type + " " + Messages.Dashboard.status + '</span>'
           + '<span>' + " " + Messages.Dashboard.hasBeenChangedFrom + " " + '</span>'
           + '<span class="bold">' + item.previousStatus + '</span>'
            + '<span>' + " " + Messages.Dashboard.to + " " + '</span>'
           + '<span class="bold">' + item.status + '</span>'
           + '<span>' + " " + Messages.Dashboard.on + " " + '</span>'
           + '<span>' + self.printDate(new Date(item.eventDate)) + '</span>'
       + '</div>'
       + '<div>'
            + '<span>'+ Messages.Dashboard.changedBy + ' : </span>'
            + '<span class="bold">' + item.user_name + '</span>'
        + '</div>'
        + '<div>'
             + '<span>'+ type + ' : </span>'
             + '<span class="bold">' + item.displayText + '</span>'
         + '</div>'
       return html;
    };

    self.drawTitleCreatedOrUpdatedItem = function(item, createOrUpdateText) {
      var entityId = "";
      if (item.refObject && item.refObject[0] && item.refObject[0].entityId) {
          entityId =  "(" + item.refObject[0].entityId + ")";
      }
      var type = item.objectType === "Deal" ? "Oppportunity" : item.objectType;
      var limit = 20;
      if (type == "Note") {
        limit = 120;
      }
      var html =  '<div>'
           + '<span class="bold">' + type + ': </span>'
           + '<span class="title-color-blue bold">' + entityId + " " +  self.stripHTML(item.displayText, limit) + '</span>'
           + '<span>' + " " + createOrUpdateText + " " + '</span>'
           + '<span>' + self.printDate(new Date(item.eventDate)) + '</span>'
       + '</div>';

       html += self.relateTo(item)
        + self.createOrUpdate(item)
        + self.dueDate(item)
        + self.closeDate(item)
        + self.addedBy(item)
        + self.drawAmount(item);
       return html;
    };

    self.drawAmount = function(item) {
        var amountHtml = "";
        if (item.refObject && item.refObject[0]) {
            if (item.refObject[0].value) {
              amountHtml = '<div>'
                  + '<span>'+ Messages.Dashboard.amount + ': </span>'
                  + '<span>' + item.refObject[0].value + " " + item.refObject[0].currency + '</span>'
              + '</div>';
            }
        }
        return amountHtml;
    };

    self.drawAvatar = function(userId) {
        var user = ALL_USERS[userId];
        var imageData = '<i class="md-person md-3x"></i>';
        var html = '<div class="content-left"><span class="menu-avatar">'
        if (connection && user && user['avatar-url']) {
            var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(user.person) + '&fieldName=' + encodeURIComponent('picture');
            imageData = '<div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ');width:30px;"></div>';
        }
        html += imageData +'</span></div>';
        return html;
    };

    self.closeDate =  function(item) {
      var html = "";
      if (item.refObject && item.refObject[0]) {
          if (item.refObject[0].closeDate) {
            html = '<div>'
                 + '<span>'+ Messages.Dashboard.closeDate + ': </span>'
                 + '<span>' + self.printDate(new Date(item.refObject[0].closeDate)) + '</span>'
             + '</div>';
          }
      }
      return html;
    };

    self.dueDate =  function(item) {
      var html = "";
      if (item.refObject && item.refObject[0]) {
          if (item.refObject[0].dueDate) {
            html = '<div>'
                 + '<span>'+ Messages.Dashboard.dueDate + ': </span>'
                 + '<span>' + self.printDate(new Date(item.refObject[0].dueDate)) + '</span>'
             + '</div>';
          }
      }
      return html;
    };

    self.createOrUpdate = function(item) {
        var html = "";

        if (item.objectType === "Note" || item.objectType === "Comment") {
            if (item.eventType === "Update") {
              html = '<div>'
                     + '<span>'+ Messages.Dashboard.updatedBy + ': </span>'
                     + '<span>' + item.user_name + '</span>'
                 + '</div>';
            }
        } else {
          var message = Messages.Dashboard.createdBy;
          if (item.eventType === "Update") {
            message = Messages.Dashboard.updatedBy;
          }

          html = '<div>'
                 + '<span>'+ message + ': </span>'
                 + '<span>' + item.user_name + '</span>'
             + '</div>';
        }

        return html;
    };

    self.addedBy = function(item) {
      var html = "";
      if (item.objectType === "Note" || item.objectType === "Comment") {
          html = '<div>'
                + '<span>'+ Messages.Dashboard.addedBy + ': </span>'
                + '<span>' + item.user_name + '</span>'
             + '</div>';
      }
      return html;
    }

    self.relateTo = function(item) {
        var html = "";
        var type = item.immediateParentObjectType === "Deal" ? "Oppportunity" : item.immediateParentObjectType;
        if (item.immediateParentDisplay) {
           html = '<div>'
                   + '<span>'+ Messages.Dashboard.relatedTo + " " + type + ': </span>'
                   + '<span>' + htmlStrip(item.immediateParentDisplay) + '</span>'
               + '</div>';
        }
        return html;
    };

    self.printDate = function(date) {
      return dateFormat(date) + " " + timeFormat(date);
    };

    self.stripHTML = function(data, limit){
      var stripValue = htmlStrip(data);
      if (limit && stripValue.length > limit) {
          stripValue = stripValue.substr(0, limit-1);
          stripValue = stripValue + "...";
      }
      return stripValue;
    };

    return self;
}(FeedListController || {}));
