var NoteController = (function (NoteController)
{
    var self = NoteController;
    var sharedNoteForOpen = null;
    var table = models.noteDBModel.name;
    var objectType = {objectType: "Note"};

    self.synchronization = function (items, callback) {
        if (callback != null && typeof callback == "function") {
            callback([]);
        }
    };

    self.syncPartData = function (err, data, callback) {
        if (err == null) {
            if (data != null && data.length > 0) {
                var notes = [];
                for (var i = 0, max = data.length; i < max; i++) {
                    notes.push(data[i]);
                }
                if (callback != null && typeof callback == "function") {
                    callback(notes);
                }
            } else {
                if (callback != null && typeof callback == "function") {
                    callback([]);
                }
            }
        } else {
            if (callback != null && typeof callback == "function") {
                callback([]);
            }
        }
    };

//	self.encode = function(items, callback) {
//		var resultItem, result = [];
//		if (items != null) {
//			if (items.length != null && items.length > 0) {
//				for (var i = 0, max = items.length; i < max; i++) {
//					resultItem = self.encodeItem(items[i]);
//					if (resultItem != null) {
//						result.push(resultItem);
//					}
//				}
//				if (callback != null && typeof callback == "function") {
//					callback(result);
//				}
//			} else {
//				resultItem = self.encodeItem(items);
//				if (resultItem != null) {
//					result.push(resultItem);
//				}
//				if (callback != null && typeof callback == "function") {
//					callback(result);
//				}
//			}
//		}
//	};

//	self.encodeItem = function(item) {
//		if (item['_id'] != null) {
//			var result 					= {};
//            result = item;
//
//			result['id']				= getTextTypeObject(item['_id'], 'integer');
//			result['body'] 				= item.note.escape();
//			result['author-id'] 		= getTextTypeObject(item['creator'], 'integer');
//			result['owner-id'] 			= {"type":"integer","nil":"true"};
//			result['group-id']			= {"type":"integer","nil":"true"};
//			result['group'] 			= "";
//			result['updated-at'] 		= getTextTypeObject(item['modificationDate'], 'datetime');
//			result['created-at'] 		= getTextTypeObject(item['creationDate'], 'datetime');
//			result['attachments'] 		= item['fileAttachments'];
//			result['subject-id'] 		= {"type":"integer","nil":"true"};
//			result['subject-type'] 		= {"nil":"true"};
//			result['subject-name'] 		= {"nil":"true"};
//			result['type-id'] 			= item['rootObject'];
//			result['visible-to'] 		= item.accessList;
//			result['urlList']	        = item.urlList;
//
//
//            if (item['assignedTo'] != null) {
//				result['owner-id'] 	= getTextTypeObject(item['assignedTo'], 'integer');
//			}
//
//			if (item['immediateParent'] != null) {
//				var temp = GlobalAllData.filter(function(o) {
//				  return o._id == item['immediateParent'];
//				});
//				if (temp.length > 0 && temp[0].objectType == "Note") {
//					result['recording-id']	= getTextTypeObject(item['immediateParent'], 'integer');
//				}
//			}
//
//			result['collection-id'] 	= {"type":"integer","nil":"true"};
//			result['collection-type'] 	= {"nil":"true"};
//
//			if (item['rootObject'] != null) {
//				result['subject-id'] 	= getTextTypeObject(item['rootObject'], 'integer');
//
//				var subject = GlobalAllData.filter(function(o) {
//				  return o._id == item['rootObject'];
//				});
//
//				if (subject.length > 0) {
//					subject = subject[0];
//					if (subject.objectType == "Note") {
//						result['subject-type'] 	= subject.objectType;
//						result['subject-name'] 	= subject.note;
//					} else if (subject.objectType == "Company") {
//						result['subject-type'] 	= "Party";
//						result['subject-name'] 	= subject.companyName;
//					} else if (subject.objectType == "Person") {
//						result['subject-type'] 	= "Party";
//						result['subject-name'] 	= subject.firstName + " " + subject.lastName;
//					} else if (subject.objectType == "Deal") {
//						result['subject-type'] 		= subject.objectType;
//						result['subject-name'] 		= subject.dealName;
//						result['collection-id'] 	= getTextTypeObject(item['rootObject'], 'integer');
//						result['collection-type'] 	=  subject.dealName;
//					} else if (subject.objectType == "Project") {
//						result['subject-type'] 		= "Kase";
//						result['subject-name'] 		= subject.projectName;
//						result['collection-id'] 	= getTextTypeObject(item['rootObject'], 'integer');
//						result['collection-type'] 	= "Kase";
//					}
//				}
//			}
//
//			return result;
//		} else {
//			return undefined;
//		}
//	};

    self.save = function (name, visibleTo, immediate, urlList, sharedWithUsers, location, callback) {
        var note = null;

        if (typeof name == "object") {
            note = name;
        } else {
            note = objectType;
            if (name) {
                note['note'] = name;
            }
            note['status'] = "Created";
            note['immediate'] = immediate;

            if (urlList != null && urlList.length > 0) {
                note['urlList'] = urlList;
            } else {
                note['urlList'] = [];
            }
            if (visibleTo) {
                note['accessList'] = visibleTo;
            }
            
            if(location && location.length > 0){
                note.location = {type: "Point", coordinates: location};
            } else {
                if(note.location){
                    delete note.location;
                }
            }
        }
        note.conversationActive = sharedWithUsers;

        if (connection) {
            ClientAPI.attachChildObject(note, immediate, function (err, res) {
                if (err && res.statusCode != 0) {
                    if (callback != null && typeof callback == "function") {
                        callback('error', []);
                    }
                } else {
                    if (res != null && callback != null && typeof callback == "function") {
                        callback(res.object);
                    }
                }
            });
        } else {
            var objectNote = {'object': note, 'objectType': table, id: UtilController.randomNumber()};
            db.insert(models.offlineInsertDBModel.name, [objectNote], function () {
                alert(Messages.Offline.offlineMode);
                if (visibleTo != null && typeof visibleTo == "function") {
                    visibleTo();
                } else if (callback != null && typeof callback == "function") {
                    callback();
                }
            });
        }
    };

    self.update = function (id, name, visibleTo, immediate, urlList, shareWithUsers, location, callback) {
        if (connection) {
            if (id) {
                self.findById(id, function (data) {
                    if (data != null && data[0] != null) {
                        if (name) {
                            data[0]['note'] = name;
                        }

                        if (urlList != null && urlList.length > 0) {
                            data[0]['urlList'] = urlList;
                        } else {
                            delete data[0]['urlList'];
                        }
                        if(shareWithUsers){
                            data[0].conversationActive = shareWithUsers;
                        }
                        var visible = visibleTo;
                        
                         if (location && location.length > 0) {
                            data[0].location = {type: "Point", coordinates: location};
                        }

                        var resultItem = null;
                        var countRequest = 0;
                        ClientAPI.updateObject(data[0], function (err, data) {
                            if (!err) {
                                if (data.object) {
                                    resultItem = data.object;
                                    var id = data.object._id;
                                    if (visibleTo != null) {
                                        countRequest++;
                                        ClientAPI.updateACL(id, visible, function (err) {
                                            countRequest--;
                                            if (countRequest == 0) {
                                                callback(data.object);
                                            }
                                        });
                                    } else {
                                        alert(data['statusDesc']);
                                        if (countRequest == 0) {
                                            callback(data.object);
                                        }
                                    }

                                    if (immediate) {
                                        countRequest++;
                                        NoteController.findById(id, function (data) {
                                            ClientAPI.attachChildObject(data[0], immediate, function (err, res) {
                                                countRequest--;
                                                if (countRequest == 0) {
                                                    callback(res.object);
                                                }
                                            });
                                        });
                                    }
                                } else {
                                    alert(data['statusDesc']);
                                    if (callback != null && typeof callback == 'function') {
                                        callback();
                                    }
                                }
                            }
                        });
                    } else {
                        if (callback != null && typeof callback == "function") {
                            callback();
                        }
                    }
                });
            } else {
                if (callback != null && typeof callback == "function") {
                    callback();
                }
            }
        } else {
            alert("You are in offline mode. You can't save this comment!");
        }
    };
    
    self.updateNotesLink = function(id, noteLinks){
        if(connection){
            ClientAPI.find({objectType: 'Note', _id: new ObjectId(id)}, null, function(err, data){
                var noteObject = data[0];
                if(noteLinks && noteLinks.length > 0){
                    noteObject.urlList = noteLinks;
                    ClientAPI.updateObject(noteObject, function(err, data){
                       if(!err){
                           goBack();
                       } else {
                           alert("Incorrect format of the link, please specify full address.");
                       }
                    });
                }
            });
        }
    };

    self.findAll = function (callback) {
        if (connection) {
            ClientAPI.find(objectType, [["modificationDate", -1]], function (err, data) {
                if (err == null) {
                    var items = [];
                    for (var i = 0, max = data.length; i < max; i++) {
                        items.push(data[i]);
                    }
                    if (callback != null && typeof callback == "function") {
                        callback(items);
                    }
                } else {
                    if (callback != null && typeof callback == "function") {
                        callback();
                    }
                }
            });
        } else {
            if (callback != null && typeof callback == "function") {
                callback([]);
            }
        }
    };

    self.findById = function (id, callback) {
        if (id == null) {
            if (callback != null && typeof callback == "function") {
                callback();
            }
        }

        if (connection) {
            ClientAPI.find({objectType: "Note", _id: new ObjectId(id)}, null, function (err, data) {
                if (err == null && typeof callback == "function") {
                    callback(data);
                } else {
                    if (typeof callback == "function") {
                        callback();
                    }
                }
            });
        } else {
            if (callback != null && typeof callback == "function") {
                callback();
            }
        }
    };

    self.delete = function (id, callback) {
        if (connection) {
            ClientAPI.removeObject(id, function (err, data) {
                if (data != null && data.statusCode != null) {
                    if (callback != null && typeof callback == "function") {
                        callback(data.statusCode);
                    }
                }
            });
        }
    };

    self.sharedNoteForOpen = function () {
        return sharedNoteForOpen;
    };

    self.getAllByCaseId = function (id, callBack) {
        if (connection) {
            if (id != null) {
                ClientAPI.find({immediateParent: new ObjectId(id), objectType: "Note"}, null, function (err, data) {
                    self.syncPartData(err, data, callBack);
                });
            } else {
                if (callBack != null && typeof callBack == "function") {
                    callBack([]);
                }
            }
        } else {
            if (callBack != null && typeof callBack == "function") {
                callBack([]);
            }
        }
    };

    self.getAllByImmediateId = function (id, callBack) {
        if (connection) {
            if (id != null) {
                ClientAPI.find({immediateParent: new ObjectId(id), objectType: "Note"}, null, function (err, data) {
                    self.syncPartData(err, data, callBack);
                });
            } else {
                if (callBack != null && typeof callBack == "function") {
                    callBack([]);
                }
            }
        } else {
            if (callBack != null && typeof callBack == "function") {
                callBack([]);
            }
        }
    };

    self.getAllByRootId = function (id, callBack) {
        if (connection) {
            if (id != null) {
                ClientAPI.find({immediateParent: new ObjectId(id), objectType: "Note"}, null, function (err, data) {
                    self.syncPartData(err, data, callBack);
                });
            } else {
                if (callBack != null && typeof callBack == "function") {
                    callBack([]);
                }
            }
        } else {
            if (callBack != null && typeof callBack == "function") {
                callBack([]);
            }
        }
    };

//	self.showNotes = function(data, callback) {
//		var html = '',img = '';
//		if (data != null && data.length != null && data.length > 0) {
//			$(data).each(function(index, value){
//				var comment = '';
//				var body 	= '';
//
//				if (value['commentCount'] != null && value['commentCount'] > 0) {
//					comment = "Comments: " + value['commentCount'];
//				} else {
//					comment = "No comments";
//				}
//
//				if (value.body == null || value.body == "") {
//					body = "No description";
//				} else {
//					body = value.body;
//				}
//
//				if (value.attachments != null && value.attachments.attachment != null && value.attachments.attachment.url != null) {
//					var found = $.inArray(value.attachments.attachment.name.split(".")[1], ["jpg", "png", "gif"]) > -1;
//					img = '<img id="" class="" src="../../styles/custom-icons/file-icon.png" onerror="imgError(this);">';
//				} else {
//					img = "";
//				}
//
//			    html +='<li>'
//	                   + '<a href="#" class="note" note-id="' + value.id.text + '">'
//	                   + '<h1 class="ui-li-heading">Note by ' + ALL_USERS[value['author-id'].text].name + " - " + dateTimeFormatWithAt(parseISO8601(value['created-at'].text)) + '</h1>'
//	                   + '<p class="ui-li-desc wrap">' + body +  '</p>'
//	                   + '<p class="ui-li-desc wrap">' + comment +  '</p>'
//	                   + '<p>' + img + '</p>'
//	                   + '</a>'
//	                   +'</li>';
//			});
//		}
//		if (callback != null && typeof callback == "function") {
//			callback(html);
//		}
//	};


    return self;
}(NoteController || {}));
