var OfflineController = (function (OfflineController)
{
    var self = OfflineController;
    var table = models.offlineInsertDBModel.name;

    self.synchronization = function (callback) {
        if (connection) {
            db.selectAll(models.offlineInsertDBModel.name, function (data) {
                cnt = 0;
                total_success = 0;
                if (data.length > 0) {
                    $.mobile.loading("show", {
                        text: "",
                        html: '<p style="text-align:center"><img src="' + rootPath + '/libs/jqueryMobile1.3.1/images/ajax-loader.gif" onerror="imgError(this);">'
                                + '</p><p style="text-align:center">Saving items from offline mode</p>'
                                + '<p style="text-align:center" id="counter-value"></p>',
                        textVisible: true,
                        theme: "d"
                    });
                } else {
                    if (callback != null && typeof callback == "function") {
                        callback();
                    }
                }

                $(data).each(function (index, value) {
                    cnt++;
                    var object = value.offlineInsert.object;

                    if ("task" == value.offlineInsert.objectType) {
                        if (object.taskCategory != null && object.taskCategory.val != null) {
                            object.taskCategory = new ObjectId(object.taskCategory.val);
                        }
                        if (object.immediateParent != null && object.immediateParent.val != null) {
                            object.immediateParent = new ObjectId(object.immediateParent.val);
                        }
                        if (object.rootObject != null && object.rootObject.val != null) {
                            object.rootObject = new ObjectId(object.rootObject.val);
                        }
                    }

                    if ("deal" == value.offlineInsert.objectType) {
                        if (object.dealCategory != null && object.dealCategory.val != null) {
                            object.dealCategory = new ObjectId(object.dealCategory.val);
                        }
                        if (object.immediateParent != null && object.immediateParent.val != null) {
                            object.immediateParent = new ObjectId(object.immediateParent.val);
                        }
                        if (object.rootObject != null && object.rootObject.val != null) {
                            object.rootObject = new ObjectId(object.rootObject.val);
                        }
                    }

                    if (value.offlineInsert.objectType == "task" || value.offlineInsert.objectType == "deal" ||
                            value.offlineInsert.objectType == "people" || value.offlineInsert.objectType == "company" ||
                            value.offlineInsert.objectType == "kase") {
                        // add object with parent
                        if (value.offlineInsert['parent-id']) {
                            if (value.offlineInsert.objectType == "deal") {
                                for (var i = 0; i < value.offlineInsert.object.dealParticipants.length; i++) {
                                    value.offlineInsert.object.dealParticipants[i].participant_id = new ObjectId(value.offlineInsert.object.dealParticipants[i].participant_id.val);
                                }
                            }
                                ClientAPI.attachChildObject(value.offlineInsert.object, value.offlineInsert['parent-id'], function (err, res) {
                                    if (err) {
                                        $('#counter-value').text("Error while saving...");
                                        cnt--;
                                        if (cnt == 0) {
                                            if (callback != null && typeof callback == "function") {
                                                callback();
                                            }
                                            $.mobile.loading('hide');
                                        }
                                    } else {
                                        total_success++;
                                        cnt--;

                                        $('#counter-value').text(total_success + '/' + data.length);
                                        db.deleteObject(table, "id", value.offlineInsert.id);
                                        if (value.offlineInsert.objectType == "task") {
                                            var owner = "";
                                            if (res.object.assignedTo != null) {
                                                owner = res.object.assignedTo;
                                            } else {
                                                owner = res.object.owner;
                                            }

                                            SipMessageSettingFunctions.sendInfoMessage(owner, {
                                                taskid: res.object._id,
                                                body: res.object.taskDescription
                                            }, function () {
                                            });
                                        }

                                        if (cnt == 0) {
                                            if (callback != null && typeof callback == "function") {
                                                callback();
                                            }
                                            $.mobile.loading('hide');
                                        }
                                    }
                                });
                        } else {
                            if (value.offlineInsert.objectType == "people") {
                                for (var i = 0; i < value.offlineInsert.object.companies.length; i++) {
                                    value.offlineInsert.object.companies[i].company = new ObjectId(value.offlineInsert.object.companies[i].company.val);
                                }
                            }
                            ClientAPI.insertObject(value.offlineInsert.object, function (err, item) {
                                if (err != null) {
                                    $('#counter-value').text("Error while saving...");
                                    cnt--;
                                    if (cnt == 0) {
                                        if (callback != null && typeof callback == "function") {
                                            callback();
                                        }
                                        $.mobile.loading('hide');
                                    }
                                } else {
                                    total_success++;
                                    cnt--;

                                    $('#counter-value').text(total_success + '/' + data.length);
                                    db.deleteObject(table, "id", value.offlineInsert.id);
                                    if (value.offlineInsert.objectType == "task") {
                                        var owner = "";
                                        if (item.object.assignedTo != null) {
                                            owner = item.object.assignedTo;
                                        } else {
                                            owner = item.object.owner;
                                        }

                                        SipMessageSettingFunctions.sendInfoMessage(owner, {
                                            taskid: item.object._id,
                                            body: item.object.taskDescription
                                        }, function () {
                                        });
                                    }

                                    if (cnt == 0) {
                                        if (callback != null && typeof callback == "function") {
                                            callback();
                                        }
                                        $.mobile.loading('hide');
                                    }
                                }
                            });
                        }
                    }

                    if (value.offlineInsert.objectType == "comment") {
                        CommentController.save(value.offlineInsert.object, value.offlineInsert.object.immediate, function () {
                            cnt--;
                            db.deleteObject(table, "id", value.offlineInsert.id);
                            if (cnt == 0) {
                                if (callback != null && typeof callback == "function") {
                                    callback();
                                }
                                $.mobile.loading('hide');
                            }
                        });
                    }

                    if (value.offlineInsert.objectType == "note") {
                        var publicNote = value.offlineInsert.object.accessList != null ? true : false;
                        NoteController.save(value.offlineInsert.object, publicNote, value.offlineInsert.object.immediate, [], value.offlineInsert.object.sendOptional, function (err, data) {
                            cnt--;
                            db.deleteObject(table, "id", value.offlineInsert.id);
                            if (cnt == 0) {
                                if (callback != null && typeof callback == "function") {
                                    callback();
                                }
                                $.mobile.loading('hide');
                            }
                        });
                    }
                    if (value.offlineInsert.objectType == "favorite") {
                        if (value.offlineInsert.object && value.offlineInsert.object.status) {
                            if (value.offlineInsert.object.status == "Add"){
                                if (value.offlineInsert.object.favorite &&
                                    value.offlineInsert.object.favorite.id &&
                                    value.offlineInsert.object.favorite.id.text) {
                                      ClientAPI.find({_id:new ObjectId(value.offlineInsert.object.favorite.id.text)},[], function(err, data){
                                        if (data && data[0]) {
                                            var type = value.offlineInsert.object.objectType;
                                            if (!type) {
                                              type = data[0].objectType;
                                            }
                                            if (type === "Project") {
                                              type = "Case";
                                            }
                                            FavoriteController.save(type, data[0], function(){
                                                 db.deleteObject(table, "id", value.offlineInsert.id);
                                                 cnt--;
                                                 if (cnt == 0) {
                                                    if (callback != null && typeof callback == "function") {
                                                        callback();
                                                    }
                                                    $.mobile.loading('hide');
                                                }
                                            });
                                        } else {
                                            cnt--;
                                            if (cnt == 0) {
                                               if (callback != null && typeof callback == "function") {
                                                   callback();
                                               }
                                               $.mobile.loading('hide');
                                           }
                                        }
                                      });
                                }
                            } else {
                                if (value.offlineInsert.object.favorite && value.offlineInsert.object.favorite.id) {
                                    FavoriteController.removeFavorite(value.offlineInsert.object.favorite.id, function(){
                                        db.deleteObject(table, "id", value.offlineInsert.id);
                                        cnt--;
                                        if (cnt == 0) {
                                            if (callback != null && typeof callback == "function") {
                                                callback();
                                            }
                                            $.mobile.loading('hide');
                                        }
                                    });
                                }
                            }
                        }
                    }
                });
            });
        } else {
            if (callback != null && typeof callback == "function") {
                callback();
            }
        }
    };

    return self;
}(OfflineController || {}));
