/**
 * Created by dragank on 9/12/2014.
 */
var PermissionController = (function (PermissionController)
{
    var self = PermissionController;
    self.view = "";
    self.permission = [];
    self.changeACL = false;
    self.persmissionObject = null;
    var $visibleList = null;
    var $listUser = null;
    self.init = function (view) {

        self.permission = [];
        self.view = view;
        self.changeACL = false;
        $visibleList = $('#visible-list', self.view);
        $listUser = $('#list-user', self.view);

        self.removedUsersFromGroup = [];

        $(document).off('keydown', view + ' #auto-visible');
        $(document).off('click', view + ' .autocomplete-permission');
        $(document).off('click', view + ' .deletePermission');
        $(document).off('change', view + ' .changeData');
        $(document).off('keyup', view + ' #group-user-autocompletion');
        $(document).off('click', view + ' .list-of-group-users');
        $(document).off('click', view + ' .deleteUserFromGroup');

        $(document).on('keyup', view + ' #auto-visible', self.autocomplete);
        $(document).on('click', view + ' .autocomplete-permission', self.addPermission);
        $(document).on('click', view + ' .deletePermission', self.deletePermission);
        $(document).on('change', view + ' .changeData', self.changeCheckBox);
        $(document).on('keyup', view + ' #group-user-autocompletion', self.userAutocompletion);
        $(document).on('click', view + ' .list-of-group-users', self.addUserToGroup);
        $(document).on('click', view + ' .deleteUserFromGroup', self.deleteUserFromGroup);
    };

    self.changeCheckBox = function () {
        self.changeACL = true;
        if ($(this).data('type') == "acl") {
            self.permission[$(this).data('index')]['canUpdateACL'] = this.checked;
        } else {
            self.permission[$(this).data('index')]['canUpdateData'] = this.checked;
        }
    };

    self.setData = function (permission) {
        var i, max;
        for (i = 0, max = permission.length; i < max; i++) {
            if (!permission[i].identity.startsWith('ContentAdmins')) {
                if (ALL_USERS[permission[i].identity]) {
                    permission[i].name = ALL_USERS[permission[i].identity].name;
                }
            }
        }

        self.permission = permission;
        self.showTablePermission();
    };

    self.isAdmin = function(){
      try {
         return JSON.parse(localStorage.getItem('userProfile')).app_domain_admin;
      } catch (e) {
        contentAdmin = false;
      }
      return contentAdmin;
    };

    self.showTablePermission = function () {
        var i, max, show = false, html, contentAdmin;
        html = '<table data-role="table" class="permission-table ui-responsive table-stroke" style="padding-top: 10px;font-size: 14px;">';
        html += '<thead><tr><th style="text-align: left;padding-left: 10px;">Full name</th><th>Data</th><th>ACL</th><th></th></tr></thead><tbody>';

        for (i = 0, max = self.permission.length; i < max; i++) {
            if (self.permission[i].name) {
                show = true;
                html += '<tr><td>' + self.permission[i].name + '</td>';
                if (self.permission[i].canUpdateData) {
                    html += "<td><input type='checkbox' data-type='data' data-index=" + i + " class='changeData' checked></td>";
                } else {
                    html += "<td><input type='checkbox' data-type='data' data-index=" + i + " class='changeData'></td>";
                }
                if (self.permission[i].canUpdateACL) {
                    html += "<td><input type='checkbox' data-type='acl' data-index=" + i + " class='changeData' checked></td>";
                } else {
                    html += "<td><input type='checkbox' data-type='acl' data-index=" + i + " class='changeData'></td>";
                }
                html += "<td><a data-deleteId=" + i + " class='deletePermission' style='display:block; color:gray;'><i class='md-delete md-2x'></i></a></td></tr>";
            }
        }

        html += '</tbody></table>';

        if (show) {
            $listUser.empty().append(html);
        } else {
            $listUser.empty();
        }
    };

    self.autocomplete = function () {
        var text = $(this).val();
        var i, max, html = "";
        if (text.length >= 3) {
            showLoadingIndikator();
            $visibleList.show();
            $listUser.hide();
            if (connection) {
                ClientAPI.getAppUsersAndGroups(text, 0, 5, function (err, data) {
                    if (!err) {
                        for (i = 0, max = data.length; i < max; i++) {
                            html += '<li data-id=' + data[i]["_id"].replace(/\s+/g, '&#32;') + '  class="autocomplete-permission">';
                            if (data[i].identityType == "User") {
                                html += data[i]['firstName'] + " " + data[i]['lastName'];
                            } else {
                                html += data[i]['identityName'];
                            }
                            html += "</li>";
                        }
                    }
                    $visibleList.empty().append(html);

                    if ($visibleList.hasClass('ui-listview')) {
                        $visibleList.listview('refresh');
                    } else {
                        $visibleList.trigger('create');
                    }
                    hideLoadingIndikator();
                });
            } else {
                db.selectByQuery('SELECT * FROM (SELECT id, name FROM user UNION SELECT id, name FROM groups) as t WHERE t.name LIKE ? LIMIT ?,?', ['%' + text + '%', 0, 5], 'user', function (data) {
                    for (i = 0, max = data.length; i < max; i++) {
                        html += '<li data-id=' + data[i]["id"]['text'].replace(/\s+/g, '&#32;') + '  class="autocomplete-permission">';
                        html += data[i]['name'];
                        html += "</li>";
                    }
                    $visibleList.empty().append(html);

                    if ($visibleList.hasClass('ui-listview')) {
                        $visibleList.listview('refresh');
                    } else {
                        $visibleList.trigger('create');
                    }
                    hideLoadingIndikator();
                });
            }
        } else {
            $visibleList.hide();
            $listUser.show();
        }
    };

    self.addPermission = function () {
        $visibleList.hide();
        $listUser.show();
        self.changeACL = true;
        var addItem = true;

        for (var i = 0, max = self.permission.length; i < max; i++) {
            if (self.permission[i].identity == $(this).attr('data-id')) {
                addItem = false;
            }
        }
        if (addItem) {
            self.permission.push({"identity": $(this).attr('data-id'), "canUpdateData": true, 'canUpdateACL': false, name: $(this).text()});
        }
        $('#auto-visible', self.view).val('');
        $visibleList.empty();
        self.showTablePermission();
    };

    self.deletePermission = function () {
        self.changeACL = true;
        self.permission.splice($(this).data('deleteid'), 1);
        self.showTablePermission();
    };
    //methods for drawing users when creating groups
    self.userAutocompletion = function () {
        var $autocompleteUserList = $("#edit-group #group-user-list");
        var text = $(this).val();
        var i, max, html = "";
        if (text.length >= 3) {
            showLoadingIndikator();
            $autocompleteUserList.show();
            //$visibleList.show();
            //$listUser.hide();
            if (connection) {
                ClientAPI.getAppUsersAndGroups(text, 0, 5, function (err, data) {
                    if (!err) {
                        for (i = 0, max = data.length; i < max; i++) {
                            html += '<li data-id=' + data[i]["_id"].replace(/\s+/g, '&#32;') + '  class="list-of-group-users">';
                            if (data[i].identityType == "User") {
                                html += data[i]['firstName'] + " " + data[i]['lastName'];
                            } else {
                                html += data[i]['identityName'];
                            }
                            html += "</li>";
                        }
                    }
                    $autocompleteUserList.empty().append(html);

                    if ($autocompleteUserList.hasClass('ui-listview')) {
                        $autocompleteUserList.listview('refresh');
                    } else {
                        $autocompleteUserList.trigger('create');
                    }
                    hideLoadingIndikator();
                });
            } else {
                db.selectByQuery('SELECT * FROM (SELECT id, name FROM user UNION SELECT id, name FROM groups) as t WHERE t.name LIKE ? LIMIT ?,?', ['%' + text + '%', 0, 5], 'user', function (data) {
                    for (i = 0, max = data.length; i < max; i++) {
                        html += '<li data-id=' + data[i]["id"]['text'].replace(/\s+/g, '&#32;') + '  class="list-of-group-users">';
                        html += data[i]['name'];
                        html += "</li>";
                    }
                    $autocompleteUserList.empty().append(html);

                    if ($autocompleteUserList.hasClass('ui-listview')) {
                        $autocompleteUserList.listview('refresh');
                    } else {
                        $autocompleteUserList.trigger('create');
                    }
                    hideLoadingIndikator();
                });
            }
        } else {
            $autocompleteUserList.hide();
            //$listUser.show();
        }
    };

        self.addUserToGroup = function () {
        //$visibleList.hide();
        //$listUser.show();
        $("#edit-group #group-user-list").hide();
        $("#edit-group #group-users").show();
        self.changeACL = true;
        var addItem = true;

        for (var i = 0, max = self.permission.length; i < max; i++) {
            if (self.permission[i].identity == $(this).attr('data-id')) {
                addItem = false;
            }
        }
        if (addItem) {
            self.permission.push({"identity": $(this).attr('data-id'), "canUpdateData": true, 'canUpdateACL': false, name: $(this).text()});
        }
        $('#group-user-autocompletion', self.view).val('');
        //$visibleList.empty();
        $("#edit-group #group-user-list").empty();
        self.drawGroupUsersTable();
    };

    self.drawGroupUsersTable = function () {
        var i, max, show = false, html;
        var contentAdmin = self.isAdmin();
        html = '<table data-role="table" class="permission-table ui-responsive table-stroke" style="padding-top: 10px;font-size: 14px;">';
        html += '<thead><tr><th style="text-align: left;padding-left: 10px;">User</th><th></th></tr></thead><tbody>';

        for (i = 0, max = self.permission.length; i < max; i++) {
            if (self.permission[i].name) {
                show = true;
                html += '<tr><td>' + self.permission[i].name + '</td>';
                if (contentAdmin) {
                  html += "<td><a data-deleteId=" + i + " class='deleteUserFromGroup' userId='" + self.permission[i].identity + "' style='display:block; color:gray;'><i class='md-delete md-2x'></i></a></td></tr>";
                } else {
                  html += "<td></td></tr>";
                }
            }
        }
        html += '</tbody></table>';

        if (show) {
            $("#edit-group #group-users").empty().append(html);
        } else {
            $("#edit-group #group-users").empty();
        }
    };

    self.setGroupUsersData = function (users) {
        var userList = [];
        for (var i = 0; i < users.length; i++) {
            var tempUserObj = {};
            if (users[i]['_id']) {
                tempUserObj.identity = users[i]['_id'];
            }
            if (users[i].firstName && users[i].lastName) {
                tempUserObj.name = users[i].firstName + " " + users[i].lastName;
            }
            userList.push(tempUserObj);
        }
        self.permission = userList;
        self.drawGroupUsersTable();
    };

    self.deleteUserFromGroup = function () {
        self.permission.splice($(this).data('deleteid'), 1);
        var deletedUserId = $(this).attr('userId');
        self.removedUsersFromGroup.push(deletedUserId);
        self.drawGroupUsersTable();
    };

    self.drawPermissionForObject = function(item) {
      var html = "";
      var visibleTo = item['visible-to'];
      if (!visibleTo) {
        visibleTo = item['accessList'];
      }
      if (visibleTo && visibleTo.length > 0) {
          for (var i = 0, max = visibleTo.length; i < max; i++) {
              if (!isNaN(visibleTo[i]['identity'])) {
                  html += '<span class="visible-user-item" data-identity="'+visibleTo[i]['identity']+'">' + ALL_USERS[visibleTo[i]['identity']].name + '</span>';
              } else {
                  if (visibleTo[i]['identity'].startsWith('ContentAdmins')) {
                      if (visibleTo.length == 1) {
                          html = '<span class="visible-user-item">Just me</span>';
                      }
                  } else {
                      if (ALL_USERS[visibleTo[i]['identity']]) {
                          html += '<span class="visible-user-item" data-identity="'+visibleTo[i]['identity']+'">' + ALL_USERS[visibleTo[i]['identity']].name + '</span>';
                      }
                  }
              }
          }
      }
      html += '<span class="add-new-permission-user" style="vertical-align: sub;"><i class="md-add-circle-outline md-2x"></i></span>';
      return html;
    };

    self.removePermissionFromObject = function(identity, item, callback){
      if (connection) {
          self.changePermissionData = [];
          self.callback = callback;
          var currentUserId = localStorage.getItem("userId");
          if (currentUserId != identity) {
            var visibleTo = item['visible-to'];
            if (item.objectType == "Note") {
              visibleTo = item['accessList'];
            }
            for (var i = 0, max = visibleTo.length; i < max; i++) {
                if (visibleTo[i].identity != identity) {
                  self.changePermissionData.push(visibleTo[i]);
                }
            }
            self.persmissionObject = item;
            showActionDialog("Are you sure you want do delete permission for " + ALL_USERS[identity].name + "?", "Yes", function(){
                showLoadingIndikator();
                if (self.persmissionObject.objectType == "Note") {
                  ClientAPI.updateACL(self.persmissionObject._id, self.changePermissionData, self.callbackData);
                } else {
                  ClientAPI.updateACL(self.persmissionObject.id.text, self.changePermissionData, self.callbackData);
                }
                hideLoadingIndikator();
            }, "No", function() {
              self.changePermissionData = [];
              self.persmissionObject = null;
              if (self.callback && typeof self.callback == "function") {
                  self.callback(false);
                  self.callback = null;
              }
            });
          } else {
            if (self.callback && typeof self.callback == "function") {
                self.callback(false);
                self.callback = null;
            }
          }
        } else {
          if (self.callback && typeof self.callback == "function") {
              self.callback(false);
              self.callback = null;
          }
        }
    };

    self.callbackData = function (err, data) {
        self.changePermissionData = [];
        if (!err) {
          var controller  = self.selectControllerByType(self.persmissionObject.objectType);
          var id = null;
          if (self.persmissionObject.objectType == "Note") {
             id = self.persmissionObject._id;
          } else {
            id = self.persmissionObject.id.text;
          }
          controller.findById(id, function (data) {
                if (Array.isArray(data)) {
                  data = data[0];
                }
                controller.syncPartData(err, [data], function(){
                    self.persmissionObject = null;
                    if (self.callback && typeof self.callback == "function") {
                        self.callback(true);
                        self.callback = null;
                    }
                });
            });
        } else {
            self.persmissionObject = null;
            if (self.callback && typeof self.callback == "function") {
                self.callback(false);
                self.callback = null;
            }
        }

    };

    self.selectControllerByType = function(type) {
        var controller = TaskController;
        if (type == "Task") {
          controller = TaskController;
        } else if (type == "Project" || type == "Case") {
          controller = CaseController;
        } else if (type == "Deal") {
          controller = DealController;
        } else if (type == "Person") {
          controller = PeopleController;
        } else if (type == "Company") {
          controller = CompanyController;
        } else if (type == "Note") {
          controller = NoteController;
        }
        return controller;
    };


    // self.drawPermissionForObject = function(task) {
    //   var html = "";
    //   if (task['visible-to'].length > 0) {
    //       for (var i = 0, max = task['visible-to'].length; i < max; i++) {
    //           if (!isNaN(task['visible-to'][i]['identity'])) {
    //               html += '<li class="visible-user-item" style="border:0; text-indent:0;"><span>' + ALL_USERS[task['visible-to'][i]['identity']].name + '</span></li>';
    //           } else {
    //               if (task['visible-to'][i]['identity'].startsWith('ContentAdmins')) {
    //                   if (task['visible-to'].length == 1) {
    //                       html = '<li class="visible-user-item" style="border:0; text-indent:0;"><span>Just me</span></li>';
    //                   }
    //               } else {
    //                   if (ALL_USERS[task['visible-to'][i]['identity']]) {
    //                       html += '<li class="visible-user-item" style="border:0; text-indent:0;"><span>' + ALL_USERS[task['visible-to'][i]['identity']].name + '</span></li>';
    //                   }
    //               }
    //           }
    //       }
    //   }
    //   return html;
    // };


    return self;
}(PermissionController || {}));
