var SyncController = (function (SyncController)
{
    var self = SyncController;

    self.sync = function (callback) {
    if (connection) {
        if (window.localStorage.getItem('syncDateAll') != null) {
            window.localStorage.removeItem('syncDateAll');
        }
        FavoriteController.synchronization();
        DealStatusController.synchronization();
        CaseStatusController.synchronization();
        DealCategoryController.synchronization(function () {
        });
        TaskCategoryController.synchronization(function () {
        });

            if (window.localStorage.getItem('syncDateAll') == null) {
                self.removeDeletedObject(null, function () {
                    var asyncCounter = 6;
                    self.syncTasks(function () {
                        asyncCounter--;
                        if (asyncCounter == 0 && callback && typeof callback == "function") {
                            callback();
                        }
                    });
                    self.syncDeals(function () {
                        asyncCounter--;
                        if (asyncCounter == 0 && callback && typeof callback == "function") {
                            callback();
                        }
                    });
                    self.syncCases(function () {
                        asyncCounter--;
                        if (asyncCounter == 0 && callback && typeof callback == "function") {
                            callback();
                        }
                    });

                    self.syncCompany(function(){
                        asyncCounter--;
                        if(asyncCounter == 0 && callback && typeof callback == "function"){
                            callback();
                        }
                    });
                    
                    self.syncPeople(function(){
                       asyncCounter--;
                       if(asyncCounter == 0 && callback && typeof callback == "function"){
                           callback();
                       }
                    });

                    self.syncPhoneContact(function () {
                        asyncCounter--;
                        if (asyncCounter == 0 && callback && typeof callback == "function") {
                            callback();
                        }
                    });
                });
            } else {
                self.removeDeletedObject([], function () {
                    ClientAPI.find({modificationDate: {$gte: new Date(window.localStorage.getItem('syncDateAll'))}},
                            null, function (err, items) {
                                if (err == null) {
                                    window.localStorage.setItem('syncDateAll', new Date());
                                    self.syncPartition(items, callback);
                                } else {
                                    if (callback != null && typeof callback == "function") {
                                        callback();
                                    }
                                }
                            });
                });
            }
        } else {
            if (callback != null && typeof callback == "function") {
                callback();
            }
        }
    };

    self.syncTasks = function (callback) {
        var terminatedTask = ["Completed", "Canceled"];
        ClientAPI.find({$and: [{objectType: "Task"}, {status: {$nin: terminatedTask}}]}, null, function (err, tasks) {
            if (!err) {
                window.localStorage.setItem('syncDateAll', new Date());
                TaskController.synchronization(tasks, function () {
                    callback();
                });
            } else {
                callback();
            }
        });
    };

    self.syncDeals = function (callback) {
        ClientAPI.find({$and: [{objectType: "Deal"}, {status: {$ne: 'Completed'}}]}, null, function (err, deals) {
            if (!err) {
                window.localStorage.setItem('syncDateAll', new Date());
                DealController.synchronization(deals, function () {
                    if (callback && typeof callback == "function") {
                        callback();
                    }
                });

            } else {
                callback();
            }
        });
    };

    self.syncCases = function (callback) {
        ClientAPI.find({$and: [{objectType: "Project"}, {status: {$ne: 'Completed'}}]}, null, function (err, cases) {
            if (!err) {
                window.localStorage.setItem('syncDateAll', new Date());
                CaseController.synchronization(cases, function () {
                    if (callback && typeof callback == "function") {
                        callback();
                    }
                });
            } else {
                console.log("Sync error");
            }
        });
    };

    self.syncCompany = function (callback) {
        ClientAPI.find({objectType: 'Company'}, null, function (err, data) {
            if (!err && data && data.length > 0) {
                window.localStorage.setItem('syncDateAll', new Date());
                CompanyController.synchronization(data, function () {
                    if (callback && typeof callback == "function") {
                        callback();
                    }
                });
            } else {
                if (callback && typeof callback == "function") {
                    callback();
                }
            }
        });
    };

    self.syncPeople = function (callback) {
        ClientAPI.find({query: {objectType: 'Person'}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
            if (!err && data && data.length > 0) {
                window.localStorage.setItem('syncDateAll', new Date());
                PeopleController.synchronization(data, function () {
                    if (callback && typeof callback == "function") {
                        callback();
                    }
                });
                if (callback && typeof callback == "function") {
                    callback();
                }
            } else {
                if (callback && typeof callback == "function") {
                    callback();
                }
            }
        });
    };

    self.syncPhoneContact = function (callback) {
        ContactsController.findPhoneContacts("", function (contacts) {
            var contactArray = [];
            $(contacts).each(function (index, value) {
                var contact = ContactsController.preparePhoneContactsToSend(value);
                if (contact.phones.length > 0) {

                    if ((contact.familyName != null && $.trim(contact.familyName) != "") || (contact.givenName != null && $.trim(contact.givenName) != "")) {
                        contactArray.push(contact);
                    }
                }
            });

            ContactsController.insertContactInDatabaseByTableName(models.phoneContactDBModel.name, contactArray);
            hideLoadingIndikator();
            if (callback && typeof callback == "function") {
                callback();
            }
        });
    };
    
    self.syncNotification = function (callback) {
        if (connection) {
            ClientAPI.getNotifications(null, function (err, data) {
                if (!err) {
                    NotificationService.synchronization(data.notifications, function () {
                        if (callback && typeof callback == "function") {
                            callback();
                        }
                    });
                } else {
                    console.log("syncNotification error: " + JSON.stringify(err));
                    if (callback && typeof callback == "function") {
                        callback();
                    }
                }
            });
        } else {
            if (callback && typeof callback == "function") {
                callback();
            }
        }
    };

    self.syncPartition = function (items, callback) {
        if (items != null) {
            //GlobalAllData = items;
            var companyMap = [];

            var company = items.filter(function (item) {
                return item.objectType == "Company";
            });

            for (var i = 0, max = company.length; i < max; i++) {
                COMPANY_MAP[company[i]['_id']] = company[i].companyName;
            }

            CompanyController.synchronization(company, function () {
            });

            var people = items.filter(function (item) {
                return item.objectType == "Person";
            });

            PeopleController.synchronization(COMPANY_MAP, people, function () {
            });

            var deal = items.filter(function (item) {
                return item.objectType == "Deal";
            });
            DealController.synchronization(deal, function () {
            });

            var task = items.filter(function (item) {
                return item.objectType == "Task";
            });
            TaskController.synchronization(task, function () {
            });

            var project = items.filter(function (item) {
                return item.objectType == "Project";
            });
            CaseController.synchronization(project, function () {
            });

            company = null;
            people = null;
            deal = null;
            task = null;
            note = null;
            comment = null;
            project = null;
            companyMap = null;

            if (callback != null && typeof callback == "function") {
                setTimeout(function () {
                    self.syncPhoneContact();
                }, 2000);
                callback();
            }
        }
    };

    self.syncContact = function (callback) {
        if (connection) {
            ClientAPI.find({$or: [{objectType: 'Company'}, {objectType: 'Person'}]}, null, function (err, items) {
                var companyMap = [];

                var company = items.filter(function (item) {
                    return item.objectType == "Company";
                });

                for (var i = 0, max = company.length; i < max; i++) {
                    companyMap[company[i]['_id']] = company[i].companyName;
                }

                CompanyController.synchronization(company, function () {
                });

                var people = items.filter(function (item) {
                    return item.objectType == "Person" && item.identity_id == null;
                });
                PeopleController.synchronization(companyMap, people, function () {
                    if (callback != null && typeof callback == "function") {
                        callback();
                    }
                });
            });
        }
    };

    self.removeDeletedObject = function (items, callback) {
        if (items != null) {
            //obrisati objekte  na osnovu datuma
            if (callback != null && typeof callback == "function") {
                callback();
            }
        } else {
            db.deleteAllFromTablesInDB(function () {
                if (callback != null && typeof callback == "function") {
                    callback();
                }
            });
        }
    };

    self.syncSipAccount = function (callback) {
        if (connection) {
            var objectSip = {
                domain: window.localStorage.getItem("sipDomain")
            };

            ClientAPI.getOnlineUsers(objectSip.domain, function (error, data) {
                if (!error) {
                    if (data.users != null && data.users.length != null && data.users.length > 0) {
                        db.deleteAllFromTable(models.sipDBModel.name);
                        sipAccount.length = 0;
                        sipAccountMap.length = 0;
                        sipAccountMap = {};
                        $(data.users).each(function (index, value) {
                            var user = MyGroupFunctions.findUserById(value.userid);
                            var time = value.lastLogin.split('T')[1].split('.')[0];
                            var date = value.lastLogin.split('T')[0];
                            var last = "Last seen " + time + ", " + date;
                            if (user != null) {
                                var item = {
                                    "id": value.userid,
                                    "name": user.name,
                                    "phone": value.username,
                                    "date": date,
                                    "time": time,
                                    "last": last,
                                    "status": value.status,
                                    "expires": value.expires,
                                    "lastSeen": value.lastSeen
                                };
                                sipAccountMap[item.phone] = item;
                                sipAccount.push(item);
                            }
                        });

                        if (sipAccount.length != null && sipAccount.length > 0) {
                            db.insertMultiple(models.sipDBModel.name, [sipAccount], function () {
                                if (callback != null) {
                                    callback();
                                }
                            });
                        }
                    }
                }
            });
        }
    };

    return self;
}(SyncController || {}));
