var SyncSipController = (function (SyncSipController) {
    var self = SyncSipController;

    var offset = 0;
    var syncActive = 0;
    var callbackFunction;
    var syncAllConnectionCheck = false;
    var syncTaskPeopleCompanyUser = [];
    var syncTaskBoolean = false;

    self.callbackFunction = function () {
        return callbackFunction;
    };

    self.syncAllConnectionCheck = function () {
        return self.syncAllConnectionCheck;
    };

    self.syncAll = function (callback) {
        self.syncSipAccount();
        self.syncSipMessage();
    };


    self.syncSipAccount = function (callback) {
        if (connection) {
            var objectSip = {
                domain: window.localStorage.getItem("sipDomain")
            };
            ClientAPI.getOnlineUsers(objectSip.domain, function (error, data) {
                if (!error && data.users != null && data.users.length != null && data.users.length > 0) {
                    db.deleteAllFromTable(models.sipDBModel.name);
                    sipAccount.length = 0;
                    sipAccountMap.length = 0;
                    sipAccountMap = {};
                    $(data.users).each(function (index, value) {
                        var user = MyGroupFunctions.findUserById(value.userid);
                        var time = value.lastLogin.split('T')[1].split('.')[0];
                        var date = value.lastLogin.split('T')[0];
                        var last = "Last seen " + time + ", " + date;
                        if (user != null) {
                            var item = {
                                "id": value.userid,
                                "name": user.name,
                                "phone": value.username,
                                "date": date,
                                "time": time,
                                "last": last,
                                "status": value.status,
                                "expires": value.expires,
                                "lastSeen": value.lastSeen
                            };
                            sipAccountMap[item.phone] = item;
                            sipAccount.push(item);
                        }
                    });

                    if (sipAccount.length != null && sipAccount.length > 0) {
                        db.insertMultiple(models.sipDBModel.name, [sipAccount], function () {
                            if (typeof callback == 'function') {
                                callback();
                            }
                        });
                    }
                } else {
                    if (typeof callback == 'function') {
                        callback();
                    }
                }
            });
        }
    };

    self.syncSipMessage = function (callback) {
        if (connection) {
            SipMessageSettingFunctions.getDataFromServer();
        }
    };

    return self;
}(SyncSipController || {}));