var UtilController = (function (UtilController)
{
    var self = UtilController;
    var version = '8';

    self.synchronizationAplicationVersion = function (callback) {
//        $.post(sipUrl + 'SetAppVersion', {'version': window.localStorage.getItem("serverVersion")}, function (data) {
//            version = data;
//            self.checkVersion(callback);
//        });
    };

    self.checkVersion = function (callback) {
        if (window.localStorage.getItem("serverVersion") == version) {
            if (callback != null && typeof callback == "function") {
                callback(true);
            }
        } else {
            if (callback != null && typeof callback == "function") {
                callback(false);
            }
        }
    };

    self.version = function () {
        return version;
    };

    self.randomNumber = function () {
        var chars = "1234567890";
        var string_length = 16;
        var randomstring = '';
        var charCount = 0;
        var numCount = 0;
        var rnum;

        for (var i = 0; i < string_length; i++) {
            // If random bit is 0, there are less than 3 digits already saved, and there are not already 5 characters saved, generate a numeric value.
            if ((Math.floor(Math.random() * 2) == 0) && numCount < 3 || charCount >= 5) {
                rnum = Math.floor(Math.random() * 10);
                randomstring += rnum;
                numCount += 1;
            } else {
                // If any of the above criteria fail, go ahead and generate an alpha character from the chars string
                rnum = Math.floor(Math.random() * chars.length);
                randomstring += chars.substring(rnum, rnum + 1);
                charCount += 1;
            }
        }
        return randomstring;
    };

    self.dateToStringMobiScroll = function (inDate, date) {
        if (navigator.userAgent.match(/(iPad|iPhone)/)) {
            console.log("inDate: " + inDate.toJSON().split(".")[0]);
            return inDate.toJSON().split(".")[0];
        } else {
            var min = inDate.getMinutes();
            var hh = inDate.getHours();
            var dd = inDate.getDate();
            var mm = inDate.getMonth() + 1;
            var yyyy = inDate.getFullYear();
            if (dd < 10) {
                dd = '0' + dd;
            }

            if (mm < 10) {
                mm = '0' + mm;
            }
            if (min < 10) {
                min = '0' + min;
            }

            if (hh < 10) {
                hh = '0' + hh;
            }

//			if (date) {
            return dd + '.' + mm + '.' + yyyy;
//			} else {
//				return dd + '.' + mm + '.' + yyyy + ' ' + hh + ':' + min ;
//			}
        }
    };

    self.compareDate = function (a, b) {
        var a = new Date(a);
        var b = new Date(b);
        if (a.getUTCFullYear() == b.getUTCFullYear()) {
            if (a.getMonth() == b.getMonth()) {
                return  a.getDate() - b.getDate();
            } else {
                return a.getMonth() - b.getMonth();
            }
        } else {
            return a.getUTCFullYear() - b.getUTCFullYear();
        }
    };

    self.compareDateTime = function (a, b) {
        var a = new Date(a);
        var b = new Date(b);
        var compareDate = self.compareDate(a, b);
        if (compareDate == 0) {
            if (a.getHours() == b.getHours()) {
                if (a.getMinutes() == b.getMinutes()) {
                    return a.getSeconds() - b.getSeconds();
                } else {
                    return a.getMinutes() - b.getMinutes();
                }
            } else {
                return a.getHours() - b.getHours();
            }
        } else {
            return compareDate;
        }
    };

    self.validateURL = function(textval) {
       var urlregex = /^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/;
       return urlregex.test(textval);
   }

   self.checkAppVersion = function() {
     if (cordova.getAppVersion) {
         cordova.getAppVersion.getVersionNumber(function (version) {
           var deviceType = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
           var appType = (deviceType == "iPhone" || deviceType == "iPad") ? "IOS" : "APK";
           ClientAPI.getAppVersion({'appType': appType, 'currentVersion': version}, function(err, data){
             if (!err) {
               if (data && data.length > 0 && data[0].currentVersion) {
                  if (self.compareVersion(data[0].currentVersion, version)) {
                    showActionDialog(Messages.General.newVersionApp, "Yes", function(){
                      if (deviceType == "iPhone" || deviceType == "iPad") {
                        window.open('https://play.google.com/store/apps/details?id=com.comtrade.beezify&hl=en', '_blank', 'location=yes');
                      } else {
                        window.open('https://itunes.apple.com/si/app/beezify/id966492343?mt=8', '_blank', 'location=yes');
                      }
                    },"No", function(){});
                  }
               }
             }
           });
         });
     }
   }

   self.compareVersion = function(serverVersion, currentVersion){
     var serverVer = serverVersion.split('.');
     var currentVer= currentVersion.split('.');
     var result = false;
     if (serverVer.length == currentVer.length) {
       for (var i = serverVer.length-1; i >= 0 ; i--) {
         if (parseInt(serverVer[i]) > parseInt(currentVer[i])){
            result = true;
            break;
         }
       }
     }
     return result;
   }


  self.isAndroid = function() {
    var deviceType = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
    if (deviceType == "iPhone" || deviceType == "iPad") {
      return false;
    } else {
      return true;
    }
  }

    return self;
}(UtilController || {}));
