var ChatAPI = (function (ChatAPI) {
    var self = ChatAPI;
    var socket = null;

    self.connect = function (callback) {
        console.log("connected");
        if (socket && socket.connected) {
            callback();
        } else {
            socket = io.connect(ClientAPI.rootURL, {secure: true});
            socket.on('connect', function () {
                callback();
            });
        }
    };

    self.onMessage = function (callback) {
        if (socket) {
            socket.on('message', callback);
            
        }
    };
    
    self.joinRoom = function (roomId, callback) {
        getAF(function (err, af) {
            if (err && typeof callback == "function") {
                callback(err);
                return;
            }
            socket.emit('joinRoom', {_af: af, roomId: roomId});
        });
    };
    
    self.leaveRoom = function (roomId, callback) {
        getAF(function (err, af) {
            if (err && typeof callback == "function") {
                callback(err);
                return;
            }
            if (socket) {
                socket.removeAllListeners();
                socket.emit('leaveRoom', {_af: af, roomId: roomId});
            }
        });
    };

    return self;
})(ChatAPI || {});