var ObjectId=function(val){
	this.val=val;
};

var DateParam=function(val){
	if(!(val instanceof Date)) throw new Error('Parameter is not an instance of a Date object');
	this.val=val.value;
};

function setContentAuthHeader(headerValue) {
    $(document).ajaxSend(function (event, jqXHR, ajaxOptions) {
        if (ajaxOptions.url.toString().substring(0, ClientAPI.rootURL.length) === ClientAPI.rootURL) {
            jqXHR.setRequestHeader("Connect-Auth", headerValue);
        }
    });
}

var ClientAPI=ClientAPI || {};

ClientAPI.rootURL = 'https://test1.beezify.io';

ClientAPI.setTokenDeviceAuth = function (app_domain_name, token, device_id) {
    if (!(ClientAPI.rootURL !== undefined && ClientAPI.rootURL != null && ClientAPI.rootURL.length > 0)) {
        ClientAPI.rootURL = window.location.protocol + "//" + window.location.host;
    }
    setContentAuthHeader(app_domain_name + "=" + token + "=" + device_id);
};

function getAF(callback){
	var cb=callback || function(err){if(err) throw err;};
    var af = sessionStorage.getItem('_af');
    var af_date = new Date(parseInt(sessionStorage.getItem('_af_date'), 10));
    if(af && (new Date() - af_date) < 300000) {
        return cb(null, af);
	}
	else{

    	$.get(ClientAPI.rootURL+'/api/auth/af', function(data){
    		if(!(data&&data.af))return cb(new Error('Missing af token'));
            sessionStorage.setItem('_af', data.af);
            sessionStorage.setItem('_af_date', new Date().valueOf());
    		cb(null, data.af);
    	}).fail(function(){
    		cb(new Error('Request failed'));
    	});
	}
}

function serializeQueryParameters(query, rec) {
    return JSON.stringify(processQueryParameters(query, rec));
}

function processQueryParameters(query, rec){
    var parsedQuery={ __parameterProperties : {}, __type: 'value' };

	if(query instanceof ObjectId)
        parsedQuery.__parameterProperties.objectId=query.val;
    else if(query instanceof Date){
        parsedQuery.__parameterProperties.date=query.valueOf();
    }
    else if(typeof query=='number'){
        parsedQuery.__parameterProperties.number=query;
    }
    else if(typeof query=='boolean'){
        parsedQuery.__parameterProperties.boolean=query;
    }
    else if(query instanceof RegExp){
        parsedQuery.__parameterProperties.regexp=JSON.stringify({
            src: query.source,
            flags: ( query.global?'g':'')+(query.ignoreCase?'i':'')+(query.multiline?'m':'')
        });
    }
    else if(typeof query=='string'){
        parsedQuery.__parameterProperties.mixed=query;
    }
    else{
		if(query !== null && typeof query==='object' ){
			if(Object.keys(query).length>0)
			{
	        	parsedQuery={__type:'object'};
	        	for(var p in query){
                    if(query[p] instanceof Array){
                        parsedQuery[p] = { __type: 'array', __items: [] };
                        if(query[p].length<1) continue;
//			            parsedQuery[p]={ __type:'array', __items:[] };
			            for(var i=0;i<query[p].length;i++){
			                parsedQuery[p].__items[i]= processQueryParameters(query[p][i], true);
			            }
			        }
			        else if(typeof query[p] !== 'function'){
			            parsedQuery[p]= processQueryParameters(query[p], true);
			        }
			    }
			}
			else {
				parsedQuery={__parameterProperties : { mixed: ''}, __type:'object'};
			}
        }
        else{
        	parsedQuery={__parameterProperties : {}, __type:rec === true ? 'value' : 'object'};
            parsedQuery.__parameterProperties.mixed=query ? query+'' : null;
        }
    }

	return parsedQuery;
}

ClientAPI.getAFToken = getAF;

ClientAPI.registerDeviceWithLoginPassword = function (domain, login, password, device_id, callback) {
    var cb = callback || function (err) { if (err) throw err; };
    setContentAuthHeader('');
    $.get(ClientAPI.rootURL + '/api/auth/login', function (data) {
        if (!data.af) return cb(new Error('Missing af token'));
        $.post(ClientAPI.rootURL + '/api/auth/regdevpwd', { domain: domain, login: login, password: password, device_id: device_id, _af: data.af },
            function (status, textStatus, request) {
                if (status.statusCode === 0) {
                    sessionStorage.setItem('_af', status.af);
                    sessionStorage.setItem('_af_date', new Date().valueOf());
                }
                cb(null, { status: status, token: request.getResponseHeader('Connect-Auth') });
        }).fail(function () {
            cb(new Error('Request failed'));
        });
    }).fail(function () {
        cb(new Error('Request failed'));
    });
};

ClientAPI.loginWithPassword=function(domain, login, password, callback){
	var cb=callback || function(err){if(err) throw err;}
	$.get(ClientAPI.rootURL+'/api/auth/login', function(data){
		if(!data.af)return cb(new Error('Missing af token'));
		/*var hashObj = new jsSHA(login+password, "TEXT");
	    var pwd=hashObj.getHash("SHA-256", "HEX");*/
	    $.post(ClientAPI.rootURL+'/api/auth/login',{ domain: domain, login: login, password: password, _af: data.af }, function(status){
            if(status.statusCode === 0) {
                sessionStorage.setItem('_af', status.af);
                sessionStorage.setItem('_af_date', new Date().valueOf());
            }
            cb(null, status);
	    }).fail(function(){
	    	cb(new Error('Request failed'));
	    });
	}).fail(function(){
		cb(new Error('Request failed'));
	});
};

ClientAPI.resetPassword=function(oldPassword, newPassword, callback) {
	if(typeof callback!=='function'|| arguments.length != 3) throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/auth/changepwd', {
		    	_af: af,
		    	params: { oldPwd: oldPassword, pwd: newPassword }
	    	},
	    	function(status){
		    	callback(null, status);
	    });
	});
};

ClientAPI.logout=function(callback){
	var cb=callback || function(err){if(err) throw err;};
	getAF(function(err, af){
		if(err)return cb(err);
	    $.post(ClientAPI.rootURL+'/api/auth/logout', { _af: af }, function(status){
            setContentAuthHeader('');
            sessionStorage.clear();
	    	cb(null, status);
	    }).fail(function(){
	    	cb(new Error('Request failed'));
	    });
	});
};

ClientAPI.search = function (query, options, callback) {
    var parsedQuery = serializeQueryParameters({ queries: query });
    if (typeof callback != 'function' || !(query instanceof Array)) throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/search', {_af: af, params: {query: parsedQuery, options: options}},
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

/**
 * @api {post} ClientAPI.find find
 * @apiDescription Fetch an array of objects
 * @apiName find
 * @apiGroup ClientAPI
 *
 * @apiVersion 1.0.0
 *
 * @apiParam {Object} obj
 * @apiParam {String} obj.objectType string denoting type of object
 * @apiParam {Object} obj.query find query to be executed
 * @apiParam {Array} [obj.sort] array of arrays with sort queries (default sort will be used)
 * @apiParam {String} [obj.objectType] string denoting type of object (used for queries with population)
 * @apiParam {String} [obj.population] type of object to be added into the call (used for queries with population)
 * @apiParam {Function} callback function to be executed when ajax call returns
 *
 * @apiSuccessExample Success-Response:
 * HTTP/1.1 200 OK
 * [ {...} ]
 *
 * @apiExample {json} Single object:
 * ClientAPI.find({
 *  _id: new ObjectId('55d49668ca50e93470c8cf03')
 * }, function(e,d) { console.log(e||d); });
 *
 * @apiExample {json} Multiple objects (simple):
 * ClientAPI.find({
 *     objectType:'Task',
 *     sort: ['taskName', 1],
 *     query: { taskName: 'test' }
 * }, function(e,d) { console.log(e||d); });
 *
 *
 * @apiUse defaultError
 */
ClientAPI.find=function(queryObject, callback){
    var preparedQuery = {};
    if(arguments.length === 3 && typeof arguments[2] === 'function') {
        preparedQuery.query = arguments[0];
        preparedQuery.sort = arguments[1];
        callback = arguments[2];
    }
    else if(arguments.length === 2 && typeof arguments[1] === 'function') {
        preparedQuery = queryObject;
    }

    preparedQuery.query=serializeQueryParameters(preparedQuery.query);
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/find', { _af: af, params: preparedQuery},
            function(data){
	    	    callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.findCount=function(query, callback){
	var parsedQuery=serializeQueryParameters(query);
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/findcount', { _af: af, params: { query: parsedQuery }},
            function(data){
	    	    callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

/**
 * @api {post} ClientAPI.findPaged findPaged
 * @apiDescription Fetch an array of objects with server side paging; expands on ClientAPI.find
 * @apiName findPaged
 * @apiGroup ClientAPI
 *
 * @apiVersion 1.0.0
 *
 * @apiParam {Object} obj
 * @apiParam {String} obj.objectType string denoting type of object
 * @apiParam {Object} obj.query find query to be executed
 * @apiParam {Array} [obj.sort] array of arrays with sort queries (default sort will be used)
 * @apiParam {Number{>1}} [obj.page=1] actual page to skip to
 * @apiParam {Number{1-1000}} [obj.pageSize=10] size of page
 * @apiParam {String} [obj.objectType] string denoting type of object (used for queries with population)
 * @apiParam {String} [obj.population] type of object to be added into the call (used for queries with population)
 * @apiParam {Function} callback function to be executed when ajax call returns
 *
 * @apiExample {json} Basic usage:
 * ClientAPI.findPaged({
 *     objectType:'Task',
 *     sort: ['taskName', 1],
 *     page: 2,
 *     pageSize: 20,
 *     query: { taskName: 'test' }
 * }, function(e,d) { console.log(e||d); });
 *
 * @apiSuccessExample Success-Response:
 * HTTP/1.1 200 OK
 * [ {...} ]
 *
 * @apiUse defaultError
 */
ClientAPI.findPaged=function(queryObject, callback){
    var queryPrepared = {};
    if (arguments.length === 5 && typeof arguments[4] === 'function') {
        queryPrepared.query = arguments[0];
        queryPrepared.sort = arguments[1];
        queryPrepared.page = arguments[2];
        queryPrepared.pageSize = arguments[3];
        callback = arguments[4];
    }
    else if (arguments.length === 2 && typeof callback === 'function') {
        queryPrepared = queryObject;
    }
	if(typeof callback!='function') throw new Error('Invalid parameters');
    queryPrepared.query = serializeQueryParameters(queryPrepared.query);
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/findpaged', { _af: af, params: queryPrepared},
            function(data){
	    	    callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.getChildCount = function (object_ids, query, childtypes, callback) {
	var parsedQuery = serializeQueryParameters(query);
	if (!(object_ids instanceof Array && typeof callback == 'function')) throw new Error('Invalid parameters');
	getAF(function (err, af) {
		if (err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/db/getchildcount', {
				_af: af,
				params: {object_ids: object_ids, childtypes: childtypes, query: parsedQuery}
			},
			function (data) {
				callback(null, data);
			}).fail(function () {
			callback(new Error('Request failed'));
		});
	});
};

ClientAPI.getFeedCount = function (query, callback) {
    var parsedQuery = serializeQueryParameters(query);
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getfeedcount', { _af: af, params: { query: parsedQuery } },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.getFeed = function (query, sort, page, pageSize, callback) {
    var parsedQuery = serializeQueryParameters(query);
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getfeed', { _af: af, params: { query: parsedQuery, sort: sort, page: page, pageSize: pageSize } },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.aggregate=function(query, callback){
    if(!query instanceof Array) throw new Error('Invalid parameters');
    var parsedQuery=serializeQueryParameters({ pipeline: query });
    if(typeof callback!='function') throw new Error('Invalid parameters');
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/aggregate', { _af: af, params: { query: parsedQuery }},
            function(data){
                callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

/**
 * @api {post} ClientAPI.insertObject insertObject
 * @apiDescription Create a new db object
 * @apiName insertObject
 * @apiGroup ClientAPI
 *
 * @apiVersion 1.0.0
 *
 * @apiParam {Object} obj
 * @apiParam {Object} obj.objectType string denoting type of object
 * @apiParam {Function} callback function to be executed when ajax call returns
 *
 * @apiExample {json} Example usage:
 * ClientAPI.insertObject({}, function(e,d) { console.log(e||d); });
 *
 * @apiUse defaultSuccess
 *
 * @apiError (Error) NoAttach Can not attach object with insertObject, use attachChildObject it does inserts too
 * @apiUse OwnerNotFoundError
 * @apiUse ObjectStatusError
 *
 * @apiUse defaultError
 */
ClientAPI.insertObject=function(obj, callback){
	var parsedObj=serializeQueryParameters(obj);
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/insertobject', { _af: af, params: { object: parsedObj }}, function(data){
	    	callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

/**
 * @api {post} ClientAPI.updateObject updateObject
 * @apiDescription Update an existing object in the database; object must contain correct version information
 * @apiName updateObject
 * @apiGroup ClientAPI
 *
 * @apiVersion 1.0.0
 *
 * @apiParam {Object} obj the object to update
 * @apiParam {Object} obj._id ObjectId of the object to update
 * @apiParam {Object} obj.versionID versionId of the object to update (received from backend from a find query)
 * @apiParam {Function} callback function to be executed when ajax call returns
 *
 * @apiExample {json} Example usage:
 * ClientAPI.updateObject({}, function(e,d) { console.log(e||d); });
 *
 * @apiUse defaultSuccess
 * @apiUse NotFoundError
 * @apiUse defaultError
 */
ClientAPI.updateObject=function(obj, callback){
	var parsedObj=serializeQueryParameters(obj);
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/updateobject', { _af: af, params: { object: parsedObj }}, function(data){
	    	callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

/**
 * @api {post} ClientAPI.attachChildObject attachChildObject
 * @apiDescription Insert new object attached to an exisiting object
 * @apiName attachChildObject
 * @apiGroup ClientAPI
 *
 * @apiVersion 1.0.0
 *
 * @apiParam {Object} childObject
 * @apiParam {String} childObject.objectType string denoting type of object
 *; @apiParam {String} parentId id of the parent object
 * @apiParam {Function} callback function to be executed when ajax call returns
 *
 * @apiSuccessExample Success-Response:
 * HTTP/1.1 200 OK
 * { object: {}, statusCode: 0, statusDesc: 'Success' }
 *
 * @apiExample {json} attach object:
 * ClientAPI.attachChildObject({
 *  objectType: 'Task',
 *  taskName: '13210',
 *  taskPriority: 'Low'
 * }, '55d49668ca50e93470c8cf03', function(e,d) { console.log(e||d); });
 *
 * @apiUse defaultError
 */
ClientAPI.attachChildObject=function(childObject, parentId, callback){
	var parsedObj=serializeQueryParameters(childObject);
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/attachchild', { _af: af, params: { childObject: parsedObj, parentId: parentId }},
            function(data){
	    	    callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.promoteToRootObject=function(objId, objectType, callback){
    if(!(objId!==undefined&&objId!=null&&
        objectType!==undefined&&objectType!=null&&objectType.length>0)) throw new Error('Invalid parameters');
    if(typeof callback!='function') throw new Error('Invalid parameters');
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/promtoroot', { _af: af, objId: objId, objectType: objectType }, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.reallocateChildrenToNewRoot=function(oldRootId, newRootId, newRootObjectType, callback){
    if(!(oldRootId!==undefined&&oldRootId!=null&&newRootId!==undefined&&newRootId!=null&&
        newRootObjectType!==undefined&&newRootObjectType!=null&&newRootObjectType.length>0)) throw new Error('Invalid parameters');
    if(typeof callback!='function') throw new Error('Invalid parameters');
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/reallochldrn',
            { _af: af, oldRootId: oldRootId, newRootId: newRootId, newRootObjectType: newRootObjectType },
            function(data){
                callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.availableSchemas=function(callback){
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/availableschemas', { _af: af }, function(data){
	    	callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.getMetadataProperties=function(objectType, callback){
	if(!(typeof objectType=='string' && objectType.length>0)) throw new Error('Invalid parameters');
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/metadataprops', { _af: af, params: { objectType: objectType } }, function(data){
	    	callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.getMetadata=function(objectType, property, callback){
	if(!(typeof objectType=='string' && objectType.length>0&&typeof property=='string' && property.length>0)) throw new Error('Invalid parameters');
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/metadata', { _af: af, params: { objectType: objectType, property: property } }, function(data){
	    	callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.availableObjectFields=function(objectType, callback){
	if(!(typeof objectType=='string' && objectType.length>0)) throw new Error('Invalid parameters');
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/availableobjectfields', { _af: af, params: { objectType: objectType }},
            function(data){
	    	    callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.getCategoryNames = function (callback) {
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getctgrynames', { _af: af }, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.getCategoriesForObjectType=function(objectType, callback){
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/objtypctgs', { _af: af, objectType: objectType}, function(data){
	    	callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.addCategory = function (categoryName, name, description, isDefault, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/addctgry',
            { _af: af, params: { categoryType: categoryName, name: name, description: description, isDefault: isDefault } },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.updateCategory = function (category, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    var parsedObj = serializeQueryParameters(category);
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/updctgry',
            { _af: af, params: { category: parsedObj } },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.addTemplate = function (templateName, template, type, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/addtmp',
            { _af: af, params: { templateName: templateName, template: template, type: type } },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.updateTemplate = function (template, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    var parsedObj = serializeQueryParameters(template);
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/updtmp',
            { _af: af, params: { template: parsedObj } },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};


ClientAPI.getTemplatesForType=function(type, callback){
    if(typeof callback!='function') throw new Error('Invalid parameters');
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/tmptypes', { _af: af, type: type}, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.removeTemplate=function(template, callback){
    if(!(template!==undefined&&template!=null)) throw new Error('Invalid parameters');
    if(typeof callback!='function') throw new Error('Invalid parameters');
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/removetmp', { _af: af, template:template }, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.getIdentitiesInfo = function (identity_ids, callback) {
    if (!(identity_ids instanceof Array&&typeof callback == 'function')) throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getidentinfo', { _af: af, params: { identity_ids: identity_ids } },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.getAppUsersAndGroups=function(name, startAt, maxCount, filterType, callback){
    if(typeof filterType === 'function') {
        callback = filterType;
        filterType = '';
    }
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/getappusersgroups', { _af: af, params: { name: name, startAt: startAt, maxCount: maxCount, filterType: filterType }},
            function(data){
	    	    callback(null, data);
	        }).fail(function(){
	    	    callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.getAppUsersAndGroupsCount=function(name, callback){
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/getappusersgroupscnt', { _af: af, params: { name: name }},
            function(data){
	    	    callback(null, data);
	        }).fail(function(){
	    	    callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.getUsersGroupsNumber = function (type, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getusersgroupscount', {_af: af, params: {type: type}},
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.updateSipStatus = function (sipProfile, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/sip/UpdateStatus', {
            _af: af,
            domain: sipProfile.domain,
            status: sipProfile.status
        }, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.getOnlineUsers = function (domain, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/sip/getonlineusers', {
            _af: af,
            domain: domain
        }, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.registerSip = function (sipInfo, callback) {
    if (typeof callback != 'function' || !sipInfo.expires || !sipInfo.domain || !sipInfo.user) {
        throw new Error('Invalid parameters');
    }
    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/sip/register', {
            _af: af,
            domain: sipInfo.domain,
            user: sipInfo.user,
            pass: sipInfo.pass,
            expires: sipInfo.expires
        }, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.updateUserProfile=function(profile, callback){
	var parsedObj=serializeQueryParameters(profile);
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
	    $.post(ClientAPI.rootURL+'/api/db/updusrprof', { _af: af, params: { profile: parsedObj }}, function(data){
	    	callback(null, data);
	    }).fail(function(){
	    	callback(new Error('Request failed'));
	    });
	});
};

ClientAPI.getUserInfo=function(callback) {
	if(typeof callback!='function') throw new Error('Invalid parameters getUserInfo');
    $.get(ClientAPI.rootURL+'/api/auth/getuserinfo', function(data){
    	callback(null, data);
    }).fail(function(){
    	callback(new Error('Request failed'));
    });
};

/*
 * Call to fetch current api version
 *
 *  @param: callback
 *  async callback function returns error as a single parameter or null and server data
 *
 *  server data is: { version: 'version-tag' }
 */
ClientAPI.getApiVersion = function (callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters getUserInfo');
    $.get(ClientAPI.rootURL + '/api/auth/getversion', function (data) {
        callback(null, data);
    }).fail(function () {
        callback(new Error('Request failed'));
    });
};

/*
 * Fetch notifications for logged in user
 *
 *  @param: callback
 *  async callback function returns error as a single parameter or null and server data
 *
 *  server data is an array of notifications
 */
ClientAPI.getNotifications = function (options, callback) {
    if(arguments.length === 1) {
        callback = options;
        options = void 0;
    }
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getnotifications', {_af: af, options: options}, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

/*
 * Update notifications for given user, also used to mark a single notification as read
 *
 *  @param: callback
 *  async callback function returns error as a single parameter or null and server data
 *
 *  server data is a confirmation message { statusCode: 0, statusDesc: 'msg' }
 */
ClientAPI.updateNotifications = function (params, callback) {
    if (arguments.length === 1) {
        throw new Error('Invalid parameters');
    }
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/updnotifications', {_af: af, params: params}, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.getNotificationCount = function (callback) {
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getnotificationcount', {_af: af}, function (data) {
            callback(null,data.count);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.bindAttachmentUploadHandler=function(formID, success, error, progress, beforeSend){
	if(!(formID!==undefined&&formID!=null)) throw new Error('Invalid parameters');
    if(typeof success!='function')  throw new Error('Invalid parameters');
    if(typeof error!='function')  throw new Error('Invalid parameters');
    var fid=(formID[0]=='#'?'':'#')+formID;
    if($(fid).length<1) error('Form with id "'+fid+'" not found');
    if($(fid).children('#attachment').length<1) $(fid).prepend('<input type="file" name="attachment" id="attachment" />');
    if($(fid).children('#_af').length<1) $(fid).prepend('<input type="hidden" name="_af" id="_af" />');
    $(fid).attr('enctype', 'multipart/form-data');
    var bf=function(){}, prog=function(event, position, total, percentComplete){};
    if(typeof beforeSend=='function') bf=beforeSend;
    if(typeof progress=='function') prog=progress;
    $(fid).ajaxForm({ beforeSubmit: function(){ return false; }, beforeSend: bf, uploadProgress: prog });
    $(fid).submit(function(){
        if($(fid).children('#objId').length<1){
                error('Missing object id field');
        }
        else{
	        getAF(function(err, af){
		        if(err) return error(err);
                $(fid).children('#_af').val(af);
                $(fid).ajaxSubmit({ url: ClientAPI.rootURL+'/api/db/attachfile', type: 'post', iframe: true, success: success, error: error });
	        });
        }
        return false;
    });
};

ClientAPI.getFileAttachment=function(objId, attachmentName){
    window.location = ClientAPI.rootURL+'/api/db/getfilattchmnt?objId='+encodeURIComponent(objId)+'&attachmentName='+encodeURIComponent(attachmentName);
};

ClientAPI.deleteFileAttachment=function(objId, attachmentName, callback){
    if(typeof callback!='function') throw new Error('Invalid parameters');
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/delfilattchmnt', { _af: af, objId:objId, attachmentName:attachmentName }, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.editAttachment=function(objId, fileId , newDesc, callback){
    if(typeof callback != 'function' && objId== undefined && fileId == undefined && newDesc == undefined) throw new Error('Invalid parameters');
    getAF(function(err, af){
       if(err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/editattchmnt', {_af:af, objId : objId, fileId : fileId , newDesc : newDesc}, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};


ClientAPI.bindImageUploadHandler = function (formID, success, error, progress, beforeSend) {
    if (!(formID !== undefined && formID != null)) throw new Error('Invalid parameters');
    if (typeof success != 'function') throw new Error('Invalid parameters');
    if (typeof error != 'function') throw new Error('Invalid parameters');
    var fid = (formID[0] == '#' ? '' : '#') + formID;
    if ($(fid).length < 1) error('Form with id "' + fid + '" not found');
    if ($(fid).find('#attachment').length < 1) $(fid).prepend('<input type="file" name="attachment" id="attachment" />');
    if ($(fid).children('#_af').length < 1) $(fid).prepend('<input type="hidden" name="_af" id="_af" />');
    $(fid).attr('enctype', 'multipart/form-data');
    var bf = function () { }, prog = function (event, position, total, percentComplete) { };
    if (typeof beforeSend == 'function') bf = beforeSend;
    if (typeof progress == 'function') prog = progress;

    $(fid).off('submit');
    $(fid).on('submit',function (e) {
        if ($(fid).find('#objId').length < 1) {
            error('Missing object id field');
        }
        else if ($(fid).find('#fieldName').length < 1) {
            error('Missing field name');
        }
        else {
            getAF(function (err, af) {
                if (err) return error(err);
                $(fid).children('#_af').val(af);
                $(fid).ajaxSubmit({
                    beforeSubmit: function () {
                    },
                    beforeSend: bf,
                    uploadProgress: prog,
                    url: ClientAPI.rootURL + '/api/db/uploadimg',
                    type: 'post',
                    dataType:'json',
                    textarea:true,
                    success: success,
                    error: error});
            });
        }
        return false;
    });
};

ClientAPI.uploadImage = function (formId,success,err,progress,beforeSend){
	// prepare image form for post
	ClientAPI.bindImageUploadHandler(formId, success,err,progress,beforeSend);
	// submit the form after it is prepared
	var fid = (formId[0] == '#' ? '' : '#') + formId;
	$(fid).submit();
};

ClientAPI.downloadImage = function (objId, fieldName) {
    window.location = (ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(objId) + '&fieldName=' + encodeURIComponent(fieldName));
};

ClientAPI.deleteImage = function (objId, fieldName, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/deleteimg', { _af: af, objId: objId, fieldName: fieldName }, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.changeOwner = function (objId, identity_id, callback) {
    if (!(objId !== undefined && objId != null && identity_id !== undefined && identity_id != null && identity_id.length>0)) {
        throw new Error('Invalid parameters');
    }
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    var parsedObj = serializeQueryParameters({ objId: objId, identity_id: identity_id });
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/changeowner', { _af: af, params: parsedObj }, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.updateACL=function(objId, newACL, callback){
    if(!(objId!==undefined&&objId!=null&&newACL!==undefined&&newACL!=null&&newACL instanceof Array)){
        throw new Error('Invalid parameters');
    }
    if(typeof callback!='function') throw new Error('Invalid parameters');
    var parsedObj=serializeQueryParameters({ objId: objId, newACL: newACL });
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/updacl', { _af: af, params: parsedObj }, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.executeTransitionalAction=function(action, objectType, objId, paramObj, callback){
    if(!(objId!==undefined&&objId!=null&&action!==undefined&&action!=null&&action.length>0&&
            objectType!==undefined&&objectType!=null&&objectType.length>0)) throw new Error('Invalid parameters');
    if(typeof callback!='function') throw new Error('Invalid parameters');
    var parsedObj=serializeQueryParameters({ action: action, objectType: objectType, objId: objId, paramObj: paramObj });
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/exectract', { _af: af, params: parsedObj }, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.undoLastTransitionalAction=function(objectType, objId, paramObj, callback){
    if(!(objId!==undefined&&objId!=null&&objectType!==undefined&&objectType!=null&&objectType.length>0)) throw new Error('Invalid parameters');
    if(typeof callback!='function') throw new Error('Invalid parameters');
    var parsedObj=serializeQueryParameters({ objectType: objectType, objId: objId, paramObj: paramObj });
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/undolsttract', { _af: af, params: parsedObj }, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.addGroupAdmins=function (userIds, group, callback) {
    if(arguments.length != 3 || typeof callback !== 'function') {
        throw new Error('Invalid parameters');
    }
    if(!group || !(group.length > 0) || !userIds || !(userIds.length > 0)) {
        return callback(new Error('Invalid parameters'));
    }
    getAF(function (err, af) {
        if(err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/addgroupadmins', { _af: af, group: group, userIds: userIds }, function (data) {
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    })
};

ClientAPI.removeGroupAdmin=function (userId, group, callback) {
    if(arguments.length != 3 || typeof callback !== 'function') {
        throw new Error('Invalid parameters');
    }
    if(!group || !userId ) {
        return callback(new Error('Invalid parameters'));
    }
    getAF(function (err, af) {
        if(err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/removegroupadmin', { _af: af, group: group, userId: userId }, function (data) {
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    })
};

ClientAPI.getGroupAdmins=function (group, callback) {
    if(arguments.length != 2 || typeof callback !== 'function') {
        throw new Error('Invalid parameters');
    }
    if(!group || !(group.length > 0)) {
        return callback(new Error('Invalid parameters'));
    }
    getAF(function (err, af) {
        if(err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getgroupadmins', { _af: af, group: group }, function (data) {
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    })
};

ClientAPI.addUsersToGroup=function (userIds, group, callback) {
	if(arguments.length != 3 || typeof callback !== 'function') {
		throw new Error('Invalid parameters');
	}
	if(!group || !(group.length > 0) || !userIds || !(userIds.length > 0)) {
		return callback(new Error('Invalid parameters'));
	}
	getAF(function (err, af) {
		if(err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/db/addusertogroup', { _af: af, group: group, userIds: userIds }, function (data) {
			callback(null, data);
		}).fail(function(){
            callback(new Error('Request failed'));
        });
	})
};

ClientAPI.removeUserFromGroup=function (userId, group, callback) {
	if(arguments.length != 3 || typeof callback !== 'function') {
		throw new Error('Invalid parameters');
	}
	if(!group || !(group.length > 0)) {
		return callback(new Error('Invalid parameters'));
	}
	getAF(function (err, af) {
		if(err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/db/removeuserfromgroup', { _af: af, group: group, userId: userId }, function (data) {
			callback(null, data);
		}).fail(function(){
            callback(new Error('Request failed'));
        });
	})
};

ClientAPI.addGroup=function (groupName, groupDescription, callback) {
	if(arguments.length != 3 || typeof callback !== 'function') {
		throw new Error('Invalid parameters');
	}
	if(!(groupName && groupName.length > 0 && groupDescription && groupDescription.length > 0)) {
		return callback(new Error('Invalid parameters'));
	}
	getAF(function (err, af) {
		if(err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/db/addgroup', { _af: af, groupName: groupName, groupDescription: groupDescription }, function (data) {
			callback(null, data);
		}).fail(function(){
            callback(new Error('Request failed'));
        });
	})
};

ClientAPI.updateGroup=function (groupName, groupDescription, callback) {
	if(arguments.length != 3 || typeof callback !== 'function') {
		throw new Error('Invalid parameters');
	}
	if(!(groupName && groupName.length > 0 && groupDescription && groupDescription.length > 0)) {
		return callback(new Error('Invalid parameters'));
	}
	getAF(function (err, af) {
		if(err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/db/updategroup', { _af: af, groupName: groupName, groupDescription: groupDescription }, function (data) {
			callback(null, data);
		}).fail(function(){
            callback(new Error('Request failed'));
        });
	});
};

ClientAPI.getGroupMembers = function (groupName, startAt, maxCount, callback) {
    if (arguments.length != 4 || typeof callback !== 'function') {
        throw new Error('Invalid parameters');
    }
    if (!(groupName && groupName.length > 0)) {
        return callback(new Error('Invalid parameters'));
    }
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getgroupmembers', { _af: af, params: { name: groupName, startAt: startAt, maxCount:maxCount }}, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.getIdentityGroups = function (identity_id, callback) {
    if (arguments.length != 2 || typeof callback !== 'function') {
        throw new Error('Invalid parameters');
    }
    if (!(identity_id && identity_id.length > 0)) {
        return callback(new Error('Invalid parameters'));
    }
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getidentitygroups', { _af: af, params: { identity_id: identity_id }}, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

/**
 * @api {post} ClientAPI.removeObject removeObject
 * @apiDescription Remove an existing object from the database; the operation fails if the object has children
 * @apiName removeObject
 * @apiGroup ClientAPI
 *
 * @apiVersion 1.0.0
 *
 * @apiParam {String} objId ObjectId of the object we need to remove
 * @apiParam {Function} callback function to be executed when ajax call returns
 *
 * @apiExample {json} Example usage:
 * ClientAPI.removeObject('55d49668ca50e93470c8cf03', function(e,d) { console.log(e||d); });
 *
 * @apiUse defaultSuccess
 * @apiUse NotFoundError
 * @apiUse defaultError
 */
ClientAPI.removeObject=function(objId, callback){
    if(!(objId!==undefined&&objId!=null)) throw new Error('Invalid parameters');
    if(typeof callback!='function') throw new Error('Invalid parameters');
    getAF(function(err, af){
        if(err)return callback(err);
        $.post(ClientAPI.rootURL+'/api/db/removeobj', { _af: af, objId:objId }, function(data){
            callback(null, data);
        }).fail(function(){
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.getLocale = function (path, callback) {
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    $.get(ClientAPI.rootURL + '/api/locale/getlocale', { path: path }, function (data) {
        callback(null, data);
    }).fail(function () {
        callback(new Error('Request failed'));
    });
};

ClientAPI.setLocale = function (lang, callback) {
    if (!(lang !== undefined && lang != null && lang.length > 0)) throw new Error('Invalid parameters');
    if (typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err) return callback(err);
        $.post(ClientAPI.rootURL + '/api/locale/changelocale', { _af: af, lang: lang }, function (data) {
            callback(null, data);
        }).fail(function () {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.registerNotificationToken = function (tokenInfo, callback) {
	if(!tokenInfo || typeof callback != 'function') {
		throw new Error('Invalid parameters');
	}
	getAF(function (err, af) {
		if (err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/push/registertoken', {_af: af, params: tokenInfo}, function (data) {
			callback(null, data);
		}).fail(function () {
			callback(new Error('Request failed'));
		});
	});
};

ClientAPI.getUserSettings = function (callback) {
	if(typeof callback != 'function') {
		throw new Error('Invalid parameters');
	}

	getAF(function (err, af) {
		if (err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/auth/getusrdata', { _af: af }, function (data) {
			callback(null, data);
		}).fail(function () {
			callback(new Error('Request failed'));
		});
	});
};

ClientAPI.updateUserSettings = function (userSettings, callback) {
	if (!userSettings || typeof userSettings != 'object' || typeof callback != 'function') {
		throw new Error('Invalid parameters');
	}

	getAF(function (err, af) {
		if (err) return callback(err);
		$.post(ClientAPI.rootURL + '/api/auth/setusrdata', {_af: af, params: userSettings }, function (data) {
			callback(null, data);
		}).fail(function () {
			callback(new Error('Request failed'));
		});
	});
};

ClientAPI.requestPasswordReset = function(email, callback){
	//var parsedObj=serializeQueryParameters(obj);
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
		$.post(ClientAPI.rootURL+'/user/resetpwd', { _af: af, email:email}, function(data){
			callback(null, data);
		}).fail(function(){
			callback(new Error('Request failed'));
		});
	});
};

ClientAPI.inviteUser = function(invite,callback){
    //NOTE (petarz): new form design doesn't need firstName and lastName, it just needs an email and message
	if(typeof callback!='function'  || !invite.message || !invite.email){ throw new Error("Invalid parameters");}

	getAF(function(err,af){
		if(err){return callback(err);}
		$.post(ClientAPI.rootURL+'/api/db/userinvite',{_af:af, invite:invite},function success(data){
			callback(null,data);
		}).fail(function requestFailed(){
			callback(new Error('Request failed'));
		});
	});

};

ClientAPI.getInvitations = function (queryObject, callback) {
    if(typeof callback != 'function'){
        throw new Error("Invalid parameters");
    }
    getAF(function (err, af) {
        if (err) {
            return callback(err);
        }
        $.post(ClientAPI.rootURL + '/api/db/getinvitations', {_af: af, params: queryObject}, function success(data) {
            callback(null, data);
        }).fail(function requestFailed() {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.getInvitationNumber = function (callback) {
    if (typeof callback != 'function') {
        throw new Error("Invalid parameters");
    }
    getAF(function (err, af) {
        if (err) {
            return callback(err);
        }
        $.post(ClientAPI.rootURL + '/api/db/getinvitationcount', {_af: af}, function success(data) {
            callback(null, data);
        }).fail(function requestFailed() {
            callback(new Error('Request failed'));
        });
    });
};

ClientAPI.downloadAsCsv = function(objectId, title){
    var url = ClientAPI.rootURL + '/api/db/csvexport?objectId='+encodeURIComponent(objectId);
    if(title){
        url+= '&title='+encodeURIComponent(title);
    }
    window.location =  url;
};

ClientAPI.downloadQueryAsCsv = function(query){
    if (query) {
        getAF(function (err, af) {
            if (err) {
                return callback(err);
            }
            var parsedQuery=serializeQueryParameters({ pipeline: query, title:(new Date()).toJSON() });

            $.post(ClientAPI.rootURL + '/api/db/csvexport', {_af: af, params: {query: parsedQuery}}, function success(response, status, xhr) {
                var filename = "";
                var disposition = xhr.getResponseHeader('Content-Disposition');
                if (disposition && disposition.indexOf('attachment') !== -1) {
                    var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                    var matches = filenameRegex.exec(disposition);
                    if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                }

                var type = xhr.getResponseHeader('Content-Type');
                var blob = new Blob([response], { type: type });
                if (typeof window.navigator.msSaveBlob !== 'undefined') {

                    window.navigator.msSaveBlob(blob, filename);
                } else {
                    var URL = window.URL || window.webkitURL;
                    var downloadUrl = URL.createObjectURL(blob);

                    if (filename) {

                        var a = document.createElement("a");

                        if (typeof a.download === 'undefined') {
                            window.location = downloadUrl;
                        } else {
                            a.href = downloadUrl;
                            a.download = filename;
                            document.body.appendChild(a);
                            a.click();
                        }
                    } else {
                        window.location = downloadUrl;
                    }

                    setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100);
                }
            }).fail(function requestFailed() {
                console.log('Request failed');
            });
        });



    }
};

ClientAPI.findConversations = function (roomId, query, sort, page, pageSize, callback) {
    var parsedQuery = serializeQueryParameters(query);
    if (roomId.length !== 24 || typeof callback != 'function') throw new Error('Invalid parameters');
    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/getconvs', {
                _af: af,
                params: {roomId: roomId, query: parsedQuery, sort: sort, page: page, pageSize: pageSize}
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.findSettings = function (queryObject, callback) {
    if(typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    queryObject.query = serializeQueryParameters(queryObject.query);

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/user/settings', {
                _af: af,
                params: queryObject
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.addSettings = function (settings, callback) {
    if(typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/user/addsettings', {
                _af: af,
                settings: serializeQueryParameters(settings)
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.updateSettings = function (settings, callback) {
    if (typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/user/updatesettings', {
                _af: af,
                settings: serializeQueryParameters(settings)
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.removeSettings = function (settings, callback) {
    if(typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/user/removesettings', {
                _af: af,
                settings: serializeQueryParameters(settings)
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.findLocations = function (params, callback) {
    if (typeof callback != 'function' || !params.position || !params.objectType) {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.ajax({
            type: 'POST',
            url: ClientAPI.rootURL + '/api/db/locations',
            contentType: 'application/json; charset=UTF-8',
            data: JSON.stringify({
                _af: af,
                params: params
            }),
            dataType: 'json'
        })
            .done(function (data) {
                callback(null, data);
            })
            .fail(function (reason) {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.getEffortCount = function(queryObject, callback){
    if(typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/effortcount', {
                _af: af,
                params: queryObject
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.findEfforts = function (queryObject, callback) {
    if (typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    queryObject.query = serializeQueryParameters(queryObject.query);

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/efforts', {
                _af: af,
                params: queryObject
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.addEfforts = function (efforts, callback) {
    if (typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/addefforts', {
                _af: af,
                efforts: serializeQueryParameters(efforts)
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.updateEfforts = function (efforts, callback) {
    if (typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/updateefforts', {
                _af: af,
                efforts: serializeQueryParameters(efforts)
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.removeEfforts = function (efforts, callback) {
    if (typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/db/removeefforts', {
                _af: af,
                efforts: serializeQueryParameters(efforts)
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.getReport = function (params) {
    if (!params || !params.format || !params.reportName) {
        throw new Error('Invalid parameters');
    }

    window.location = '/api/reports/report?' + $.param({ reports: serializeQueryParameters(params)});
};

ClientAPI.prepareReport = function (params, callback) {
	if (!params || !params.format || !params.reportName) {
		throw new Error('Invalid parameters');
	}
	if (typeof callback != 'function') {
		throw new Error('Invalid parameters');
	}

	getAF(function (err, af) {
		if (err)return callback(err);
		$.post(ClientAPI.rootURL + '/api/reports/report', {
				_af: af,
				params: serializeQueryParameters(params)
			},
			function (data) {
				callback(null, data);
			}).fail(function () {
			callback(new Error('Request failed'));
		});
	});
};

ClientAPI.getKanbanLists = function (params, callback) {
    if(callback === undefined) {
        callback = params;
        params = {};
    }
    if (typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/kanban/lists', {
                _af: af,
                params: params
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.updateKanbanList = function (params, callback) {
    if (typeof callback != 'function') {
        throw new Error('Invalid parameters');
    }

    getAF(function (err, af) {
        if (err)return callback(err);
        $.post(ClientAPI.rootURL + '/api/kanban/updateLists', {
                _af: af,
                params: params
            },
            function (data) {
                callback(null, data);
            }).fail(function () {
                callback(new Error('Request failed'));
            });
    });
};

ClientAPI.getAppVersion = function(params, callback){
	if(typeof callback!='function') throw new Error('Invalid parameters');
	getAF(function(err, af){
		if(err)return callback(err);
		$.post(ClientAPI.rootURL+'/api/db/getappversion', { _af: af, params: params},
			function(data){
				callback(null, data);
			}).fail(function(){
			callback(new Error('Request failed'));
		});
	});
};
