/******************************
 *********** Users ************
 ******************************/
var ALL_USERS = [];
var ALL_USERS_OBJS = [];

/******************************
 ****** taskCategories ********
 ******************************/
var taskCategories = [];

/******************************
 ****** dealCategories ********
 ******************************/
var dealCategories = [];

/******************************
 ****** UPCOMING TASKS  *******
 ******************************/
var UPCOMING_TASKS = [];

/******************************
 ****** UPCOMING OVERDUE ******
 ******************************/
var UPCOMING_OVERDUE = [];

/******************************
 ****** UPCOMING OVERDUE ******
 ******************************/
var ASSIGNED_TASKS = [];

/******************************
 ****** ASSIGNED OVERDUE ******
 ******************************/
var ASSIGNED_OVERDUE = [];

/******************************
 ********* COMPLETED **********
 ******************************/
var COMPLETED = [];

/******************************
 ********* PEOPLE **********
 ******************************/
var PEOPLE = [];

/******************************
 ********* COMPANY ***********
 ******************************/
var COMPANY = [];

var COMPANY_MAP = [];

/******************************
 ********** CASES *************
 ******************************/
var CASES = [];

/******************************
 ********** DEALS *************
 ******************************/
var DEALS = [];

/******************************
 ********** GROUPS *************
 ******************************/
var GROUPS = [];

/******************************
 ******* dealsCategory ********
 ******************************/
var dealsCategory = [];

/******************************
 ******* taskCategory ********
 ******************************/
var taskCategory = [];

/******************************
 ******* sipAccountMap ***********
 ******************************/
var sipAccountMap = [];

/******************************
 ******* sipAccount ***********
 ******************************/
var sipAccount = [];

/******************************
 ******* CONTACT_MAPPING ******
 ******************************/
var CONTACT_MAPPING = [];

function getAllUsers(data, callback) {
    console.log("Ulazak u get all users");
    ALL_USERS_OBJS = [];
    if (!connection) {
        var peopleFromDB = {};
        db.selectAll('user', function (user) {
            db.selectAll('people', function (people) {
                $(people).each(function (index, value) {
                    peopleFromDB[value['people']['id']['text']] = value['people'];
                });
                $(user).each(function (index, value) {
                    if (peopleFromDB[value['user']['person']]) {
                        value['user']['avatar-url'] = peopleFromDB[value['user']['person']]['avatar-url'];
                    }
                    ALL_USERS[value['user'].id.text] = value['user'];
                    ALL_USERS_OBJS.push(value['user']);
                });
                if(callback && typeof callback == "function"){
                    callback();
                }
            });
        });
        $(GROUPS).each(function (index, value) {
            ALL_USERS[value.id.text] = value;
        });
    } else {
      try {
        ClientAPI.getAppUsersAndGroupsCount(null, function (err, count) {
        	ClientAPI.getAppUsersAndGroups(null, 0, count, function (err, items) {
        	  	ClientAPI.find({query: {objectType: 'Person'}, objectType: 'Person'},
        	  		function (err, data) {
        		  	  	var peopleFromDB = {};
            		  		$(data).each(function(index, element){
        					       var itemEncode = PeopleController.encodeItem(element);
        	                peopleFromDB[itemEncode['id']['text']] = itemEncode;
          				    });
      			  	      $(items).each(function(index, element){
            			  		if (element.identityType === "User") {
                            var userEncode = UserController.encodeItem(element);
                						ALL_USERS[element._id] = userEncode;
                            ALL_USERS_OBJS.push(userEncode);
                					} else if (element.identityType === "Group") {
                            var groupEncode = GroupController.encodeItem(element);
                						ALL_USERS[element._id] = groupEncode;
                            ALL_USERS_OBJS.push(groupEncode);
                					}
                					if (peopleFromDB[element['person']]) {
        	                    ALL_USERS[element._id]['avatar-url'] = peopleFromDB[element['person']]['avatar-url'];
        	                }
                          ALL_USERS_OBJS.push(element);
              				});
                      console.log("Callback getAllUser");
                      if(callback && typeof callback == "function"){
                          callback();
                      }
        	  	  });
    	      });
        });
      } catch(e){
        console.log("Callback getAllUser");
        if(callback && typeof callback == "function"){
            callback();
        }
      }
    }
}


function getAllTaskByType(type) {
    db.selectByColumn('task', 'status', type, function (data) {
        for (var item in data) {
            var taskObject = data[item]['task'];
            var owner = "Owner: " + ALL_USERS[taskObject['owner-id']['text']]['name'];
            taskObject['owner'] = owner;

            var subjectDesc = taskObject['subject-type'] + ":" + taskObject['subject-name'];
            if (typeof taskObject['subject-type'] !== 'object') {
                taskObject['subjectDes'] = subjectDesc;
            } else {
                taskObject['subjectDes'] = " ";
            }

            if (type == 'completed') {
                COMPLETED.push(taskObject);
            }

            if (type == 'assigned') {
                if (taskObject['frame'] == "overdue") {
                    ASSIGNED_TASKS.push(taskObject);
                } else {
                    ASSIGNED_OVERDUE.push(taskObject);
                }
            }

            if (type == 'upcoming') {
                if (taskObject['frame'] == "overdue") {
                    UPCOMING_TASKS.push(taskObject);
                } else {
                    UPCOMING_OVERDUE.push(taskObject);
                }
            }
        }

        if (type == 'completed') {
            COMPLETED.sort(function (a, b) {
                sortFunction(a, b);
            });
        }

        if (type == 'assigned') {
            UPCOMING_TASKS.sort(function (a, b) {
                sortFunction(a, b);
            });
            UPCOMING_OVERDUE.sort(function (a, b) {
                sortFunction(a, b);
            });
        }

        if (type == 'upcoming') {
            ASSIGNED_TASKS.sort(function (a, b) {
                sortFunction(a, b);
            });
            ASSIGNED_OVERDUE.sort(function (a, b) {
                sortFunction(a, b);
            });
        }
    });
}

function getAllTaskForDealByType(id, type, callBack) {
    var retArray = new Array();
    if (connection) {
        ClientAPI.find({objectType: "Task", status: type, $or: [{immediateParent: new ObjectId(id)}, {rootObject: new ObjectId(id)}]}, [["dueDate", -1], ["status", -1]], function (err, data) {
            var result = [];
            if (!err) {
                for (var i = 0, max = data.length; i < max; i++) {
                    result.push(TaskController.encodeItem(data[i]));
                }
                if (callBack != null && typeof callBack == "function") {
                    callBack(result);
                }
            } else {
                if (callBack != null && typeof callBack == "function") {
                    callBack(result);
                }
            }
        });
    } else {
        if (type != "Completed") {
            db.selectByQuery('SELECT * FROM ' + models.taskDBModel.name + ' WHERE status=? AND [subject-id]=?', [type, getTextTypeObject(id, 'integer')], 'task', function (data) {
                retArray = sortTask(type, data);
                if (callBack != null) {
                    callBack(retArray);
                }
            });
        } else {
            if (callBack != null && typeof callBack == "function") {
                callBack([]);
            }
        }
    }

}

function getAllUpcomingTaskForDeal(id, callBack) {
    var retArray = new Array();
    if (connection) {
        ClientAPI.find({objectType: "Task", status: {$ne: "Completed"}, $or: [{immediateParent: new ObjectId(id)}, {rootObject: new ObjectId(id)}]}, [["dueDate", -1], ["status", -1]], function (err, data) {
            if (!err) {
                var result = [];
                for (var i = 0, max = data.length; i < max; i++) {
                    result.push(TaskController.encodeItem(data[i]));
                }
                if (callBack != null && typeof callBack == "function") {
                    callBack(result);
                }
            } else {
                if (callBack != null && typeof callBack == "function") {
                    callBack([]);
                }
            }
        });
    } else {
        db.selectByQuery('SELECT * FROM ' + models.taskDBModel.name + ' WHERE [subject-id]=?', [getTextTypeObject(id, 'integer')], 'task',
                function (data) {
                    var result = [];
                    for (var obj in data) {
                        if (data[obj].status != "Completed") {
                            result.push(data[obj]);
                        }
                    }

                    retArray = sortTask("", result);
                    if (callBack != null) {
                        callBack(retArray);
                    }
                });
    }
}

function getAllCases(data) {
    if (data == null) {
        db.selectAll('kase', function (data) {
            $(data).each(function (index, value) {
                CASES.push(value['kase']);
            });
        });
    } else {
        CASES = data['kases']['kase'];
    }
}
function getAllCompany(data) {
    COMPANY = [];
    if (data == null) {
        if (db != null) {
            db.selectAll('company', function (data) {
                $(data).each(function (index, value) {
                    COMPANY.push(value['company']);
                });
            });
        }
    } else {
        var pom = new Object();
        pom.companies = new Object();
        pom.companies.company = [];
        for (var p in data['companies']['company']) {
            pom.companies.company[p] = new Object();
            for (var l in data['companies']['company'][p]) {
                pom.companies.company[p][l] = data['companies']['company'][p][l];
            }
        }
        COMPANY = data['companies']['company'];
    }
}



function getAllPeople(data) {
    PEOPLE = [];
    if (data == null) {
        if (db != null) {

        }
    } else {
        var pom = new Object();
        pom.people = new Object();
        pom.people.person = [];
        if (data.length > 1) {
            for (var p in data['people']['person']) {
                pom.people.person[p] = new Object();
                for (var l in data['people']['person'][p]) {
                    pom.people.person[p][l] = data['people']['person'][p][l];
                }
            }
            PEOPLE = pom['people']['person'];
        } else {
            PEOPLE = data['people']['person'];
        }
    }
}

function getAllDeals(data) {
    if (data == null) {
        db.selectAll('deal', function (data) {
            $(data).each(function (index, value) {
                DEALS.push(value['deal']);
            });
        });
    } else {
        var pom = new Object();
        pom.deals = new Object();
        pom.deals.deal = [];
        for (var p in data['deals']['deal']) {
            pom.deals.deal[p] = new Object();
            for (var l in data['deals']['deal'][p]) {
                if (typeof data['deals']['deal'][p] == 'object')
                    pom.deals.deal[p][l] = data['deals']['deal'][p][l];
                else {
                    pom.deals.deal[p] = data['deals']['deal'][p];
                }
            }
        }
        if (pom['deals']['deal'].length) {
            DEALS = pom['deals']['deal'];
        } else {
            DEALS = pom['deals'];
        }
    }
}

function getDealsByStatus(status) {
    var retArray = new Array();
    for (var deal in DEALS) {
        if (DEALS[deal].status === status) {
            retArray.push(DEALS[deal]);
        }
    }
    return retArray;
}

function getDealByID(dealId) {
    var dealObj = new Object();
    for (var deal in DEALS) {
        if (DEALS[deal].id.text == dealId)
            dealObj = DEALS[deal];
    }
    return dealObj;
}

function getAllDealsCategory() {
    dealsCategory = [];
    dealCategories = [];
    db.selectAll(models.dealCategoriesDBModel.name, function (data) {
        $(data).each(function (index, value) {
            dealsCategory.push(value.dealCategory);
            dealCategories.push(value.dealCategory);
        });
        console.log('deal category');
    });
}

function getAllTasksCategory() {
    taskCategory = [];
    taskCategories = [];
    db.selectAll(models.taskCategoriesDBModel.name, function (data) {
        $(data).each(function (index, value) {
            taskCategory[value['taskCategory'].id.text] = value['taskCategory'];
            taskCategories.push(value['taskCategory']);
            console.log('task category');
        });
    });

}

function getAllGroups(data) {
    GROUPS = [];
    if (data == null) {
        db.selectAll(models.groupsDBModel.name, function (data) {
            $(data).each(function (index, value) {
                GROUPS.push(value);
            });
        });
    } else {
        $.each(data, function (index, value) {
            GROUPS.push(value);
        });
    }
}

function sortTask(type, data) {
    data.sort(function (a, b) {
        return sortFunction(a, b);
    });
    return data;
}

function sortFunction(a, b) {
    var aFrame = a.frame;
    var bFrame = b.frame;
    var aIndex = myMap[aFrame];
    var bIndex = myMap[bFrame];
    return (aIndex - bIndex);
}

function contactIdAndPhoneMapping() {
    CONTACT_MAPPING = [];
    if (PEOPLE != null) {
        $(PEOPLE).each(function (index, value) {
            if (value['contact-data'] != null && value['contact-data']['phone-numbers'] != null && value['contact-data']['phone-numbers']['phone-number'] != null) {
                if (value['contact-data']['phone-numbers']['phone-number'].length > 0) {
                    var id = value.id.text;
                    $(value['contact-data']['phone-numbers']['phone-number']).each(function (index2, value2) {
                        CONTACT_MAPPING[value2.number] = id;
                    });
                } else {
                    CONTACT_MAPPING[value['contact-data']['phone-numbers']['phone-number'].number] = value.id.text;
                }
            }
        });
    }
}
