
var VCardParser = function vCardParser(vCard) {

    var splited = [];
    var separator = ";";

    this.parse = function () {
        var result = new Object();
        result.emails = [];
        result.tel = [];
        splited['EMAIL'] = [];
        splited['TEL'] = [];
        splited['URL'] = [];
        if (vCard != null) {
            temp = vCard.split('\n');

            if (temp[0] != null) {
                var t = temp[0].split(separator);
                if (t.length == 1) {
                    separator = ':';
                }
            }

            for (var i = 0, max = temp.length; i < max; i++) {
                var s = temp[i].split(separator);
                if (s[0] != null && s[1] != null) {
                    if (s[0].substring(0, 5) == "EMAIL") {
                        splited["EMAIL"].push({
                            type: s[0],
                            value: s[1]
                        });
                    } else if (s[0].substring(0, 3) == "TEL") {
                        splited["TEL"].push({
                            type: s[0],
                            value: s[1]
                        });
                    } else if (s[0].substring(0, 5) == "TITLE") {
                        splited["TITLE"] = s[1];
                    } else if (s[0].substring(0, 2) == "FN") {
                        splited["FN"] = s[1];
                    } else if (s[0].substring(0, 2) == "NOTE") {
                        splited["NOTE"] = s[1];
                    } else if (s[0].substring(0, 2) == "N;" || s[0].substring(0, 2) == "N:") {
                        splited["N"] = s[1];
                    } else if (s[0].substring(0, 7) == "VERSION") {
                        splited["VERSION"] = s[1];
                    } else if (s[0].substring(0, 3) == "ORG") {
                        splited["ORG"] = s[1];
                    } else if (s[0].substring(0, 3) == "URL") {
                        if (s[0] == "URL") {
                            splited["URL"].push({
                                type: "Work",
                                value: s[1]
                            });
                        } else {
                            splited["URL"].push({
                                type: s[0],
                                value: s[1]
                            });
                        }

                    } else {
                        splited[s[0]] = s[1];
                    }
                }
            }
            console.log(splited);
        }
        result.n = this.getN(splited);
        result.begin = this.getBegin(splited);
        result.version = this.getVersion(splited);
        result.org = this.getOrg(splited);
        result.title = this.getTitle(splited);
        result.fn = this.getFN(splited);
        result.note = this.getNote(splited);
        result.emails = this.getEmail(splited);
        result.tel = this.getTel(splited);
        result.webs = this.getWebAddresses(splited);


        this.getAddress(splited);
        this.getLable(splited);
        return result;
    };

    this.getBegin = function (value) {
        return value['BEGIN'];
    };

    this.getVersion = function (value) {
        if (!isNaN(value['VERSION'])) {
            return value['VERSION'];
        } else {
            return "1.1";
        }
    };

    this.getOrg = function (value) {
        var tempSplit = '';
        if (value['ORG'] != null && $.trim(value['ORG']) != "") {
            tempSplit = value['ORG'].split(';')[0];
        } else {
            var fn = this.getFN(value);
            if (fn == null) {
                var n = value['N'];
                tempSplit = n;
            }
        }
        return tempSplit;
    };

    this.getTitle = function (value) {
        if (value['TITLE'] != null) {
            return value['TITLE'];
        } else {
            return value['ROLE'];
        }
    };

    this.getFN = function (value) {
        return value['FN'];
    };

    this.getN = function (value) {
        var field = ['lastName', 'firstName', 'additionalName', 'title'];
        var temp = value['N'];
        var res = new Object();

        if (temp != null) {
            temp = temp.split(';');
            if (temp.length > 1) {
                for (var i = 0, max = temp.length; i < max; i++) {
                    if (temp[i] != null && temp[i] != "") {
                        res[field[i]] = temp[i];
                    }
                }
            } else {
                var fn = this.getFN(value);
                if (fn != null) {
                    var tempFN = fn.split(' ');
                    res['lastName'] = tempFN[0] != null ? tempFN[0] : "";
                    res['firstName'] = tempFN[1] != null ? tempFN[1] : "";
                }
            }
        }

        return res;
    };

    this.getEmail = function (value) {
        var res = [];

        for (var i = 0, max = value['EMAIL'].length; i < max; i++) {
            var splitTempType = value['EMAIL'][i]['type'].split(';');

            for (var k = 0, l = splitTempType.length; k < l; k++) {
                var type = splitTempType[k].split('=');
                if (type.length > 1) {
                    if (type[0].toUpperCase() == "WORK" || type[1].toUpperCase() == "WORK") {
                        splitTemp = "Work";
                        break;
                    } else if (type[0].toUpperCase() == "HOME" || type[1].toUpperCase() == "HOME") {
                        splitTemp = "Home";
                        break;
                    } else {
                        splitTemp = "Other";
                    }
                } else {
                    if (type[0].toUpperCase() == "WORK") {
                        splitTemp = "Work";
                        break;
                    } else if (type[0].toUpperCase() == "HOME") {
                        splitTemp = "Home";
                        break;
                    } else {
                        splitTemp = "Other";
                    }
                }
            }

            res.push({
                type: splitTemp,
                value: value['EMAIL'][i]['value']
            });
        }
        return res;
    };

    this.getTel = function (value) {
        var res = [];
        var splitTemp = "";

        for (var i = 0, max = value['TEL'].length; i < max; i++) {
            var splitTempType = value['TEL'][i]['type'].split(';');

            for (var k = 0, l = splitTempType.length; k < l; k++) {
                var type = splitTempType[k].split('=');
                if (type.length > 1) {
                    if (type[0].toUpperCase() == "CELL" || type[1].toUpperCase() == "CELL") {
                        splitTemp = "Cell";
                        break;
                    } else {
                        splitTemp = type[1];
                    }
                } else {
                    splitTemp = type[0];
                }
            }

            splitTemp = splitTemp.split(',');

            if (splitTemp.length != null) {
                if (splitTemp[splitTemp.length - 1].toUpperCase() != 'VOICE') {
                    splitTemp = splitTemp[splitTemp.length - 1];
                } else {
                    splitTemp = splitTemp[0];
                }
            }

            splitTemp = splitTemp.toLowerCase();
            splitTemp = splitTemp[0].toUpperCase() + splitTemp.substring(1, splitTemp.length);
            splitTemp = splitTemp.split(',')[0];

            if (splitTemp == "Cell") {
                splitTemp = "Mobile";
            }

            value['TEL'][i]['value'] = this.formatTel(value['TEL'][i]['value']);

            if (this.valitationTel(value['TEL'][i]['value'])) {
                res.push({
                    type: splitTemp,
                    value: value['TEL'][i]['value']
                });
            }
        }

        return res;
    };

    this.getNote = function (value) {
        return value['NOTE'];
    };

    this.getAddress = function (value) {

    };

    this.getLable = function (value) {

    };

    this.formatTel = function (tel) {
        var res = '';
        tel = tel + '';
        for (var i = 0, len = tel.length; i < len; i++) {
            if (!isNaN(tel[i]) || tel[i] == '+') {
                res += tel[i];
            }
        }
        return res;
    };

    this.getWebAddresses = function (value) {
        return value['URL'];
    };

    this.valitationEmail = function (email) {
        var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
    };

    this.valitationTel = function (value) {
        return (value != null && $.trim(value) != "");
    };


};
/*
 var vCard1 = "BEGIN:VCARD\r\nVERSION:3.0\r\nN:Enyedi;Szilárd;;;\r\nFN:Szilárd Enyedi\r\nORG:Technical University of Cluj-Napoca, Automation Department;\r\nTITLE:Associate professor\r\nEMAIL;type=INTERNET;type=WORK;type=pref:Szilard.Enyedi@aut.utcluj.ro\r\nTEL;type=CELL;type=pref:+40 744 433253\r\nTEL;type=WORK:+40 264 401220\r\nADR;type=WORK;type=pref:;;C12, Baritiu 26, 400027 Cluj-Napoca, Romania;;;;\r\nURL;type=pref:http://users.utcluj.ro/~szilard\r\nEND:VCARD\r\n";
 var vCard2 = "BEGIN:VCARD\nVERSION:3.0\nN:Gump;Forrest\nFN:Forrest Gump\nORG:Bubba Gump Shrimp Co.\nTITLE:Shrimp Man\nTEL;TYPE=WORK,VOICE:(111) 555-1212\nTEL;TYPE=HOME,VOICE:(404) 555-1212\nADR;TYPE=WORK:;;100 Waters Edge;Baytown;LA;30314;United States of America\nLABEL;TYPE=WORK:100 Waters Edge\\nBaytown, LA 30314\\nUnited States of America\nADR;TYPE=HOME:;;42 Plantation St.;Baytown;LA;30314;United States of America\nLABEL;TYPE=HOME:42 Plantation St.\\nBaytown, LA 30314\\nUnited States of America\nEMAIL;TYPE=PREF,INTERNET:forrestgump@example.com\nREV:20080424T195243Z\nEND:VCARD";
 var vCard3 = "BEGIN:VCARD\nVERSION:3.0N:Madsen;LeifFN:Leif MadsenORG:LeifMadsen Enterprises, Inc.TITLE:Asterisk Consultant and AuthorTEL;TYPE=WORK,VOICE:+14164790259EMAIL;TYPE=PREF,INTERNET:leif@leifmadsen.comURL:http://www.leifmadsen.comX-SIP:sip:leif@leifmadsen.comREV:20110323T150000ZEND:VCARD";
 var vCard4 = "BEGIN:VCARD\nVERSION:3.0\nN:Gump;Forrest\nFN:Forrest Gump\nORG:Bubba Gump Shrimp Co.\nTITLE:Shrimp Man\nTEL;TYPE=WORK,VOICE:(111) 555-1212\nTEL;TYPE=HOME,VOICE:(404) 555-1212\nADR;TYPE=WORK:;;100 Waters Edge;Baytown;LA;30314;United States of America\nLABEL;TYPE=WORK:100 Waters Edge\\nBaytown, LA 30314\\nUnited States of America\nADR;TYPE=HOME:;;42 Plantation St.;Baytown;LA;30314;United States of America\nLABEL;TYPE=HOME:42 Plantation St.\\nBaytown, LA 30314\\nUnited States of America\nEMAIL;TYPE=PREF,INTERNET:forrestgump@example.com\nREV:20080424T195243Z\nEND:VCARD";
 var vCard5 = "BEGIN:VCARD\nFN:Davide Alberani\nTEL:+39 347 53 09 089\nEMAIL:da@mimante.net\nURL:http://www.mimante.net\nN:Alberani;Davide\nADR:via Caduti di Cefalonia 22/a;40059;Medicina\nROLE:software developer\nVERSION:3.0\nEND:VCARD";
 
 var vCard6 = "BEGIN:VCARD\nVERSION:3.0\nN:Moore;Cindy;;;\nFN:Cindy Moore\nORG:Sweetwater County Library System;\nTITLE:Head of Circulation and Reference\nEMAIL;type=INTERNET;type=WORK:cmoore@sweetwaterlibraries.com\nTEL;type=WORK:307-352-6667 Ext 2220\nTEL;type=WORK,FAX:307-352-6657\nADR;type=WORK:;;400 C Street;Rock Springs;WY;82901;USA\nURL;type=WORK:http\://www.sweetwaterlibraries.com/\nURL;type=HOME:http\://www.sweetwaterlibraries.com/sclsblogs/readeronthesamepage/\nEND:VCARD";
 var vCard7 = "BEGIN:VCARD\nN;CHARSET=utf-8:Vick;Lance;;;\nFN;CHARSET=utf-8:Lance Vick\nORG;CHARSET=utf-8:Tawlk\nTITLE;CHARSET=utf-8:CTO & Lead Engineer\nTEL;WORK:4072837596\nEMAIL;INTERNET;WORK;CHARSET=utf-8:lance@tawlk.com\nADR;WORK;CHARSET=utf-8:;;4545 36th St.;Orlando;FL;32811;United States\nURL;WORK;CHARSET=utf-8:http://tawlk.com\nVERSION:2.1\nEND:VCARD";
 var vCard8 = "BEGIN:VCARD\nN:RKI Analytical Instruments GmbH\nTEL;WORK:+49617169890\nURL:http://GasSensor.de\nEMAIL:rki@rki-analytical.de\nADR:;;Feldbergstr. 57;Oberursel;;D-61440;\nEND:VCARD";
 var vCard9 = "BEGIN:VCARD\nVERSION:3.0\nN:Enyedi;Szilárd;;;\nFN:Szilárd Enyedi\nORG:Technical University of Cluj-Napoca, Automation Department;\nTITLE:Associate professor\nEMAIL;type=INTERNET;type=WORK;type=pref:Szilard.Enyedi@aut.utcluj.ro\nTEL;type=CELL;type=pref:+40 744 433253\nTEL;type=WORK:+40 264 401220\nADR;type=WORK;type=pref:;;C12, Baritiu 26, 400027 Cluj-Napoca, Romania;;;;\nURL;type=pref:http://users.utcluj.ro/~szilard\nEND:VCARD";
 var vCard10= "BEGIN:VCARD\nN:Jan;Vermeulen\nFN:Jan Vermeulen\nORG:MyBroadband\nTITLE:Hacker/Journalist\nURL:http://www.mybroadband.co.za\nEMAIL:jan@mybroadband.co.za\nTEL;WORK;PREF:+27126875159\nEND:VCARD"
 
 var vCard11= "BEGIN:VCARD\nVERSION:\nN:Card;Vee\nFN:Mr Vee Card\nORG:Ezevu.com\nTITLE:vCard Tester\nTEL;WORK;VOICE:1234567890\nTEL;MOBILE;VOICE:012356789\nADR;WORK:;;210 Card Street;Denver;Colorado;80204;USA\nEMAIL;PREF;INTERNET:vCard@sample.com\nURL:http://www.ezevu.com\nREV:20120906T081737Z\nEND:VCARD";
 var vCard12= "BEGIN:VCARD\nN:Wagner;Jason M.\nEMAIL:jwagner01@gmail.com\nTEL:13172702786\nURL:jasonw.net\nNOTE: Computer Repair & Consulting\nEND:VCARD";
 var vCard13= "BEGIN:VCARD\nVERSION:2.1\nN:;\nFN: \nORG:Infrae\nTITLE:\nTEL;WORK;VOICE:+31 10 243 7051\nADR;WORK:;;Hoevestraat 10;Rotterdam;;3033 GC;Netherlands\nEMAIL;PREF;INTERNET:info@infrae.com\nURL:http://infrae.com/\nREV:20080424T195243Z\nEND:VCARD";
 var vCard14= "BEGIN:VCARD\nN:RKI Analytical Instruments GmbH\nTEL;WORK:+49617169890\nURL:http://GasSensor.de\nEMAIL:rki@rki-analytical.de\nADR:;;Feldbergstr. 57;Oberursel;;D-61440;\nEND:VCARD"
 */

