var connection = true;
var localStorageDealId = null;
var isCordovaReady = false;

//functions
$(document).on('ready', function () {
    //cordova deviceready events bind
    if (navigator.userAgent.match(/(iPad|iPhone|Android)/)) {
        document.addEventListener('deviceready', onDeviceReady, false);
    } else {
        main();
    }

    $("[data-role=header]").fixedtoolbar({tapToggle: false});

});

//cordova events functions
function onDeviceReady() {
    isCordovaReady = true;
    $(function () {
        FastClick.attach(document.body);
    });
    initCordova();
}

function onDeviceOnline() {
    var modeStatus = window.localStorage.getItem("offlineOnlineMode");
    if (!modeStatus || modeStatus == "online") {
        connection = true;
        //SyncSipController.syncOfflineData(function() {
        OfflineController.synchronization(function () {
        });
        syncAllConnectionCheck = true;
        hideLoadingIndikator();
        //});

        var sipUsername = window.localStorage.getItem("sipUsername");
        var sipPassword = window.localStorage.getItem("sipPassword");
        var status = window.localStorage.getItem("sip_status");
        if (status == null) {
            status = "on";
        }

        if (sipUsername != null && sipPassword != null && status == "on") {
            console.log('STATUS ON  LOGIN');
            SipSettingsFunctions.sipLogin(sipUsername, sipPassword, function (data) {
                console.log('SIP LOGIN');
                if (data != null) {
                    SyncController.syncSipAccount(function () {
                        statusSipGlobal();
                    });
                } else {
                    SettingsFunctions.sipLogin(sipUsername, sipPassword, function (data) {
                        console.log('SIP LOGIN');
                    });
                }
            });
        } else {
            console.log('STATUS OFF  LOGIN');
            SyncController.syncSipAccount(function () {
                statusSipGlobal();
            });
        }
    }
}

function onDeviceOffline() {
    connection = false;
    statusSipGlobal();
    window.plugins.SipPlugin.closeConnection(function () {
    });
}

function onMenuButton() {
    if (!$.mobile.activePage.is("#login")) {
        gotoPage({url: "settings", param: null}, {url: "dashboard", param: null});
    }
}

function onBackButton() {
    // leave chat room
    if ($.mobile.activePage.is("#view-note")) {
        var noteId = ViewNoteFunctions.getCurrentId();
        ChatAPI.leaveRoom(noteId, function (err) {
            console.log("leaveRoom error:" + JSON.stringify(err));
        });
    }

    if ($.mobile.activePage.is("#dashboard") || $.mobile.activePage.is("#contacts") ||
            $.mobile.activePage.is("#tasks") || $.mobile.activePage.is("#deals") ||
            $.mobile.activePage.is("#login") || $.mobile.activePage.is("#myGroup") ||
            $.mobile.activePage.is("#case")) {
        closeAplication();
    } else {
        if (overrideBackButton != null) {
            overrideBackButton();
        } else {
            goBack();
        }
    }
}

//set application in initial state
function initCordova() {
    //cordova events
    document.addEventListener('online', onDeviceOnline, false);
    document.addEventListener('offline', onDeviceOffline, false);
    document.addEventListener('menubutton', onMenuButton, false);
    document.addEventListener('backbutton', onBackButton, false);
    connection = isConnected();
    if (window.localStorage.getItem("offlineOnlineMode") == 'offline') {
      connection = false;
    }
    setImagePath();
    registerPushNotification();
    main();
    if (window.cordova && window.cordova.plugins.Keyboard) {
        window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        cordova.plugins.Keyboard.disableScroll(true);
    }
}

function isConnected() {
    var networkState = navigator.connection.type;
    if (networkState != Connection.NONE && networkState != Connection.UNKNOWN) {
        return true;
    } else {
        return false;
    }
}

function main() {
    console.log("main");
    localStorage.setItem('debug', 'socket.io-client:socket');

    // init localization
    var language = window.localStorage.getItem("userLanguage");
    var language = language || "en";
    i18n.init({
        lng: language,
        resGetPath: rootPath + "/i18n/__lng__.json"
    }, function (t) {
        $(document).on('pageshow', function () {
            $("body").i18n();
            if (!navigator.userAgent.match(/(iPad|iPhone)/)) {
                $('input, textarea').not('#edit-profil input, textarea').on('click', function () {
                    $(this).closest('.overthrow').animate({scrollTop: $(this).closest('.overthrow').scrollTop() + $(this).offset().top - 60});
                });
            }
        });
    });

    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
        window.alert = function (msg) {
            var iframe = document.createElement("IFRAME");
            iframe.setAttribute("src", 'data:text/plain,');
            document.documentElement.appendChild(iframe);
            window.frames[0].window.alert(msg);
            iframe.parentNode.removeChild(iframe);
        };


//		$(document).on('focus','input, select, textarea',function() {
//			if(device.platform === 'iOS' && parseInt(device.version) >= 7){
//				if($(this).attr('readonly') === undefined){
//					$('#footer').hide()
//				}
//			}
//		});
//		$(document).on('blur','input, select, textarea',function(){
//			if(device.platform === 'iOS' && parseInt(device.version) >= 7){
//				if($(this).attr('readonly') === undefined){
//					$('#footer').show();
//				}
//			}
//		});
    }

    if (connection) {
        if (checkUserLogin() == true) {
            userDomain = localStorage.getItem("userDomain");
            userAuth = localStorage.getItem("userToken");
            userAdmin = localStorage.getItem("userAdmin") == "true" ? true : false;

            // console.log(userDomain + ":" + localStorage.getItem("userToken") + ":" + localStorage.getItem("deviceId"));
            ClientAPI.setTokenDeviceAuth(userDomain, localStorage.getItem("userToken"), localStorage.getItem("deviceId"));

            OfflineController.synchronization(function () {
            });
            // user synchronization
            UserController.synchronization(function () {
                getAllUsers(null, function () {
                    //main database synchronization
                    SyncController.sync(function () {
                    });

                    var navigationId = window.localStorage.getItem("notificationRouteObjectId");
                    var navigationType = window.localStorage.getItem("notificationRouteObjectType");
                    // if application is started on notification click
                    if (navigationId && navigationType) {
                        window.localStorage.removeItem("notificationRouteObjectId");
                        window.localStorage.removeItem("notificationRouteObjectType");
                        navigateAfterNotification(navigationId, navigationType);
                    } else {
                        gotoPage({url: 'dashboard', param: null});
                    }
                });
            });

//            SyncSipController.syncAll();
//            if (isPhoneGap()) {
//                setSip();
//            }

        } else {
            gotoPage({url: 'login', param: null});
        }
    } else {
        if (checkUserLogin() == true) {
            gotoPage({url: 'dashboard', param: null});

            userDomain = localStorage.getItem("userDomain");
            userAuth = localStorage.getItem("userToken");
            userAdmin = localStorage.getItem("userAdmin") == "true" ? true : false;
            console.log(userDomain + ":" + localStorage.getItem("userToken") + ":" + localStorage.getItem("deviceId"));
            ClientAPI.setTokenDeviceAuth(userDomain, localStorage.getItem("userToken"), localStorage.getItem("deviceId"));
            getAllUsers();
            getAllTasksCategory();
            getAllDealsCategory();
            getAllPeople();
            getAllCompany();
        } else {
            alert("No Internet Connection!");
            gotoPage({url: 'login', param: null});
        }
    }
    UtilController.checkAppVersion();
}

function registerPushNotification() {
    if (device.platform == 'android' || device.platform == 'Android') {
        window.plugins.pushNotification.register(function (result) {
            console.log('SUCCESS REGISTER PUSH NOTIFICATION');
        }, function (error) {
            console.log("FAILED REGISTER PUSH NOTIFICATION: " + JSON.stringify(error));
        }, {
            "senderID": "800649877568", // prod
          //  "senderID" : "60265488678", // dev
            "ecb": "onNotificationGCM"
        });
    } else {
        window.plugins.pushNotification.register(function (result) {
            console.log('SUCCESS REGISTER PUSH NOTIFICATION');
            var tokenInfo = {
                token: result,
                tokenType: 'apn'
            };
            console.log(tokenInfo);
            ClientAPI.registerNotificationToken(tokenInfo, function (e, d) {
                console.log('registerNotificationToken Done!');
                console.log(e || d);
            });
        }, function (error) {
            console.log("FAILED REGISTER PUSH NOTIFICATION: " + JSON.stringify(error));
        }, {
            "badge": "true",
            "sound": "true",
            "alert": "true",
            "ecb": "onNotificationAPN"
        });

    }
}

function navigateAfterNotification(urlId, urlType) {
    pageObject = {};
    switch (urlType) {
        case "Project":
            gotoPage({url: 'viewCase', param: {caseId: urlId}}, {url: "dashboard", param: null});
            break;
        case "Deal":
            gotoPage({url: 'viewDeal', param: {id: urlId}}, {url: "dashboard", param: null});
            break;
        case "Task":
            gotoPage({url: 'viewTask', param: {id: urlId}}, {url: "dashboard", param: null});
            break;
        case "Company":
        case "Person":
            gotoPage({url: 'viewContact', param: {contactId: urlId, contactType: urlType}}, {url: "dashboard", param: null});
            break;
        case "Note":
            gotoPage({url: 'viewNote', param: {noteId: urlId}}, {url: "dashboard", param: null});
    }
}

function onNotificationGCM(e) {
    console.log('onNotificationGCM: ' + JSON.stringify(e));
    // dobavljanje additional notifikacije info
    if (e.payload && e.event != "message") {
        window.localStorage.setItem("notificationRouteObjectId", e.payload.objectId);
        window.localStorage.setItem("notificationRouteObjectType", e.payload.objectType);
    }

    switch (e.event) {
        case 'registered':
            if (e.regid.length > 0) {
                var tokenInfo = {
                    token: e.regid,
                    tokenType: 'gcm'
                };
                console.log(tokenInfo);
                ClientAPI.registerNotificationToken(tokenInfo, function (e, d) {
                    console.log('registerNotificationToken Done!');
//                    console.log(e || d);
                    if (!e) {
                        if (d) {
                            console.log("== Notification token data ==");
                            console.log(JSON.stringify(d));
                        }
                    }

                });
            }
            break;
        case 'message':
            console.log("Notification Message Event");
          //  NotificationService.appendNotification(e, function (exists, count) {
          //      if (!exists) {
          //          var notificationObject = {id: e.payload.objectId, type: e.payload.objectType, message: e.payload.message, title: e.payload.title};
          //          var html = DashboardFunctions.drawNotification(notificationObject);
          //          if (html != "") {
          //              if (count == "0") {
          //                  ("#dashboard .badge").remove();
          //              } else {
          //                  $("#dashboard .badge-container").html("<span class='badge'></span>");
          //                  $("#dashboard .badge").text(count);
          //                  $("#dashboard .notification-list").append(html);
          //              }
          //          }
          //      }
          //  });
            break;
        case 'error':
            console.log('GCM error = ' + e.msg);
            break;
        default:
            console.log('An unknown GCM event has occurred');
            break;
    }
}

function onNotificationAPN(e) {
    console.log('onNotificationAPN: ' + JSON.stringify(e));
    if (e.payload) {
        window.localStorage.setItem("notificationRouteObjectId", e.payload.objectId);
        window.localStorage.setItem("notificationRouteObjectType", e.payload.objectType);
    }
}

function setSip() {
    console.log('SET_SIP');
    var userDataName = window.localStorage.getItem("userDataName");
    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
    } else {
        var username = window.localStorage.getItem('sipUsername');
        if (username != window.localStorage.getItem('sipUsername')) {
            window.localStorage.setItem('sipUsername', username);
        }
        var password = window.localStorage.getItem("sipPassword");

        if (username != null && password != null && window.localStorage.getItem("sip_status") == "on") {
            username = username;
            password = password;
            sipDomain = window.localStorage.getItem('sipDomain');

            var userDataName = window.localStorage.getItem("userDataName");
            var authUsername = window.localStorage.getItem("authUsername");
            var proxy = window.localStorage.getItem("proxy");
            var port = window.localStorage.getItem("port");
            var arg = [username, sipDomain, password, userDataName, authUsername, proxy, port];
            if (sipDomain != null && sipDomain != "") {
                window.plugins.SipPlugin.initialize(arg, function (msg) {
                    var objectSip = {
                        user: username,
                        pass: password,
                        domain: window.localStorage.getItem('sipDomain'),
                        expires: SIP_EXPIRE_TIME
                    };
                    SipSettingsFunctions.sipRegistration(objectSip, function () {
                    });
                }, function (msg) {
                    alert('SIP REGISTRATION: ' + msg.sip);
                });
            }
        }
    }
}

function setImagePath() {
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function onFileSystemSuccess(fileSystem) {
        fileSystem.root.getFile("dummy.html", {create: true, exclusive: false}, function gotFileEntry(fileEntry) {
            var sPath = null;
            if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                sPath = fileEntry.toNativeURL().replace("dummy.html", "");
            } else {
                sPath = fileEntry.fullPath.replace("dummy.html", "");
            }
            ;
            fileEntry.remove();
            window.localStorage.setItem('folderPath', sPath + "ConneCT/");
        }, function (error) {
            console.log("fileSystem.root.getFile error " + error);
        });
    }, function (error) {
        console.log("requestFileSystem error " + error);
    });
}

function checkUserLogin() {
    var domain = localStorage.getItem("userDomain");
    var auth = localStorage.getItem("userToken");
    if (domain == null || auth == null) {
        return false;
    }

    return true;
}

function hideFooter() {
    if (device.platform === 'iOS' && parseInt(device.version) >= 7) {
        if ($(this).attr('readonly') === undefined) {
            $('#footer').hide();
        }
    }
}

String.prototype.replaceAll = function(search, replacement) {
    var target = this;
    return target.replace(new RegExp(search, 'g'), replacement);
};
