function Model() {

    this.companiesDBModel = {
        "name": "company",
        "data": {
            "id": "TEXT",
            "name": "TEXT",
            "avatar-url": "TEXT",
            "background": "TEXT",
            "created-at": "TEXT",
            "updated-at": "TEXT",
            "visible-to": "TEXT",
            "owner-id": "TEXT",
            "group-id": "TEXT",
            "group": "TEXT",
            "author-id": "TEXT",
            "contact-data": "TEXT",
            "subject_datas": "TEXT",
//				"childObjectCount": "TEXT",
            "objectType": "TEXT",
            "searchKeywords": "TEXT",
            "tags": "TEXT"
        },
        "xmlName": ["companies"]
    };

    this.peopleDBModel = {
        "name": "people",
        "data": {
            "id": "TEXT",
            "first-name": "TEXT",
            "last-name": "TEXT",
            "title": "TEXT",
            "background": "TEXT",
            "linkedin-url": "TEXT",
            "avatar-url": "TEXT",
            "company-id": "TEXT",
            "company-name": "TEXT",
            "created-at": "TEXT",
            "updated-at": "TEXT",
            "visible-to": "TEXT",
            "owner-id": "TEXT",
            "group-id": "TEXT",
            "group": "TEXT",
            "author-id": "TEXT",
            "contact-data": "TEXT",
            "tags": "TEXT",
//				"childObjectCount" : "TEXT",
            "objectType": "TEXT",
            "searchKeywords": "TEXT",
            "referenceId": "TEXT",
            "identity_id": "TEXT",
            "subject_datas": "TEXT"
        },
        "xmlName": ["people"]
    };

    this.phoneContactDBModel = {
        "name": "phoneContact",
        "data": {
            "id": "TEXT",
            "organization": "TEXT",
            "companyName": "TEXT",
            "title": "TEXT",
            "givenName": "TEXT",
            "familyName": "TEXT",
            "phones": "TEXT",
            "emails": "TEXT",
            "info": "TEXT",
            "visible": "TEXT",
            "avatar": "TEXT"
        },
        "xmlName": ["phoneContact"]
    };

    this.dealDBModel = {
        "name": "deal",
        "data": {
            "id": "TEXT",
            "account-id": "TEXT",
            "author-id": "TEXT",
            "background": "TEXT",
            "category-id": "TEXT",
            "created-at": "TEXT",
            "currency": "TEXT",
            "duration": "TEXT",
            "group-id": "TEXT",
            "group": "TEXT",
            "name": "TEXT",
            "owner-id": "TEXT",
            "party-id": "TEXT",
            "price": "TEXT",
            "price-type": "TEXT",
            "responsible-party-id": "TEXT",
            "status": "TEXT",
            "status-changed-on": "TEXT",
            "updated-at": "TEXT",
            "visible-to": "TEXT",
            "parties": "TEXT",
            "category": "TEXT",
            "subjectDes": "TEXT",
            "searchKeywords": "TEXT",
//				"childObjectCount": "TEXT",
            "probability": "TEXT",
            "closeDate": "TEXT",
            "referenceId": "TEXT",
            "party": "TEXT",
            "link": "TEXT",
            "statusHistory": "TEXT"
        },
        "xmlName": ["deals"]
    };

    this.dealCategoriesDBModel = {
        "name": "dealCategory",
        "data": {
            "account-id": "TEXT",
            "color": "TEXT",
            "created-at": "TEXT",
            "elements-count": "TEXT",
            "id": "TEXT",
            "name": "TEXT",
            "updated-at": "TEXT"
        },
        "xmlName": "/deal_categories"
    };

    this.noteDBModel = {
        "name": "note",
        "data": {
            "id": "TEXT UNIQUE",
            "body": "TEXT",
            "author-id": "TEXT",
            "subject-id": "TEXT",
            "subject-type": "TEXT",
            "subject-name": "TEXT",
            "collection-id": "TEXT",
            "collection-type": "TEXT",
            "visible-to": "TEXT",
            "owner-id": "TEXT",
            "group-id": "TEXT",
            "updated-at": "TEXT",
            "created-at": "TEXT",
            "attachments": "TEXT",
            "group": "TEXT",
//				"childObjectCount": "TEXT",
            "type-id": "TEXT"
        },
        "xmlName": []
    };

    this.favoriteDBModel = {
        "name" : "favorite",
        "data" : {
            "id"    : "TEXT",
            "refObjectType" : "TEXT",
            "refObject"  : "TEXT",
            "refObjectId" : "TEXT"
        },
        "xmlName": []
    };

//	this.emailDBModel = {
//			"name" : "email",
//			"data" : {
//				"id" : "TEXT",
//				"title" : "TEXT",
//				"body" : "TEXT",
//				"author-id" : "TEXT",
//				"subject-id" : "TEXT",
//				"subject-type" : "TEXT",
//				"subject-name" : "TEXT",
//				"collection-id" : "TEXT",
//				"collection-type" : "TEXT",
//				"visible-to" : "TEXT",
//				"owner-id" : "TEXT",
//				"group-id" : "TEXT",
//				"group" : "TEXT",
//				"updated-at" : "TEXT",
//				"created-at" : "TEXT",
//				"attachments" : "TEXT"
//			},
//			"xmlName" : "emails"
//	};

    this.commentDBModel = {
        "name": "comment",
        "data": {
            "author-id": "TEXT",
            "body": "TEXT",
            "collection-id": "TEXT",
            "collection-type": "TEXT",
            "created-at": "TEXT",
            "group-id": "TEXT",
            "group": "TEXT",
            "id": "TEXT UNIQUE",
            "owner-id": "TEXT",
            "parent-id": "TEXT",
            "subject-id": "TEXT",
            "subject-name": "TEXT",
            "subject-type": "TEXT",
            "updated-at": "TEXT",
            "visible-to": "TEXT",
            "attachments": "TEXT"
        },
        "xmlName": "comments"
    };

    this.taskDBModel = {
        "name": "task",
        "data": {
            "id": "TEXT UNIQUE",
            "recording-id": "TEXT",
            "recording-type": "TEXT",
            "subject-id": "TEXT",
            "subject-type": "TEXT",
            "subject-name": "TEXT",
            "category-id": "TEXT",
            "body": "TEXT",
            "name": "TEXT",
            "percent-completed": "TEXT",
            "frame": "TEXT",
            "due-at": "TEXT",
            "alert-at": "TEXT",
            "created-at": "TEXT",
            "done-at": "TEXT",
            "author-id": "TEXT",
            "owner-id": "TEXT",
            "responsible-id": "TEXT",
            "updated-at": "TEXT",
            "public": "TEXT",
            "status": "TEXT",
            "visible-to": "TEXT",
            "priority": "TEXT",
            "owner": "TEXT",
            "subjectDes": "TEXT",
//				"childObjectCount": "TEXT",
            "searchKeywords": "TEXT",
            "statusHistory": "TEXT",
            "efforts": "TEXT"
        },
        "xmlName": ["tasks/completed", "tasks/upcoming", "tasks/assigned"]
    };

    this.userDBModel = {
        "name": "user",
        "data": {
            "admin": "TEXT",
            "created-at": "TEXT",
            "email-address": "TEXT",
            "id": "TEXT UNIQUE",
            "name": "TEXT",
            "updated-at": "TEXT"
        },
        "xmlName": "users"
    };

    this.accountDBModel = {
        "name": "account",
        "data": {
            "bytes": "TEXT",
            "color_theme": "TEXT",
            "created-at": "TEXT",
            "id": "TEXT",
            "name": "TEXT",
            "people-count": "TEXT",
            "plan": "TEXT",
            "ssl_enabled": "TEXT",
            "storage": "TEXT",
            "subdomain": "TEXT",
            "updated-at": "TEXT"
        },
        "xmlName": "account"
    };

    this.recordingDBModel = {
        "name": "recording",
        "data": {
            "id": "TEXT",
            "group-id": "TEXT",
            "group": "TEXT",
            "user-id": "TEXT",
            "created-at": "TEXT",
            "updated-at": "TEXT"
        },
        "xmlName": ""
    };

    this.kaseDBModel = {
        "name": "kase",
        "data": {
            "id": "TEXT",
            "author-id": "TEXT",
            "closed-at": "TEXT",
            "created-at": "TEXT",
            "updated-at": "TEXT",
            "due-at": "TEXT",
            "name": "TEXT",
            "background": "TEXT",
            "visible-to": "TEXT",
            "group-id": "TEXT",
            "group": "TEXT",
            "owner-id": "TEXT",
            "party-id": "TEXT",
            "party": "TEXT",
            "subjectDes": "TEXT",
            'searchKeywords': "",
//				"childObjectCount": "TEXT",
            "status": "TEXT",
            "parties": "TEXT",
            "statusHistory": "TEXT",
            "link": "TEXT"
        },
        "xmlName": ["kases"]
    };

    this.taskCategoriesDBModel = {
        "name": "taskCategory",
        "data": {
            "account-id": "TEXT",
            "color": "TEXT",
            "created-at": "TEXT",
            "elements-count": "TEXT",
            "id": "TEXT",
            "name": "TEXT",
            "updated-at": "TEXT"
        },
        "xmlName": "/task_categories"
    };

    this.groupsDBModel = {
        "name": "groups",
        "data": {
            "id": "TEXT",
            "name": "TEXT",
            "description": "TEXT"
        },
        "xmlName": "/groups"
    };

    this.membershipDBModel = {
        "name": "membership",
        "data": {
            "id": "TEXT",
            "group-id": "TEXT",
            "group": "TEXT",
            "user-id": "TEXT",
            "created-at": "TEXT",
            "updated-at": "TEXT"
        },
        "xmlName": "/memberships"
    };

    this.recentDBModel = {
        "name": "recent",
        "data": {
            "id": "TEXT NOT NULL UNIQUE",
            "type": "TEXT NOT NULL",
            "object": "TEXT"
        }
    };

    this.domainDBModel = {
        "name": "domain",
        "data": {
            "id": "TEXT NOT NULL UNIQUE",
            "domain": "TEXT NOT NULL UNIQUE",
            "username": "TEXT NOT NULL",
            "password": "TEXT NOT NULL",
            "server": "TEXT NOT NULL"
        }
    };

    this.offlineInsertDBModel = {
        "name": "offlineInsert",
        "data": {
            "id": "TEXT NOT NULL UNIQUE",
            "objectType": "TEXT",
            "object": "TEXT NOT NULL",
            "parent-id": "TEXT"
        }
    };

    this.offlineMessageStatusDBModel = {
        "name": "offlineMessageStatus",
        "data": {
            "id": "TEXT UNIQUE",
            "status": "TEXT"
        }
    };

    this.sipDBModel = {
        "name": "sip",
        "data": {
            "id": "TEXT UNIQUE",
            "name": "TEXT",
            "phone": "TEXT",
            "date": "TEXT",
            "time": "TEXT",
            "last": "TEXT",
            "status": "TEXT",
            "expires": "TEXT",
            "lastSeen": "TEXT"
        }
    };

    this.infoMessageDBModel = {
        "name": "infoMessage",
        "data": {
            "_id": "TEXT UNIQUE",
            "body": "TEXT",
            "created": "TEXT",
            "updated": "TEXT",
            "fromDomain": "TEXT",
            "fromUser": "TEXT",
            "status": "TEXT",
            "toDomain": "TEXT",
            "toUser": "TEXT"
        }
    };

    this.notificationDBModel = {
        "name": "notification",
        "data": {
            "id": "TEXT NOT NULL",
            "parentId": "TEXT",
            "status": "TEXT",
            "object": "TEXT"
        }
    };

    this.draftDBModel = {
        "name": "draft",
        "data": {
            "id": "TEXT UNIQUE",
            "objectId": "TEXT UNIQUE",
            "type": "TEXT",
            "updated-at": "TEXT",
            "object": "TEXT"
        }
    };
};
