var NotificationService = (function (NotificationService) {

    var self = NotificationService;

    self.notificationCount = function (callback) {
        db.selectByQuery("SELECT count(*) FROM notification WHERE status = ?", ["unseen"], "notification", function (data) {
            if (data && callback && typeof callback == "function") {
                callback(data[0]["count(*)"]);
            }
        });
    };

    self.loadNotifications = function (items, offset, callback) {
        db.selectByQuery("SELECT * FROM notification LIMIT ?,?", [items, offset], "notification", function (data) {
            if (data && callback && typeof callback == "function") {
                callback(data);
            }
        });
    };

  //  self.appendNotification = function (notificationObject, callback) {
  //      var notification = {};
  //      notification.id = notificationObject.payload.objectId;
  //      notification.type = notificationObject.payload.objectType;
  //      notification.object = notificationObject.payload;
  //      notification.status = "Unread";
  //      self.loadNotifications(function (data) {
  //          console.log("appendNotification load: ");
  //          console.log(JSON.stringify(data));
  //          var exists = false;
  //          for (var i = 0; i < data.length; i++) {
  //              if (notificationObject.payload.objectId == data[i].id && notificationObject.payload.message == data[i].object.message) {
  //                  exists = true;
  //                  break;
  //              }
  //          }
  //          if (!exists) {
  //              db.insert("notification", [notification], function () {
  //                  if (callback && typeof callback == "function") {
  //                      self.notificationCount(function (count) {
  //                          console.log("Notification counter --append");
  //                          console.log(count);
  //                          callback(exists, count);
  //                      });
  //                  }
  //              });
  //          } else {
  //              callback(exists);
  //          }
  //      });
  //  };

//    self.deleteNotification = function (notificationId, callback) {
//        if (notificationId) {
//            db.deleteObject("notification", "id", notificationId, function () {
//                if (callback && typeof callback == "function") {
//                    callback();
//                }
//            });
//        }
//    };

    self.readAllNotifications = function (callback) {
        if (connection) {
            ClientAPI.updateNotifications(null, function (err, data) {
                if (!err) {
                    callback(data);
                } else {
                    if (callback && typeof callback == "function") {
                        console.log("updateNotifications error: " + JSON.stringify(err));
                        callback();
                    }
                }
            });
        } else {
            if(callback && typeof callback == "function"){
                callback({readAllOffline: true});
            }
        }
    };

    self.markAsRead = function (id, callback) {
        db.updateObject("notification", "id", id, {status: "seen"}, false, function () {
            callback();
        });
    };

    self.readNotification = function (refId, refType, notifId, callback) {
        ClientAPI.updateNotifications({refId: refId, notificationType: refType}, function (err, data) {
            if (!err) {
                self.markAsRead(notifId, callback);
            } else {
                if (callback && typeof callback == "function") {
                    callback([]);
                }
            }
        });
    };

//    self.readAll = function (callback) {
//        db.updateObject("notification", null, null, {status: "Read"}, true, function () {
//            if (callback && typeof callback == "function") {
//                callback();
//            }
//        });
//    };

    self.synchronization = function (data, callback) {
        if (data && data.length > 0) {
            var table = "notification";
            var results = [];
            for (var i = 0; i < data.length; i++) {
                var notificationObj = {};
                notificationObj.id = data[i].notification['_id'];
                if(data[i]['_id']){
                    notificationObj.parentId = data[i]['_id'];
                 } else {
                     notificationObj.parentId = data[i].notification.objectId;
                 }
                if (data[i].notification.seen) {
                    notificationObj.status = "seen";
                } else {
                    notificationObj.status = "unseen";
                }
                notificationObj.object = data[i].notification;
                results.push(notificationObj);
            }
            db.deleteAllFromTable(table, function () {
                db.insertMultiple(table, [results], function () {
                    if (callback && typeof callback == "function") {
                        return callback();
                    }
                });
            });
        } else {
            if(callback && typeof callback == "function"){
                callback();
            }
        }
    };

    return self;
}(NotificationService || {}));
