
function printRequestError(jqXHR, status, position) {
    var output = '';

    if (jqXHR.status === 0) {
        output = 'No connection. Verify Network.';
    } else if (jqXHR.status == 401) {
        output = 'Unauthorized. Access denied.';
    } else if (jqXHR.status == 404) {
        output = 'The record could not be found.';
    } else if (jqXHR.status == 422) {
        output = 'Email address is not well-formed.';
    } else if (jqXHR.status == 500) {
        output = 'Internal Server Error.';
    } else if (jqXHR.status == 507) {
        output = 'Not enough storage space.';
    } else if (status === 'parsererror') {
        output = 'Requested XML parse failed.';
    } else if (status === 'timeout') {
        output = 'Time out error.';
    } else if (status === 'abort') {
        output = 'Ajax request aborted.';
    } else {
        console.log('Uncaught Error.\n' + jqXHR.responseText);
        return;
        //output = 'Uncaught Error.\n' + jqXHR.responseText;
    }

    if (environmentMode == ENVIRONMENT_MODE.DEVELOPMENT) {
        output += '\nat ' + position;
    }

    if (connected || jqXHR.status != 0 && output != '') {
        alert(output);
    }
}

function printRequestError2(err) {
    var output = '';

    output += err.name + ': ' + err.code;
    output += '\n' + err.message;

    if (environmentMode == ENVIRONMENT_MODE.DEVELOPMENT) {
        for (var i = 0, len = err.stack.length; i < len; i++) {
            output += '\nat ' + err.stack[i];
        }
    }
    if (connected) {
        alert(output);
    }
}

//TODO: nema potrebe jer je izvodljivo sa new Date(stringDate);
function parseISO8601(stringDate) {

    var date = new Date();
    var fullYear = parseInt(stringDate.substring(0, 4), 10);
    var month = parseInt(stringDate.substring(5, 7), 10) - 1;
    var day = parseInt(stringDate.substring(8, 10), 10);
    var hours = parseInt(stringDate.substring(11, 13), 10);
    var minutes = parseInt(stringDate.substring(14, 16), 10);
    var seconds = parseInt(stringDate.substring(17, 19), 10);

    date.setFullYear(fullYear);
    date.setMonth(month);
    date.setDate(day);
    date.setHours(hours);
    date.setMinutes(minutes);
    date.setSeconds(seconds);

    return date;
}

function toShortString(iso8601StringDate) {
    // YYYY-MM-DDTHH:mm:ssZ > YYYYMMDDHHmmss
    var shortDate =
            iso8601StringDate.substring(0, 4)
            + ''
            + iso8601StringDate.substring(5, 7)
            + ''
            + iso8601StringDate.substring(8, 10)
            + ''
            + iso8601StringDate.substring(11, 13)
            + ''
            + iso8601StringDate.substring(14, 16)
            + ''
            + iso8601StringDate.substring(17, 19);

    return shortDate;
}

function dateFormat(date) {
    return date.getDate() + '.' + (date.getMonth() + 1) + '.' + date.getFullYear();
}

function timeFormat(date) {
    var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    var min = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    return hours + ':' + min;
}
function dateTimeFormatWithAt(date, temp) {
    if (temp) {
        return dateFormat(date);
    } else {
        return dateFormat(date) + ' at ' + timeFormat(date);
    }
}


function xmlDateToFormattedDate(xmlDate) {

    var year = xmlDate.substring(0, 4);
    var month = xmlDate.substring(5, 7);
    var day = xmlDate.substring(8, 10);

    return day + '.' + month + '.' + year + '.';
}

function getScriptFileName() {
    // Since scripts are executed sequentially, the currently executed script tag 
    // is always the last script tag on the page until then.
    var scripts = document.getElementsByTagName('script');
    var scriptSrc = scripts[scripts.length - 1].src;

    return scriptSrc.substring(scriptSrc.lastIndexOf('/') + 1);
}

function async(fn) {
    setTimeout(fn, 0);
}

function removeFromArray(arr) {
    var what, a = arguments, L = a.length, ax;
    while (L > 1 && arr.length) {
        what = a[--L];
        while ((ax = arr.indexOf(what)) != -1) {
            arr.splice(ax, 1);
        }
    }
    return arr;
}

function convertDateTimeForXml() {
    var date = new Date();
    var result = '';
    result = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate();
    result += 'T' + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
    return result;
}

function convertDateTimeForHighriseSince(date) {
    var result = '';
    var month = (date.getMonth() + 1) < 10 ? '0' + (date.getMonth() + 1) : (date.getMonth() + 1);
    result = date.getFullYear() + "" + month + "" + date.getDate();
    result += date.getHours() + "" + date.getMinutes() + "" + date.getSeconds();
    return result;
}

function str2slug(str) {
    var rep = '-';
    str = str.toLowerCase().replace(/\s+/g, rep) // replace whitespace

    // remove accents, swap ñ for n, etc
    var from = "àáäâèéëêìíïîòóöôùúüûñçćčšž";
    var to = "aaaaeeeeiiiioooouuuuncccsz";
    for (var i = 0, l = from.length; i < l; i++) {
        str = str.replace(
                new RegExp(from.charAt(i), 'g'),
                to.charAt(i)
                );
    }
    // remove invalid chars
    str = str.replace(new RegExp('[^a-z0-9' + rep + ']', "g"), '').replace(/-+/g, rep); // collapse dashes;
    if (str.slice(-1) == "-") {
        return str = str.substring(0, str.length - 1);
    } else {
        return str;
    }
}

function generateRandomNumbersRange(pCount, pMin, pMax) {
    min = pMin < pMax ? pMin : pMax;
    max = pMax > pMin ? pMax : pMin;
    var resultArr = [], randNumber;
    while (pCount > 0) {
        randNumber = Math.round(min + Math.random() * (max - min));
        if (resultArr.indexOf(randNumber) == -1) {
            resultArr.push(randNumber);
            pCount--;
        }
    }
    return resultArr.join("");
}