function WebClient() {

    var timeout = 10000;

    this.getFunction = function (query, onSuccess, onError) {
        $.ajax({
            type: 'GET',
//			timeout: timeout,
            url: 'https://' + userDomain + '.highrisehq.com' + query,
            dataType: 'xml',
            cache: false,
            async: true,
            headers: {
                'Authorization': 'Basic ' + userAuth,
            },
            success: function (data, textStatus, jqXHR) {
                var json = new JKL.ParseXML().parseElement((data));
                if (onSuccess != null) {
                    onSuccess(json);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status != 200) {
                    setErrorFunction(jqXHR, onWebError);
                } else {
                    if (onSuccess != null) {
                        onSuccess();
                    }
                }
            }
        });
    };

    this.postFunction = function (xml, query, onSuccess, onError, async) {
        $.ajax({
            type: 'POST',
//			timeout: timeout, 
            url: 'https://' + userDomain + '.highrisehq.com' + query,
            data: xml,
            contentType: 'application/xml',
            dataType: 'xml',
            cache: false,
            async: async ? false : true,
            headers: {
                'Authorization': 'Basic ' + userAuth,
            },
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 507) {
                    if (onError != null) {
                        onError(jqXHR);
                    }
                } else {
                    if (onError != null) {
                        setErrorFunction(jqXHR, onError);
                    }
                    if (jqXHR.status != 200) {
                        setErrorFunction(jqXHR, onWebError);
                    } else {
                        if (onSuccess != null) {
                            onSuccess();
                        }
                    }
                }
            }
        });
    };

    this.postFunctionDeleteFiles = function (xml, query, onSuccess, onError, async) {
        $.ajax({
            type: 'POST',
//			timeout: timeout, 
            url: 'https://' + userDomain + '.highrisehq.com' + query,
            data: xml,
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            processData: false,
            cache: false,
            headers: {
                'Authorization': 'Basic ' + userAuth
            },
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 507) {
                    if (onError != null) {
                        onError(jqXHR);
                    }
                } else {
                    if (onError != null) {
                        setErrorFunction(jqXHR, onError);
                    }
                    if (jqXHR.status != 200) {
                        setErrorFunction(jqXHR, onWebError);
                    } else {
                        if (onSuccess != null) {
                            onSuccess();
                        }
                    }
                }
            }
        });
    };

    this.postFunctionFiles = function (xml, query, onSuccess, onError, async) {
        $.ajax({
            type: 'POST',
//			timeout: timeout, 
            url: 'https://' + userDomain + '.highrisehq.com' + query,
            data: xml,
            contentType: false,
            processData: false,
            cache: false,
            async: true,
            headers: {
                'Authorization': 'Basic ' + userAuth,
            },
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 507) {
                    if (onError != null) {
                        onError(jqXHR);
                    }
                } else {
                    if (onError != null) {
                        setErrorFunction(jqXHR, onError);
                    }
                    if (jqXHR.status != 200) {
                        setErrorFunction(jqXHR, onWebError);
                    } else {
                        if (onSuccess != null) {
                            onSuccess();
                        }
                    }
                }
            }
        });
    };

    this.putFunctionFiles = function (xml, query, onSuccess, onError, async) {
        $.ajax({
            type: 'PUT',
//			timeout: timeout, 
            url: 'https://' + userDomain + '.highrisehq.com' + query,
            data: xml,
            contentType: false,
            processData: false,
            cache: false,
            async: true,
            headers: {
                'Authorization': 'Basic ' + userAuth,
            },
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 507) {
                    if (onError != null) {
                        onError(jqXHR);
                    }
                } else {
                    if (onError != null) {
                        setErrorFunction(jqXHR, onError);
                    }
                    if (jqXHR.status != 200) {
                        setErrorFunction(jqXHR, onWebError);
                    } else {
                        if (onSuccess != null) {
                            onSuccess();
                        }
                    }
                }
            }
        });
    };

    this.putFunction = function (xml, query, onSuccess, onError) {
        $.ajax({
            type: 'PUT',
//			timeout: timeout, 
            url: 'https://' + userDomain + '.highrisehq.com' + query,
            data: xml,
            contentType: 'application/xml',
            dataType: 'xml',
            cache: false,
            async: false,
            headers: {
                'Authorization': 'Basic ' + userAuth,
            },
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (onError != null) {
                    setErrorFunction(jqXHR, onError);
                }
                if (jqXHR.status != 200) {
                    if (jqXHR.status == 403) {
                        alert(jqXHR.responseText);
                        hideLoadingIndikator();
                    } else {
                        setErrorFunction(jqXHR, onWebError);
                    }
                } else {
                    if (onSuccess != null) {
                        onSuccess();
                    }
                }
            }
        });
    };

    this.deleteFunction = function (query, onSuccess) {
        $.ajax({
            type: 'DELETE',
//			timeout: timeout, 
            url: 'https://' + userDomain + '.highrisehq.com' + query,
            dataType: 'xml',
            cache: false,
            async: true,
            headers: {
                'Authorization': 'Basic ' + userAuth,
            },
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 404) {
                    alert("Please sync application with Highrise!");
                    hideLoadingIndikator();
                    goBack();
                } else if (jqXHR.status == 422) {
                    alert("There was a problem with Highrise, this action is not allowed!");
                    hideLoadingIndikator();
                    goBack();
                } else if (jqXHR.status == 403) {
                    alert("You do not have permission to delete this!");
                    hideLoadingIndikator();
                } else if (jqXHR.status == 200) {
                    if (onSuccess != null) {
                        onSuccess();
                    }
                } else {
                    this.setErrorFunction(jqXHR, onWebError);
                }
            }
        });
    };

    this.postSipFunction = function (data, query, onSuccess, onError) {
        $.ajax({
            type: 'POST',
            url: sipUrl + query,
            data: data,
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            dataType: 'json',
            cache: false,
            async: false,
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (onError != null) {
                    setErrorFunction(jqXHR, onError);
                }
                if (jqXHR.status != 200) {
                    setErrorFunction(jqXHR, onWebError);
                } else {
                    if (onSuccess != null) {
                        onSuccess();
                    }
                    onError();
                }
            }
        });
    };

    this.getSipFunction = function (data, query, onSuccess, onError) {
        $.ajax({
            type: 'GET',
            url: sipUrl + query,
            dataType: 'json',
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            data: data,
            cache: false,
            async: true,
            timeout: 1000,
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status != 200) {
                    setErrorFunction(jqXHR, onWebError);
                    setErrorFunction(jqXHR, onError);
                } else {
                    if (onSuccess != null) {
                        onSuccess();
                    }
                }
            }
        });
    };

    this.getAdsFunction = function (data, query, onSuccess, onError) {
        $.ajax({
            type: 'GET',
            url: adsUrl + query,
            dataType: 'json',
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            data: data,
            cache: false,
            async: true,
            timeout: 1000,
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status != 200) {
                    setErrorFunction(jqXHR, onWebError);
                    setErrorFunction(jqXHR, onError);
                } else {
                    if (onSuccess != null) {
                        onSuccess();
                    }
                }
            }
        });
    };

    this.postInfoMessageFunction = function (data, query, onSuccess, onError) {
        $.ajax({
            type: 'POST',
            url: sipUrl + query,
            data: data,
            contentType: 'application/json',
            dataType: 'json',
            cache: false,
            async: false,
            success: function (data, textStatus, jqXHR) {
                if (onSuccess != null) {
                    onSuccess(data);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (onError != null) {
                    setErrorFunction(jqXHR, onError);
                }
                if (jqXHR.status != 200) {
                    setErrorFunction(jqXHR, onWebError);
                } else {
                    if (onSuccess != null) {
                        onSuccess();
                    }
                    onError();
                }
            }
        })
    }
}


function setErrorFunction(jqXHR, onError) {
    if (onError) {
        if (typeof jqXHR == "function") {
            onError(jqXHR);
        } else {
            try {
                console.log(JSON.stringify(jqXHR));
            } catch (e) {
                // TODO: handle exception
                console.log(e);
            }

        }
    }
}