$(document).on('pageshow', '#call-log', function () {
    CallLogFunctions.bindElementControls();
});

$(document).on('pageinit', '#call-log', function () {
    CallLogFunctions.init();
});

$(document).on('pagehide', '#call-log', function () {
    CallLogFunctions.unbindElementControls();
});

var CallLogFunctions = (function (CallLogFunctions)
{
    var self = CallLogFunctions;
    var start = 0;
    var end = null;
    var offset = 20;
    var callLogObject = null;
    var $callLogsList;
    var calllogs;
    var $calllogPopup;
    var $calllogPopupList;

    self.init = function () {
        showLoadingIndikator();
        $callLogsList = $("#all-logs");
        $calllogPopup = $("#calllog-popup");
        $calllogPopupList = $("#calllog-popup-list");
        self.getAllPhoneNumber(function (phones) {
            window.plugins.callLog.all(function (data) {
                self.drawCallLogs(data, phones);
            }, function (err) {
                hideLoadingIndikator();
            });
        });
    };

    self.bindElementControls = function () {
        $(document).on('click', '#all-logs .calllog-item', self.callLogItemEvent);
        $(document).on('click', '#call-log .popup-link', self.popupLinkEvent);
        $(document).on('click', '#back-link', goBack);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#all-logs .calllog-item');
        $(document).off('click', '#back-link');
        $(document).off('click', '#call-log .popup-link');
    };

    self.drawCallLogs = function (data, phones) {
        db.selectByQuery("SELECT * FROM phoneContact", [], models.phoneContactDBModel.name, function (phoneContacts) {
            calllogs = [];
            if (data.Rows != null) {
                calllogs = data.Rows;
            }
            var html = "";
            if (calllogs.length != 0) {
                var datetime;
                var name;
                var user;
                var contact;
                var phoneNumber;
                var type;
                var id;

                for (var i = 0; i < calllogs.length; i++) {
                    datetime = calllogs[i][0].split(':');
                    user = null;
                    contact = null;
                    type = null;
                    phoneNumber = calllogs[i][1];
                    calllogs[i].phoneNumber = phoneNumber;

                    if (MyGroupFunctions.findUserByPhone(phoneNumber) != null) {
                        user = MyGroupFunctions.findUserByPhone(phoneNumber);
                        calllogs[i].id = user.id;
                        calllogs[i].type = "user";
                        calllogs[i].name = user.name;
                        calllogs[i].push(user);
                    } else if (self.findPhoneContact(phones, phoneNumber) != null) {
                        contact = self.findPhoneContact(phones, phoneNumber);
                        calllogs[i].id = contact.id;
                        calllogs[i].type = contact.type;
                        calllogs[i].name = contact.name;
                        calllogs[i].push(contact);
                    } else {
                        if (phoneContacts.length > 0) {
                            for (var k = 0; k < phoneContacts.length; k++) {
                                if (phoneContacts[k].phones.length) {
                                    for (var j = 0; j < phoneContacts[k].phones.length; j++) {
                                        if (phoneContacts[k].phones[j].phoneNumber == phoneNumber) {
                                            calllogs[i].id = phoneContacts[k].id;
                                            calllogs[i].type = "phonecontact";
                                            if (phoneContacts[k].givenName != null && phoneContacts[k].givenName != "") {
                                                calllogs[i].name = phoneContacts[k].givenName;
                                                if (phoneContacts[k].lastName != null && phoneContacts[k].lastName != "") {
                                                    calllogs[i].name = calllogs[i].name + " " + phoneContacts[k].lastName;
                                                }
                                            }
                                            calllogs[i].push(phoneContacts[k]);
                                            console.log(JSON.stringify(phoneContacts[k]));
                                        }
                                    }
                                } else {
                                    calllogs[i].id = "";
                                    calllogs[i].type = "";
                                    calllogs[i].name = phoneNumber;
                                }
                            }
                        } else {
                            calllogs[i].id = "";
                            calllogs[i].type = "";
                            calllogs[i].name = phoneNumber;
                        }
                    }

                    if (calllogs[i].name == null) {
                        calllogs[i].name = phoneNumber;
                        calllogs[i].phoneNumber = "";
                    }

                    html += '<li><a href="#" id="' + calllogs[i].id + '" index="' + i + '" class="calllog-item list-elem ' + calllogs[i].type + '" name="' + calllogs[i].name + '" number="' + calllogs[i][1] + '" duration="' + calllogs[i][3] + '" date="' + calllogs[i][0] + '" type="' + calllogs[i][2] + '">';

                    switch (calllogs[i][2]) {
                        case "incoming":
                            html += '<div class="content-left"><i class="md-call-received md-2x" style="color: blue;"></i></div>';
                            break;
                        case "outgoing":
                            html += '<div class="content-left"><i class="md-call-made md-2x" style="color: green;"></i></div>';
                            break;
                        case "missed":
                            html += '<div class="content-left"><i class="md-call-missed md-2x" style="color: red;"></i></div>';
                            break;
                    }

                    html += '<div class="content-center" style="padding-left: 60px;">'
                            + '<div class="subject">' + calllogs[i].name + '</div>'
                            + '<div class="title">' + calllogs[i].phoneNumber + '</div>'
                            + '<div>Duration: ' + calllogs[i][3] + '</div>'
                            + '<div>Date: ' + datetime[0] + '</div>'
                            + '<div>Duration: ' + datetime[1] + ':' + datetime[2] + '</div>'
                            + '</div>'
                            + '</a></li>';
                }
            } else {
                html = emptyListHtml;
            }
            $callLogsList.empty().append(html);
            setTimeout(function(){
                hideLoadingIndikator();
            }, 200);
        });
    };

    self.callLogItemEvent = function () {
        var index = $(this).attr("index");
        var item = calllogs[index];
        if (item[item.length - 1] != null) {
            callLogObject = item[item.length - 1];
        }
        var html = '<li><a href="#" phonenumber="' + item[1] + '" class="popup-link" id="call-person"><i class="md-phone md-2x"></i><span class="advanced-menu-text"> Call contact</span></a></li>'
                + '<li><a href="#" phonenumber="' + item[1] + '" class="popup-link" id="send-sms"><i class="md-sms md-2x"></i><span class="advanced-menu-text"> Send SMS</span></a></li>';

        if ($(this).hasClass("user")) {
            html += '<li><a href="#" objectid="' + callLogObject.id + '" type="user" class="popup-link" id="open-user"><i class="md-person md-2x"></i><span class="advanced-menu-text"> Open user</span></a></li>';
        } else if ($(this).hasClass("people")) {
            html += '<li><a href="#" objectid="' + callLogObject.id + '" type="person" class="popup-link" id="open-contact"><i class="md-person md-2x"></i><span class="advanced-menu-text"> Open person</span></a></li>';
        } else if ($(this).hasClass("company")) {
            html += '<li><a href="#" objectid="' + callLogObject.id + '" type="company" class="popup-link" id="open-contact"><i class="md-business md-2x"></i><span class="advanced-menu-text"> Open company</span></a></li>';
        } else if ($(this).hasClass("phonecontact")) {
            html += '<li><a href="#" objectid="' + callLogObject.id + '" type="phonecontact" class="popup-link" id="open-phone-contact"><span class="advanced-menu-text"> Open phone contact</span></a></li>';
        } else {
            html += '<li><a href="#" phonenumber="' + item[1] + '" class="popup-link" id="add-person"><i class="md-person md-2x"></i><span class="advanced-menu-text"> Add Person</span></a></li>';
            html += '<li><a href="#" phonenumber="' + item[1] + '" class="popup-link" id="add-company"><i class="md-business md-2x"></i><span class="advanced-menu-text"> Add Company</span></a></li>';
        }

        $calllogPopupList.empty().append(html);
        $calllogPopup.popup("open");
        $calllogPopup.popup("reposition", {y: 200});
    };

    self.popupLinkEvent = function () {
        switch ($(this).attr("id")) {
            case "call-person":
                MyGroupFunctions.call($(this).attr("phonenumber"), callLogObject.id, callLogObject.type, callLogObject.name);
                break;
            case "send-sms":
                window.location = 'sms:' + $(this).attr('phonenumber');
                break;
            case "open-user":
                if ($(this).attr("objectid") != null && $(this).attr("objectid") != "") {
                    MyGroupFunctions.openUser($(this).attr("objectid"));
                }
                break;
            case "open-contact":
                gotoPage({url: "viewContact", param: {contactId: $(this).attr("objectid"), contactType: $(this).attr("type")}}, {url: "callLog", param: null});
                break;
            case "open-phone-contact":
                gotoPage({url: "viewPhoneContact", param: {phoneContactId: $(this).attr("objectid"), contactType: "Person"}}, {url: "callLog", param: null});
                break;
            case "add-person":
                var name = new ContactName();
                name.givenName = "New";
                name.familyName = "Contact";
                var phoneNumbers = [];
                phoneNumbers[0] = new ContactField('work', $(this).attr('phonenumber'), false);
                gotoPage({url: "editContact", param: {contactType: "Person", phoneNumbers: phoneNumbers}}, {url: "callLog", param: null});
                break;
            case "add-company":
                var phoneNumbers = [];
                phoneNumbers[0] = new ContactField('work', $(this).attr('phonenumber'), false);
                gotoPage({url: "editContact", param: {contactType: "Company", phoneNumbers: phoneNumbers}}, {url: "callLog", param: null});
                break;
            default:
                break;
        }
        $calllogPopup.popup("open");
    };

    self.getAllPhoneNumber = function (callback) {
      if (connection) {
        var searchTypes = ["Person", "Company"];
        ClientAPI.find({objectType: {$in: searchTypes}}, null, function (err, data) {
            if (data && data.length > 0) {
                var phones = [];
                for(var i=0; i<data.length; i++){
                    if(data[i].phoneNumbers && data[i].phoneNumbers.length > 0){
                        var tempObj = {};
                        tempObj.id = data[i]["_id"];
                        tempObj.type = data[i].objectType.toLowerCase();
                        tempObj.phones = [];
                       for(var j=0; j<data[i].phoneNumbers.length; j++){
                           tempObj.phones.push(data[i].phoneNumbers[j].phoneNumber);
                       }
                       if(data[i].objectType == "Company"){
                           tempObj.name = data[i].companyName;
                       } else {
                           tempObj.name = data[i].firstName + " " + data[i].lastName;
                       }
                       phones.push(tempObj);
                    }
                }
                if(callback && typeof callback == "function"){
                    callback(phones);
                }
            }
        });
      } else {
        if(callback && typeof callback == "function"){
            callback([]);
        }
      }
    };

    self.findPhoneContact = function(phones, number){
        var contact = null;
        var exists = false;
        for(var i=0; i<phones.length; i++){
            for(var j=0; j<phones[i].phones.length; j++){
                if(number == phones[i].phones[j]){
                    exists = true;
                    break;
                }
            }
            if(exists){
                contact = phones[i];
                break;
            }
        }
        return contact;
    };

    return self;
}(CallLogFunctions || {}));
