$(document).on('pageinit', '#case', function () {
    CaseFunctions.init();
});

$(document).on('pageshow', '#case', function () {
    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
        $("#call-list-link").remove();
    }

    CaseFunctions.bindElementControls();
    CaseFunctions.filterCases();
    sharedCaseId = null;
    sharedCaseForOpen = null;
});

$(document).on('pagehide', '#case', function () {
    CaseFunctions.unbindElementControls();
});

var CaseFunctions = (function (CaseFunctions) {
    var self = CaseFunctions;
    self.drawListParams = [];
    self.findTime = null;

    var Navigation = {
        'MY_OPEN_CASES': 'my-open-cases',
        'ALL_OPEN_CASES': 'all-open-cases',
        'ALL_CLOSED_CASES': 'all-closed-cases',
        'MY_CLOSED_CASES': 'my-closed-cases',
        'MY_FAVORITE_CESES': 'my-favorite-cases',
        'MY_CUSTOM_FILTER':'filter-custom'
    };

    var listViewId = 'case-list';
    var $openCase = null;
    var $closedCase = null;
    var $caseList = null;
    var $caseEmptyList = null;
    var $refreshLink = null;
    var $filterCaseType = null;
    var $case = null;
    var favoriteMapData = {};

    self.init = function () {

        //hide call list option for iOS devices
        removeCallListForIOS("main-nav-list", "case", "call-list-link");

        $openCase = $('#open-case');
        $closedCase = $('#closed-case');
        $caseList = $('#case-list');
        $caseEmptyList = $('#case-empty-list-message');
        $refreshLink = $('#case-refresh-link');
        $filterCaseType = $("#filter-case-type");
        $case = $("#case");
        self.drawListParams[listViewId] = {
            'start': 0,
            'type': "Created",
            'searchValue': "",
            'offset': offset
        };
        NavigationController.loadUserInfo('case');
        self.addMoreFilter('filter-case-type');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#dashboard-link', self.dashboardLinkEvent);
        $(document).on('click', '#contacts-link', self.contactsLinkEvent);
        $(document).on('click', '#tasks-link', self.tasksLinkEvent);
        $(document).on('click', '#deals-link', self.dealsLinkEvent);
        $(document).on('click', '#settings-link', self.settingsLinkEvent);
        $(document).on('click', '#drafts-link', self.draftLinkEvent);
        $(document).on('click', '#mygroup-link', self.myGroupLinkEvent);
        $(document).on('click', '#menu-link', self.menuLinkEvent);
        $(document).on('click', '#case-link', self.menuLinkEvent);
        $(document).on('click', '#case-list .case-item', self.caseItemEvent);
        $('#filter-case-type').on('change', self.filterCases);
        $(document).on('click', '#case-refresh-link', self.refreshLinkEvent);
        $(document).on('click', '#case .ui-input-clear', self.caseInputDeleteAllEvent);
        $(document).on('input', '#case #case-content input', self.searchInputEvent);
        $(document).on('click', '#case .float-add-action', self.addLinkEvent);
        $(document).on('click', '#about-link', self.gotoAbout);
        $("#case .app-user").on('click', self.gotoProfilPage);
        $("#case .domain-link-info").on('click', self.gotoDomainPage);
        $("#case").on('click', '.favorite-event', self.eventFavorite);

        $(document).on('click', '#case #call-list-link', function () {
            gotoPage({url: "callLog", param: null}, {url: "case", param: null});
        });

        $case.on("swipeup", "#case-list", self.onPullUp);
        $case.on("swipedown", "#case-list", self.onPullDown);

        $case.on("scrollstart", "#case-list", function () {
            console.log("scrollstart");
            $case.off("swipeup", "#case-list");
            $case.off("swipedown", "#case-list");
        });

        $case.on("scrollend", "#case-list", function () {
            console.log("scrollend");
            $case.on("swipeup", "#case-list", self.onPullUp);
            $case.on("swipedown", "#case-list", self.onPullDown);
        });

        $('body').on('submit', function (event) {
            event.preventDefault(); // cancel default form submit
            event.stopPropagation();
            return false;
        });

        $('.backdrop').on('click', function () {
            $('html').removeClass('sidebar-left-in');
        });

        $case.on('swipeleft', '.sidebar', function () {
            if ($("html").hasClass("sidebar-left-in")) {
                $("html").removeClass("sidebar-left-in");
            }
        });

        $(document).on("click", "#case #app-calendar", function(){
            gotoPage({url: "calendar", param: null}, {url: "case", param: null});
        });
          $(document).on('click', '#overview-link', self.overviewLinkEvent);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#dashboard-link');
        $(document).off('click', '#contacts-link');
        $(document).off('click', '#tasks-link');
        $(document).off('click', '#deals-link');
        $(document).off('click', '#mygroup-link');
        $(document).off('click', '#settings-link');
        $(document).off('click', '#drafts-link');
        $(document).off('click', '#menu-link');
        $(document).off('click', '#case-link');
        $(document).off('click', '#case-list .case-item');
        $('#filter-case-type').off('change');
        $(document).off('click', '#case-refresh-link');
        $(document).off('input', '#case #case-content input');
        $(document).off('click', '#case .ui-input-clear');
        $(document).off('click', '#case .float-add-action');
        $(document).off('click', '#case #call-list-link');
        $(document).off('click', '#about-link');
        $(document).off('click', '#overview-link');
        $case.off("swipeup", "#case-list");
        $case.off("swipedown", "#case-list");
        $case.off("scrollstart", "#case-list");
        $case.off("scrollend", "#case-list");
        $('.backdrop').off('click');
        $('html').removeClass('sidebar-left-in');
        $case.off('swipeleft', '.sidebar');
        $(document).off("click", "#case #app-calendar");
        $("#case .app-user").off('click');
        $("#case .domain-link-info").off('click');
        $("#case").off('click', '.favorite-event');
    };

    self.overviewLinkEvent = function () {
        gotoPage({url: "overview", param: null});
    };

    self.gotoDomainPage = function () {
        gotoPage({url: "domain", param: null}, {url: "case", param: null});
    };

    self.gotoProfilPage = function(){
      gotoPage({url: "editProfil", param: null}, {url: "case", param: null});
    };

    self.gotoProfilPage = function(){
      gotoPage({url: "editProfil", param: null}, {url: "case", param: null});
    };

    self.gotoAbout = function () {
        gotoPage({url: "about", param: null}, {url: "case", param: null});
    };

    self.settingsLinkEvent = function () {
        gotoPage({url: "settings", param: null}, {url: "case", param: null});
    };

    self.onPullUp = function () {
        console.log("swipeup");
        var count = $("#case-list li", '#' + $.mobile.activePage.attr('id')).length;
        var bool = $($("#case-list li", '#' + $.mobile.activePage.attr('id'))[count - 2]).visible();
        if (bool && !$("html").hasClass("sidebar-left-in")) {
            console.log("swipeup-1");
            self.listScrollLoadEvent();
        }
    };

    self.onPullDown = function () {
        console.log("swipedown");
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            console.log("swipedown-1");
            self.refreshLinkEvent();
            $("input:jqmData(type='search')", '#case').val("");
        }
    };

    self.addLinkEvent = function () {
        gotoPage({url: "editCase", param: null}, {url: "case", param: null});
    };

    self.dashboardLinkEvent = function () {
        gotoPage({url: "dashboard", param: null});
    };

    self.contactsLinkEvent = function () {
        gotoPage({url: "contacts", param: null});
    };

    self.tasksLinkEvent = function () {
        gotoPage({url: "tasks", param: null});
    };

    self.dealsLinkEvent = function () {
        gotoPage({url: "deals", param: null});
    };

    self.myGroupLinkEvent = function () {
        gotoPage({url: "myGroup", param: null});
    };

    self.menuLinkEvent = function () {
        $('html').toggleClass('sidebar-left-in');
    };

    self.caseItemEvent = function () {
        var caseId = $(this).attr('caseId');
        var caseIds = [];
        $("#case-list").find(".case-item").each(function () {
            caseIds.push($(this).attr("caseId"));
        });
        gotoPage({url: "viewCase", param: {caseId: caseId, caseIds: caseIds, listParams: self.drawListParams[listViewId]}}, {url: "case", param: null});
    };

    self.addMoreFilter = function(id){
      var $filterElement = $("#" + id);
      if ($filterElement) {
        CaseController.findAllFilters(function(items){
          items.forEach(function(element, index){
            $filterElement.append('<option value="filter-custom-' + index + '" filter=\''+ element.settingData.filterQuery +'\'>' + element.settingData.filterName + '</option>');
          });
        });
      }
    };

    self.filterCases = function () {
        var request = null;

        showLoadingIndikator();
        $caseList.empty();
        var filteredCase = $filterCaseType.find('option:selected').val();

        if (filteredCase && filteredCase.startsWith('filter-custom')) {
           filteredCase = "filter-custom";
        }

        if (filteredCase == Navigation['ALL_OPEN_CASES']) {
            request = {$or: [{status: "Created"}, {status: "InProgress"}]};
            self.drawListParams[listViewId] = {
                'start': 0,
                'type': "ALL_OPEN_CASES",
                'searchValue': "",
                'request': request,
                'offset': offset
            };

            CaseController.getCases(request, 0, offset, function (data) {
                $refreshLink.show();
                self.drawCaseListView('case-list', data, false);
            });

        } else if (filteredCase == Navigation['MY_OPEN_CASES']) {
            request = {
                $and: [
                    {$or: [{status: "Created"}, {status: "InProgress"}]},
                    {$or: [
                            {owner: window.localStorage.getItem('userId')},
                            {creator: window.localStorage.getItem('userId')}
                        ]}
                ]
            };

            self.drawListParams[listViewId] = {
                'start': 0,
                'type': "MY_OPEN_CASES",
                'searchValue': "",
                'request': request,
                'offset': offset
            };

            CaseController.getCases(request, 0, offset, function (data) {
                $refreshLink.show();
                self.drawCaseListView('case-list', data, false);
            });

        } else if (filteredCase == Navigation['ALL_CLOSED_CASES']) {

            request = {status: "Closed"};
            self.drawListParams[listViewId] = {
                'start': 0,
                'type': "ALL_CLOSED_CASES",
                'searchValue': "",
                'request': request,
                'offset': offset
            };

            CaseController.getCases(request, 0, offset, function (data) {
                $refreshLink.show();
                self.drawCaseListView('case-list', data, false);
            });

        } else if (filteredCase == Navigation['MY_CLOSED_CASES']) {
            request = {
                status: "Closed",
                $or: [
                    {owner: window.localStorage.getItem('userId')},
                    {creator: window.localStorage.getItem('userId')}
                ]
            };

            self.drawListParams[listViewId] = {
                'start': 0,
                'type': "MY_CLOSED_CASES",
                'searchValue': "",
                'request': request,
                'offset': offset
            };

            CaseController.getCases(request, 0, offset, function (data) {
                $refreshLink.show();
                self.drawCaseListView('case-list', data, false);
            });
        } else if (filteredCase == Navigation['MY_FAVORITE_CESES']) {
            self.drawListParams[listViewId]["favorite"] = true;
            CaseController.findAllFavoriteProject(function(data){
                $refreshLink.show();
                self.drawCaseListView('case-list', data || [], false);
            });
        } else if (filteredCase == Navigation['MY_CUSTOM_FILTER']) {
              request = JSON.parse($filterCaseType.find(":selected").attr('filter'));
              self.drawListParams[listViewId] = {
                  'start': 0,
                  'type': "MY_CUSTOM_FILTER",
                  'searchValue': "",
                  'request': request,
                  'offset': offset
              };
              CaseController.findCustomCase(request, function(data) {
                $refreshLink.show();
                self.drawCaseListView('case-list', data || [], false);
              });
        }
        $filterCaseType.i18n();
        $filterCaseType.selectmenu('refresh', true);
    };

    self.getCasesTaskCount = function (cases) {
        if (cases) {
            for (var i = 0; i < cases.length; i++) {
                (function (num) {
                    if (connection) {
                        // count of overdue tasks
                        ClientAPI.findCount({
                            objectType: "Task",
                            status: {$ne: "Completed"},
                            dueDate: {$lt: new Date()},
                            immediateParent: new ObjectId(cases[num].id.text)
                        },
                        function (err, data) {
                            $(".overdue-tasks[caseId='" + cases[num].id.text + "']").empty().append(data);
                        });
                        //count of opened tasks
                        ClientAPI.findCount({
                            objectType: "Task",
                            status: {$ne: "Completed"},
                            immediateParent: new ObjectId(cases[num].id.text)
                        },
                        function (err, data) {
                            $(".opened-tasks[caseId='" + cases[num].id.text + "']").empty().append('/' + data);
                        });
                    } else {
                        db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE [recording-id] =? AND frame =? AND status != ?',
                                [getTextTypeObject(cases[num].id.text, 'integer'), "Overdue", "Completed"], models.taskDBModel.name, function (data) {
                            $(".overdue-tasks[caseId='" + cases[num].id.text + "']").empty().append(data[0]['count(*)']);
                        });

                        db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE [recording-id] =? AND status != ?',
                                [getTextTypeObject(cases[num].id.text, 'integer'), "Completed"], models.taskDBModel.name, function (data) {
                            $(".opened-tasks[caseId='" + cases[num].id.text + "']").empty().append('/' + data[0]['count(*)']);
                        });

                    }
                })(i);
            }
        }
    };

    self.eventFavorite = function(e){
        var isFavorite = $(this).hasClass("contact-favorite-star");
        var caseId  = $(this).parent().attr('caseid');
        var element  = $(this);
        CaseController.findByObjectId(caseId, function(item){
            if (isFavorite) {
                 FavoriteController.findByObjectIdDB(caseId , function(data){
                    if (data[0]) {
                        FavoriteController.removeFavorite(data[0].id, function(){
                            element.toggleClass("contact-favorite-star");
                        });
                    }
                 });
            } else {
                FavoriteController.save("Case", item, function(){
                  element.toggleClass("contact-favorite-star");
                });
            }
        });
        e.stopPropagation();
    }

    self.drawCaseListView = function (listViewId, data, append) {
      FavoriteController.findAllMapByTypes(["Case"], function(favoriteMap){
          favoriteMapData = favoriteMap;
          var html = "";
          var $listViewId = $('#' + listViewId);
          if (!append) {
              $listViewId.empty();
              self.drawListParams[listViewId]['start'] = offset;
              self.drawListParams[listViewId]['offset'] = offset;
          } else {
              self.drawListParams[listViewId]['start'] += self.drawListParams[listViewId]['offset'];
          }

          if (data.length >= 1) {
              for (var i = 0; i < data.length; i++) {
                  html += self.drawCaseItem(data[i]);
              }
          }
          if (html != "" || append) {
              $listViewId.show().append(html);
          }
          if ($('li', $listViewId).length == 0){
              var empty = $(emptyListHtml).css("min-height", "inherit");
              $listViewId.append(empty);
          }
          $("#case").i18n();
          $('#view-contact-cases-content').i18n();
          hideLoadingIndikator();
          self.getCasesTaskCount(data);
      });
    };

    self.drawCaseItemParentInfo = function(itemData) {
      var parentInfo = "";
      if (itemData.party) {
          switch (itemData.party.type.toLowerCase()) {
              case "company":
                  parentInfo = '<span data-i18n="case.company"></span><span>:<b> ' + itemData.party.name +'</b><span data-i18n="case.on" class="case-space"></span></span>';
                  break;
              case "person":
                  var names = itemData.party.name.split(" ");
                  var fullName = "";
                  if (names[1]) {
                      fullName = names[1] + " ";
                  }
                  if (names[0]) {
                      fullName += names[0];
                  }
                  parentInfo = '<span data-i18n="case.person"></span><span>:<b> ' + itemData.party.name +'</b><span data-i18n="case.on" class="case-space"></span></span>';
          }
      }
      return parentInfo;
    };

    self.drawCaseItemParentCloseDate = function(itemData){
      var closeDate = "";
      if (itemData.closeDate) {
          var dateTimeObject = new Date(itemData.closeDate);
          closeDate = '<span>Close date: <b>' +
              dateFormat(dateTimeObject) + " " + timeFormat(dateTimeObject)
          + ' | </b></span>';
      }
      return closeDate;
    };

    self.drawCaseItemDueDate = function(itemData){
      var closeDate = "";
      try {
        if (itemData['due-at'] && itemData['due-at']['text']) {
            var dueCaseDate = itemData['due-at'].text.split('T')[0];
            var dueDate = new Date(dueCaseDate);
            var now = new Date();
            var dateColor = "fg-green";
            var days = Math.floor(Math.abs(dueDate-now)/(24*60*60*1000))
            if (dueDate < now) {
                dateColor = "fg-red";
            } else if (days < 5) {
                dateColor = "orange";
            }
            dueCaseDate = dateTimeFormatWithAt(dueDate, true);
            closeDate = '<div class="case-item-status-padding '
            + dateColor  + '"><span>Due date: <b>'
            + dueCaseDate + '</b></span></div>';
        }
      } catch (e) {

      }
      return closeDate;
    };

    self.drawCaseItemStatus = function(itemData){
      var status = "";
      if (itemData.status != null && itemData.status != "") {
          var statusKey;
          if (itemData.status.toLocaleLowerCase() == "created") {
              statusKey = "case.created";
          } else if (itemData.status.toLocaleLowerCase() == "inprogress") {
              statusKey = "case.inprogress";
          } else if (itemData.status.toLocaleLowerCase() == "closed") {
              statusKey = "case.closed";
          }
          status = '<span data-i18n="' + statusKey + '"></span>';
      }
      return status;
    };

    self.drawCaseItemAvatar = function(itemData) {
      var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(ALL_USERS[itemData['owner-id'].text].person) + '&fieldName=' + encodeURIComponent('picture');
      var imageData = '<i class="avatar md-person  md-3x"></i>';
      if (connection && ALL_USERS[itemData['owner-id'].text]['avatar-url'] != null) {
          imageData = '<div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ');width:40px;"></div>';
      }
      return imageData;
    }


    self.drawCaseItem = function(itemData) {
        var starColor = favoriteMapData[itemData.id.text] ? "contact-favorite-star" : "";
        var imageData = self.drawCaseItemAvatar(itemData);
        var parentInfo = self.drawCaseItemParentInfo(itemData);
        var closeDate = self.drawCaseItemParentCloseDate(itemData);
        var dueDate = self.drawCaseItemDueDate(itemData);
        var status = self.drawCaseItemStatus(itemData);

        var html = "<li><a caseId='" + itemData.id.text + "' class='case-item list-item-el'>";
            html += '<div class="favorite-event ' + starColor + '" style="float:left;">'
                    + '<span class="is-contact-image" style="padding: 5px 0px 10px 10px;">'
                    +  imageData
                    + '</span>'
                    + '<span style="padding-left:20px">'
                        + '<i class="md-grade md-lg"></i>'
                    + '</span>'
                + '</div>';

        html += '<div class="content-center" style="padding-left:60px;">'
                    + '<div class="title bold">'
                        + '<span> ('+ itemData.entityId + ') </span>'
                        + '<span>' + itemData.name + '</span>'
                    + '</div>'
                    + '<div>'
                        + '<span class="case-item-status-padding"><b>'+ ALL_USERS[itemData['owner-id'].text].name + '</b></span>'
                        + '<span class="case-item-status-padding" data-i18n="case.createdProjectOn"></span>'
                        + parentInfo
                        + '<span class="deal-item-padding">'
                            + dateFormat(new Date(itemData['created-at'].text)) + " " + timeFormat(new Date(itemData['created-at'].text))
                        + '</span>'
                    + '</div>'
                    + '<div class="deal-item-status-padding">'
                        + closeDate
                        + '<span>Status: <b>' + status + '</b></span>'
                    + '</div>'
                    + dueDate
                    + '<div class="deal-item-status-padding">'
                    + '<span data-i18n="case.tasks"></span>:'
                    + '<span class="overdue-tasks" caseId="' + itemData.id.text + '"></span>'
                    + '<span class="opened-tasks" caseId="' + itemData.id.text + '"></span>'
                    + '</div>'
                + '</div>'
        html += "</a></li>"
        return html;
    };

    self.refreshLinkEvent = function () {
        if (connection) {
            ClientAPI.find({objectType: "Project"}, null, function (err, data) {
                if (data != null) {
                    CaseController.synchronization(data, function () {
                        self.filterCases();
                    });
                }
            });
        }
    };

    self.caseInputDeleteAllEvent = function () {
        self.filterCases();
    };

    self.searchInputEvent = function (event) {
        if (self.findTime) {
            clearTimeout(self.findTime);
        }
        self.findTime = setTimeout(function () {
            if (event.currentTarget.value.length > 0) {
                if (connection) {
                    var query = {
                        objectType: "Project",
                        searchKeywords: new RegExp(event.currentTarget.value.trim().toLowerCase().replace(' ', '|'), "i")
                    };
                    ClientAPI.findPaged(query, [["modificationDate", -1]], 1, offset, function (err, data) {
                        var items = [];
                        for (var i = 0, max = data.length; i < max; i++) {
                            items.push(CaseController.encodeItem(data[i]));
                        }
                        self.drawListParams[listViewId] = {
                            'start': offset,
                            'type': "search",
                            'searchValue': event.currentTarget.value,
                            'offset': offset
                        };
                        self.drawCaseListView(listViewId, items, false);
                    });
                } else {
                    self.drawListParams[listViewId] = {
                        'start': 0,
                        'type': "search",
                        'searchValue': event.currentTarget.value,
                        'offset': offset
                    };
                    self.searchCaseOffline(function (searchArray) {
                        self.drawCaseListView(listViewId, searchArray, false);
                    });
                }
            } else {
                self.filterCases();
            }
        }, 300);
    };

    self.setConnectionMode = function () {
    };

    self.listScrollLoadEvent = function () {
        var requestObject = {objectType: "Project"};
        if (self.drawListParams[listViewId]['type'] != "search") {
            requestObject = self.drawListParams[listViewId]['request'];
        } else {
            requestObject['searchKeywords'] = new RegExp(self.drawListParams[listViewId]['searchValue'].trim().replace(' ', '|'), "g");
        }
        self.listScrollLoad(listViewId, requestObject);
    };

    self.listScrollLoad = function (listViewId, query) {
        showLoadingIndikator();
        if (connection) {
            CaseController.getCases(query, self.drawListParams[listViewId]['start'], self.drawListParams[listViewId]['offset'], function (items) {
                self.drawCaseListView(listViewId, items, true);
            });
        } else {
            self.searchCaseOffline(function (searchArray) {
                self.drawCaseListView(listViewId, searchArray, true);
            });
        }
    };

    self.searchCaseOffline = function (callback) {
        var queryDate = [];
        var query = "SELECT * FROM KASE WHERE ";
        var request = self.drawListParams[listViewId]['request'];
        var temp = false;
        for (var propery in request) {
            if (propery == '$or') {
                if (temp) {
                    query += " AND";
                } else {
                    temp = true;
                }

                if (request[propery][0].owner) {
                    query += " ([owner-id] =? OR [author-id] =?) ";
                    queryDate.push(getTextTypeObject(request[propery][0].owner, 'integer'));
                    queryDate.push(getTextTypeObject(request[propery][1].creator, 'integer'));
                }

                if (request[propery][1].owner) {
                    query += " ([owner-id] =? OR [author-id] =?) ";
                    queryDate.push(request[propery][1].owner);
                    queryDate.push(request[propery][0].creator);
                }

                if (request[propery][0].status) {
                    query += " (status=? OR status=?) ";
                    queryDate.push(request[propery][0].status);
                    queryDate.push(request[propery][1].status);
                }
            } else {
                if (temp) {
                    query += " AND " + propery + "=? ";
                    queryDate.push(request[propery]);
                } else {
                    temp = true;
                    query += " " + propery + "=? ";
                    queryDate.push(request[propery]);
                }
            }
        }


        if (self.drawListParams[listViewId]['type'] == 'search') {
            var searchValues = [];
            if (self.drawListParams[listViewId]['searchValue'] != null && self.drawListParams[listViewId]['searchValue'] != "") {
                searchValues = self.drawListParams[listViewId]['searchValue'].split(' ');
            }
            if (searchValues.length > 0 && temp) {
                query += "AND ";
            }
            for (var i = 0, max = searchValues.length; i < max; i++) {
                if (i == 0) {
                    query += "searchKeywords LIKE ? ";
                    queryDate.push("%" + searchValues[i] + "%");
                } else {
                    query += "OR searchKeywords LIKE ? ";
                    queryDate.push("%" + searchValues[i] + "%");
                }
            }
        }

        query += "ORDER BY [updated-at] DESC LIMIT ?, ?";
        queryDate.push(self.drawListParams[listViewId]['start']);
        queryDate.push(self.drawListParams[listViewId]['offset']);

        db.selectByQuery(query, queryDate, 'deal', function (items) {
            hideLoadingIndikator();
            if (callback != null && typeof callback != null) {
                callback(items);
            }
        });

    };

    self.draftLinkEvent = function () {
        gotoPage({url: "draft", param: null}, {url: "case", param: null});
    };

    return self;
}(CaseFunctions || {}));
