$(document).on('pageinit', '#update-case-link', function () {
        UpdateCaseLink.init();
});

$(document).on('pageshow', '#update-case-link', function () {
    UpdateCaseLink.bindElementControls();
});

$(document).on('pagehide', '#update-case-link', function () {
    UpdateCaseLink.unbindElementControls();
});

var UpdateCaseLink = (function (UpdateCaseLink) {
    var self = UpdateCaseLink;
    var caseId = null;
    var caseObj = null;

    self.init = function () {
        if(pageObject){
            caseId = pageObject.caseId;
            pageObject = null;
        }
        CaseController.findById(caseId, function (data) {
            if (data[0] == null) {
                data = CaseController.encodeItem(data);
                caseObj = data;
            } else {
                data = data[0].kase;
                caseObj = data;
            }
            self.loadLinks(caseObj.link);
        });
    };

    self.bindElementControls = function () {
        $(document).on('click', '#update-case-link #back-link', goBack);
        $(document).on('click', '#update-case-link #more-link', self.openEditCommentPopup);
        $(document).on('click', '#update-case-link #save-link', self.saveCaseLinks);
        $('#update-case-link .popup-menu-backdrop').on('click', function () {
            $('#update-case-link .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#update-case-link .btn-case-link', self.populateLinkList);
        $(document).on('click', '#update-case-link .additional-options', self.saveCaseLinks);
        $(document).on('click', '#update-case-link #case-link-details', function () {
            $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
            $("#update-case-link .case-link-list-container").toggle();
        });
        $(document).on('click', '#update-case-link .link-val', function(){
            var linkVal = $(this).text();
            window.open(linkVal, "_blank", "location=yes");
        });
        $(document).on('click', '#update-case-link .link-remove-btn', self.removeLink);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#update-case-link #back-link');
        $(document).off('click', '#update-case-link #more-link');
        $(document).off('click', '#update-case-link #save-link');
        $('#update-case-link .popup-menu-backdrop').off('click');
        $(document).off('click', '#update-case-link .btn-case-link');
        $(document).off('click', '#update-case-link .additional-options');
        $(document).off('click', '#update-case-link #case-link-details');
        $(document).off('click', '#update-case-link .link-val');
        $(document).off('click', '#update-case-link .link-remove-btn');
    };

    self.loadLinks = function (links) {
        var html = "";
        if (links instanceof  Array) {
            for (var i = 0; i < links.length; i++) {
                html += "<li>";
                if (links[i].urlType.toLowerCase() == "link") {
                    html += "<div class='link-type' linkType='" + links[i].urlType + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
                } else {
                    html += "<div class='link-type' linkType='" + links[i].urlType + "' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
                }
                html += "<div class='link-desc truncate' link-val = '"+ links[i].url +"' style='padding: 0px 10px; max-width: 70%;'>" + links[i].urlDesc + "</div>"
                        + "<div class='link-remove-btn'><i class='md md-delete md-2x'></i></div>"
                        + "</li>";
            }
        } else {
            html += "<li>";
            if (links.urlType.toLowerCase() == "link") {
                html += "<div class='link-type' linkType='" + links.urlType + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
            } else {
                html += "<div class='link-type' linkType='" + links.urlType + "' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
            }
            html += "<div class='link-desc truncate' link-val = '"+ links.url +"' style='padding: 0px 10px; max-width: 70%;'>" + links.urlDesc + "</div>"
                    + "<div class='link-remove-btn'><i class='md md-delete md-2x'></i></div>"
                    + "</li>";
        }

        if (html != "") {
            $("#update-case-link #case-link-list").append(html);
        }
    };

    self.saveCaseLinks = function () {
        var caseLinks = [];
        var $caseLinks = $("#update-case-link #case-link-list li");
        for(var i=0; i< $caseLinks.length; i++){
            var linkObject = {};
            linkObject.url = $($caseLinks[i]).find('div.link-desc').attr('link-val');
            linkObject.urlDescription = $($caseLinks[i]).find('div.link-desc').text();
            linkObject.urlType = $($caseLinks[i]).find('div.link-type').attr('linkType');
            caseLinks.push(linkObject);
        }
        CaseController.updateCaseLinks(caseId, caseLinks);
    };

    self.openEditCommentPopup = function () {
        $('#update-case-link .popup-menu-backdrop').toggle();
        $('#update-case-link .advanced-menu').css('z-index', '20000');
        $('#update-case-link .advanced-menu').slideToggle('4000', 'swing');
    };

    self.populateLinkList = function(){
        var html = "";
        var $linkVal = $("#update-case-link .case-link-val");
        var $linkDesc = $("#update-case-link .case-link-desc");
        var $linkType = $("#update-case-link .case-link-type option:selected");
        var linkUrl = $linkVal.val();
        var linkDesc = $linkDesc.val();
        if(linkUrl && linkDesc){
            html += "<li>";
            if ($linkType.val() == "link") {
                html += "<div class='link-type' linkType='" + $linkType.val() + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
            } else {
                html += "<div class='link-type' linkType='" + $linkType.val() + "' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
            }
            html += "<div class='link-desc truncate' link-val='"+ $linkVal.val() +"' style='padding: 0px 10px; max-width: 70%;'>" + linkDesc + "</div>"
                    + "<div class='link-remove-btn'><i class='md md-delete md-2x'></i></div>"
                    + "</li>";
        }
        if (html != "") {
            $("#update-case-link #case-link-list").append(html);
            $linkVal.val("");
            $linkDesc.val("");
        }
    };

    self.removeLink = function(){
      $(this).parent().remove();
    };

    return self;
}(UpdateCaseLink || {}));
