var navigationFix = false;
$(document).on('pageinit', '#view-case', function () {
    ViewCaseFunctions.init();
    $("#view-case-general-content").click(function () {
        $("#view-case .navigation_button").toggle("slow");
    });
});

$(document).on('pageshow', '#view-case', function () {
    sharedTaskForOpen = null;
    ViewCaseFunctions.bindElementControls();
    ViewCaseFunctions.setConnectionMode();
    setTimeout(function () {
        $("#view-case .swipe-indicator").fadeOut("400");
    }, 1000);
});

$(document).on('pagehide', '#view-case', function () {
    ViewCaseFunctions.unbindElementControls();
    navigationFix = false;
});

var ViewCaseFunctions = (function (ViewCaseFunctions) {
    var self = ViewCaseFunctions;

    var $addNewLink = null,
        $generalLink = null,
        $notesLink = null,
        $tasksLink = null,
        $generalContent = null,
        $notesContent = null,
        $tasksContent = null,
        $caseTaskList = null,
        $refreshLink = null,
        $casefilterTaskList = null,
        $casePartyList = null,
        $viewCasePrivate = null,
        $viewCasePermissionList = null,
        $casesEmptyNoteListMessage = null,
        $casesEmptyTaskListMessage = null,
        $partyHeading = null,
        $caseBackgroundInfo = null,
        $taskStatusChangeComment = null,
        listViewId = 'view-case-tasks-list',
//        tapholdActive = false,
        statusText = null,
        $casePopup = null,
        $caseMoreLink = null;

    var caseObject = null;
    var listParams = [];
    var $notesLinkContainer = null;
    var $tasksLinkContainer = null;
    var $taskList = null;
    var caseId = null;
    var caseIds = null;
    var currentCaseIndex = null;
    var $attachContent = null;
    var $caseAttachLink = null;
    var $caseAttachLinkText = null;
    var $attachList = null;
    var attachments = null;

    var Navigation = {
        'CURRENT_POSITION': 'view-case-general-link',
        'GENERAL_TAB': 'view-case-general-link',
        'NOTE_TAB': 'view-case-notes-link',
        'TASK_TAB': 'view-case-tasks-link',
        'ATTACH_TAB': 'view-case-attach-link',
        'REFRESH_BUTTON': 'view-case-refresh-link'
    };

    var TaskType = {
        'CURRENT': 'filter-case-upcoming-tasks',
        'UPCOMING': 'filter-case-upcoming-tasks',
        'COMPLETED': 'filter-case-completed-tasks',
        'MYUPCOMING': 'filter-case-my-upcoming-tasks',
        'RECENTLYADDED': 'filter-case-recent-tasks'
    };

    self.init = function () {
        navigationFix = false;
        $generalLink = $('#view-case-general-link');
        $notesLink = $('#view-case #view-case-notes-link-text');
        $notesLinkContainer = $('#view-case-notes-link');
        $tasksLink = $('#view-case #view-case-tasks-link-text');
        $tasksLinkContainer = $('#view-case-tasks-link');
        $refreshLink = $('#view-case-refresh-link');
        $addNewLink = $('#add-new-link');
        $generalContent = $('#view-case-general-content');
        $notesContent = $('#view-case-notes-content');
        $tasksContent = $('#view-case-tasks-content');
        $caseTaskList = $('#view-case-tasks-list');
        $partyHeading = $("#party-heading");
        $casefilterTaskList = $('#filter-case-task-type');
        $viewCasePrivate = $('#permission-case-users');
        $viewCasePermissionList = $('#user-case-permission-list');
        $casePartyList = $('#case-party-list');
        $casesEmptyNoteListMessage = $('#cases-empty-note-list-message');
        $casesEmptyTaskListMessage = $('#cases-empty-task-list-message');
        $caseBackgroundInfo = $("#case-background-info");
        $taskStatusChangeComment = $('#task-status-comment-on-complete');
        $caseMoreLink = $("#case-more-link");
        $casePopup = $("#view-case .advanced-menu");
        $taskList = $('#view-case-tasks-list');
        $attachContent = $('#view-case #view-case-attach-content');
        $caseAttachLink = $('#view-case #view-case-attach-link');
        $caseAttachLinkText = $('#view-case #view-case-attach-link-text');
        $attachList = $('#view-case #view-case-attach-list');

        $casesEmptyTaskListMessage.hide();
        $casesEmptyNoteListMessage.hide();
        $casefilterTaskList.i18n();
        $casefilterTaskList.val('filter-case-upcoming-tasks').selectmenu("refresh");
        if (pageObject) {
            caseId = pageObject.caseId;
            caseIds = pageObject.caseIds;
            listParams = pageObject.listParams;
            pageObject = null;
        }

        // case pagination method
        if (caseIds && caseIds.length > 1) {
            currentCaseIndex = caseIds.indexOf(caseId);
            $('#view-case .title-h1').text("(" + (currentCaseIndex + 1) + "/" + caseIds.length + ")");
        }
        // init viewCase Object
        CaseController.findById(caseId, function (data, feedElements) {
            if (!data){
              return;
            }
            if (data[0] == null) {
                data = CaseController.encodeItem(data);
                caseObject = data;
            } else {
                data = data[0].kase;
                caseObject = data;
            }
            if (!feedElements) {
              feedElements = [];
            }

            self.getAttachmentCount(function (count, attachment) {
                if (count) {
                  $caseAttachLinkText.text("(" + count + ")");
                }
                if (attachment) {
                  attachments = attachment;
                }
                self.navigateFilter();
            });
            self.drawHeading();
            if (feedElements) {
                self.loadItemHistory(feedElements);
            }
        });

        FavoriteController.findByObjectIdDB(caseId, function(data){
            if (data && data.length > 0) {
                $('.md-star').addClass('contact-favorite-star');
            }
        });
    };

    self.activateTab = function (tabName) {
        switch (tabName) {
            case "General":
                $notesLinkContainer.removeClass("btn-active");
                $tasksLinkContainer.removeClass("btn-active");
                $caseAttachLink.removeClass("btn-active");
                $generalLink.addClass("btn-active");
                break;
            case "Note":
                $tasksLinkContainer.removeClass("btn-active");
                $generalLink.removeClass("btn-active");
                $caseAttachLink.removeClass("btn-active");
                $notesLinkContainer.addClass("btn-active");
                break;
            case "Task":
                $generalLink.removeClass("btn-active");
                $notesLinkContainer.removeClass("btn-active");
                $caseAttachLink.removeClass("btn-active");
                $tasksLinkContainer.addClass("btn-active");
                break;
            case "Attachment":
                $generalLink.removeClass("btn-active");
                $notesLinkContainer.removeClass("btn-active");
                $tasksLinkContainer.removeClass("btn-active");
                $caseAttachLink.addClass("btn-active");
                break;
        }
    };

    self.floatButton = function() {
        var id = $(this).parent().parent().attr('id');
        if (id === "view-case-general-content") {
          self.editCase();
        } else if (id === "view-case-tasks-content" || id === "view-case-notes-content"){
          self.addLink();
        } else {
          self.openFloatButtonAttachment();
        }
    };

    self.openFloatButtonAttachment = function () {
        $(this).toggleClass("rotation-event");
        $('#view-case .popup-menu-backdrop').toggle();
        $('#view-case .menu-more-option').toggle();
    };

    self.closeFloatButtonAttachment = function() {
        $('#view-case .menu-more-option').hide();
        $('#view-case .float-add-action').removeClass("rotation-event");
        $(this).hide();
        $('.float-add-action').show();
    };


    self.bindElementControls = function () {
        $(document).on('click', '#back-link', self.goBack);
        $(document).on('click', '#view-case #view-case-general-link', self.navigateFilter);
        $(document).on('click', '#view-case #view-case-notes-link', self.navigateFilter);
        $(document).on('click', '#view-case #view-case-tasks-link', self.navigateFilter);
        $(document).on('click', '#view-case #view-case-refresh-link', self.navigateFilter);
        $(document).on('click', '#edit-cases', self.editCase);
        // $(document).on('click', '#view-case .float-add-action', self.floatButton);
        $(document).on('click', '#view-case #add-new-link', self.addLink);
        $(document).on('change', '#view-case #filter-case-task-type', self.filterTasks);
        $(document).on('click', '#delete-cases', self.caseDeleteLinkEvent);
        $(document).on('click', '#view-case #view-case-tasks-list .task-item', self.openTask);
//        $(document).on('taphold', '#view-case #view-case-tasks-list .task-item', self.deleteTaskItem);
        $(document).on('click', '#view-case #view-case-notes-list .note', self.openNote);
        $(document).on('click', '#view-case #view-case-tasks-list .createdTask', self.completeTaskEvent);
        $(document).on('click', '#view-case #view-case-tasks-list .assignedTask', self.completeTaskEvent);
        $(document).on('click', '#view-case #view-case-tasks-list .inprogressTask', self.completeTaskEvent);
        $(document).on('click', '#view-case #view-case-tasks-list .completedTask', self.completeTaskEvent);
        $(document).on('click', '#view-case #view-case-tasks-list .canceledTask', function () {
            alert("Status change is not allowed!");
        });

        $(document).on('click', '#view-case #change-case-status', self.openChangeCaseStatusPopup);
        $(document).on('click', '#view-case #current-case-status', self.openChangeCaseStatusPopup);

        $(document).on('click', '#case-more-link', self.openCaseOptionsPopup);
        $('#view-case .popup-menu-backdrop').on('click', function () {
            $('#view-case .advanced-menu').hide();
            $('#view-case .attach-advanced-menu').hide();
            $(this).hide();
        });

        $("body").on('swipeleft', '#view-case', self.leftSwipeItemEvent);
        $("body").on('swiperight', '#view-case', self.rightSwipeItemEvent);

        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });
        $(document).on("click", "#view-case #case-party-list", self.gotoCaseParent);

        $(document).on("click", "#view-case .childTasks", self.getChildTasks);


        $(document).on("click", "#view-case .task-due-date-change", self.changeDueDateEvent);
        $(document).on('click', '#view-case #update-link', self.gotoLinkChange);
        $(document).on('click', '#view-case .comment-container', self.showNoteComments);
        $(document).on('click', '#view-case #favorite-case', self.setAsFavorite);
        $(document).on('click', '#view-case #favorite-case-mouseover', self.setAsFavorite);

        $(document).on("click", "#view-case #view-case-attach-link", self.navigateFilter);
        $(document).on("click", "#view-case #take-photo", self.takePhoto);
        $(document).on("click", "#view-case #choose-from-gallery", self.chooseFromFileSystem);
        $(document).on("click", "#view-case .attachment", self.openAttachment);
        $(document).on("click", "#view-case .delete-item", self.deleteAttachment);
        $(document).on("click", "#view-case .child-task-item", self.navigateToChildTask);
        $(document).on("click", "#view-case .load-task-child-btn", self.loadChildTaskEvent);

        $(document).on("click", "#view-case .case-link-display", self.viewItemVisibleToggle);
        $(document).on("click", "#view-case .view-item-history", self.viewItemVisibleToggle);
        $(document).on("click", "#view-case .view-item-visibility", self.viewItemVisibleToggle);
        $(document).on('click', '#view-case .favorite-event', TaskFunctions.eventFavorite);
        $(document).on('click', '#view-case .task-list-icons', self.changeEventDueDateChildTask);
        $(document).on("click", "#view-case .case-link-el", function () {
            var linkVal = $(this).attr('caseUrl');
            window.open(linkVal, '_blank', 'location=yes');
        });

        $(document).on('click', '#view-case .float-add-action', self.floatButton);
        $(document).on('click', '#view-case .popup-menu-backdrop', self.closeFloatButtonAttachment);
        $(document).on('click', '#view-case #view-case-take-photo', function() {
            self.closeFloatButtonAttachment();
            self.takePhoto();
        });

        $(document).on('click', '#view-case #view-case-choose-image', function() {
            self.closeFloatButtonAttachment();
            self.chooseFromFileSystem();
        });
        $(document).on('click', '#view-case #case-due-date', self.gotoDueDateChange);
        $(document).on('click', '#view-case #view-case-heading-owner', self.changeOwner);
        $(document).on('click', '#view-case .add-new-permission-user', self.changePermission);
        $(document).on('click', '#view-case .visible-user-item', self.removePersonPermission);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#back-link');
        $(document).off('click', '#view-case #view-case-general-link');
        $(document).off('click', '#view-case #view-case-notes-link');
        $(document).off('click', '#view-case #view-case-tasks-link');
        $(document).off('click', '#view-case #view-case-refresh-link');
        $(document).off('click', '#edit-cases');
        $(document).off('click', '#view-case #add-new-link');
        $(document).off('change', '#view-case #filter-case-task-type');
        $(document).off('click', '#delete-cases');
        $(document).off('click', '#view-case #view-case-tasks-list .task-item');
        $(document).off('click', '#view-case #view-case-tasks-list .createdTask');
        $(document).off('click', '#view-case #view-case-tasks-list .completedTask');
        $(document).off('click', '#view-case #view-case-tasks-list .canceledTask');
        $(document).off('click', '#view-case #view-case-tasks-list .assignedTask');
        $(document).off('click', '#view-case #view-case-tasks-list .inprogressTask');
        $(document).off('click', '#view-case .float-add-action');
//        $(document).off('taphold', '#view-case #view-case-tasks-list .task-item');
        $(document).off('click', '#view-case #change-case-status');
        $(document).off('click', '#view-case #current-case-status');
        $(document).off('click', '#view-case #view-case-notes-list .note');
        $(document).off('click', '#case-more-link');
        $('#view-case .popup-menu-backdrop').off('click');

        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));

        $("body").off('swipeleft', '#view-case');
        $("body").off('swiperight', '#view-case');
        $(document).off("click", "#view-case .view-item-visibility");
        $(document).off('click', '#view-case #case-party-list');
        $(document).off("click", "#view-case .childTasks");
        $(document).off("click", "#view-case .case-link-display");
        $(document).off("click", "#view-case .case-link-el");
        $(document).off("click", "#view-case .task-due-date-change");
        $(document).off('click', '#view-case #update-link');
        $(document).off('click', '#view-case .comment-container');
        $(document).off('click', '#view-case #favorite-case');
        $(document).off('click', '#view-case #favorite-case-mouseover');
        $(document).off("click", "#view-case .view-item-history");
        $(document).off("click", "#view-case #view-case-attach-link");
        $(document).off("click", "#view-case #take-photo");
        $(document).off("click", "#view-case #choose-from-gallery");
        $(document).off("click", "#view-case .attachment");
        $(document).off("click", "#view-case .delete-item");
        $(document).off("click", "#view-case .child-task-item");
        $(document).off("click", "#view-case .load-task-child-btn");
        $(document).off('click', '#view-case .favorite-event');
        $(document).off('click', '#view-case .task-list-icons');
        $(document).off('click', '#view-case .float-add-action');
        $(document).off('click', '#view-case .popup-menu-backdrop');
        $(document).off('click', '#view-case #view-case-take-photo');
        $(document).off('click', '#view-case #view-case-choose-image');
        $(document).off('click', '#view-case #case-due-date');
        $(document).off('click', '#view-case #view-case-heading-owner');
        $(document).off('click', '#view-case .add-new-permission-user');
        $(document).off('click', '#view-case .visible-user-item');
    };

    self.removePersonPermission = function() {
      var identity = $(this).attr('data-identity');
      caseObject.objectType = "Project";
      PermissionController.removePermissionFromObject(identity, caseObject, function(success){
        if (success) {
          $('.visible-user-item[data-identity=' + identity +']').remove();
          var visibleTo = [];
          for (var i = 0, max = caseObject['visible-to'].length; i < max; i++) {
              if (caseObject['visible-to'][i].identity != identity) {
                visibleTo.push(caseObject['visible-to'][i]);
              }
          }
          caseObject['visible-to'] = visibleTo;
        }
      });
    };

    self.changeEventDueDateChildTask = function(e) {
        var idTask = $(this).attr("taskid");
        var dueDate = $(this).attr("duedate");
        var created = $(this).attr("created");
        var displayName = $(this).attr("displayName");
        var parent = {url: "viewCase", controller: ViewCaseFunctions, param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}}
        var params = null;
        if ($(this).hasClass('md-flag')) {
            params = {
                url: "changeStatus",
                param: {
                  parentId: idTask,
                  parentType: "Task"
                }
            };
        } else if ($(this).hasClass('md-event')) {
          params = {
              url: "changeDueDate",
              param: {
                'taskId': idTask,
                'dueDate': dueDate
              }
          };
        } else if ($(this).hasClass('md-access-time')) {
          params = {
            url: "effort",
            param: {
              'displayName':  displayName,
              'relatedCreationDate' : created,
              'relatedType' : "Task",
              'relatedId' : idTask
            }
          };
        }
        gotoPage(params, parent);
        e.stopPropagation();
    }


    self.viewItemVisibleToggle =  function (event) {
          $('html, body').animate({scrollTop: $(document).height()}, 'slow');
          $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
          $('#' + $(this).attr('container')).toggleClass('hide');
    };

    self.gotoDueDateChange = function () {
        var id = caseObject.id.text;
        var dueDate = caseObject['due-at']['text'];
        gotoPage({
            url: "changeDueDate",
            controller: ChangeDueDateFunctions,
            isModal: true,
            param: {'id': id, 'dueDate': dueDate}
        }, {url: "viewCase", controller: ViewCaseFunctions, param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.changeOwner = function () {
        gotoPage(
          {url: "changeOwner", param: {"id": caseObject.id.text, type: "Project"}},
          {url: "viewCase", controller: ViewCaseFunctions, param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}}
        );
    };

    self.changePermission = function(){
        gotoPage({url: "changePermission", param: {"id": caseObject.id.text, type: "Project"}}, {url: "viewCase", controller: ViewCaseFunctions, param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.gotoLinkChange = function () {
        gotoPage({url: "updateCaseLink", param: {caseId: caseObject.id.text}}, {url: "viewCase", controller: ViewCaseFunctions, param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.changeDueDateEvent = function () {
        var idTask = $(this).attr("taskid");
        var dueDate = $(this).attr("duedate");
        gotoPage({
            url: "changeDueDate",
            controller: ChangeDueDateFunctions,
            isModal: true,
            param: {taskId: idTask, dueDate: dueDate}
        }, {url: "viewCase", controller: ViewCaseFunctions, param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.getChildTasks = function () {
        var parentId = $(this).attr("parentId");
        $("ul[id='" + parentId + "']").attr('data-pageCount', 1);
        $("i", this).toggleClass("md-expand-more md-expand-less");
        if (connection) {
            var request = {objectType: "Task", immediateParent: new ObjectId(parentId)};
            ClientAPI.findPaged(request, [["dueDate", 1]], 1, offset, function (err, items) {
                if (items && items.length > 0) {
                    var tasks = [];
                    for (var i = 0; i < items.length; i++) {
                        tasks.push(TaskController.encodeItem(items[i]));
                    }
                    TaskFunctions.drawSimpleTaskListView(parentId, tasks);
                    if(tasks.length < offset){
                        $("ul[id='" + parentId + "'] .load-task-child-btn").remove();
                    }
                    for (var i = 0; i < tasks.length; i++) {
                        (function (num) {
                            ClientAPI.findCount({
                                objectType: "Task",
                                immediateParent: new ObjectId(tasks[num].id.text)
                            },
                                    function (err, data) {
                                        if (!err) {
                                            if (data == 0) {
                                                $("a[parentId='" + tasks[num].id.text + "']").remove();
                                            } else {
                                                $("a[parentId='" + tasks[num].id.text + "']").append(" (" + data + ")");
                                            }
                                        }
                                    });
                        })(i);
                    }
                    $("#view-case ul [id='" + parentId + "']").toggle();
                } else {
                    alert("Empty task list!");
                }
            });
        } else {
            db.selectByQuery('SELECT * FROM TASK WHERE [recording-id] = ? AND [recording-type] = ? LIMIT ?, ?', [getTextTypeObject(parentId, 'integer'), "Task", 0, offset], 'task', function (items) {
                TaskFunctions.drawSimpleTaskListView(parentId, items);
                $("ul[id='" + parentId + "'] .load-task-child-btn").remove();
                for (var i = 0; i < items.length; i++) {
                    (function (num) {
                        db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-id" = ? AND "recording-type" = ?',
                                [getTextTypeObject(items[num].id.text, 'integer'), "Task"], models.taskDBModel.name, function (data) {
                            if (data[0]['count(*)'] == 0) {
                                $("a[parentId='" + items[num].id.text + "']").remove();
                            } else {
                                $("a[parentId='" + items[num].id.text + "']").append(" (" + data[0]['count(*)'] + ")");
                            }
                        });
                    })(i);
                }
                $("#view-case ul [id='" + parentId + "']").toggle();
            });
        }
    };

    self.gotoCaseParent = function () {
        gotoPage({url: "viewContact", param: {contactId: caseObject.party.id, contactType: caseObject.party.type.toLowerCase()}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.leftSwipeItemEvent = function () {
        if (caseIds && caseIds.length > 1) {
            currentCaseIndex++;
//            currentCaseIndex = (currentCaseIndex > caseIds.length - 1) ? 0 : currentCaseIndex;
            if (currentCaseIndex > caseIds.length - 1) {
                if (connection && !listParams.favorite) {
                    var query = {objectType: "Project"};
                    if(listParams.parentId){
                        query.immediateParent = listParams.parentId;
                    }
                    switch(listParams.type){
                        case "ALL_OPEN_CASES":
                            query.status = {$nin: ["Closed"]};
                            break;
                        case "MY_OPEN_CASES":
                            query.status = {$nin: ["Closed"]};
                            query.owner = localStorage.getItem('userId');
                            break;
                        case "ALL_CLOSED_CASES":
                            query.status = "Closed";
                            break;
                        case "MY_CLOSED_CASES":
                            query.status = "Closed";
                            query.owner = localStorage.getItem('userId');
                            break;

                    }
                    CaseController.getCases(query, listParams.start, listParams.offset, function (items) {
                        if (items.length == 0) {
                            currentCaseIndex = 0;
                        }
                        for (var i = 0; i < items.length; i++) {
                            caseIds.push(items[i].id.text);
                        }
                        caseId = caseIds[currentCaseIndex];
                        self.init();
                        listParams.start += listParams.offset;
                    });
                } else {
                    currentCaseIndex = 0;
                    caseId = caseIds[currentCaseIndex];
                    self.init();
                }
            } else {
                caseId = caseIds[currentCaseIndex];
                self.init();
            }
        }
    };

    self.rightSwipeItemEvent = function () {
        if (caseIds && caseIds.length > 1) {
            currentCaseIndex--;
            currentCaseIndex = (currentCaseIndex < 0) ? currentCaseIndex = (caseIds.length - 1) : currentCaseIndex;
            caseId = caseIds[currentCaseIndex];
            self.init();
        }
    };

    self.openCaseOptionsPopup = function () {
        $("#view-case .navigation_button").hide();
        $('#view-case .popup-menu-backdrop').toggle();
        $('#view-case .advanced-menu').css('z-index', '20000');
        $('#view-case .advanced-menu').slideToggle('4000', 'swing');
    };

    self.caseDeleteLinkEvent = function () {
        $("#view-case .popup-menu-backdrop").hide();
        $casePopup.hide();
        setTimeout(function () {
            showActionDialog(Messages.Case.deleteCaseMessage, "Yes", self.deleteCase, "No", function () {
            });
        }, 100);
    };

    self.deleteCase = function () {
        CaseController.deleteCase(caseObject.id.text, function (data) {
            if (data == 0) {
                self.goBack();
            } else {
                alert(Messages.Case.deleteCaseMessageErr);
            }
        });
    };

    self.onPullDown = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            self.navigateFilter();
        }
    };

    self.onPullUp = function () {
        var activeTab = Navigation['CURRENT_POSITION'];
        var bool;

        switch (activeTab) {
            case "view-case-notes-link":
                bool = $("#view-case-notes-list li", '#' + $.mobile.activePage.attr('id')).last().visible();
                break;
            case "view-case-tasks-link":
                console.log("task tab activated");
                bool = $("#view-case-tasks-list li", '#' + $.mobile.activePage.attr('id')).last().visible();
                break;
        }

        if (bool) {
            self.listScrollLoadEvent();
        }
    };

    self.openChangeCaseStatusPopup = function () {
        gotoPage({url: "changeStatus", param: {parentType: "Project", parentId: caseObject.id.text, parentVisibility: caseObject['visible-to'], status: caseObject.status}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.goBack = function () {
        goBack();
    };

    self.completeTaskEvent = function () {
        var taskId = $(this).attr('taskId');
        gotoPage({url: "changeStatus", param: {parentId: taskId, parentType: "Task"}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

//    self.deleteTaskItem = function () {
//        tapholdActive = true;
//        setTimeout(function () {
//            tapholdActive = false;
//        }, 1000);
//        var taskId = $(this).attr('taskId');
//        if (connection) {
//            showActionDialog(Messages.Task.deleteTaskMessage, "Yes", function () {
//                showLoadingIndikator();
//                TaskController.findById(taskId, function (data) {
//                    data = TaskController.encodeItem(data);
//                    var requestObject = {
//                        "taskid": data.id.text,
//                        "body": data.body
//                    };
//                    TaskController.deleteTask(data.id.text, function (data) {
//                        if (data == 0) {
//                            db.selectSingleRecord(models.infoMessageDBModel.name, "body", requestObject, function (data) {
//                                if (data != null) {
//                                    var messageId = data.infoMessage._id;
//                                    db.deleteObject(models.infoMessageDBModel.name, "_id", messageId);
//                                    SipMessageSettingFunctions.setMessageStatus([
//                                        {'messageid': messageId, 'status': 5 }
//                                    ]);
//                                }
//                                self.navigateFilter();
//                                hideLoadingIndikator();
//                            });
//
//                        } else {
//                            hideLoadingIndikator();
//                            alert(Messages.Task.deleteTaskMessageErr);
//                        }
//                    });
//                });
//            }, "No", function () {
//            });
//        }
//    };

    self.navigateFilter = function (type) {
        $("#view-case .filter-container").show();
        var navigation = null;
        navigation = $(this).attr("id");
        if (type != null && (
                type == Navigation['GENERAL_TAB'] ||
                type == Navigation['REFRESH_BUTTON'] ||
                type == Navigation['NOTE_TAB'] ||
                type == Navigation['TASK_TAB'] ||
                type == Navigation['ATTACH_TAB'])
                ) {
            navigation = type;
        }

        if (navigation == null) {
            navigation = Navigation['CURRENT_POSITION'];
        }

        if (navigation == null || Navigation['GENERAL_TAB'] == navigation) {
            //refaktorisati
            Navigation['CURRENT_POSITION'] = Navigation['GENERAL_TAB'];
            $taskList.hide();
            $addNewLink.hide();
            $refreshLink.hide();
            $caseMoreLink.show();
            self.activateTab("General");
            $generalContent.show();
            $notesContent.hide();
            $tasksContent.hide();
            $attachContent.hide();
            self.drawGeneral();
        } else if (Navigation['REFRESH_BUTTON'] == navigation) {
            if (Navigation['CURRENT_POSITION'] == Navigation['NOTE_TAB']) {
                $taskList.hide();
                self.drawNotes();
            } else if (Navigation['CURRENT_POSITION'] == Navigation['TASK_TAB']) {
                //$casefilterTaskList.val(TaskType['CURRENT']).selectmenu('refresh');
                self.filterTasks();
                $taskList.show();
            }
        } else if (Navigation['NOTE_TAB'] == navigation) {
            Navigation['CURRENT_POSITION'] = navigation;
            //refaktorisati
            $taskList.hide();
            $addNewLink.show();
            $refreshLink.show();
            $caseMoreLink.hide();
            self.activateTab("Note");
            $generalContent.hide();
            $notesContent.show();
            $tasksContent.hide();
            $attachContent.hide();
            self.drawNotes();
        } else if (Navigation['TASK_TAB'] == navigation) {
            Navigation['CURRENT_POSITION'] = navigation;
            //refaktorisati
            $addNewLink.show();
            $refreshLink.show();
            $caseMoreLink.hide();
            self.activateTab("Task");
            $generalContent.hide();
            $notesContent.hide();
            $attachContent.hide();
            $tasksContent.show();
            $caseTaskList.empty();
            //$casefilterTaskList.val(TaskType['CURRENT']).selectmenu('refresh');
            self.filterTasks();
            $taskList.show();
        } else if (Navigation['ATTACH_TAB'] == navigation) {
            Navigation['CURRENT_POSITION'] = navigation;
            $addNewLink.show();
            $caseMoreLink.hide();
            self.activateTab("Attachment");
            $generalContent.hide();
            $notesContent.hide();
            $tasksContent.hide();
            $attachContent.show();
            AttachmentController.drawList("#view-case-attach-list", attachments);
        }
    };

    self.drawGeneral = function () {
        var html = "";

        var name = "";
        if (typeof caseObject.background == "string" && caseObject.background != "") {
            $caseBackgroundInfo.html(caseObject.background);
        } else {
            $caseBackgroundInfo.text(Messages.Case.backgroundInfo);
        }

        if (caseObject['due-at'] && caseObject['due-at'].text) {
            $("#view-case #case-due-date").html(dateFormat(new Date(caseObject["due-at"].text)));
            $("#view-case #case-due-date-container").show();
        } else {
            $("#view-case #case-due-date-container").hide();
        }

        if (caseObject.status) {
            $("#current-case-status").text(caseObject.status);
        } else {
            $("#current-case-status-container").remove();
        }

        if (caseObject.link) {
            $("#view-case .empty-link-msg").hide();
            var caseLinkHtml = "";
            if (caseObject.link instanceof Array) {
                for (var i = 0; i < caseObject.link.length; i++) {
                    caseLinkHtml += "<li>";
                    switch (caseObject.link[i].urlType) {
                        case "link":
                            caseLinkHtml += "<div class='link-icon'><i class='md md-link'></i></div>";
                            break;
                        case "video":
                            caseLinkHtml += "<div class='link-icon'><i class='md md-videocam'></i></div>";
                    }
                    caseLinkHtml += "<div class='truncate case-link-el' caseUrl='" + caseObject.link[i].url + "' >" + caseObject.link[i].urlDesc + "</div>"
                            + "</li>";
                }
            } else {
                caseLinkHtml += "<li>";
                switch (caseObject.link.urlType) {
                    case "link":
                        caseLinkHtml += "<div class='link-icon'><i class='md md-link'></i></div>";
                        break;
                    case "video":
                        caseLinkHtml += "<div class='link-icon'><i class='md md-videocam'></i></div>";
                        break;
                }
                caseLinkHtml += "<div class='truncate case-link-el'" + caseObject.link.url + ">" + caseObject.link.urlDesc + "</div>"
                        + "</li>";
            }
            if (caseLinkHtml != "") {
                $("#view-case #case-link-list").html(caseLinkHtml);
            } else {
                $("#view-case #case-link-list").empty();
                $("#view-case .empty-link-msg").css('display', 'block');
                $("#view-case .empty-link-msg").css('padding', '10px');
                $("#view-case .empty-link-msg").show();
            }
        }

        self.emptyList();
        hideLoadingIndikator();
        self.setConnectionMode();
    };

    //refaktorisati
    self.drawHeadingCount = function () {
        if (connection) {
            ClientAPI.find({immediateParent: new ObjectId(caseObject.id.text)}
            , null, function (err, data) {
                var notes = data.filter(function (item) {
                    return item.objectType == "Note";
                });
                $notesLink.text('(' + notes.length + ')');
            });
        } else {
            $notesLink.text('(' + 0 + ')');
        }
        self.getTaskCount($casefilterTaskList.find('option:selected').val());
    };

    self.drawHeading = function () {
        var i, max;
        $('#view-case-heading-owner').text(ALL_USERS[caseObject['owner-id'].text].name);
        $('#view-case-heading').html(caseObject.name);

        self.drawHeadingCount();
        $viewCasePermissionList.empty();

        var htmlUser = PermissionController.drawPermissionForObject(caseObject);

        if (htmlUser != "") {
            $viewCasePermissionList.append(htmlUser);
            $viewCasePrivate.show();
        } else {
            $viewCasePrivate.hide();
        }

        //draw parent object
        if (caseObject.party != null && caseObject.party.name) {
            if (caseObject.party.type.toLowerCase() == "person") {
                self.drawPeopleElement();
            } else {
                self.drawCompanyElement();
            }
        } else {
            $('#case-party-list-container').hide();
            $('#view-case #involved').empty();
        }

        hideLoadingIndikator();

        $('#rb-open-case').parent().show();
        $('#rb-inprogressreopen-case').parent().show();
        $('#rb-inprogress-case').parent().show();
        $('#rb-closed-case').parent().show();

        if (caseObject.status == "Created") {
            $('#rb-open-case').attr("checked", true).checkboxradio("refresh");
            $('#rb-inprogressreopen-case').parent().hide();
        } else if (caseObject.status == 'InProgress') {
            $('#rb-open-case').parent().hide();
            $('#rb-inprogressreopen-case').parent().hide();
            $('#rb-inprogress-case').attr("checked", true).checkboxradio("refresh");
        } else if (caseObject.status == 'Closed') {
            $('#rb-open-case').parent().hide();
            $('#rb-inprogress-case').parent().hide();
            $('#rb-inprogressreopen-case').parent().show();
            $('#rb-closed-case').attr("checked", true).checkboxradio("refresh");
        }
        self.setConnectionMode();
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
    };

    self.drawPeopleElement = function () {
        $("#view-case #case-party-list").empty();
        var firstName = "";
        var lastName = "";
        var names = caseObject.party.name.split(" ");
        if (names[1]) {
            firstName = names[1];
        }
        if (names[0]) {
            lastName = names[0];
        }
        $("#view-case #case-party-list").html(firstName + " " + lastName);
        $("#involved").html("Person");
        $('#case-party-list-container').show();
    };

    self.drawCompanyElement = function () {
        $("#view-case #case-party-list").empty();
        var name = caseObject.party.name;
        var html = "";
        if (name != null && name != "") {
            html = '<span style="padding:0px;" contactId="' + caseObject.party.id + '" type="company">' + name + '</span>';
            $("#view-case #case-party-list").html(html);
            $("#view-case #involved").html("Company");
            $('#case-party-list-container').show();
        } else {
            $('#view-case #involved').empty();
        }
    };

    self.filterTasks = function () {
        navigationFix = true;

        var type = $casefilterTaskList.find('option:selected').val();
        if (type == null) {
            type = TaskType['CURRENT'];
            $casefilterTaskList.find('option:selected').val(TaskType['CURRENT']);
            $casefilterTaskList.selectmenu('refresh');
        }

        switch (type) {
            case TaskType['UPCOMING']:
                self.getTaskCount(type);
                TaskController.getTasksBySubjectIdAndType(caseObject.id.text, "Kase", 0, offset, 'Upcoming', false, function (tasks) {
                    TaskType['CURRENT'] = TaskType['UPCOMING'];
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "Upcoming",
                        'offset': offset,
                        'parentId': caseObject.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, tasks, "Upcoming", false);
                    self.emptyList();
                    self.setConnectionMode();
                });
                break;
            case TaskType['COMPLETED']:
                self.getTaskCount(type);
                TaskController.getTasksBySubjectIdAndType(caseObject.id.text, "Kase", 0, offset, 'Completed', false, function (tasks) {
                    TaskType['CURRENT'] = TaskType['COMPLETED'];
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "Completed",
                        'offset': offset,
                        'parentId': caseObject.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, tasks, "Completed", false);
                    self.emptyList();
                    self.setConnectionMode();
                });
                break;
            case TaskType['MYUPCOMING']:
                self.getTaskCount(type);
                caseObject.objectType = "Kase";
                TaskController.findMyUpcomingTaskForParentObject(caseObject, function(items){
                    TaskType['CURRENT'] = TaskType['MYUPCOMING'];
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "MyUpcoming",
                        'offset': offset,
                        'parentId': caseObject.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, items, false);
                    self.emptyList();
                    self.setConnectionMode();
                });
                break;
            case TaskType['RECENTLYADDED']:
                caseObject.objectType = "Kase";
                TaskController.findRecentlyAdded(caseObject, function(items) {
                    TaskType['CURRENT'] = TaskType['RECENTLYADDED'];
                    self.getTaskCount(type, items.length);
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "Upcoming",
                        'offset': offset,
                        parentId: caseObject.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, items, "Upcoming", false);
                    self.setConnectionMode();
                });
                break;
        }
    };

    self.getTaskCount = function (filterValue, count) {
        switch (filterValue) {
            case TaskType['UPCOMING']:
                if (connection) {
                    ClientAPI.findCount({
                        objectType: "Task",
                        status: {$nin: ["Completed", "Canceled", "Verified"]},
                        immediateParent: new ObjectId(caseObject.id.text)
                    },
                            function (err, data) {
                                $tasksLink.text('(' + data + ')');
                                self.setConnectionMode();
                            });
                } else {
                    $notesLink.text('(0)');
                    $tasksLink.text('(0)');

                    db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "subject-type" =? AND "subject-name"= ? AND "recording-id" = ? AND status != ? AND status != ? AND status != ?',
                            ['Kase', caseObject.name, getTextTypeObject(caseObject.id.text, 'integer'), "Completed", "Canceled", "Verified"], models.taskDBModel.name, function (data) {
                        $tasksLink.text('(' + data[0]['count(*)'] + ')');
                        self.setConnectionMode();
                    });
                }
                break;
            case TaskType['COMPLETED']:
                if (connection) {
                    ClientAPI.findCount({
                        objectType: "Task",
                        status: {$in: ["Completed", "Canceled", "Verified"]},
                        immediateParent: new ObjectId(caseObject.id.text)
                    },
                            function (err, data) {
                                $tasksLink.text('(' + data + ')');
                                self.setConnectionMode();
                            });
                } else {
                    $notesLink.text('(0)');
                    $tasksLink.text('(0)');
                    db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "subject-type" =? AND "subject-name"= ? AND "recording-id" = ? AND (status = ? OR status = ? OR status = ?) ',
                            ['Kase', caseObject.name, getTextTypeObject(caseObject.id.text, 'integer'), "Completed", "Canceled", "Verified"], models.taskDBModel.name, function (data) {
                        $tasksLink.text('(' + data[0]['count(*)'] + ')');
                        self.setConnectionMode();
                    });
                }
                break;
            case TaskType['MYUPCOMING']:
                if (connection) {
                    var request = {objectType: "Task", immediateParent: new ObjectId(caseObject.id.text)};
                    var myTasksFilter = [{assignedTo: window.localStorage.getItem('userId')}, {
                            assignedTo: {$exists: false},
                            owner: window.localStorage.getItem('userId')
                        }, {assignedTo: {$type: 10}, owner: window.localStorage.getItem('userId')}];
                    var completedTasks = ["Completed", "Canceled", "Verified"];
                    request.$or = myTasksFilter;
                    request.status = {$nin: completedTasks};
                    ClientAPI.findCount(request,
                            function (err, data) {
                                $tasksLink.text('(' + data + ')');
                                self.setConnectionMode();
                            });
                } else {
                    $notesLink.text('(0)');
                    $tasksLink.text('(0)');
                    db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "subject-type" =? AND "subject-name"= ? AND "recording-id" = ? AND status != ? AND status != ? AND status != ? AND "responsible-id" = ?',
                            ['Kase', caseObject.name, getTextTypeObject(caseObject.id.text, 'integer'), "Completed", "Canceled", "Verified", getTextTypeObject(window.localStorage.getItem('userId'), 'integer')], models.taskDBModel.name, function (data) {
                        $tasksLink.text('(' + data[0]['count(*)'] + ')');
                        self.setConnectionMode();
                    });
                }
                break;
            case TaskType['RECENTLYADDED']:
              $tasksLink.text('(' + count + ')');
        }
    };

    self.listScrollLoadEvent = function () {
//		if (($(this).scrollTop() + $(window).height()) >= ($(this).height() - 400)) {
        if (Navigation['CURRENT_POSITION'] == Navigation['TASK_TAB']) {
            var requestObject = {
                objectType: "Task",
                immediateParent: new ObjectId(caseObject.id.text)
            };

            if (TaskType['CURRENT'] == TaskType['UPCOMING']) {
                if (TaskFunctions.drawListParams[listViewId] != null && TaskFunctions.drawListParams[listViewId]) {
                    TaskFunctions.drawListParams[listViewId]['taskType'] = "Upcoming";
                }
            } else if (TaskType['CURRENT'] == TaskType['COMPLETED']) {
                if (TaskFunctions.drawListParams[listViewId] != null && TaskFunctions.drawListParams[listViewId]) {
                    TaskFunctions.drawListParams[listViewId]['taskType'] = "Completed";
                }
            } else if (TaskType['CURRENT'] == TaskType['MYUPCOMING']) {
                var myTasksFilter = [{assignedTo: window.localStorage.getItem('userId')}, {
                        assignedTo: {$exists: false},
                        owner: window.localStorage.getItem('userId')
                    }, {assignedTo: {$type: 10}, owner: window.localStorage.getItem('userId')}];
                requestObject.$or = myTasksFilter;
                TaskFunctions.drawListParams[listViewId]['taskType'] = "MyUpcoming";
            }

            if (TaskFunctions.drawListParams[listViewId]['taskType'] != "Completed") {
                requestObject['status'] = {$nin: ["Completed", "Canceled", "Verified"]};
            } else {
                requestObject['status'] = {$in: ["Completed", "Canceled", "Verified"]};
            }

            var dueDateSort = 1;
            if ("Completed" == TaskFunctions.drawListParams[listViewId]['taskType']) {
                dueDateSort = -1;
            }

            var sort = [
                ["dueDate", dueDateSort],
                ["status", -1]
            ];

            self.listScrollTaskLoad(listViewId, requestObject, sort);

        } else if (Navigation['CURRENT_POSITION'] == Navigation['NOTE_TAB']) {
            var requestObject = {$and: [
                    {objectType: "Note"},
                    {immediateParent: new ObjectId(caseObject.id.text)}
                ]};
            var sort = [
                ["modificationDate", -1]
            ];
            self.listScrollNoteLoad('view-case-notes-list', requestObject, sort);
        }
//		}
    };

    self.listScrollNoteLoad = function (listViewId, query, sort) {
        showLoadingIndikator();
        $(document).off('scrollstop');
        if (connection) {
            ClientAPI.findPaged(query, sort,
                    ViewNoteFunctions.drawListParams[listViewId]['start'] / ViewNoteFunctions.drawListParams[listViewId]['offset'] + 1,
                    ViewNoteFunctions.drawListParams[listViewId]['offset'],
                    function (err, items) {
                        var notes = [];
                        for (var i = 0, max = items.length; i < max; i++) {
                            notes.push(items[i]);
                        }
                        $(document).on('scrollstop', self.listScrollLoadEvent);
                        ViewNoteFunctions.drawNote(listViewId, notes, true);
                    });
        }
    };


    self.listScrollTaskLoad = function (listViewId, query, sort) {
        try {
            showLoadingIndikator();
            if (connection) {
                ClientAPI.findPaged(query, sort,
                        TaskFunctions.drawListParams[listViewId]['start'] / TaskFunctions.drawListParams[listViewId]['offset'] + 1,
                        TaskFunctions.drawListParams[listViewId]['offset'],
                        function (err, items) {
                            var tasks = [];
                            for (var i = 0, max = items.length; i < max; i++) {
                                tasks.push(TaskController.encodeItem(items[i]));
                            }
                            TaskFunctions.drawTaskListView(listViewId, tasks, TaskFunctions.drawListParams[listViewId]['taskType'], true);
                            self.emptyList();
                            self.setConnectionMode();
                        });
            } else {
                if (TaskFunctions.drawListParams[listViewId]['taskType'] != "Completed") {
                    if (TaskFunctions.drawListParams[listViewId]['taskType'] == "MyUpcoming") {
                        var queryStringVal = "SELECT * FROM task WHERE status != ? AND status != ? AND status != ? AND [recording-id] = ? AND [responsible-id] = ? ORDER BY [due-at] LIMIT ?, ?";
                        var queryData = ["Completed", "Canceled", "Verified", getTextTypeObject(query['immediateParent'].val, 'integer'), getTextTypeObject(window.localStorage.getItem('userId'), 'integer'),
                            TaskFunctions.drawListParams[listViewId]['start'], TaskFunctions.drawListParams[listViewId]['offset']];
                        db.selectByQuery(queryStringVal, queryData, 'task', function (items) {
                            TaskFunctions.drawTaskListView(listViewId, items, "Upcoming", true);
                            self.emptyList();
                            self.setConnectionMode();
                        });
                    } else {
                        var queryString = "SELECT * FROM TASK WHERE status != ? AND status != ? AND status != ?  AND [recording-id] = ? ORDER BY [due-at] LIMIT ?, ?";
                        var queryDate = [];
                        queryDate.push("Completed");
                        queryDate.push("Canceled");
                        queryDate.push("Verified");
                        queryDate.push(getTextTypeObject(query['immediateParent'].val, 'integer'));
                        queryDate.push(TaskFunctions.drawListParams[listViewId]['start']);
                        queryDate.push(TaskFunctions.drawListParams[listViewId]['offset']);
                        db.selectByQuery(queryString, queryDate, 'task', function (items) {
                            TaskFunctions.drawTaskListView(listViewId, items, TaskFunctions.drawListParams[listViewId]['taskType'], true);
                            self.emptyList();
                            self.setConnectionMode();
                        });
                    }
                } else {
                    hideLoadingIndikator();
                    self.setConnectionMode();
                }
            }
        } catch (e) {
            console.log("err: ViewCaseFunctions - self.listScrollTaskLoad" + e);
        }
    };

    self.emptyList = function () {
        if (Navigation['CURRENT_POSITION'] == Navigation['NOTE_TAB']) {
            $casesEmptyTaskListMessage.hide();
            if ($('#view-case-notes-list li').length > 0) {
                $casesEmptyNoteListMessage.hide();
            } else {
                $casesEmptyNoteListMessage.show();
            }
        } else if (Navigation['CURRENT_POSITION'] == Navigation['TASK_TAB']) {
            $casesEmptyNoteListMessage.hide();
            if ($('#' + listViewId + " li").length > 0) {
                $casesEmptyTaskListMessage.hide();
            } else {
                $casesEmptyTaskListMessage.show();
            }
        } else if (Navigation['CURRENT_POSITION'] == Navigation['GENERAL_TAB']) {
            $casesEmptyTaskListMessage.hide();
            $casesEmptyNoteListMessage.hide();
        }
    };

    self.drawNotes = function () {
        navigationFix = true;
        if (connection) {
            ViewNoteFunctions.drawListParams['view-case-notes-list'] = {
                'start': 0,
                'offset': offset
            };

            ClientAPI.findPaged({immediateParent: new ObjectId(caseObject.id.text), objectType: "Note"}, [
                ['modificationDate', -1]
            ], 1, offset,
                    function (err, items) {

                        if (!err) {
                            // $('#view-case #view-case-notes-link').text('(' + items.length + ')');
                            var notes = [];
                            for (var i = 0, max = items.length; i < max; i++) {
                                notes.push(items[i]);
                            }
                            ViewNoteFunctions.drawNote('view-case-notes-list', notes, false);
                            hideLoadingIndikator();
                        }
                    });
        } else {
            $notesLink.text('(0)');
            $('#view-case-notes-list').empty();
            self.emptyList();
            hideLoadingIndikator();
        }

        self.setConnectionMode();
    };

    self.addLink = function () {
        ViewContactFunctions.sharedContactForOpen = {};
        openFrom = 'viewCase';
        if (Navigation['CURRENT_POSITION'] == Navigation['NOTE_TAB']) {
            gotoPage({url: "editNote", param: {parentId: caseObject.id.text, parentType: 'project', accessList: caseObject["visible-to"]}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
        } else if (Navigation['CURRENT_POSITION'] == Navigation['TASK_TAB']) {
            gotoPage({url: "editTask", param: {parentId: caseObject.id.text, parentType: 'project', accessList: caseObject["visible-to"]}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
        } else if (Navigation['CURRENT_POSITION'] == Navigation['ATTACH_TAB']) {
            $('#view-case .popup-menu-backdrop').toggle();
            $('#view-case .attach-advanced-menu').css('z-index', '20000');
            $('#view-case .attach-advanced-menu').slideToggle('4000', 'swing');
        }
    };

    self.openTask = function () {
//        if (!tapholdActive) {
        var id = null;
        var ids = [];

        id = $(this).attr('taskId');
        $(document).find("#view-case-tasks-list .task-item").each(function () {
            ids.push($(this).attr('taskId'));
        });

        gotoPage({url: "viewTask", param: {id: id, ids: ids, listParams: TaskFunctions.drawListParams[listViewId]}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});

//        }
    };

    self.openNote = function () {
        var noteId = $(this).attr('note-id');
        gotoPage({url: "viewNote", param: {noteId: noteId}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.editCase = function () {
        gotoPage({url: "editCase", param: {caseId: caseObject.id.text}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.setConnectionMode = function () {
        if (connection) {
            $("#view-case-refresh-link").show();
            $('.upcomingTask', '#view-case').show();
            $('.assignedTask', '#view-case').show();
        } else {
            $("#view-case-refresh-link", '#view-case').hide();
            $('.upcomingTask', '#view-case').hide();
            $('assignedTask', '#view-case').hide();

        }
    };

    self.showNoteComments = function () {
        var noteId = $(this).attr('noteId');
        ViewNoteFunctions.drawCommentList(noteId, function () {
            $('#' + noteId).toggle();
        });
    };

    self.setAsFavorite = function() {
       var isFavorite = $('.md-star').hasClass('contact-favorite-star');
       CaseController.findByObjectId(caseId, function(item){
           if (isFavorite) {
                FavoriteController.findByObjectIdDB(caseId , function(data){
                   if (data[0]) {
                       FavoriteController.removeFavorite(data[0].id, function(){
                           $('.md-star').toggleClass("contact-favorite-star");
                       });
                   }
                });
           } else {
               FavoriteController.save("Case", item, function(){
                   $('.md-star').toggleClass("contact-favorite-star");
               });
           }
       });
   }

    // self.setAsFavorite = function () {
    //     var favorite = false;
    //     var caseIdForRemove = caseId;
    //     if (connection) {
    //         ClientAPI.findSettings({query: {settingType: 'Favorites'}, objectType: 'Case'}, function (e, d) {
    //             var isFavorite = d.filter(function (value) {
    //                 if (caseId == value.refObject._id) {
    //                     favorite = true;
    //                     caseIdForRemove = value._id;
    //                 }
    //             });
    //             if (!favorite) {
    //                 ClientAPI.addSettings({settingType: 'Favorites', refObjectType: 'Case', refObject: caseId}, function (e, d)
    //                 {
    //                     $(".md-star").css('color', '#FECE00');
    //                     $(".md-star").css('-webkit-text-stroke-width', '1px');
    //                     $(".md-star").css('-webkit-text-stroke-color', 'gray');
    //                 });
    //             } else {
    //                 ClientAPI.removeSettings({id: caseIdForRemove}, function (e, d) {
    //                     $(".md-star").css('color', '#999');
    //                 });
    //             }
    //         });
    //     }
    // };

    self.loadItemHistory = function (feedItems) {
        var html = "";
        $("#view-case .history-list").empty();
        for (var i = 0; i < feedItems.length; i++) {
            var eventType = "";
            if (feedItems[i].eventType.toLowerCase() != "statustransition") {
                eventType = feedItems[i].eventType.toLowerCase();
            } else {
                eventType = " changed status of";
            }
            html += "<li>"
                    + "<div style='margin-bottom: 5px;'><b>" + feedItems[i].user_name + "</b> "
                    + eventType + " case"
                    + "</div>";
            if (feedItems[i].allChanges && feedItems[i].eventType != "Create") {
                for (var key in feedItems[i].allChanges) {
                    var descText = "";
                    var entered = false;
                    switch (key) {
                        case "projectName":
                            descText = "Name";
                            entered = true;
                            break;
                        case "projectDescription":
                            descText = "Description";
                            entered = true;
                            break;
                        case "assignedTo":
                            descText = "Assignee";
                            entered = true;
                            break;
                        case "status":
                            descText = "Status";
                            entered = true;
                            break;
                        case "urlList":
                            descText = "Links";
                            entered = true;
                            break;
                        case "immediateParentDisplay":
                            if (feedItems[i].allChanges[key].newValue) {
                                descText = "Related to";
                                entered = true;
                            }
                            break;
                    }
                    if (entered) {
                        if (key == "assignedTo" && feedItems[i].allChanges[key].newValue != "null" && ALL_USERS[feedItems[i].allChanges[key].newValue]) {
                            html += "<div style='margin-bottom: 5px;'>"
                                    + descText + " changed to <span style='color: #2A66D9;'>" + ALL_USERS[feedItems[i].allChanges[key].newValue].name + "</span>"
                                    + "</div>";
                        } else if (key == "urlList") {
                            html += "<div style='margin-bottom: 5px;'>"
                                    + descText + " changed to ";
                            for (var j = 0; j < feedItems[i].allChanges[key].newValue.length; j++) {
                                html += " <span style='color: #2A66D9;'>" + feedItems[i].allChanges[key].newValue[j].url + "</span> ";
                            }
                        } else {
                            html += "<div style='margin-bottom: 5px;'>"
                                    + descText + " changed to <span style='color: #2A66D9; word-break: break-all;'>" + htmlStrip(feedItems[i].allChanges[key].newValue) + "</span>"
                                    + "</div>";
                        }
                    }
                }
                if (feedItems[i].trackedChanges && feedItems[i].trackedChanges.assignedTo) {
                    if (feedItems[i].trackedChanges.assignedTo.oldValue) {
                        html += "<div style='margin-bottom: 5px;'> Old assignee: " + "<b>" + feedItems[i].trackedChanges.assignedTo.oldValue + "</b></div>";
                    }
                    if (feedItems[i].trackedChanges.assignedTo.newValue) {
                        html += "<div style='margin-bottom: 5px;'> New assignee: " + "<b>" + feedItems[i].trackedChanges.assignedTo.newValue + "</b></div>";
                    }
                }
            }
            html += "<div>" + dateFormat(new Date(feedItems[i].eventDate)) + ", " + timeFormat(new Date(feedItems[i].eventDate)) + "h</div>"
                    + "</li>";

        }
        if (html != "") {
            $("#view-case .history-list").append(html);
        }
    };

    self.getAttachmentCount = function (callback) {
        if (connection) {
            ClientAPI.aggregate([{$match:
                            {$or:
                                        [
                                            {_id: new ObjectId(caseObject.id.text)},
                                            {immediateParent: new ObjectId(caseObject.id.text)}
                                        ]
                            }
                },
                {$project:
                            {
                                "fileAttachments": 1,
                                "objectType": 1,
                                "taskName": 1,
                                "note": 1,
                                "projectName": 1
                            }
                }], function (err, data) {
                if (data && data.length > 0) {
                    var attachedElem = data.filter(function (value) {
                        return value.objectType == "Project" || value.objectType == "Note";
                    });
                    var noteList = data.filter(function (value) {
                        return value.objectType == "Note";
                    });

                    $notesLink.text('(' + noteList.length + ')');

                    var attachments = [];
                    var attachCounter = 0;
                    for (var i = 0; i < attachedElem.length; i++) {
                        if (attachedElem[i].fileAttachments && attachedElem[i].fileAttachments.length > 0) {
                            var attachObject = {};
                            attachCounter += attachedElem[i].fileAttachments.length;
                            attachObject.id = attachedElem[i]['_id'];
                            attachObject.files = attachedElem[i].fileAttachments;
                            attachments.push(attachObject);
                        }
                    }
                }
                if (callback && typeof callback == "function") {
                    callback(attachCounter, attachments);
                }

            });
        } else {
            callback();
            $notesLink.text('(0)');
        }
    };

    self.deleteAttachment = function () {
        var fileName = $(this).attr('attachmentName');
        var parentId = $(this).attr('parentId');
        AttachmentController.deleteAttachment(parentId, fileName, ViewCaseFunctions);
    };

    self.takePhoto = function () {
        AttachmentController.takePhoto("#view-case", caseObject.id.text, "#view-case-attach-list", "#view-case-attach-link-text" , ViewCaseFunctions);
    };

    self.chooseFromFileSystem = function () {
        $("#view-case .popup-menu-backdrop").hide();
        gotoPage({url: "fileSystem", param: {parentId: caseObject.id.text, parentType: "Project"}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
    };

    self.openAttachment = function () {
        var url = $(this).attr("url");
        var parentId = $(this).attr('parentId');
        var attachmentName = $(this).attr('attachmentName');
        AttachmentController.openAttachment(url, parentId, attachmentName);
    };

    self.navigateToChildTask = function () {
        var id = $(this).attr('taskId');
        var taskIds = [];
        var $parent = $(this).parent().parent();
        $parent.find('.child-task-item').each(function () {
            taskIds.push($(this).attr('taskId'));
        });
        var currentPage = $parent.attr('data-pageCount');
        currentPage = parseInt(currentPage);
        if(currentPage > 1){
            gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), childPage: currentPage + 1, offset: 30}}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
        } else {
            gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), start: 30, offset: 30}}}, {url: "viewCase", param: {caseId: caseObject.id.text, caseIds: caseIds, listParams: listParams}});
        }
    };

    self.loadChildTaskEvent = function () {
        var taskId = $(this).parent().attr('id');
        var pageCount = $(this).parent().attr('data-pageCount');
        $(this).parent().attr('data-pageCount', ++pageCount);
        var $that = $(this);
        if (connection) {
            TaskFunctions.loadMoreChildTasks(taskId, pageCount, $that);
        }
    };

    return self;
}(ViewCaseFunctions || {}));
