$(document).on('pageinit', '#change-due-date', function () {
    ChangeDueDateFunctions.init();
});

$(document).on('pageshow', '#change-due-date', function () {
    ChangeDueDateFunctions.bindElementControls();
    ChangeDueDateFunctions.setConnectionMode();
});

$(document).on('pagehide', '#change-due-date', function () {
    ChangeDueDateFunctions.unbindElementControls();
});

var ChangeDueDateFunctions = (function (ChangeDueDateFunctions) {
    var self = ChangeDueDateFunctions;
    var id = null;
    var dueDate = null;
    var type = null;
    var $dateTimePicker = null;
    var $dateTimePickerContainer = null;
    var $dueDateMsg = null;
    var $taskFrame = null;
    var $floatButton = null
    var $titleHeader = null;
    var $lableDueDate = null;
    var $messageDueDate = null;
    var $page = null;

    self.init = function () {
        self.initDateTimePicker();
        $dateTimePickerContainer = $("#change-due-date #date-time-picker-container");
        $dateTimePicker = $("#change-due-date #date-time-picker");
        $taskFrame = $("#change-due-date #task-frame-due-date");
        $dueDateMsg = $("#change-due-date #due-date-msg");
        $page = $("#change-due-date");

        $titleHeader = $('#change-due-date .title-h1');
        $lableDueDate = $('#lable-due-date');
        $messageDueDate = $("#due-date-message-box");

        if (pageObject) {
            dueDate = pageObject.dueDate;
            id = pageObject.id;
            type = pageObject.type;
        }
        self.loadDateList();
        self.taskDateEventChange();
        self.changeText();
    };

    self.changeText = function() {
        if (type == "closeDate") {
          $messageDueDate.hide();
          $titleHeader.attr('data-i18n', "task.changeCloseDate");
          $titleHeader.css('text-transform', 'uppercase');
          $titleHeader.i18n();
          $lableDueDate.attr('data-i18n', "task.closeDate");
          $lableDueDate.css('text-transform', 'uppercase');
          $lableDueDate.i18n();
          $page.i18n();
        }
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#due-date-back-link');
        $(document).off('click', '#due-date-save-link');
        $(document).off('click', '#due-date-more-link');
        $(document).off('change', '#change-due-date #task-frame-due-date');
        $('#change-due-date .popup-menu-backdrop').off('click');
        $(document).off('click', '#change-due-date .additional-options');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#due-date-back-link', goBack);
        $(document).on('click', '#due-date-save-link', self.dueDateSaveButton);
        $(document).on('click', '#due-date-more-link', self.openDueDatePopup);
        $(document).on('change', '#change-due-date #task-frame-due-date', self.taskDateEventChange);
        $(document).on('click', '#change-due-date .popup-menu-backdrop', self.hideBackdrop);
        $(document).on('click', '#change-due-date .additional-options', self.dueDateSaveButton);
    };

    self.initDateTimePicker = function () {
        if (navigator.userAgent.match(/(iPad|iPhone)/)) {
            $("#change-due-date #date-time-picker").attr('type', 'datetime-local');
        } else {
            $('#disable-date-time').removeClass("disable-date-time-class");
            $("#change-due-date #date-time-picker").mobiscroll().date({
                theme: 'android',
                display: 'modal',
                mode: 'scroller',
                dateOrder: 'dd MM yy',
                dateFormat: 'dd.mm.yy',
                timeFormat: 'HH:ii',
                timeWheels: 'HH:ii',
                maxDate: new Date(2025, 1, 1),
                minDate: new Date(2010, 1, 1)
            });
        }
    };

    self.loadData = function () {
        var selectDate = "";
        if (navigator.userAgent.match(/(iPad|iPhone)/)) {
            selectDate = dueDate.replace('Z', '');
        } else {
            var date = dueDate.split('T')[0];
            selectDate = date.split("-")[2] + '.' + date.split("-")[1] + '.' + date.split("-")[0];
        }
        $dateTimePicker.val(selectDate);
    };

    self.loadDateList = function () {
        if (dueDate && dueDate != "undefined") {
            var taskDate = new Date(dueDate);
            taskDate.setHours(0, 0, 0, 0);
            var now = new Date();
            now.setHours(0, 0, 0, 0);
            var tomorrow = new Date(now.getTime() + (24 * 60 * 60 * 1000));
            tomorrow.setHours(0, 0, 0, 0);
            var thisWeek = new Date(now.getTime() + (6 - now.getDay()) * 24 * 60 * 60 * 1000);
            thisWeek.setHours(0, 0, 0, 0);
            var nextWeek = new Date(now.getTime() + (24 * 60 * 60 * 1000 * (13 - now.getDay())));
            nextWeek.setHours(0, 0, 0, 0);

            if (taskDate.valueOf() == now.valueOf()) {
                $taskFrame.val("Today").selectmenu().selectmenu("refresh");
            } else if (taskDate.valueOf() == tomorrow.valueOf()) {
                $taskFrame.val("Tomorrow").selectmenu().selectmenu("refresh");
            } else if (taskDate.valueOf() == thisWeek.valueOf()) {
                $taskFrame.val("ThisWeek").selectmenu().selectmenu("refresh");
            } else if (taskDate.valueOf() == nextWeek.valueOf()) {
                $taskFrame.val("NextWeek").selectmenu().selectmenu("refresh");
            } else {
                $taskFrame.val("Specific").selectmenu().selectmenu("refresh");
            }

            var selectDate = "";
            if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                selectDate = dueDate.replace('Z', '');
            } else {
                var date = dueDate.split('T')[0];
                selectDate = date.split("-")[2] + '.' + date.split("-")[1] + '.' + date.split("-")[0];
            }
            $dateTimePicker.val(selectDate);
        } else {
            $taskFrame.val("Later").selectmenu().selectmenu("refresh");
        }
    };

    self.taskDateEventChange = function () {
        var now = new Date();
        var today = new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getDate(), 23, 59, 0, 0);
        if ($taskFrame.val() == 'Specific') {
            $dateTimePickerContainer.show();
        } else {
            $dateTimePickerContainer.hide();
            if ($taskFrame.val() == "Today") {
                $dateTimePicker.val(UtilController.dateToStringMobiScroll(today));
            } else if ($taskFrame.val() == "Tomorrow") {
                var tomorrow = new Date(now.getTime() + (24 * 60 * 60 * 1000));
                tomorrow = new Date(tomorrow.getUTCFullYear(), tomorrow.getUTCMonth(), tomorrow.getDate(), 23, 59, 0, 0);
                $dateTimePicker.val(UtilController.dateToStringMobiScroll(tomorrow));
            } else if ($taskFrame.val() == "ThisWeek") {
                var thisWeek = new Date(now.getTime() + (24 * 60 * 60 * 1000 * (6 - now.getDay())));
                thisWeek = new Date(thisWeek.getUTCFullYear(), thisWeek.getUTCMonth(), thisWeek.getDate(), 23, 59, 0, 0);
                $dateTimePicker.val(UtilController.dateToStringMobiScroll(thisWeek));
            } else if ($taskFrame.val() == "NextWeek") {
                var nextWeek = new Date(now.getTime() + (24 * 60 * 60 * 1000 * (13 - now.getDay())));
                nextWeek = new Date(nextWeek.getUTCFullYear(), nextWeek.getUTCMonth(), nextWeek.getDate(), 23, 59, 0, 0);
                $dateTimePicker.val(UtilController.dateToStringMobiScroll(nextWeek));
            } else if ($taskFrame.val() == "Later") {
                $dateTimePicker.val('');
            }
        }
    };

    self.dueDateSaveButton = function () {
        playSound("www/libs/blop.mp3");
        if (id) {
            if (connection) {
                if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                    var dueAt = new Date($dateTimePicker.val());
                } else {
                    dueAt = new Date(parseInt($dateTimePicker.val().split(".")[2].split(" ")[0]),
                            parseInt($dateTimePicker.val().split(".")[1] - 1),
                            parseInt($dateTimePicker.val().split(".")[0]), 23, 59, 0);
                }
                if (type == "closeDate") {
                  ChangeDueDateController.updateCloseDate(id, dueAt, self.sucessChangeData);
                } else {
                  ChangeDueDateController.updateDueDate(id, dueAt, self.sucessChangeData);
                }

            }
        }
    };
    self.sucessChangeData = function(data) {
      var currentDate = reverseDate(dueDate.split('T')[0]);
      var newDate = getDueDateFormat($dateTimePicker.val());
      if (data != null) {
          var noteText = "User: " + window.localStorage.getItem("userDataName") + " change due date of task from " + currentDate + " to " + newDate;
          if ($dueDateMsg.val()) {
              noteText += " with comment: " + $dueDateMsg.val();
          }
          NoteController.save(noteText, false, id, [], false, null, function () {
              goBack();
          });
      }
    };

    self.openDueDatePopup = function () {
        $('#change-due-date .popup-menu-backdrop').toggle();
        $('#change-due-date .advanced-menu').css('z-index', '20000');
        $('#change-due-date .advanced-menu').slideToggle('4000', 'swing');
    };

    self.hideBackdrop = function () {
        $('#change-due-date .advanced-menu').hide();
        $('#change-due-date .popup-menu-backdrop').hide();
    };

    self.setConnectionMode = function () {
      if (connection) {
        $('#change-due-date .additional-options').show();
      } else {
        $('#change-due-date .additional-options').hide();
      }
    };

    return self;
}(ChangeDueDateFunctions || {}));
