$(document).on('pageinit', '#change-owner', function () {
    ChangeOwnerFunctions.init();
});

$(document).on('pageshow', '#change-owner', function () {
    ChangeOwnerFunctions.bindElementControls();
    ChangeOwnerFunctions.setConnectionMode();
});

$(document).on('pagehide', '#change-owner', function () {
    ChangeOwnerFunctions.unbindElementControls();
});

var ChangeOwnerFunctions = (function (ChangeOwnerFunctions) {
    var self = ChangeOwnerFunctions;
    self.pageObject = null;
    self.item = null;
    self.controller = null;

    var $changeOwner = null;
    var $floatButton = null;
    var $autocompleteResponsible = null;

    self.init = function () {
      showLoadingIndikator();
      self.initVariable();

      if (pageObject && pageObject.id) {
        self.pageObject = pageObject;
        self.controller = self.selectControllerByType(pageObject.type);
        pageObject = null;
      }

      AutoCompleteController.addViewId('autocomplete-responsible', 'autocomplete-responsible-list', 'autocomplete-responsible');
      self.loadDate();
    };

    self.initVariable = function() {
      self.pageObject = null;
      $changeOwner = $("#change-owner");
      $floatButton = $('.float-add-action', $changeOwner);
      $autocompleteResponsible = $('#autocomplete-responsible', $changeOwner);
      $changeOwner.page();
      $changeOwner.i18n();
    };

    self.bindElementControls = function () {
        $(document).on('click', '#change-owner #change-owner-back-link', goBack);
        $(document).on('click', '#change-owner .float-add-action', self.floatButton);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#change-owner #change-owner-back-link');
        $(document).off('click', '#change-owner .float-add-action');
    };

    self.loadDate = function() {
      self.controller.findById(self.pageObject.id, function(data){
        self.item = self.extractData(data);
        self.drawPage();
      });
    };

    self.extractData = function(data) {0
      var item = null;
      debugger;
      if (self.pageObject.type == "Task") {
        if (connection) {
            item = self.controller.encodeItem(data);
        } else {
          item = data[0].task;
        }
      } else if (self.pageObject.type == "Project" || self.pageObject.type == "Case") {
        if (connection) {
            item = self.controller.encodeItem(data);
        } else {
          item = data[0].kase;
        }
      } else if (self.pageObject.type == "Deal") {
        item = data;
      }
      return item;
    };

    self.drawPage = function(data) {
        AutoCompleteController.setObject('responsible', self.item["owner-id"].text);
        $autocompleteResponsible.val(ALL_USERS[self.item["owner-id"].text].name);
        hideLoadingIndikator();
    };


    self.floatButton = function() {
      self.changeOwner(AutoCompleteController.getObject('responsible'));
    };

    self.selectControllerByType = function(type){
        var controller = TaskController;
        if (type == "Task") {
          controller = TaskController;
        } else if (type == "Project" || type == "Case") {
          controller = CaseController;
        } else if (type == "Deal") {
          controller = DealController;
        }
        return controller;
    };

    self.changeOwner = function(ownerId, callback) {
      if (self.pageObject.type == "Task") {
        ClientAPI.changeOwner(self.pageObject.id, JSON.stringify(ownerId), function(err, data){
          ClientAPI.executeTransitionalAction('Assign', self.pageObject.type, self.pageObject.id, {assignedTo: JSON.stringify(ownerId)}, self.callbackData);
        });
      } else {
        ClientAPI.changeOwner(self.pageObject.id, JSON.stringify(ownerId),self.callbackData);
      }
    };

    self.callbackData = function (err, data) {
      if (!err) {
          self.controller.findById(self.pageObject.id, function (data) {
              self.controller.syncPartData(err, [data], function(){
                  goBack();
              });
          });
      } else {
          goBack();
      }
    };

    self.setConnectionMode = function () {
      if (connection) {
        $floatButton.show();
      } else {
        $floatButton.hide();
      }
    };

    return self;
}(ChangeOwnerFunctions || {}));
