$(document).on('pageinit', '#change-permission', function () {
    ChangePermissionFunctions.init();
});

$(document).on('pageshow', '#change-permission', function () {
    ChangePermissionFunctions.bindElementControls();
    ChangePermissionFunctions.setConnectionMode();
});

$(document).on('pagehide', '#change-permission', function () {
    ChangePermissionFunctions.unbindElementControls();
});

var ChangePermissionFunctions = (function (ChangePermissionFunctions) {
    var self = ChangePermissionFunctions;
    self.pageObject = null;
    self.controller = null;
    self.item = null;
    var $changePermission = null;
    var $floatButton = null;

    self.init = function () {
      showLoadingIndikator();
      self.initVariable();
      if (pageObject && pageObject.id) {
        self.pageObject = pageObject;
        pageObject = null;
        self.controller = self.selectControllerByType(self.pageObject.type);
      }
      PermissionController.init('#change-permission');
      AutoCompleteController.init('#change-permission');
      self.loadData();
    };

    self.initVariable = function() {
      self.pageObject = null;
      $changePermission = $("#change-permission");
      $floatButton = $('.float-add-action', $changePermission);
      $changePermission.page();
      $changePermission.i18n();
    };

    self.bindElementControls = function () {
        $(document).on('click', '#change-permission #change-permission-back-link', goBack);
        $(document).on('click', '#change-permission .float-add-action', self.floatButton);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#change-permission #change-permission-back-link');
        $(document).off('click', '#change-permission .float-add-action');
    };

    self.selectControllerByType = function(type) {
        var controller = TaskController;
        if (type == "Task") {
          controller = TaskController;
        } else if (type == "Project" || type == "Case") {
          controller = CaseController;
        } else if (type == "Deal") {
          controller = DealController;
        } else if (type == "Person") {
          controller = PeopleController;
        } else if (type == "Company") {
          controller = CompanyController;
        } else if (type == "Note") {
          controller = NoteController;
        }
        return controller;
    };

    self.loadData = function() {
      self.controller.findById(self.pageObject.id, function(data){
        self.item = self.extractData(data);
        self.drawPage(self.item);
      });
    };

    self.drawPage = function(data) {
        PermissionController.setData(data["visible-to"] || data["accessList"]);
        hideLoadingIndikator();
    };

    self.extractData = function(data) {0
      var item = null;
      if (self.pageObject.type == "Task") {
        if (connection) {
            item = self.controller.encodeItem(data);
        } else {
          item = data[0].task;
        }
      } else if (self.pageObject.type == "Project" || self.pageObject.type == "Case") {
        if (connection) {
            item = self.controller.encodeItem(data);
        } else {
          item = data[0].kase;
        }
      } else if (self.pageObject.type == "Person") {
        if (connection) {
            item = self.controller.encodeItem(data[0]);
        } else {
          item = data[0];
        }
      } else if (self.pageObject.type == "Company") {
        if (connection) {
            item = self.controller.encodeItem(data[0]);
        } else {
          item = data[0].company;
        }
      } else if (self.pageObject.type == "Note") {
        item = data[0];
      } else if (self.pageObject.type == "Deal") {
        item = data;
      }
      return item;
    };


    self.floatButton = function() {
      ClientAPI.updateACL(self.pageObject.id, PermissionController.permission, self.callbackData);
    };

    self.callbackData = function (err, data) {
        if (!err) {
            self.controller.findById(self.pageObject.id, function (data) {
                if (Array.isArray(data)) {
                  data = data[0];
                }
                self.controller.syncPartData(err, [data], function(){
                    goBack();
                });
            });
        } else {
            goBack();
        }
    };

    self.setConnectionMode = function () {
      if (connection) {
        $floatButton.show();
      } else {
        $floatButton.hide();
      }
    };

    return self;
}(ChangePermissionFunctions || {}));
