$(document).on('pageinit', '#change-priority', function () {
    ChangePriorityFunctions.init();
});

$(document).on('pageshow', '#change-priority', function () {
    ChangePriorityFunctions.bindElementControls();
    ChangePriorityFunctions.setConnectionMode();
});

$(document).on('pagehide', '#change-priority', function () {
    ChangePriorityFunctions.unbindElementControls();
});

var ChangePriorityFunctions = (function (ChangePriorityFunctions) {
    var self = ChangePriorityFunctions;
    self.pageObject = null;
    self.item = null;
    var $changePriority = null;
    var $floatButton = null
    var $currentPriorityValue = null;
    var $prioritySelectData = null;

    self.init = function () {
      showLoadingIndikator();
      self.initVariable();
      if (pageObject && pageObject.parentId) {
        self.pageObject = pageObject;
        pageObject = null;
        TaskController.findById(self.pageObject.parentId, self.drawPage);
      } else {
        hideLoadingIndikator();
      }
    };

    self.initVariable = function() {
      self.pageObject = null;
      $changePriority = $("#change-priority");
      $floatButton = $('.float-add-action', $changePriority);
      $currentPriorityValue = $('#priority-value', $changePriority);
      $prioritySelectData = $("#priority-data", $changePriority);
      $changePriority.page();
      $changePriority.i18n();
    };

    self.bindElementControls = function () {
        $(document).on('click', '#change-priority #change-priority-back-link', goBack);
        $(document).on('click', '#change-priority .float-add-action', self.floatButton);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#change-priority #change-priority-back-link');
        $(document).off('click', '#change-priority .float-add-action');
    };

    self.drawPage = function(data) {
        self.item = data;
        var priority = self.extractPriority(data);
        $currentPriorityValue.html(priority);
        $prioritySelectData.val(priority).selectmenu('refresh');
        hideLoadingIndikator();
    };

    self.extractPriority = function(data) {
      var priority = "Normal";
      if (connection) {
        priority = data.taskPriority;
      } else {
        if (data && data[0]) {
            if (data[0]['task']) {
              priority = data[0]['task']['priority'];
            }
        }
      }
      return priority;
    };

    self.floatButton = function() {
        showLoadingIndikator();
        debugger;
        if (self.item) {
            self.item.taskPriority = $prioritySelectData.val();
            ChangePriorityController.updatePriority(self.item, function(data) {
                hideLoadingIndikator();
                goBack();
            });
        } else {
          hideLoadingIndikator();
        }
    };

    self.setConnectionMode = function () {
      if (connection) {
        $floatButton.show();
      } else {
        $floatButton.hide();
      }
    };

    return self;
}(ChangePriorityFunctions || {}));
