$(document).on('pageinit', '#change-progress', function () {
    ChangeProgressFunctions.init();
});

$(document).on('pageshow', '#change-progress', function () {
    ChangeProgressFunctions.bindElementControls();
    ChangeProgressFunctions.setConnectionMode();
});

$(document).on('pagehide', '#change-progress', function () {
    ChangeProgressFunctions.unbindElementControls();
});

var ChangeProgressFunctions = (function (ChangeProgressFunctions) {
    var self = ChangeProgressFunctions;
    self.pageObject = null;
    self.item = null;
    var $changeProgress = null;
    var $slider = null;
    var $floatButton = null;
    self.percentCompleted = 0;
    self.init = function () {
      showLoadingIndikator();
      self.initVariable();
      $changeProgress.page();
      if (pageObject && pageObject.parentId) {
        self.pageObject = pageObject;
        pageObject = null;
        TaskController.findById(self.pageObject.parentId, self.drawPage);
      } else {
        hideLoadingIndikator();
      }
    };

    self.initVariable = function() {
      self.pageObject = null;
      self.percentCompleted = 0;
      $changeProgress = $("#change-progress");
      $slider = $("#change-progress #slider-percent");
      $floatButton = $('#change-progress .float-add-action');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#change-progress #change-progress-back-link', goBack);
        $(document).on('click', '#change-progress .float-add-action', self.floatButton);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#change-progress #change-progress-back-link');
        $(document).off('click', '#change-progress .float-add-action');
    };

    self.drawPage = function(data) {
        self.extractPercentCompleted(data);
        if (self.percentCompleted) {
          self.item = data;
          $slider.val(self.percentCompleted).slider('refresh');
        }
        hideLoadingIndikator();
    };

    self.extractPercentCompleted = function(data){
      if (connection) {
        self.percentCompleted = data.percentCompleted;
      } else {
        if (data && data[0]) {
            if (data[0]['task']) {
              self.percentCompleted = data[0]['task']['percent-completed'];
            }
        }
      }
    };

    self.floatButton = function() {
        showLoadingIndikator();
        if (self.item) {
            self.item.percentCompleted = $slider.val();
        }
        ChangeProgressController.updatePercentCompletion(self.item, function(data){
            hideLoadingIndikator();
            goBack();
        });
    };

    self.setConnectionMode = function () {
      if (connection) {
        $floatButton.show();
      } else {
        $floatButton.hide();
      }
    };

    return self;
}(ChangeProgressFunctions || {}));
