$(document).on('pageinit', '#change-status', function () {
    ChangeStatusFunctions.init();
});

$(document).on('pageshow', '#change-status', function () {
    ChangeStatusFunctions.bindElementControls();
    //showLoadingIndikator();
    if (!connection) {
        $('#' + $.mobile.activePage.attr('id') + ' #comment-delete-link').hide();
        $('#' + $.mobile.activePage.attr('id') + ' #comment-save-link').hide();
        $("#change-status .delete-item").hide();
    }
});

$(document).on('pagehide', '#change-status', function () {
    ChangeStatusFunctions.unbindElementControls();
});

var ChangeStatusFunctions = (function (ChangeStatusFunctions) {
    var self = ChangeStatusFunctions;

    var $changeStatusBody = null;
    var parentId = null;
    var parentType = null;
    var statusText = null;
    var taskObject = null;
    var parentVisibility = null;
    var changeToComplete = null;
    var status = null;

    self.init = function () {
        $("#change-status").page();
        $changeStatusBody = $('#change-status-body');
        AutoCompleteController.init('#change-status');
        AutoCompleteController.addViewId('new-owner', 'new-owner-list', 'new-owner');
        if (pageObject) {
            parentId = pageObject.parentId;
            parentType = pageObject.parentType;
            parentVisibility = pageObject.parentVisibility;
            changeToComplete = pageObject.toComplete;
            status = pageObject.status;
            if (parentType == "Deal") {
                $("#change-status #deal-status-options").show();
                $("#change-status #case-status-options").hide();
                $("#change-status #task-status-options").hide();
            } else if (parentType == "Project") {
                $("#change-status #case-status-options").show();
                $("#change-status #deal-status-options").hide();
                $("#change-status #task-status-options").hide();
                $("#change-status #case-status-value").i18n();
                $("#change-status #case-status-value").selectmenu().selectmenu('refresh');
            } else if (parentType == "Task") {
                $("#change-status #task-status-options").show();
                $("#change-status #deal-status-options").hide();
                $("#change-status #case-status-options").hide();
            }
            if (parentType == "Task") {
                if (connection) {
                    ClientAPI.find({objectType: {$in: ['Task']}, _id: new ObjectId(parentId)}, null, function (err, data) {
                        if (data != null && data.length > 0) {
                            taskObject = TaskController.encodeItem(data[0]);
                            self.changeTaskDropDownList();
                            statusText = $("#change-status #task-status-value").val();
                            $("#change-status .reassigned-container").hide();
                        }
                    });
                }
            } else if (parentType == "Deal") {
                self.changeDealDropDownList();
                statusText = $("#change-status #deal-status-value").val();
                $("#change-status .reassigned-container").hide();
            } else if (parentType == "Project") {
                self.changeCaseDropDownList();
                statusText = $("#change-status #case-status-value").val();
                $("#change-status .reassigned-container").hide();
            }
            pageObject = null;
            hideLoadingIndikator();
        }
    };

    self.bindElementControls = function () {
        $(document).on('click', '#change-status-back-link', goBack);
        $(document).on('click', '#change-status-more-link', self.openEditCommentPopup);
        $(document).on('click', "#change-status-save-link", self.saveChangeStatus);
        $(document).on('change', "#change-status #deal-status-value", self.changeDealOption);
        $(document).on('change', "#change-status #case-status-value", self.changeCaseOption);
        $(document).on('change', '#change-status #task-status-value', self.changeTaskOption);
        $('#change-status .popup-menu-backdrop').on('click', function () {
            $('#change-status .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#change-status .additional-options', self.saveChangeStatus);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#change-status-back-link');
        $(document).off('click', '#change-status-more-link');
        $(document).off('click', "#change-status-save-link");
        $(document).off('change', "#change-status #deal-status-value");
        $(document).off('change', "change-status #case-status-value");
        $(document).off('change', '#change-status #task-status-value');
        $('#change-status .popup-menu-backdrop').off('click');
        $(document).off('click', '#change-status .additional-options');
        parentId = null;
        parentType = null;
        statusText = null;
        taskObject = null;
        changeToComplete = null;
    };

    self.saveChangeStatus = function () {
        playSound("www/libs/blop.mp3");
        $(this).addClass('not-clickable');
        if (connection) {
            showLoadingIndikator();
            var additionalOptions = null;
            if (statusText == "Assign") {
                var responsibleId = AutoCompleteController.getObject('responsible');
                if (typeof responsibleId === "number") {
                    responsibleId = JSON.stringify(responsibleId);
                }
                additionalOptions = {assignedTo: responsibleId};
            }
            if(parentType == "Task"){
                parentVisibility = taskObject['visible-to'];
            }
            ClientAPI.executeTransitionalAction(statusText, parentType, parentId, additionalOptions, function (err, data) {
                if (!err) {
                    var type = parentType;
                    if(parentType == "Project"){
                        type = "Case";
                    }
                    var newNote = 'Status of ' + type + ' has been changed to <b> ' + statusText + '</b> by user ' + window.localStorage.getItem('userDataName');
                    if ($changeStatusBody.val() != "") {
                        newNote += ' with comment: ' + $changeStatusBody.val();
                    }
                    NoteController.save(newNote, parentVisibility, parentId, [], false, null, function (data) {
                    });
                    switch (parentType) {
                        case "Task":
                            if (statusText == "Complete") {
                                TaskController.updatePercentCompletion(parentId, function (data) {
                                    if (data) {
                                        TaskController.findById(parentId, function (data) {
                                            TaskController.syncPartData(err, [data], function () {
                                                goBack();
                                            });
                                        });
                                    }
                                });
                            } else {
                                TaskController.findById(parentId, function (data) {
                                    TaskController.syncPartData(err, [data], function () {
                                        goBack();
                                    });
                                });
                            }
                            break;
                        case "Deal":
                            DealController.findById(parentId, function (data) {
                                var deal = null;
                                if (data[0]) {
                                    deal = DealController.encodeItem(data[0]);
                                    DealController.syncPartData(null, data, function () {
                                        goBack();
                                    });
                                } else {
                                    deal = data;
                                    DealController.syncPartData(null, data, function () {
                                        goBack();
                                    });
                                }
                            });
                            break;
                        case "Project":
                            CaseController.findById(parentId, function (data) {
                                CaseController.syncPartData(err, [data], function (data) {
                                    goBack();
                                });
                            });
                            break;
                    }
                }
            });
        } else {
            alert("Unable to change status in offline mode!");
        }
    };

    self.changeDealOption = function () {
        statusText = $(this).val();
        $changeStatusBody.val("");
    };

    self.changeCaseOption = function () {
        statusText = $(this).val();
        $changeStatusBody.val("");
    };

    self.changeTaskOption = function () {
        statusText = $(this).val();
        if (statusText == "Assign") {
            self.getCurrentOwnerOfTask();
            $("#change-status .reassigned-container").show();
        } else {
            $("#change-status .reassigned-container").hide();
        }
        $changeStatusBody.val("");
    };

    self.setStatus = function () {
        switch (parentType) {
            case "Deal":
                statusText = $("#change-status #deal-status-value").val();
                $("#change-status .reassigned-container").hide();
                break;
            case "Project":
                statusText = $("#change-status #case-status-value").val();
                $("#change-status .reassigned-container").hide();
                break;
        }

    };

    self.openEditCommentPopup = function () {
        $('#change-status .popup-menu-backdrop').toggle();
        $('#change-status .advanced-menu').css('z-index', '20000');
        $('#change-status .advanced-menu').slideToggle('4000', 'swing');
    };


    self.getCurrentOwnerOfTask = function () {
        if (taskObject && taskObject['responsible-id'] && taskObject["responsible-id"].text && ALL_USERS[taskObject["responsible-id"].text]) {
            var oldOwner = ALL_USERS[taskObject["responsible-id"].text].name;
            $("#change-status #old-owner-container").show();
            $("#change-status #old-owner").text(oldOwner);
        } else {
            $("#change-status #old-owner-container").hide();
        }
    };

    self.changeTaskDropDownList = function () {
        if (taskObject.status.toLowerCase() == "completed") {
            $("#change-status #task-status-value").empty().append("<option value='Cancel' data-i18n='changeStatus.cancel'></option>")
                    .append("<option value='Reopen' data-i18n='changeStatus.reopen'></option>")
                    .append("<option value='Verify' data-i18n='changeStatus.verified'></option>");
        } else if (taskObject.status.toLowerCase() == "inprogress") {
            $("#change-status #task-status-value").empty().append("<option value='Complete' data-i18n='changeStatus.complete'></option>")
                    .append("<option value='Cancel' data-i18n='changeStatus.cancel'></option>")
                    .append("<option value='Pending-Waiting' data-i18n='changeStatus.wait'>");
        } else if (taskObject.status.toLowerCase() == "canceled") {
            $("#change-status #task-status-value").empty().append("<option value='Reopen' data-i18n='changeStatus.reopen'></option>");
        } else if (taskObject.status.toLowerCase() == "verified"){
            $("#change-status #task-status-value").empty().append("<option value='Reopen' data-i18n='changeStatus.reopen'></option>");
        } else if (taskObject.status.toLowerCase() == "waiting") {
            $("#change-status #task-status-value").empty().append("<option value='Start' data-i18n='changeStatus.start'></option>")
                    .append("<option value='Assign' data-i18n='changeStatus.assign'></option>")
                    .append("<option value='Complete' data-i18n='changeStatus.complete'></option>")
                    .append("<option value='Pending-Waiting' data-i18n='changeStatus.cancel'>");
        } else {
            $("#change-status #task-status-value").empty().append("<option value='Start' data-i18n='changeStatus.start'></option>")
                    .append("<option value='Assign' data-i18n='changeStatus.assign'></option>")
                    .append("<option value='Complete' data-i18n='changeStatus.complete'></option>")
                    .append("<option value='Pending-Waiting' data-i18n='changeStatus.wait'>");
        }
        if (changeToComplete != null && changeToComplete == "yes") {
            $("#change-status #task-status-value").empty().append("<option value='Complete' data-i18n='changeStatus.complete'></option>");
        }
        $('#change-status #task-status-value').i18n();
        $('#change-status #task-status-value').selectmenu().selectmenu('refresh');
    };

    self.changeDealDropDownList = function () {
        if (status.toLowerCase() == "negotiation") {
            $("#change-status #deal-status-value").empty().append("<option value='ProposalSent' data-i18n='changeStatus.proposalSent'></option>")
                    .append("<option value='Won' data-i18n='changeStatus.won'></option>")
                    .append("<option value='Lost' data-i18n='changeStatus.lost'></option>")
                    .append("<option value='Inactive' data-i18n='changeStatus.inactive'></option>");
        } else if (status.toLowerCase() == "proposalsent") {
            $("#change-status #deal-status-value").empty().append("<option value='Won' data-i18n='changeStatus.won'></option>")
                    .append("<option value='Lost' data-i18n='changeStatus.lost'></option>")
                    .append("<option value='Inactive' data-i18n='changeStatus.inactive'></option>");
        } else if (status.toLowerCase() == "pending") {
            $("#change-status #deal-status-value").empty().append("<option value='Prospecting' data-i18n='changeStatus.prospecting'></option>")
                    .append("<option value='Analyses' data-i18n='changeStatus.analyses'></option>")
                    .append("<option value='Negotiation' data-i18n='changeStatus.negotiation'></option>")
                    .append("<option value='ProposalSent' data-i18n='changeStatus.proposalSent'></option>")
                    .append("<option value='Won' data-i18n='changeStatus.won'></option>")
                    .append("<option value='Lost' data-i18n='changeStatus.lost'></option>")
                    .append("<option value='Inactive' data-i18n='changeStatus.inactive'></option>");
        } else if (status.toLowerCase() == "prospecting") {
            $("#change-status #deal-status-value").empty().append("<option value='Analyses' data-i18n='changeStatus.analyses'></option>")
                    .append("<option value='Negotiation' data-i18n='changeStatus.negotiation'></option>")
                    .append("<option value='ProposalSent' data-i18n='changeStatus.proposalSent'></option>")
                    .append("<option value='Won' data-i18n='changeStatus.won'></option>")
                    .append("<option value='Lost' data-i18n='changeStatus.lost'></option>")
                    .append("<option value='Inactive' data-i18n='changeStatus.inactive'></option>");
        } else if (status.toLowerCase() == "analyses") {
            $("#change-status #deal-status-value").empty().append("<option value='ProposalSent' data-i18n='changeStatus.proposalSent'></option>")
                    .append("<option value='Negotiation' data-i18n='changeStatus.negotiation'></option>")
                    .append("<option value='Won' data-i18n='changeStatus.won'></option>")
                    .append("<option value='Lost' data-i18n='changeStatus.lost'></option>")
                    .append("<option value='Inactive' data-i18n='changeStatus.inactive'></option>");
        } else if (status.toLowerCase() == "won" || status.toLowerCase() == "lost") {
            $("#change-status #deal-status-value").empty().append("<option value='Negotiation' data-i18n='changeStatus.negotiation'></option>")
                    .append("<option value='Inactive' data-i18n='changeStatus.inactive'></option>");
        } else if (status.toLowerCase() == "inactive") {
            $("#change-status #deal-status-value").empty().append("<option value='Pending' data-i18n='changeStatus.pending'></option>");
        }
        $('#change-status #deal-status-value').i18n();
        $('#change-status #deal-status-value').selectmenu().selectmenu('refresh');
    };

    self.changeCaseDropDownList = function () {
        if (status.toLowerCase() == "closed") {
            $("#change-status #case-status-value").empty().append("<option value='Reopen' data-i18n='changeStatus.reopen'></option>");
        } else if (status.toLowerCase() == "inprogress" || status.toLowerCase() == "created") {
          var html = "<option value='Start' data-i18n='changeStatus.start'></option>";
              html += "<option value='Close' data-i18n='changeStatus.close'></option>";
            $("#change-status #case-status-value").empty().append(html);
        }
        $('#change-status #case-status-value').i18n();
        $('#change-status #case-status-value').selectmenu().selectmenu('refresh');

    };

    return self;
}(ChangeStatusFunctions || {}));
