$(document).on('pageinit', '#contacts', function () {
    ContactFunctions.init();
    sharedCaseForOpen = null;
});

$(document).on('pageshow', '#contacts', function () {
    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
        $("#call-list-link").remove();
    }

    if (ViewContactFunctions.sharedContactForOpen != null && ViewContactFunctions.sharedContactForOpen.item) {
        ViewContactFunctions.sharedContactForOpen.item = null;
    }
    if (syncAllConnectionCheck) {
        syncAllConnectionCheck = false;
    }
    ContactFunctions.bindElementControls();
    ContactFunctions.setConnectionMode();
});

$(document).on('pagehide', '#contacts', function () {
    ContactFunctions.unbindElementControls();
});


var ContactFunctions = (function (ContactFunctions)
{
    var self = ContactFunctions;
    self.findTime = null;
    var $contactList = null;
    var $recentList = null;
    var $addContactMenu = null;
    var $phoneContacts = null;
    var $emptyRecent = null;
    var $emptyContact = null;
    var $contactPage = null;
    var table = 'task';
    var $filterContacts = null;
    var CONTACT_LIST = {RECENT: 0, PEOPLE: 1, COMPANY: 2, PHONE: 3, FAVORITE:4, CUSTOM_FILTER:5};
    var currentContactList = null;
    self.sharedContactForOpen = {};
    self.drawListParams = [];
    self.findTime = null;
    var SCROLL_START = 1;

    var listViewId = 'contact-list';
    var parentIdForPhoneContact = null;
    var accessListForPhoneContact = null;
    var defaultFilterValue = null;
    var listType = null;
    var favoriteMapData = null;


    self.init = function () {
        VisibleDomainController.hide("contacts");
        //hide call list option for iOS devices
        removeCallListForIOS("main-nav-list", "contacts", "call-list-link");
        $contactList = $('#contact-list');
        $recentList = $('#recent-list');
        $addContactMenu = $('#add-contact-menu');
        $recentList = $("#recent-list");
        $emptyRecent = $("#empty-recent");
        $phoneContacts = $('#phone-contacts');
        $emptyContact = $('#contacts-list-message');
        $filterContacts = $("#filter-contacts");
        $contactPage = $("#contacts");
        if (pageObject) {
            parentIdForPhoneContact = pageObject.phoneContactParentId;
            accessListForPhoneContact = pageObject.phoneContactParentAccessList;
            defaultFilterValue = pageObject.filterVal;
        }
        pageObject = null;
        if (defaultFilterValue) {
            $filterContacts.val(defaultFilterValue);
        }
        $contactList.empty();
        self.filterContacts();
        NavigationController.loadUserInfo('contacts');
        FavoriteController.findAllMapByTypes(["Company", "Person"],function(favoriteMap){
            favoriteMapData = favoriteMap;
        });
        self.addMoreFilter("filter-contacts");
    };

    self.bindElementControls = function () {
        $(document).on('click', '#dashboard-link', self.dashboardLinkEvent);
        $(document).on('click', '#case-link', self.caseLinkEvent);
        $(document).on('click', '#deals-link', self.dealsLinkEvent);
        $(document).on('click', '#close-link', self.closeLinkEvent);
        $(document).on('click', '#tasks-link', self.tasksLinkEvent);
        $(document).on('click', '#settings-link', self.settingsLinkEvent);
        $(document).on('click', '#drafts-link', self.draftLinkEvent);
        $(document).on('click', '#add-person', self.addPerson);
        $(document).on('click', '#add-company', self.addCompany);
        $(document).on('click', '#fav-container .contact-task-icon', self.taskContactItemEvent);
        $(document).on('click', '#fav-container .contact-deal-icon', self.dealContactItemEvent);
        $(document).on('click', '#fav-container .contact-note-icon', self.contactContactItemEvent);
        $(document).on('click', '#fav-container .contact-call-icon', self.callContactItemEvent);
        $(document).on('click', '#fav-container .contact-mail-icon', self.mailContactItemEvent);
        $(document).on('click', '#fav-container .contact-sms-icon', self.smsContactItemEvent);
        $(document).on('click', '#menu-link', self.menuLinkEvent);

        $(document).on('click', '#mygroup-link', self.myGroupLinkEvent);
        $(document).on('click', '.contact-user', self.callEvent);
        $(document).on('click', '#contact-list .contact', self.contactListEvent);
        $(document).on('click', '#add-contact-from-qrcode', self.addContactUsingQRCode);
        $("input", '#contacts').on('input', self.contactsInputEvent);
        $(document).on('click', '#contacts-link', self.menuLinkEvent);
        $(document).on('click', '#contacts .ui-input-clear', self.filterContacts);
        $(document).on('click', '#recent-list .contact', self.contactListEvent);
        $(document).on('click', '#add-all-contacts-from-phone', self.addAllContactsFromPhone);
        $("#contacts").on('click', '#contacts .ui-input-clear', self.contactsInputDeleteAllEvent);
        $('#filter-contacts', '#contacts').on('change', self.filterContacts);
        $(document).on('click', '.phone-contact', self.openPhoneContact);
        $(document).on('click', '#add-new-contact-from-phone', self.openPhoneContacts);
        $(document).on('click', '#contacts #call-list-link', self.openCallList);
        $(document).on('click', '#contacts #about-link', self.gotoAbout);
        $("#contacts .app-user").on('click', self.gotoProfilPage);
        $("#contacts .domain-link-info").on('click', self.gotoDomainPage);
        $("#contacts").on('click', '.favorite-event', self.eventFavorite);

        $('#contacts .float-add-action').on('click', function () {
            $(this).toggleClass("rotation-event");
            $('#contacts .popup-menu-backdrop').toggle();
            $('#contacts .menu-more-option').toggle();
        });

        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });

        $('body').on('submit', function (event) {
            event.preventDefault(); // cancel default form submit
            event.stopPropagation();
            return false;
        });

        $('.backdrop').on('click', function () {
            $('html').removeClass('sidebar-left-in');
        });

        $('#contacts .popup-menu-backdrop').on('click', function () {
            $('#contacts .menu-more-option').hide();
            $("#contacts .float-add-action").removeClass("rotation-event");
            $(this).hide();
        });

        $("body").on('swipeleft', "#contacts .sidebar", function () {
            if ($("html").hasClass("sidebar-left-in")) {
                $("html").removeClass("sidebar-left-in");
            }

        });

        $(document).on("click", "#contacts #app-calendar", function(){
            gotoPage({url: "calendar", param: null}, {url: "contacts", param: null});
        });

        $(document).on('click', '#overview-link', self.overviewLinkEvent);

    };

    self.unbindElementControls = function () {
        $(document).off('click', '#dashboard-link');
        $(document).off('click', '#case-link');
        $(document).off('click', '#deals-link');
        $(document).off('click', '#close-link');
        $(document).off('click', '#tasks-link');
        $(document).off('click', '#mygroup-link');
        $(document).off('click', '#settings-link');
        $(document).off('click', '#drafts-link');
        $(document).off('click', '#menu-link');
        $(document).off('click', '#contacts-link');

        $(document).off('click', '#recent-list .contact');
        $('#filter-contacts', '#contacts').off('change');
        $(document).off('click', '#add-person');
        $(document).off('click', '#add-company');
        $(document).off('click', '#fav-container .contact-task-icon');
        $(document).off('click', '#fav-container .contact-deal-icon');
        $(document).off('click', '#fav-container .contact-note-icon');
        $(document).off('click', '#fav-container .contact-call-icon');
        $(document).off('click', '#fav-container .contact-mail-icon');
        $(document).off('click', '#fav-container .contact-sms-icon');
        $(document).off('click', '.contact-user');
        $(document).off('click', '#overview-link');
        $(document).off('click', '#add-contact-from-qrcode');
        $("input", '#contacts').off('input');
        $(document).off('click', '#contacts .ui-input-clear');
        $(document).off('click', '#recent-list li a');
        $(document).off('click', '#contact-list li a');
        $(document).off('click', '#add-all-contacts-from-phone');
        $(document).off('click', '.phone-contact');
        $(document).off('click', '#add-new-contact-from-phone');
        $('#contacts .float-add-action').off('click');
        $(document).off('click', '#contacts #call-list-link');
        $(document).off('click', '#contacts #about-link');
        $("#contacts .app-user").off('click');
        $("#contacts .domain-link-info").off('click');
        $("#contacts .domain-link-info").off('click');
        $("#contacts .favorite-event").off('click');

        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
        $(document).off('click', '#contact-list .contact');
        $('.backdrop').off('click');
        $('#contacts .popup-menu-backdrop').off('click');
        $("body").off('swipeleft', "#contacts .sidebar");
        $('html').removeClass('sidebar-left-in');
        $(document).off("click", "#contacts #app-calendar");
        parentIdForPhoneContact = null;
        accessListForPhoneContact = null;
        defaultFilterValue = null;
    };

    self.overviewLinkEvent = function () {
        gotoPage({url: "overview", param: null});
    };

    self.gotoDomainPage = function () {
        gotoPage({url: "domain", param: null}, {url: "contacts", param: null});
    };

    self.gotoProfilPage = function(){
      gotoPage({url: "editProfil", param: null}, {url: "contacts", param: null});
    };

    self.gotoAbout = function () {
        gotoPage({url: "about", param: null}, {url: "contacts", param: null});
    };

    self.openCallList = function () {
        gotoPage({url: "callLog", param: null}, {url: "contacts", param: null});
    };

    self.settingsLinkEvent = function () {
        gotoPage({url: "settings", param: null}, {url: "contacts", param: null});
    };

    self.openPhoneContacts = function () {
        $('#contacts .popup-menu-backdrop').hide();
        $('#contacts .additional-options').hide();
        $('#contacts .float-add-action').show();
        $filterContacts.val('filter-phone-contacts');
        self.filterContacts();
    };

    self.addMoreFilter = function(id){
      var $filterElement = $("#" + id);
      if ($filterElement) {
        ContactsController.findAllFilters(function(items){
          items.forEach(function(element, index){
            $filterElement.append('<option value="filter-custom-' + index + '" filter=\''+ element.settingData.filterQuery +'\'>' + element.settingData.filterName + '</option>');
          });
        });
      }
    };

    self.filterContacts = function () {
        SCROLL_START = 1;
        FavoriteController.findAllMapByTypes(["Company", "Person"], function(favoriteMap){
            favoriteMapData = favoriteMap;
        });

        var filterValue = $filterContacts.find('option:selected').val();
        var ogrFilterValue = filterValue;
        if (filterValue && filterValue.startsWith('filter-custom')) {
           filterValue = "filter-custom";
        }

        switch (filterValue) {
            case "filter-recent-contacts":
                $filterContacts.val("filter-recent-contacts").attr('selected', 'selected');
                currentContactList = CONTACT_LIST.RECENT;
                isRecentContact = true;
                if ($("#contacts input").val().length > 0) {
                    self.contactsInputEvent();
                } else {
                    self.contactsShowRecentListEvent();
                }
                break;
            case "filter-people-contacts":
                $filterContacts.val("filter-people-contacts").attr('selected', 'selected');
                currentContactList = CONTACT_LIST.PEOPLE;
                isRecentContact = false;
                if ($("#contacts input").val().length > 0) {
                    self.contactsInputEvent();
                } else {
                    self.showPeople();
                }
                break;
            case "filter-companies-contacts":
                $filterContacts.val("filter-companies-contacts").attr('selected', 'selected');
                currentContactList = CONTACT_LIST.COMPANY;
                isRecentContact = false;
                if ($("#contacts input").val().length > 0) {
                    self.contactsInputEvent();
                } else {
                    self.showCompanies();
                }
                break;
            case "filter-phone-contacts":
                isRecentContact = false;
                $filterContacts.val("filter-phone-contacts").attr('selected', 'selected');
                currentContactList = CONTACT_LIST.PHONE;
                if ($("#contacts input").val().length > 0) {
                    self.contactsInputEvent();
                } else {
                    self.showPhoneContact();
                }

                break;
            case "filter-favorite-contacts":
                isRecentContact = false;
                $filterContacts.val("filter-favorite-contacts").attr('selected', 'selected');
                currentContactList = CONTACT_LIST.FAVORITE;
                if ($("#contacts input").val().length > 0) {
                    self.contactsInputEvent();
                } else {
                    self.showFavorites();
                }

                break;
          case "filter-custom":
                isRecentContact = false;
                currentContactList = CONTACT_LIST.CUSTOM_FILTER;
                if ($("#contacts input").val().length > 0) {
                    self.contactsInputEvent();
                } else {
                    self.showCustomFilter();
                }
                $filterContacts.val(ogrFilterValue).attr('selected', 'selected');
                break;
            default:
                $filterContacts.val("filter-recent-contacts").attr('selected', 'selected');
                currentContactList = CONTACT_LIST.RECENT;
                isRecentContact = true;
                if ($("#contacts input").val().length > 0) {
                    self.contactsInputEvent();
                } else {
                    self.contactsShowRecentListEvent();
                }
                break;
        }
        $filterContacts.i18n();
        $filterContacts.selectmenu('refresh', true);
    };

    self.showCustomFilter = function () {
        if (connection) {
          var request = JSON.parse($filterContacts.find(":selected").attr('filter'));
          ContactsController.findCustomContact(request, function(items){
              var contacts = [];
              for (var i = 0, max = items.length; i < max; i++) {
                  contacts.push(self.checkFavorite(items[i]));
              }
              contacts.sort(sortContact);
              self.drawContact('contact-list', contacts, false);
              $recentList.hide();
          });
        }
    };


    function sortContact(a, b) {
        var name1, name2;

        if (a["objectType"] == "company" || a["objectType"] == "Company") {
            name1 = a["name"];
        } else {
            name1 = a["first-name"] + " " + a["last-name"];
        }
        if (b["objectType"] == "company" || b["objectType"] == "Company") {
            name2 = b["name"];
        } else {
            name2 = b["first-name"] + " " + b["last-name"];
        }

        return name1.localeCompare(name2);

    }

    self.eventFavorite = function(e){
        var isFavorite = $(this).hasClass("contact-favorite-star");
        var contactId  = $(this).parent().attr('contactid');
        var objectType = $(this).parent().attr('type');
        var objectSubtype = $(this).parent().attr('subtype');
        var controller = PeopleController;

        if (objectType) {
            objectType = objectType[0].toUpperCase() + objectType.slice(1, objectType.length);
        }

        if ("Company" == objectType) {
            controller = CompanyController;
        } else if ("Person" == objectType) {
            if (objectSubtype) {
               controller = PhoneContactController
               objectType = objectSubtype;
            }
        }

        controller.findById(contactId, function(item){
          var favoriteContactData;
          if (!connection && objectType == "Company") {
            favoriteContactData = item[0][objectType.toLocaleLowerCase()];
          } else {
            favoriteContactData = item[0];
          }
          self.partionEventFavorite(isFavorite, objectType, favoriteContactData);
        });

        $(this).toggleClass("contact-favorite-star");
        e.stopPropagation();
    }

    self.partionEventFavorite = function(isFavorite, objectType, item, callback){
        if (isFavorite) {
             FavoriteController.findByObjectIdDB(item._id || item.id.text , function(data){
                if (data[0]) {
                    if (objectType == "PhoneNumber") {
                       FavoriteController.removeFavoriteDB(data[0].id, callback);
                    } else {
                        FavoriteController.removeFavorite(data[0].id, callback);
                    }
                }
             });
        } else {
            if (item.company) {
                item = item.company;
            }
            FavoriteController.save(objectType, item, callback);
        }
    }

    self.showPeople = function () {
        if (connection) {
            ClientAPI.findPaged({query: {objectType: "Person", identity_id: {$exists: false}}, page: 1, pageSize: offset, objectType: "Person", population: "companies.company"}, function (err, items) {
                var contacts = [];
                for (var i = 0, max = items.length; i < max; i++) {
                    contacts.push(self.checkFavorite(PeopleController.encodeItem(items[i])));
                }
                contacts.sort(sortContact);
                self.drawContact('contact-list', contacts, false);
                $recentList.hide();
            });
        } else {
           db.selectByQuery('SELECT * FROM PEOPLE WHERE identity_id = "undefined" LIMIT ?, ?', [0, offset], 'person', function (items) {
                var contacts = [];
                for (var i = 0, max = items.length; i < max; i++) {
                   contacts.push(self.checkFavorite(items[i]));
                }
                self.drawContact('contact-list', contacts, false);
                $recentList.hide();
            });
        }
    };

    self.showCompanies = function () {
        if (connection) {
            ClientAPI.findPaged({objectType: "Company"}, [["modificatioDate", -1]], 1, offset, function (err, items) {
                if (!err && items != null && items.length != null) {
                    var contacts = [];
                    for (var i = 0, max = items.length; i < max; i++) {
                       contacts.push(self.checkFavorite(CompanyController.encodeItem(items[i])));
                    }
                    contacts.sort(sortContact);
                    self.drawContact('contact-list', contacts, false);
                    var companyIds = self.getCompanyIds(contacts);
                    self.drawCompanyDetails(companyIds);
                    $recentList.hide();
                }
            });
        } else {
            db.selectByQuery('SELECT * FROM COMPANY LIMIT ?, ?', [0, offset], 'company', function (items) {
                var contacts = [];
                for (var i = 0, max = items.length; i < max; i++) {
                    contacts.push(self.checkFavorite(items[i]));
                }
                self.drawContact('contact-list', contacts, false);
                $recentList.hide();
            });
        }
    };


    self.showFavorites = function () {
        try {
            FavoriteController.findContactAll(function(data){
                var items = [];
                var companyItems = [];
                var personItems = [];
                var phoneNumber = [];
                for (var i = 0, max = data.length; i < max; i++) {
                    var item = null;
                    if (data[i].favorite) {
                        item = data[i].favorite.refObject;
                    } else {
                        item = data[i].refObject;
                        if (item._id) {
                            if (item.objectType == "Company") {
                                item = CompanyController.encodeItem(item);
                            } else if (item.objectType == "Person") {
                                item = PeopleController.encodeItem(item);
                            }
                        }
                    }

                    item.favorite = true;
                    if (item.objectType == "Company") {
                        companyItems.push(item);
                    } else if (item.objectType == "Person") {
                        personItems.push(item);
                    } else {
                        phoneNumber.push(item);
                    }
                }

                // sort company contacts
                companyItems.sort(sortContact);
                personItems.sort(sortContact);
                for (var i = 0; i < companyItems.length; i++) {
                    items.push(companyItems[i]);
                }
                for (var i = 0; i < personItems.length; i++) {
                    items.push(personItems[i]);
                }
                for (var i = 0; i < phoneNumber.length; i++) {
                    items.push(phoneNumber[i]);
                }
                self.drawContact('contact-list', items, false, true);
                var companyIds = self.getCompanyIds(contacts);
                self.drawCompanyDetails(companyIds);
                $recentList.hide();
                $('#contacts-list-message').hide();
            });
        } catch (e) {
            console.log("ContactFunctions.js - self.showFavorites - " + e);
        }
    };

    self.showPhoneContact = function () {
        try {
            showLoadingIndikator();
            $('#empty-phone-contact').hide();
            $('#empty-recent').hide();
            $('#contacts-list-message').hide();
            $recentList.hide();
            var phoneObjects = [];
            var html = "";
            var queryData = [];
            var queryStringPhoneContact = "SELECT * FROM phoneContact ";

//            var queryData = [searchValues,searchValues,searchValues,((SCROLL_START - 1) * offset), offset];
            if (self.drawListParams['contact-list'] != null && self.drawListParams['contact-list'].type == "search") {
                queryStringPhoneContact += 'WHERE givenName LIKE ? or familyName LIKE ? OR companyName LIKE ? ORDER BY familyName, givenName  LIMIT ?, ?';
                searchValues = "%" + self.drawListParams['contact-list']['searchValue'] + "%";
                queryData = [searchValues, searchValues, searchValues, ((SCROLL_START - 1) * offset), offset];
            } else {
                queryStringPhoneContact += 'ORDER BY familyName, givenName  LIMIT ?, ?';
                queryData = [((SCROLL_START - 1) * offset), offset];
            }

            db.selectByQuery(queryStringPhoneContact, queryData, models.phoneContactDBModel.name, function (contacts) {
                    SCROLL_START++;
                    contacts.sort(sortContact);
                    $(contacts).each(function (index, value) {
                        var phoneContact = {};
                        phoneContact.id = value.id;
                        phoneContact.url = value.avatar;
                        phoneObjects.push(phoneContact);
                        html += self.drawPhoneContactItem(self.checkFavorite(value));
                    });

                    if (html != "") {
                        if (SCROLL_START > 2) {
                            $('#contact-list').show().append(html);
                        } else {
                            $('#contact-list').empty().show().append(html);
                        }
                    }
                    hideLoadingIndikator();
                    self.loadPhoneContactAvatar(phoneObjects);
            });
        } catch (e) {
            console.log(e);
        }
    };

    self.openPhoneContact = function (contactId) {
        var id = $(this).attr("contactId");
        if (contactId && typeof contactId == "string") {
            id = contactId;
        }
        var ids = [];
        $("#contact-list").find(".phone-contact").each(function () {
            ids.push($(this).attr("contactId"));
        });
        gotoPage({url: "viewPhoneContact", param: {phoneContactId: id, phoneContactIds: ids, contactType: "Person", parentId: parentIdForPhoneContact, accessList: accessListForPhoneContact}}, {url: "contacts", param: null});
    };

    self.onPullDown = function () {
        if ($("#contact-list li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            if (currentContactList == CONTACT_LIST.PHONE) {
                SCROLL_START = 1;
                self.showPhoneContact();
            }
        }
    };

    self.onPullUp = function () {
        if ($("#contact-list li", '#' + $.mobile.activePage.attr('id')).last().visible() && !$("html").hasClass("sidebar-left-in")) {
            if (self.findTime) {
                clearTimeout(self.findTime);
            }
            self.findTime = setTimeout(function () {
                if (currentContactList == CONTACT_LIST.COMPANY || currentContactList == CONTACT_LIST.PEOPLE) {
                    var requestObject = {objectType: "Person", identity_id: {$exists: false}};

                    if (currentContactList === CONTACT_LIST.COMPANY) {
                        requestObject = {objectType: "Company"};
                    }

                    var sort = [
                        ["modificatioDate", -1]
                    ];

                    self.listScrollLoad('contact-list', requestObject, sort);
                } else if (currentContactList == CONTACT_LIST.PHONE) {
                    self.showPhoneContact();
                }
            }, 300);
        }
    };

    self.listScrollLoad = function (listViewId, query, sort) {
        if (self.findTime) {
            clearTimeout(self.findTime);
        }
        self.findTime = setTimeout(function () {
            showLoadingIndikator();
            if (connection) {
                if (query.objectType.toLowerCase() == "company") {
                    ClientAPI.findPaged(query, sort, SCROLL_START, offset, function (err, items) {
                        var i, max;
                        if (items != null && items.length >= 1) {
                            var contacts = [];
                            for (i = 0, max = items.length; i < max; i++) {
                                contacts.push(self.checkFavorite(CompanyController.encodeItem(items[i])));
                            }
                            self.drawContact('contact-list', contacts, true);
                            var companyIds = self.getCompanyIds(contacts);
                            self.drawCompanyDetails(companyIds);
                        } else {
                            hideLoadingIndikator();
                        }
                    });
                } else if (query.objectType.toLowerCase() == "person") {
                    ClientAPI.findPaged({query: query, page: SCROLL_START, pageSize: offset, objectType: "Person", population: "companies.company"}, function (err, items) {
                        var i, max;
                        if (items != null && items.length >= 1) {
                                var contacts = [];
                                for (i = 0, max = items.length; i < max; i++) {
                                    contacts.push(self.checkFavorite(PeopleController.encodeItem(items[i])));
                                }
                                self.drawContact('contact-list', contacts, true);
                        } else {
                            hideLoadingIndikator();
                        }
                    });
                }
            } else {
                var queryType = "PEOPLE";
                if (currentContactList === CONTACT_LIST.COMPANY) {
                    queryType = "COMPANY";
                }

                if (queryType == "PEOPLE") {
                    queryType = 'PEOPLE WHERE identity_id = "undefined"';
                }
                db.selectByQuery('SELECT * FROM ' + queryType + ' LIMIT ?, ?', [(SCROLL_START - 1) * offset, offset], queryType.toLowerCase(), function (items) {
                    var contacts = [];
                    for (var i = 0, max = items.length; i < max; i++) {
                        contacts.push(self.checkFavorite(items[i]));
                    }
                    self.drawContact('contact-list', contacts, true);
                    $recentList.hide();
                    hideLoadingIndikator();
                });
            }
        }, 300);
    };

    self.dashboardLinkEvent = function () {
        gotoPage({url: "dashboard", param: null});
    };

    self.caseLinkEvent = function () {
        gotoPage({url: "case", param: null});
    };

    self.dealsLinkEvent = function () {
        gotoPage({url: "deals", param: null});
    };

    self.closeLinkEvent = function () {
        closeAplication();
    };

    self.tasksLinkEvent = function () {
        gotoPage({url: "tasks", param: null});
    };

    self.menuLinkEvent = function () {
        $('html').toggleClass('sidebar-left-in');
    };

    self.myGroupLinkEvent = function () {
        gotoPage({url: "myGroup", param: null});
    };

    self.addPerson = function () {
        gotoPage({url: "editContact", param: {contactType: "Person"}}, {url: "contacts", param: null});
    };

    self.addCompany = function () {
        gotoPage({url: "editContact", param: {contactType: "Company"}}, {url: "contacts", param: null});
    };

    self.taskContactItemEvent = function () {
        ViewContactFunctions.tab.current = "TASK";
        self.openContact($(this).attr('contactId'), $(this).attr('type'));
    };

    self.dealContactItemEvent = function () {
        ViewContactFunctions.tab.current = "DEAL";
        self.openContact($(this).attr('contactId'), $(this).attr('type'));
    };

    self.contactContactItemEvent = function () {
        ViewContactFunctions.tab.current = "NOTE";
        self.openContact($(this).attr('contactId'), $(this).attr('type'));
    };

    self.contactListEvent = function () {
        ViewContactFunctions.tab.current = "GENERAL";
        var contactId = $(this).attr('contactId');
        var contactObjects = [];
        $("#" + listType).find(".contact").each(function () {
            var contactObj = {};
            contactObj.id = $(this).attr("contactId");
            contactObj.type = $(this).attr("type");
            contactObjects.push(contactObj);
        });
        self.openContact(contactId, $(this).attr('type'), contactObjects);
    };

    self.callContactItemEvent = function () {
        if ($(this).attr("type") == "phoneContact") {
            MyGroupFunctions.call($(this).attr('phonenumber'));
        } else {
            self.showContactPopup($(this).attr('contactId'), $(this).attr('type'), "number", "tel", "Call", "number");
        }
    };

    self.mailContactItemEvent = function () {
        if ($(this).attr("type") == "phoneContact") {
            window.location = 'mailto:' + $(this).attr('phonenumber');
        } else {
            self.showContactPopup($(this).attr('contactId'), $(this).attr('type'), "email", "mailto", "Email to", "address");
        }
    };

    self.smsContactItemEvent = function () {
        if ($(this).attr("type") == "phoneContact") {
            window.location = 'sms:' + $(this).attr('phonenumber');
        } else {
            self.showContactPopup($(this).attr('contactId'), $(this).attr('type'), "number", "sms", "SMS to", "number");
        }
    };

    self.callEvent = function () {
        try {
            if ($(this).attr('action') == "tel") {
                MyGroupFunctions.call($(this).attr('phonenumber'));
            }
        } catch (e) {
            console.log("Contact.js -> self.callEvent -> \n" + e);
        }
    };

    self.addContactUsingQRCode = function () {
        try {
            $addContactMenu.popup('close');
            setTimeout(function () {
                window.plugins.barcodeScanner.scan(function (result) {
                    var vCard = new VCardParser(result.text);
                    vCard = vCard.parse();
                    if ((parseFloat(vCard.version) == 3.0) || (parseFloat(vCard.version) == 2.1) || (vCard.begin != null && vCard.begin.substring(0, 5) == "VCARD")) {
                        gotoPage({url: "previewContact", param: {vCard: vCard}}, {url: "contacts", param: null});
                    } else {
                        showAlertDialog("This is not a valid vCard!", "Error", "OK", function () {
                        });
                    }
                }, function (error) {
                    showAlertDialog("Error. Try again!", "Error", "OK", function () {
                    });
                });
            }, 100);
        } catch (e) {
            console.log("ContactFunctions.js - self.drawContact - " + e);
        }
    };

    self.checkFavorite = function(encodeItemData) {
        var idData;
        if (encodeItemData.id.text) {
            idData = encodeItemData.id.text;
        } else {
            idData = encodeItemData.id;
        }
        if (favoriteMapData[idData]) {
            encodeItemData['favorite'] = true;
        }
        return encodeItemData;
    }

    self.contactsInputEvent = function (evt) {
        if (self.findTime) {
            clearTimeout(self.findTime);
        }

        var searchValue = $("input").val();

        self.findTime = setTimeout(function () {
            try {
                if (currentContactList == CONTACT_LIST.PHONE) {
                    if (searchValue.length > 0) {
                        SCROLL_START = 1;
                        self.drawListParams['contact-list'] = {
                            'start': SCROLL_START,
                            'type': "search",
                            'searchValue': searchValue,
                            'offset': offset
                        };
                        searchValues = "%" + searchValue + "%";
                        var queryData = [searchValues, searchValues, searchValues, ((SCROLL_START - 1) * offset), offset];
                        var queryStringPhoneContact = 'SELECT * FROM phoneContact WHERE givenName LIKE ? or familyName LIKE ? OR companyName LIKE ? ORDER BY familyName, givenName  LIMIT ?, ?';
                        db.selectByQuery(queryStringPhoneContact, queryData, 'phoneContact', function (contacts) {
                            var html = "";
                            var contactArray = [];
                            for (var i = 0, max = contacts.length; i < max; i++) {
                                contactArray.push(self.checkFavorite(contacts[i]));
                            }
                            contactArray.sort(sortContact);
                            $(contactArray).each(function (index, value) {
                                html += self.drawPhoneContactItem(value);
                            });

                            if (html != "") {
                                if (SCROLL_START > 2) {
                                    $('#contact-list').show().append(html);
                                } else {
                                    $('#contact-list').empty().show().append(html);
                                }
                            } else {
                                $('#empty-phone-contact').show();
                            }
                        });

                    } else {
                        self.filterContacts();
                    }
                } else {
                    if (connection) {
                        var html = "";
                        var pattern = new RegExp(searchValue.trim().replace(' ', '|'), "i");
                        if (searchValue.length > 0) {
                            self.drawListParams['contact-list'] = {
                                'start': 0,
                                'type': "search",
                                'searchValue': searchValue,
                                'offset': offset
                            };

                            var searchType = [{objectType: "Company"}, {objectType: "Person"}];
                            if (currentContactList === CONTACT_LIST.COMPANY) {
                                searchType = [{objectType: "Company"}];
                            } else if (currentContactList === CONTACT_LIST.PEOPLE) {
                                searchType = [{objectType: "Person"}];
                            } else {
                                searchType = [{objectType: "Company"}, {objectType: "Person"}];
                            }
                            if (currentContactList === CONTACT_LIST.COMPANY) {
                                ClientAPI.findPaged({$or: searchType, 'searchKeywords': pattern, identity_id: {$exists: false}}, null, 1, offset, function (err, items) {
                                    if (!err) {
                                        $recentList.hide();
                                        var contacts = [];
                                        for (i = 0, max = items.length; i < max; i++) {
                                            contacts.push(self.checkFavorite(CompanyController.encodeItem(items[i])));
                                        }
                                        contacts.sort(sortContact);
                                        self.drawContact('contact-list', contacts, false);
                                        var companyIds = self.getCompanyIds(contacts);
                                        self.drawCompanyDetails(companyIds);
                                    }
                                });
                            } else if (currentContactList === CONTACT_LIST.PEOPLE) {
                                ClientAPI.findPaged({query: {objectType: "Person", 'searchKeywords': pattern, identity_id: {$exists: false}}, page: 1, pageSize: offset, objectType: "Person", population: "companies.company"}, function (err, items) {
                                    if (!err) {
                                        $recentList.hide();
                                        var contacts = [];
                                        for (i = 0, max = items.length; i < max; i++) {
                                            contacts.push(self.checkFavorite(PeopleController.encodeItem(items[i])));
                                        }
                                        contacts.sort(sortContact);
                                        self.drawContact('contact-list', contacts, false);
                                    }
                                });
                            } else if (currentContactList === CONTACT_LIST.CUSTOM_FILTER) {
                                var request = JSON.parse($filterContacts.find(":selected").attr('filter'));
                                if (request && request[0] && request[0].$match) {
                                    request[0]['$match']['searchKeywords'] = pattern;
                                }
                                // page: 1, pageSize: offset,s
                                ContactsController.findCustomContact(request, function(items){
                                      $recentList.hide();
                                      var contacts = [];
                                      for (i = 0, max = items.length; i < max; i++) {
                                          contacts.push(self.checkFavorite(items[i]));
                                      }
                                      contacts.sort(sortContact);
                                      self.drawContact('contact-list', contacts, false);
                                });
                            } else {
                                var searchWords = searchValue.split(" ");
                                db.selectAll('recent', function (data) {
                                    var contacts = [];
                                    for (var i = 0; i < data.length; i++) {
                                        var contact = data[i].recent.object;
                                        for (var j = 0; j < contact.searchKeywords.length; j++) {
                                            var match = false;
                                            for (var k = 0; k < searchWords.length; k++) {
                                                if (contact.searchKeywords[j].indexOf(searchWords[k]) > -1) {
                                                    contacts.push(self.checkFavorite(contact));
                                                    match = true
                                                    break;
                                                }
                                            }
                                            if (match) {
                                                break;
                                            }
                                        }
                                    }
                                    $recentList.hide();
                                    self.drawContact('contact-list', contacts, false);
                                    var companies = contacts.filter(function (item) {
                                        return item.objectType.toLowerCase() == "company";
                                    });
                                    var companyIds = self.getCompanyIds(companies);
                                    self.drawCompanyDetails(companyIds);
                                });
                            }
                        } else {
                            self.filterContacts();
                        }
                    } else {
                        //offline
                        if (searchValue.length > 0) {
                            self.drawListParams['contact-list'] = {
                                'start': 0,
                                'type': "search",
                                'searchValue': searchValue,
                                'offset': offset
                            };

                            var queryData = [];
                            var drawItems = [];
                            var queryStringPeople = 'SELECT * FROM people WHERE identity_id = "undefined" AND ';
                            var queryStringCompany = 'SELECT * FROM company WHERE ';
                            var searchValues = self.drawListParams[listViewId]['searchValue'].split(' ');

                            for (var i = 0, max = searchValues.length; i < max; i++) {
                                if (i == 0) {
                                    queryStringPeople += 'searchKeywords LIKE ? ';
                                    queryStringCompany += 'searchKeywords LIKE ? ';
                                    queryData.push("%" + searchValues[i] + "%");
                                } else {
                                    queryStringPeople += 'OR searchKeywords LIKE ? ';
                                    queryStringCompany += 'OR searchKeywords LIKE ? ';
                                    queryData.push("%" + searchValues[i] + "%");
                                }
                            }

                            queryStringPeople += "ORDER BY [updated-at] DESC LIMIT ?, ?";
                            queryStringCompany += "ORDER BY [updated-at] DESC LIMIT ?, ?";
                            queryData.push(self.drawListParams[listViewId]['start']);
                            queryData.push(self.drawListParams[listViewId]['offset']);

                            db.selectByQuery(queryStringPeople, queryData, 'people', function (items) {
                                for (var i = 0, max = items.length; i < max; i++) {
                                    drawItems.push(self.checkFavorite(items[i]));
                                }
                                db.selectByQuery(queryStringCompany, queryData, 'company', function (items) {
                                    for (var i = 0, max = items.length; i < max; i++) {
                                        drawItems.push(self.checkFavorite(items[i]));
                                    }
                                    if (drawItems) {
                                        $recentList.hide();
                                        drawItems.sort(sortContact);
                                        self.drawContact('contact-list', drawItems, false);
                                    }
                                });
                            });
                        } else {
                            self.filterContacts();
                        }
                    }
                }
            } catch (e) {
                console.log("ContactFunctions.js - self.contactsInputEvent - " + e);
            }
        });

    };

    self.contactsInputDeleteAllEvent = function () {
        try {
            self.contactsShowRecentListEvent();
        } catch (e) {
            console.log("ContactFunctions.js - self.contactsInputDeleteAllEvent - " + e);
        }
    };

    self.drawContact = function (listViewId, items, append, favorite) {
        if (listViewId) {
            listType = listViewId;
        }
        $emptyRecent.hide();
        if (items != null && items.length != null) {
            var html = "";
            var $listView = $('#' + listViewId);
            for (var i = 0, max = items.length; i < max; i++) {
                if (items[i].objectType.toLowerCase() == "company") {
                    if (items[i]['_id'] != null) {
                        var encodeItemData = CompanyController.encodeItem(items[i]);
                        encodeItemData.favorite = favorite;
                        html += self.drawCompanyItem(encodeItemData);
                    } else {
                        html += self.drawCompanyItem(items[i]);
                    }
                } else if (items[i].objectType.toLowerCase() == "person") {
                    if (items[i]['_id'] != null) {
                        var encodeItemData = PeopleController.encodeItem(items[i]);
                        encodeItemData.favorite = favorite;
                        html += self.drawPeopleItem(encodeItemData);
                    } else {
                        html += self.drawPeopleItem(items[i]);
                    }
                } else {
                   html += self.drawPhoneContactItem(items[i]);
                }
            }
            if ('recent-list' == listViewId) {
                if (html != "") {
                    html = '<li data-role="list-divider" class="list-divider">Recently active contacts</li>' + html;
                }
            }
            if (append) {
                $listView.show().append(html);
                SCROLL_START++;
            } else {
                SCROLL_START = 2;
                $listView.empty().show().append(html);
            }

            if (listViewId == 'contact-list') {
                if (favorite) {
                    if ($contactList.find('li').length > 0) {
                        $emptyRecent.hide();
                    } else {
                        $emptyRecent.show();
                    }
                } else {
                    if ($contactList.find('li').length > 0) {
                        $emptyContact.hide();
                    } else {
                        $emptyContact.show();
                    }
                }
            } else {
                if ($recentList.find('li').length > 1) {
                    $emptyRecent.hide();
                } else {
                    $emptyRecent.show();
                }
            }
            hideLoadingIndikator();
        }
    };

    self.drawCompanyItem = function (item) {
        var html = "";
        if (item != null) {
            var name = typeof item.name != "object" ? item.name : "";
            var avatar = null;
            if (connection && item['avatar-url'] != null) {
                avatar = window.localStorage.getItem('folderPath') + item['avatar-url'];
            }

            html += '<li>'
                + '<a class="contact list-elem" contactId="' + item.id.text + '" type="company">';
            var starColor = item.favorite == true ? "contact-favorite-star" : "";
            if (avatar) {
                var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(item.id.text) + '&fieldName=' + encodeURIComponent('picture') + '&v=' + new Date(item['updated-at'].text).getTime();
                html += '<div type="company" class="favorite-event '+ starColor + '">'
                        + '<span class="contact-favorite-image"><i class="md-grade md-lg contact-favorite-avatar-image"></i></span>'
                        + '<div class="content-left-avatar" avatar_path="' + avatar + '" style="margin-left: 25px;padding: 10px 10px; width:42px;"><div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ')"></div></div>'
                        + '</div>';
            } else {
                html += '<div class="content-left favorite-event ' + starColor + '" type="company">'
                        + '<span class="contact-favorite-image"><i class="md-grade md-lg"></i></span>'
                        + '<span class="avatar is-contact-image" style="margin-left: 25px;"><i class="md-business  md-3x"></i></span>'
                        + '</div>';
            }

            html += '<div class="content-center" style="padding-left:75px; min-height:55px; ">'
                    + '<div class="contact-name truncate">' + name + '</div>'
                    + '</div>'
                    + '<div id="' + item.id.text + '" class="company-detail-container">'
                    + '<span class="dealCount" style="padding-left:15px">Opportunities (0) </span><span class="caseCount">Projects (0) </span><span class="taskCount">Tasks (0) </span>'
                    + '</div>'
                    + '</a>'
                    + '</li>';

            return html;
        } else {
            return "";
        }
    };

    self.drawPeopleItem = function (item) {
        var html = "";
        var title = "";
        if (item != null) {
            var avatar = null;
            var firstName = typeof item['first-name'] != "object" ? item['first-name'] : "";
            var lastName = typeof item['last-name'] != "object" ? item['last-name'] : "";
            var companyid = item["company-id"].text;
            var company = item['company-name'];
            if (item.title != null && typeof item.title == "string") {
                title = item.title;
            } else {
                title = "";
            }

            title = item.title == "null" ? "" : item.title;
            if (connection && item['avatar-url'] != null) {
                avatar = window.localStorage.getItem('folderPath') + item['avatar-url'];
            }
            var starColor = item.favorite == true ? "contact-favorite-star" : "";
            // drawing people contact
            html = '<li>';
            html += '<a class="contact list-elem" contactId="' + item.id.text + '" type="person">';
            if (avatar) {
                var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(item.id.text) + '&fieldName=' + encodeURIComponent('picture');
                html += '<div class="favorite-event ' + starColor + '">'
                        + '<span class="contact-favorite-image"><i class="md-grade md-lg contact-favorite-avatar-image"></i></span>'
                        + '<div class="content-left-avatar" style="margin-left: 25px;padding:10px; width:40px" avatar_path="' + avatar + '"><div class="content-avatar is-profile-pic" style="background-image:url(' + fileUrl + ')">'
                        + '</div></div>';
            } else {
                html += '<div class="content-left favorite-event ' + starColor + '">'
                        + '<span class="contact-favorite-image"><i class="md-grade md-lg"></i></span>'
                        + '<span class="avatar is-contact-image" style="margin-left: 25px;"><i class="md-person  md-3x"></i></span>';
            }
            html += '</div>'
                    + '<div class="content-center" style="padding-left:75px; min-height: 55px; ">'
                    + '<div class="contact-name">' + firstName + ' ' + lastName + '</div>'
                    + '<div class="contact-title">' + title + '</div>'
                    + '<div class="company-name">'+ company + '</div>'
                    + '</div>'
                    + '</div>'
                    + '</a>'
                    + '</li>';
            return html;
        } else {
            return html;
        }
    };


    self.drawPhoneContactItem = function (contact) {
        var html = "";
        if (contact) {
            var avatar = null;
            if (contact.avatar != null && contact.avatar != "") {
                avatar = contact.avatar;
            }

            var name = contact.familyName + ' ' + contact.givenName;
            var company = contact.company ? contact.company : "";
            var phone = "";

            if (contact.phones != null && contact.phones.length > 0 && contact.phones[0].phoneNumber != null) {
                phone = contact.phones[0].phoneNumber;
            }
            var starColor = contact.favorite == true ? "contact-favorite-star" : "";
            html += '<li>'
                    + '<a class="phone-contact list-elem" contactId="' + contact.id + '" type="person" subtype="PhoneNumber">'
                    + '<div class="content-left favorite-event ' + starColor + '">'
                    + '<span class="contact-favorite-image" style="top:10px;"><i class="md-grade md-lg contact-favorite-avatar-image"></i></span>'
                    + '<span class="avatar is-contact-image" style="margin-left: 25px;"><i class="md-person  md-3x"></i></span>'
                    + '</div>';
            html +=  '<div class="content-center" style="padding-left:75px; min-height: 55px; ">'
                    + '<div class="contact-name truncate">' + name + '</div>'
                    + '<div class="subtitle">' + phone + '</div>'
                    + '</div>'
                    + '</a>'
                    + '</li>';
            return html;
        } else {
            return html;
        }
    };

    self.loadPhoneContactAvatar = function (phoneContacts) {
        for (var i = 0; i < phoneContacts.length; i++) {
            self.validateImage(phoneContacts[i].url, phoneContacts[i].id);
        }
    };

    self.validateImage = function (url, listId) {
        var img = new Image();
        img.onload = function () {
            var $element = $("a[contactId='" + listId + "'] .content-left");
            var html = '<span class="contact-favorite-image" style="top:10px;"><i class="md-grade md-lg contact-favorite-avatar-image"></i></span>'
            html += '<div class="content-left-avatar" avatar_path="' + url + '" style="margin-left: 25px;padding: 10px 10px; width:42px;"><div class="content-avatar is-profile-pic" style="background-image:url(' + url + ')">';
            $element.empty();
            $element.html(html);
            $("a[contactId='" + listId + "'] .content-left .content-left-avatar").css("padding", "0px");
        };

        img.onerror = function (err) {
            console.log("Loading image error: " + err);
        };
        img.src = url;
    };

    self.contactsShowRecentListEvent = function () {
        try {
            FavoriteController.findAllMapByTypes(["Company", "Person"], function(favoriteMap){
                favoriteMapData = favoriteMap;
                $emptyContact.hide();
                db.selectAll('recent', function (data) {
                    var items = [];
                    var companyItems = [];
                    var personItems = [];
                    for (var i = data.length - 1, j = 0; i >= 0 && j != 7; i--, j++) {
                        var id = "";
                        if (typeof data[i].recent.object.id == "string") {
                            id = data[i].recent.object.id;
                        } else {
                            id = data[i].recent.object.id.text;
                        }

                        if (favoriteMapData && favoriteMapData[id]) {
                            data[i].recent.object['favorite'] = true;
                        }

                        if (data[i].recent.object.objectType == "Company") {
                            companyItems.push(data[i].recent.object);
                        } else {
                            personItems.push(data[i].recent.object);
                        }
                    }
                    // sort company contacts
                    companyItems.sort(sortContact);
                    personItems.sort(sortContact);
                    for (var i = 0; i < companyItems.length; i++) {
                        items.push(companyItems[i]);
                    }

                    for (var i = 0; i < personItems.length; i++) {
                        items.push(personItems[i]);
                    }

                    $contactList.hide();
                    self.drawContact('recent-list', items, false);
                    var companyIds = self.getCompanyIds(companyItems);
                    self.drawCompanyDetails(companyIds);
                 });
            });
        } catch (e) {
            console.log("ContactFunctions.js - self.contactsShowRecentListEvent - " + e);
        }
    };

    self.openContact = function (id, type, contactObjects) {

        gotoPage({url: "viewContact", param: {contactId: id, contactType: type, contactObjects: contactObjects, listPageCount: SCROLL_START}}, {url: "contacts", param: null});
    };

    self.addAllContactsFromPhone = function () {
        try {
            $addContactMenu.popup('close');
            self.sharedContactForOpen.type = 'person';
            setTimeout(function () {
                showActionDialog(Messages.Contact.addAllFromPhoneContactsBook, "Yes", function () {
                    ContactsController.findPhoneContacts("", ContactsController.prepareAndSendAllPhoneContacts);
                }, "No", function () {
                });
            }, 100);
        } catch (e) {
            console.log("ContactFunctions.js - self.addAllContactsFromPhone - " + e);
        }
    };

    self.setConnectionMode = function () {
        try {
            if (connection) {
                $('#' + $.mobile.activePage.attr('id') + ' #refresh-link').show();
                $('#' + $.mobile.activePage.attr('id') + ' #add-person-from-phone').show();
                $('#' + $.mobile.activePage.attr('id') + ' #add-all-contacts-from-phone').show();
            } else {
                $('#' + $.mobile.activePage.attr('id') + ' #refresh-link').hide();
                $('#' + $.mobile.activePage.attr('id') + ' #add-person-from-phone').hide();
                $('#' + $.mobile.activePage.attr('id') + ' #add-all-contacts-from-phone').hide();
            }
        } catch (e) {
            console.log("ContactFunctions.js - self.setConnectionMode - " + e);
        }
    };

    self.drawCompanyDetails = function (companies) {
        if (companies) {
            for (var i = 0; i < companies.length; i++) {
                (function (num) {
                    self.drawCompanyDeals(companies[i]);
                    self.drawCompanyCases(companies[i]);
                    self.drawCompanyTasks(companies[i]);
                })(i);
            }
        }
    };

    self.drawCompanyDeals = function (companyId) {
        if (connection) {
            var request = {objectType: "Deal", immediateParent: new ObjectId(companyId), status: {$nin: ["Won", "Inactive", "Lost"]}};
            ClientAPI.findCount(request, function (err, data) {
                if (!err) {
                    $("#" + companyId + ' .dealCount').text('Opportunities  (' + data + ') ');
                }
            });
        } else {
            var query = "SELECT count(*) FROM deal WHERE [party-id] = ? AND status != ? AND status != ? AND status != ?";
            var queryList = [getTextTypeObject(companyId, 'integer'), "Won", "Inactive", "Lost"];
            db.selectByQuery(query, queryList, "deal", function (data) {
                $("#" + companyId + ' .dealCount').text('Opportunities  (' + data[0]['count(*)'] + ') ');
            });
        }
    };

    self.drawCompanyCases = function (companyId) {
        if (connection) {
            var request = {objectType: "Project", immediateParent: new ObjectId(companyId), status: {$nin: ["Closed"]}};
            ClientAPI.findCount(request, function (err, data) {
                if (!err) {
                    $("#" + companyId + ' .caseCount').text('Projects (' + data + ') ');
                }
            });
        } else {
            var query = "SELECT count(*) FROM kase WHERE [party-id] = ? AND status != ?";
            var queryList = [getTextTypeObject(companyId, 'integer'), "Closed"];
            db.selectByQuery(query, queryList, "kase", function (data) {
                $("#" + companyId + ' .caseCount').text('Projects (' + data[0]['count(*)'] + ') ');
            });
        }
    };

    self.drawCompanyTasks = function (companyId) {
        if (connection) {
            var request = {objectType: "Task", immediateParent: new ObjectId(companyId), status: {$nin: ["Completed"]}};
            ClientAPI.findCount(request, function (err, data) {
                if (!err) {
                    $("#" + companyId + ' .taskCount').text('Tasks (' + data + ') ');
                }
            });
        } else {
            var query = "SELECT count(*) FROM task WHERE [recording-id] = ? AND status != ?";
            var queryList = [getTextTypeObject(companyId, 'integer'), "Completed"];
            db.selectByQuery(query, queryList, "task", function (data) {
                $("#" + companyId + ' .taskCount').text('Tasks (' + data[0]['count(*)'] + ') ');
            });
        }
    };

    self.getCompanyIds = function (companies) {
        var companyIds = [];
        for (var i = 0; i < companies.length; i++) {
            companyIds.push(companies[i].id.text);
        }
        return companyIds;
    };

    self.draftLinkEvent = function () {
        gotoPage({url: "draft", param: null}, {url: "contacts", param: null});
    };

    return self;
}(ContactFunctions || {}));
