$(document).on('pageinit', '#edit-contact', function () {
    EditContactFunctions.init();
    overrideBackButton = EditContactFunctions.backLinkEvent;
});

$(document).on('pageshow', '#edit-contact', function () {
    EditContactFunctions.bindElementControls();
    EditContactFunctions.setFontSize();
    hideLoadingIndikator();
    $("#edit-contact .ui-input-clear").click(function () {
        $("#title-box").hide();
    });
});

$(document).on('pagehide', '#edit-contact', function () {
    EditContactFunctions.unbindElementControls();
});

var EditContactFunctions = (function (EditContactFunctions)
{
    var self = EditContactFunctions;
    var OPERATION;
    var contact;
    var companyId;
    var type = "people";
    var i, max;
    var contactForOpen = null;
    var contactType = null;
    var phoneContact = null;
    var isPhoneContact = false;
    var phoneArray = [];
    var emailArray = [];
    var webArray = [];
    var visibilityObjectId = null;

    self.init = function () {

        PermissionController.init('#edit-contact');
        AutoCompleteController.init('#edit-contact');
        AutoCompleteController.addViewId('autocomplete-company', 'autocomplete-company-list', 'autocomplete-company', function (data) {
            setTimeout(function(){
                visibilityObjectId = data.id;
                showActionDialog("Take visibility of parent object?", "Yes", self.updateACL, "No", function () {
                });
            }, 2000);
            $("#title-box").show();
        });

        if (pageObject) {
            var contactId = pageObject.contactId;
            var phoneContactId = pageObject.phoneContactId;
            contactType = pageObject.contactType;
            if (contactId && contactType) {
                $('#contact-edit-title').show();
                //init editContact Object
                var controller = null;
                if (contactType == 'Company') {
                    controller = CompanyController;
                } else {
                    controller = PeopleController;
                }
                controller.findById(contactId, function (item) {
                    if (item != null && item[0] != null) {
                        if (item[0]['_id']) {
                            if (contactType == "Company") {
                                contactForOpen = controller.encodeItem(item[0]);
                            } else {
                                contactForOpen = controller.encodeItem(item[0]);
                            }
                        } else {
                            if (contactType == "Company") {
                                contactForOpen = item[0]['company'];
                            } else {
                                if (item[0]['people'] == null) {
                                    contactForOpen = item[0];
                                } else {
                                    contactForOpen = item[0]['people'];
                                }
                            }
                        }
                    }
                    if (contactForOpen['objectType']) {
                        contactForOpen['currentType'] = contactForOpen['objectType'];
                    }

                    OPERATION = "EDIT";
                    $('#contact-edit-title').show();
                    if (contactForOpen.currentType == "Company") {
                        contact = contactForOpen;
                    } else {
                        contact = contactForOpen;

                    }
                    self.loadData();
                }, true);
            } else {
                if (phoneContactId) {
                    // ucitavanje phone contact
                    isPhoneContact = true;
                    if (isPhoneContact) {
                        $('#phone-contact-add-title').show();
                    }
                    ContactsController.findPhoneContactById(phoneContactId, function (data) {
                        phoneContact = data;
                        if (phoneContact) {
                            contact = self.encodePhoneContact(phoneContact);
                            console.log("contact");
                            console.log(JSON.stringify(contact));
                            self.loadData();
                        }
                    });
                }

                // add people to company
                var parentId = pageObject.parentId;
                var parentName = pageObject.parentName;
                if (parentId) {
                    $("#edit-contact #title-box").show();
                    OPERATION = "ADD";
                    if (isPhoneContact) {
                        $('#phone-contact-add-title').show();
                    } else {
                        $('#contact-add-title').show();
                    }
                    contactType = "People";
                    contact = null;
//                    $('#contact-company').val(sharedCompanyForAddPeople.name).selectmenu('refresh');
                    if (parentName) {
                        $('#autocomplete-company').val(parentName);
                        AutoCompleteController.setObject('Company', parentId);
                    }
                    var accessList = pageObject.accessList;
                    if (accessList) {
                        contact = {"visible-to": accessList};
                        PermissionController.setData(contact["visible-to"]);
                    }
                } else {
                    if (!isPhoneContact) {
                        $('#contact-add-title').show();
                        if (pageObject.phoneNumbers) {
                            self.drawCallLogPhone(pageObject.phoneNumbers);
                        }
                    }
                }
            }
        }
        self.initForm();
        pageObject = null;

    };

    self.updateACL = function () {
            var aclObjectVisibility = [];
            var request = {'objectType': "Company", _id: new ObjectId(visibilityObjectId)};
            if (connection) {
                ClientAPI.find(request, null, function (err, data) {
                    if (data && data.length > 0) {
                        aclObjectVisibility = data[0]['accessList'];
                        if (aclObjectVisibility.length > 0) {
                            if (!PermissionController.changeACL) {
                                PermissionController.changeACL = true;
                            }
                            PermissionController.setData(aclObjectVisibility);
                        }
                    }
                });
            }
    };

    self.capitalize = function (txt) {
        if (txt != null && txt.charAt(0) != null) {
            return txt.charAt(0).toUpperCase() + txt.slice(1);
        } else {
            return txt;
        }
    };

    self.encodePhoneContact = function (phoneContact) {
        var phoneObj = {
            "contact-data": {
                "phone-numbers": {
                    "phone-number": []
                },
                "email-addresses": {
                    "email-address": []
                },
                "web-addresses": {
                    "web-address": []
                }
            }
        };
        if (phoneContact.name) {
            phoneObj['first-name'] = phoneContact.name.givenName;
            phoneObj['last-name'] = phoneContact.name.familyName;
        }
        if (phoneContact.phoneNumbers) {
            if (phoneContact.phoneNumbers.length > 1) {
                for (i = 0; i < phoneContact.phoneNumbers.length; i++) {
                    var phone = {id: {}};
                    phone.id.text = phoneContact.phoneNumbers[i].id;
                    phone.location = self.capitalize(phoneContact.phoneNumbers[i].type);
                    phone.number = phoneContact.phoneNumbers[i].value;
                    phoneObj['contact-data']['phone-numbers']['phone-number'].push(phone);
                }
            } else {
                phoneObj['contact-data']['phone-numbers']['phone-number'] = {id: {}};
                phoneObj['contact-data']['phone-numbers']['phone-number'].id.text = phoneContact.phoneNumbers[0].id;
                phoneObj['contact-data']['phone-numbers']['phone-number'].location = self.capitalize(phoneContact.phoneNumbers[0].type);
                phoneObj['contact-data']['phone-numbers']['phone-number'].number = phoneContact.phoneNumbers[0].value;
            }
        }
        if (phoneContact.emails) {
            if (phoneContact.emails.length > 1) {
                for (i = 0; i < phoneContact.emails.length; i++) {
                    var email = {id: {}};
                    email.id.text = phoneContact.emails[i].id;
                    email.location = self.capitalize(phoneContact.emails[i].type);
                    email.address = phoneContact.emails[i].value;
                    phoneObj['contact-data']['email-addresses']['email-address'].push(email);
                }
            } else {
                phoneObj['contact-data']['email-addresses']['email-address'] = {id: {}};
                phoneObj['contact-data']['email-addresses']['email-address'].id.text = phoneContact.emails[0].id;
                phoneObj['contact-data']['email-addresses']['email-address'].location = self.capitalize(phoneContact.emails[0].type);
                phoneObj['contact-data']['email-addresses']['email-address'].address = phoneContact.emails[0].value;
            }
        }
        if (phoneContact.urls) {
            if (phoneContact.urls.length > 1) {
                for (i = 0; i < phoneContact.urls.length; i++) {
                    var web = {id: {}};
                    web.id.text = phoneContact.urls[i].id;
                    web.urlType = self.capitalize(phoneContact.urls[i].type);
                    web.URL = phoneContact.urls[i].value;
                    phoneObj['contact-data']['web-addresses']['web-address'].push(web);
                }
            } else {
                phoneObj['contact-data']['web-addresses']['web-address'] = {id: {}};
                phoneObj['contact-data']['web-addresses']['web-address'].id.text = phoneContact.urls[0].id;
                phoneObj['contact-data']['web-addresses']['web-address'].urlType = self.capitalize(phoneContact.urls[0].type);
                phoneObj['contact-data']['web-addresses']['web-address'].URL = phoneContact.urls[0].value;
            }
        }
        return phoneObj;
    };


    self.getEmailLocation = function (type) {
        var emailLocation = '<select class="contact-email-location" data-mini="true" data-theme="d">';
        if (type == 'Work') {
            emailLocation += '<option value="Work" selected="selected" data-i18n="contact.work"></option>';
            emailLocation += '<option value="Home" data-i18n="contact.home"></option>';
            emailLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Home') {
            emailLocation += '<option value="Work" data-i18n="contact.work"></option>';
            emailLocation += '<option value="Home" selected="selected" data-i18n="contact.home"></option>';
            emailLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Other') {
            emailLocation += '<option value="Work" data-i18n="contact.work"></option>';
            emailLocation += '<option value="Home" data-i18n="contact.home"></option>';
            emailLocation += '<option value="Other" selected="selected" data-i18n="contact.other"></option>';
        } else {
            emailLocation += '<option value="Work" data-i18n="contact.work"></option>';
            emailLocation += '<option value="Home" data-i18n="contact.home"></option>';
            emailLocation += '<option value="Other" data-i18n="contact.other"></option>';
        }
        emailLocation += '</select>';
        return emailLocation;
    };


    self.getWebLocation = function (type) {
        var webLocation = '<select class="contact-web-location" data-mini="true" data-theme="d">';
        if (type == 'Work') {
            webLocation += '<option value="Work" selected="selected" data-i18n="contact.work"></option>';
            webLocation += '<option value="Personal" data-i18n="contact.personal">Personal</option>';
            webLocation += '<option value="Other" data-i18n="contact.other">Other</option>   ';
        } else if (type == 'Personal') {
            webLocation += '<option value="Work" data-i18n="contact.work"></option>';
            webLocation += '<option value="Personal" selected="selected" data-i18n="contact.personal"></option>';
            webLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Other') {
            webLocation += '<option value="Work" data-i18n="contact.work"></option>';
            webLocation += '<option value="Personal" data-i18n="contact.personal"></option>';
            webLocation += '<option value="Other" selected="selected" data-i18n="contact.other"></option>';
        } else {
            webLocation += '<option value="Work" data-i18n="contact.work"></option>';
            webLocation += '<option value="Personal" data-i18n="contact.personal"></option>';
            webLocation += '<option value="Other" data-i18n="contact.other"></option>';
        }
        webLocation += '</select>';
        return webLocation;
    };

    self.getPhoneLocation = function (type) {
        var phoneLocation = '<select class="contact-phone-location" data-mini="true" data-theme="d">';

        if (type == 'Work') {
            phoneLocation += '<option value="Work" data-i18n="contact.work" selected="selected">Work</option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Fax" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Mobile') {
            phoneLocation += '<option value="Work" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.mobile" selected="selected"></option>';
            phoneLocation += '<option value="Fax" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Fax') {
            phoneLocation += '<option value="Work" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.mobile"></option>';
            phoneLocation += '<option value="Fax" selected="selected" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Pager') {
            phoneLocation += '<option value="Work" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.mobile"></option>';
            phoneLocation += '<option value="Fax" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" selected="selected" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Home') {
            phoneLocation += '<option value="Work" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.mobile"></option>';
            phoneLocation += '<option value="Fax" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" selected="selected" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Skype') {
            phoneLocation += '<option value="Work" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.mobile"></option>';
            phoneLocation += '<option value="Fax" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" selected="selected" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" data-i18n="contact.other"></option>';
        } else if (type == 'Other') {
            phoneLocation += '<option value="Work" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.mobile"></option>';
            phoneLocation += '<option value="Fax" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" selected="selected" data-i18n="contact.other"></option>';
        } else {
            phoneLocation += '<option value="Work" data-i18n="contact.work"></option>';
            phoneLocation += '<option value="Mobile" data-i18n="contact.mobile"></option>';
            phoneLocation += '<option value="Fax" data-i18n="contact.fax"></option>';
            phoneLocation += '<option value="Pager" data-i18n="contact.pager"></option>';
            phoneLocation += '<option value="Home" data-i18n="contact.home"></option>';
            phoneLocation += '<option value="Skype" data-i18n="contact.skype"></option>';
            phoneLocation += '<option value="Other" data-i18n="contact.other"></option>';
        }

        phoneLocation += '</select>';

        return phoneLocation;
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#edit-contact-phone-table .remove-contact-phone');
        $(document).off('click', '#edit-contact-phone-table .remove-contact-email');
        $(document).off('click', '#edit-contact-phone-table .remove-contact-web');
        $(document).off('click', '#back-link');
        $(document).off('keypress', '.contact-phone-number');
        $(document).off('click', '#edit-contact-more-link');
        $('#edit-contact .popup-menu-backdrop').off('click');
        $('#save-link').off('click');
        $("#edit-contact #autocomplete-company").off("keyup");
        $(document).off('click', '#edit-contact .additional-options');
        contactForOpen = null;
        isPhoneContact = false;
    };

    self.bindElementControls = function () {
        $(document).on('click', '.remove-contact-phone', self.removeContactAddress);
        $(document).on('click', '.remove-contact-email', self.removeContactAddress);
        $(document).on('click', '.remove-contact-web', self.removeContactAddress);
        $(document).on('click', '#back-link', self.backLinkEvent);
        $(document).on('keypress', '.contact-phone-number', self.validationTel);
        $(document).on('click', '#edit-contact-more-link', self.openEditContactPopup);
        $('#edit-contact .popup-menu-backdrop').on('click', function () {
            $('#edit-contact .advanced-menu').hide();
            $(this).hide();
        });

        $('#add-contact-phone').on('click', self.addContactPhone);
        $('#add-contact-email').on('click', self.addContactEmail);
        $('#add-contact-web').on('click', self.addContactWebAddress);
        $('#save-link').on('click', self.contactSaveButton);
        $("#edit-contact #autocomplete-company").on("keyup", function () {
            if ($(this).val() == "") {
                $("#edit-contact #title-box").hide();
                AutoCompleteController.setObject("Company", null);
            } else {
                $("#edit-contact #title-box").show();
            }
        });
        $(document).on('click', '#edit-contact .additional-options', self.contactSaveButton);
    };

    self.openEditContactPopup = function () {
        $('#edit-contact .popup-menu-backdrop').toggle();
        $('#edit-contact .advanced-menu').css('z-index', '20000');
        $('#edit-contact .advanced-menu').slideToggle('4000', 'swing');
    };


    self.setFontSize = function () {
        $('.contact-phone-number').each(function (index, value) {
            $(value).parent().css('padding', 'inherit');
        });
        $('.contact-email-adress').each(function (index, value) {
            $(value).parent().css('padding', 'inherit');
        });
        $('.contact-web-adress').each(function (index, value) {
            $(value).parent().css('padding', 'inherit');
        });
    };

    self.validationTel = function (event) {
        return (event.charCode >= 48 && event.charCode <= 57) || event.charCode == 43;
    };

    self.removeContactAddress = function (evt) {
        $(evt.currentTarget).parent().parent().remove();
    };

    self.backLinkEvent = function () {
        if ($("#contact-first-name").val() != "" || $("#contact-last-name").val() != "" || $("#edit-contact #contact-name").val() != "") {
            if (contactForOpen == null) {
                showActionDialog("There is unsaved data left, would you like to save it?", "Yes", function () {
                    if (contactType == "Person" || contactType == "People") {
                        self.savePerson();
                    } else if (contactType == "Company") {
                        self.saveCompany();
                    }
                }, "No", function () {
                    goBack();
                });
            } else if (contactForOpen != null) {
                if (contactType == "Person" || contactType == "People") {
                    if (contactForOpen["first-name"] != $("#contact-first-name").val() || contactForOpen["last-name"] != $("#contact-last-name").val()
                            || contactForOpen["background"] != $("#edit-contact #contact-background").val()
                            || contactForOpen["referenceId"] != $("#edit-contact #contact-reference-id").val()
                            || contactForOpen["company-name"] != $("#edit-contact #autocomplete-company").val()
                            || contactForOpen["title"] != $("#edit-contact #contact-title").val()) {
                        showActionDialog("There is unsaved data left, would you like to save it?", "Yes", function () {
                            self.savePerson();
                        }, "No", function () {
                            goBack();
                        });
                    } else {
                        goBack();
                    }
                } else if (contactType == "Company") {
                    if (contactForOpen.name != $("#edit-contact #contact-name").val() || contactForOpen.background != $("#edit-contact #contact-background").val()) {
                        showActionDialog("There is unsaved data left, would you like to save it?", "Yes", function () {
                            self.saveCompany();
                        }, "No", function () {
                            goBack();
                        });
                    } else {
                        goBack();
                    }
                } else {
                    goBack();
                }
            }
        } else {
            goBack();
        }
    };

    // event dodavanje tel broja
    self.addContactPhone = function () {
        $('#edit-contact-phone-table').append(
                '<tr class="contact-phone-row" phone_id="">'
                + '<td>' + self.getPhoneLocation() + '</td>'
                + '<td><input class="contact-phone-number" type="tel" data-mini="true" value="" class="full-width"/>'
                + '</td>'
                + '<td><a class="remove-contact-phone" href=""> <i class="md-remove  md-2x"></i></a></td>'
                + '</tr>');

        // Trigger create table
        $("#edit-contact-phone-table").i18n();
        $('#edit-contact-phone-table').trigger('create');
        self.setFontSize();
        
    };

    // event dodavanje email-a
    self.addContactEmail = function () {
        $('#edit-contact-email-table').append(
                '<tr class="contact-email-row" email_id="">'
                + '<td>' + self.getEmailLocation() + '</td>'
                + '<td><input class="contact-email-adress" type="email" data-mini="true" value="" class="full-width"/></td>'
                + '<td><a class="remove-contact-email" href=""> <i class="md-remove  md-2x"></i></a></td>'
                + '</tr>');

        // Trigger create table
        $('#edit-contact-email-table').i18n();
        $('#edit-contact-email-table').trigger('create');
        self.setFontSize();
    };

    // event dodavanje web addresse
    self.addContactWebAddress = function () {
        $('#edit-contact-web-table').append(
                '<tr class="contact-web-row" webAddress_id="">'
                + '<td>' + self.getWebLocation() + '</td>'
                + '<td><input class="contact-web-adress" type="text" data-mini="true" value="" class="full-width"/></td>'
                + '<td><a class="remove-contact-web" href=""> <i class="md-remove  md-2x"></i></a></td>'
                + '</tr>');

        // Trigger create table
        $('#edit-contact-web-table').i18n();
        $('#edit-contact-web-table').trigger('create');
        self.setFontSize();
    };

    self.initForm = function () {
        if (OPERATION == "EDIT") {
            $('#contact-delete-button').show();
        } else {
            $('#contact-delete-button').hide();
        }

        if (contactType == 'Person' || contactType == 'People') {
            $('#edit-contact-person').show();
            $('#edit-contact-company').hide();
            $("#contact-reference-id").parent().parent().show();
        } else if (contactType === 'Company') {
            $('#edit-contact-company').show();
            $('#edit-contact-person').hide();
            $("#contact-reference-id").parent().parent().hide();
        }
    };

    self.loadData = function () {
        var visibleTo;
        var groupId;
        if (contact['company-name']) {
            $("#edit-contact #title-box").show();
        } else {
            $("#edit-contact #title-box").hide();
        }
        if (contactType == 'Person' || contactType == 'People') {
            var firstName = typeof contact['first-name'] != "object" ? contact['first-name'] : "";
            var lastName = typeof contact['last-name'] != "object" ? contact['last-name'] : "";
            var title = typeof contact.title != "object" ? contact.title : "";
            var company = typeof contact['company-name'] != "object" ? contact['company-name'] : "";


            var background = typeof contact.background != "object" ? contact.background : "";
            if (title == null) {
                title = "";
            }
            if (company == null) {
                company = "";
            }
            visibleTo = contact['visible-to'];
            if (contact['group-id']) {
                groupId = contact['group-id'].text;
            }
            phoneArray = contact['contact-data']['phone-numbers']['phone-number'];
            emailArray = contact['contact-data']['email-addresses']['email-address'];
            webArray = contact['contact-data']['web-addresses']['web-address'];

            $('#contact-first-name').val(firstName);
            $('#contact-last-name').val(lastName);
            $('#contact-title').val(title);
            $('#contact-reference-id').val(contact.referenceId);
            if (contact["company-id"] != null && contact["company-id"].text != null && contact['company-name']) {
                $('#autocomplete-company').val(contact['company-name']);
                AutoCompleteController.setObject('Company', contact["company-id"].text);
            }


            $('#contact-background').val(background);
        } else {
            var name = contact.name != null ? contact.name : "";
            var background = typeof contact.background != "object" ? contact.background : "";
            phoneArray = contact['contact-data']['phone-numbers']['phone-number'];
            emailArray = contact['contact-data']['email-addresses']['email-address'];
            webArray = contact['contact-data']['web-addresses']['web-address'];
            visibleTo = contact['visible-to'];
            groupId = contact['group-id'].text;
            $('#contact-name').val(name);
            $('#contact-reference-id').parent().show();
            $('#contact-background').val(background);
        }
        if (phoneArray != null) {
            var html = "";
            if (phoneArray.length > 1) {
                for (var obj in phoneArray) {
                    if (phoneArray[obj].location != null) {
                        html += '<tr class="contact-phone-row" phone_id="' + phoneArray[obj].id.text + '">'
                                + '<td><select class="contact-phone-location" data-theme="d" disabled="disabled"><option value="' + phoneArray[obj].location + '" selected="selected">'
                                + phoneArray[obj].location + '</option></select></td>'
                                + '<td><input class="contact-phone-number" type="tel" data-mini="true" value="' + phoneArray[obj].number + '"/></td>'
                                + '<td><a class="remove-contact-phone" href=""> <i class="md-remove  md-2x"></i></a></td>'
                                + '</tr>';
                    }
                }
            } else {
                if (phoneArray.id != null) {
                    html += '<tr class="contact-phone-row" phone_id="' + phoneArray.id.text + '">'
                            + '<td><select class="contact-phone-location" data-theme="d" disabled="disabled"><option value="' + phoneArray.location + '" selected="selected">'
                            + phoneArray.location + '</option></select></td>'
                            + '<td><input class="contact-phone-number" type="tel" data-mini="true" value="' + phoneArray.number + '"/></td>'
                            + '<td><a class="remove-contact-phone" href=""> <i class="md-remove  md-2x"></i></a></td>'
                            + '</tr>';
                }
            }

            $('#edit-contact-phone-table').append(html).trigger('create');
        }

        if (emailArray != null) {
            var html = "";
            if (emailArray.length > 1) {
                for (var obj in emailArray) {
                    if (emailArray[obj].id) {
                        html += '<tr class="contact-email-row" email_id="' + emailArray[obj].id.text + '">'
                                + '<td><select class="contact-email-location" data-theme="d" disabled="disabled"><option value="' + emailArray[obj].location + '" selected="selected">'
                                + emailArray[obj].location + '</option></select></td>'
                                + '<td><input class="contact-email-adress" type="email" data-mini="true" value="' + emailArray[obj].address + '"/></td>'
                                + '<td><a class="remove-contact-email" href=""> <i class="md-remove  md-2x"></i></a></td>'
                                + '</tr>';
                    }
                }
            } else {
                if (emailArray.id != null) {
                    html += '<tr class="contact-email-row" email_id="' + emailArray.id.text + '">'
                            + '<td><select class="contact-email-location" data-theme="d" disabled="disabled"><option value="' + emailArray.location + '" selected="selected">'
                            + emailArray.location + '</option></select></td>'
                            + '<td><input class="contact-email-adress" type="email" data-mini="true" value="' + emailArray.address + '"/></td>'
                            + '<td><a class="remove-contact-email" href=""> <i class="md-remove  md-2x"></i></a></td>'
                            + '</tr>';
                }
            }
            $('#edit-contact-email-table').append(html).trigger('create');
        }

        if (webArray != null) {
            var html = "";
            if (webArray.length > 1) {
                for (var obj in webArray) {
                    if (webArray[obj].id) {
                        html += '<tr class="contact-web-row" web_id="' + webArray[obj].id.text + '">'
                                + '<td><select class="contact-web-location" data-theme="d" disabled="disabled"><option value="' + webArray[obj].urlType + '" selected="selected">'
                                + webArray[obj].urlType + '</option></select></td>'
                                + '<td><input class="contact-web-adress" type="text" data-mini="true" value="' + webArray[obj].URL + '""/></td>'
                                + '<td><a class="remove-contact-web" href=""> <i class="md-remove  md-2x"></i></a></td>'
                                + '</tr>';
                    }
                }
            } else {
                if (webArray.id != null) {
                    html += '<tr class="contact-web-row" web_id="' + webArray.id.text + '">'
                            + '<td><select class="contact-web-location" data-theme="d" disabled="disabled">'
                            + '<option value="' + webArray.urlType + '" selected="selected">'
                            + webArray.urlType + '</option></select></td>'
                            + '<td><input class="contact-web-adress" type="text" data-mini="true" value="' + webArray.URL + '"" /></td>'
                            + '<td><a class="remove-contact-web" href=""> <i class="md-remove  md-2x"></i></a></td>'
                            + '</tr>';
                }
            }
            $('#edit-contact-web-table').append(html).trigger('create');
        }
        if (visibleTo) {
            console.log("Visible to: " + visibleTo);
            PermissionController.setData(visibleTo);
        }
    };

    self.contactSaveButton = function () {
        $("#edit-contact .advanced-menu").hide();
        $("#edit-contact .popup-menu-backdrop").hide();
        $(this).addClass('not-clickable');
        if (contactType == 'Person' || contactType == 'People') {
            self.savePerson();
        } else {
            self.saveCompany();
        }
    };


    self.savePerson = function () {
        playSound("www/libs/blop.mp3");
        var firstName = $.trim($('#contact-first-name').val());
        var lastName = $.trim($('#contact-last-name').val());
        var title = $.trim($('#contact-title').val());
        var info = $.trim($('#contact-background').val());
        var referenceId = $.trim($('#contact-reference-id').val());
        var personsCompany = null;

        var companyId = null;
        var companyName = null;
        var phones = [];
        var emails = [];
        var webs = [];
        var visible = [];
        
        // get company of Person
        if($("#autocomplete-company").val() != ""){
            personsCompany = $("#autocomplete-company").val().escape();
        }

        if ($('#autocomplete-company').val() == "") {
            AutoCompleteController.setObject('Company', null);
        }

        if (firstName == null || firstName == "") {
            alert("First name field is empty!");
            return;
        }

        if (AutoCompleteController.getObject('Company')) {
            companyId = AutoCompleteController.getObject('Company');
            companyName = null;
        } else {
            companyId = null;
            companyName = $("#edit-contact #autocomplete-company").val();
            if ($.trim(companyName) == "") {
                companyName = null;
            }
        }

        if (lastName == null || lastName == "") {
            alert("Last name field is empty!");
            return;
        }

        var contactPhoneRows = $('.contact-phone-row');
        for (i = 0; i < contactPhoneRows.length; i++) {
            phones.push({phoneNumber: $.trim($(contactPhoneRows[i]).find('.contact-phone-number').val()), numberType: $.trim($(contactPhoneRows[i]).find('.contact-phone-location option:selected').val())});
        }

        var contactEmailRows = $('.contact-email-row');
        var valideMail = true;
        for (i = 0; i < contactEmailRows.length; i++) {
            var value = $(contactEmailRows[i]).find('.contact-email-adress').val();
            var temp = patternForMail.exec(value);

            if (temp != null) {
                valideMail = true;
                emails.push({eMailAddress: $.trim($(contactEmailRows[i]).find('.contact-email-adress').val()), eMailAddressType: $.trim($(contactEmailRows[i]).find('.contact-email-location option:selected').val())});
            } else {
                valideMail = false;
                alert(emailMessageIncorrect(value));
                break;
            }
        }

        if (!valideMail) {
            return;
        }

        var contactWebRows = $('.contact-web-row');
        for (i = 0, max = contactWebRows.length; i < max; i++) {
            webs.push({URL: $.trim($(contactWebRows[i]).find('.contact-web-adress').val()), urlType: $.trim($(contactWebRows[i]).find('.contact-web-location option:selected').val())});
        }
        var visible = PermissionController.permission;
        //edit postojeceg objekta
        if (contactForOpen) {
            var contactCurrentId = contactForOpen.id.text;
            contactForOpen.currentType = "";
            if (window.localStorage.getItem("enableSave") == "true") {
                showActionDialog(Messages.Contact.saveContactMessage, 'Yes', function () {
                    if (!PermissionController.changeACL) {
                        visible = null;
                    }
                    if (companyName != null) {
                        CompanyController.findCompanyByName(companyName, function (company) {
                            if (company != null && company[0] != null) {
                                PeopleController.update(contactCurrentId, firstName, lastName, company[0].id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                    if (connection) {
                                        ViewContactFunctions.tab.current = "GENERAL";
                                        gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                    } else {
                                        goBack();
                                    }
                                });
                            } else {
                                CompanyController.save(companyName, [], [], webs, "", [], function (newCompany) {
                                    if (newCompany != null) {
                                        PeopleController.update(contactCurrentId, firstName, lastName, newCompany.id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                            if (connection) {
                                                ViewContactFunctions.tab.current = "GENERAL";
                                                gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                            } else {
                                                goBack();
                                            }
                                        });
                                    }
                                });
                            }
                        });
                    } else {
                        PeopleController.update(contactCurrentId, firstName, lastName, companyId, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                            goBack();
                        });
                    }
                }, "No", function () {
                });
            } else {
                if (!PermissionController.changeACL) {
                    visible = null;
                }

                if (companyName != null) {
                    CompanyController.findCompanyByName(companyName, function (company) {
                        if (company != null && company[0] != null) {
                            PeopleController.update(contactCurrentId, firstName, lastName, company[0].id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                if (connection) {
                                    ViewContactFunctions.tab.current = "GENERAL";
                                    gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                } else {
                                    goBack();
                                }
                            });
                        } else {
                            CompanyController.save(companyName, [], [], webs, "", [], function (newCompany) {
                                if (newCompany != null) {
                                    PeopleController.update(contactCurrentId, firstName, lastName, newCompany.id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                        if (connection) {
                                            ViewContactFunctions.tab.current = "GENERAL";
                                            gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                        } else {
                                            goBack();
                                        }
                                    });
                                }
                            });
                        }
                    });
                } else {
                    PeopleController.update(contactForOpen.id.text, firstName, lastName, companyId, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                        goBack();
                    });
                }
            }
        } else {
            if (companyId != null && companyName == null) {
                if (window.localStorage.getItem("enableSave") == "true") {
                    showActionDialog(Messages.Contact.saveContactMessage, 'Yes', function () {
                        if (connection) {
                            PeopleController.save(firstName, lastName, companyId, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                ViewContactFunctions.tab.current = "GENERAL";

                                gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});

                            });
                        } else {
                            goBack();
                        }
                    }, "No", function () {
                    });
                } else {
                    PeopleController.save(firstName, lastName, companyId, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                        if (connection) {
                            ViewContactFunctions.tab.current = "GENERAL";
                            if (data) {
                                gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                            } else {
                                goBack();
                            }
                        } else {
                            goBack();
                        }
                    });
                }
            } else {
                if (companyName != null) {
                    CompanyController.findCompanyByName(companyName, function (company) {
                        if (company != null && company[0] != null) {
                            if (window.localStorage.getItem("enableSave") == "true") {
                                showActionDialog(Messages.Contact.saveContactMessage, 'Yes', function () {
                                    PeopleController.save(firstName, lastName, company[0].id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                        if (connection) {
                                            ViewContactFunctions.tab.current = "GENERAL";
                                            gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                        } else {
                                            goBack();
                                        }
                                    });
                                }, "No", function () {
                                });
                            } else {
                                PeopleController.save(firstName, lastName, company[0].id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                    if (connection) {
                                        ViewContactFunctions.tab.current = "GENERAL";
                                        gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                    } else {
                                        goBack();
                                    }
                                });
                            }
                        } else {
                            if (window.localStorage.getItem("enableSave") == "true") {
                                showActionDialog(Messages.Contact.saveContactMessage, 'Yes', function () {
                                    CompanyController.save(companyName, [], [], webs, "", false, function (newCompany) {
                                        if (newCompany != null) {
                                            PeopleController.save(firstName, lastName, newCompany.id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                                if (connection) {
                                                    ViewContactFunctions.tab.current = "GENERAL";
                                                    gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                                } else {
                                                    goBack();
                                                }
                                            });
                                        }
                                    });
                                }, "No", function () {
                                });
                            } else {
                                CompanyController.save(companyName, [], [], webs, "", visible, function (newCompany) {
                                    if (newCompany != null) {
                                        PeopleController.save(firstName, lastName, newCompany.id.text, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                            if (connection) {
                                                ViewContactFunctions.tab.current = "GENERAL";
                                                gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                            } else {
                                                goBack();
                                            }
                                        });
                                    }
                                });
                            }
                        }
                    });
                } else {
                    if (window.localStorage.getItem("enableSave") == "true") {
                        showActionDialog(Messages.Contact.saveContactMessage, 'Yes', function () {
                            PeopleController.save(firstName, lastName, companyId, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                                if (connection) {
                                    ViewContactFunctions.tab.current = "GENERAL";
                                    gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                                } else {
                                    goBack();
                                }
                            });
                        }, "No", function () {
                        });
                    } else {
                        PeopleController.save(firstName, lastName, companyId, title, phones, emails, webs, info, referenceId, visible, personsCompany, function (data) {
                            if (connection) {
                                ViewContactFunctions.tab.current = "GENERAL";
                                gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});

                            } else {
                                goBack();
                            }
                        });
                    }
                }
            }
        }
        contactForOpen = null;
    };

    self.saveCompany = function () {
        playSound("www/libs/blop.mp3");
        var name = $.trim($('#contact-name').val());
        var info = $.trim($('#contact-background').val());
        var phones = [];
        var emails = [];
        var webs = [];

        if (name == null || name == "") {
            alert("Name field is empty!");
        }

        var contactPhoneRows = $('.contact-phone-row');
        for (i = 0; i < contactPhoneRows.length; i++) {
            phones.push({phoneNumber: $.trim($(contactPhoneRows[i]).find('.contact-phone-number').val()), numberType: $.trim($(contactPhoneRows[i]).find('.contact-phone-location option:selected').val())});
        }

        var contactEmailRows = $('.contact-email-row');
        var valideMail = true;
        for (i = 0; i < contactEmailRows.length; i++) {
            var value = $(contactEmailRows[i]).find('.contact-email-adress').val();
            var temp = patternForMail.exec(value);

            if (temp != null) {
                valideMail = true;
                emails.push({eMailAddress: $.trim($(contactEmailRows[i]).find('.contact-email-adress').val()), eMailAddressType: $.trim($(contactEmailRows[i]).find('.contact-email-location option:selected').val())});
            } else {
                valideMail = false;
                alert(emailMessageIncorrect(value));
                break;
            }
        }

        var contactWebRows = $('.contact-web-row');
        for (i = 0; i < contactWebRows.length; i++) {
            webs.push({URL: $.trim($(contactWebRows[i]).find('.contact-web-adress').val()), urlType: $.trim($(contactWebRows[i]).find('.contact-web-location option:selected').val())});
        }

        var visible = PermissionController.permission;

        if (contactForOpen != null) {
            var contactObjectId = contactForOpen.id.text;
            if (window.localStorage.getItem("enableSave") == "true") {
                showActionDialog(Messages.Contact.saveContactMessage, 'Yes', function () {
                    if (!PermissionController.changeACL) {
                        visible = null;
                    }
                    CompanyController.update(contactObjectId, name, phones, emails, webs, info, visible, function (data) {
                        goBack();
                    });
                }, "No", function () {
                });
            } else {
                if (!PermissionController.changeACL) {
                    visible = null;
                }
                CompanyController.update(contactForOpen.id.text, name, phones, emails, webs, info, visible, function (data) {
                    goBack();
                });
            }
        } else {
            if (window.localStorage.getItem("enableSave") == "true") {
                showActionDialog(Messages.Contact.saveContactMessage, 'Yes', function () {
                    CompanyController.save(name, phones, emails, webs, info, visible, function (data) {
                        if (connection) {
                            ViewContactFunctions.tab.current = "GENERAL";
                            gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                        } else {
                            goBack();
                        }
                    });
                }, "No", function () {
                });
            } else {
                CompanyController.save(name, phones, emails, webs, info, visible, function (data) {
                    if (connection) {
                        ViewContactFunctions.tab.current = "GENERAL";
                        gotoPage({url: "viewContact", param: {contactId: data.id.text, contactType: data.objectType}});
                    } else {
                        goBack();
                    }
                });
            }
        }
        contactForOpen = null;
    };

    self.drawCallLogPhone = function (phoneArray) {
        for (var index in phoneArray) {
            var phoneType = phoneArray[index].type;
            phoneType = phoneType.charAt(0).toUpperCase() + phoneType.slice(1);
            var html = '<tr class="contact-phone-row">'
                    + '<td><select class="contact-phone-location" data-theme="d" disabled="disabled"><option value="' + phoneType + '" selected="selected">'
                    + phoneType + '</option></select></td>'
                    + '<td><input class="contact-phone-number" type="tel" data-mini="true" value="' + phoneArray[index].value + '"/></td>'
                    + '<td><a class="remove-contact-phone" href=""> <i class="md-remove  md-2x"></i></a></td>'
                    + '</tr>';
        }
        $('#edit-contact-phone-table').append(html).trigger('create');
    };


    return self;
}(EditContactFunctions || {}));