$(document).on('pageinit', '#view-phone-contact', function () {
    ViewPhoneContactFunctions.init();
});

$(document).on('pageshow', '#view-phone-contact', function () {
    ViewPhoneContactFunctions.bindElementControls();
    showLoadingIndikator();
});

$(document).on('pagehide', '#view-phone-contact', function () {
    ViewPhoneContactFunctions.unbindElementControls();
});

var ViewPhoneContactFunctions = (function (ViewPhoneContactFunctions) {
    var self = ViewPhoneContactFunctions;
    var phoneContactId = null;
    var contactType = null;
    var phoneContactParentId = null;
    var phoneContactAccessList = null;
    var phoneContactIds = [];
    var currentIndex = null;
    var phoneContact = null;
    var $contactEmailList = null;
    var $contactPhoneList = null;
    var $contactPhoneListLabel = null;
    var $contactEmailListLabel = null;
    var $contactWebAdressList = null;
    var $contactWebAdressListLabel = null;

    self.init = function () {

        $contactPhoneList = $("#view-phone-contact #contact-phone-list");
        $contactPhoneListLabel = $("#view-phone-contact #contact-phone-box");
        $contactEmailList = $('#view-phone-contact #contact-email-list');
        $contactEmailListLabel = $('#view-phone-contact #contact-email-box');
        $contactWebAdressList = $('#view-phone-contact #contact-web-adress-list');
        $contactWebAdressListLabel = $('#view-phone-contact #contact-web-adress-box');

        if (pageObject) {
            if (pageObject.phoneContactId) {
                phoneContactId = pageObject.phoneContactId;
            }
            if (pageObject.contactType) {
                contactType = pageObject.contactType;
            }
            if (pageObject.parentId) {
                phoneContactParentId = pageObject.parentId;
            }
            if (pageObject.accessList) {
                phoneContactAccessList = pageObject.accessList;
            }
            if (pageObject.phoneContactIds){
                phoneContactIds = pageObject.phoneContactIds;
            }
        }
        pageObject = null;

        // phone contact pagination
        if(phoneContactIds && phoneContactIds.length > 1){
            currentIndex = phoneContactIds.indexOf(phoneContactId);
        }
        debugger;

        ContactsController.findPhoneContactById(phoneContactId, function (data) {
            if (data) {
                phoneContact = self.encodePhoneContact(data);
                self.loadData();
            }
            hideLoadingIndikator();
        });
    };

    self.bindElementControls = function () {
        $(document).on('click', '#view-phone-contact #contact-more-link', self.openEditCommentPopup);
        $(document).on('click', '#view-phone-contact #back-link', goBack);
        $(document).on('click', '#view-phone-contact #add-contact', self.openEditContact);
        $(document).on('click', '#view-phone-contact .call', self.callContact);
        $(document).on('click', '#favorite-contact-action', self.favoriteContactEvent);
        $(document).on('click', '#view-phone-contact .float-add-action', self.openEditContact);
        $('#view-phone-contact .popup-menu-backdrop').on('click', function () {
            $('#view-phone-contact .advanced-menu').hide();
            $(this).hide();
        });
        $("body").on('swipeleft', '#view-phone-contact', self.swipeLeftEvent);
        $("body").on('swiperight', '#view-phone-contact', self.swipeRightEvent);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#view-phone-contact #contact-more-link');
        $(document).off('click', '#view-phone-contact #back-link');
        $(document).off('click', '#view-phone-contact #add-contact');
        $(document).off('click', '#view-phone-contact .call');
        $(document).off('click', '#favorite-contact-action');
        $(document).off('click', '#view-phone-contact .float-add-action');
        $('#view-phone-contact .popup-menu-backdrop').off('click');
        $("body").off('swipeleft', '#view-phone-contact');
        $("body").off('swiperight', '#view-phone-contact');
        phoneContact = null;
    };

    self.favoriteContactEvent = function() {
        PhoneContactController.findById(phoneContactId, function(item){
            if ($('#favorite-contact-action > span.popup-menu-item').hasClass("contact-favorite-star")) {
                 FavoriteController.findByObjectIdDB(phoneContactId , function(data){
                    if (data[0]) {
                        FavoriteController.removeFavoriteDB(data[0].id, function () {
                            $('#favorite-contact-action > span.popup-menu-item').toggleClass("contact-favorite-star");
                            $('#view-phone-contact .popup-menu-backdrop').hide();
                            $('#view-phone-contact .advanced-menu').hide();
                        });
                    }
                 });
            } else {
               FavoriteController.save("PhoneNumber", item[0], function(){
                    $('#favorite-contact-action > span.popup-menu-item').toggleClass("contact-favorite-star");
                    $('#view-phone-contact .popup-menu-backdrop').hide();
                    $('#view-phone-contact .advanced-menu').hide();
                });
            }
        });
    }

    self.openEditCommentPopup = function () {
        $('#view-phone-contact .popup-menu-backdrop').toggle();
        $('#view-phone-contact .advanced-menu').css('z-index', '20000');
        $('#view-phone-contact .advanced-menu').slideToggle('4000', 'swing');
    };

    self.encodePhoneContact = function (phoneContact) {
        var phoneObj = {
            "contact-data": {
                "phone-numbers": {
                    "phone-number": []
                },
                "email-addresses": {
                    "email-address": []
                },
                "web-addresses": {
                    "web-address": []
                }
            },
            url:{}
        };
        if (phoneContact.id) {
            phoneObj["id"] = phoneContact.id;
        }
        if (phoneContact.photos) {
            if (phoneContact.photos.length > 0) {
                phoneObj.url = phoneContact.photos[0].value;
            }
        }

        if (phoneContact.name) {
            phoneObj['first-name'] = phoneContact.name.givenName;
            phoneObj['last-name'] = phoneContact.name.familyName;
        }
        if (phoneContact.phoneNumbers) {
            if (phoneContact.phoneNumbers.length > 1) {
                for (var i = 0; i < phoneContact.phoneNumbers.length; i++) {
                    var phone = {id: {}};
                    phone.id.text = phoneContact.phoneNumbers[i].id;
                    phone.location = self.capitalize(phoneContact.phoneNumbers[i].type);
                    phone.number = phoneContact.phoneNumbers[i].value;
                    phoneObj['contact-data']['phone-numbers']['phone-number'].push(phone);
                }
            } else {
                phoneObj['contact-data']['phone-numbers']['phone-number'] = {id: {}};
                phoneObj['contact-data']['phone-numbers']['phone-number'].id.text = phoneContact.phoneNumbers[0].id;
                phoneObj['contact-data']['phone-numbers']['phone-number'].location = self.capitalize(phoneContact.phoneNumbers[0].type);
                phoneObj['contact-data']['phone-numbers']['phone-number'].number = phoneContact.phoneNumbers[0].value;
            }
        }
        if (phoneContact.emails) {
            if (phoneContact.emails.length > 1) {
                for (i = 0; i < phoneContact.emails.length; i++) {
                    var email = {id: {}};
                    email.id.text = phoneContact.emails[i].id;
                    email.location = self.capitalize(phoneContact.emails[i].type);
                    email.address = phoneContact.emails[i].value;
                    phoneObj['contact-data']['email-addresses']['email-address'].push(email);
                }
            } else {
                phoneObj['contact-data']['email-addresses']['email-address'] = {id: {}};
                phoneObj['contact-data']['email-addresses']['email-address'].id.text = phoneContact.emails[0].id;
                phoneObj['contact-data']['email-addresses']['email-address'].location = self.capitalize(phoneContact.emails[0].type);
                phoneObj['contact-data']['email-addresses']['email-address'].address = phoneContact.emails[0].value;
            }
        }
        if (phoneContact.urls) {
            if (phoneContact.urls.length > 1) {
                for (i = 0; i < phoneContact.urls.length; i++) {
                    var web = {id: {}};
                    web.id.text = phoneContact.urls[i].id;
                    web.urlType = self.capitalize(phoneContact.urls[i].type);
                    web.URL = phoneContact.urls[i].value;
                    phoneObj['contact-data']['web-addresses']['web-address'].push(web);
                }
            } else {
                phoneObj['contact-data']['web-addresses']['web-address'] = {id: {}};
                phoneObj['contact-data']['web-addresses']['web-address'].id.text = phoneContact.urls[0].id;
                phoneObj['contact-data']['web-addresses']['web-address'].urlType = self.capitalize(phoneContact.urls[0].type);
                phoneObj['contact-data']['web-addresses']['web-address'].URL = phoneContact.urls[0].value;
            }
        }
        return phoneObj;
    };

    self.capitalize = function (txt) {
        if (txt != null && txt.charAt(0) != null) {
            return txt.charAt(0).toUpperCase() + txt.slice(1);
        } else {
            return txt;
        }
    };

    self.loadData = function(){
        $('#view-phone-contact .avatar-container').html('<span id="avatar" class="avatar is-contact-image"><i class="md-person  md-3x"></i></span>');
        var name = "";
        if(phoneContact["first-name"]){
            name = phoneContact["first-name"];
        }
        if(phoneContact["last-name"]){
            name = name + " " + phoneContact["last-name"];
        }

        $("#view-phone-contact #user-name").text(name);
        FavoriteController.findByObjectIdDB(phoneContact["id"], function(items){
            if (items && items.length > 0) {
                $('#favorite-contact-action > span.popup-menu-item')
                .addClass("contact-favorite-star");
            }
        });

        //load phone numbers
        self.drawPhoneNumbers(phoneContact['contact-data']['phone-numbers']);
        self.drawEmailAddresses(phoneContact['contact-data']['email-addresses']);
        self.drawWebAddresses(phoneContact['contact-data']['web-addresses']);

        // load user avatar
        if(phoneContact.url){
            self.loadContactAvatar(phoneContact.url);
        }

    };

    self.drawPhoneNumbers = function (contactPhoneNumberArray) {
        try {
            var contactPhoneNumbers = contactPhoneNumberArray;
            var phoneHTML = "";
            $contactPhoneList.empty();

            if (contactPhoneNumberArray['phones'] != null) {
                contactPhoneNumberArray['phone-number'] = contactPhoneNumberArray['phones'];
            }

            if (contactPhoneNumberArray['phone-number'] != null) {
                if (contactPhoneNumberArray['phone-number'].length > 1) {
                    for (var i = 0; i < contactPhoneNumberArray['phone-number'].length; i++) {

                        if (contactPhoneNumberArray['phone-number'][i].phoneNumber != null) {
                            contactPhoneNumberArray['phone-number'][i].number = contactPhoneNumberArray['phone-number'][i].phoneNumber;
                            contactPhoneNumberArray['phone-number'][i].location = contactPhoneNumberArray['phone-number'][i].numberType;
                        }

                        if (contactPhoneNumberArray['phone-number'][i].location != null) {
                            phoneHTML += '<li style="margin-bottom:20px">'
                                    + contactPhoneNumberArray['phone-number'][i].location
                                    + '&nbsp;&nbsp;'
                                    + '<span class="bold">' + contactPhoneNumberArray['phone-number'][i].number
                                    + '</span>'
                                    + '<a class="call" href="#" phonenumber="' + contactPhoneNumberArray['phone-number'][i].number + '"><i class="md-phone-in-talk  md-2x" style="color:gray;"></i></a>'
                                    //+ '<a class="call" href="tel:' + contactPhoneNumberArray['phone-number'][i].number + '"></a>'
                                    + '<a class="sms" href="sms:' + contactPhoneNumberArray['phone-number'][i].number + '"><i class="md-sms  md-2x" style="color:gray;"></i></a>'
                                    + '</li>';
                        }
                    }
                } else {
                    if (contactPhoneNumberArray['phone-number'] != null && contactPhoneNumberArray['phone-number'][0] != null && contactPhoneNumberArray['phone-number'][0].phoneNumber != null) {
                        contactPhoneNumberArray['phone-number'].number = contactPhoneNumberArray['phone-number'][0].phoneNumber;
                        contactPhoneNumberArray['phone-number'].location = contactPhoneNumberArray['phone-number'][0].numberType;
                    }

                    if (contactPhoneNumberArray['phone-number'].location != null) {
                        phoneHTML += '<li style="margin-bottom:20px">'
                                + contactPhoneNumberArray['phone-number'].location
                                + '&nbsp;&nbsp;'
                                + '<span class="bold">' + contactPhoneNumberArray['phone-number'].number
                                + '</span>'
                                + '<a class="call" href="#" phonenumber="' + contactPhoneNumberArray['phone-number'].number + '"><i class="md-phone-in-talk  md-2x" style="color:gray;"></i></a>'
                                + '<a class="sms" href="sms:' + contactPhoneNumberArray['phone-number'].number + '"><i class="md-sms  md-2x" style="color:gray;"></i></a>'
                                + '</li>';
                    }

                }
                if (phoneHTML != "") {
                    $contactPhoneList.append(phoneHTML);
                    $contactPhoneListLabel.show();
                    $contactPhoneList.show();
                } else {
                    $contactPhoneListLabel.hide();
                }
            }
        } catch (e) {
            console.log("ViewContactFunctions.js -> self.loadCompanyGeneral -> \n" + e);
        }
    };

    self.drawEmailAddresses = function (contactEmailArray) {
        try {
            // email addresses
            var addressHTML = "";
            $contactEmailList.empty();

            if (contactEmailArray['emails'] != null) {
                contactEmailArray['email-address'] = contactEmailArray['emails'];
            }

            if (contactEmailArray['email-address'] != null) {
                if (contactEmailArray['email-address'].length > 1) {
                    for (var i = 0; i < contactEmailArray['email-address'].length; i++) {

                        if (contactEmailArray['email-address'][i].eMailAddress != null) {
                            contactEmailArray['email-address'][i].address = contactEmailArray['email-address'][i].eMailAddress;
                            contactEmailArray['email-address'][i].location = contactEmailArray['email-address'][i].eMailAddressType;
                        }

                        if (contactEmailArray['email-address'][i].address != null) {
                            addressHTML += '<li style="margin-bottom:20px">'
                                    + contactEmailArray['email-address'][i].location
                                    + '&nbsp;&nbsp;'
                                    + '<span class="bold">' + contactEmailArray['email-address'][i].address
                                    + '</span>'
                                    + '<a class="email" href="mailto:' + contactEmailArray['email-address'][i].address + '"><i class="md-email md-2x" style="color:gray;"></i></a>'
                                    + '</li>';
                        }
                    }
                } else {

                    if (contactEmailArray['phone-number'] != null && contactEmailArray['phone-number'][0] != null && contactEmailArray['phone-number'][0].eMailAddress != null) {
                        contactEmailArray['phone-number'].address = contactEmailArray['phone-number'][0].eMailAddress;
                        contactEmailArray['phone-number'].location = contactEmailArray['phone-number'][0].eMailAddressType;
                    }

                    if (contactEmailArray['email-address'].address != null) {
                        addressHTML += '<li style="margin-bottom:20px">'
                                + contactEmailArray['email-address'].location
                                + '&nbsp;&nbsp;'
                                + '<span class="bold">' + contactEmailArray['email-address'].address
                                + '</span>'
                                + '<a class="email" href="mailto:' + contactEmailArray['email-address'].address + '"><i class="md-email md-2x" style="color:gray;"></i></a>'
                                + '</li>';
                    }
                }
                if (addressHTML != "") {
                    $contactEmailList.append(addressHTML);
                    $contactEmailListLabel.show();
                    $contactEmailList.show();
                } else {
                    $contactEmailListLabel.hide();
                }
            }
        } catch (e) {
            console.log("ViewContactFunctions.js -> self.loadCompanyGeneral -> \n" + e);
        }
    };

    self.drawWebAddresses = function (contactWebArray) {
        try {
            $contactWebAdressList.empty();
            var webAddressHTML = "";
            if (contactWebArray['web-address'] != null) {
                if (contactWebArray['web-address'].length > 1) {
                    for (var i = 0; i < contactWebArray['web-address'].length; i++) {
                        webAddressHTML += '<li><a class="web" url="' + contactWebArray['web-address'][i].URL + '" href="">' + contactWebArray['web-address'][i].urlType + '&nbsp;&nbsp;<span class="bold">' + contactWebArray['web-address'][i].URL + '</span>'
                                + '</a></li>';
                    }
                } else {
                    if (contactWebArray['web-address'].urlType != null) {
                        webAddressHTML += '<li><a class="web" url="' + contactWebArray['web-address'].URL + '" href="">' + contactWebArray['web-address'].urlType + '&nbsp;&nbsp;<span class="bold">' + contactWebArray['web-address'].URL + '</span>'
                                + '</a></li>';
                    }
                }
                if (webAddressHTML != "") {
                    $contactWebAdressList.append(webAddressHTML);
                    $contactWebAdressListLabel.show();
                    $contactWebAdressList.show();
                } else {
                    $contactWebAdressListLabel.hide();
                }
            }
        } catch (e) {
            console.log("ViewContactFunctions.js -> self.loadCompanyGeneral -> \n" + e);
        }
    };

    self.loadContactAvatar = function (url) {
        var img = new Image();
        img.onload = function () {
            $('#view-phone-contact .avatar-container').empty();
            $("#view-phone-contact .avatar-container").html('<div id="avatar" class="content-left-avatar" style="width:42px; position: static;"><div class="content-avatar is-profile-pic" style="background-image: url(' + url + ')"></div></div>');
        };

        img.onerror = function (err) {
            console.log("Loading image error: " + err);
        };
        img.src = url;
    };

    self.openEditContact = function(){
      gotoPage({url: "editContact", param: {phoneContactId: phoneContactId, contactType: "Person", parentId: phoneContactParentId, accessList: phoneContactAccessList}}, {url: "viewPhoneContact", param: {phoneContactId: phoneContactId, phoneContactIds: phoneContactIds, contactType: "Person", parentId: phoneContactParentId, accessList: phoneContactAccessList}});
    };

    self.swipeLeftEvent =  function(){
        if(phoneContactIds && phoneContactIds.length > 1){
            currentIndex++;
            currentIndex = (currentIndex > phoneContactIds.length -1) ? 0 : currentIndex;
            phoneContactId = phoneContactIds[currentIndex];
            self.init();
        }
    };

    self.swipeRightEvent = function(){
        if(phoneContactIds && phoneContactIds.length){
            currentIndex--;
            currentIndex = (currentIndex < 0) ? (phoneContactIds.length - 1) : currentIndex;
            phoneContactId = phoneContactIds[currentIndex];
            self.init();
        }
    };

    self.callContact = function () {
        try {
            var phoneNumber = $(this).attr('phonenumber');
            document.location.href = "tel:" + phoneNumber;
        } catch (e) {
            console.log("ViewContactFunctions.js -> self.loadCompanyGeneral -> \n" + e);
        }
    };

    return self;
}(ViewPhoneContactFunctions || {}));
