$(document).on('pageinit', '#dashboard', function () {
    DashboardFunctions.loadNumberOfFeedListItems();
    hideLoadingIndikator();
});

$(document).on('pageshow', '#dashboard', function () {
    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
        $("#call-list-link").remove();
    }
    DashboardFunctions.bindElementControls();
    DashboardFunctions.setConnectionMode();
    Advert.getAdverts("#ad-banner");
    Advert.bindElementControls();
    DashboardFunctions.init();
});

$(document).on('pagehide', '#dashboard', function () {
    DashboardFunctions.unbindElementControls();
});

var DashboardFunctions = (function (DashboardFunctions)
{
    var self = DashboardFunctions;
    var $dashboardList = null;
    var $dashboardListMessage = null;
    var $dashboard = null;
    var $filterFeed = null;
    var start = 0;
    var searchValue = null;
    var selectedNotifications = [];
    var readAllInOffline = false;
    var notificationInterval = null;
    var notificationPage = 0;
    var notificationOffset = 5;
    var listFavoriteIds = [];
    var onlineUsersSip = [9];

    self.currentFilter = "filter-all-feed";

    self.scrollTopData =  {
        'start' : 0,
        'scrollTop' : 0
    };

    self.loadNumberOfFeedListItems = function() {
      if (localStorage.getItem('feedOffset')) {
        try {
          feedOffset = parseInt(localStorage.getItem('feedOffset'));
        } catch(e) {}
      }
    }

    self.preinit = function(callback){
      FavoriteController.findUserIds(function(data){
        listFavoriteIds = data;
        if (callback != null && typeof callback == "function") {
            callback();
        }
      });
    }

    self.init = function () {
        VisibleDomainController.hide('dashboard');
        showLoadingIndikator();
        //hide call list option for iOS devices
        removeCallListForIOS("main-nav-list", "dashboard", "call-list-link");

        //show user current location
        if(latitude && longitude) {
            var maps = new GoogleMap();
            maps.getUserAddress(function (address, status) {
                if (address) {
                    $("#dashboard #user-location").text(address);
                } else {
                    $("#dashboard #user-location").hide();
                }
            });
        }

        self.loadNotification();
        notificationInterval = setInterval(self.loadNotification, 30000);
        NavigationController.loadUserInfo('dashboard');

        $('#dashboard .float-add-action').show();
        $dashboardList = $('#dashboard-list');

        $filterFeed = $('#dashboard #filter-feed-type');
        if ($filterFeed) {
            $filterFeed.i18n();
            $filterFeed.val(self.currentFilter).selectmenu('refresh');
        }
        if (connection) {
          self.preinit(function(){
              self.loadFeed(0, null, self.setDisplayPosition);
          });
        } else {
          hideLoadingIndikator();
        }

        self.loadSipUserFromServer();
        setTimeout(function(){
          UserController.setPhoneNumberToUsers();
        }, 1000);

    };

    self.bindElementControls = function () {
        $dashboard = $('#dashboard');
        $(document).on('click', '#contacts-link', self.contactsLinkEvent);
        $(document).on('click', '#tasks-link', self.tasksLinkEvent);
        $(document).on('click', '#case-link', self.caseLinkEvent);
        $(document).on('click', '#deals-link', self.dealsLinkEvent);
        $(document).on('click', '#mygroup-link', self.myGroupLinkEvent);
        $(document).on('click', '#dashboard-link', self.refreshDashboardEvent);
        $(document).on('click', '#dashboard-link', self.menuLinkEvent);
        $(document).on('click', '#menu-link', self.menuLinkEvent);
        $(document).on('click', '#dashboard-list li', self.itemEvent);
        $(document).on('click', '#settings-link', self.settingsLinkEvent);
        $(document).on('click', '#about-link', self.gotoAbout);
        $(document).on('click', '#drafts-link', self.draftLinkEvent);
        $(document).on('click', '#overview-link', self.overviewLinkEvent);
        $(document).on('click', '#dashboard .phone-popup-dialog-item', self.popupDialogItem);
        $(document).on('click', '#dashboard #dashboard-list .content-left', self.avatarEvent);


        $(document).on('click', '#dashboard #open-case', function () {
            gotoPage({url: "editCase", param: null}, {url: "dashboard", param: null});
        });
        $(document).on('click', '#dashboard #open-deal', function () {
            gotoPage({url: "editDeal", param: null}, {url: "dashboard", param: null});
        });
        $(document).on('click', '#dashboard #open-task', function () {
            gotoPage({url: "editTask", param: null}, {url: "dashboard", param: null});
        });
        $(document).on('click', '#dashboard #open-contact', function () {
            gotoPage({url: "editContact", param: {contactType: "Person"}}, {url: "dashboard", param: null});
        });

        $(document).on('click', '#dashboard #open-note', self.createNote);
        $('#dashboard .float-add-action').on('click', function () {
            $(this).toggleClass("rotation-event");
            $('#dashboard .popup-menu-backdrop').toggle();
            $('#dashboard .menu-more-option').toggle();
        });
        $(document).on('click', '#dashboard .popup-menu-backdrop', function () {
            $('#dashboard .menu-more-option').hide();
            $('#dashboard .float-add-action').removeClass("rotation-event");
            $(this).hide();
            $('.float-add-action').show();
        });

        $(document).on('click', '#dashboard #call-list-link', self.gotoCallList);

        $("input", '#dashboard').on('keyup', self.feedInputEvent);
        $dashboard.on('click', '.ui-input-clear', self.feedInputDeleteAllEvent);

        $("body").on("swipeup", '#dashboard', self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#dashboard');
            $("body").off("swipedown", '#dashboard');
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });

        $('body').on('submit', function (event) {
            event.preventDefault(); // cancel default form submit
            event.stopPropagation();
            return false;
        });

        $('.backdrop').on('click', function () {
            $('html').removeClass('sidebar-left-in');
        });

        $('.notification-backdrop').on('click', function () {
            $('.advanced-menu.advanced-notification').hide();
            $('html').removeClass('notification-bar-right-in');
        });

        $("body").on('swipeleft', '#dashboard .sidebar', function () {
            if ($("html").hasClass("sidebar-left-in")) {
                $("html").removeClass("sidebar-left-in");
            }
        });

        $("body").on('swiperight', '#dashboard .notification-bar', function () {
            if ($("html").hasClass("notification-bar-right-in")) {
                $('.advanced-menu.advanced-notification').hide();
                $("html").removeClass("notification-bar-right-in");
            }
        });

        $("#dashboard .btn-notification").on("click", function () {
            $("html").addClass("notification-bar-right-in");
        });

        $(document).on("click", "div.notification-item", self.navigateToNotificationItem);

        $("#dashboard .app-user").on('click', self.gotoProfilPage);
        $("#dashboard .domain-link-info").on('click', self.gotoDomainPage);
        $(document).on("click", "#dashboard #read-all-notif", self.readAllNotifications);
        $(document).on("click", "#dashboard .notification-popup", self.openNotificationPopup);
        $(document).on("click", "#dashboard #retrieve-location", self.noteWithLocation);
        $(document).on("click", "#dashboard #app-calendar", function(){
            gotoPage({url: "calendar", param: null}, {url: "dashboard", param: null});
        });
        $(document).on("click", "#dashboard .load-more-button", self.loadMoreNotifications);
        $('#filter-feed-type').on('change', self.filterFeed);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#contacts-link');
        $(document).off('click', '#tasks-link');
        $(document).off('click', '#case-link');
        $(document).off('click', '#deals-link');
        $(document).off('click', '#mygroup-link');
        $(document).off('click', '#dashboard-link');
        $(document).off('click', '#menu-link');
        $(document).off('click', '#dashboard-list li');
        $(document).off('click', '#settings-link');
        $(document).off('click', '#about-link');
        $(document).off('click', '#drafts-link');
        $(document).off('click', '#dashboard #open-case');
        $(document).off('click', '#dashboard #open-deal');
        $(document).off('click', '#dashboard #open-task');
        $(document).off('click', '#dashboard #open-contact');
        $(document).off('click', '#overview');
        $(document).off('click', '#overview-link');
        $('#dashboard .float-add-action').off('click');
        $(document).off('click', '#dashboard .popup-menu-backdrop');
        $("input:jqmData(type='search')", '#dashboard').off('input');
        $dashboard.off('click', '.ui-input-clear');
        $(document).off('click', '#dashboard #open-note');
        $(document).off('click', '#dashboard #call-list-link');
        $("body").off("swipeup", '#dashboard');
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
        $('.backdrop').off('click');
        $('.notification-backdrop').off('click');
        $("body").off('swipeleft', '#dashboard .sidebar');
        $('html').removeClass('sidebar-left-in');
        $("#dashboard .btn-notification").off("click");
        $("body").off('swiperight', '#dashboard .notification-bar');
        $(document).off("click", "div.notification-item");
        $("#dashboard .app-user").off('click');
        $("#dashboard .domain-link-info").off('click');
        $(document).off("click", "#dashboard #read-all-notif");
        $(document).off("click", "#dashboard .notification-popup");
        $(document).off("click", "#dashboard #retrieve-location");
        $(document).off("click", "#dashboard #app-calendar");
        $(document).off("click", "#dashboard .load-more-button");
        $('#filter-feed-type').off('change');
        $(document).off('click', '#dashboard .phone-popup-dialog-item');
        $(document).off('click', '#dashboard #dashboard-list .content-left');
        clearInterval(notificationInterval);
    };

    self.loadSipUserFromServer = function() {
        UserController.loadSipUserFromServer(function(data){
          onlineUsersSip = data ? data : [];
        });
    }

    self.avatarEvent = function(event) {
      if (UtilController.isAndroid()) {
        var userId = $(event.currentTarget).parent().attr('userId');
        if (onlineUsersSip.indexOf(parseInt(userId)) >= 0) {
            $('#phone-popup-dialog li.call-option').show();
        } else {
            $('#phone-popup-dialog li.call-option').hide();
        }

        if (ALL_USERS[userId] && ALL_USERS[userId].phone) {
          $('#phone-popup-dialog li.call-option-native').show();
        } else {
          $('#phone-popup-dialog li.call-option-native').hide();
        }

        $('#phone-popup-dialog').attr('userId', userId).popup("open");
        event.stopPropagation();
      }
    }

    self.popupDialogItem = function(event) {
      if (UtilController.isAndroid()) {
        var type = $(event.currentTarget).attr('data-type');
        var userId = $(event.currentTarget).parent().parent().attr('userId');
        if (type == "CALL") {
          document.location.href = "tel:" + ALL_USERS[userId].phone;
        } else {
          MyGroupFunctions.callUserById(userId, type);
        }
      }
    }

    self.filterFeed = function(event) {
        if (event) {
          self.currentFilter = $(event.currentTarget).find('option:selected').val();
        }
        self.loadSipUserFromServer();
        self.feedInputDeleteAllEvent();
    };

    self.setDisplayPosition = function(){
       if (self.scrollTopData.start != 0) {
         start = self.scrollTopData.start;
       }
       if (self.scrollTopData.scrollTop != 0) {
         try {
           $("#dashboard-list li").parent().parent().scrollTop(self.scrollTopData.scrollTop);
        } catch(e) {}
       }
       self.scrollTopData =  {
           'start' : 0,
           'scrollTop' : 0
       };
    };



    self.createNote = function () {
        var userId = window.localStorage.getItem('userId');
        if (userId) {
            if (connection) {
                ClientAPI.find({query: {'identity_id': userId}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
                    if (!err) {
                        if (data != null && data.length > 0) {
                            var item = PeopleController.encodeItem(data[0]);
                            gotoPage({url: "editNote", param: {parentId: item.id.text, parentType: "people"}}, {url: "dashboard", param: null});
                        }
                    }
                });
            } else {
                var queryData = [];
                var query = "SELECT * FROM people WHERE identity_id = ?";
                queryData = [userId];
                db.selectByQuery(query, queryData, "people", function (user) {
                    gotoPage({url: "editNote", param: {parentId: user[0].id.text, parentType: "people"}}, {url: "dashboard", param: null});
                });
            }
        }
    };

    self.onPullDown = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            self.refreshDashboardEvent();
            $("input:jqmData(type='search')", '#dashboard').val("");
        }
    };

    self.onPullUp = function () {
        if ($("#dashboard-list li", '#' + $.mobile.activePage.attr('id')).last().visible()) {
            self.loadFeed(start, searchValue);
        }
    };

    self.itemEvent = function () {
        self.scrollTopData =  {
            'start' : start,
            'scrollTop' : this.offsetTop
        };
        var type = $(this).find("a").attr('subjecttype');
        var id = $(this).find("a").attr('refid');
        var immediateid = $(this).find("a").attr('immediateid');
        ClientAPI.find({_id: new ObjectId(id)}, null, function (err, data) {
          if (!err && data.length > 0) {
              switch (type) {
                  case 'Person':
                      gotoPage({url: "viewContact", param: {contactId: id, contactType: "Person"}}, {url: "dashboard", param: null});
                      break;
                  case 'Company':
                      gotoPage({url: "viewContact", param: {contactId: id, contactType: "Company"}}, {url: "dashboard", param: null});
                      break;
                  case 'Project':
                      gotoPage({url: "viewCase", param: {caseId: id}}, {url: "dashboard", param: null});
                      break;
                  case 'Deal':
                      gotoPage({url: "viewDeal", param: {id: id}}, {url: "dashboard", param: null});
                      break;
                  case 'Task':
                      gotoPage({url: "viewTask", param: {id: id, ids: []}}, {url: "dashboard", param: null});
                      break;
                  case 'Note':
                      var attachmentName = $(this).find("a").attr('attachmentname');
                      if (attachmentName && attachmentName !== null && attachmentName !== "") {
                          ViewNoteFunctions.openAttachment(id, attachmentName);
                      } else {
                          gotoPage({url: "viewNote", param: {noteId: id}}, {url: "dashboard", param: null});
                      }
                      break;
                  case 'Comment':
                        CommentController.findById(id, function(data) {
                            if (data && data.immediateParent) {
                              NoteController.findById(data.immediateParent, function(data){
                                  if (data && data.length > 0) {
                                    gotoPage({url: "viewNote", param: {noteId: data[0]["_id"], commentTab: "true"}}, {url: "dashboard", param: null});
                                  }
                              });
                            } else {
                                alert(Messages.Dashboard.objectDoesNotExist);
                            }
                        });
                      break;
              }
           }
        });


    };

    self.gotoDomainPage = function () {
        gotoPage({url: "domain", param: null}, {url: "dashboard", param: null});
    };

    self.gotoCallList = function () {
        gotoPage({url: "callLog", param: null}, {url: "dashboard", param: null});
    };

    self.gotoAbout = function () {
        gotoPage({url: "about", param: null}, {url: "dashboard", param: null});
    };

    self.settingsLinkEvent = function () {
        gotoPage({url: "settings", param: null}, {url: "dashboard", param: null});
    };

    self.overviewLinkEvent = function () {
        gotoPage({url: "overview", param: null});
    };

    self.contactsLinkEvent = function () {
        gotoPage({url: "contacts", param: null});
    };

    self.tasksLinkEvent = function () {
        gotoPage({url: "tasks", param: null});
    };

    self.caseLinkEvent = function () {
        gotoPage({url: "case", param: null});
    };

    self.dealsLinkEvent = function () {
        gotoPage({url: "deals", param: null});
    };

    self.myGroupLinkEvent = function () {
        gotoPage({url: "myGroup", param: null});
    };

    self.refreshDashboardEvent = function () {
        searchValue = null;
        if (connection) {
            self.loadFeed(0, searchValue);
        }
    };

    self.menuLinkEvent = function () {
        $("html").toggleClass("sidebar-left-in");
    };

    self.loadFeed = function (startParam, search, callback) {

        if (!$("html").hasClass("sidebar-left-in")) {
            showLoadingIndikator();
            var offset = feedOffset;
            if (startParam != null) {
                start = startParam;
            }

            if (self.scrollTopData && self.scrollTopData.start != 0) {
              offset = feedOffset * self.scrollTopData.start;
            }

            if (connection) {
                var append = false;
                if (start != 0) {
                    append = true;
                }

                start++;

                var ids = null;
                if (self.currentFilter === "filter-favorite-feed"){
                    ids = listFavoriteIds;
                }

                if (search) {
                    FeedController.search(search, ids, start, offset, function (data) {
                        self.drawFeed($dashboardList, data, append);
                        hideLoadingIndikator();
                        if (callback) {
                          callback();
                        }
                    });
                } else {
                    FeedController.getFeed(ids, start, offset, function (data) {
                        self.drawFeed($dashboardList, data, append);
                        hideLoadingIndikator();
                        if (callback) {
                          callback();
                        }
                    });
                }
            }
        }
    };

    self.drawFeed = function (listDiv, data, append) {
        FeedListController.drawFeed(listDiv, data, append);
    };

    self.listScrollLoadEvent = function () {
        if (($(this).scrollTop() + $(window).height()) >= ($(this).height() - 200)) {
            self.loadFeed(start, searchValue);
        }
    };

    self.feedInputEvent = function (event) {
        if (event.keyCode != 13) {
            searchValue = event.currentTarget.value.toLowerCase();
            self.loadFeed(0, searchValue);
        }
    };

    self.feedInputDeleteAllEvent = function () {
        searchValue = null;
        self.loadFeed(0);
    };

    self.setConnectionMode = function () {
        if (connection) {
            if ($("#dashboard #offline-dashboard-message").is(':empty') == false) {
                $("#dashboard #offline-dashboard-message").empty();
                $('#dashboard #refresh-link').show();
            }
        } else {
            $('#dashboard #offline-dashboard-message').html('<p class="center"><img src="' + rootPath + '/images/noWifi.png" onerror="imgError(this);"></p>'
                    + '<p style="text-align:center;">' + Messages.Login.offlineMessage + '</p></div>');
            if ($dashboardList) {
                $dashboardList.empty();
            }

            $('#dashboard #refresh-link').hide();
        }
    };

    self.navigateToNotificationItem = function () {
        $('html').removeClass('notification-bar-right-in');
        var objectId = $(this).attr('objectId');
        var parentId = $(this).attr('parentId');
        var notifType = $(this).attr('notifType');
        var objectType = $(this).attr('objectType');
        var notifId = $(this).attr('notifId');
        if (connection) {
            NotificationService.readNotification(parentId, notifType, notifId, function () {
                ClientAPI.find({_id: new ObjectId(objectId), objectType: objectType}, null, function (err, data) {
                    if (data && data[0]) {
                        switch (objectType) {
                            case "Project":
                                gotoPage({url: 'viewCase', param: {caseId: objectId}}, {url: "dashboard", param: null});
                                break;
                            case "Deal":
                                gotoPage({url: 'viewDeal', param: {id: objectId}}, {url: "dashboard", param: null});
                                break;
                            case "Task":
                                gotoPage({url: 'viewTask', param: {id: objectId}}, {url: "dashboard", param: null});
                                break;
                            case "Company":
                            case "Person":
                                gotoPage({url: 'viewContact', param: {contactId: objectId, contactType: objectType}}, {url: "dashboard", param: null});
                                break;
                            case "Note":
                                gotoPage({url: 'viewNote', param: {noteId: objectId}}, {url: "dashboard", param: null});
                                break;
                            case "Comment":
                                if (connection) {
                                    ClientAPI.find({objectType: "Comment", _id: new ObjectId(objectId)}, null, function (err, data) {
                                        if (data != null && data[0] != null && data[0].immediateParent) {
                                            ClientAPI.find({objectType: "Note", _id: new ObjectId(data[0].immediateParent)}, null, function (err, data) {
                                                if (!err && data.length > 0) {
                                                    var noteId = data[0]["_id"];
                                                    gotoPage({url: "viewNote", param: {noteId: noteId, commentTab: "true"}}, {url: "dashboard", param: null});
                                                }
                                            });
                                        } else {
                                            alert("Error!");
                                        }
                                    });
                                }
                        }
                    } else {
                        alert("Item is deleted!");
                    }
                });
            });
        } else {
            NotificationService.markAsRead(notifId, function () {
                selectedNotifications.push({parentId: parentId, notifType: notifType, notifId: notifId});
                switch (objectType) {
                    case "Project":
                        gotoPage({url: 'viewCase', param: {caseId: objectId}}, {url: "dashboard", param: null});
                        break;
                    case "Deal":
                        gotoPage({url: 'viewDeal', param: {id: objectId}}, {url: "dashboard", param: null});
                        break;
                    case "Task":
                        gotoPage({url: 'viewTask', param: {id: objectId}}, {url: "dashboard", param: null});
                        break;
                    case "Company":
                    case "Person":
                        gotoPage({url: 'viewContact', param: {contactId: objectId, contactType: objectType}}, {url: "dashboard", param: null});
                        break;
                    case "Note":
                        gotoPage({url: 'viewNote', param: {noteId: objectId}}, {url: "dashboard", param: null});
                        break;
                    case "Comment":
                        if (connection) {
                            ClientAPI.find({objectType: "Comment", _id: new ObjectId(objectId)}, null, function (err, data) {
                                if (data != null && data[0] != null && data[0].immediateParent) {
                                    ClientAPI.find({objectType: "Note", _id: new ObjectId(data[0].immediateParent)}, null, function (err, data) {
                                        if (!err && data.length > 0) {
                                            var noteId = data[0]["_id"];
                                            gotoPage({url: "viewNote", param: {noteId: noteId, commentTab: "true"}}, {url: "dashboard", param: null});
                                        }
                                    });
                                } else {
                                    alert("Error!");
                                }
                            });
                        }
                }
            });
        }
    };

//    self.removeAllNotifications = function () {
//        NotificationService.deleteAllNotification(function () {
//            $(".advanced-menu.advanced-notification").hide();
//            $('html').removeClass('notification-bar-right-in');
//            $("#dashboard .notification-list").empty();
//            $("#dashboard .badge").hide();
//        });
//    };

    self.drawNotification = function (notification) {
        var html = "";
        var notificationIcon = "";
        switch (notification.type.toLowerCase()) {
            case "deal":
                notificationIcon = "<i class='md-attach-money  md-2x'></i>";
                break;
            case "task":
                notificationIcon = "<i class='md-assignment-turned-in  md-2x'></i>";
                break;
            case "project":
                notificationIcon = "<i class='md-work md-2x'></i>";
                break;
            case "note":
                notificationIcon = "<i class='md-insert-drive-file md-2x'></i>";
                break;
            case "person":
                notificationIcon = "<i class='md-person  md-3x'></i>";
                break;
            case "company":
                notificationIcon = "<i class='md-business  md-3x'></i>";
            case "comment":
                notificationIcon = "<i class='md-mode-comment md-2x'></i>";
                break;
        }
        var notificationBackground = "unread-notification";
        if(notification.seen){
            notificationBackground = "read-notification";
        }

        html += "<li notifId = '" + notification.id + "' class= '" + notificationBackground + "'>";

        html += "<div class='notification-item' notifId = '" + notification.id + "' parentId='" + notification.parentId + "'objectId='" + notification.objectId
                + "' objectType = '" + notification.type + "' notifType = '" + notification.notifType + "'>"
                + "<div class='notification-icon'>" + notificationIcon + "</div>"
                + "<div class='notification-box'>"
                + "<div class='has-bottom-margin'>" + dateFormat(new Date(notification.eventDate)) + ", " + timeFormat(new Date(notification.eventDate)) + " h</div>"
                + "<div class='truncate has-bottom-margin' style='color: #2A66D9;'>" + notification.message + "</div>"
                + "<div class='truncate'>" + notification.title + "</div>"
                + "</div>"
                + "</div>"
                + "</li>";
        return html;

    };


    self.openNotificationPopup = function () {
        $(".advanced-notification").toggle();
    };

    self.readAllNotifications = function () {
        NotificationService.readAllNotifications(function (data) {
            notificationPage = 0;
            $("#dashboard .load-more-button").show();
            $(".advanced-menu.advanced-notification").hide();
            $('html').removeClass('notification-bar-right-in');
            $("#dashboard .badge-container").remove();
            if (data && data.length > 0) {
                SyncController.syncNotification(function () {
                    self.drawNotificationList(notificationPage, notificationOffset, false);
                });
            } else if (data && data.readAllOffline){
                readAllInOffline = data.readAllOffline;
            }
        });
    };

    self.draftLinkEvent = function () {
        gotoPage({url: "draft", param: null}, {url: "dashboard", param: null});
    };

    self.loadMoreNotifications = function(){
        notificationPage++;
        self.drawNotificationList(notificationPage*notificationOffset, notificationOffset, true);
    };

    self.drawNotificationList = function (items, offset, appendToList) {
        NotificationService.loadNotifications(items, offset, function (data) {
            if(data.length < offset){
                $("#dashboard .load-more-button").hide();
            }
            NotificationService.notificationCount(function (count) {
                if (count == "0") {
                    $("#dashboard .badge").remove();
                } else {
                    $("#dashboard .badge-container").html("<span class='badge'></span>");
                    $("#dashboard .badge").text(count);
                }
            });

            var html = "";
            for (var i = 0; i < data.length; i++) {
                var notificationObj = {};
                notificationObj.id = data[i].id;
                notificationObj.parentId = data[i].parentId;
                notificationObj.objectId = data[i].object.objectId;
                notificationObj.type = data[i].object.objectType;
                notificationObj.message = data[i].object.displayText;
                notificationObj.title = "By " + data[i].object.user_name;
                notificationObj.notifType = data[i].object.notificationType;
                notificationObj.eventDate = data[i].object.eventDate;

                if (data[i].object.seen) {
                    notificationObj.seen = data[i].object.seen;
                }

                html += self.drawNotification(notificationObj);
            }
            if (html != "") {
                if(appendToList){
                    $("#dashboard .notification-list").append(html);
                } else {
                    $("#dashboard .notification-list").empty().append(html);
                }
            }
        });
    };

    self.readNotificationOffline = function (callback) {
        for (var i = 0; i < selectedNotifications.length; i++) {
            ClientAPI.updateNotifications({refId: selectedNotifications[i].parentId, notificationType: selectedNotifications[i].notifType}, function(err, data){

            });
        }
        selectedNotifications = [];
        if (callback && typeof callback == "function") {
            callback();
        }
    };

    self.retrieveUserLocation = function (callback) {
        getUserLocation(function (data) {
            hideLoadingIndikator();
            if (data.latitude && data.longitude) {
                latitude = data.latitude;
                longitude = data.longitude;
                var maps = new GoogleMap();
                maps.getUserAddress(function (address, status) {
                    if (address) {
                        userAddress = address;
                        if(callback && typeof callback == "function"){
                            callback();
                        }
                        $("#dashboard #user-location").text(address);
                    } else {
                        $("#dashboard #user-location").hide();
                    }
                });
            } else if (data.code && data.message) {
                alert("Error: " + data.message + "\n Please, check GPS settings!");
            }
            $("#dashboard .popup-menu-backdrop").hide();
            $('#dashboard .menu-more-option').hide();
            $('#dashboard .float-add-action').removeClass("rotation-event");
        });
    };

    self.noteWithLocation = function () {
        self.retrieveUserLocation(function () {
            var userId = window.localStorage.getItem('userId');
            if (connection && userId) {
                ClientAPI.find({query: {'identity_id': userId}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
                    if (!err) {
                        if (data != null && data.length > 0) {
                            var item = PeopleController.encodeItem(data[0]);
                            gotoPage({url: "editNote", param: {parentId: item.id.text, parentType: "people", saveLocation: true}}, {url: "dashboard", param: null});
                        }
                    }
                });
            }
        });
    };

    self.loadNotification = function () {
        notificationPage = 0;
        $("#dashboard .load-more-button").show();
        if (connection) {
            if (selectedNotifications.length > 0) {
                self.readNotificationOffline(function () {
                    SyncController.syncNotification(function () {
                        self.drawNotificationList(notificationPage, notificationOffset, false);
                    });
                });
            } else if (readAllInOffline) {
                ClientAPI.updateNotifications(null, function (err, data) {
                    $(".advanced-menu.advanced-notification").hide();
                    $('html').removeClass('notification-bar-right-in');
                    $("#dashboard .badge-container").remove();
                    readAllInOffline = false;
                    SyncController.syncNotification(function () {
                        self.drawNotificationList(notificationPage, notificationOffset, false);
                    });
                });
            } else {
                SyncController.syncNotification(function () {
                    self.drawNotificationList(notificationPage, notificationOffset, false);
                });
            }
        } else {
            SyncController.syncNotification(function () {
                self.drawNotificationList(notificationPage, notificationOffset, false);
            });
        }
    };

    self.gotoProfilPage = function(){
      gotoPage({url: "editProfil", param: null}, {url: "dashboard", param: null});
    };

    return self;
}(DashboardFunctions || {}));
