$(document).on('pageinit', '#deals', function () {
    ViewContactFunctions.sharedContactForOpen = {};
    DealFunctions.init();
});

$(document).on('pageshow', '#deals', function () {
    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
        $("#call-list-link").remove();
    }

    DealFunctions.bindElementControls();
    ViewDealFunctions.currentTab = "general";
});

$(document).on('pagehide', '#deals', function () {
    DealFunctions.unbindElementControls();
});

var DealFunctions = (function (DealFunctions)
{
    var self = DealFunctions;
    self.drawListParams = [];
    self.divider = [];
    self.findTime = null;
    var listViewId = 'deal-list';
    var currentStatus = null;

    // var $dealListEmpty 	= null;
    var $filterDealType = null;
    var $deals = null;
    var favoriteMapData = {};

    self.init = function () {
        VisibleDomainController.hide("deals");
        //hide call list option for iOS devices
        removeCallListForIOS("main-nav-list", "deals", "call-list-link");

        // $dealListEmpty	= $("#deal-list-message");
        $filterDealType = $("#filter-deal-type");
        $deals = $('#deals');
        NavigationController.loadUserInfo('deals');
        self.drawFilter();
        self.filterDealTypeEvent();
        self.addMoreFilter("filter-deal-type");
    };

    self.bindElementControls = function () {
        $(document).on('click', '#dashboard-link', self.dashboardLinkEvent);
        $(document).on('click', '#contacts-link', self.contactsLinkEvent);
        $(document).on('click', '#case-link', self.caseLinkEvent);
        $(document).on('click', '#tasks-link', self.tasksLinkEvent);
        $(document).on('click', '#close-link', self.closeLinkEvent);
        $(document).on('click', '#menu-link', self.menuLinkEvent);
        $(document).on('click', '#deals-link', self.menuLinkEvent);
        $(document).on('click', '#settings-link', self.settingsLinkEvent);
        $(document).on('click', '#drafts-link', self.draftLinkEvent);
        $(document).on('click', '#about-link', self.gotoAbout);
        $(document).on('click', '#mygroup-link', self.myGroupLinkEvent);
        $(document).on('click', '#deal-list a', self.viewDealEvent);
        $('#deals .float-add-action').on('click', self.addDeal);
        $filterDealType.on('change', self.filterDealTypeEvent);
        $("input", '#deals').on('input', self.dealsInputEvent);
        $(document).on('click', '#deals .ui-input-clear', self.dealsInputDeleteAllEvent);
        $("#deals .app-user").on('click', self.gotoProfilPage);
        $("#deals .domain-link-info").on('click', self.gotoDomainPage);
        $(document).on('click', "#deals #call-list-link", function () {
            gotoPage({url: "callLog", param: null}, {url: "deals", param: null});
        });
        $("#deals").on('click', '.favorite-event', self.eventFavorite);

        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });

        $('body').on('submit', function (event) {
            event.preventDefault(); // cancel default form submit
            event.stopPropagation();
            return false;
        });

        $('.backdrop').on('click', function () {
            $('html').removeClass('sidebar-left-in');
        });

        $("body").on('swipeleft', "#deals .sidebar", function () {
            if ($("html").hasClass("sidebar-left-in")) {
                $("html").removeClass("sidebar-left-in");
            }

        });
        $(document).on("click", "#deals #app-calendar", function(){
            gotoPage({url: "calendar", param: null}, {url: "deals", param: null});
        });
        $(document).on('click', '#overview-link', self.overviewLinkEvent);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#dashboard-link');
        $(document).off('click', '#contacts-link');
        $(document).off('click', '#case-link');
        $(document).off('click', '#tasks-link');
        $(document).off('click', '#close-link');
        $(document).off('click', '#deals-link');
        $(document).off('click', '#menu-link');
        $(document).off('click', '#settings-link');
        $(document).off('click', '#about-link');
        $(document).off('click', '#drafts-link');
        $(document).off('click', '#mygroup-link');
        $(document).off('click', '#deal-list a');
        $('#deals .float-add-action').off('click');
        $("#deals .domain-link-info").off('click');
        $filterDealType.off('change');
        $("input", '#deals').off('input');
        $(document).off('click', '#deals .ui-input-clear');
        $(document).off('click', "#deals #call-list-link");
        $("#deals .app-user").off('click');
        $("#deals").off('click', '.favorite-event');

        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
        $('.backdrop').off('click');
        $("body").off('swipeleft', "#deals .sidebar");
        $('html').removeClass('sidebar-left-in');
        $(document).off("click", "#deals #app-calendar");
        $(document).off('click', '#overview-link');
    };

    self.drawFilter = function() {
      var html = "";
      if (VisibleDomainController.isDomainCTSales()) {
        html = '<option value="filter-all-deals" data-i18n="deal.all" selected="selected">All</option>'
            + '<option value="filter-active-deals" data-i18n="deal.active">Active</option>'
            + '<option value="filter-inactive-deals" data-i18n="deal.inactive">Inactive</option>'
            + '<option value="filter-my-active-deals" data-i18n="deal.myActive">My Active</option>'
            + '<option value="filter-my-won-deals" data-i18n="deal.myWon">My won</option>'
            + '<option value="filter-my-inactive-deals" data-i18n="deal.myInactive">My inactive</option>'
            + '<option value="filter-favorite-deals" data-i18n="deal.myFavorite">Favorites</option>';
      } else {
        html = '<option value="filter-open-deals" data-i18n="deal.openDeals" selected="selected"></option>'
            + '<option value="filter-closed-deals" data-i18n="deal.closedDeals"></option>'
            + '<option value="filter-my-active-deals" data-i18n="deal.myActive">My active (open)</option>'
            + '<option value="filter-my-won-deals" data-i18n="deal.myWon">My won deals</option>'
            + '<option value="filter-my-lost-deals" data-i18n="deal.myLost">My lost deals</option>'
            + '<option value="filter-favorite-deals" data-i18n="deal.myFavorite"></option>';
      }

      $filterDealType.empty().append(html).i18n();
    };

    self.overviewLinkEvent = function () {
        gotoPage({url: "overview", param: null});
    };

    self.eventFavorite = function(e){
        var isFavorite = $(this).hasClass("contact-favorite-star");
        var dealId  = $(this).parent().attr('dealid');
        var element  = $(this);

        DealController.findByObjectId(dealId, function(item){
            if (isFavorite) {
                 FavoriteController.findByObjectIdDB(dealId , function(data){
                    if (data[0]) {
                        FavoriteController.removeFavorite(data[0].id, function(){
                            element.toggleClass("contact-favorite-star");
                        });
                    }
                 });
            } else {
                FavoriteController.save("Deal", item, function(){
                  element.toggleClass("contact-favorite-star");
                });
            }
        });
        e.stopPropagation();
    }


    self.gotoDomainPage = function () {
        gotoPage({url: "domain", param: null}, {url: "deals", param: null});
    };

    self.gotoProfilPage = function(){
      gotoPage({url: "editProfil", param: null}, {url: "deals", param: null});
    };

    self.gotoAbout = function () {
        gotoPage({url: "about", param: null}, {url: "deals", param: null});
    };

    self.settingsLinkEvent = function () {
        gotoPage({url: "settings", param: null}, {url: "deals", param: null});
    };

    self.onPullDown = function () {
        if ($("#deal-list li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            showLoadingIndikator();
            self.refresh();
            $("input:jqmData(type='search')", '#deals').val("");
        }
    };

    self.onPullUp = function () {
        var count = $("#deal-list li", '#' + $.mobile.activePage.attr('id')).length;
        var bool = $($("#deal-list li", '#' + $.mobile.activePage.attr('id'))[count - 2]).visible();
        if (bool && !$("html").hasClass("sidebar-left-in")) {
            showLoadingIndikator();
            if (self.findTime) {
                clearTimeout(self.findTime);
            }
            self.findTime = setTimeout(function () {
                var requestObject = {};
                if (self.drawListParams[listViewId]['status'] != "search") {
                    requestObject = self.requestObjectFilter(self.drawListParams[listViewId]['status']);
                } else {
                    requestObject['searchKeywords'] = new RegExp(self.drawListParams[listViewId]['searchValue'].trim().replace(' ', '|'), "i");
                }

                var sort = [["modificationDate", -1]];
                var customFilter = self.checkAndPrepairCustomFilter();

                if (customFilter) {
                    sort = customFilter[1];
                    requestObject = customFilter[0];
                }

                self.listScrollLoad(listViewId, requestObject, sort);
            }, 300);
        }
    };

    self.checkAndPrepairCustomFilter = function(){
          var customFilter = JSON.parse($filterDealType.find(":selected").attr('filter'));
          if (customFilter) {
              var sort = [];
              var requestObject= {};
              if (customFilter[1]){
                  for (var key in customFilter[1]) {
                    if (customFilter[1].hasOwnProperty(key)) {
                      sort.push(key);
                      sort.push(customFilter[1][key]);
                    }
                  }
              }

              if (sort) {
                sort = [sort]
              } else {
                sort = [];
              }
              requestObject = customFilter[0].$match;
              if (self.drawListParams[listViewId]['status'] != "search") {
                requestObject['searchKeywords'] = new RegExp(self.drawListParams[listViewId]['searchValue'].trim().replace(' ', '|'), "i");
              }
              return [requestObject, sort];
          } else {
            return null;
          }
    }

    self.addMoreFilter = function(id){
      var $filterElement = $("#" + id);
      if ($filterElement) {
        DealController.findAllFilters(function(items){
          items.forEach(function(element, index){
            $filterElement.append('<option value="filter-custom-' + index + '" filter=\''+ element.settingData.filterQuery +'\'>' + element.settingData.filterName + '</option>');
          });
        });
      }
    };

    self.requestObjectFilter = function(currentStatus) {
        var request = {objectType: "Deal"};
        if (currentStatus == "Open") {
            request['$or'] = [{status: "ProposalSent"}, {status: "Negotiation"}, {status: "Analyses"}, {status: "Prospecting"}, {status: "Pending"}];
        } else if (currentStatus == "Won") {
            request['status'] = "Won";
        } else if (currentStatus == "Lost") {
            request['status'] = "Lost";
        } else if (currentStatus == "Active") {
            request['$or'] = [{status: "ProposalSent"}, {status: "Negotiation"}, {status: "Analyses"}, {status: "Prospecting"}, {status: "Pending"}];
        } else if (currentStatus == "Closed") {
            request['$or'] = [{status: "Won"}, {status: "Lost"}, {status: "Inactive"}];
        } else if (currentStatus == "filter-all-deals") {

        } else if (currentStatus == "filter-active-deals") {
          request['$or'] = [
            {salesStage: "00"},
            {salesStage: "01"},
            {salesStage: "02"},
            {salesStage: "03"},
            {salesStage: "04"},
            {salesStage: "05"},
            {salesStage: "07"},
            {salesStage: "09"}
          ];
        } else if (currentStatus == "filter-inactive-deals") {
            request['salesStage'] = "08";
        } else if (currentStatus == "filter-my-active-deals") {
            request['$or'] = [
              {salesStage: "00"},
              {salesStage: "01"},
              {salesStage: "02"},
              {salesStage: "03"},
              {salesStage: "04"},
              {salesStage: "05"},
              {salesStage: "07"},
              {salesStage: "09"}
            ];
            request['owner'] = window.localStorage.getItem('userId');
        } else if (currentStatus == "filter-my-won-deals") {
          request['salesStage'] = "07";
          request['owner'] = window.localStorage.getItem('userId');
        } else if (currentStatus == "filter-my-inactive-deals") {
          request['$or'] = [
            {salesStage: "08"},
            {salesStage: "06"}
          ];
        }
        return request;
    };

    self.dashboardLinkEvent = function () {
        gotoPage({url: "dashboard", param: null});
    };

    self.contactsLinkEvent = function () {
        gotoPage({url: "contacts", param: null});
    };

    self.caseLinkEvent = function () {
        gotoPage({url: "case", param: null});
    };

    self.tasksLinkEvent = function () {
        gotoPage({url: "tasks", param: null});
    };

    self.closeLinkEvent = function () {
        closeAplication();
    };

    self.menuLinkEvent = function () {
        $('html').toggleClass('sidebar-left-in');
    };

    self.myGroupLinkEvent = function () {
        gotoPage({url: "myGroup", param: null});
    };

    self.addDeal = function () {
        gotoPage({url: "editDeal", param: null}, {url: "deals", param: null});
    };

    self.viewDealEvent = function (evt) {
        var dealId = $(evt.currentTarget).attr('dealId');
        var dealIds = [];
        $("#deal-list").find(".deals-item").each(function () {
            dealIds.push($(this).attr("dealId"));
        });
        gotoPage({url: "viewDeal", controller: ViewDealFunctions, isModal:false,  param: {id: dealId, ids: dealIds, listParams: self.drawListParams[listViewId]}}, {url: "deals", controller: DealFunctions ,param: null});
    };

    self.refresh = function () {
        if (connection) {
            DealController.refresh(function () {
                self.filterDealTypeEvent();
            });
        } else {
            self.filterDealTypeEvent();
        }
    };

    self.drawDealItem = function(deal) {
        var starColor = favoriteMapData[deal.id.text] ? "contact-favorite-star" : "";
        var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(ALL_USERS[deal['owner-id'].text].person) + '&fieldName=' + encodeURIComponent('picture') + '&v=' + new Date(ALL_USERS[deal['owner-id'].text]['updated-at'].text).getTime();
        var imageData = '<i class="avatar md-person  md-3x"></i>';
        if (connection && ALL_USERS[deal['owner-id'].text]['avatar-url'] != null) {
            imageData = '<div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ');width:40px;"></div>';
        }
        var html = "<li><a dealid='" + deal.id.text + "' class='deals-item'>";
            html += '<div class="favorite-event ' + starColor + '" style="float:left;">'
                    + '<span class="is-contact-image" style="padding: 5px 0px 10px 10px;">'
                    +  imageData
                    + '</span>'
                    + '<span style="padding-left:20px">'
                        + '<i class="md-grade md-lg"></i>'
                    + '</span>'
                + '</div>';

        var closeDate = "";
        if (deal.closeDate) {
            var dateTimeObject = new Date(deal.closeDate);
            closeDate = '<span>Close date: <b>' +
                dateFormat(dateTimeObject) + " " + timeFormat(dateTimeObject)
            + ' | </b></span>';
        }

        var personOrCompany = "";
        if (deal.party && deal.party.type && deal.party.type != "integer") {
            personOrCompany = '<div class="deal-item-status-padding">'
                                +'<span>' + deal.party.type + ': </span>'
                                + '<span><b>' + deal.party.name + '</b></span>'
                            + '</div>';
        }

        var priceText = null;
        if (deal.price && deal.price.text == null) {
            priceText = Messages.General.noPrice;
        } else {
            if (deal.price.text == "0") {
                priceText = Messages.General.noPrice;
            } else {
                priceText = self.priceFormatter(deal.price.text) + ' ' + deal.currency;
            }
        }

        if (priceText) {
            price = '<div class="deal-item-status-padding">'
                        + '<span>Price: <b>' + priceText + '</b></span>'
                    + '</div>';
        }

        html += '<div class="content-center" style="padding-left:60px;">'
                    + '<div class="title bold">'
                        + '<span> ('+ deal.entityId + ') </span>'
                        + '<span>' + deal.name + '</span>'
                    + '</div>'
                    + '<div>'
                        + '<span class="deal-item-padding"><b>'+ ALL_USERS[deal['owner-id'].text].name + '</b></span>'
                        + '<span class="deal-item-padding">created Opportunity on</span>'
                        + '<span class="deal-item-padding">'
                            + dateFormat(new Date(deal['created-at'].text)) + " " + timeFormat(new Date(deal['created-at'].text))
                        + '</span>'
                    + '</div>'
                    + '<div id="view-deal-probability" class="deal-item-status-padding">'
                        + '<span id="view-deal-probability-text"><b>'+ deal.probability + '%</b></span>'
                        + '<progress value="' + deal.probability + '" max="100" class="deal-item-progress"></progress>'
                    + '</div>'
                    + personOrCompany
                    + '<div class="deal-item-status-padding">'
                        + closeDate
                        + '<span>Status: <b>' + deal.status + '</b></span>'
                    + '</div>'
                    + price
                + '</div>'
        html += "</a></li>"
        return html;
    };

    self.drawDealList = function (listViewId, data, append, liCount) {

        if (liCount == null) {
            liCount = 0;
        }
        showLoadingIndikator();
        var $listView = $('#' + listViewId);
        var html = "";
        if (self.divider[listViewId] == null) {
            self.divider[listViewId] = {};
        }
        if (self.drawListParams[listViewId] == null) {
            self.drawListParams[listViewId] = {};
        }
        if (!append) {
            $listView.empty();
            self.drawListParams[listViewId]['start'] = offset;
            if (self.drawListParams[listViewId]['status'] != "search") {
                // if (currentStatus != null) {
                // 	self.drawListParams[listViewId]['status'] = currentStatus;
                // }
            } else {
                self.drawListParams[listViewId]['status'] = "search";
            }

            self.drawListParams[listViewId]['offset'] = offset;
        } else {
            if (data.length > 0) {
                self.drawListParams[listViewId]['start'] += self.drawListParams[listViewId]['offset'];
            }
        }
        FavoriteController.findAllMapByTypes(["Deal"], function(favoriteMap){
            favoriteMapData = favoriteMap;
            for (i = 0, max = data.length; i < max; i++) {
                html += self.drawDealItem(data[i]);
            }
            if (!append) {
                $listView.empty();
            }
            $listView.append(html);
            if ($("li", $listView).length == liCount) {
                $listView.append(emptyListHtml);
            }
            hideLoadingIndikator();
        });
    };

    self.priceFormatter = function (x) {
        return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    };

    self.filterDealTypeEvent = function () {
      if (VisibleDomainController.isDomainCTSales()) {
        self.filterForCTSales();
      } else {
        self.filterForCtcee();
      }
    };

    self.filterForCtcee = function() {
      var id = null;
      $("input:jqmData(type='search')", '#deals').val("");
      var newVal = $filterDealType.find('option:selected').val();
      if (!newVal) {
        newVal = "filter-open-deals";
      }
      var orgVal = newVal;
      if (newVal && newVal.startsWith('filter-custom')) {
         newVal = "filter-custom";
      }

      self.drawListParams[listViewId] = {
          'start': 0,
          'status': "Pending",
          'searchValue': "",
          'offset': offset
      };

      switch (newVal) {
          case "filter-open-deals":
              currentStatus = 'Open';
              self.drawListParams[listViewId]['status'] = currentStatus;
              if (self.drawListParams[listViewId] != null && self.drawListParams[listViewId]['status'] != null) {
                  self.drawListParams[listViewId]['status'] = currentStatus;
              }
              DealController.findDealByStatus(listViewId, id, false, function (data) {
                  self.drawDealList(listViewId, data, false, 0);
              });
              break;
          case "filter-my-won-deals":
              currentStatus = 'Won';
              self.drawListParams[listViewId]['status'] = currentStatus;
              self.drawListParams[listViewId]['owner'] = window.localStorage.getItem('userId');
              if (self.drawListParams[listViewId] != null && self.drawListParams[listViewId]['status'] != null) {
                  self.drawListParams[listViewId]['status'] = currentStatus;
              }
              DealController.findDealByStatus(listViewId, id, false, function (data) {
                  self.drawDealList(listViewId, data, false, 0);
              });
              break;
          case "filter-my-lost-deals":
              currentStatus = 'Lost';
              self.drawListParams[listViewId]['status'] = currentStatus;
              self.drawListParams[listViewId]['owner'] = window.localStorage.getItem('userId');
              if (self.drawListParams[listViewId] != null && self.drawListParams[listViewId]['status'] != null) {
                  self.drawListParams[listViewId]['status'] = currentStatus;
              }
              DealController.findDealByStatus(listViewId, id, false, function (data) {
                  self.drawDealList(listViewId, data, false, 0);
              });
              break;
          case "filter-my-active-deals":
              currentStatus = 'Active';
              self.drawListParams[listViewId]['status'] = currentStatus;
              self.drawListParams[listViewId]['owner'] = window.localStorage.getItem('userId');
              if (self.drawListParams[listViewId] != null && self.drawListParams[listViewId]['status'] != null) {
                  self.drawListParams[listViewId]['status'] = currentStatus;
              }
              DealController.findDealByStatus(listViewId, id, false, function (data) {
                  self.drawDealList(listViewId, data, false, 0);
              });
              break;
          case "filter-closed-deals":
              currentStatus = 'Closed';
              self.drawListParams[listViewId]['status'] = currentStatus;
              if (self.drawListParams[listViewId] != null && self.drawListParams[listViewId]['status'] != null) {
                  self.drawListParams[listViewId]['status'] = currentStatus;
              }
              DealController.findDealByStatus(listViewId, id, false, function (data) {
                  self.drawDealList(listViewId, data, false, 0);
              });
              break;
          case "filter-favorite-deals":
              currentStatus = 'Favorite';
              self.drawListParams[listViewId]['status'] = currentStatus;
              self.drawListParams[listViewId]['favorite'] = true;
              if (self.drawListParams[listViewId] != null && self.drawListParams[listViewId]['status'] != null) {
                  self.drawListParams[listViewId]['status'] = currentStatus;
              }
              DealController.findDealByStatus(listViewId, id, false, function (data) {
                  self.drawDealList(listViewId, data, false, 0);
              });
              break;
          case "filter-custom":
              currentStatus = 'filter-custom';
              self.drawListParams[listViewId]['status'] = currentStatus;
              self.drawListParams[listViewId]['favorite'] = false;
              var request = JSON.parse($filterDealType.find(":selected").attr('filter'));
              DealController.findCustomDeal(request, function(data) {
                self.drawDealList(listViewId, data, false, 0);
              });
              break;
      }
      $filterDealType.i18n();
      $filterDealType.val(orgVal).selectmenu('refresh');
    };

    self.filterForCTSales = function() {
      var id = null;
      $("input:jqmData(type='search')", '#deals').val("");
      var newVal = $filterDealType.find('option:selected').val();
      if (!newVal) {
        newVal = "filter-all-deals";
      }

      if (newVal && newVal.startsWith('filter-custom')) {
         newVal = "filter-custom";
         self.drawListParams[listViewId]['status'] = "filter-custom";
         self.drawListParams[listViewId]['favorite'] = false;
         var request = JSON.parse($filterDealType.find(":selected").attr('filter'));
         DealController.findCustomDeal(request, function(data) {
           self.drawDealList(listViewId, data, false, 0);
         });
      } else {
        self.drawListParams[listViewId] = {
            'start': 0,
            'status': "Pending",
            'searchValue': "",
            'offset': offset
        };
        self.drawListParams[listViewId]['status'] = newVal;
        DealController.findDealByStatusCTSales(listViewId, id, false, function (data) {
            self.drawDealList(listViewId, data, false, 0);
        });
      }

      $filterDealType.i18n();
      $filterDealType.val(newVal).selectmenu('refresh');
    };

    self.listScrollLoadEvent = function () {
        if (($(this).scrollTop() + $(window).height()) >= ($(this).height() - 200)) {
            if (self.findTime) {
                clearTimeout(self.findTime);
            }
            self.findTime = setTimeout(function () {
                var requestObject = {};
                if (self.drawListParams[listViewId]['status'] != "search") {
                    requestObject = self.requestObjectFilter(self.drawListParams[listViewId]['status']);
                } else {
                    requestObject['searchKeywords'] = new RegExp(self.drawListParams[listViewId]['searchValue'].trim().replace(' ', '|'), "i");
                }
                var sort = [["modificationDate", -1]];
                var customFilter = self.checkAndPrepairCustomFilter();
                if (customFilter) {
                    sort = customFilter[1];
                    requestObject = customFilter[0];
                }
                self.listScrollLoad(listViewId, requestObject, sort);
            }, 300);
        }
    };

    self.listScrollLoad = function (listViewId, query, sort) {
        showLoadingIndikator();
        $(document).off('scrollstop');
        if (connection) {
            ClientAPI.findPaged(query, sort,
                    self.drawListParams[listViewId]['start'] / self.drawListParams[listViewId]['offset'] + 1,
                    self.drawListParams[listViewId]['offset'],
                    function (err, items) {
                        var deals = [];
                        for (var i = 0, max = items.length; i < max; i++) {
                            deals.push(DealController.encodeItem(items[i]));
                        }
                        $(document).on('scrollstop', self.listScrollLoadEvent);
                        self.drawDealList(listViewId, deals, true);
                    });
        } else {
            var query = "SELECT * FROM DEAL WHERE ";
            var queryDate = [];
            if (self.drawListParams[listViewId]['status'] == 'search') {
                var searchValues = self.drawListParams[listViewId]['searchValue'].split(' ');

                for (var i = 0, max = searchValues.length; i < max; i++) {
                    if (i == 0) {
                        query += 'searchKeywords LIKE ? ';
                        queryDate.push("%" + searchValues[i] + "%");
                    } else {
                        query += 'OR searchKeywords LIKE ? ';
                        queryDate.push("%" + searchValues[i] + "%");
                    }
                }

                query += "ORDER BY [updated-at] DESC LIMIT ?, ?";
                queryDate.push(self.drawListParams[listViewId]['start']);
                queryDate.push(self.drawListParams[listViewId]['offset']);
            } else {
                query += 'status =? ORDER BY [updated-at] DESC LIMIT ?, ?';
                queryDate.push(self.drawListParams[listViewId]['status']);
                queryDate.push(self.drawListParams[listViewId]['start']);
                queryDate.push(self.drawListParams[listViewId]['offset']);
            }

            db.selectByQuery(query, queryDate, 'deal', function (items) {
                $(document).on('scrollstop', self.listScrollLoadEvent);
                self.drawDealList(listViewId, items, true);
            });
            hideLoadingIndikator();
        }
    };

    self.dealsInputEvent = function (event) {
        self.drawListParams[listViewId] = {
            'start': 0,
            'status': "search",
            'searchValue': event.currentTarget.value,
            'offset': offset
        };
        if (self.findTime) {
            clearTimeout(self.findTime);
        }
        self.findTime = setTimeout(function () {
            if (event.currentTarget.value.length != 0) {
                if (connection) {
                    var pattern = new RegExp(event.currentTarget.value.trim().replace(' ', '|'), "i");
                    if (event.currentTarget.value.length > 0) {
                        ClientAPI.findPaged({objectType: "Deal", searchKeywords: pattern}, [["modificationDate", -1]], 1, offset, function (err, items) {
                            var deals = [];
                            for (var i = 0, max = items.length; i < max; i++) {
                                deals.push(DealController.encodeItem(items[i]));
                            }
                            self.drawDealList(listViewId, deals, false);
                        });
                    } else {
                        self.filterDealTypeEvent();
                    }
                } else {
                    var query = "SELECT * FROM DEAL WHERE ";
                    var queryDate = [];
                    var searchValues = self.drawListParams[listViewId]['searchValue'].split(' ');

                    for (var i = 0, max = searchValues.length; i < max; i++) {
                        if (i == 0) {
                            query += 'searchKeywords LIKE ? ';
                            queryDate.push("%" + searchValues[i] + "%");
                        } else {
                            query += 'OR searchKeywords LIKE ? ';
                            queryDate.push("%" + searchValues[i] + "%");
                        }
                    }

                    query += "ORDER BY [updated-at] DESC LIMIT ?, ?";
                    queryDate.push(self.drawListParams[listViewId]['start']);
                    queryDate.push(self.drawListParams[listViewId]['offset']);

                    db.selectByQuery(query, queryDate, 'deal', function (items) {
                        self.drawDealList(listViewId, items, false);
                    });

                    hideLoadingIndikator();
                }
            } else {
                self.drawListParams[listViewId] = {
                    'start': 0,
                    'status': currentStatus,
                    'offset': offset
                };
                self.filterDealTypeEvent();
            }
        }, 300);
    };

    self.dealsInputDeleteAllEvent = function () {
        $("#" + listViewId).empty();
        self.drawListParams[listViewId]['status'] = $filterDealType.find('option:selected').val();
        self.filterDealTypeEvent();
    };

    self.draftLinkEvent = function () {
        gotoPage({url: "draft", param: null}, {url: "deals", param: null});
    };

    return self;
}(DealFunctions || {}));
