$(document).on('pageinit', '#update-deal-link', function () {
        UpdateDealLink.init();
});

$(document).on('pageshow', '#update-deal-link', function () {
    UpdateDealLink.bindElementControls();
});

$(document).on('pagehide', '#update-deal-link', function () {
    UpdateDealLink.unbindElementControls();
});

var UpdateDealLink = (function (UpdateDealLink) {
    var self = UpdateDealLink;
    var dealId = null;
    var dealObj = null;
    
    self.init = function () {
        if(pageObject){
            dealId = pageObject.dealId;
            pageObject = null;
        }
        DealController.findById(dealId, function (data) {
            dealObj = data;
            self.loadLinks(dealObj.link);
        });
    };

    self.bindElementControls = function () {
        $(document).on('click', '#update-deal-link #back-link', goBack);
        $(document).on('click', '#update-deal-link #more-link', self.openEditCommentPopup);
        $(document).on('click', '#update-deal-link #save-link', self.saveDealLinks);
        $('#update-deal-link .popup-menu-backdrop').on('click', function () {
            $('#update-deal-link .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#update-deal-link .additional-options', self.saveDealLinks);
        $(document).on('click', '#update-deal-link .btn-deal-link', self.populateLinkList);
        $(document).on('click', '#update-deal-link #deal-link-details', function(){
            $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
            $("#update-deal-link .deal-link-list-container").toggle();
        });
        $(document).on('click', '#update-deal-link .link-val', function(){
            var linkVal = $(this).text();
            window.open(linkVal, "_blank", "location=yes");
        });
        $(document).on('click', '#update-deal-link .link-remove-btn', self.removeLink);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#update-deal-link #back-link');
        $(document).off('click', '#update-deal-link #more-link');
        $(document).off('click', '#update-deal-link #save-link');
        $('#update-deal-link .popup-menu-backdrop').off('click');
        $(document).off('click', '#update-deal-link .additional-options');
        $(document).off('click', '#update-deal-link .btn-deal-link');
        $(document).off('click', '#update-deal-link #deal-link-details');
        $(document).off('click', '#update-deal-link .link-val');
        $(document).off('click', '#update-deal-link .link-remove-btn');
    };
    
    self.loadLinks = function (links) {
        var html = "";
        if (links instanceof  Array) {
            for (var i = 0; i < links.length; i++) {
                html += "<li>";
                if (links[i].urlType.toLowerCase() == "link") {
                    html += "<div class='link-type' linkType='"+ links[i].urlType + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
                } else {
                    html += "<div class='link-type' linkType='"+ links[i].urlType +"' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
                }
                html += "<div class='link-desc truncate' link-val='"+ links[i].url +"' style='padding: 0px 10px; max-width: 70%;'>" + links[i].urlDesc + "</div>"
                        + "<div class='link-remove-btn'><i class='md md-delete md-2x'></i></div>"
                        + "</li>";
            }
        } else {
            html += "<li>";
            if (links.urlType.toLowerCase() == "link") {
                html += "<div class='link-type' linkType='" + links.urlType + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
            } else {
                html += "<div class='link-type' linkType='"+ links.urlType + "' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
            }
            html += "<div class='link-desc truncate' link-val = '"+ links.url +"' style='padding: 0px; max-width: 70%;'>" + links.urlDesc + "</div>"
                    + "<div class='link-remove-btn'><i class='md md-delete md-2x'></i></div>"
                    + "</li>";
        }
        
        if (html != "") {
            $("#update-deal-link #deal-link-list").append(html);
        }
    };

    self.saveDealLinks = function () {
        var dealLinks = [];
        var $linkItems = $("#update-deal-link #deal-link-list li");
        var linksCount = $linkItems.length;
        for (var i = 0; i < linksCount; i++) {
            var linkObject = {};
            linkObject.url = $($linkItems[i]).find('div.link-desc').attr('link-val');
            linkObject.urlDescription = $($linkItems[i]).find('div.link-desc').text();
            linkObject.urlType = $($linkItems[i]).find('div.link-type').attr('linkType');
            dealLinks.push(linkObject);
        }
        DealController.updateDealLinks(dealId, dealLinks);
        
    };
    
    self.openEditCommentPopup = function () {
        $('#update-deal-link .popup-menu-backdrop').toggle();
        $('#update-deal-link .advanced-menu').css('z-index', '20000');
        $('#update-deal-link .advanced-menu').slideToggle('4000', 'swing');
    };
    
    self.populateLinkList = function(){
        var html = "";
        var $linkVal = $("#update-deal-link .deal-link-val");
        var $linkDesc = $("#update-deal-link .deal-link-desc");
        var $linkType = $("#update-deal-link .deal-link-type option:selected");
        var linkUrl = $linkVal.val();
        var linkDesc = $linkDesc.val();
        if(linkUrl && linkDesc){
            html += "<li>";
            if($linkType.val() == "link"){
                html += "<div class='link-type' linkType='"+ $linkType.val() +"' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
            } else {
                html += "<div class='link-type' linkType='"+ $linkType.val() +"' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
            }
            html += "<div class='link-desc truncate' link-val = '"+ $linkVal.val() +"' style='padding: 0px 10px; max-width: 70%;'>" + linkDesc + "</div>"
                    + "<div class='link-remove-btn'><i class='md md-delete md-2x'></i></div>"
                    + "</li>";
        }
        if(html != ""){
            $("#update-deal-link #deal-link-list").append(html);
            $linkVal.val("");
            $linkDesc.val("");
        }
    };
    
    self.removeLink = function(){
        $(this).parent().remove();
    };
    
    return self;
}(UpdateDealLink || {}));			