var navigationFix = false;
$(document).on('pageinit', "#view-deal", function () {
    navigationFix = false;
    ViewDealFunctions.init();
    $("#view-deal-general-content").click(function () {
        $("#view-deal .navigation_button").toggle("slow");
    });
});

$(document).on('pagehide', '#view-deal', function () {
    ViewDealFunctions.unbindElementControls();
    navigationFix = false;
});

$(document).on('pageshow', '#view-deal', function () {
    sharedTaskForOpen = null;
    ViewDealFunctions.bindElementControls();
    taskFromContactObject = null;
    setTimeout(function () {
        $("#view-deal .swipe-indicator").fadeOut("400");
    }, 1000);
});

var ViewDealFunctions = (function (ViewDealFunctions)
{
    var self = ViewDealFunctions;
    var deal = null;
    self.currentTab = null;
    self.currentTaskType = 'Upcoming';
    var $permissionDealUsersPopup = null;
    var $addNewLink = null;
    var $dealsMoreLink = null;
    var $addElement = null;
    var $refreshLink = null;
    var $refreshElement = null;
    var $generalContent = null;
    var $generalLink = null;
    var $notesContent = null;
    var $notesLink = null;
    var $noteList = null;
    var $tasksContent = null;
    var $tasksLink = null;
    var $tasksList = null;
    var $viewDealHeading = null;
    var $viewDealDesc1 = null;
    var $userDealPermissionList = null;
    var $viewDealPrivate = null;
    var $filterDealTaskType = null;
    var $rbDealPending = null;
    var $rbDealWon = null;
    var $rbDealLost = null;
    var $rbDealNegotiation = null;
    var $rbDealInactive = null;
    var $rbDealAnalyses = null;
    var $rbDealProspecting = null;
    var $rbDealProposalSent = null;
    var $dealsRadioFirst = null;
    var $dealsRadioSecond = null;
    var $dealsRadioThird = null;
    var $dealsDescription = null;
    var $viewDealDescription = null;
    var $dealPartyList = null;
    var $dealStatusChangeComment = null;
    var $lastNoteHeadingContainer = null;
    var $lastNoteHeading = null;
    var $lastNote = null;
    var $dealCategoryDescription = null;
    var $viewDealProbability = null;
    var statusText = null;
    var listViewId = null;
//	var tapholdActive 						= false;
    var $dealPopup = null;
    var dealId = null;
    var dealIds = null;
    var listParams = [];
    var $notesLinkContainer = null;
    var $tasksLinkContainer = null;

    var $taskList = null;
    var currentDealIndex = null;
    var $attachContent = null;
    var $attachList = null;
    var attachments = null;

    self.init = function () {
        VisibleDomainController.hide("view-deal");
        $permissionDealUsersPopup = $('#permission-deal-users-popup');
        $addNewLink = $('#add-new-link');
        $dealsMoreLink = $("#deal-more-link");
        $dealPopup = $("#view-deal .advanced-menu");
        $addElement = $('#view-deal-add-element');
        $refreshLink = $('#view-deal #refresh-link');
        $refreshElement = $('#view-deal-refresh-element');
        $generalContent = $('#view-deal-general-content');
        $generalLink = $('#view-deal-general-link');
        $notesContent = $('#view-deal-notes-content');
        $notesLink = $('#view-deal-notes-link-text');
        $notesLinkContainer = $('#view-deal-notes-link');
        $noteList = $('#view-deal-notes-list');
        $tasksContent = $('#view-deal-tasks-main-content');
        $tasksLink = $('#view-deal-tasks-link-text');
        $tasksLinkContainer = $('#view-deal-tasks-link');
        $tasksList = $('#view-deal-tasks-list');
        $viewDealHeading = $('#view-deal-heading');
        $viewDealDesc1 = $('#view-deal-desc1');
        $userDealPermissionList = $('#user-deal-permission-list');
        $viewDealPrivate = $("#deal-view-private-box");
        $filterDealTaskType = $("#filter-deal-task-type");
        $rbDealPending = $('#rb-deal-pending');
        $rbDealWon = $('#rb-deal-won');
        $rbDealLost = $('#rb-deal-lost');
        $rbDealNegotiation = $('#rb-deal-negotiation');
        $rbDealInactive = $('#rb-deal-inactive');
        $rbDealAnalyses = $('#rb-deal-analyses');
        $rbDealProspecting = $('#rb-deal-prospecting');
        $rbDealProposalSent = $('#rb-deal-proposal-sent');
        $dealsRadioFirst = $('.deals-radio-first');
        $dealsRadioSecond = $('.deals-radio-second');
        $dealsRadioThird = $('.deals-radio-third');
        $dealsDescription = $('#deals-description');
        $viewDealDescription = $('#view-deal-description');
        $dealPartyList = $('#deal-party-list');
        $dealStatusChangeComment = $('#deal-status-change-comment');
        $lastNoteHeadingContainer = $("#view-deal-latest-note-heading-container");
        $lastNoteHeading = $("#view-deal-latest-note-heading");
        $lastNote = $("#view-deal-latest-note");
        listViewId = 'view-deal-tasks-list';
        $dealCategoryDescription = $("#view-deal-category");
        $viewDealProbability = $('#view-deal-probability');
        $viewDeal = $('#view-deal');
        $taskList = $('#view-deal-tasks-list');
        $viewDealPrivate.show();
        self.currentTaskType = "Upcoming";
        $attachContent = $('#view-deal #view-deal-attach-content');
        $attachList = $('#view-deal #view-deal-attach-list');
        // init params

        if (pageObject) {
            dealId = pageObject.id;
            dealIds = pageObject.ids;
            listParams = pageObject.listParams;
            pageObject = null;
        }
        //deal pagination
        if (dealIds && dealIds.length > 1) {
            currentDealIndex = dealIds.indexOf(dealId);
            $("#view-deal .title-h1").text("(" + (currentDealIndex + 1) + "/" + dealIds.length + ")");
        }


        // load deal
        DealController.findById(dealId, function (data, feedItems) {
            deal = data;
            // init view
            self.drawHeading();

            self.getAttachmentCount(function (count, attachment) {
                $("#view-deal #view-deal-attach-link-text").text("(" + count + ")");
                attachments = attachment;
                if (self.currentTab.toLocaleLowerCase() == "attachment") {
                    self.loadAttachment(attachments);
                }
            });

            if (self.currentTab != null) {
                if (self.currentTab.toLowerCase() == "tasks") {
                    self.navigateTasks();
                } else if (self.currentTab.toLowerCase() == "notes") {
                    self.navigateNotes();
                } else if (self.currentTab.toLowerCase() == "general") {
                    self.navigateGeneral();
                }
            } else {
                self.navigateGeneral();
            }
            if (feedItems) {
                self.loadItemHistory(feedItems);
            }
        });

        FavoriteController.findByObjectIdDB(dealId, function(data){
            if (data && data.length > 0) {
                $('.md-star').addClass('contact-favorite-star');
            }
        });
    };

    self.activateTab = function (tabName) {
        switch (tabName) {
            case "General":
                $notesLinkContainer.removeClass("btn-active");
                $tasksLinkContainer.removeClass("btn-active");
                $("#view-deal #view-deal-attach-link").removeClass("btn-active");
                $generalLink.addClass("btn-active");
                break;
            case "Note":
                $tasksLinkContainer.removeClass("btn-active");
                $generalLink.removeClass("btn-active");
                $("#view-deal #view-deal-attach-link").removeClass("btn-active");
                $notesLinkContainer.addClass("btn-active");
                break;
            case "Task":
                $generalLink.removeClass("btn-active");
                $notesLinkContainer.removeClass("btn-active");
                $("#view-deal #view-deal-attach-link").removeClass("btn-active");
                $tasksLinkContainer.addClass("btn-active");
                break;
            case "Attachment":
                $generalLink.removeClass("btn-active");
                $notesLinkContainer.removeClass("btn-active");
                $tasksLinkContainer.removeClass("btn-active");
                $("#view-deal #view-deal-attach-link").addClass("btn-active");
                break;
        }

    };

    self.bindElementControls = function () {
        $(document).on('click', '#view-deal-general-link', self.navigateGeneral);
        $(document).on('click', '#view-deal-notes-link', self.navigateNotes);
        $(document).on('click', '#view-deal-tasks-link', self.navigateTasks);
        $(document).on('click', '#refresh-link', self.refreshButtonEvent);
        $('#view-deal-back-link').on('click', self.backButtonEvent);
        $('#filter-deal-task-type').on('change', self.filterTaskTypeEvent);
        $(document).on('click', '#view-deal-private', self.openPrivate);
        $(document).on('click', '#deal-more-link', self.openDealOptionsPopup);
        $(document).on('click', '#add-new-link', self.addNewEvent);
        $(document).on('click', '#view-deal-notes-list .note', self.eventNoteView);
        $(document).on('click', 'li .createdTask', self.completeTaskEvent);
        $(document).on('click', 'li .assignedTask', self.completeTaskEvent);
        $(document).on('click', 'li .completedTask', self.completeTaskEvent);
        $(document).on('click', 'li .inprogressTask', self.completeTaskEvent);

        $(document).on('click', 'li .canceledTask', function () {
            alert("Status change is not allowed!");
        });
        $(document).on('click', '#deal-party-list', self.dealPartyListEvent);
        $(document).on('click', '#view-deal .task-item', self.taskItemEvent);
//		$(document).on('taphold', '#view-deal .task-item', self.deleteTaskItem);
        $(document).on('click', "#update-deal-status", self.openChangeDealStatusPopup);
        $(document).on('click', '#view-deal #update-link', self.gotoUpdateDealLink);
        $(document).on('click', '#delete-deal', self.dealDeleteLinkEvent);
        $(document).on('click', '#edit-deal-action', self.editDealEvent);
        $(document).on('click', '#view-deal .float-add-action', self.floatButton);
        $(document).on('click', '#view-deal .popup-menu-backdrop', self.closeFloatButtonAttachment);


        $(document).on('click', '#view-deal #deal-view-take-photo', function() {
            self.closeFloatButtonAttachment();
            self.takePhoto();
        });

        $(document).on('click', '#view-deal #view-task-choose-image', function() {
            self.closeFloatButtonAttachment();
            self.chooseFromFileSystem();
        });

        $('#view-deal .popup-menu-backdrop').on('click', function () {
            $('#view-deal .advanced-menu').hide();
            $('#view-deal .attach-advanced-menu').hide();
            $(this).hide();
        });

        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });



        $("body").on("swipeleft", "#view-deal", self.dealSwipeLeftEvent);
        $("body").on("swiperight", "#view-deal", self.dealSwipeRightEvent);

        $(document).on("click", "#view-deal .childTasks", self.getChildTasks);
        $(document).on("click", "#view-deal .task-due-date-change", self.changeDueDateEvent);
        $(document).on('click', '#view-deal .comment-container', self.getCommentList);
        $(document).on('click', '#view-deal #favorite-deal', self.setAsFavorite);
        $(document).on('click', '#view-deal #favorite-deal-mouseover', self.setAsFavorite);
        $(document).on('click', '#view-deal .task-list-icons', TaskFunctions.changeEventDueDateChildTask);
        $(document).on('click', '#view-deal #view-deal-attach-link', self.loadAttachment);
        $(document).on('click', '#view-deal .delete-item', self.deleteAttachment);
        $(document).on('click', '#view-deal #take-photo', self.takePhoto);
        $(document).on('click', '#view-deal #choose-from-gallery', self.chooseFromFileSystem);
        $(document).on('click', '#view-deal .attachment', self.openAttachment);
        $(document).on('click', '#view-deal .child-task-item', self.navigateToChildTask);
        $(document).on('click', '#view-deal .load-task-child-btn', self.loadChildTaskEvent);
        $("#filter-deal-task-type").selectmenu();

        $(document).on("click", "#view-deal .deal-link-display", self.viewItemVisibleToggle);
        $(document).on("click", "#view-deal .view-item-history", self.viewItemVisibleToggle);
        $(document).on("click", "#view-deal .view-deal-permission", self.viewItemVisibleToggle);
        $(document).on('click', '#view-deal .favorite-event', TaskFunctions.eventFavorite);
        $(document).on('click', '#view-deal .task-list-icons', self.changeEventDueDateChildTask);
        $(document).on("click", "#view-deal .deal-link-el", function () {
            var linkVal = $(this).attr('linkurl');
            window.open(linkVal, "_blank", "location=yes");
        });
        $(document).on('click', '#view-deal .add-new-permission-user', self.changePermission);
        $(document).on('click', '#view-deal .visible-user-item', self.removePersonPermission);

        if (!VisibleDomainController.isDomainCTSales()) {
          $(document).on('click', '#view-deal #view-deal-author', self.openAuthorEvent);
          $(document).on('click', '#view-deal #view-deal-owner', self.changeOwner);
          $(document).on('click', '#view-deal #view-deal-close-date', self.changeCloseDateEvent);
          $(document).on('click', '#view-deal #current-deal-status', self.openChangeDealStatusPopup);
        }
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#view-deal-general-link');
        $(document).off('click', '#view-deal-notes-link');
        $(document).off('click', '#view-deal-tasks-link');
        $(document).off('click', '#refresh-link');
        $(document).off('click', '#view-deal-private');
        $(document).off('click', '#add-new-link');
        $(document).off('click', '#deal-more-link');
        $('#view-deal-back-link').off('click');
        $(document).off('click', '#delete-deal');
        $('#filter-deal-task-type').off('change');
        $(document).off('click', '#view-deal .task-list-icons');
        $(document).off('click', '#edit-deal-action');
        $(document).off('click', '#view-deal-notes-list .note');
        $(document).off('scrollstop');
        $(document).off('click', 'li .assignedTask');
        $(document).off('click', 'li .createdTask');
        $(document).off('click', 'li .completedTask');
        $(document).off('click', 'li .inprogressTask');
        $(document).off('click', 'li .canceledTask');
        $(document).off('click', '#deal-party-list');
        $(document).off('click', '#view-deal .task-item');
        $(document).off('click', '#view-deal .float-add-action');
//		$(document).off('taphold', '#view-deal .task-item');
        $(document).off('click', "#update-deal-status");
        $(document).off('click', '#view-deal #update-link');
        $('#view-deal .popup-menu-backdrop').off('click');
        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipeleft", "#view-deal");
        $("body").off("swiperight", "#view-deal");
        $(document).off("click", "#view-deal .childTasks");
        $(document).off("click", "#view-deal .deal-link-display");
        $(document).off("click", "#view-deal .deal-link-el");
        $(document).off("click", "#view-deal .task-due-date-change");
        $(document).off('click', '#view-deal .comment-container');
        $(document).off('click', '#view-deal #favorite-deal');
        $(document).off('click', '#view-deal #favorite-deal-mouseover');
        $(document).off("click", "#view-deal .view-item-history");
        $(document).off('click', '#view-deal #view-deal-attach-link');
        $(document).off('click', '#view-deal .delete-item');
        $(document).off('click', '#view-deal #take-photo');
        $(document).off('click', '#view-deal #choose-from-gallery');
        $(document).off('click', '#view-deal .attachment');
        $(document).off('click', '#view-deal .child-task-item');
        $(document).off('click', '#view-deal .load-task-child-btn');
        $(document).off("click", "#view-deal .view-deal-permission");
        $(document).off('click', '#view-deal .favorite-event');
        $(document).off('click', '#view-deal .task-list-icons');
        $(document).off('click', '#view-deal .float-add-action');
        $(document).off('click', '#view-deal .popup-menu-backdrop');
        $(document).off('click', '#view-deal #deal-view-take-photo');
        $(document).off('click', '#view-deal #view-task-choose-image');
        $(document).off('click', '#view-deal #current-deal-status');
        $(document).off('click', '#view-deal #view-deal-author');
        $(document).off('click', '#view-deal #view-deal-owner');
        $(document).off('click', '#view-deal #view-deal-close-date');
        $(document).off('click', '#view-deal .add-new-permission-user');
        $(document).off('click', '#view-deal .visible-user-item');
    };

    self.removePersonPermission = function() {
      var identity = $(this).attr('data-identity');
      deal.objectType = "Deal";
      PermissionController.removePermissionFromObject(identity, deal, function(success){
        if (success) {
          $('.visible-user-item[data-identity=' + identity +']').remove();
          var visibleTo = [];
          for (var i = 0, max = deal['visible-to'].length; i < max; i++) {
              if (deal['visible-to'][i].identity != identity) {
                visibleTo.push(deal['visible-to'][i]);
              }
          }
          deal['visible-to'] = visibleTo;
        }
      });
    };

    self.floatButton = function() {
        var id = $(this).parent().parent().attr('id');
        if (id === "view-deal-general-content") {
          self.editDealEvent();
        } else if (id === "view-deal-tasks-main-content" || id === "view-deal-notes-content"){
          self.addNewEvent();
        } else {
          self.openFloatButtonAttachment();
        }
    };

    self.openFloatButtonAttachment = function () {
        $(this).toggleClass("rotation-event");
        $('#view-deal .popup-menu-backdrop').toggle();
        $('#view-deal .menu-more-option').toggle();
    };

    self.closeFloatButtonAttachment = function() {
        $('#view-deal .menu-more-option').hide();
        $('#view-deal .float-add-action').removeClass("rotation-event");
        $(this).hide();
        if (!VisibleDomainController.isDomainCTSales()) {
            $('.float-add-action').show();
        }
    };

    self.changeEventDueDateChildTask = function(e) {
        var idTask = $(this).attr("taskid");
        var dueDate = $(this).attr("duedate");
        var created = $(this).attr("created");
        var displayName = $(this).attr("displayName");
        var parent = {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}};

        var params = null;
        if ($(this).hasClass('md-flag')) {
            params = {
                url: "changeStatus",
                param: {
                  parentId: idTask,
                  parentType: "Task"
                }
            };
        } else if ($(this).hasClass('md-event')) {
          params = {
              url: "changeDueDate",
              param: {
                'taskId': idTask,
                'dueDate': dueDate
              }
          };
        } else if ($(this).hasClass('md-access-time')) {
          params = {
            url: "effort",
            param: {
              'displayName':  displayName,
              'relatedCreationDate' : created,
              'relatedType' : "Task",
              'relatedId' : idTask
            }
          };
        }
        gotoPage(params, parent);
        e.stopPropagation();
    }

    self.viewItemVisibleToggle =  function (event) {
          $('html, body').animate({scrollTop: $(document).height()}, 'slow');
          $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
          $('#' + $(this).attr('container')).toggleClass('hide');
    };

    self.changeCloseDateEvent = function () {
        var id = deal.id.text;
        var dueDate = deal['closeDate'];
        gotoPage({
            url: "changeDueDate",
            controller: ChangeDueDateFunctions,
            isModal: true,
            param: {'id': id, 'dueDate': dueDate, 'type' : "closeDate"}
        }, {url: "viewDeal", param: {"id": id, ids: dealIds, listParams: listParams}});
    };

    self.changeOwner = function () {
        var id = deal.id.text;
        self.closeModalPanel();
        gotoPage(
          {url: "changeOwner", param: {"id": id, type: "Deal"}},
          {url: "viewDeal", param: {"id": id, ids: dealIds, listParams: listParams}}
        );
    };

    self.changePermission = function(){
        gotoPage({url: "changePermission", param: {"id": deal.id.text, type: "Deal"}}, {url: "viewDeal", param: {"id": deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.gotoUpdateDealLink = function () {
        self.closeModalPanel();
        gotoPage({url: "updateDealLink", param: {dealId: deal.id.text}},
        {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.changeDueDateEvent = function () {
        var idTask = $(this).attr("taskid");
        var dueDate = $(this).attr("duedate");
        self.closeModalPanel();
        gotoPage({
            url: "changeDueDate",
            param: {taskId: idTask, dueDate: dueDate}
        }, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.getChildTasks = function () {
        $("i", this).toggleClass("md-expand-more md-expand-less");
        var parentId = $(this).attr("parentId");
        $("ul[id='" + parentId + "']").attr('data-pageCount', 1);
        if (connection) {
            var request = {objectType: "Task", immediateParent: new ObjectId(parentId)};
            ClientAPI.findPaged(request, [["dueDate", 1]], 1, offset, function (err, items) {
                if (items && items.length > 0) {
                    var tasks = [];
                    for (var i = 0; i < items.length; i++) {
                        tasks.push(TaskController.encodeItem(items[i]));
                    }
                    TaskFunctions.drawSimpleTaskListView(parentId, tasks);
                    if(items.length < offset){
                        $("ul[id='" + parentId + "'] .load-task-child-btn").remove();
                    }
                    for (var i = 0; i < tasks.length; i++) {
                        (function (num) {
                            ClientAPI.findCount({
                                objectType: "Task",
                                immediateParent: new ObjectId(tasks[num].id.text)
                            },
                                    function (err, data) {
                                        if (!err) {
                                            if (data == 0) {
                                                $("a[parentId='" + tasks[num].id.text + "']").remove();
                                            } else {
                                                $("a[parentId='" + tasks[num].id.text + "']").append("(" + data + ")");
                                            }
                                        }
                                    });
                        })(i);
                    }
                    $("#view-deal ul [id='" + parentId + "']").toggle();
                }
            });
        } else {
            db.selectByQuery('SELECT * FROM TASK WHERE [recording-id] = ? AND [recording-type] = ? LIMIT ?, ?', [getTextTypeObject(parentId, 'integer'), "Task", 0, offset], 'task', function (items) {
                TaskFunctions.drawSimpleTaskListView(parentId, items);
                $("ul[id='" + parentId + "'] .load-task-child-btn").remove();
                for (var i = 0; i < items.length; i++) {
                    (function (num) {
                        db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-id" = ? AND "recording-type" = ?',
                                [getTextTypeObject(items[num].id.text, 'integer'), "Task"], models.taskDBModel.name, function (data) {
                            if (data[0]['count(*)'] == 0) {
                                $("a[parentId='" + items[num].id.text + "']").remove();
                            } else {
                                $("a[parentId='" + items[num].id.text + "']").append(" (" + data[0]['count(*)'] + ")");
                            }
                        });
                    })(i);
                }
                $("#view-deal ul [id='" + parentId + "']").toggle();
            });
        }
    };

    self.dealSwipeLeftEvent = function () {
        if (dealIds && dealIds.length > 1) {
            currentDealIndex++;
            if (currentDealIndex > dealIds.length - 1) {
                if (connection && !listParams.favorite) {
                    var requestObject = {objectType: "Deal"};
                    if (listParams.parentId) {
                        requestObject['immediateParent'] = listParams.parentId;
                    }
                    var currentStatus = listParams.status;
                    if (currentStatus == "Open") {
                        requestObject['$or'] = [{status: "ProposalSent"}, {status: "Negotiation"}, {status: "Analyses"}, {status: "Prospecting"}, {status: "Pending"}];
                    } else if (currentStatus == "Won") {
                        requestObject['status'] = "Won";
                    } else if (currentStatus == "Lost") {
                        requestObject['status'] = "Lost";
                    } else if (currentStatus == "Active") {
                        requestObject['$or'] = [{status: "ProposalSent"}, {status: "Negotiation"}, {status: "Analyses"}, {status: "Prospecting"}, {status: "Pending"}];
                    } else if (currentStatus == "Closed") {
                        requestObject['$or'] = [{status: "Won"}, {status: "Lost"}, {status: "Inactive"}];
                    }
                    if (listParams.owner) {
                        requestObject['owner'] = listParams.owner;
                    }

                    ClientAPI.findPaged(requestObject, [["modificationDate", -1]],
                            listParams.start / listParams.offset + 1,
                            listParams.offset,
                            function (err, items) {
                                if (items.length == 0) {
                                    currentDealIndex = 0;
                                }
                                for (var i = 0, max = items.length; i < max; i++) {
                                    dealIds.push(DealController.encodeItem(items[i]).id.text);
                                }
                                listParams.start += listParams.offset;
                                dealId = dealIds[currentDealIndex];
                                self.init();
                            });
                } else {
                    currentDealIndex = 0;
                    dealId = dealIds[currentDealIndex];
                    self.init();
                }
            } else {
                dealId = dealIds[currentDealIndex];
                self.init();
            }
        }
    };

    self.dealSwipeRightEvent = function () {
        if (dealIds && dealIds.length > 1) {
            currentDealIndex--;
            currentDealIndex = (currentDealIndex < 0) ? (dealIds.length - 1) : currentDealIndex;
            dealId = dealIds[currentDealIndex];
            self.init();
        }
    };

    self.dealDeleteLinkEvent = function () {
        $("#view-deal .popup-menu-backdrop").hide();
        $dealPopup.hide();
        setTimeout(function () {
            showActionDialog(Messages.Deal.deleteMessage, "Yes", self.deleteDeal, "No", function () {
            });

        }, 100);
    };

    self.onPullDown = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            console.log("onPullDown view deal -1");
            self.refreshButtonEvent();
        }
    };

    self.openDealOptionsPopup = function () {
        $("#view-deal .navigation_button").hide();
        $('#view-deal .popup-menu-backdrop').toggle();
        $('#view-deal .advanced-menu').css('z-index', '20000');
        $('#view-deal .advanced-menu').slideToggle('4000', 'swing');
    };


    self.onPullUp = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).last().visible()) {
            console.log("onPullUp view deal - 1");
            self.listScrollLoadEvent();
        }
    };

    self.openChangeDealStatusPopup = function () {
        self.closeModalPanel();
        gotoPage({url: "changeStatus", param: {parentType: "Deal", parentId: deal.id.text, parentVisibility: deal['visible-to'], status: deal.status}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.navigateGeneral = function () {
        $("#second-navigation-container").show();
        $taskList.hide();
        $addNewLink.hide();
        $dealsMoreLink.show();
        $refreshLink.hide();
        $refreshElement.hide();
        $addElement.hide();
        $generalContent.show();
        self.activateTab("General");

        $notesContent.hide();
        $tasksContent.hide();
        self.currentTab = 'general';
        self.drawGeneral();
        self.setConnectionMode();
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');

        $attachContent.hide();
    };

    self.navigateTasks = function () {
        $("#view-deal .filter-container").show();
        navigationFix = true;
        $("#second-navigation-container").hide();
        $('#' + $.mobile.activePage.attr('id') + ' #refresh-link').show();
        $taskList.show();
        $addNewLink.show();
        $dealsMoreLink.hide();
        $refreshElement.show();
        $addElement.show();

        $generalContent.hide();
        $notesContent.hide();
        $tasksContent.show();
        $attachContent.hide();
        self.activateTab("Task");
        self.currentTab = 'tasks';
        self.setConnectionMode();

        //navigation-button
        if (self.currentTaskType == "Upcoming") {
            $filterDealTaskType.val('filter-deal-upcoming-tasks').selectmenu('refresh');
        } else if (self.currentTaskType == "Completed") {
            $filterDealTaskType.val('filter-deal-completed-tasks').selectmenu('refresh');
        } else if (self.currentTaskType == "MyUpcoming") {
            $filterDealTaskType.val('filter-deal-my-upcoming-tasks').selectmenu('refresh');
        }
        self.filterTaskTypeEvent();
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
    };

    self.navigateNotes = function () {
        navigationFix = true;
        $taskList.hide();
        $addNewLink.show();
        $dealsMoreLink.hide();
        $refreshElement.show();
        $addElement.show();
        $generalContent.hide();
        $notesContent.show();
        $tasksContent.hide();
        $attachContent.hide();

        self.activateTab("Note");

        self.currentTab = 'notes';
        self.setConnectionMode();
        //navigation-button
        self.drawNotes();
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
    };

    self.drawGeneral = function () {
        if (deal.status.toLowerCase() == 'pending') {
            $rbDealPending.attr("checked", true).checkboxradio("refresh");
            $rbDealWon.attr("checked", false).checkboxradio("refresh");
            $rbDealWon.removeClass("ui-btn-active-won");
            $rbDealLost.attr("checked", false).checkboxradio("refresh");
            $rbDealLost.removeClass("ui-btn-active-lost");
            $dealsRadioFirst.addClass("deals-radio-current");
            $dealsRadioSecond.removeClass("deals-radio-current");
            $dealsRadioThird.removeClass("deals-radio-current");

        } else if (deal.status.toLowerCase() == 'won') {
            $rbDealPending.attr("checked", false);
            $rbDealPending.checkboxradio("refresh");
            $rbDealWon.attr("checked", true);
            $rbDealWon.checkboxradio("refresh");
            $rbDealLost.attr("checked", false);
            $rbDealLost.checkboxradio("refresh");
            $dealsRadioFirst.removeClass("deals-radio-current");
            $dealsRadioSecond.addClass("deals-radio-current");
            $dealsRadioThird.removeClass("deals-radio-current");

        } else if (deal.status.toLowerCase() == 'lost') {
            $rbDealPending.attr("checked", false);
            $rbDealPending.checkboxradio("refresh");
            $rbDealWon.attr("checked", false);
            $rbDealWon.checkboxradio("refresh");
            $rbDealLost.attr("checked", true);
            $rbDealLost.checkboxradio("refresh");

            $dealsRadioFirst.removeClass("deals-radio-current");
            $dealsRadioSecond.removeClass("deals-radio-current");
            $dealsRadioThird.addClass("deals-radio-current");
        }

        if (deal.background.nil) {
            $dealsDescription.hide();
            $(".heading", '#deals-description').hide();
            $viewDealDescription.hide();
        } else {
            $dealsDescription.show();
            $viewDealDescription.show();
            $(".heading", '#deals-description').show();
            $viewDealDescription.html(deal.background);
        }

        if (deal.category != null && deal.category.name != null) {
            $dealCategoryDescription.text(deal.category.name);
            $("#view-deal-category-container").show();
        } else {
            $("#view-deal-category-container").hide();
        }

        if (deal.status) {
            $("#current-deal-status").text(deal.status);
        } else {
            $("#view-deal-status-container").remove();
        }

        if (deal != null && deal.probability) {
            $('#view-deal-probability-text').text(deal.probability + "%");
            $('.deal-view-progress').attr('value', deal.probability);
        } else {
            $("#view-deal-probability-container").remove();
        }

        if (deal.party != null && deal.party.name) {
            if (deal.party.type.toLowerCase() == "person") {
                self.drawPeopleList();
            } else {
                self.drawCompanyList();
            }
        } else {
            $('#deal-party-list-container').hide();
            $('#involved').empty();
        }
    };

    self.refreshButtonEvent = function () {
        if (self.currentTab == 'tasks') {
            showLoadingIndikator();
            self.filterTaskTypeEvent();
        }
        if (self.currentTab == "notes") {
            self.navigateNotes();
        }
    };


    self.drawNotes = function () {
        if (connection) {
            ViewNoteFunctions.drawListParams['view-deal-notes-list'] = {
                'start': 0,
                'offset': offset
            };
            ClientAPI.findPaged({immediateParent: new ObjectId(deal.id.text), objectType: "Note"}, [['modificationDate', -1]], 1, offset, function (err, items) {
                if (!err) {
                    var notes = [];
                    for (var i = 0, max = items.length; i < max; i++) {
                        notes.push(items[i]);
                    }
                    $("#second-navigation-container").hide();
                    $('#' + $.mobile.activePage.attr('id') + ' #refresh-link').show();

                    if (notes.length > 0) {
                        ViewNoteFunctions.drawNote('view-deal-notes-list', notes, false);
                    } else {
                        $noteList.empty();
                        $noteList.append(emptyListHtml);
                        $lastNoteHeadingContainer.hide();
                    }
                    hideLoadingIndikator();
                }
            });
        } else {
            $notesLink.text('(0)');
            $noteList.empty();
            $noteList.append(emptyListHtml);
            $lastNoteHeadingContainer.hide();
            hideLoadingIndikator();
        }

        self.setConnectionMode();
    };

    self.drawHeading = function () {
        switch (self.currentTaskType) {
            case "Upcoming":
                self.getTaskCount('filter-deal-upcoming-tasks');
                break;
            case "Completed":
                self.getTaskCount('filter-deal-completed-tasks');
                break;
            case "MyUpcoming":
                self.getTaskCount('filter-deal-my-upcoming-tasks');
                break;
        }

        $viewDealHeading.html(deal.name);
        var textPrice;
        if (deal.price != null && deal.price.text != null) {
            textPrice = self.priceFormatter(deal.price.text) + ' ' + deal.currency;
            $("#view-deal-desc1-container").show();
        } else {
            textPrice = Messages.General.noPrice;
            $("#view-deal-desc1-container").hide();
        }

        $viewDealDesc1.html(textPrice);
        $("#view-deal-author").html(ALL_USERS[deal['author-id'].text].name);
        $("#view-deal-owner").html(ALL_USERS[deal['owner-id'].text].name);
//		$userDealPermissionList.empty();
        if (deal.closeDate) {
            $("#view-deal-close-date").html(dateFormat(new Date(deal.closeDate)));
            var dateDifference = Math.ceil((new Date(deal.closeDate) - new Date()) / (1000 * 60 * 60 * 24));
            if (dateDifference < 0) {
                $("#view-deal-close-date").css("color", "red");
            } else {
                $("#view-deal-close-date").css("color", "#75CE83");
            }
            if (dateDifference > 0 && dateDifference <= 3) {
                $("#view-deal-close-date").css("color", "#77C2E5");
            }
            $("#view-deal-close-date-container").show();
        } else {
            $("#view-deal-close-date-container").hide();
        }
        $("#deal-view-private").empty();

        var htmlUser = PermissionController.drawPermissionForObject(deal);
        if (htmlUser != "") {
            $("#deal-view-private").append(htmlUser);
            $viewDealPrivate.show();
        } else {
            $viewDealPrivate.hide();
        }

        hideLoadingIndikator();

        if (deal.link) {
            $("#view-deal .empty-link-msg").hide();
            var dealLinkHtml = "";
            if (deal.link instanceof Array) {
                for (var i = 0; i < deal.link.length; i++) {
                    dealLinkHtml += "<li>";
                    switch (deal.link[i].urlType) {
                        case "link":
                            dealLinkHtml += "<div class='link-icon'><i class='md md-link'></i></div>";
                            break;
                        case "video":
                            dealLinkHtml += "<div class='link-icon'><i class='md md-videocam'></i></div>";
                            break;
                    }
                    dealLinkHtml += "<div class='truncate deal-link-el' linkUrl='" + deal.link[i].url + "' >" + deal.link[i].urlDesc + "</div>"
                            + "</li>";
                }
            } else {
                dealLinkHtml += "<li>";
                switch (deal.link.urlType) {
                    case "link":
                        dealLinkHtml += "<div class='link-icon'><i class='md md-link'></i></div>";
                        break;
                    case "video":
                        dealLinkHtml += "<div class='link-icon'><i class='md md-videocam'></i></div>";
                        break;
                }
                dealLinkHtml += "<div class='truncate deal-link-el' linkUrl='" + +"' >" + deal.link.urlDesc + "</div>"
                        + "</li>";
            }
            if (dealLinkHtml != "") {
                $("#view-deal #deal-link-list").html(dealLinkHtml);
            } else {
                $("#view-deal #deal-link-list").empty();
                $("#view-deal .empty-link-msg").css('display', 'block');
                $("#view-deal .empty-link-msg").css('padding', '10px');
                $("#view-deal .empty-link-msg").show();
            }
        }
        if (deal['created-at'] != null && deal['created-at'].text != null && deal['created-at'].text != "" && deal.status != "Won" && deal.status != "Lost" && deal.status != "Inactive") {
            var currentDate = new Date();
            var creationDate = new Date(deal['created-at'].text);
            var daysOpened = currentDate - creationDate;
            daysOpened = Math.ceil(daysOpened / (1000 * 3600 * 24));
            $("#view-deal #deal-days-opened").text(daysOpened);
            $("#view-deal #deal-days-opened-container").show();
        } else {
            $("#view-deal #deal-days-opened-container").hide();
        }
    };

    self.priceFormatter = function (x) {
        return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    };

    self.backButtonEvent = function () {
        goBack();
    };

    self.openPrivate = function () {
        $permissionDealUsersPopup.popup("open");
        $permissionDealUsersPopup.popup("reposition", {y: 200});
    };

    self.addNewEvent = function () {
        if (self.currentTab == 'tasks') {
            self.closeModalPanel();
            gotoPage({url: "editTask", param: {parentId: deal.id.text, parentType: 'deal', accessList: deal["visible-to"]}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
        } else if (self.currentTab == 'notes') {
            openFrom = 'viewDeal';
            self.closeModalPanel();
            gotoPage({url: "editNote", param: {parentId: deal.id.text, parentType: "deal", accessList: deal["visible-to"]}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
        } else if (self.currentTab == "Attachment") {
            $('#view-deal .popup-menu-backdrop').toggle();
            $('#view-deal .attach-advanced-menu').css('z-index', '20000');
            $('#view-deal .attach-advanced-menu').slideToggle('4000', 'swing');
        }
    };

    self.editDealEvent = function () {
        self.closeModalPanel();
        gotoPage({url: "editDeal", param: {id: deal.id.text}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.eventNoteView = function (evt) {
        var index = $(evt.currentTarget).attr('note-id');
        self.closeModalPanel();
        gotoPage({url: "viewNote", param: {noteId: index}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.filterTaskTypeEvent = function () {
        var type = $filterDealTaskType.find('option:selected').val();
        switch (type) {
            case 'filter-deal-upcoming-tasks':
                self.currentTaskType = 'Upcoming';
                TaskController.getTasksBySubjectIdAndType(deal.id.text, "Deal", 0, offset, 'Upcoming', false, function (tasks) {
                    self.getTaskCount('filter-deal-upcoming-tasks');
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "Upcoming",
                        'offset': offset,
                        'parentId': deal.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, tasks, "Upcoming", false);
                    self.setConnectionMode();
                });
                break;
            case 'filter-deal-completed-tasks':
                self.currentTaskType = 'Completed';
                TaskController.getTasksBySubjectIdAndType(deal.id.text, "Deal", 0, offset, 'Completed', false, function (tasks) {
                    self.getTaskCount('filter-deal-completed-tasks');
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "Completed",
                        'offset': offset,
                        'parentId': deal.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, tasks, "Completed", false);
                    self.setConnectionMode();
                });
                break;
            case 'filter-deal-my-upcoming-tasks':
                self.currentTaskType = 'MyUpcoming';
                self.getTaskCount('filter-deal-my-upcoming-tasks');
                deal.objectType = "Deal";
                TaskController.findMyUpcomingTaskForParentObject(deal, function(items){
                  TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "MyUpcoming",
                        'offset': offset,
                        'parentId': deal.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, items, false);
                    self.setConnectionMode();
                });
                break;
            case "filter-deal-recent-tasks":
                deal.objectType = "Deal";
                TaskController.findRecentlyAdded(deal, function(items) {
                    self.getTaskCount('filter-deal-recent-tasks', items.length);
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': "Upcoming",
                        'offset': offset,
                        'parentId': deal.id.text
                    };
                    TaskFunctions.drawTaskListView(listViewId, items, "Upcoming", false);
                    self.setConnectionMode();
                });
                break;
        }
    };

    self.getTaskCount = function (filterValue, count) {
        switch (filterValue) {
            case 'filter-deal-upcoming-tasks':
                if (connection) {
                    ClientAPI.findCount({
                        objectType: "Task",
                        status: {$nin: ["Completed", "Canceled", "Verified"]},
                        immediateParent: new ObjectId(deal.id.text)
                    },
                            function (err, data) {
                                $tasksLink.text('(' + data + ')');
                                self.setConnectionMode();
                            });
                } else {
                    db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-id" =? AND "subject-name" = ? AND "subject-type" = ? AND status != ? AND status != ? AND status != ?',
                            [getTextTypeObject(deal.id.text, 'integer'), deal.name, "Deal", "Completed", "Canceled", "Verified"], models.taskDBModel.name, function (data) {
                        $tasksLink.text('(' + data[0]['count(*)'] + ')');
                        $notesLink.text('(0)');
                        self.setConnectionMode();
                    });
                }
                break;
            case 'filter-deal-completed-tasks':
                if (connection) {
                    ClientAPI.findCount({
                        objectType: "Task",
                        status: {$in: ["Completed", "Canceled", "Verified"]},
                        immediateParent: new ObjectId(deal.id.text)
                    },
                            function (err, data) {
                                $tasksLink.text('(' + data + ')');
                                self.setConnectionMode();
                            });
                } else {
                    db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-id" =? AND "subject-name" = ? AND "subject-type" = ? AND (status = ? OR status = ? OR status = ?)',
                            [getTextTypeObject(deal.id.text, 'integer'), deal.name, "Deal", "Completed", "Canceled", "Verified"], models.taskDBModel.name, function (data) {
                        $tasksLink.text('(' + data[0]['count(*)'] + ')');
                        $notesLink.text('(0)');
                        self.setConnectionMode();
                    });
                }
                break;
            case 'filter-deal-my-upcoming-tasks':
                if (connection) {
                    var request = {objectType: "Task", immediateParent: new ObjectId(deal.id.text)};
                    var myTasksFilter = [{assignedTo: window.localStorage.getItem('userId')}, {
                            assignedTo: {$exists: false},
                            owner: window.localStorage.getItem('userId')
                        }, {assignedTo: {$type: 10}, owner: window.localStorage.getItem('userId')}];
                    var completedTasks = ["Completed", "Canceled", "Verified"];
                    request.$or = myTasksFilter;
                    request.status = {$nin: completedTasks};
                    ClientAPI.findCount(request,
                            function (err, data) {
                                $tasksLink.text('(' + data + ')');
                                self.setConnectionMode();
                            });
                } else {
                    db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-id" =? AND "subject-name" = ? AND "subject-type" = ? AND status != ? AND status != ? AND status = ? AND "responsible-id" = ?',
                            [getTextTypeObject(deal.id.text, 'integer'), deal.name, "Deal", "Completed", "Canceled", "Verified", getTextTypeObject(window.localStorage.getItem('userId'), 'integer')], models.taskDBModel.name, function (data) {
                        $tasksLink.text('(' + data[0]['count(*)'] + ')');
                        $notesLink.text('(0)');
                        self.setConnectionMode();
                    });
                }
                break;
            case 'filter-deal-recent-tasks':
                $tasksLink.text('(' + count + ')');
                break;

        }
    };

    self.listScrollLoadEvent = function () {
//		if (($(this).scrollTop() + $(window).height()) >= ($(this).height() - 200)) {
        if (self.currentTab == "tasks") {
            var requestObject = {objectType: "Task", immediateParent: new ObjectId(deal.id.text)};
            TaskFunctions.drawListParams[listViewId]['taskType'] = self.currentTaskType;
            if (TaskFunctions.drawListParams[listViewId]['taskType'] != "Completed") {
                requestObject['status'] = {$nin: ["Completed", "Canceled", "Verified"]};
            } else {
                requestObject['status'] = {$in: ["Completed", "Canceled", "Verified"]};
            }

            if (self.currentTaskType == "MyUpcoming") {
                var myTasksFilter = [{assignedTo: window.localStorage.getItem('userId')}, {
                        assignedTo: {$exists: false},
                        owner: window.localStorage.getItem('userId')
                    }, {assignedTo: {$type: 10}, owner: window.localStorage.getItem('userId')}];
                requestObject.$or = myTasksFilter;
            }

            var dueDateSort = 1;
            if ("Completed" == TaskFunctions.drawListParams[listViewId]['taskType']) {
                dueDateSort = -1;
            }
            var sort = [["dueDate", dueDateSort], ["status", -1]];
            self.listScrollTaskLoad(listViewId, requestObject, sort);
        } else if (self.currentTab == "notes") {
            var requestObject = {objectType: "Note", immediateParent: new ObjectId(deal.id.text)};
            var sort = [["modificationDate", -1]];
            self.listScrollNoteLoad('view-deal-notes-list', requestObject, sort);
        }
//		}
    };

    self.listScrollNoteLoad = function (listViewId, query, sort) {
        showLoadingIndikator();
        $(document).off('scrollstop');
        if (connection) {

            ClientAPI.findPaged(query, sort,
                    ViewNoteFunctions.drawListParams[listViewId]['start'] / ViewNoteFunctions.drawListParams[listViewId]['offset'] + 1,
                    ViewNoteFunctions.drawListParams[listViewId]['offset'],
                    function (err, items) {
                        var notes = [];
                        for (var i = 0, max = items.length; i < max; i++) {
                            notes.push(items[i]);
                        }
                        ViewNoteFunctions.drawNote(listViewId, notes, true);
                    });
        }
    };

    self.completeTaskEvent = function () {
        var taskId = $(this).attr("taskId");
        self.closeModalPanel();
        gotoPage({url: "changeStatus", param: {parentId: taskId, parentType: "Task"}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.listScrollTaskLoad = function (listViewId, query, sort) {
        $(document).off('scrollstop');

        showLoadingIndikator();
        if (connection) {
            ClientAPI.findPaged(query, sort,
                    TaskFunctions.drawListParams[listViewId]['start'] / TaskFunctions.drawListParams[listViewId]['offset'] + 1,
                    TaskFunctions.drawListParams[listViewId]['offset'],
                    function (err, items) {
                        var tasks = [];
                        for (var i = 0, max = items.length; i < max; i++) {
                            tasks.push(TaskController.encodeItem(items[i]));
                        }
                        TaskFunctions.drawTaskListView(listViewId, tasks, TaskFunctions.drawListParams[listViewId]['taskType'], true);
                        self.setConnectionMode();
                    });
        } else {
            if (TaskFunctions.drawListParams[listViewId]['taskType'] != "Completed") {
                if (self.currentTaskType == "MyUpcoming") {
                    var sqlQuery = "SELECT * FROM task WHERE [recording-id] = ? AND status != ? AND status != ? AND status != ? AND [responsible-id] = ? LIMIT ?, ?";
                    var queryData = [getTextTypeObject(query['immediateParent'].val, "integer"), "Completed", "Canceled", "Verified", getTextTypeObject(window.localStorage.getItem('userId'), 'integer'),
                        TaskFunctions.drawListParams[listViewId]['start'], TaskFunctions.drawListParams[listViewId]['offset']];
                    db.selectByQuery(sqlQuery, queryData, 'task', function (items) {
                        TaskFunctions.drawTaskListView(listViewId, items, "Upcoming", true);
                        self.setConnectionMode();
                    });

                } else {
                    var querySQL = 'SELECT * FROM task WHERE "recording-id" =? AND status != ? AND status != ? AND status != ? ORDER BY [due-at] LIMIT ?, ?';
                    var queryDate = [];
                    queryDate.push(getTextTypeObject(query['immediateParent'].val, "integer"));
                    queryDate.push("Completed");
                    queryDate.push("Canceled");
                    queryDate.push("Verified");
                    queryDate.push(TaskFunctions.drawListParams[listViewId]['start']);
                    queryDate.push(TaskFunctions.drawListParams[listViewId]['offset']);

                    db.selectByQuery(querySQL, queryDate, 'task', function (items) {
                        TaskFunctions.drawTaskListView(listViewId, items, TaskFunctions.drawListParams[listViewId]['taskType'], true);
                        self.setConnectionMode();
                    });
                }
            } else {
                hideLoadingIndikator();
                self.setConnectionMode();
            }
        }
    };

    self.drawCompanyList = function () {
        $dealPartyList.empty();
        var name = deal.party.name;
        var html = "";
        if (name != null && name != "") {
            html = '<span style="padding:0px;" contactId="' + deal.party.id + '" type="company">' + name + '</span>';
            $dealPartyList.html(html);
            $("#involved").html("Company");
            $('#deal-party-list-container').show();
        } else {
            $('#involved').empty();
        }
    };

    self.drawPeopleList = function () {
        $dealPartyList.empty();
        if (deal.party != null) {
            $dealPartyList.html(deal.party.name);
            $("#involved").html("Person");
            $('#deal-party-list-container').show();
        } else {
            $('#involved').remove();
        }
    };



    self.dealPartyListEvent = function () {
        self.closeModalPanel();
        gotoPage({url: "viewContact", param: {contactId: deal.party.id, contactType: deal.party.type.toLowerCase()}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.openAuthorEvent = function () {
        self.closeModalPanel();
        var authorId = ALL_USERS[deal['author-id'].text].person;
        gotoPage({url: "viewContact", param: {contactId: authorId, contactType: "person"}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.taskItemEvent = function (evt) {
//        if (!tapholdActive) {
        var id = null;
        var ids = [];

        id = $(this).attr('taskId');
        $(document).find("#view-deal .task-item").each(function () {
            ids.push($(this).attr('taskId'));
        });
        self.closeModalPanel();
        gotoPage({url: "viewTask", param: {id: id, ids: ids, listParams: TaskFunctions.drawListParams[listViewId]}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
//        }
    };

    self.deleteDeal = function () {
        DealController.delete(deal.id.text, function (data) {
            if (data == 0) {
                deal = null;
                goBack();
            } else {
                alert(Messages.Deal.deleteMessageErr);
            }
        });
    };

//	self.deleteTaskItem = function() {
//		tapholdActive = true;
//		setTimeout(function(){
//			tapholdActive = false;
//		}, 1000);
//		var taskId = $(this).attr('taskId');
//	 	if (connection) {
//	 		showActionDialog(Messages.Task.deleteTaskMessage, "Yes", function() {
//	 			showLoadingIndikator();
//	 			TaskController.findById(taskId, function(data) {
//					data = TaskController.encodeItem(data);
//					var requestObject = {
//						"taskid" : data.id.text,
//						"body" : data.body
//					};
//					TaskController.deleteTask(data.id.text, function(data){
//						if (data == 0) {
//						   	db.selectSingleRecord(models.infoMessageDBModel.name, "body", requestObject, function(data) {
//						   		if (data != null) {
//							   		var messageId = data.infoMessage._id;
//									db.deleteObject(models.infoMessageDBModel.name, "_id", messageId);
//									SipMessageSettingFunctions.setMessageStatus([{'messageid': messageId, 'status' : 5 }]);
//						   		}
//								self.navigateTasks();
//								hideLoadingIndikator();
//						   	});
//
//						} else {
//							hideLoadingIndikator();
//							alert(Messages.Task.deleteTaskMessageErr);
//						}
//					});
//	 			});
//	 		}, "No", function() {
//	 		});
//	 	}
//	};

    self.setConnectionMode = function () {
        if (!connection) {
            $('#view-deal #refresh-link').hide();
            $('.upcomingTask', '#view-deal-tasks-list').hide();
            $('.assignedTask', '#view-deal-tasks-list').hide();
        } else {
            $('.upcomingTask', '#view-deal-tasks-list').show();
            $('.assignedTask', '#view-deal-tasks-list').show();
        }
    };

    self.getCommentList = function () {
        var noteId = $(this).attr("noteId");
        ViewNoteFunctions.drawCommentList(noteId, function () {
            $("#" + noteId).toggle();
        });
    };

     self.setAsFavorite = function() {
        var isFavorite = $('.md-star').hasClass('contact-favorite-star');
        DealController.findByObjectId(dealId, function(item){
            if (isFavorite) {
                 FavoriteController.findByObjectIdDB(dealId , function(data){
                    if (data[0]) {
                        FavoriteController.removeFavorite(data[0].id, function(){
                            $('.md-star').toggleClass("contact-favorite-star");
                        });
                    }
                 });
            } else {
                FavoriteController.save("Deal", item, function(){
                    $('.md-star').toggleClass("contact-favorite-star");
                });
            }
        });
    }

    self.loadItemHistory = function (feedItems) {
        var html = "";
        $("#view-deal .history-list").empty();
        for (var i = 0; i < feedItems.length; i++) {
            var eventType = "";
            if (feedItems[i].eventType.toLowerCase() != "statustransition") {
                eventType = feedItems[i].eventType.toLowerCase();
            } else {
                eventType = " changed status of";
            }
            html += "<li>"
                    + "<div style='margin-bottom: 5px;'><b>" + feedItems[i].user_name + "</b> "
                    + eventType + " deal"
                    + "</div>";

            if (feedItems[i].allChanges && feedItems[i].eventType != "Create") {
                for (var key in feedItems[i].allChanges) {
                    var descText = "";
                    var entered = false;
                    switch (key) {
                        case "dealInfo":
                            descText = "Description";
                            entered = true;
                            break;
                        case "duration":
                            descText = "Duration";
                            entered = true;
                            break;
                        case "assignedTo":
                            descText = "Assignee";
                            entered = true;
                            break;
                        case "status":
                            descText = "Status";
                            entered = true;
                            break;
                        case "urlList":
                            descText = "Links";
                            entered = true;
                            break;
                        case "immediateParentDisplay":
                            if (feedItems[i].allChanges[key].newValue) {
                                descText = "Related to";
                                entered = true;
                            }
                            break;
                    }
                    if (entered) {
                        if (key == "assignedTo" && feedItems[i].allChanges[key].newValue != "null" && ALL_USERS[feedItems[i].allChanges[key].newValue]) {
                            html += "<div style='margin-bottom: 5px;'>"
                                    + descText + " changed to <span style='color: #2A66D9;'>" + ALL_USERS[feedItems[i].allChanges[key].newValue].name + "</span>"
                                    + "</div>";
                        } else if (key == "urlList") {
                            html += "<div style='margin-bottom: 5px;'>"
                                    + descText + " changed to ";
                            for (var j = 0; j < feedItems[i].allChanges[key].newValue.length; j++) {
                                html += " <span style='color: #2A66D9;'>" + feedItems[i].allChanges[key].newValue[j].url + "</span> ";
                            }
                        } else {
                            html += "<div style='margin-bottom: 5px;'>"
                                    + descText + " changed to <span style='color: #2A66D9; word-break: break-all;'>" + htmlStrip(feedItems[i].allChanges[key].newValue) + "</span>"
                                    + "</div>";
                        }
                    }
                }
                if (feedItems[i].trackedChanges && feedItems[i].trackedChanges.assignedTo) {
                    if (feedItems[i].trackedChanges.assignedTo.oldValue) {
                        html += "<div style='margin-bottom: 5px;'> Old assignee: " + "<b>" + feedItems[i].trackedChanges.assignedTo.oldValue + "</b></div>";
                    }
                    if (feedItems[i].trackedChanges.assignedTo.newValue) {
                        html += "<div style='margin-bottom: 5px;'> New assignee: " + "<b>" + feedItems[i].trackedChanges.assignedTo.newValue + "</b></div>";
                    }

                }
            }
            html += "<div>" + dateFormat(new Date(feedItems[i].eventDate)) + ", " + timeFormat(new Date(feedItems[i].eventDate)) + "h</div>"
                    + "</li>";

        }
        if (html != "") {
            $("#view-deal .history-list").append(html);
        }
    };

    self.getAttachmentCount = function (callback) {
        if (connection) {
            ClientAPI.aggregate([{$match:
                            {$or:
                                        [
                                            {_id: new ObjectId(deal.id.text)},
                                            {immediateParent: new ObjectId(deal.id.text)}
                                        ]
                            }
                },
                {$project:
                            {
                                "fileAttachments": 1,
                                "objectType": 1,
                                "taskName": 1,
                                "note": 1,
                                "projectName": 1
                            }
                }], function (err, data) {
                if (data && data.length > 0) {
                    var attachedElem = data.filter(function (value) {
                        return value.objectType == "Deal" || value.objectType == "Note";
                    });
                    var noteList = data.filter(function (value) {
                        return value.objectType == "Note";
                    });

                    $notesLink.text('(' + noteList.length + ')');

                    var attachments = [];
                    var attachCounter = 0;
                    for (var i = 0; i < attachedElem.length; i++) {
                        if (attachedElem[i].fileAttachments && attachedElem[i].fileAttachments.length > 0) {
                            var attachObject = {};
                            attachObject.id = attachedElem[i]["_id"];
                            attachObject.files = attachedElem[i].fileAttachments;
                            attachCounter += attachedElem[i].fileAttachments.length;
                            attachments.push(attachObject);
                        }
                    }
                }
                if (callback && typeof callback == "function") {
                    callback(attachCounter, attachments);
                }

            });
        } else {
            $notesLink.text('(0)');
        }
    };

    self.loadAttachment = function () {
        $generalContent.hide();
        $notesContent.hide();
        $dealsMoreLink.hide();
        $tasksContent.hide();
        $addNewLink.show();
        $attachContent.show();
        self.currentTab = "Attachment";
        self.activateTab("Attachment");
        //self.drawAttachments(attachments);
        AttachmentController.drawList("#view-deal-attach-list", attachments);
    };

    self.deleteAttachment = function () {
        var fileName = $(this).attr('attachmentName');
        var parentId = $(this).attr('parentId');
        AttachmentController.deleteAttachment(parentId, fileName, ViewDealFunctions);
    };

    self.takePhoto = function () {
        AttachmentController.takePhoto("#view-deal", deal.id.text, "#view-deal-attach-list", "#view-deal-attach-link-text" ,ViewDealFunctions);
    };

    self.chooseFromFileSystem = function () {
        $("#view-deal .popup-menu-backdrop").hide();
        self.closeModalPanel();
        gotoPage({url: "fileSystem", param: {parentId: deal.id.text, parentType: "Deal"}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
    };

    self.openAttachment = function () {
        var url = $(this).attr("url");
        var parentId = $(this).attr('parentId');
        var attachmentName = $(this).attr('attachmentName');
        AttachmentController.openAttachment(url, parentId, attachmentName);
    };

    self.closeModalPanel = function () {
        $('#fullScreenModal').remove();
        $('body').css('overflow', 'auto');
        $('html').removeClass('modal-open');
        ViewDealFunctions.unbindElementControls();
    };

    self.navigateToChildTask = function () {
        var id = $(this).attr('taskId');
        var taskIds = [];
        var $parent = $(this).parent().parent();
        $parent.find('.child-task-item').each(function () {
            taskIds.push($(this).attr('taskId'));
        });
        self.closeModalPanel();
        var currentPage = $parent.attr('data-pageCount');
        currentPage = parseInt(currentPage);
        if(currentPage > 1){
            gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), childPage: currentPage + 1, offset: 30}}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
        } else {
            gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), start: 30, offset: 30}}}, {url: "viewDeal", param: {id: deal.id.text, ids: dealIds, listParams: listParams}});
        }
    };

    self.loadChildTaskEvent = function () {
        var taskId = $(this).parent().attr('id');
        var pageCount = $(this).parent().attr('data-pageCount');
        $(this).parent().attr('data-pageCount', ++pageCount);
        var $that = $(this);
        if (connection) {
            TaskFunctions.loadMoreChildTasks(taskId, pageCount, $that);
        }
    };

    return self;
}(ViewDealFunctions || {}));
