$(document).on('pageinit', '#file-system', function () {
    FileSystemFunctions.init();
});

$(document).on('pageshow', '#file-system', function () {
    FileSystemFunctions.bindElementControls();
});

$(document).on('pagehide', '#file-system', function () {
    FileSystemFunctions.unbindElementControls();
});

var FileSystemFunctions = (function (FileSystemFunctions) {
    var self = FileSystemFunctions;
    var parentObject = {};
    var fileName = "";
    var that = "";


    self.init = function () {

        if (pageObject.parentId && pageObject.parentType) {
            parentObject.id = pageObject.parentId;
            parentObject.type = pageObject.parentType;
            if (pageObject.fileExtension) {
                parentObject.enabledExtension = pageObject.fileExtension;
            }
            pageObject = null;
        }

        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, self.getFileSystem, self.error);
    };

    self.bindElementControls = function () {
        $(document).on('click', '#back-link', goBack);
        $(document).on('click', '.dir-class', self.openDir);
        $(document).on('click', '.file-open', self.openOptionPopup);
        $(document).on('click', '.up-dir', self.up);
        $(document).on('click', '#open-file-action', self.openFile);
        $(document).on('click', '#file-system #upload-file-action', self.uploadFileAction);
    };

    self.unbindElementControls = function () {
        parentObject = {};
        $(document).off('click', '#back-link');
        $(document).off('click', '.dir-class');
        $(document).off('click', '.up-dir');
        $(document).off('click', '.file-open');
        $(document).off('click', '#open-file-action');
        $(document).off('click', '#file-system #upload-file-action');
    };

    self.openOptionPopup = function () {
        fileName = $(this).attr('file-name');
        that = $(this);
        $("#file-system-popup").popup("open");
        $("#file-system-popup").popup("reposition", {y: 200});
    };

    self.openFile = function () {
        var resolve = setInterval(function () {
            if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                window.resolveLocalFileSystemURI(window.localStorage.getItem('folderPath') + fileName, function (s) {
                    if (s.isFile) {
                        window.open(s.toNativeURL(), "_blank");
                    }
                }, function (e) {
                    console.log("resolveLocalFileSystemURI error " + JSON.stringify(e));
                });
            } else {
                window.plugins.FileOpener.openFile(that.attr("path"));
            }
            clearInterval(resolve);
        }, 500);
    };

    self.uploadFileAction = function () {
        var firstInt = setInterval(function () {
            var url = encodeURI(ClientAPI.rootURL + "/api/db/uploadimg");
            if (parentObject.type == "Note" || parentObject.type == "Deal" || parentObject.type == "Task" || parentObject.type == "Project") {
                url = encodeURI(ClientAPI.rootURL + "/api/db/attachfile");
            }

            var extensionName = that.attr("file-name").split(".");
            extensionName = extensionName[extensionName.length - 1].toLowerCase();
            if ((extensionName != "png" && extensionName != "jpg" && extensionName != "jpeg") && parentObject.type == "Contact") {
                hideLoadingIndikator();
                alert("This extension cannot be used as avatar! Please choose another one.");
            } else {
                if (parentObject.id) {
                    var path = that.attr("path");
                    var name = that.attr("file-name");

                    if (parentObject.type == "Contact") {
                        showLoadingIndikator();
                        self.entry.getFile(name, {create: false}, function (fileEntry) {
                            fileEntry.file(function (file) {
                                var reader = new FileReader();
                                reader.onloadend = function (evt) {
                                    getAF(function (err, af) {
                                        var params = new Object();
                                        params['_af'] = af;
                                        params['objId'] = parentObject.id;
                                        params['fieldName'] = "picture";

                                        var options = new FileUploadOptions();
                                        options.fileKey = "attachment";
                                        options.fileName = file.name;
                                        options.mimeType = file.type;
                                        options.chunkedMode = false;
                                        options.params = params;

                                        var ft = new FileTransfer();
                                        ft.upload(fileEntry.toInternalURL(), url, win, fail, options, true);

                                        function win(r) {
                                            hideLoadingIndikator();
                                            if (r.responseCode == 200) {
                                                alert("File is successfully uploaded!");
                                                goBack();
                                            } else {
                                                alert("Error uploading file!");
                                            }
                                            console.log("Code = " + r.responseCode);
                                        }

                                        function fail(error) {
                                            hideLoadingIndikator();
                                            alert("Error uploading file!");
                                            console.log("An error has occurred: Code = " + error.code);
                                        }
                                    });
                                };
                                reader.readAsBinaryString(file);

                            }, function () {
                                hideLoadingIndikator();
                                console.log(error.code);
                            });
                        }, function () {
                            hideLoadingIndikator();
                            console.log("ERROR");
                        });
                    } else {
                        $("#file-system-popup").popup("close");
                        setTimeout(function () {
                            showPromptDialog("Add description for attachment!", "Prompt", "Add", function () {
                                showLoadingIndikator();
                                var attachDesc = $("#prompt-text-input-popup-field").val();
                                if (attachDesc != "") {
                                    self.entry.getFile(name, {create: false}, function (fileEntry) {
                                        fileEntry.file(function (file) {
                                            var reader = new FileReader();
                                            reader.onloadend = function (evt) {
                                                getAF(function (err, af) {
                                                    var params = new Object();
                                                    params['_af'] = af;
                                                    params['objId'] = parentObject.id;
                                                    params['description'] = attachDesc;
                                                    params['typeInfo'] = file.name.split(".")[1].toLowerCase();

                                                    var options = new FileUploadOptions();
                                                    options.fileKey = "attachment";
                                                    options.fileName = file.name;
                                                    options.mimeType = file.type;
                                                    options.chunkedMode = false;
                                                    options.params = params;

                                                    var ft = new FileTransfer();
                                                    ft.upload(fileEntry.toInternalURL(), url, win, fail, options, true);

                                                    function win(r) {
                                                        hideLoadingIndikator();
                                                        if (r.responseCode == 200) {
                                                            ClientAPI.find({objectType: parentObject.type, _id: new ObjectId(parentObject.id)}, null, function (err, data) {
                                                                if (data != null && data.length > 0) {
                                                                    goBack();
//                                                                    sharedNoteForOpen = data[0];
//                                                                    alert("File is successfully uploaded!");
//                                                                    goBack();
//                                                                    var setDraw = setInterval(function () {
//                                                                        ViewNoteFunctions.drawAttachments();
//                                                                        clearInterval(setDraw);
//                                                                    }, 100);
                                                                }
                                                            });
                                                        } else {
                                                            hideLoadingIndikator();
                                                            alert("Error uploading file!");
                                                        }
                                                        console.log("Code = " + r.responseCode);
                                                    }

                                                    function fail(error) {
                                                        hideLoadingIndikator();
                                                        alert("Error uploading file!");
                                                        console.log("An error has occurred: Code = " + error.code);
                                                    }
                                                });
                                            };
                                            reader.readAsBinaryString(file);

                                        }, function () {
                                            hideLoadingIndikator();
                                            console.log(error.code);
                                        });
                                    }, function () {
                                        hideLoadingIndikator();
                                        console.log("ERROR");
                                    });
                                } else {
                                    hideLoadingIndikator();
                                    alert("Please add description!");
                                }
                            }, "Cancel", function () {
                                hideLoadingIndikator();
                            });
                        }, 500);
                    }
                } else {
                    alert("Error uploading file!");
                }
            }
            clearInterval(firstInt);
        }, 500);
    };

    self.getFileSystem = function (fileSystem) {
        self.entry = fileSystem.root;
        self.drawFiles(self.entry);
    };

    self.error = function (err) {
        alert("ERROR " + JSON.stringify(err));
    };

    self.readFiles = function (fileNames) {
        for (var i = 0; i < fileNames.length; i++) {
            self.showAvatar(fileNames[i]);
        }
    };

    self.showAvatar = function (fileName) {
        setTimeout(function () {
            var customURL = fileName.substr("file://".length);
            customURL = encodeURI(customURL);
            $("li[path='" + fileName + "'] .content-avatar").css('background-image', 'url' + '(' + customURL + ')');
        }, 0);
    };

    self.drawFiles = function (parent) {
        self.entry = parent;
        var directoryReader = parent.createReader();
        directoryReader.readEntries(function (entries) {
            console.log("#1Enter directoryReader");
            var $list = $('#file-system-list');
            $list.empty();
            var html = '<li data-icon="false" class="up-dir"><a href="#" style="height: 50px; position: relative; top:10px; padding-left:10px;"><i class="md-settings-backup-restore md-3x"></i><span class="basic-title" style="padding-left:10px;">Up</span></a></li>';
            var i;

            var attachType;
            var IMAGES = ["png", "jpg", "gif", "jpeg"];
            var DOCUMENTS = ["doc", "pdf", "txt", "xls", "xlsx", "ppt", "docx", "log", "docm"];
            var ZIPS = ["zip", "tar", "rar", "gzip", "7z"];
            var MEDIA = ["mp3", "aac", "mp2", "wma", "m4a", "mp4", "wav"];
            var attachClass;

            for (i = 0; i < entries.length; i++) {
                if (entries[i].isDirectory) {
                    html += '<li data-icon="false" class="dir-class" style="padding:5px 10px;" path="' + entries[i].name + '"><a href="#"><i class="fa fa-folder fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                } else {
                    if (parentObject.enabledExtension) {
                        var fileExt = parentObject.enabledExtension;
                        if (entries[i].name.split(".")[1]) {
                            attachType = entries[i].name.split(".")[1].toLowerCase();
                        }
                        if (fileExt.indexOf(attachType) != -1) {
                            attachClass = "attachment-image";
                            html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px; position:relative;"><div class="content-left-avatar"><div class="content-avatar"></div></div><span class="contain-tumbnail truncate">' + entries[i].name + '</span></a></li>';
                        }
                    } else {

                        if (entries[i].name.split(".")[1]) {
                            attachType = entries[i].name.split(".")[1].toLowerCase();
                        }
                        attachClass = "file-class";

                        if (IMAGES.indexOf(attachType) != -1) {
                            attachClass = "attachment-image";
                        } else if (DOCUMENTS.indexOf(attachType) != -1) {
                            attachClass = "attachment-document";
                        } else if (MEDIA.indexOf(attachType) != -1) {
                            attachClass = "attachment-music";
                        } else if (ZIPS.indexOf(attachType) != -1) {
                            attachClass = "attachment-zip";
                        }

                        if (attachClass == "attachment-image") {
                            html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px; position:relative;"><div class="content-left-avatar"><div class="content-avatar"></div></div><span class="contain-tumbnail truncate">' + entries[i].name + '</span></a></li>';
                        } else if (attachClass == "attachment-document") {
                            switch (attachType) {
                                case "doc":
                                    html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-word-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                                    break;
                                case "docx":
                                    html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-word-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                                    break;
                                case "pdf":
                                    html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-pdf-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                                    break;
                                case "xls":
                                    html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-excel-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                                    break;
                                case "xlsx":
                                    html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-excel-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                                    break;
                                case "ppt":
                                    html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-powerpoint-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                                    break;
                                default :
                                    html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-text-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                            }

                        } else if (attachClass == "attachment-music") {
                            html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-music fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                        } else if (attachClass == "attachment-zip") {
                            html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-archive-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                        } else {
                            html += '<li data-icon="false" style="padding:5px 10px;" class="file-open ' + attachClass + '" file-name="' + entries[i].name + '" path="' + entries[i].toURL() + '"><a href="#" style="height:50px;" class="basic-file-attach"><i class="fa fa-file-o fa-3x"></i><span class="folder-title basic-title truncate">' + entries[i].name + '</span></a></li>';
                        }
                    }
                }
            }
            console.log("Html for draw");
            console.log(html);
            $list.append(html);

            // Append images
            var fileEntries = [];
            var typeOfFile = "";
            var attachExt = "";
            for (i = 0; i < entries.length; i++) {
                if (entries[i].name.split(".")[1]) {
                    typeOfFile = entries[i].name.split(".")[1].toLowerCase();
                }
                if (IMAGES.indexOf(typeOfFile) != -1) {
                    attachExt = "attachment-image";
                } else if (DOCUMENTS.indexOf(typeOfFile) != -1) {
                    attachExt = "attachment-document";
                } else if (MEDIA.indexOf(typeOfFile) != -1) {
                    attachExt = "attachment-music";
                } else if (ZIPS.indexOf(typeOfFile) != -1) {
                    attachExt = "attachment-zip";
                }
                if (attachExt == "attachment-image") {
                    console.log("==Entries object==");
                    console.log(JSON.stringify(entries[i]));
                    fileEntries.push(entries[i].toURL());
                }
            }

            self.readFiles(fileEntries);

        }, self.error);
    };

    self.openDir = function () {
        var path = $(this).attr("path");
        if (self.entry) {
            self.entry.getDirectory(path, {create: false, exclusive: false}, self.drawFiles, self.error);
        }
    };

    self.uploadFile = function () {
        var fileName = $(this).attr('file-name');
        var that = $(this);
        showActionDialog("Do you want to upload or open this file?", "Upload", function () {
            var firstInt = setInterval(function () {
                var url = encodeURI(ClientAPI.rootURL + "/api/db/uploadimg");
                if (parentObject.type == "Note") {
                    url = encodeURI(ClientAPI.rootURL + "/api/db/attachfile");
                }

                var extensionName = that.attr("file-name").split(".")[1].toLowerCase();
                if ((extensionName != "png" && extensionName != "jpg") && parentObject.type == "Contact") {
                    hideLoadingIndikator();
                    alert("This extension cannot be used as avatar! Please choose another one.");
                } else {
                    if (parentObject.id) {
                        var path = that.attr("path");
                        var name = that.attr("file-name");

                        if (parentObject.type == "Contact") {
                            showLoadingIndikator();
                            self.entry.getFile(name, {create: false}, function (fileEntry) {
                                fileEntry.file(function (file) {
                                    var reader = new FileReader();
                                    reader.onloadend = function (evt) {
                                        getAF(function (err, af) {
                                            var params = new Object();
                                            params['_af'] = af;
                                            params['objId'] = parentObject.id;
                                            params['fieldName'] = "picture";

                                            var options = new FileUploadOptions();
                                            options.fileKey = "attachment";
                                            options.fileName = file.name;
                                            options.mimeType = file.type;
                                            options.chunkedMode = false;
                                            options.params = params;

                                            var ft = new FileTransfer();
                                            ft.upload(file.fullPath, url, win, fail, options, true);

                                            function win(r) {
                                                hideLoadingIndikator();
                                                if (r.responseCode == 200) {
                                                    alert("File is successfully uploaded!");
                                                    goBack();
                                                } else {
                                                    alert("Error uploading file!");
                                                }
                                                console.log("Code = " + r.responseCode);
                                                console.log("Response = " + JSON.stringify(r.response));
                                                console.log("Sent = " + r.bytesSent);
                                            }

                                            function fail(error) {
                                                hideLoadingIndikator();
                                                alert("Error uploading file!");
                                                console.log("An error has occurred: Code = " + error.code);
                                                console.log("upload error source " + error.source);
                                                console.log("upload error target " + error.target);
                                            }
                                        });
                                    };
                                    reader.readAsBinaryString(file);

                                }, function () {
                                    console.log(error.code);
                                });
                            }, function () {
                                console.log("ERROR");
                            });
                        } else {
                            showPromptDialog("Add discription for attachment!", "Prompt", "Add", function () {
                                showLoadingIndikator();
                                var attachDesc = $("#prompt-text-input-popup-field").val();
                                if (attachDesc != "") {
                                    self.entry.getFile(name, {create: false}, function (fileEntry) {
                                        fileEntry.file(function (file) {
                                            var reader = new FileReader();
                                            reader.onloadend = function (evt) {
                                                getAF(function (err, af) {
                                                    var params = new Object();
                                                    params['_af'] = af;
                                                    params['objId'] = parentObject.id;
                                                    params['description'] = attachDesc;
                                                    params['typeInfo'] = file.name.split(".")[1].toLowerCase();

                                                    var options = new FileUploadOptions();
                                                    options.fileKey = "attachment";
                                                    options.fileName = file.name;
                                                    options.mimeType = file.type;
                                                    options.chunkedMode = false;
                                                    options.params = params;

                                                    var ft = new FileTransfer();
                                                    ft.upload(file.fullPath, url, win, fail, options, true);

                                                    function win(r) {
                                                        hideLoadingIndikator();
                                                        if (r.responseCode == 200) {
                                                            ClientAPI.find({objectType: parentObject.type, _id: new ObjectId(parentObject.id)}, null, function (err, data) {
                                                                if (data != null && data.length > 0) {
                                                                    sharedNoteForOpen = data[0];
                                                                    alert("File is successfully uploaded!");
                                                                    goBack();
                                                                    var setDraw = setInterval(function () {
                                                                        ViewNoteFunctions.drawAttachments();
                                                                        clearInterval(setDraw);
                                                                    }, 100);
                                                                }
                                                            });
                                                        } else {
                                                            alert("Error uploading file!");
                                                        }
                                                        console.log("Code = " + r.responseCode);
                                                        console.log("Response = " + JSON.stringify(r.response));
                                                        console.log("Sent = " + r.bytesSent);
                                                    }

                                                    function fail(error) {
                                                        hideLoadingIndikator();
                                                        alert("Error uploading file!");
                                                        console.log("An error has occurred: Code = " + error.code);
                                                        console.log("upload error source " + error.source);
                                                        console.log("upload error target " + error.target);
                                                    }
                                                });
                                            };
                                            reader.readAsBinaryString(file);

                                        }, function () {
                                            console.log(error.code);
                                        });
                                    }, function () {
                                        console.log("ERROR");
                                    });
                                } else {
                                    alert("Please add description!");
                                }
                            }, "Cancel", function () {

                            });
                        }
                    } else {
                        alert("Error uploading file!");
                    }
                }
                clearInterval(firstInt);
            }, 500);
        }, "Open", function () {
            var resolve = setInterval(function () {
                if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                    window.resolveLocalFileSystemURI(window.localStorage.getItem('folderPath') + fileName, function (s) {
                        console.log("resolveLocalFileSystemURI success " + JSON.stringify(s));
                        if (s.isFile) {
                            console.log("resolveLocalFileSystemURI open " + JSON.stringify(that.attr("path")));
                            window.open(s.toNativeURL(), "_blank");
                        }
                    }, function (e) {
                        console.log("resolveLocalFileSystemURI error " + JSON.stringify(e));
                    });
                } else {
                    window.plugins.FileOpener.openFile(that.attr("path"));
                }
                ;
                clearInterval(resolve);
            }, 500);
        });
    };

    self.up = function () {
        self.entry.getParent(self.drawFiles, self.error);
    };

    return self;
}(FileSystemFunctions || {}));
