$(document).on('pageinit', '#login', function () {

    $("#more-operations").click(function () {
        $("#advanced-login-options").toggle();
        $(".option-title").text(function (i, v) {
            return v === "Advanced" ? "Simple" : "Advanced";
        });
    });
    

    LoginFunctions.bindElementControls();
});

$(document).on('pageshow', '#login', function () {
    if (!connection) {
        $('#login #content').html('<p class="center"><img src="' + rootPath + '/images/noWifi.png" onerror="imgError(this);"></p>'
                + '<p style="text-align:center; font-size: 16px;">' + Messages.Login.offlineMessage + '</p></div>');
    }
});

$(document).on('pagehide', '#login', function () {
    LoginFunctions.unbindElementControls();
});

var LoginFunctions = (function (LoginFunctions)
{
    var self = LoginFunctions;

    self.unbindElementControls = function () {
        $(document).off('click', '#login-auth-button');
        $('#forgot-psw').off('click');
        $(document).off('click', '.pass-visibility');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#login-auth-button', self.loginAuthButtonEvent);
        $('#forgot-psw').on('click', self.openForgotPswLink);

        if (!(/ios|iphone|ipod|ipad/i.test(navigator.userAgent.toLowerCase()))) {
            $('#forgot-psw').show();
        }
        $(document).on('click', '.pass-visibility', function () {
            if ($('#loginPassword').attr('type') == 'password') {
                $('#loginPassword').attr('type', 'text');
            } else {
                $('#loginPassword').attr('type', 'password');
            }
        });
    };

    self.openForgotPswLink = function () {
        window.open($('#serverAddress').val() + '/user/resetpwd', '_system');
    };

    self.loginAuthButtonEvent = function () {
        userDomain = $.trim($('#domain').val());
        var username = $.trim($('#loginUserName').val());
        var password = $.trim($('#loginPassword').val());
        var serverAddress = $.trim($('#serverAddress').val());
        var login = true;
        var errorMessage = '';

        if (userDomain == null || userDomain == "") {
            $("#login-msg").html("Credentials required!");
            $("#login-error").css("display", "block");
            $("#login-error").css("position", "relative");
            $("#login-error").show();
            login = false;
            return;
        }
        if (username == null || username == "") {
            $("#login-msg").html("Credentials required!");
            $("#login-error").css("display", "block");
            $("#login-error").css("position", "relative");
            $("#login-error").show();
            login = false;
            return;
        }
        if (password == null || password == "") {
            $("#login-msg").html("Credentials required!");
            $("#login-error").css("display", "block");
            $("#login-error").css("position", "relative");
            $("#login-error").show();
            login = false;
            return;
        }

        if (serverAddress == null || serverAddress == "") {
            $("#login-msg").html("Credentials required!");
            $("#login-error").css("display", "block");
            $("#login-error").css("position", "relative");
            $("#login-error").show();
            login = false;
            return;
        }

        if (login) {
            $("#login-error").hide();
            showLoadingIndikator();
            ClientAPI.rootURL = serverAddress;
            window.localStorage.setItem('serverAddress', serverAddress);

            LoginController.login(userDomain, username, password, self.getUserContextServiceEvent);
        }
    };

    self.getUserContextServiceEvent = function (err, data) {
        if (data && data['status'] && data['status'].statusCode == 0 && data['token']) {
            userId = data['status'].user.user_id;
            if (data['status'].user.domainMembership.groups[0] == "Everyone@" + localStorage.getItem('userDomain')) {
                userAdmin = true;
            } else {
                userAdmin = false;
            }
            //save login parameters
            window.localStorage.setItem("userProfile", JSON.stringify(data['status'].user));
            window.localStorage.setItem("userId", userId);
            window.localStorage.setItem("userAdmin", userAdmin);
            //window.localStorage.setItem("userAuth", userAuth);
            window.localStorage.setItem("userDomain", data['status'].user.app_domain_name);
            window.localStorage.setItem("userDataName", data['status'].user.first_name + " " + data['status'].user.last_name);
            window.localStorage.setItem("userDataEmail", data['status'].user.primary_email);

            var newDomain = {
                id: UtilController.randomNumber(),
                domain: $.trim($('#domain').val()),
                username: $.trim($('#loginUserName').val()),
                password: $.trim($('#loginPassword').val()),
                server: $.trim($('#serverAddress').val())
            };
            var addNewDomain = true;
            if (newDomain.domain == null || newDomain.domain == '') {
                addNewDomain = false;
            }

            if (newDomain.username == null || newDomain.username == '') {
                addNewDomain = false;
            }

            if (newDomain.password == null || newDomain.password == '') {
                addNewDomain = false;
            }
            if (addNewDomain) {
                DomainController.save(newDomain);
            }

            //send info data to server
            //sendInfoUser("login");
            //showLoadingIndikator();
            // user synchronization
            UserController.synchronization(function () {
                getAllUsers(null, function () {
                    SyncController.sync(function () {
                    });

                    if (data.status.user.domainMembership.askForProfileUpdate != null && data.status.user.domainMembership.askForProfileUpdate == true) {
                        window.localStorage.setItem('serverAddress', ClientAPI.rootURL);
                        gotoPage({url: "editProfil", param: null}, {url: "dashboard", param: null});
                        hideLoadingIndikator();
                    } else {
                        if (addNewDomain) {
                            gotoPage({url: "dashboard", param: null});
                        } else {
                            window.localStorage.setItem('serverAddress', ClientAPI.rootURL);
                            var i, max, index;
                            var historyData = JSON.parse(window.localStorage.getItem('historyData'));

                            if (!historyData) {
                                historyData = [];
                            }

                            for (i = 0, max = historyData.length; i < max; i++) {
                                if (historyData[i].domain == window.localStorage.getItem('userDomain')) {
                                    index = i;
                                }
                            }

                            if (index != null) {
                                if (historyData[index].enableSave) {
                                    window.localStorage.setItem('enableSave', historyData[index].enableSave);
                                }

                                if (historyData[index].notificationStatus) {
                                    window.localStorage.setItem('notificationStatus', historyData[index].notificationStatus);
                                }

                                if (historyData[index].pictureQuality) {
                                    window.localStorage.setItem('pictureQuality', historyData[index].pictureQuality);
                                }

                                if (historyData[index].port) {
                                    window.localStorage.setItem('port', historyData[index].port);
                                }

                                if (historyData[index].proxy) {
                                    window.localStorage.setItem('proxy', historyData[index].proxy);
                                }

                                if (historyData[index].sipDomain) {
                                    window.localStorage.setItem('sipDomain', historyData[index].sipDomain);
                                }

                                if (historyData[index].sipPassword) {
                                    window.localStorage.setItem('sipPassword', historyData[index].sipPassword);
                                }

                                if (historyData[index].sipUsername) {
                                    window.localStorage.setItem('sipUsername', historyData[index].sipUsername);
                                }

                                if (historyData[index].recent && historyData[index].recent.length > 0) {
                                    db.insertMultiple(models.recentDBModel.name, [historyData[index].recent]);
                                }
                            }

                            hideLoadingIndikator();
                            alert(Messages.Domain.successChangeDomain);
                            gotoPage({url: "dashboard", param: null});
                        }
                    }
                });
            });

            SyncSipController.syncAll();

            setTimeout(function () {
                OfflineController.synchronization(function () {
                });
                var sipUsername = window.localStorage.getItem("sipUsername");
                var sipPassword = window.localStorage.getItem("sipPassword");
                var status = window.localStorage.getItem("sip_status");

                if (sipUsername != null && status == "on") {
                    SipSettingsFunctions.sipLogin(sipUsername, sipPassword, function (data) {
                        if (data != null) {
                            SyncSipController.syncSipAccount(function () {
                                statusSipGlobal();
                                MyGroupFunctions.setConnectionMode();
                            });
                        } else {
                            SipSettingsFunctions.sipLogin(sipUsername, sipPassword, function (data) {
                            });
                        }
                    });
                } else {
                    SyncSipController.syncSipAccount(function () {
                        statusSipGlobal();
                        MyGroupFunctions.setConnectionMode();
                    });
                }
            }, 100);

        } else {
            alert("Invalid domain data!");
            hideLoadingIndikator();
        }
    };

    return self;
}(LoginFunctions || {}));