$(document).on('pageinit', '#edit-comment', function () {
    CommentFunctions.init();
});

$(document).on('pageshow', '#edit-comment', function () {
    CommentFunctions.bindElementControls();
    showLoadingIndikator();
    if (connection) {
    } else {
        $('#' + $.mobile.activePage.attr('id') + ' #comment-delete-link').hide();
        $('#' + $.mobile.activePage.attr('id') + ' #comment-save-link').hide();
        $("#edit-comment .delete-item").hide();
    }
});

$(document).on('pagehide', '#edit-comment', function () {
    CommentFunctions.unbindElementControls();
});

var CommentFunctions = (function (CommentFunctions) {
    var self = CommentFunctions;
    var commentId = null;
    var delevgateId = null;
    var comment = null;
    var noteId = null;

    var $editCommentBody = null;
    var $editCommentTitle = null;

    self.init = function () {
        $editCommentBody = $('#edit-comment-body');
        $editCommentTitle = $('#edit-comment-title');
        commentId = pageObject.commentId;
        pageObject = null;
        if (connection) {
            ClientAPI.find({_id: new ObjectId(commentId), objectType: "Comment"}, null, function (err, data) {
                comment = CommentController.encodeItem(data[0]);
                $editCommentBody.val(comment.body);
                $editCommentTitle.append('Edit this comment');
                hideLoadingIndikator();
            });
        }
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#comment-back-link');
        $(document).off('click', '#comment-delete-link');
        $(document).off('click', '#comment-save-link');
        $(document).off('click', '#edit-comment-more-link');
        $('#edit-comment .popup-menu-backdrop').off('click');
        $(document).off('click', '#edit-comment .additional-options');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#comment-back-link', goBack);
        $(document).on('click', '#comment-delete-link', self.commentDeleteButton);
        $(document).on('click', '#comment-save-link', self.commentSaveButton);
        $(document).on('click', '#edit-comment-more-link', self.openEditCommentPopup);
        $('#edit-comment .popup-menu-backdrop').on('click', function () {
            $('#edit-comment .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#edit-comment .additional-options', self.commentSaveButton);

    };

    self.openEditCommentPopup = function () {
        $('#edit-comment .popup-menu-backdrop').toggle();
        $('#edit-comment .advanced-menu').css('z-index', '20000');
        $('#edit-comment .advanced-menu').slideToggle('4000', 'swing');
    };

    // definiranje save event
    self.commentSaveButton = function () {
        playSound("www/libs/blop.mp3");
        $(document).off('click', '#comment-save-link');
        var body = $.trim($editCommentBody.val());

        if (window.localStorage.getItem("enableSave") == "true") {
            showActionDialog(Messages.Comment.saveComment, 'Yes', function () {
                CommentController.update(commentId, body, function (data) {
                    goBack();
                });
            }, 'No', function () {
            });

        } else {
            CommentController.update(commentId, body, function (data) {
                goBack();
            });
        }

        return false;
    };

    // definiranje delete event
    self.commentDeleteButton = function () {
        $("#edit-comment-popup").hide();
        $('#edit-comment .popup-menu-backdrop').hide();
        setTimeout(function () {
            showActionDialog(Messages.Comment.deleteComment, 'Yes', function () {
                CommentController.delete(commentId, function (data) {
                    if (data != null && data == 0) {
                        goBack();
                    }
                });
            }, 'No', function () {
            });

            return false;
        }, 200);
    };

    return self;
}(CommentFunctions || {}));			