$(document).on('pageshow', '#edit-note', function () {

    //initiate richtext editor
    if (tinymce.editors.length > 0) {
        tinymce.editors = [];
    }
    tinymce.init({
        mode: "exact",
        selector: "#editor",
        autoresize_min_height: 250,
        menubar: false,
        theme_advanced_buttons3_add : "pastetext,pasteword,selectall",
        content_css: "styles/tinymce-custom.css",
        statusbar: false,
        skin: 'light',
        plugins: "autoresize",
        toolbar: [
            "bold italic underline bullist numlist outdent indent"
        ]
    });

    setTimeout(function () {
        tinymce.activeEditor.on('click', function (e) {
            if (tinymce.activeEditor.getContent() == "<p>Enter your note ...</p>") {
                tinymce.activeEditor.setContent("");
            }
            // Show toolbar
            $(".mce-toolbar-grp.mce-stack-layout-item").show();
            $(".mce-tinymce.mce-container.mce-panel").css("margin-top", "30px");
        });
    }, 1000);

    $("#edit-more-options-button").click(function () {
        if ($(this).text() == " See more") {
            $(this).html("<i class='md-keyboard-arrow-up md-1x'></i> Hide");
        } else {
            $(this).html("<i class='md-keyboard-arrow-down md-1x'></i> See more");
        }
        $(".edit-more-options").slideToggle('4000', 'swing');
    });

    NoteEditFunctions.init();
    NoteEditFunctions.bindElementControls();
});

$(document).on('pagehide', '#edit-note', function () {
    NoteEditFunctions.unbindElementControls();
});

var NoteEditFunctions = (function (NoteEditFunctions)
{
    var self = NoteEditFunctions;
    var note = null;
    var parentsId = null;
    var parentType = null;
    var draftNoteId = null;
    var draftNoteObjectId = null;
    var draftNoteObjectUrls = null;
    var draftInterval = null;
    var duplicate = null;
    var saveLocation = false;

    var $appendToParent = null,
            $autoCompleteAppend = null,
            $autoCompleteAppendList = null,
            $noteBody = null,
            $btnSave = null;
    var visibilityObjectId = null;
    var visibilityObjectType = null;

    self.init = function () {
        self.selectElement();
        PermissionController.init('#edit-note');
        AutoCompleteController.init('#edit-note');
        AutoCompleteController.addViewId('autocomplete-append', 'autocomplete-append-list', 'autocomplete-append', function (data) {
            visibilityObjectId = data.id;
            visibilityObjectType = data.objectType;
            showActionDialog("Take visibility of parent object?", "Yes", self.updateACL, "No", function () {
            });
        });
        var noteId = pageObject.noteId;
        draftNoteId = pageObject.draftId;
        draftNoteObjectId = pageObject.draftObjectId;
        duplicate = pageObject.duplicate;
        saveLocation = pageObject.saveLocation;
        if (noteId) {
            if (duplicate)
                $("#note-duplicate-title").show();
            else
                $("#note-edit-title").show();
            NoteController.findById(noteId, function (data) {
                note = data[0];
                self.selectObjectFromDatabase(note.immediateParent, note.immediateParentObjectType, note.immediateParent, note.immediateParentObjectType);
                self.loadNote();
            });
        } else {
            $("#note-add-title").show();
            if (draftNoteId) {
                db.selectByQuery("SELECT * FROM draft WHERE [id] = ?", [draftNoteId], "draft", function (data) {
                    if (data && data[0]) {
                        draftNoteObjectUrls = data[0].object.urlList;
                        self.loadDraft(data[0]);
                        self.selectObjectFromDatabase(data[0].object.parentId, data[0].object.parentType, data[0].object.parentId, data[0].object.parentType);
                    }
                });
            } else {
                setTimeout(function () {
                    tinymce.activeEditor.setContent("Enter your note ...");
                    if (saveLocation) {
                        $("#edit-note .btn-location").find("i").removeClass("md-location-off").addClass("md-location-on");
                        tinymce.activeEditor.setContent("<span id='my-location'>" + userAddress + "</span>");
                    }
                    // adding note from Team page, after sip call
                    if (pageObject) {
                        if (pageObject.sipName && pageObject.sipPhone) {
                            tinymce.activeEditor.setContent(pageObject.sipName + " - " + pageObject.sipPhone);
                        }
                    }
                }, 300);
                parentsId = pageObject.parentId;
                parentType = pageObject.parentType;
                var accessList = pageObject.accessList;
                if (accessList) {
                    note = {accessList: accessList};
                    PermissionController.setData(note['accessList']);
                }
                if (pageObject.parentId && pageObject.parentType) {
                    self.selectObjectFromDatabase(pageObject.parentId, pageObject.parentType, pageObject.parentId, pageObject.parentType);
                }
            }
        }
        pageObject = null;
        draftInterval = setInterval(self.saveToDraft, 60000);
    };

    self.updateACL = function () {
        var aclObjectVisibility = [];
        var request = "";
        switch (visibilityObjectType) {
            case "Company":
                request = {'objectType': "Company", _id: new ObjectId(visibilityObjectId)};
                break;
            case "Person":
                request = {'objectType': "Person", _id: new ObjectId(visibilityObjectId)};
                break;
            case "Deal":
                request = {'objectType': "Deal", _id: new ObjectId(visibilityObjectId)};
                break;
            case "Project":
                request = {'objectType': "Project", _id: new ObjectId(visibilityObjectId)};
                break;
            case "Note":
                request = {'objectType': "Note", _id: new ObjectId(visibilityObjectId)};
                break;
            case "Task":
                request = {'objectType': "Task", _id: new ObjectId(visibilityObjectId)};
                break;
        }
        if (connection) {
            ClientAPI.find(request, null, function (err, data) {
                if (data && data.length > 0) {
                    aclObjectVisibility = data[0]['accessList'];
                    if (aclObjectVisibility.length > 0) {
                        if (!PermissionController.changeACL) {
                            PermissionController.changeACL = true;
                        }
                        PermissionController.setData(aclObjectVisibility);
                    }
                }
            });
        }
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#edit-note #back-link');
        $(document).off('click', '#edit-note #save-link');
        $(document).off('change', '#edit-note #append-data-deal-task');
        $(document).off('click', '#edit-note-more-link');
        $(document).off('click', '#edit-note .mce-toolbar-grp.mce-stack-layout-item');
        $(document).off('click', '#edit-note');
        $('#edit-note .popup-menu-backdrop').off('click');
        $(document).off('click', '#edit-note .additional-options');
        $(document).off('click', '#edit-note .btn-templates');
        $(document).off('click', '#edit-note .template-list li');
        $(document).off('click', '#edit-note .btn-location');
        $(document).off('click', '#edit-note .share-check');
        note = null;
        draftNoteId = null;
        draftNoteObjectId = null;
        draftNoteObjectUrls = null;
        console.log("#1 Clear Draft Interval");
        clearInterval(draftInterval);
    };

    self.bindElementControls = function () {
        $(document).on('click', '#edit-note #back-link', self.goBackAction);
        $(document).on('click', '#edit-note #save-link', self.saveLinkEvent);
        $(document).on('change', '#edit-note #append-data-note', self.appendDataNoteEventChange);
        $(document).on('click', '#edit-note-more-link', self.openEditNotePopup);
        $(document).on('click', '#edit-note .mce-toolbar-grp.mce-stack-layout-item', function (event) {
            event.stopPropagation();
        });
        $(document).on('click', '#edit-note', function () {
            $(".mce-toolbar-grp.mce-stack-layout-item").hide();
            $(".mce-tinymce.mce-container.mce-panel").css("margin-top", "0px");
        });
        $('#edit-note .popup-menu-backdrop').on('click', function () {
            $('#edit-note .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#edit-note .additional-options', self.saveLinkEvent);
        $(document).on('click', '#edit-note .btn-templates', self.showTemplates);
        $(document).on('click', '#edit-note .template-list li', self.setNoteTemplate);
        $(document).on('click', '#edit-note .btn-location', function () {
            var that = $(this);
            if ($(this).find('i').hasClass('md-location-on')) {
                $(this).find('i').removeClass('md-location-on').addClass('md-location-off');
                latitude = null;
                longitude = null;
                userAddress = null;
                saveLocation = false;
                tinyMCE.activeEditor.dom.remove(tinyMCE.activeEditor.dom.select('p #my-location'));
            } else {
                DashboardFunctions.retrieveUserLocation(function () {
                    that.find('i').toggleClass('md-location-on');
                    if (that.find('i').hasClass('md-location-on')) {
                        var existingText = tinymce.activeEditor.getContent();
                        if(existingText != ""){
                            tinymce.activeEditor.setContent(existingText  + "<span id='my-location'>" + userAddress + "</span>");
                        } else {
                            tinymce.activeEditor.setContent("<span id='my-location'>" + userAddress + "</span>");
                        }
                        saveLocation = true;
                    } else {
                        saveLocation = false;
                        tinymce.activeEditor.setContent("");
                        latitude = null;
                        longitude = null;
                        userAddress = null;
                    }
                });
            }
        });
        $(document).on('click', '#edit-note .share-check', function(){
            $(this).toggleClass('conversation-on');
        });
    };

    self.openEditNotePopup = function () {
        $('#edit-note .popup-menu-backdrop').toggle();
        $('#edit-note .advanced-menu').css('z-index', '20000');
        $('#edit-note .advanced-menu').slideToggle('4000', 'swing');
    };

    self.selectElement = function () {
        $appendToParent = $("#append-data-note", '#edit-note');
        $autoCompleteAppend = $("#autocomplete-append", '#edit-note');
        $autoCompleteAppendList = $("#autocomplete-append-list", '#edit-note');
        $noteBody = $("#editor");
        $btnSave = $('#save-link', '#edit-note');
    };

    self.loadNote = function () {
        try {
            if (note) {
                tinymce.activeEditor.setContent(note.note);
                PermissionController.setData(note['accessList']);
                if (note.conversationActive) {
                    $("#edit-note .share-check").addClass('conversation-on');
                } else {
                    if($("#edit-note .share-check").hasClass("conversation-on")){
                        $("#edit-note .share-check").removeClass("conversation-on");
                    }
                }
            }
        } catch (e) {
            console.log(JSON.stringify(e));
        }
    };

    self.selectObjectFromDatabase = function (idSubject, typeSubject, idRecording, typeRecording) {
        var id, type;
        if (idSubject != idRecording) {
            id = idRecording;
            type = typeRecording;
        } else {
            id = idSubject;
            type = typeSubject;
        }

        var tableName, query, queryData = [getTextTypeObject(id, 'integer')];
        if ("deal" == type.toLowerCase()) {
            $appendToParent.val('Deal').selectmenu('refresh');
            $autoCompleteAppend.parent().parent().show();
            query = 'SELECT * FROM deal where id =?';
            tableName = "deal";
        } else if ("kase" == type.toLowerCase() || "project" == type.toLowerCase()) {
            $appendToParent.val('Project').selectmenu('refresh');
            $autoCompleteAppend.parent().parent().show();
            query = 'SELECT * FROM kase where id =?';
            tableName = "kase";
        } else if ("company" == type.toLowerCase()) {
            $appendToParent.val('Company').selectmenu('refresh');
            $autoCompleteAppend.parent().parent().show();
            query = 'SELECT * FROM company where id =?';
            tableName = "company";
        } else if ("people" == type.toLowerCase() || "person" == type.toLowerCase()) {
            $appendToParent.val('Person').selectmenu('refresh');
            $autoCompleteAppend.parent().parent().show();
            query = 'SELECT * FROM people where id =?';
            tableName = "people";
        } else if (type.toLowerCase() == "task") {
            $appendToParent.val('Task').selectmenu('refresh');
            $autoCompleteAppend.parent().parent().show();
            query = 'SELECT * FROM task where id =?';
            tableName = "task";
        }

        self.appendDataNoteEventChange();

        db.selectByQuery(query, queryData, tableName, function (data) {
            if (data != null && data[0] != null) {
                AutoCompleteController.setObject($autoCompleteAppend.attr('data-objecttype'), data[0].id.text);
                if ("people" == type.toLowerCase() || "person" == type.toLowerCase()) {
                    $autoCompleteAppend.val(data[0]['first-name'] + ' ' + data[0]['last-name']);
                } else {
                    if (type.toLowerCase() == "task") {
                        if (data[0].name) {
                            $autoCompleteAppend.val(data[0].name);
                        } else {
                            $autoCompleteAppend.val(data[0].body);
                        }
                    } else {
                        $autoCompleteAppend.val(data[0].name);
                    }

                }
            }
        });

    };

    self.saveLinkEvent = function () {
        $("#edit-note .advanced-menu").hide();
        $("#edit-note .popup-menu-backdrop").hide();
        $(this).addClass('not-clickable');
        if ($.trim(tinymce.activeEditor.getContent()) == "") {
            alert(Messages.Note.noteMessage);
        } else {
            if (window.localStorage.getItem("enableSave") == "true") {
                showActionDialog(Messages.Note.saveNote, "Yes", self.saveNote, "No", function () {
                });
            } else {
                self.saveNote();
            }
        }
    };

    self.saveNote = function () {
        playSound("www/libs/blop.mp3");
        var sharedWithUsers;
        if($("#edit-note .share-check").hasClass('conversation-on')){
            sharedWithUsers = true;
        } else {
            sharedWithUsers = false;
        }
        var body = $.trim(tinymce.activeEditor.getContent());
        var locationCoordinates = [];
        if(latitude && longitude && saveLocation){
            locationCoordinates.push(longitude);
            locationCoordinates.push(latitude);
        }
        if (body == "<p>Enter your note ...</p>") {
            alert("Enter note body!");
        } else {
            var parentId = AutoCompleteController.getObject($appendToParent.val());
            if (!parentId) {
                parentId = parentsId;
            }
            var accessList = PermissionController.permission;
            var urlList = [];

            if (note && note['_id']) {
                if (duplicate) {
                    NoteController.save(body, accessList, parentId, urlList, sharedWithUsers, locationCoordinates, function (err) {
                        hideLoadingIndikator();
                        if (err == "error") {
                            alert("Invalid params");
                        } else {
                            //remove item from draft
                            if (draftNoteId) {
                                DraftFunctions.deleteDraft(draftNoteId);
                            }
                            goBack();
                        }
                    });
                } else {
                    urlList = note['urlList'];
                    NoteController.update(note['_id'], body, accessList, parentId, urlList, sharedWithUsers, locationCoordinates, function (dataObject) {
                        goBack();
                    });
                }
            } else if (draftNoteId && draftNoteObjectId) {
                urlList = draftNoteObjectUrls;
                NoteController.update(draftNoteObjectId, body, accessList, parentId, urlList, sharedWithUsers, locationCoordinates, function (dataObject) {
                    DraftFunctions.deleteDraft(draftNoteId);
                    goBack();
                });

            } else {
                NoteController.save(body, accessList, parentId, urlList, sharedWithUsers, locationCoordinates, function (err) {
                    hideLoadingIndikator();
                    if (err == "error") {
                        alert("Invalid params");
                    } else {
                        //remove item from draft
                        if (draftNoteId) {
                            DraftFunctions.deleteDraft(draftNoteId);
                        }
                        goBack();
                    }
                });
            }
        }
    };

    self.appendDataNoteEventChange = function () {
        $autoCompleteAppend.val('');
        $autoCompleteAppendList.empty();
        AutoCompleteController.setObject($autoCompleteAppend.attr('data-objecttype'), null);
        if ($appendToParent.val() != "none") {
            AutoCompleteController.setObject('Company', null);
            AutoCompleteController.setObject('Person', null);
            AutoCompleteController.setObject('Deal', null);
            AutoCompleteController.setObject('Project', null);
            AutoCompleteController.setObject('Note', null);
            $autoCompleteAppend.attr('data-objecttype', $appendToParent.val());
            $autoCompleteAppend.parent().parent().show();
        } else {
            $autoCompleteAppend.parent().parent().hide();
        }
    };

    self.goBackAction = function () {
        clearInterval(draftInterval);
        var noteBody = $($.trim(tinymce.activeEditor.getContent())).text();
        //note from server side
        if (note && note.note) {
            if (htmlStrip(note.note) != noteBody && noteBody != "") {
                showDialog("DIALOG", "There is unsaved data left in your note, would you like to save it?", "WARNING", "Yes", function () {
                    self.saveLinkEvent();
                }, "No", function () {
                    self.deleteDraftItem();
                }, "To Draft", function () {
                    self.saveToDraft(function () {
                        goBack();
                    });
                });
            } else {
                goBack();
            }
        } else if (draftNoteId) {
            db.selectByQuery("SELECT * FROM draft WHERE [id] = ?", [draftNoteId], "draft", function (data) {
                if (data && data[0]) {
                    if ($(data[0].object.body).text() != noteBody) {
                        showDialog("DIALOG", "There is unsaved data left in your note, would you like to save it?", "WARNING", "Yes", function () {
                            self.saveLinkEvent();
                        }, "No", function () {
                            self.deleteDraftItem();
                        }, "To Draft", function () {
                            self.saveToDraft(function () {
                                goBack();
                            });
                        });
                    } else {
                        goBack();
                    }
                } else {
                    goBack();
                }
            });
        } else {
            showDialog("DIALOG", "There is unsaved data left in your note, would you like to save it?", "WARNING", "Yes", function () {
                self.saveLinkEvent();
            }, "No", function () {
                goBack();
            }, "To Draft", function () {
                self.saveToDraft(function () {
                    goBack();
                });
            });
        }

    };

    self.loadDraft = function (draft) {
        tinymce.activeEditor.setContent(draft.object.body);
        PermissionController.setData(draft.object.accessList);
        if (draft.object.conversationActive) {
            $("#edit-note .share-check").addClass('conversation-on');
        } else {
            if($("#edit-note .share-check").hasClass('conversation-on')){
                $("#edit-note .share-check").removeClass('conversation-on');
            }
        }
    };

    self.saveToDraft = function (callback) {
        var body = $.trim(tinymce.activeEditor.getContent());
        var parentId = AutoCompleteController.getObject($appendToParent.val());
        var accessList = PermissionController.permission;
        var urlList = [];
        var sharedWithUsers;
        if($("#edit-note .share-check").hasClass('conversation-on')){
            sharedWithUsers = true;
        } else {
            sharedWithUsers = false;
        }
        var draft = {};
        draft.id = UtilController.randomNumber();
        draft.type = "Note";
        draft['updated-at'] = new Date();
        var noteObj = {};
        noteObj.body = body;
        noteObj.parentId = parentId;
        noteObj.parentType = $appendToParent.val();
        noteObj.conversationActive = sharedWithUsers;
        noteObj.accessList = accessList;
        noteObj.urlList = urlList;
        draft.object = noteObj;

        // object for draft exists
        if (note && note['_id']) {
            console.log("Existing note save to draft");
            console.log(note['_id']);
            draft.objectId = note['_id'];
            draft.object.id = note['_id'];
            DraftController.checkIfNoteObjectExists(note['_id'], function (exists) {
                if (exists) {
                    db.updateObject("draft", "objectId", note['_id'], draft, false, function () {
                        if (callback && typeof callback == "function") {
                            callback();
                        }
                    });
                } else {
                    db.insert("draft", [draft], function () {
                        draftNoteId = draft.id;
                        if (callback && typeof callback == "function") {
                            callback();
                        }
                    });
                }
            });
        } else {
            if ($.trim(tinymce.activeEditor.getContent()) == "") {
                alert("Note is empty!");
            } else {
                if (draftNoteId) {
                    db.updateObject("draft", "id", draftNoteId, draft, false, function () {
                        if (callback && typeof callback == "function") {
                            callback();
                        }
                    });
                } else {
                    db.insert("draft", [draft], function () {
                        draftNoteId = draft.id;
                        if (callback && typeof callback == "function") {
                            callback();
                        }
                    });
                }
            }
        }
    };

    self.deleteDraftItem = function () {
        if (draftNoteId) {
            DraftFunctions.deleteDraft(draftNoteId, function () {
                goBack();
            });
        } else {
            goBack();
        }
    };

    self.loadNoteTemplates = function (callback) {
        ClientAPI.getTemplatesForType({type: "Template"}, function (err, data) {
            if (!err && data && data.length > 0) {
                $("#edit-note .template-list").empty();
                var templateExists = false;
                var html = "";
                for (var i = 0; i < data.length; i++) {
                    html += EditProfilFunctions.drawTemplateItem(data[i], false);
                }
                if (html != "") {
                    $("#edit-note .template-list").append(html);
                    templateExists = true;
                }
                if (callback && typeof callback == "function") {
                    callback(templateExists);
                }
            }
        });
    };

    self.showTemplates = function () {
        self.loadNoteTemplates(function (templateExists) {
            if (templateExists) {
                $("#edit-note .template-list").toggle();
            }
        });
    };

    self.setNoteTemplate = function () {
        var template = $(this).find('.template-element').attr('templateObj');
        template = JSON.parse(template);
        var templateText = template.template;
        if (note && note.note) {
            showActionDialog("If note is filled, the existing text will be overwritten. Are you sure you want to use new template?", "Yes", function () {
                tinymce.activeEditor.setContent(templateText);
            }, "No", function () {

            });
        } else {
            tinymce.activeEditor.setContent(templateText);
        }
        $("#edit-note .template-list").hide();
    };

    return self;
}(NoteEditFunctions || {}));
