$(document).on('pageinit', '#update-note-link', function () {
    UpdateNoteLink.init();
});

$(document).on('pageshow', '#update-note-link', function () {
    UpdateNoteLink.bindElementControls();
});

$(document).on('pagehide', '#update-note-link', function () {
    UpdateNoteLink.unbindElementControls();
});

var UpdateNoteLink = (function (UpdateNoteLink) {
    var self = UpdateNoteLink;
    var noteId = null;

    self.init = function () {
        if (pageObject) {
            noteId = pageObject.noteId;
            pageObject = null;
        }

        NoteController.findById(noteId, function (data) {
            if (data && data[0]) {
                self.loadLinks(data[0].urlList);
            }
        });
    };

    self.bindElementControls = function () {
        $(document).on('click', '#update-note-link #back-link', goBack);
        $(document).on('click', '#update-note-link #more-link', self.openEditCommentPopup);
        $(document).on('click', '#update-note-link #save-link', self.saveNoteLinks);
        $(document).on('click', '#update-note-link .remove-link', self.removeLink);
        $('#update-note-link .popup-menu-backdrop').on('click', function () {
            $('#update-note-link .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#update-note-link .additional-options', self.saveNoteLinks);
        $(document).on('click', '#update-note-link .btn-note-link', self.populateLinkList);
        $(document).on('click', '#update-note-link #note-link-details', function () {
            $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
            $("#update-note-link .note-link-list-container").toggle();
        });
        $(document).on('click', '#update-note-link .link-val', function () {
            var linkVal = $(this).text();
            window.open(linkVal, "_blank", "location=yes");
        });
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#update-note-link #back-link');
        $(document).off('click', '#update-note-link #more-link');
        $(document).off('click', '#update-note-link #save-link');
        $(document).off('click', '#update-note-link .remove-link');
        $('#update-note-link .popup-menu-backdrop').off('click');
        $(document).off('click', '#update-note-link .additional-options');
        $(document).off('click', '#update-note-link .btn-note-link');
        $(document).off('click', '#update-note-link #note-link-details');
        $(document).off('click', '#update-note-link .link-val');
    };

    self.loadLinks = function (links) {
        var html = "";
        var linkToDisplay = "";
        if (links instanceof  Array) {
            for (var i = 0; i < links.length; i++) {
                html += "<li>";
                if (links[i].urlType.toLowerCase() == "link") {
                    html += "<div class='link-type' linkType='" + links[i].urlType + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
                } else {
                    html += "<div class='link-type' linkType='" + links[i].urlType + "' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
                }
                
                if(links[i].urlDescription != ""){
                    linkToDisplay = links[i].urlDescription;
                } else {
                    linkToDisplay = links[i].url;
                }
                
                html += "<div class='link-desc truncate' link-val='"+ links[i].url +"' style='padding: 0px 10px; max-width: 70%;'>" + linkToDisplay + "</div>"
                        + "<div class='remove-link'><i class='md md-delete md-2x'></i></div>"
                        + "</li>";
            }
        } else {
            html += "<li>";
            if (links.urlType.toLowerCase() == "link") {
                html += "<div class='link-type' linkType='" + links.urlType + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
            } else {
                html += "<div class='link-type' linkType='" + links.urlType + "' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
            }
            if(links.urlDescription != ""){
                linkToDisplay = links.urlDescription;
            } else {
               linkToDisplay = links.url;
            }
            html += "<div class='link-desc truncate' link-val='"+ links.url + "' style='padding: 0px 10px; max-width: 70%;'>" + linkToDisplay + "</div>"
                    + "<div class='remove-link'><i class='md md-delete md-2x'></i></div>"
                    + "</li>";
        }

        if (html != "") {
            $("#update-note-link #note-link-list").append(html);
        }
    };

    self.saveNoteLinks = function () {
        var noteLinks = [];
        var $linkItems = $("#update-note-link #note-link-list li");
        var linksCount = $linkItems.length;
        for (var i = 0; i < linksCount; i++) {
            var linkObject = {};
            linkObject.url = $($linkItems[i]).find('div.link-desc').attr('link-val');
            linkObject.urlDescription = $($linkItems[i]).find('div.link-desc').text();
            linkObject.urlType = $($linkItems[i]).find('div.link-type').attr('linkType');
            noteLinks.push(linkObject);
        }
        NoteController.updateNotesLink(noteId, noteLinks);

    };

    self.removeLink = function () {
        $(this).parent().remove();
    };

    self.openEditCommentPopup = function () {
        $('#update-note-link .popup-menu-backdrop').toggle();
        $('#update-note-link .advanced-menu').css('z-index', '20000');
        $('#update-note-link .advanced-menu').slideToggle('4000', 'swing');
    };

    self.populateLinkList = function () {
        var html = "";
        var $linkVal = $("#update-note-link .note-link-val");
        var $linkDesc = $("#update-note-link .note-link-desc");
        var $linkType = $("#update-note-link .note-link-type option:selected");
        var linkUrl = $linkVal.val();
        var linkDesc = $linkDesc.val();
        if (linkUrl && linkDesc) {
            html += "<li>";
            if ($linkType.val() == "link") {
                html += "<div class='link-type' linkType='" + $linkType.val() + "' style='padding: 0px 10px;'><i class='md md-link'></i></div>";
            } else {
                html += "<div class='link-type' linkType='" + $linkType.val() + "' style='padding: 0px 10px;'><i class='md md-videocam'></i></div>";
            }
            html += "<div class='link-desc truncate' link-val = '"+ $linkVal.val() +"' style='padding: 0px 10px; max-width: 70%;'>" + linkDesc + "</div>"
                    + "<div class='remove-link'><i class='md md-delete md-2x'></i></div>"
                    + "</li>";
        }
        if (html != "") {
            $("#update-note-link #note-link-list").append(html);
            $linkVal.val("");
            $linkDesc.val("");
        }
    };

    return self;
}(UpdateNoteLink || {}));			