$(document).on('pageinit', '#view-note', function () {
    ViewNoteFunctions.init();
});

$(document).on('pageshow', '#view-note', function () {
    ViewNoteFunctions.bindElementControls();
});

$(document).on('pagehide', '#view-note', function () {
    ViewNoteFunctions.unbindElementControls();
    ViewNoteFunctions.openFrom = '';
});

var ViewNoteFunctions = (function (ViewNoteFunctions) {
    var self = ViewNoteFunctions;
    self.openFrom = '';
    self.drawListParams = [];
    var $viewNote = null;
    var listViewId = 'view-note-tasks-list';
    var noteObject = null;
    var $viewNoteGeneralContent = null;
    var $viewNoteAttachmentContent = null;
    var $viewNoteCommentsContent = null;
    var $viewNoteTasksContent = null;
    var $viewNoteBodyBox = null;
    var $viewNoteBodyDesc = null;
    var $viewNoteCreatedAtBox = null;
    var $viewNoteCreatedAtDesc = null;
    var $viewNoteUpdatedAtBox = null;
    var $viewNoteUpdatedAtDesc = null;
    var $viewNotePermissionList = null;
    var $viewNoteCommentsList = null;
    var $viewNoteAttachmentList = null;
    var $viewNoteAuthorBox = null;
    var $viewNoteAuthorDesc = null;
    var $viewNoteParentBox = null;
    var $viewNoteParentHeading = null;
    var $viewNoteParentDesc = null;
    var $viewNoteRootBox = null;
    var $viewNoteRootHeading = null;
    var $viewNoteRootDesc = null;
    var $notesAddLink = null;
    var $notesMoreLink = null;
    var $viewNoteCommentBody = null;
    var $filterNoteTaskType = null;
    var type = null;
    var currentTaskType = null;
    var taskIdForComplete = null;
    var $attachmentPopup = null;
    var $notePopup = null;

    var $generalLink = null;
    var $attachementLink = null;
    var $commentsLink = null;
    var $tasksLink = null;
    var $attachementLinkContainer = null;
    var $commentsLinkContainer = null;
    var $tasksLinkContainer = null;
    var $taskList = null;
    var noteId = null;
    var appendedAditional = false;
    var lastCommentDate = null;
    var colors = ["red", "orange", "yellow", "cyan", "bisque", "pink", "plum", "gray", "blue", "beige", "powderblue", "palegreen", "peachpuff", "palegoldenrod",
        "paleturquoise", "palevioletred", "purple", "aqua", "azure", "brown", "aquamarine", "burlywood", "cadetblue", "chartreuse", "chocolate", "coral", "cornflowerblue",
        , "cornsilk", "crimson", "deeppink", "firebrick", "gold", "honeydew", "indianred", "khaki"];
    var userColorsHash = {};

    self.init = function () {
        self.selecteElement();
        self.currentTab = 'general';
        hideLoadingIndikator();
        $filterNoteTaskType.i18n();
        $filterNoteTaskType.selectmenu('refresh');

        if (navigator.userAgent.match(/(iPad|iPhone)/)) {
            if (!appendedAditional) {
                $("#view-note .attach-advanced-menu ul").append('<li id="ios-gallery"><span class="popup-menu-item"><i class="md-image md-2x"></i></span>\n\
                <span class="advanced-menu-text">Choose from gallery</span></li>');
                $("#view-note .attach-advanced-menu > ul").listview("refresh");
                appendedAditional = true;
            }
        }

        if (pageObject) {
            noteId = pageObject.noteId;
            if (pageObject.commentTab) {
                self.currentTab = 'comments';
            }
            pageObject = null;
        }

        NoteController.findById(noteId, function (data) {
            noteObject = data[0];
            //register socket if conversation active
            if (noteObject.conversationActive) {
                 $(".conversation-indicator").show();
                ChatAPI.connect(function () {
                    console.log("Socket registered!");
                    ChatAPI.joinRoom(noteObject['_id'], function (err) {
                        if (err) {
                            console.log(JSON.stringify(err));
                        }
                    });
                    self.broadcastMessage();
                });
            }
            self.navigationActive();
            if (noteObject.immediateParentObjectType != null && noteObject.immediateParentObjectType == "Task") {
                $viewNote.find('#notes-tasks-link').remove();
            }
        });
    };

    self.bindElementControls = function () {
        $(document).on('click', '#back-link', function () {
            ChatAPI.leaveRoom(noteObject['_id'], function (err) {
                console.log("Leave Room error");
                console.log(JSON.stringify(err));
            });
            goBack();
        });
        $(document).on('click', '#notes-general-link', self.showGeneral);
        $(document).on('click', '#notes-attachment-link', self.showAttachments);
        $(document).on('click', '#notes-comment-link', self.showComments);
        $(document).on('click', '#notes-tasks-link', self.showTasks);
        $(document).on('click', '#view-note-save-comment', self.saveCommentEvent);
        $(document).on('click', '#notes-more-link', self.openNoteOptionsPopup);
        $(document).on('click', '#view-note-comments-list .comment', self.openComment);
        $(document).on('click', '#delete-note', self.notesDeleteLinkEvent);
        $(document).on('click', '#edit-note-action', self.editNote);
        $(document).on('click', '#notes-add-link', self.addEvent);
        $(document).on('click', '#voice-note', self.voiceNote);
        $(document).on('click', '#take-photo', self.takePhoto);
        $(document).on('click', '#choose-from-gallery', self.chooseFromGallery);
        $(document).on('click', '.delete-item', self.deleteAttachment);
        $(document).on('click', '.attachment', self.openAttach);
        $(document).on('click', '#view-note #add-url-link', self.navigateToUpdateLink);
        $(document).on('change', '#filter-note-task-type', self.filterNoteTaskTypeEvent);
        $(document).on('click', '#view-note-general-content .parent', self.openParent);
        $(document).on('click', '#author-desc', self.openAuthor);
        $(document).on('click', '#view-note-tasks-list .upcomingTask', self.viewNoteTaskCompletedEvent);
        $(document).on('click', '#view-note-tasks-list .assignedTask', self.viewNoteTaskCompletedEvent);
        $(document).on('click', '#view-note-tasks-list .task-item', self.viewNoteTasksListEvent);
        $(document).on('click', '#view-note #parent-info-desc', self.parentInfoLinkEvent);
//        $(document).on('taphold', '#view-note-tasks-list .task-item', self.deleteTaskItem);
        $(document).on('click', '#view-note .float-add-action', self.editNote);
        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });
        $('#view-note .popup-menu-backdrop').on('click', function () {
            $('#view-note .advanced-menu').hide();
            $("#view-note .attach-advanced-menu").hide();
            $(this).hide();
        });

        $("#view-note .attach-advanced-menu #ios-gallery").on("click", self.chooseFromIOSGallery);
        $(document).on('click', '#view-note .task-due-date-change', self.changeDueDateEvent);
        $(document).on('click', '#view-note .createdTask', self.completeTaskEvent);
        $(document).on('click', '#view-note .upcomingTask', self.completeTaskEvent);
        $(document).on('click', '#view-note .assignedTask', self.completeTaskEvent);
        $(document).on('click', '#view-note .inprogressTask', self.completeTaskEvent);
        $(document).on('click', '#view-note .completedTask', self.completeTaskEvent);
        $(document).on('click', '#view-note .canceledTask', function () {
            alert("Status change is not allowed!");
        });
        $(document).on('click', '#copy-note-action', self.duplicateNote);
        $(document).on('click', '#view-note .childTasks', self.getChildTasks);
        $(document).on('click', '#view-note .child-task-item', self.navigateToChildTasks);
        $(document).on('click', '#view-note .load-task-child-btn', self.loadChildTaskEvent);
        $(document).on("click", "#view-note .view-item-visibility", self.viewItemVisibleToggle);
        $(document).on('click', '#view-note .add-new-permission-user', self.changePermission);
        $(document).on('click', '#view-note .visible-user-item', self.removePersonPermission);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#back-link');
        $(document).off('click', '#notes-general-link');
        $(document).off('click', '#notes-attachment-link');
        $(document).off('click', '#notes-comment-link');
        $(document).off('click', '#notes-tasks-link');
        $(document).off('click', '#view-note-save-comment');
        $(document).off('click', '#notes-more-link');
        $(document).off('click', '#view-note-comments-list .comment');
        $(document).off('click', '#delete-note');
        $(document).off('click', '#edit-note-action');
        $(document).off('click', '#notes-add-link');
        $(document).off('click', '#voice-note');
        $(document).off('click', '#take-photo');
        $(document).off('click', '#choose-from-gallery');
        $(document).off('click', '.delete-item');
        $(document).off('click', '.attachment');
        $(document).off('click', '#view-note #add-url-link');
        $(document).off('change', '#filter-note-task-type');
        $(document).off('click', '#view-note-general-content .parent');
        $(document).off('click', '#author-desc');
        $(document).off('click', '#view-note-tasks-list .upcomingTask');
        $(document).off('click', '#view-note-tasks-list .assignedTask');
        $(document).off('click', '#view-note-tasks-list .task-item');
        $(document).off('click', '#view-note #parent-info-desc');
        $(document).off('click', '#view-note .float-add-action');
//        $(document).off('taphold', '#view-note-tasks-list .task-item');
        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
        $('#view-note .popup-menu-backdrop').off('click');
        $("#view-note .attach-advanced-menu #ios-gallery").off("click");
        $(document).off('click', '#view-note .task-due-date-change');
        $(document).off('click', '#view-note .createdTask');
        $(document).off('click', '#view-note .upcomingTask');
        $(document).off('click', '#view-note .assignedTask');
        $(document).off('click', '#view-note .inprogressTask');
        $(document).off('click', '#view-note .completedTask');
        $(document).off('click', '#view-note .canceledTask');
        $(document).off('click', '#copy-note-action');
        $(document).off('click', '#view-note .childTasks');
        $(document).off('click', '#view-note .child-task-item');
        $(document).off('click', '#view-note .load-task-child-btn');
        $(document).off("click", "#view-note .view-item-visibility");
        $(document).off('click', '#view-note .add-new-permission-user');
        $(document).off('click', '#view-note .visible-user-item');
        noteId = null;
        appendedAditional = false;
    };

    self.removePersonPermission = function() {
      var identity = $(this).attr('data-identity');
      debugger;
      noteObject.objectType = "Note";
      PermissionController.removePermissionFromObject(identity, noteObject, function(success){
        if (success) {
          $('.visible-user-item[data-identity=' + identity +']').remove();
          var visibleTo = [];
          for (var i = 0, max = noteObject['accessList'].length; i < max; i++) {
              if (noteObject['accessList'][i].identity != identity) {
                visibleTo.push(noteObject['accessList'][i]);
              }
          }
          noteObject['accessList'] = visibleTo;
        }
      });
    };

    self.selecteElement = function () {
        PermissionController.init('#view-note');

        $viewNote = $('#view-note');
        $viewNoteGeneralContent = $('#view-note-general-content');
        $viewNoteAttachmentContent = $('#view-note-attachment-content');
        $viewNoteCommentsContent = $('#view-note-comments-content');
        $viewNoteTasksContent = $('#view-note-tasks-content');
        $viewNoteBodyBox = $('#note-body-box');
        $viewNoteBodyDesc = $('#note-body-description');
        $viewNoteCreatedAtBox = $('#created-at-box');
        $viewNoteCreatedAtDesc = $('#created-at-desc');
        $viewNoteUpdatedAtBox = $('#updated-at-box');
        $viewNoteUpdatedAtDesc = $('#updated-at-desc');
        $viewNotePermissionList = $('#user-note-permission-list');
        $viewNoteCommentsList = $('#view-note-comments-list');
        $viewNoteAttachmentList = $('#view-note-attachment-list');
        $viewNoteAuthorBox = $('#author-box');
        $viewNoteAuthorDesc = $('#author-desc');
        $viewNoteParentBox = $('#parent-info-box');
        $viewNoteParentHeading = $('#parent-info-heading');
        $viewNoteParentDesc = $('#parent-info-desc');
        $viewNoteRootBox = $('#root-info-box');
        $viewNoteRootHeading = $('#root-info-heading');
        $viewNoteRootDesc = $('#root-info-desc');
        $notesAddLink = $('#notes-add-link');
        $notesMoreLink = $('#notes-more-link');
        $viewNoteCommentBody = $("#view-note-comment-body");
        $filterNoteTaskType = $('#filter-note-task-type');
        $attachmentPopup = $("#view-note .attach-advanced-menu");
        $notePopup = $("#view-note .advanced-menu");

        // tab variables
        $generalLink = $("#view-note #notes-general-link");
        $attachementLink = $("#view-note #notes-attachment-link-text");
        $commentsLink = $("#view-note #notes-comment-link-text");
        $tasksLink = $("#view-note #notes-tasks-link-text");
        $attachementLinkContainer = $("#view-note #notes-attachment-link");
        $commentsLinkContainer = $("#view-note #notes-comment-link");
        $tasksLinkContainer = $("#view-note #notes-tasks-link");
        $taskList = $("#view-note-tasks-list");
    };

    self.viewItemVisibleToggle =  function (event) {
          $('html, body').animate({scrollTop: $(document).height()}, 'slow');
          $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
          $('#' + $(this).attr('container')).toggleClass('hide');
    };

    self.activateTab = function (tabName) {
        switch (tabName) {
            case "General":
                $attachementLinkContainer.removeClass("btn-active");
                $commentsLinkContainer.removeClass("btn-active");
                $tasksLinkContainer.removeClass("btn-active");
                $generalLink.addClass("btn-active");
                break;
            case "Attachement":
                $commentsLinkContainer.removeClass("btn-active");
                $tasksLinkContainer.removeClass("btn-active");
                $generalLink.removeClass("btn-active");
                $attachementLinkContainer.addClass("btn-active");
                break;
            case "Comment":
                $tasksLinkContainer.removeClass("btn-active");
                $generalLink.removeClass("btn-active");
                $attachementLinkContainer.removeClass("btn-active");
                $commentsLinkContainer.addClass("btn-active");
                break;
            case "Task":
                $generalLink.removeClass("btn-active");
                $attachementLinkContainer.removeClass("btn-active");
                $commentsLinkContainer.removeClass("btn-active");
                $tasksLinkContainer.addClass("btn-active");
                break;
        }
    };

    self.navigationActive = function () {
        if (self.currentTab == 'tasks') {
            self.showTasks();
        } else if (self.currentTab == 'attachments') {
            self.showAttachments();
        } else if (self.currentTab == 'comments') {
            self.showComments();
        } else {
            self.showGeneral();
        }
    };

    self.setChildObjectsCountNumber = function () {
        if (connection) {
            $tasksLink.text('(0)');
            $commentsLink.text('(0)');
            var attachCnt = 0;
            attachCnt += (noteObject.fileAttachments) ? noteObject.fileAttachments.length : 0;
            attachCnt += (noteObject.urlList) ? noteObject.urlList.length : 0;
            ;
            $attachementLink.text('(' + attachCnt + ')');

            ClientAPI.aggregate([{
                    $match: {$and: [{immediateParent: {$in: [new ObjectId(noteObject["_id"])]}}],
                        objectType: {$in: ['Comment', 'Task']}}}, {$group: {_id: {parent: '$immediateParent', type: '$objectType'},
                        cnt: {$sum: 1}}}, {$project: {_id: 0, parent: '$_id.parent', type: '$_id.type', cnt: 1}}, {
                    $group: {_id: '$parent', types: {$push: {type: '$type', cnt: '$cnt'}}}}],
                    function (err, data) {
                        if (err) {
                            console.log(err);
                        }
                        if (data != null && data[0] != null && data[0].types != null) {
                            var types = data[0].types;
                            for (var i = 0, max = types.length; i < max; i++) {
                                if (types[i].type == "Task") {
                                    $tasksLink.text('(' + types[i].cnt + ')');
                                } else if (types[i].type == "Comment") {
                                    $commentsLink.text('(' + types[i].cnt + ')');
                                }
                            }
                        }
                    });
        }
    };

    self.showGeneral = function () {
        self.currentTab = 'general';
        self.activateTab("General");
        $taskList.hide();
        $viewNoteGeneralContent.show();
        $viewNoteAttachmentContent.hide();
        $viewNoteCommentsContent.hide();
        $viewNoteTasksContent.hide();
        $notesAddLink.hide();
        $notesMoreLink.show();

        $viewNoteAuthorBox.hide();
        if (noteObject.creator != null) {
            $viewNoteAuthorDesc.html(ALL_USERS[noteObject.creator].name);
            $viewNoteAuthorDesc.attr("userid", ALL_USERS[noteObject.creator].id.text);
            $viewNoteAuthorBox.show();
        }

        $viewNoteParentBox.hide();
        if (noteObject.immediateParentObjectType != null && noteObject.immediateParentDisplay != null) {
            if (noteObject.immediateParentObjectType == "Project") {
                noteObject.immediateParentObjectType = "Case";
            }
            var key = "";
            switch (noteObject.immediateParentObjectType.toLowerCase()) {
                case "company":
                    key = "note.noteOnCompany";
                    break;
                case "contact":
                    key = "note.noteOnContact";
                    break;
                case "deal":
                    key = "note.noteOnDeal";
                    break;
                case "task":
                    key = "note.noteOnTask";
                    break;
                case "case":
                    key = "note.noteOnCase";
                    break;
            }
            $viewNoteParentHeading.attr('data-i18n', key);
            $viewNoteParentHeading.i18n();
            //$viewNoteParentHeading.html("Note on " + noteObject.immediateParentObjectType.toLowerCase());
            $viewNoteParentDesc.html(noteObject.immediateParentDisplay);
            $viewNoteParentDesc.attr("parentid", noteObject.immediateParent);
            $viewNoteParentDesc.attr("parenttype", noteObject.immediateParentObjectType);
            $viewNoteParentBox.show();
        }

        $viewNoteRootBox.hide();
        if (noteObject.rootObjectType != null && noteObject.rootObjectDisplay != null) {

            $viewNoteRootDesc.html(noteObject.rootObjectDisplay);
            $viewNoteRootDesc.attr("parentid", noteObject.rootObject);
            $viewNoteRootDesc.attr("parenttype", noteObject.rootObjectType);
            if (noteObject.rootObjectType == "Project") {
                noteObject.rootObjectType = "Case";
            }
            var key1 = "";
            switch (noteObject.rootObjectType.toLowerCase()) {
                case "company":
                    key1 = "note.relatedToCompany";
                    break;
                case "contact":
                    key1 = "note.relatedToContact";
                    break;
                case "deal":
                    key1 = "note.relatedToDeal";
                    break;
                case "task":
                    key1 = "note.relatedToTask";
                    break;
                case "case":
                    key1 = "note.relatedToCase";
                    break;
            }
            $viewNoteRootHeading.attr('data-i18n', key1);
            $viewNoteRootHeading.i18n();
            $viewNoteRootBox.show();

        }

        $viewNoteUpdatedAtBox.hide();
        if (noteObject.modificationDate != null) {
            $viewNoteUpdatedAtDesc.html(dateTimeFormatWithAt(parseISO8601(noteObject.modificationDate)));
            $viewNoteUpdatedAtBox.show();
        }

        $viewNoteCreatedAtBox.hide();
        if (noteObject.creationDate != null) {
            $viewNoteCreatedAtDesc.html(dateTimeFormatWithAt(parseISO8601(noteObject.creationDate)));
            $viewNoteCreatedAtBox.show();
        }

//        $viewNoteBodyDesc.text(noteObject.note);
        $viewNoteBodyDesc.html(noteObject.note);
        self.parseNoteBody();

        PermissionController.setData(noteObject.accessList);
        var htmlUser = PermissionController.drawPermissionForObject(noteObject);

        $viewNotePermissionList.empty().append(htmlUser);
        self.setChildObjectsCountNumber();
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
    };

    self.parentInfoLinkEvent = function () {
        var parentId = $(this).attr('parentid');
        var parentType = $(this).attr('parenttype').toLowerCase();
        switch (parentType) {
            case "deal":
                gotoPage({url: "viewDeal", param: {id: parentId}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
                break;
            case "case":
                gotoPage({url: "viewCase", param: {caseId: parentId}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
                break;
            case "task":
                gotoPage({url: "viewTask", param: {id: parentId}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
                break;
            case "company":
                gotoPage({url: "viewContact", param: {contactId: parentId, contactType: parentType}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
                break;
            case "person":
                gotoPage({url: "viewContact", param: {contactId: parentId, contactType: parentType}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
                break;
        }
    };

    self.changePermission = function(){
        gotoPage(
          {url: "changePermission", param: {"id": noteObject["_id"], type: "Note"}},
          {url: "viewNote", param: {noteId: noteObject["_id"]}}
        );
    };

    self.showAttachments = function () {
        self.currentTab = 'attachments';
        self.activateTab("Attachement");
        $taskList.hide();
        $viewNoteGeneralContent.hide();
        $viewNoteAttachmentContent.show();
        $viewNoteTasksContent.hide();
        $viewNoteCommentsContent.hide();
        $notesAddLink.show();
        $notesMoreLink.hide();
        self.drawAttachments();
    };

    self.showComments = function () {
        self.currentTab = 'comments';
        self.activateTab("Comment");
        $taskList.hide();
        $viewNoteGeneralContent.hide();
        $viewNoteAttachmentContent.hide();
        $viewNoteCommentsContent.show();
        $viewNoteTasksContent.hide();
        $notesAddLink.hide();
        $notesMoreLink.hide();
        self.findCommentsForNote();
    };

    self.showTasks = function () {
        self.currentTab = 'tasks';
        self.activateTab("Task");
        $taskList.show();
        $viewNoteGeneralContent.hide();
        $viewNoteAttachmentContent.hide();
        $viewNoteTasksContent.show();
        $viewNoteCommentsContent.hide();
        $notesAddLink.show();
        $notesMoreLink.hide();
        self.filterNoteTaskTypeEvent();
    };

    self.onPullDown = function () {
//        if ($("#view-note-main-content ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
//            showLoadingIndikator();
//            self.navigationActive();
//        }
    };

    self.onPullUp = function () {
//        if ($("#view-note-main-content ul:visible li", '#' + $.mobile.activePage.attr('id')).last().visible()) {
//            showLoadingIndikator();
//            self.listScrollLoadTaskEvent();
//        }
    };

    self.listScrollLoadTaskEvent = function () {
        if (self.currentTab == 'tasks') {
            showLoadingIndikator();
            var dueDateSort = 1;
            if ("Completed" == TaskFunctions.drawListParams[listViewId]['taskType']) {
                dueDateSort = -1;
            }
            var sort = [["dueDate", dueDateSort]];
            TaskController.syncTasksByParentId(noteObject["_id"], true, sort, TaskFunctions.drawListParams[listViewId]['start'], offset, function (data) {
                TaskFunctions.drawTaskListView(listViewId, data, TaskFunctions.drawListParams[listViewId]['taskType'], true);
            });
        }
    };


    self.openNoteOptionsPopup = function () {
        $('#view-note .popup-menu-backdrop').toggle();
        $('#view-note .advanced-menu').css('z-index', '20000');
        $('#view-note .advanced-menu').slideToggle('4000', 'swing');
    };

    self.chooseFromIOSGallery = function () {
        $("#view-note .attach-advanced-menu").hide();
        $("#view-note .popup-menu-backdrop").hide();
        navigator.camera.getPicture(function (mediaFiles) {
            showPromptDialog("Add description for attachment!", "Prompt", "Add", function () {
                //showLoadingIndikator();
                var attachDesc = $("#prompt-text-input-popup-field").val();
                if (attachDesc != "") {
                    getAF(function (err, af) {
                        var params = {};
                        params['_af'] = af;
                        params['objId'] = noteObject['_id'];
                        params['description'] = attachDesc;
                        params['typeInfo'] = mediaFiles.split(".")[1].toLowerCase();
                        var splitovano = mediaFiles.split("/");
                        var name = splitovano[splitovano.length - 1].split(".")[0];
                        var options = new FileUploadOptions();
                        options.fileKey = "attachment";
                        options.fileName = name;
                        options.mimeType = "image/jpeg";
                        options.chunkedMode = false;
                        options.params = params;

                        var url = encodeURI(ClientAPI.rootURL + "/api/db/attachfile");
                        var ft = new FileTransfer();
                        ft.upload(mediaFiles, url, function (r) {
                            if (r.responseCode == 200) {
                                console.log("Attachment succesfully added!");
                                noteId = noteObject['_id'];
                                self.init();
                            } else {
                                alert("Error uploading file!");
                            }
                            console.log("Code = " + r.responseCode);
                            console.log("Response = " + JSON.stringify(r.response));
                            console.log("Sent = " + r.bytesSent);
                        }, function (error) {
                            alert("Error uploading picture!");
                            console.log("An error has occurred: Code = " + error.code);
                            console.log("upload error source " + error.source);
                            console.log("upload error target " + error.target);
                        }, options, true);
                    });
                } else {
                    alert("Please add description!");
                }
            }, "Cancel", function () {

            });
        }, function (e) {
            alert(e);
        }, {quality: 75, allowEdit: true, destinationType: Camera.DestinationType.FILE_URI, sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM});
    };

    self.addEvent = function () {
        if (self.currentTab == 'tasks') {
            openFrom = 'viewNote';
            gotoPage({url: "editTask", param: {parentId: noteObject["_id"], parentType: 'Note', accessList: noteObject["visible-to"]}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});

        } else if (self.currentTab == 'attachments') {
            $('#view-note .popup-menu-backdrop').toggle();
            $('#view-note .attach-advanced-menu').css('z-index', '20000');
            $('#view-note .attach-advanced-menu').slideToggle('4000', 'swing');
        }
    };

    self.openAuthor = function () {
        var userid = $(this).attr("userid");
        MyGroupFunctions.openUser(userid);
    };

    self.openParent = function () {
        var parentId = $(this).attr("parentid");
        var parentType = $(this).attr("parenttype");

        if (parentType == "Person" || parentType == "Company") {
            if (openFrom == "viewContact") {
                goBack();
            } else {
                ContactFunctions.openContact(parentId, parentType.toLowerCase());
            }
        } else if (parentType == "Project" || parentType == "Case") {
            if (openFrom == "viewCase") {
                goBack();
            } else {
                CaseController.openCase(parentId);
            }
        } else if (parentType == "Task") {
            if (openFrom == "viewTask") {
                goBack();
            } else {
                var id = null;
                var ids = [];

                id = $(this).attr('taskId');
                $(document).find("#view-note-tasks-list .task-item").each(function () {
                    ids.push($(this).attr('taskId'));
                });
                gotoPage({url: "viewTask", param: {id: id, ids: ids}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
            }
        } else if (parentType == "Deal") {
            if (openFrom == "viewDeal") {
                goBack();
            } else {
                gotoPage({url: "viewDeal", param: {id: parentId}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
            }
        }
    };

    self.viewNoteTaskCompletedEvent = function () {
        taskIdForComplete = $(this).attr('taskId');
        if (window.localStorage.getItem("enableSave") == "true") {
            showActionDialog(Messages.Task.completeTaskMessage, "Yes", self.completeTask, "No", function () {
            });
        } else {
            self.completeTask();
        }
    };

    self.completeTask = function () {
        showLoadingIndikator();
        TaskController.completeTask(taskIdForComplete, function (data) {
            hideLoadingIndikator();
            var authorId = null;
            var body = null;
            if (data[0] !== null && data[0]["author-id"] !== null) {
                authorId = data[0]["author-id"].text;
                body = data[0]["body"];
            } else if (data != null && data["author-id"] != null) {
                authorId = data["author-id"];
                body = data["body"];
            }

            if (authorId) {
                SipMessageSettingFunctions.sendInfoMessage(authorId, {
                    taskid: taskIdForComplete,
                    body: "Task completed!",
                    tasktext: body
                }, function () {
                    self.getTasksForNote();
                });
            } else {
                self.getTasksForNote();
            }
        });
    };

//    self.deleteTaskItem = function () {
//        tapholdActive = true;
//        setTimeout(function () {
//            tapholdActive = false;
//        }, 1000);
//        var taskId = $(this).attr('taskId');
//        if (connection) {
//            showActionDialog(Messages.Task.deleteTaskMessage, "Yes", function () {
//                showLoadingIndikator();
//                TaskController.findById(taskId, function (data) {
//                    data = TaskController.encodeItem(data);
//                    var requestObject = {
//                        "taskid": data.id.text,
//                        "body": data.body
//                    };
//                    TaskController.deleteTask(data.id.text, function (data) {
//                        if (data == 0) {
//                            db.selectSingleRecord(models.infoMessageDBModel.name, "body", requestObject, function (data) {
//                                if (data != null) {
//                                    var messageId = data['infoMessage']['_id'];
//                                    db.deleteObject(models.infoMessageDBModel.name, "_id", messageId);
//                                    SipMessageSettingFunctions.setMessageStatus([
//                                        {'messageid': messageId, 'status': 5 }
//                                    ]);
//                                }
//                                self.getTasksForNote();
//                                hideLoadingIndikator();
//                            });
//
//                        } else {
//                            hideLoadingIndikator();
//                            alert(Messages.Task.deleteTaskMessageErr);
//                        }
//                    });
//                });
//            }, "No", function () {
//            });
//        }
//    };

    self.viewNoteTasksListEvent = function () {
        var id = null;
        var ids = [];

        id = $(this).attr('taskId');
        $(document).find("#view-note-tasks-list .task-item").each(function () {
            ids.push($(this).attr('taskId'));
        });

        gotoPage({url: "viewTask", param: {id: id, ids: ids, listParams: TaskFunctions.drawListParams[listViewId]}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
    };

    self.currentTab = function () {
        return self.currentTab;
    };

    self.notesTasksLinkEvent = function () {
        TaskController.countObjectByParentId(noteObject.id.text, function (data) {
            $notesTasksLink.text('Tasks (' + data + ')');
        });
        self.showTasks();
        self.currentTab = 'tasks';

        currentTaskType = $filterNoteTaskType.find('option:selected').val();

        if ("filter-note-upcoming-tasks" == currentTaskType) {
            currentTaskType = 'upcoming';
        } else if ("filter-note-completed-tasks" == currentTaskType) {
            currentTaskType = 'completed';
        }
    };

    self.notesDeleteLinkEvent = function () {
        $notePopup.hide();
        $("#view-note .popup-menu-backdrop").hide();
        setTimeout(function () {
            showActionDialog(Messages.Note.deleteNoteMessage, "Yes", self.deleteNote, "No", function () {
            });
        }, 100);
    };

    self.deleteNoteEvent = function () {
        if (window.localStorage.getItem("enableSave") == "true") {
            showActionDialog('Save Comment?', 'Yes', function () {
                self.deleteNote();
            }, "No", function () {
            });
        } else {
            self.deleteNote();
        }
    };

    self.deleteNote = function () {
        NoteController.delete(noteObject["_id"], function (data) {
            if (data == 0) {
                goBack();
            } else {
                alert(Messages.Note.deleteMessageErr);
                goBack();
            }
        });
    };

    self.editNote = function () {
        gotoPage({url: "editNote", param: {noteId: noteObject["_id"]}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
    };

    self.duplicateNote = function () {
        switch (noteObject.immediateParentObjectType.toLowerCase()) {
            case "company":
                gotoPage({url: "editNote", param: {noteId: noteObject["_id"], duplicate: true}}, {url: "viewContact", param: {contactId: noteObject.immediateParent,
                        contactType: noteObject.immediateParentObjectType}});
                break;
            case "person":
                gotoPage({url: "editNote", param: {noteId: noteObject["_id"], duplicate: true}}, {url: "viewContact", param: {contactId: noteObject.immediateParent,
                        contactType: noteObject.immediateParentObjectType}});
                break;
            case "task":
                gotoPage({url: "editNote", param: {noteId: noteObject["_id"], duplicate: true}}, {url: "viewTask", param: {id: noteObject.immediateParent}});
                break;
            case "deal":
                gotoPage({url: "editNote", param: {noteId: noteObject["_id"], duplicate: true}}, {url: "viewDeal", param: {id: noteObject.immediateParent}});
                break;
            case "case":
                gotoPage({url: "editNote", param: {noteId: noteObject["_id"], duplicate: true}}, {url: "viewCase", param: {caseId: noteObject.immediateParent}});
                break;
            default :
                alert("Error duplicating note!");
        }
    };

    self.drawNote = function(listViewId, data, append) {
      try{
          var $listView = $('#' + listViewId);
          if (data.length == 0 && !append) {
            $listView.empty();
          }
          var html = "";
          var i, max, len;
          var noteids = [];

          $(data).each(function (index, value) {
              noteids.push(new ObjectId(value._id));
          });

          if (connection) {
            var request = [
              {$match: {immediateParent: {$in: noteids}, objectType: 'Comment'}},
              {$group: {_id: '$immediateParent', cnt: {$sum: 1}}}
            ];

            ClientAPI.aggregate(request, function (err, countComments) {
                if (!err) {
                    if (data && data.length && data.length > 0) {
                        if (!append) {
                          $listView.empty();
                          self.drawListParams[listViewId]['start'] = offset;
                          self.drawListParams[listViewId]['offset'] = offset;
                        } else {
                            if (data.length > 0) {
                                self.drawListParams[listViewId]['start'] += self.drawListParams[listViewId]['offset'];
                            }
                        }

                        for (i = 0, max = data.length; i < max; i++) {
                              for (j = 0, len = countComments.length; j < len; j++) {
                                  if (data[i]._id == countComments[j]['_id']) {
                                      data[i]['commentCount'] = countComments[j].cnt;
                                      break;
                                  }
                              }
                              html += self.drawNoteItemData(data[i]);
                        }

                        if (append) {
                             $listView.append(html);
                         } else {
                             $listView.empty().append(html);
                         }
                         if ($listView.find('li').length == 0) {
                             $listView.append(emptyListHtml);
                         }
                    } else {
                      if ($listView.find('li').length == 0) {
                          $listView.append(emptyListHtml);
                      }
                    }
                    $listView.i18n();
                    hideLoadingIndikator();
                } else {
                  console.log(err);
                  hideLoadingIndikator();
                }
            });
          }
      } catch(e) {
          hideLoadingIndikator();
          console.log("ViewNoteFunctions.js -> self.drawNote -> \n" + e);
      }
    };

    self.drawNoteItemAvatar = function(itemData) {
      var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(ALL_USERS[itemData.owner].person) + '&fieldName=' + encodeURIComponent('picture');
      var imageData = '<i class="avatar md-person  md-3x"></i>';
      if (connection && ALL_USERS[itemData.owner]['avatar-url'] != null) {
          imageData = '<div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ');width:40px;"></div>';
      }
      return imageData;
    }

    self.drawNoteBody = function(itemData) {
      var body = "";
      if (itemData.note == null || itemData.note == "") {
          body = "No description";
      } else {
          body = itemData.note;
          body = htmlStrip(body);
          if (body.length > 80) {
              body = body.substr(0, 79);
          }
      }
      return body;
    }

    self.drawNoteCreateTime = function(itemData) {
      var dateTime = dateFormat(new Date(itemData.creationDate)) + " " + timeFormat(new Date(itemData.creationDate));
      return dateTime;
    }

    self.drawNotePrepareComment = function(itemData) {
      var commentsData = "";

      if (itemData['commentCount'] && itemData['commentCount'] > 0) {
           commentsData += '<a class="comment-container" noteId="'
           + itemData["_id"]
           + '" style="display: inline-block;"><span>Comments ('
           + itemData['commentCount']
           + ')</span></a>'
           + '<ul id="' + itemData["_id"] + '" class="comment-list" style="display: none;"></ul>';
       }

       return commentsData;
    };

    self.drawNoteItemData = function(itemData) {
        var html = "";
        try {
              html = "<li style='min-height:60px'>"
              html += "<a note-id='" + itemData['_id'] + "' class='note list-item-el'>";
              html += '<span class="is-contact-image" style="float:left">'
                      +  self.drawNoteItemAvatar(itemData)
                      + '</span>'
                  + '<div class="content-center" style="padding-left:60px;">'
                    + '<div>'
                        + '<span class="case-item-status-padding"><b>'+ ALL_USERS[itemData.owner].name + '</b></span>'
                        + '<span class="case-item-status-padding" data-i18n="note.createdNote"></span>'
                        + '<span class="deal-item-padding">'
                        +  self.drawNoteCreateTime(itemData)
                        + '</span>'
                    + '</div>'
                    + '<div class="title bold">'
                        + '<span>' + self.drawNoteBody(itemData) + '</span>'
                    + '</div>'
                  + '</div>'
                  + "</a>"
                  + self.drawNotePrepareComment(itemData)
                  + "</li>";
        } catch(e) {
            console.log(e);
        }
        return html;
    }


    //**********************************************//
    //*********************TASKS********************//
    //**********************************************//
    self.filterNoteTaskTypeEvent = function () {
        self.setCurrentTaskType($filterNoteTaskType.find('option:selected').val());
        self.getTasksForNote();
    };

    self.getTasksForNote = function () {
        if (noteObject != null) {
            if (connection) {
                var taskType = $filterNoteTaskType.find('option:selected').val();
                // get recently added tasks
                if (taskType == "filter-note-recent-tasks") {
                    if (connection) {
                        ClientAPI.findPaged({objectType: "Task", immediateParent: new ObjectId(noteObject['_id'])}, [["dueDate", -1]], 1, offset, function (err, items) {
                            if (!err) {
                                var tasks = [];
                                for (var i = 0; i < items.length; i++) {
                                    tasks.push(TaskController.encodeItem(items[i]));
                                }
                                TaskFunctions.drawListParams[listViewId] = {
                                    'start': 0,
                                    'frame': "",
                                    'taskType': "Upcoming",
                                    'offset': offset,
                                    parentId: noteId
                                };
                                TaskFunctions.drawTaskListView(listViewId, tasks, "Upcoming", false);
                                // delete button for child tasks
                                for (var i = 0; i < items.length; i++) {
                                    $("a[parentId='" + items[i]['_id'] + "']").remove();
                                }
                            }
                        });
                    }
                } else {
                    if (taskType == 'filter-note-upcoming-tasks') {
                        taskType = "Upcoming";
                    } else {
                        taskType = "Completed";
                    }
                    $("#" + listViewId).empty();
                    TaskFunctions.drawListParams[listViewId] = {
                        'start': 0,
                        'frame': "",
                        'taskType': taskType,
                        'searchValue': "",
                        'offset': offset,
                        'parentId': noteId
                    };

                    var dueDateSort = 1;
                    if ("Completed" == TaskFunctions.drawListParams[listViewId]['taskType']) {
                        dueDateSort = -1;
                    }
                    var sort = [
                        ["dueDate", dueDateSort]
                    ];
                    self.setChildObjectsCountNumber();
                    TaskController.syncTasksByParentId(noteObject["_id"], true, sort, 0, offset, function (data) {
                        TaskFunctions.drawTaskListView(listViewId, data, TaskFunctions.drawListParams[listViewId]['taskType'], false, false);
                        for (var i = 0; i < data.length; i++) {
                            (function (num) {
                                if (connection) {
                                    ClientAPI.findCount({
                                        objectType: "Task",
                                        immediateParent: new ObjectId(data[num].id.text)
                                    },
                                            function (err, count) {
                                                if (count == 0) {
                                                    $("a[parentId='" + data[num].id.text + "']").remove();
                                                } else {
                                                    $("a[parentId='" + data[num].id.text + "']").append(" (" + count + ")");
                                                }
                                            });
                                }
                            })(i);
                        }
                    });
                }
            }
        }
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
    };

    self.setCurrentTaskType = function (newVal) {
        switch (newVal) {
            case 'filter-note-upcoming-tasks':
                currentTaskType = 'upcoming';
                type = TASK_TYPE.UPCOMING;
                break;
            case 'filter-note-completed-tasks':
                currentTaskType = 'completed';
                type = TASK_TYPE.COMPLETED;
                break;
        }
    };

    //**********************************************//
    //*******************COMMENTS*******************//
    //**********************************************//
    self.saveCommentEvent = function () {
        if (body == "") {
            alert("Enter comment!");
            hideLoadingIndikator();
            return;
        }
        var body = $.trim($("#add-note-comment-area").val());
        CommentController.save(body, noteObject["_id"], function () {
            hideLoadingIndikator();
            $("#add-note-comment-area").val("");
            if (!noteObject.conversationActive) {
                self.appendMessage();
            }
        });
    };

    self.openComment = function () {

        gotoPage({url: "editComment", param: {commentId: $(this).attr('commentId')}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
    };

    self.findCommentsForNote = function () {
        showLoadingIndikator();
        if (noteObject) {
            if (noteObject["_id"] != null && connection) {
                CommentController.getAllByNoteId(noteObject["_id"], function (data) {
                    self.drawComments(data);
                    self.setChildObjectsCountNumber();
                });
            }
        }
    };

    self.appendMessage = function () {
        CommentController.getAllByNoteId(noteObject["_id"], function (data) {
            for (var i = 0; i < data.length; i++) {
                if (new Date(data[i]['created-at'].text) > new Date(lastCommentDate)) {
                    self.setChildObjectsCountNumber();
                    var html = self.drawComment(data[i]);
                    if (html != "") {
                        $viewNoteCommentsList.append(html);
                        self.loadUserAvatars([data[i]['author-id'].text]);
                    }
                    lastCommentDate = data[i]['created-at'].text;
                    break;
                }
            }
        });
    };

    self.broadcastMessage = function () {
        ChatAPI.onMessage(function (data) {
            if (data) {
                var commentForDraw = CommentController.encodeItem(data);
                var html = "";
                html = self.drawComment(commentForDraw);
                if (html != "") {
                    $viewNoteCommentsList.append(html);
                    self.loadUserAvatars([commentForDraw['author-id'].text]);
                }
            }
        });
    };

    self.setRandomImageColor = function () {
        var randIndex = Math.floor(Math.random() * (34 - 1 + 1) + 1);
        return colors[randIndex];
    };

    self.drawComment = function (data) {
        var html = "";
        var date = "";
        var time = "";
        //generate background color for chat users
        var colorImage = self.setRandomImageColor();
        if (userColorsHash[data['author-id'].text]) {
            colorImage = userColorsHash[data['author-id'].text];
        } else {
            for (var key in userColorsHash) {
                if (userColorsHash[key] == colorImage) {
                    colorImage = self.setRandomImageColor();
                }
            }
            userColorsHash[data['author-id'].text] = colorImage;
        }

        if (data['created-at']) {
            date = dateFormat(new Date(data['created-at'].text));
            time = timeFormat(new Date(data['created-at'].text));
        }

        var commentBody = data.body;
        if (window.localStorage.getItem('userId') == data['author-id'].text) {
            html += '<li class="me" style="position: relative;">';
        } else {
            html += '<li style="position: relative;">';
        }
        html += '<div class="avatar-icon" style="background-color:' + colorImage + '" userId="' + data['author-id'].text + '">'
                + '<img src="">'
                + '</div>';

        html += '<a href="#" class="comment list-item-el" style="padding: 0px; padding-bottom:5px;" commentId="' + data.id.text + '">';

        html += '<div class="messages">'
                + '<div class="subject">' + ALL_USERS[data['author-id'].text].name + '</div>'
                + commentBody;
        html += '<div style="font-size: 11px; padding-top: 2px; font-style: italic; color: blue;">' + date + ', ' + time + 'h </div>'
                + '</div>';
        html += '</a>'
                + '</li>';
        return html;

    };

    self.drawComments = function (data) {
        if (data && data.length > 0) {
            var authorIds = [];
            var html = '';
            lastCommentDate = data[data.length - 1]['created-at'].text;

            $('#notes-comments-link').text('Comments (' + data.length + ')');
            $viewNoteCommentsList.empty();
            for (var i = 0; i < data.length; i++) {
                authorIds.push(data[i]['author-id'].text);
                html += self.drawComment(data[i]);
            }

            if (data.length == 0) {
                $viewNoteCommentsList.append(emptyListHtml);
            } else {
                $viewNoteCommentsList.append(html);
            }
            $("#comment-list.overthrow").animate({scrollTop: $("#view-note-comments-list").height()});
            self.loadUserAvatars(authorIds);
            $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
        }
        hideLoadingIndikator();
    };

    self.loadUserAvatars = function (ids) {
        if (connection) {
            for (var i = 0; i < ids.length; i++) {
                ClientAPI.find({query: {'identity_id': ids[i]}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
                    if (!err) {
                        if (data != null && data.length > 0) {
                            var item = PeopleController.encodeItem(data[0]);
                            if (item['avatar-url']) {
                                try {
                                    var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(item.id.text) + '&fieldName=' + encodeURIComponent("picture");
                                    $('.avatar-icon[userId="' + item['identity_id'] + '"]>img').attr('src', fileUrl);
                                    $('.avatar-icon[userId="' + item['identity_id'] + '"]>img').attr('height', "40px");
                                } catch (e) {
                                    console.log("ViewContactFunctions.js -> self.loadCompanyGeneral -> \n" + e);
                                }
                            } else {
                                $('.avatar-icon[userId="' + item['identity_id'] + '"]').empty().append("<i class='md-person md-4x'></i>");
                            }
                        }
                    }
                });
            }
        }
    };

    //**********************************************//
    //******************ATTACHMENTS*****************//
    //**********************************************//
    self.chooseFromGallery = function () {
        $("#view-note .popup-menu-backdrop").hide();
        gotoPage({url: "fileSystem", param: {parentId: noteObject["_id"], parentType: "Note"}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
    };

    self.drawAttachments = function () {
        var html = "";
        var description = "";
        if (noteObject != null) {
            if (noteObject.fileAttachments != null && noteObject.fileAttachments.length != 0) {
                var IMAGES = ["png", "jpg", "gif", "jpeg"];
                var DOCUMENTS = ["doc", "pdf", "txt", "xls", "ppt", "docx", "log", "docm"];
                var ZIPS = ["zip", "tar", "rar", "gzip", "7z"];
                var MEDIA = ["mp3", "aac", "mp2", "wma", "m4a", "mp4", "wav"];
                var attachClass = "attachment-other";
                var attachType;
                for (var i = 0; i < noteObject.fileAttachments.length; i++) {
                    console.log(JSON.stringify(noteObject));
                    description = "";
                    if (noteObject.fileAttachments[i].file_description) {
                        description = noteObject.fileAttachments[i].file_description;
                    } else {
                        description = "";
                    }
                    var owner = "";
                    var date = "";
                    if (noteObject.fileAttachments[i].file_creator != null && noteObject.fileAttachments[i].file_creationDate != null) {
                        owner = 'By: ' + ALL_USERS[noteObject.fileAttachments[i].file_creator].name;
                        date = dateFormat(new Date(noteObject.fileAttachments[i].file_creationDate));
                    }

                    attachType = noteObject.fileAttachments[i].type_info;
                    attachClass = "attachment-other";
                    if (IMAGES.indexOf(attachType) != -1) {
                        attachClass = "attachment-image";
                    } else if (DOCUMENTS.indexOf(attachType) != -1) {
                        attachClass = "attachment-document";
                    } else if (MEDIA.indexOf(attachType) != -1) {
                        attachClass = "attachment-music";
                    } else if (ZIPS.indexOf(attachType) != -1) {
                        attachClass = "attachment-zip";
                    }
                    if (attachClass == "attachment-image") {
                        var fileName = noteObject.fileAttachments[i].file_name;
                        var fileUrl = ClientAPI.rootURL + '/api/db/getfilattchmnt?objId=' + encodeURIComponent(noteObject["_id"]) + '&attachmentName=' + encodeURIComponent(fileName);

                        html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                + '<div class="content-left" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                + '<div class="content-left-avatar" style="padding: 0px 10px;"><div class="content-avatar" style="background-image: url(' + fileUrl + ')"></div></div>'
                                + '</div>'
                                + '<div class="content-center" style="padding:10px 40px;">'
                                + '<div class="subject truncate">' + description + '</div>'
                                + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                + '<div class="attach-date">' + date + '</div>'
                                + '</div>'
                                + '</a>'
                                + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';

                    } else if (attachClass == "attachment-document") {
                        switch (attachType) {
                            case "doc":
                                html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                        + '<div class="content-left" style="padding: 0px 10px;text-indent:0px; margin-left:10px;">'
                                        + '<i class="fa fa-file-word-o fa-3x"></i>'
                                        + '</div>'
                                        + '<div class="content-center" style="padding-left:40px;">'
                                        + '<div class="subject truncate">' + description + '</div>'
                                        + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                        + '<div class="attach-date">' + date + '</div>'
                                        + '</div>'
                                        + '</a>'
                                        + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                                break;
                            case "docx":
                                html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                        + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                                        + '<i class="fa fa-file-word-o fa-3x"></i>'
                                        + '</div>'
                                        + '<div class="content-center" style="padding-left:40px;">'
                                        + '<div class="subject truncate">' + description + '</div>'
                                        + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                        + '<div class="attach-date">' + date + '</div>'
                                        + '</div>'
                                        + '</a>'
                                        + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                                break;
                            case "pdf":
                                html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                        + '<div class="content-left" style="padding: 0px 10px;text-indent:0px; margin-left:10px;">'
                                        + '<i class="fa fa-file-pdf-o fa-3x"></i>'
                                        + '</div>'
                                        + '<div class="content-center" style="padding-left:40px;">'
                                        + '<div class="subject truncate">' + description + '</div>'
                                        + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                        + '<div class="attach-date">' + date + '</div>'
                                        + '</div>'
                                        + '</a>'
                                        + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                                break;
                            case "xls":
                                html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                        + '<div class="content-left" style="padding: 0px 10px;text-indent:0px; margin-left:10px;">'
                                        + '<i class="fa fa-file-excel-o fa-3x"></i>'
                                        + '</div>'
                                        + '<div class="content-center" style="padding-left:40px;">'
                                        + '<div class="subject truncate">' + description + '</div>'
                                        + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                        + '<div class="attach-date">' + date + '</div>'
                                        + '</div>'
                                        + '</a>'
                                        + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                                break;
                            case "xlsx":
                                html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                        + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                                        + '<i class="fa fa-file-excel-o fa-3x"></i>'
                                        + '</div>'
                                        + '<div class="content-center" style="padding-left:40px;">'
                                        + '<div class="subject truncate">' + description + '</div>'
                                        + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                        + '<div class="attach-date">' + date + '</div>'
                                        + '</div>'
                                        + '</a>'
                                        + '<a href="" class="delete-item"  attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                                break;
                            case "ppt":
                                html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                        + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                                        + '<i class="fa fa-file-powerpoint-o fa-3x"></i>'
                                        + '</div>'
                                        + '<div class="content-center" style="padding-left:40px;">'
                                        + '<div class="subject truncate">' + description + '</div>'
                                        + '<div class="truncate" style="padding:5px 0px;">' + owner + '</div>'
                                        + '<div class="attach-date">' + date + '</div>'
                                        + '</div>'
                                        + '</a>'
                                        + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                                break;
                            default :
                                html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                        + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                                        + '<i class="fa fa-file-o fa-3x"></i>'
                                        + '</div>'
                                        + '<div class="content-center" style="padding-left:40px;">'
                                        + '<div class="subject truncate">' + description + '</div>'
                                        + '<div class="truncate" style="padding: 5px 0px;">' + owner + '</div>'
                                        + '<div class="attach-date">' + date + '</div>'
                                        + '</div>'
                                        + '</a>'
                                        + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';

                        }
                    } else if (attachType == "attachment-music") {
                        html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                                + '<i class="fa fa-music fa-3x"></i>'
                                + '</div>'
                                + '<div class="content-center" style="padding-left:40px;">'
                                + '<div class="subject truncate">' + description + '</div>'
                                + '<div class="truncate" style="padding: 5px 0px;">' + owner + '</div>'
                                + '<div class="attach-date">' + date + '</div>'
                                + '</div>'
                                + '</a>'
                                + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                    } else if (attachType == "attachment-zip") {
                        html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                                + '<i class="fa fa-file-archive-o fa-3x"></i>'
                                + '</div>'
                                + '<div class="content-center" style="padding-left:40px;">'
                                + '<div class="subject truncate">' + description + '</div>'
                                + '<div class="truncate" style="padding: 5px 0px;">' + owner + '</div>'
                                + '<div class="attach-date">' + date + '</div>'
                                + '</div>'
                                + '</a>'
                                + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                    } else {
                        html += '<li class="' + attachClass + '" style="position:relative;"><a href="#" style="height:60px; padding:10px 0px;" class="attachment" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '">'
                                + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                                + '<i class="fa fa-file-o fa-3x"></i>'
                                + '</div>'
                                + '<div class="content-center" style="padding-left:40px;">'
                                + '<div class="subject truncate">' + description + '</div>'
                                + '<div class="truncate" style="padding: 5px 0px;">' + owner + '</div>'
                                + '<div class="attach-date">' + date + '</div>'
                                + '</div>'
                                + '</a>'
                                + '<a href="" class="delete-item" attachmentId="' + noteObject.fileAttachments[i].file_id + '" attachmentName="' + noteObject.fileAttachments[i].file_name + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                    }
                }
            }

            var urlType = "link";
            if (noteObject.urlList != null && noteObject.urlList.length != 0) {
                for (var int = 0; int < noteObject.urlList.length; int++) {
                    html += '<li style="position:relative;" class="' + noteObject.urlList[int].urlType + '" url="' + noteObject.urlList[int].url + '" description="' + noteObject.urlList[int].urlDescription + '"><a style="height: 60px; padding: 10px 0px;" href="" class="attachment"  url="' + noteObject.urlList[int].url + '" description="' + noteObject.urlList[int].urlDescription + '">'
                            + '<div class="content-left" style="padding: 0px 10px; text-indent:0px; margin-left:10px;">'
                            + '<i class="md-link md-3x"></i>'
                            + '</div>'
                            + '<div class="content-center" style="padding-left:40px;">'
                            + '<div class="subject truncate">' + noteObject.urlList[int].urlDescription + '</div>'
                            + '<div class="truncate" style="padding: 5px 0px; max-width:90%;">' + noteObject.urlList[int].url + '</div>'
                            + '</div>'
                            + '</a>'
                            + '<a href="" class="delete-item" url="' + noteObject.urlList[int].url + '" description="' + noteObject.urlList[int].urlDescription + '" data-icon="false"><i class="fa fa-times fa-2x"></i></a></li>';
                }
            }
        }

        if (html == "") {
            html = emptyListHtml;
        }

        $viewNoteAttachmentList.empty().append(html);
        self.setChildObjectsCountNumber();
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
    };

    self.navigateToUpdateLink = function () {
        $("#view-note .popup-menu-backdrop").hide();
        $attachmentPopup.hide();
        gotoPage({url: "updateNoteLink", param:{noteId: noteId}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
    };

    self.validateURL = function (textval) {
        var urlregex = new RegExp("^(http|https|ftp)\://([a-zA-Z0-9\.\-]+(\:[a-zA-Z0-9\.&amp;%\$\-]+)*@)*((25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])|([a-zA-Z0-9\-]+\.)*[a-zA-Z0-9\-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(\:[0-9]+)*(/($|[a-zA-Z0-9\.\,\?\'\\\+&amp;%\$#\=~_\-]+))*$");
        return urlregex.test(textval);
    };

    self.deleteAttachment = function () {
        var urlAttachment = $(this).attr("url");
        if (urlAttachment != null && urlAttachment != "") {
            $(this).parent().remove();

            var links = [];
            $('.attachment-link').each(function (index) {
                links.push({
                    url: $(this).attr("url"),
                    urlDescription: $(this).attr("description"),
                    urlType: "link"
                });
            });

            NoteController.update(noteObject["_id"], noteObject.note, noteObject.accessList, null, links, function (err) {
                if (err == "error") {
                    hideLoadingIndikator();
                    alert("Invalid params");
                } else {
                    noteObject = err;
                    hideLoadingIndikator();
                    self.drawAttachments();
                }
            });
        } else {
            var fileName = $(this).attr('attachmentName');
            showActionDialog('Are you sure you want to remove this attachment?', 'Yes', function () {
                if (connection) {
                    ClientAPI.deleteFileAttachment(noteObject["_id"], fileName, function (err, data) {
                        ClientAPI.find({objectType: "Note", _id: new ObjectId(noteObject["_id"])}, null, function (err, data) {
                            if (data != null && data.length > 0) {
                                noteObject = data[0];
                                self.drawAttachments();
                                self.setChildObjectsCountNumber();
                            }
                        });
                    });
                }

                window.resolveLocalFileSystemURI(window.localStorage.getItem('folderPath') + fileName, function (fileEntry) {
                    fileEntry.remove(function (entry) {
                        console.log("fileSystem remove success!");
                    }, function (error) {
                        console.log("fileSystem remove error " + error.code);
                    });
                }, function (error) {
                    console.log("resolveLocalFileSystemURI error " + error.code);
                });
            }, "No", function () {
            });
        }
    };

    self.openAttach = function () {
        var urlAttachment = $(this).attr("url");
        if (urlAttachment != null && urlAttachment != "") {
            if (navigator.userAgent.match(/(iPad|iPhone)/)) {
            window.open(urlAttachment, '_blank', 'location=yes');
        } else {
                window.plugins.FileOpener.openFile(urlAttachment);
            }
        } else {
            var id = noteObject["_id"];
            var attachmentName = $(this).attr('attachmentName');
            if (id != null && attachmentName != null) {
                ViewNoteFunctions.openAttachment(id, attachmentName);
            }
        }
    };

    self.openAttachment = function (feedObjId, feedAttachName) {
        if (connection) {
            ClientAPI.find({_id: new ObjectId(feedObjId)}, null, function (err, data) {
                if (data != null && data[0] != null) {
                    var fileAttachments = data[0].fileAttachments;
                    var attachment = fileAttachments.filter(function (item) {
                        return item.file_name == feedAttachName;
                    });

                    if (attachment != null && attachment[0] != null) {
                        var objId;

                        if (typeof feedObjId == "string" && feedObjId != "") {
                            objId = feedObjId;
                        } else {
                            objId = noteObject["_id"];
                        }

                        var fileName = feedAttachName;
                        var fileUrl = ClientAPI.rootURL + '/api/db/getfilattchmnt?objId=' + encodeURIComponent(objId) + '&attachmentName=' + encodeURIComponent(fileName);

                        // ako ne postoji extenzija otvori file kao JPG
                        if (fileName.indexOf('.jpg') === -1 && fileName.indexOf('.jpeg') === -1 && fileName.indexOf('.gif') === -1 && fileName.indexOf('.png') === -1) {
                            fileName = fileName + ".jpg";
                        }

                        showLoadingIndikator();
                        var fileTransfer = new FileTransfer();

                        fileTransfer.download(fileUrl, cordova.file.externalDataDirectory + fileName, function (theFile) {
                            console.log(JSON.stringify(theFile));
                            hideLoadingIndikator();
                            if (window.localStorage.getItem("enableSave") == "true") {
                                showActionDialog("Do you want to open this file?", "Yes", function () {
                                    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                                        if (theFile != null && theFile.toNativeURL() != null && theFile.toNativeURL() != "") {
                                            window.open(theFile.toNativeURL(), "_blank");
                                        }
                                    } else {
                                        if (theFile != null && theFile.toURI() != null && theFile.toURI() != "") {
                                            window.plugins.FileOpener.openFile(theFile.toURI());
                                        }
                                    }
                                }, "No", function () {
                                });
                            } else {
                                if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                                    if (theFile != null && theFile.toNativeURL() != null && theFile.toNativeURL() != "") {
                                        window.open(theFile.toNativeURL(), "_blank");
                                    }
                                } else {
                                    if (theFile != null && theFile.toURI() != null && theFile.toURI() != "") {
                                        window.plugins.FileOpener.openFile(theFile.toURI());
                                    }
                                }
                            }

                        }, function (error) {
                            hideLoadingIndikator();
                            console.log("download error source " + error.source);
                            console.log("download error target " + error.target);
                            console.log("upload error code: " + error.code);
                        }, true);
                    }
                }
            });
        }
    };

    self.takePhoto = function () {
        $("#view-note .popup-menu-backdrop").hide();
        $attachmentPopup.hide();
        var pictureQuality = window.localStorage.getItem("pictureQuality");
        if (!pictureQuality) {
            window.localStorage.setItem("pictureQuality", "75");
            pictureQuality = "75";
        }
        var interval = setInterval(function () {
            navigator.camera.getPicture(function (mediaFiles) {
                showPromptDialog("Add discription for attachment!", "Prompt", "Add", function () {
                    var attachDesc = $("#prompt-text-input-popup-field").val();
                    if (attachDesc != "") {
                        getAF(function (err, af) {
                            var splitovano = mediaFiles.split("/");
                            var name = splitovano[splitovano.length - 1].split(".")[0];
                            var type = splitovano[splitovano.length - 1].split(".")[1];

                            var params = {};
                            params['_af'] = af;
                            objId = noteObject["_id"];
                            params['objId'] = objId;
                            params['typeInfo'] = type;
                            params['description'] = attachDesc;

                            var options = new FileUploadOptions();
                            options.fileKey = "attachment";
                            options.fileName = name + "." + type;
                            options.mimeType = "image/jpeg";
                            options.chunkedMode = false;
                            options.params = params;

                            var url = encodeURI(ClientAPI.rootURL + "/api/db/attachfile");
                            var ft = new FileTransfer();
                            ft.upload(mediaFiles, url, function (r) {
                                alert("Attachment is successfully uploaded!");
                                ClientAPI.find({objectType: "Note", _id: new ObjectId(noteObject["_id"])}, null, function (err, data) {
                                    if (data != null && data.length > 0) {
                                        noteObject = data[0];
                                        var setDraw = setInterval(function () {
                                            self.drawAttachments();
                                            clearInterval(setDraw);
                                        }, 100);
                                    }
                                });
                            }, function (error) {
                                alert("Error uploading picture!");
                                console.log("An error has occurred: Code = " + error.code);
                                console.log("upload error source " + error.source);
                                console.log("upload error target " + error.target);
                            }, options, true);
                        });
                    } else {
                        alert("Please add description!");
                    }
                }, "Cancel", function () {

                });
            }, function (e) {
                alert(e);
            }, {quality: pictureQuality, cameraDirection: Camera.Direction.BACK});
            clearInterval(interval);
        }, 100);
    };

    self.voiceNote = function () {
        $("#view-note .popup-menu-backdrop").hide();
        $attachmentPopup.hide();
        var options = {limit: 1, duration: 10};
        var interval = setInterval(function () {
            navigator.device.capture.captureAudio(function (mediaFiles) {
                showPromptDialog("Add description for attachment!", "Prompt", "Add", function () {
                    var i, len;
                    var attachDesc = $("#prompt-text-input-popup-field").val();

                    if (attachDesc != "") {
                        getAF(function (err, af) {
                            var params = {};
                            params['_af'] = af;
                            params['objId'] = noteObject["_id"];
                            params['typeInfo'] = mediaFiles[0].name.split(".")[1];
                            params['description'] = attachDesc;

                            var options = new FileUploadOptions();
                            options.fileKey = "attachment";
                            options.fileName = mediaFiles[0].name;
                            options.mimeType = mediaFiles[0].type;
                            options.chunkedMode = false;
                            options.headers = {
                                Connection: "close"
                            };
                            options.params = params;

                            var url = encodeURI(ClientAPI.rootURL + "/api/db/attachfile");
                            var ft = new FileTransfer();
                            ft.upload(mediaFiles[0].fullPath, url, function (r) {
                                if (r.responseCode == 200) {
                                    alert("Attachment is successfully uploaded!");
                                    ClientAPI.find({objectType: "Note", _id: new ObjectId(noteObject["_id"])}, null, function (err, data) {
                                        if (data != null && data.length > 0) {
                                            noteObject = data[0];
                                            var setDraw = setInterval(function () {
                                                self.drawAttachments();
                                                clearInterval(setDraw);
                                            }, 100);
                                        }
                                    });
                                } else {
                                    alert("#3 Error uploading file: " + r.responseCode + "; " + r.response + "; " + r.bytesSent + "; ");
                                }
                                console.log("Code = " + r.responseCode);
                                console.log("Response = " + JSON.stringify(r.response));
                                console.log("Sent = " + r.bytesSent);
                            }, function (error) {
                                alert("Error uploading picture!");
                                console.log("An error has occurred: Code = " + error.code);
                                console.log("upload error source " + error.source);
                                console.log("upload error target " + error.target);
                            }, options, true);
                        });
                    } else {
                        alert("Please add description!");
                    }
                }, "Cancel", function () {

                });
            }, function (error) {
                alert("#4 Error uploading file: " + error.code + "; " + error.source + "; " + error.target + "; ");
            }, options);
            clearInterval(interval);
        }, 100);
    };

    self.drawCommentList = function (noteId, callback) {
        var $commentList = $("#" + noteId);
        var html = "";
        CommentController.getAllByNoteId(noteId, function (data) {
            if (data) {
                for (var i = 0; i < data.length; i++) {
                    html += "<li>";
                    html += "<div class='title' style='padding-right: 10px; word-break: break-all;'>" + data[i].body + "</div>";
                    html += "<div>By: " + ALL_USERS[data[i]['author-id'].text].name + "</div>";
                }
                $commentList.empty().append(html);
                if (typeof callback === "function") {
                    callback();
                }
            }
        });
    };

    self.changeDueDateEvent = function () {
        var idTask = $(this).attr("taskid");
        var dueDate = $(this).attr("duedate");
        gotoPage({
            url: "changeDueDate",
            controller: ChangeDueDateFunctions,
            isModal: true,
            param: {taskId: idTask, dueDate: dueDate}
        }, {
            url: "viewNote",
            controller: ViewNoteFunctions,
            param: null
        });
    };

    self.completeTaskEvent = function () {
        var taskId = $(this).attr('taskId');
        gotoPage({
            url: "changeStatus",
            controller: ChangeStatusFunctions,
            isModal: true,
            param: {parentId: taskId, parentType: "Task"}
        }, {
            url: "viewNote",
            controller: ViewNoteFunctions,
            param: null
        });
    };

    self.getCurrentId = function(){
        if(noteObject){
            return noteObject['_id'];
        } else {
            return null;
        }
    };

    self.getChildTasks = function () {
        $("i", this).toggleClass("md-expand-more md-expand-less");
        var parentId = $(this).attr("parentId");
        $("ul[id='" + parentId + "']").attr('data-pageCount', 1);
        if (connection) {
            var request = {objectType: "Task", immediateParent: new ObjectId(parentId)};
            ClientAPI.findPaged(request, [["dueDate", 1]], 1, offset, function (err, items) {
                if (items && items.length > 0) {
                    var tasks = [];
                    for (var i = 0; i < items.length; i++) {
                        tasks.push(TaskController.encodeItem(items[i]));
                    }
                    TaskFunctions.drawSimpleTaskListView(parentId, tasks);
                    if(tasks.length < offset){
                        $("ul[id='" + parentId + "'] .load-task-child-btn").remove();
                    }
                    for (var i = 0; i < tasks.length; i++) {
                        (function (num) {
                            ClientAPI.findCount({
                                objectType: "Task",
                                immediateParent: new ObjectId(tasks[num].id.text)
                            },
                                    function (err, data) {
                                        if (!err) {
                                            if (data == 0) {
                                                $("a[parentId='" + tasks[num].id.text + "']").remove();
                                            } else {
                                                $("a[parentId='" + tasks[num].id.text + "']").append("(" + data + ")");
                                            }
                                        }
                                    });
                        })(i);
                    }
                    $("#view-note ul [id='" + parentId + "']").toggle();
                }
            });
        }
    };

    self.navigateToChildTasks = function () {
        var id = $(this).attr('taskId');
        var taskIds = [];
        var $parent = $(this).parent().parent();
        $parent.find('.child-task-item').each(function () {
            taskIds.push($(this).attr('taskId'));
        });
        var currentPage = $parent.attr('data-pageCount');
        currentPage = parseInt(currentPage);
        if(currentPage > 1){
            gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), childPage: currentPage + 1, offset: 30}}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
        } else {
             gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), start: 30, offset: 30}}}, {url: "viewNote", param: {noteId: noteObject["_id"]}});
        }
    };

    self.loadChildTaskEvent = function () {
        var taskId = $(this).parent().attr('id');
        var pageCount = $(this).parent().attr('data-pageCount');
        $(this).parent().attr('data-pageCount', ++pageCount);
        var $that = $(this);
        if (connection) {
            TaskFunctions.loadMoreChildTasks(taskId, pageCount, $that);
        }
    };

    self.parseNoteBody = function () {
        $viewNoteBodyDesc.find('a').on('click', function (e) {
            e.preventDefault();
            window.open($(this).attr('href'), '_system');
        });
    };

    return self;
}(ViewNoteFunctions || {}));
