$(document).on('pageinit', '#change-password', function () {
    ChangePasswordFunctions.init();
});

$(document).on('pageshow', '#change-password', function () {
    ChangePasswordFunctions.bindElementControls();
    ChangePasswordFunctions.clear();
});

$(document).on('pagehide', '#change-password', function () {
    ChangePasswordFunctions.unbindElementControls();
});

var ChangePasswordFunctions = (function (ChangePasswordFunctions)
{
    var self = ChangePasswordFunctions;

    self.init = function () {

    };

    self.clear = function () {
        $('#old-password').val("");
        $('#new-password').val("");
        $('#new-password-confirm').val("");
    };

    self.bindElementControls = function () {
        $(document).on('click', '#save-link', self.save);
        $(document).on('click', '#back-link', goBack);
        $(document).on('click', '#change-password-more-link', self.openChangePasswordPopup);
        $('#change-password .popup-menu-backdrop').on('click', function () {
            $('#change-password .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#change-password .additional-options', self.save);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#back-link');
        $(document).off('click', '#save-link');
        $(document).off('click', '#change-password-more-link');
        $('#change-password .popup-menu-backdrop').off('click');
        $(document).off('click', '#change-password .additional-options');
    };

    self.openChangePasswordPopup = function () {
        $('#change-password .popup-menu-backdrop').toggle();
        $('#change-password .advanced-menu').css('z-index', '20000');
        $('#change-password .advanced-menu').slideToggle('4000', 'swing');
    };

    self.save = function () {
        playSound("www/libs/blop.mp3");
        var oldPass = $.trim($('#old-password').val());
        var newPass = $.trim($('#new-password').val());
        var confirmedNewPass = $.trim($('#new-password-confirm').val());

        if (oldPass == null || oldPass == "") {
            alert("Enter old password!");
            return;
        }

        if (newPass == null || newPass == "") {
            alert("Enter new password!");
            return;
        }

        if (confirmedNewPass == null || confirmedNewPass == "") {
            alert("Please re-type new password!");
            return;
        }

        if (confirmedNewPass !== newPass) {
            alert("Passwords do not match!");
        }

        if (window.localStorage.getItem("enableSave") == "true") {
            showActionDialog('Change password?', 'Yes', function () {
                if (connection) {
                    ClientAPI.resetPassword(oldPass, newPass, function (err, data) {
                        alert(data.statusDesc);
                        if (data.statusCode == 0) {
                            self.clear();
                            goBack();
                        }
                    });
                }
            }, 'No', function () {
            });
        } else {
            if (connection) {
                ClientAPI.resetPassword(oldPass, newPass, function (err, data) {
                    alert(data.statusDesc);
                    if (data.statusCode == 0) {
                        self.clear();
                        goBack();
                    }
                });
            }
        }
    };

    return self;
}(ChangePasswordFunctions || {}));

