$(document).on('pageinit', '#domain', function () {
    DomainFunctions.bindElementControls();
});

$(document).on('pageshow', '#domain', function () {
    DomainFunctions.init();
});

$(document).on('pagehide', '#domain', function () {
    DomainFunctions.unbindElementControls();
});

var DomainFunctions = (function (DomainFunctions)
{
    var self = DomainFunctions;
    self.appSettings = {};

    self.init = function () {
        DomainController.findAll(function (data) {
            self.drawDomainList('#domain-list', data);
        });
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#domain #back-link');
        $(document).off('click', '#domain #new-domain-link');
        $(document).off('click', '#domain .domain-item');
        $(document).off('click', '#domain .unactive-domain');
//        $("#domain").off('iscroll_onpulldown', '.iscroll-wrapper');
//        $("#domain").off('iscroll_onpullup', '.iscroll-wrapper');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#domain #back-link', self.goBack);
        $(document).on('click', '#domain #new-domain-link', self.addItem);
        $(document).on('click', '#domain .domain-item', self.openItem);
        $(document).on('click', '#domain .unactive-domain', self.activeteDomainEvent);
//        $("#domain").on('iscroll_onpulldown', '.iscroll-wrapper', self.onPullDown);
//        $("#domain").on('iscroll_onpullup', '.iscroll-wrapper', self.onPullUp);
        $('body').on('submit', function (event) {
            event.preventDefault(); // cancel default form submit
            event.stopPropagation();
            return false;
        });
    };

    self.goBack = function () {
        goBack();
    };

    self.addItem = function () {
        gotoPage({url: 'editDomain', param: null}, {url: "domain", param: null});
    };

    self.openItem = function () {
        var id = $(this).attr('domain-id');
        gotoPage({url: "editDomain", param: {domainId: id}}, {url: "domain", param: null});
    };

    self.activeteDomainEvent = function () {
        var id = $(this).attr('domain-id');
        self.deactivateDomains();
        if (window.localStorage.getItem("enableSave")) {
            showActionDialog(Messages.Domain.changeDomain, "YES", function () {
                self.activeteDomain(id);
            }, "NO", function () {
                $("#domain .active-domain").prop("checked", true);
            });
        } else {
            self.activeteDomain(id);
        }
    };

    self.activeteDomain = function (id) {
        if (connection) {
            DomainController.findByColumn(id, 'id', function (item) {
                if (item[0].domain != window.localStorage.getItem('userDomain')) {
                    showLoadingIndikator();
                    var historyData = JSON.parse(window.localStorage.getItem('historyData'));
                    if (!historyData) {
                        historyData = [];
                    }

                    var i, index, max;
                    for (i = 0, max = historyData.length; i < max; i++) {
                        if (historyData[i].domain == window.localStorage.getItem('userDomain')) {
                            index = i;
                        }
                    }
                    if (index != null) {
                        historyData[index] = {
                            domain: window.localStorage.getItem('userDomain'),
                            enableSave: window.localStorage.getItem('enableSave'),
                            notificationStatus: window.localStorage.getItem('notificationStatus'),
                            pictureQuality: window.localStorage.getItem('pictureQuality'),
                            serverAddress: ClientAPI.rootURL,
                            port: window.localStorage.getItem('port'),
                            proxy: window.localStorage.getItem('proxy'),
                            sipDomain: window.localStorage.getItem('sipDomain'),
                            sipPassword: window.localStorage.getItem('sipPassword'),
                            sipUsername: window.localStorage.getItem('sipUsername'),
                            recent: []
                        };
                    } else {
                        historyData.push({
                            domain: window.localStorage.getItem('userDomain'),
                            enableSave: window.localStorage.getItem('enableSave'),
                            notificationStatus: window.localStorage.getItem('notificationStatus'),
                            pictureQuality: window.localStorage.getItem('pictureQuality'),
                            serverAddress: ClientAPI.rootURL,
                            port: window.localStorage.getItem('port'),
                            proxy: window.localStorage.getItem('proxy'),
                            sipDomain: window.localStorage.getItem('sipDomain'),
                            sipPassword: window.localStorage.getItem('sipPassword'),
                            sipUsername: window.localStorage.getItem('sipUsername'),
                            recent: []
                        });
                        index = historyData.length - 1;
                    }

                    db.selectAll(models.recentDBModel.name, function (data) {
                        if (data) {
                            var i, max;
                            for (i = 0, max = data.length; i < max; i++) {
                                historyData[index].recent.push(data[i].recent);
                            }
                        }
                        SettingsFunctions.clearAndRemove(['domainDBModel']);

                        window.localStorage.setItem('historyData', JSON.stringify(historyData));
                        ClientAPI.logout(function () {
                            setTimeout(function () {
                                ClientAPI.rootURL = item[0].server;
                                LoginController.login(item[0].domain, item[0].username, item[0].password, LoginFunctions.getUserContextServiceEvent);
                            }, 1000);
                        });
                    });
                }
            });
        } else {
            alert(Messages.Domain.errorActiveDomain);
        }
    };

    self.deactivateDomains = function () {
        DomainController.findAll(function (data) {
            for (var num in data) {
                $('input[domain-id="' + data[num].id + '"]').removeClass('active-domain').addClass('unactive-domain');
            }
        });
    };

    self.drawDomainList = function (viewId, items) {
        var $list = $(viewId);
        var htmlCode = "";
        var classType = "unactive-domain";
        if (items != null && items.length > 0) {
            for (item in items) {
                classType = "unactive-domain";
                if (items[item].domain === window.localStorage.getItem("userDomain")) {
                    classType = "active-domain";
                }

                htmlCode += "<li style='position: relative;'>";
                htmlCode += "<a href='#' class='domain-item' style='padding:10px;' domain-id='" + items[item].id + "'>";
                htmlCode += "<h1 style='font-size: 14px; margin-bottom:10px; font-weight: bold;'>";
                htmlCode += items[item].domain;
                htmlCode += "</h1>";
                htmlCode += "<h1 style='font-size: 14px;'>";
                htmlCode += items[item].server;
                htmlCode += "</h1>";
                htmlCode += "</a>";
                htmlCode += "<input type='radio' name='domain-option' domain-id='" + items[item].id + "' class='" + classType + " check-domain-button'/>";
                htmlCode += "</li>";
            }
        } else {
            htmlCode += emptyListHtml;
        }
        $list.empty().append(htmlCode);
        $("#domain .active-domain").prop("checked", true);
    };

    self.onPullDown = function (event, data) {
        self.init();
    };

    self.onPullUp = function (event, data) {

    };

    return self;
}(DomainFunctions || {}));