$(document).on('pageinit', '#edit-profil', function () {
    EditProfilFunctions.init();
    overrideBackButton = EditProfilFunctions.backLinkEvent;
});

$(document).on('pageshow', '#edit-profil', function () {
    EditProfilFunctions.bindElementControls();
    EditProfilFunctions.setFontSize();
    hideLoadingIndikator();
});

$(document).on('pagehide', '#edit-profil', function () {
    EditProfilFunctions.unbindElementControls();
});

var EditProfilFunctions = (function (EditProfilFunctions)
{
    var self = EditProfilFunctions;
    var OPERATION;
    var i, max;
    var profilType = null;
    var user = "";
    var $infoLink = null;
    var $templateLink = null;
    var $moreLink = null;
    var $templateAddLink = null;

    self.init = function () {
        $infoLink = $("#edit-profil-info-link");
        $templateLink = $("#edit-profil-template-link");
        $moreLink = $("#edit-profil #edit-profil-more-link");
        $templateAddLink = $("#edit-profil #add-template-link");
        $moreLink.show();
        self.checkIfUserIsContentAdmin();
        self.loadUpdateUserForm();
        self.initForm();
    };

    self.loadUpdateUserForm = function () {
        user = JSON.parse(window.localStorage.getItem("userProfile"));
        if (connection) {
            ClientAPI.find({query: {'identity_id': user.identity_id}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
                if (!err) {
                    if (data != null && data.length > 0) {
                        var item = PeopleController.encodeItem(data[0]);
                        if (item['avatar-url']) {
                            self.loadProfilAvatar(item.id.text, item['updated-at'].text);
                        }
                    }
                }
            });
        }

        var emailHTML = "", phoneHTML = "", webAddress = "", eMailAddresses, phoneNumbers, webAddresses;
        $('#autocomplete-company').parent().parent().parent().hide();

        if (user['user_profile'] != null) {
            $('#profil-first-name').val(user['user_profile'].firstName);
            $('#profil-last-name').val(user['user_profile'].lastName);
            $('#profil-background').val(user['user_profile'].info);
            $('#profil-reference-id').val(user['user_profile'].referenceId);
            eMailAddresses = user['user_profile'].eMailAddresses;
            phoneNumbers = user['user_profile'].phoneNumbers;
            webAddresses = user['user_profile'].webAddresses;
        }

        if (eMailAddresses != null) {
            for (i = 0, max = eMailAddresses.length; i < max; i++) {
                emailHTML += '<tr class="profil-email-row" email_id="">'
                        + '<td>' + self.getEmailLocation(eMailAddresses[i].eMailAddressType) + '</td>'
                        + '<td><input class="profil-email-adress" type="email" data-mini="true" class="full-width" value="' + eMailAddresses[i].eMailAddress + '"/></td>'
                        + '<td><a class="remove-profil-email" href=""> <i class="md-remove  md-2x"></i></a></td>'
                        + '</tr>';
            }
        }

        $('#edit-profil-email-table').append(emailHTML).trigger('create');

        if (phoneNumbers != null) {
            for (i = 0, max = phoneNumbers.length; i < max; i++) {
                phoneHTML += '<tr class="profil-phone-row" phone_id="">'
                        + '<td>' + self.getPhoneLocation(phoneNumbers[i].numberType) + '</td>'
                        + '<td><input class="profil-phone-number" type="tel" data-mini="true" value="' + phoneNumbers[i].phoneNumber + '" class="full-width"/></td>'
                        + '<td><a class="remove-profil-phone" href=""> <i class="md-remove  md-2x"></i></a></td>'
                        + '</tr>';
            }
        }

        $('#edit-profil-phone-table').append(phoneHTML).trigger('create');
        $('#edit-profil-permission').hide();

        if (webAddresses) {
            for (i = 0, max = webAddresses.length; i < max; i++) {
                webAddress += '<tr class="profil-web-row" email_id="">'
                        + '<td>' + self.getWebLocation(webAddresses[i].urlType) + '</td>'
                        + '<td><input class="profil-web-adress" type="text" data-mini="true" value="' + webAddresses[i].URL + '" class="full-width"/></td>'
                        + '<td><a class="remove-profil-web" href=""> <i class="md-remove  md-2x"></i></a></td>'
                        + '</tr>';
            }
        }

        //todo dodati web address
        $('#edit-profil-web-table').append(webAddress).trigger('create');
    };

    self.getEmailLocation = function (type) {
        var emailLocation = '<select class="profil-email-location" data-mini="true" data-theme="d">';
        if (type == 'Work') {
            emailLocation += '<option value="Work" selected="selected">Work</option>';
            emailLocation += '<option value="Home">Home</option>';
            emailLocation += '<option value="Other">Other</option>';
        } else if (type == 'Home') {
            emailLocation += '<option value="Work">Work</option>';
            emailLocation += '<option value="Home" selected="selected">Home</option>';
            emailLocation += '<option value="Other">Other</option>';
        } else if (type == 'Other') {
            emailLocation += '<option value="Work">Work</option>';
            emailLocation += '<option value="Home">Home</option>';
            emailLocation += '<option value="Other" selected="selected">Other</option>';
        } else {
            emailLocation += '<option value="Work">Work</option>';
            emailLocation += '<option value="Home">Home</option>';
            emailLocation += '<option value="Other">Other</option>';
        }
        emailLocation += '</select>';
        return emailLocation;
    };


    self.getWebLocation = function (type) {
        var webLocation = '<select class="profil-web-location" data-mini="true" data-theme="d">';
        if (type == 'Work') {
            webLocation += '<option value="Work" selected="selected">Work</option>';
            webLocation += '<option value="Personal">Personal</option>';
            webLocation += '<option value="Other">Other</option>   ';
        } else if (type == 'Personal') {
            webLocation += '<option value="Work">Work</option>';
            webLocation += '<option value="Personal" selected="selected">Personal</option>';
            webLocation += '<option value="Other">Other</option>';
        } else if (type == 'Other') {
            webLocation += '<option value="Work">Work</option>';
            webLocation += '<option value="Personal">Personal</option>';
            webLocation += '<option value="Other" selected="selected">Other</option>';
        } else {
            webLocation += '<option value="Work">Work</option>';
            webLocation += '<option value="Personal">Personal</option>';
            webLocation += '<option value="Other">Other</option>';
        }
        webLocation += '</select>';
        return webLocation;
    };

    self.getPhoneLocation = function (type) {
        var phoneLocation = '<select class="profil-phone-location" data-mini="true" data-theme="d">';

        if (type == 'Work') {
            phoneLocation += '<option value="Work" selected="selected">Work</option>';
            phoneLocation += '<option value="Mobile">Mobile</option>';
            phoneLocation += '<option value="Fax">Fax</option>';
            phoneLocation += '<option value="Pager">Pager</option>';
            phoneLocation += '<option value="Home">Home</option>';
            phoneLocation += '<option value="Skype">Skype</option>';
            phoneLocation += '<option value="Other">Other</option>';
        } else if (type == 'Mobile') {
            phoneLocation += '<option value="Work">Work</option>';
            phoneLocation += '<option value="Mobile" selected="selected">Mobile</option>';
            phoneLocation += '<option value="Fax">Fax</option>';
            phoneLocation += '<option value="Pager">Pager</option>';
            phoneLocation += '<option value="Home">Home</option>';
            phoneLocation += '<option value="Skype">Skype</option>';
            phoneLocation += '<option value="Other">Other</option>';
        } else if (type == 'Fax') {
            phoneLocation += '<option value="Work">Work</option>';
            phoneLocation += '<option value="Mobile">Mobile</option>';
            phoneLocation += '<option value="Fax" selected="selected">Fax</option>';
            phoneLocation += '<option value="Pager">Pager</option>';
            phoneLocation += '<option value="Home">Home</option>';
            phoneLocation += '<option value="Skype">Skype</option>';
            phoneLocation += '<option value="Other">Other</option>';
        } else if (type == 'Pager') {
            phoneLocation += '<option value="Work">Work</option>';
            phoneLocation += '<option value="Mobile">Mobile</option>';
            phoneLocation += '<option value="Fax">Fax</option>';
            phoneLocation += '<option value="Pager" selected="selected">Pager</option>';
            phoneLocation += '<option value="Home">Home</option>';
            phoneLocation += '<option value="Skype">Skype</option>';
            phoneLocation += '<option value="Other">Other</option>';
        } else if (type == 'Home') {
            phoneLocation += '<option value="Work">Work</option>';
            phoneLocation += '<option value="Mobile">Mobile</option>';
            phoneLocation += '<option value="Fax">Fax</option>';
            phoneLocation += '<option value="Pager">Pager</option>';
            phoneLocation += '<option value="Home" selected="selected">Home</option>';
            phoneLocation += '<option value="Skype">Skype</option>';
            phoneLocation += '<option value="Other">Other</option>';
        } else if (type == 'Skype') {
            phoneLocation += '<option value="Work">Work</option>';
            phoneLocation += '<option value="Mobile">Mobile</option>';
            phoneLocation += '<option value="Fax">Fax</option>';
            phoneLocation += '<option value="Pager">Pager</option>';
            phoneLocation += '<option value="Home">Home</option>';
            phoneLocation += '<option value="Skype" selected="selected">Skype</option>';
            phoneLocation += '<option value="Other">Other</option>';
        } else if (type == 'Other') {
            phoneLocation += '<option value="Work">Work</option>';
            phoneLocation += '<option value="Mobile">Mobile</option>';
            phoneLocation += '<option value="Fax">Fax</option>';
            phoneLocation += '<option value="Pager">Pager</option>';
            phoneLocation += '<option value="Home">Home</option>';
            phoneLocation += '<option value="Skype">Skype</option>';
            phoneLocation += '<option value="Other" selected="selected">Other</option>';
        } else {
            phoneLocation += '<option value="Work">Work</option>';
            phoneLocation += '<option value="Mobile">Mobile</option>';
            phoneLocation += '<op tion value="Fax">Fax</option>';
            phoneLocation += '<option value="Pager">Pager</option>';
            phoneLocation += '<option value="Home">Home</option>';
            phoneLocation += '<option value="Skype">Skype</option>';
            phoneLocation += '<option value="Other">Other</option>';
        }

        phoneLocation += '</select>';

        return phoneLocation;
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#edit-profil-phone-table .remove-profil-phone');
        $(document).off('click', '#edit-profil-phone-table .remove-profil-email');
        $(document).off('click', '#edit-profil-phone-table .remove-profil-web');
        $(document).off('click', '#back-link');
        $(document).off('keypress', '.profil-phone-number');
        $(document).off('click', '#edit-profil-more-link');
        $('#edit-profil .popup-menu-backdrop').off('click');
        $('.advanced-menu #add-contact').off("click");
        $(document).off('click', '#edit-user-avatar');
        $(document).off('click', '#from-gallery-upload');
        $(document).off('click', '#photo-upload');
        $(document).off('click', '#edit-profil .additional-options');
        $(document).off('click', '#edit-profil #edit-profil-info-link');
        $(document).off('click', '#edit-profil #edit-profil-template-link');
        $(document).off('click', '#edit-profil .btn-remove-template');
        $(document).off('click', '#edit-profil #add-template-link');
        $(document).off('click', '#edit-profil .template-element');
    };

    self.bindElementControls = function () {
        $(document).on('click', '.remove-profil-phone', self.removeProfilAddress);
        $(document).on('click', '.remove-profil-email', self.removeProfilAddress);
        $(document).on('click', '.remove-profil-web', self.removeProfilAddress);
        $(document).on('click', '#back-link', goBack);
        $(document).on('keypress', '.profil-phone-number', self.validationTel);
        $(document).on('click', '#edit-profil-more-link', self.openEditProfilPopup);
        $(document).on('click', '#edit-user-avatar', self.openAttachPopup);
        $(document).on('click', '#from-gallery-upload', self.uploadUserProfilAvatar);
        $(document).on('click', '#photo-upload', self.uploadCameraPicture);
        $('#edit-profil .popup-menu-backdrop').on('click', function () {
            $('#edit-profil .advanced-menu').hide();
            $(this).hide();
        });
        $(document).on('click', '#edit-profil .additional-options', self.profilSaveButton);

        $('#add-profil-phone').on('click', self.addProfilPhone);
        $('#add-profil-email').on('click', self.addProfilEmail);
        $('#add-profil-web').on('click', self.addProfilWebAddress);
        $('.advanced-menu #add-contact').on('click', self.profilSaveButton);
        $(document).on('click', '#edit-profil #edit-profil-info-link', self.navigateToInfo);
        $(document).on('click', '#edit-profil #edit-profil-template-link', self.templateLinkEvent);
        $(document).on('click', '#edit-profil .btn-remove-template', self.deleteTemplateItem);
        $(document).on('click', '#edit-profil #add-template-link', self.navigateToEditTemplate);
        $(document).on('click', '#edit-profil .template-element', self.loadTemplate);
    };

    self.openAttachPopup = function () {
        $("#upload-avatar-popup").popup("open");
        $("#upload-avatar-popup").popup("reposition", {y: 200});
    };

    self.uploadUserProfilAvatar = function () {
        if (connection) {
            ClientAPI.find({query: {'identity_id': user.identity_id}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
                if (!err) {

                    if (data != null && data.length > 0) {
                        var item = PeopleController.encodeItem(data[0]);


                        if (navigator.userAgent.match(/(iPad|iPhone)/)) {
                            navigator.camera.getPicture(function (mediaFiles) {
                                getAF(function (err, af) {
                                    var params = {};
                                    params['_af'] = af;
                                    params['objId'] = item.id.text;
                                    params['fieldName'] = "picture";

                                    var splitovano = mediaFiles.split("/");
                                    var name = splitovano[splitovano.length - 1].split(".")[0];
                                    var options = new FileUploadOptions();
                                    options.fileKey = "attachment";
                                    options.fileName = name;
                                    options.mimeType = "image/jpeg";
                                    options.chunkedMode = false;
                                    options.params = params;

                                    var url = encodeURI(ClientAPI.rootURL + "/api/db/uploadimg");
                                    var ft = new FileTransfer();
                                    ft.upload(mediaFiles, url, function (r) {
                                        if (r.responseCode == 200) {
                                            alert("Picture is successfully uploaded!");
                                            $('#avatar').attr('src', mediaFiles);
                                            self.loadProfilAvatar(item.id.text, item['updated-at'].text);
                                        } else {
                                            alert("Error uploading file!");
                                        }
                                        console.log("Code = " + r.responseCode);
                                        console.log("Response = " + JSON.stringify(r.response));
                                        console.log("Sent = " + r.bytesSent);
                                    }, function (error) {
                                        alert("Error uploading picture!");
                                        console.log("An error has occurred: Code = " + error.code);
                                        console.log("upload error source " + error.source);
                                        console.log("upload error target " + error.target);
                                    }, options, true);
                                });
                            }, function (e) {
                                alert(e);
                            }, {quality: 75, allowEdit: true, destinationType: Camera.DestinationType.FILE_URI, sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM});
                        } else {
                            gotoPage({url: "fileSystem", param: {parentId: item.id.text, parentType: "Contact", fileExtension: ["jpg", "png", "jpeg", "gif"]}}, {url: "editProfil", param: null});
                        }
                    }
                }
            });
        }
    };

    self.uploadCameraPicture = function () {
        if (connection) {
            ClientAPI.find({query: {'identity_id': user.identity_id}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
                if (!err) {

                    if (data != null && data.length > 0) {
                        var item = PeopleController.encodeItem(data[0]);
                        var pictureQuality = window.localStorage.getItem("pictureQuality");
                        if (!pictureQuality) {
                            window.localStorage.setItem("pictureQuality", "75");
                            pictureQuality = "75";
                        }
                        navigator.camera.getPicture(function (mediaFiles) {
                            getAF(function (err, af) {
                                var params = new Object();
                                params['_af'] = af;
                                params['objId'] = item.id.text;
                                params['fieldName'] = "picture";

                                var splitovano = mediaFiles.split("/");
                                var name = splitovano[splitovano.length - 1].split(".")[0];
                                var options = new FileUploadOptions();
                                options.fileKey = "attachment";
                                options.fileName = name;
                                options.mimeType = "image/jpeg";
                                options.chunkedMode = false;
                                options.params = params;

                                var url = encodeURI(ClientAPI.rootURL + "/api/db/uploadimg");
                                var ft = new FileTransfer();
                                ft.upload(mediaFiles, url, function (r) {
                                    if (r.responseCode == 200) {
                                        alert("Picture is successfully uploaded!");
                                        self.loadProfilAvatar(item.id.text, item['updated-at'].text);
                                    } else {
                                        alert("Error uploading file!");
                                    }
                                    console.log("Code = " + r.responseCode);
                                    console.log("Response = " + JSON.stringify(r.response));
                                    console.log("Sent = " + r.bytesSent);
                                }, function (error) {
                                    alert("Error uploading picture!");
                                    console.log("An error has occurred: Code = " + error.code);
                                    console.log("upload error source " + error.source);
                                    console.log("upload error target " + error.target);
                                }, options, true);
                            });
                        }, function (e) {
                            alert(e);
                        }, {quality: pictureQuality, cameraDirection: Camera.Direction.BACK});

                    }
                }
            });
        }
    };

    self.loadProfilAvatar = function (objectId, modificationDate) {
        try {
            var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(objectId) + '&fieldName=' + encodeURIComponent("picture") + '&v=' + new Date(modificationDate).getTime();
            $("#edit-profil .avatar-container").html('<div id="edit-user-avatar" style="width:42px;"><div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ')"></div></div>');
        } catch (e) {
            console.log("ViewContactFunctions.js -> self.loadCompanyGeneral -> \n" + e);
        }
    };

    self.openEditProfilPopup = function () {
        $('#edit-profil .popup-menu-backdrop').toggle();
        $('#edit-profil .advanced-menu').css('z-index', '20000');
        $('#edit-profil .advanced-menu').slideToggle('4000', 'swing');
    };


    self.setFontSize = function () {
        $('.profil-phone-number').each(function (index, value) {
            $(value).parent().css('padding', 'inherit');
        });
        $('.profil-email-adress').each(function (index, value) {
            $(value).parent().css('padding', 'inherit');
        });
        $('.profil-web-adress').each(function (index, value) {
            $(value).parent().css('padding', 'inherit');
        });
    };

    self.validationTel = function (event) {
        return (event.charCode >= 48 && event.charCode <= 57) || event.charCode == 43;
    };

    self.removeProfilAddress = function (evt) {
        $(evt.currentTarget).parent().parent().remove();
    };

    // event dodavanje tel broja
    self.addProfilPhone = function () {
        $('#edit-profil-phone-table').append(
                '<tr class="profil-phone-row" phone_id="">'
                + '<td>' + self.getPhoneLocation() + '</td>'
                + '<td><input class="profil-phone-number" type="tel" data-mini="true" value="" class="full-width"/>'
                + '</td>'
                + '<td><a class="remove-profil-phone" href=""> <i class="md-remove  md-2x"></i></a></td>'
                + '</tr>');

        // Trigger create table
        $('#edit-profil-phone-table').trigger('create');
        self.setFontSize();
    };

    // event dodavanje email-a
    self.addProfilEmail = function () {
        $('#edit-profil-email-table').append(
                '<tr class="profil-email-row" email_id="">'
                + '<td>' + self.getEmailLocation() + '</td>'
                + '<td><input class="profil-email-adress" type="email" data-mini="true" value="" class="full-width"/></td>'
                + '<td><a class="remove-profil-email" href=""> <i class="md-remove  md-2x"></i></a></td>'
                + '</tr>');

        // Trigger create table
        $('#edit-profil-email-table').trigger('create');
        self.setFontSize();
    };

    // event dodavanje web addresse
    self.addProfilWebAddress = function () {
        $('#edit-profil-web-table').append(
                '<tr class="profil-web-row" webAddress_id="">'
                + '<td>' + self.getWebLocation() + '</td>'
                + '<td><input class="profil-web-adress" type="text" data-mini="true" value="" class="full-width"/></td>'
                + '<td><a class="remove-profil-web" href=""> <i class="md-remove  md-2x"></i></a></td>'
                + '</tr>');

        // Trigger create table
        $('#edit-profil-web-table').trigger('create');
        self.setFontSize();
    };

    self.initForm = function () {
        if (OPERATION == "EDIT") {
            $('#profil-delete-button').show();
        } else {
            $('#profil-delete-button').hide();
        }

        if (profilType == 'Person' || profilType == 'People') {
            $('#edit-profil-person').show();
            $('#edit-profil-company').hide();
            $("#profil-reference-id").parent().parent().show();
        } else if (profilType === 'Company') {
            $('#edit-profil-company').show();
            $('#edit-profil-person').hide();
            $("#profil-reference-id").parent().parent().hide();
        }
    };

    self.profilSaveButton = function () {
        $(this).addClass('not-clickable');
        self.updateUserProfil();
    };


    self.updateUserProfil = function () {
        playSound("www/libs/blop.mp3");
        var firstName = $.trim($('#profil-first-name').val());
        var lastName = $.trim($('#profil-last-name').val());
        var info = $.trim($('#profil-background').val());
        var referenceId = $.trim($('#profil-reference-id').val());
        var phones = [];
        var emails = [];
        var webs = [];

        if (firstName == null || firstName == "") {
            alert("First name field is empty!");
            return;
        }

        if (lastName == null || lastName == "") {
            alert("Last name field is empty!");
            return;
        }

        var profilPhoneRows = $('.profil-phone-row');
        for (i = 0; i < profilPhoneRows.length; i++) {
            phones.push({phoneNumber: $.trim($(profilPhoneRows[i]).find('.profil-phone-number').val()), numberType: $.trim($(profilPhoneRows[i]).find('.profil-phone-location option:selected').val())});
        }

        var profilEmailRows = $('.profil-email-row');
        var valideMail = true;
        for (i = 0; i < profilEmailRows.length; i++) {
            var value = $(profilEmailRows[i]).find('.profil-email-adress').val();
            var temp = patternForMail.exec(value);

            if (temp != null) {
                valideMail = true;
                emails.push({eMailAddress: $.trim($(profilEmailRows[i]).find('.profil-email-adress').val()), eMailAddressType: $.trim($(profilEmailRows[i]).find('.profil-email-location option:selected').val())});
            } else {
                valideMail = false;
                alert(emailMessageIncorrect(value));
                break;
            }
        }

        if (!valideMail) {
            return;
        }

        var profilWebRows = $('.profil-web-row');
        for (i = 0, max = profilWebRows.length; i < max; i++) {
            webs.push({URL: $.trim($(profilWebRows[i]).find('.profil-web-adress').val()), urlType: $.trim($(profilWebRows[i]).find('.profil-web-location option:selected').val())});
        }

        if (window.localStorage.getItem("enableSave") == "true") {
            showActionDialog(Messages.Profil.saveProfilMessage, 'Yes', function () {
                ProfilController.save(firstName, lastName, phones, emails, webs, info, referenceId, function (data) {
                    goBack();
                });
            }, "No", function () {
            });
        } else {
            ProfilController.save(firstName, lastName, phones, emails, webs, info, referenceId, function (data) {
                goBack();
            });
        }
    };

    self.navigateToInfo = function () {
        $moreLink.show();
        $templateAddLink.hide();
        $infoLink.addClass('btn-active');
        $templateLink.removeClass('btn-active');
        $("#edit-profil .profil-info").show();
        $("#edit-profil .template-list").hide();
        $("#edit-profil .additional-options").show();
    };

    self.templateLinkEvent = function () {
        $("#edit-profil .profil-info").hide();
        $("#edit-profil .template-list").show();
        $("#edit-profil .template-list").empty();
        $templateAddLink.show();
        $moreLink.hide();
        $("#edit-profil .additional-options").hide();
        $templateLink.addClass('btn-active');
        $infoLink.removeClass('btn-active');
        if (connection) {
            ClientAPI.getTemplatesForType({type: "Template"}, function (err, data) {
                if (data && data.length > 0) {
                    var html = "";
                    for (var i = 0; i < data.length; i++) {
                        html += self.drawTemplateItem(data[i], true);
                    }
                    if (html != "") {
                        $("#edit-profil .template-list").append(html);
                    }
                } else {
                    $("#edit-profil .template-list").append('<li class="center empty-list">Empty list</li>');
                }
            });
        }
    };

    self.drawTemplateItem = function (item, toDelete) {
        var html = "";
        html += "<li style='min-height: 50px; position: relative;'>"
                + "<a class='template-element' style='padding: 10px;' href='' templateObj = '" + JSON.stringify(item) + "'>"
                + "<div class='title truncate' style='margin-right: 30px;'>" + item.templateName + "</div>";
        if (toDelete) {
            html += "<div class='fg-red'>" + dateTimeFormatWithAt(new Date(item.modificationDate), true) + "</div>";
        }
        html += "</a>";
        if (toDelete) {
            html += "<span class='btn-remove-template' templateObj='" + JSON.stringify(item) + "' style='position: absolute; right: 10px; bottom: 2px; cursor: pointer;'><i class='md-delete md-2x'></i></span>";
        }
        html += "</li>";
        return html;
    };

    self.deleteTemplateItem = function () {
        var templateObj = $(this).attr('templateObj');
        templateObj = JSON.parse(templateObj);
        if (connection) {
            if (templateObj) {
                ClientAPI.removeTemplate(templateObj, function (err, data) {
                    if (!err && data) {
//                        $(".template-list a[templateId='" + templateId + "']").closest('li').remove();
                        self.templateLinkEvent();
                    }
                });
            }
        }
    };

    self.navigateToEditTemplate = function () {
        gotoPage({url: "editTemplate", param: null}, {url: "editProfil", param: null});
    };

    self.loadTemplate = function () {
        var template = $(this).attr("templateObj");
        if (template) {
            gotoPage({url: "editTemplate", param: {template: template}}, {url: "editProfil", param: null});
        }
    };

    self.checkIfUserIsContentAdmin = function () {
        if (connection) {
            ClientAPI.getUserInfo(function (err, data) {
                if (!err) {
                    var userProfile = data.userProfile;
                    var isContentAdmin = userProfile.domainMembership.groups.some(function (group) {
                        return group === ('ContentAdmins@' + userProfile.app_domain_name);
                    });
                    if (isContentAdmin) {
                        $templateLink.show();
                    }
                }
            });
        }
    };

    return self;
}(EditProfilFunctions || {}));
