$(document).on('pageinit', '#invite', function () {
    InviteFunctions.init();
});

$(document).on('pageshow', '#invite', function () {
    InviteFunctions.bindElementControls();
});

$(document).on('pagehide', '#invite', function () {
    InviteFunctions.unbindElementControls();
});

var InviteFunctions = (function (InviteFunctions) {
    var self = InviteFunctions;

    self.init = function () {
        self.appendDefaultMsg();
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#invite-back-link');
        $(document).off('click', '#invite-save-link');
        $(document).off('click', '#invite-more-link');
        $('#invite .popup-menu-backdrop').off('click');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#invite-back-link', goBack);
        $(document).on('click', '#invite-save-link', self.inviteSaveButton);
        $(document).on('click', '#invite-more-link', self.openInvitePopup);
        $('#invite .popup-menu-backdrop').on('click', function () {
            $('#invite .advanced-menu').hide();
            $(this).hide();
        });

    };

    self.inviteSaveButton = function () {
        var email = $("#invite #email").val();
        var inviteMsg = $("#invite #invite-msg").val();
        
        var inviteObject = {
            message: inviteMsg,
            email: email
        };
        
        if(!email){
            alert("Enter email!");
            self.closeSaveOption();
            return;
        }
        
        if(!inviteMsg){
            alert("Enter message!");
            self.closeSaveOption();
            return;
        }

        if (validateEmail(email)) {
            if (connection) {
                ClientAPI.inviteUser(inviteObject, function (err, data) {
                    if (!err) {
                        goBack();
                    } else {
                        alert("Error: #" + err.code + ", status:" + err.status);
                    }
                });
            }
        } else {
            alert("Invalid email!");
            self.closeSaveOption();
        }
    };

    self.openInvitePopup = function () {
        $('#invite .popup-menu-backdrop').toggle();
        $('#invite .advanced-menu').css('z-index', '20000');
        $('#invite .advanced-menu').slideToggle('4000', 'swing');
    };
    
   function validateEmail(email) {
        var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
    };
    
    self.appendDefaultMsg = function(){
        var msg = window.localStorage.getItem("userDataName") + " invited you to use Beezify solution.";
        $("#invite #invite-msg").val(msg);
    };
    
    self.closeSaveOption = function () {
        $('#invite .advanced-menu').hide();
        $('#invite .popup-menu-backdrop').hide();
    };

    return self;
}(InviteFunctions || {}));			