$(document).on('pageinit', '#myGroup', function () {
    MyGroupFunctions.init();

});

$(document).on('pageshow', '#myGroup', function () {
    MyGroupFunctions.bindElementControls();
    MyGroupFunctions.setConnectionMode();
    $("#myGroup .title-h1").html(window.localStorage.getItem("userDataName"));
});

$(document).on('pagehide', '#myGroup', function () {
    MyGroupFunctions.unbindElementControls();
});

var MyGroupFunctions = (function (MyGroupFunctions) {
    var self = MyGroupFunctions;
    var users = null;
    var userId = null;
    var phoneNumber;
    var fullName;
    var userIdForTasks;
    var clicked;
    var $myGroup;
    var currentUser;
    var contactIdfromContactView = null;
    var contactTypefromContactView = null;
    var viewContactSipName = null;
    var currentTab = 'USERS';
    self.favoriteMap = {};
    self.currentFilterType = "filter-all-users";
    self.findTime = null;
    self.findTimeSip = null;
    var $filterUserType = null;

    self.init = function () {
        //hide call list option for iOS devices
        removeCallListForIOS("main-nav-list", "myGroup", "call-list-link");
        $myGroup = $("#myGroup");
        self.checkIfUserIsDomainAdmin();
        FavoriteController.findAllMapByTypes(["User"], function(favoriteMap){
          self.favoriteMap = favoriteMap;
          self.drawUsers();
        });
        self.drawTeamGroups();

        $("#open-edit-note-view").hide();
        self.navigateToGeneral();
        NavigationController.loadUserInfo('myGroup');
        $myGroup.i18n();
        $filterUserType = $("#filter-user-type");
        self.filterTypeEvent();
    };

    self.bindElementControls = function () {
      $(document).on('click', '#dashboard-link', self.dashboardLinkEvent);
      $(document).on('click', '#contacts-link', self.contactsLinkEvent);
      $(document).on('click', '#call-log-link', self.callLogLinkEvent);
      $(document).on('click', '#tasks-link', self.tasksLinkEvent);
      $(document).on('click', '#case-link', self.caseLinkEvent);
      $(document).on('click', '#deals-link', self.dealsLinkEvent);
      $(document).on('click', '#settings-link', self.settingsLinkEvent);
      $(document).on('click', '#drafts-link', self.draftLinkEvent);
      $(document).on('click', '#menu-link', self.menuLinkEvent);
      $(document).on('click', '#mygroup-link', self.menuLinkEvent);
      $(document).on('click', '#users-list .user', self.openUser);
      $(document).on('click', '#users-list .call-sms-user', self.callUser);
      $(document).on('click', '#set-user-call-logs', self.callLogEvent);
      $(document).on('click', '#refresh-link', self.refreshMyGroup);
      // $(document).on('change', '#myGroup input[type=radio][name=sip-radio]', self.setSipStatus);
      $(document).on('click', '#sip-messages-link', self.sipMessagesLink);
      $("input", '#myGroup').on('keyup', self.searchInputEvent);
      $(document).on('click', '#users-list .contact-case-icon', self.openUser);
      $(document).on('click', '#users-list .contact-task-icon', self.openUser);
      $(document).on('click', '#users-list .contact-deal-icon', self.openUser);
      $(document).on('click', '#myGroup .float-add-action', self.openInvatePage);

      $(document).on('click', '#about-link', self.gotoAbout);
      $("#myGroup .app-user").on('click', self.gotoProfilPage);
      $("#myGroup .domain-link-info").on('click', self.gotoDomainPage);
      $(document).on('click', '#myGroup #call-list-link', function () {
          gotoPage({url: "callLog", param: null}, {url: "myGroup", param: null});
      });

      $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
      $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

      $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
          $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
          $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
      });

      $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
          $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
          $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
      });
      $('body').on('submit', function (event) {
          event.preventDefault(); // cancel default form submit
          event.stopPropagation();
          return false;
      });

      $('.backdrop').on('click', function () {
          $('html').removeClass('sidebar-left-in');
      });

      $("body").on('swipeleft', "#myGroup .sidebar", function () {
          if ($("html").hasClass("sidebar-left-in")) {
              $("html").removeClass("sidebar-left-in");
          }
      });

      $(document).on('click', '#myGroup #team-groups', self.addGroupLink);
      $(document).on('click', '#myGroup #add-group-link', self.gotoEditGroup);
      $(document).on('click', '#myGroup #team-users', function () {
          currentTab = 'USERS';
          self.navigateToGeneral();
      });
      $(document).on('click', '#myGroup .group-list-item', function () {
          var groupName = $(this).attr("id");
          var groupDesc = $(this).find('.subtitle').text();
          currentTab = 'GROUPS';
          gotoPage({url: "editGroup", param: {groupName: groupName, groupDescription: groupDesc}}, {url: "myGroup", param: null});
          ;
      });
      $(document).on('click', '#myGroup #team-map', self.navigateToMap);
      $(document).on("click", "#myGroup #app-calendar", function(){
          gotoPage({url: "calendar", param: null}, {url: "myGroup", param: null});
      });
      $(document).on('click', '#overview-link', self.overviewLinkEvent);
      $(document).on('click', '#myGroup .favorite-event', self.eventFavorite);
      $('#filter-user-type', '#myGroup').on('change', self.filterTypeEvent);
      $(document).on('click', '#myGroup .phone-popup-dialog-item', self.popupDialogItem);
  };

  self.unbindElementControls = function () {
         $(document).off('click', '#dashboard-link');
         $(document).off('click', '#contacts-link');
         $(document).off('click', '#call-log-link');
         $(document).off('click', '#tasks-link');
         $(document).off('click', '#case-link');
         $(document).off('click', '#deals-link');
         $(document).off('click', '#menu-link');
         $(document).off('click', '#mygroup-link');
         $(document).off('click', '#settings-link');
         $(document).off('click', '#drafts-link');
         $(document).off('click', '#users-list .user');
         $(document).off('click', '#users-list .call-sms-user');
         $(document).off('click', '#set-user-task');
         $(document).off('click', '#set-user-call-logs');
         $(document).off('click', '#set-user-view-all-task');
         $(document).off('click', '#set-user-view-assigned-task');
         $(document).off('click', '#refresh-link');
        //  $(document).off('change', '#myGroup input[type=radio][name=sip-radio]');
         $(document).off('click', '#sip-messages-link');
         $("input", '#myGroup').off('keyup');
         $(document).off('click', '#myGroup .ui-input-clear');
         $(document).off('click', '#myGroup #open-edit-note-view');
         $(document).off('click', '#myGroup #create-new-contact');
         $(document).off('click', '#users-list .contact-case-icon');
         $(document).off('click', '#users-list .contact-task-icon');
         $(document).off('click', '#users-list .contact-deal-icon');
         $(document).off('click', '#myGroup .float-add-action');
         $(document).off('click', '#myGroup #call-list-link');
         $(document).off('click', '#myGroup #team-groups');
         $(document).off('click', '#myGroup #add-group-link');
         $(document).off('click', '#myGroup #team-users');
         $(document).off('click', '#myGroup .group-list-item');
         $(document).off('click', '#myGroup #team-map');
         $(document).off('click', '#myGroup .phone-popup-dialog-item');
         $(document).off('click', '#about-link');
         $(document).off('click', '#overview-link');
         $("#myGroup .domain-link-info").off('click');
         $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
         $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
         $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
         $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
         $('.backdrop').off('click');
         $("body").off('swipeleft', "#myGroup .sidebar");
         $('html').removeClass('sidebar-left-in');
         $(document).off("click", "#myGroup #app-calendar");
         $("#myGroup .app-user").off('click');
         $(document).off('click', '#myGroup .favorite-event');
         $('#filter-user-type', '#myGroup').off('change');

         contactIdfromContactView = null;
         contactTypefromContactView = null;
         viewContactSipName = null;
     };

     self.filterTypeEvent = function (event) {
        showLoadingIndikator();
         if (event) {
             self.currentFilterType = $(event.currentTarget).find('option:selected').val();
         }
         $filterUserType.i18n();
         $filterUserType.val(self.currentFilterType).selectmenu('refresh');
         self.showOrHideFavoriteUser(self.currentFilterType == 'filter-favorite-users');
     };

    self.showOrHideFavoriteUser = function(isFavorite){
      var listHideItems = 0;
      if (isFavorite) {
        listHideItems = $('#users-list li:not(.favorite)').hide();
        if ($('#users-list li').length - listHideItems.length === 0) {
            $('#mygroup-empty-list-message').show();
        } else {
            $('#mygroup-empty-list-message').hide();
        }
      } else {
        $('#users-list li:not(.favorite)').show();
        self.sortData();
      }
      hideLoadingIndikator();
    };

    self.sortData = function() {
      var $usersList = $('#users-list');
      var listFavoriteItems = $('li.favorite', $usersList).clone();
      $('li.favorite', $usersList).remove();
      $usersList.prepend(listFavoriteItems);
    };

    self.eventFavorite = function(e) {
      showLoadingIndikator();
      var element  = $(this);
      var isFavorite = element.hasClass("contact-favorite-star");
      var userId  = element.parent().attr('userid');
      UserController.findUserById(userId, function(item){
        if (item && item[0]) {
          if (isFavorite) {
               FavoriteController.findByObjectIdDB(item[0].person , function(data){
                  if (data && data[0]) {
                      FavoriteController.removeFavorite(data[0].id, function(){
                          element.toggleClass("contact-favorite-star");
                          element.parent().parent().toggleClass('favorite');
                          hideLoadingIndikator();
                      });
                  } else {
                      hideLoadingIndikator();
                  }
               });
          } else {
            PeopleController.findById(item[0].person, function(data){
              if (data && data[0]) {
                FavoriteController.save("User", data[0], function(){
                  element.toggleClass("contact-favorite-star");
                  element.parent().parent().toggleClass('favorite');
                  hideLoadingIndikator();
                });
              } else {
                  hideLoadingIndikator();
              }
            }, true)
          }
        }
      });
      e.stopPropagation();
      e.preventDefault();
    };

    self.callUserById = function(userId, type, successCallback, errorCallback) {
      // var deviceType = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
      // if (deviceType == "iPhone" || deviceType == "iPad") {
          // var link = "beephone://?domain="+localStorage.getItem('userDomain')+"&token="+token+"&userid="+userId;
          // var ref = window.open(link, '_blank', 'location=yes');
          // ref.addEventListener('loaderror', function(event) {
          //   window.open('https://itunes.apple.com/us/app/beephone-beta/id1100815934', '_blank', 'location=yes');
          //  });
      // } else
      if (UtilController.isAndroid()){
        var url = 'https://play.google.com/store/apps/details?id=com.gsvba.tfy.phone';
        var appAction = "com.gsvba.tfy.phone";
        var name = ALL_USERS[userId] ? ALL_USERS[userId].name : "";
        window.plugins.voip.call(
          [url, appAction, userId, name, type],
          successCallback, errorCallback
        );
      }
    };

    self.overviewLinkEvent = function () {
        gotoPage({url: "overview", param: null});
    };

    self.gotoDomainPage = function () {
        gotoPage({url: "domain", param: null}, {url: "myGroup", param: null});
    };

    self.gotoProfilPage = function(){
      gotoPage({url: "editProfil", param: null}, {url: "myGroup", param: null});
    };

    self.gotoAbout = function () {
        gotoPage({url: "about", param: null}, {url: "myGroup", param: null});
    };

    self.addGroupLink = function () {
        currentTab = 'GROUPS';
        self.navigateToGeneral();
    };

    self.gotoEditGroup = function () {
        currentTab = 'GROUPS';
        gotoPage({url: "editGroup", param: null}, {url: "myGroup", param: null});
    };

    self.navigateToGeneral = function () {
        switch (currentTab) {
            case 'USERS':
                $("#team-groups").removeClass("btn-active");
                $("#team-users").addClass("btn-active");
                $("#myGroup #group-list-container").hide();
                $("#myGroup #user-list-container").show();
                $('#myGroup #add-group-link').hide();
                $('#myGroup #favorite-case-mouseover').show();

                break;
            case 'GROUPS':
                $("#team-users").removeClass("btn-active");
                $("#team-groups").addClass("btn-active");
                $("#myGroup #group-list-container").show();
                $("#myGroup #user-list-container").hide();
                $('#myGroup #favorite-case-mouseover').hide();
                if (ALL_USERS[localStorage.getItem('userId')]['admin'].text) {
                  $('#myGroup #add-group-link').show();
                } else {
                  $('#myGroup #add-group-link').hide();
                }
                break;
        }
    };

    self.drawTeamGroups = function () {
      GroupController.findGroups(function(groups) {
          var html = "";
          for (var i = 0; i < groups.length; i++) {
              html += self.drawTeamGroup(groups[i]);
          }
          if (html != "") {
              $("#myGroup #group-list").empty().append(html);
          }
      });
    };

    self.drawTeamGroup = function (groupItem) {
        var html = "";
        if (groupItem) {
            html += '<li>'
                    + '<a href="#" id="' + groupItem.name + '" class="group-list-item">'
                    + '<div class="title">' + groupItem.name + '</div>'
                    + '<div class="subtitle">' + groupItem.description + '</div>'
                    + '</a>'
                    + '</li>';
        }
        return html;
    };

    // if user is not domain admin he can not invite people to join
    self.checkIfUserIsDomainAdmin = function () {
      var userProfile = JSON.parse(localStorage.getItem('userProfile'))
      if (userProfile.app_domain_admin) {
          $("#myGroup .float-add-action").show();
      } else {
          $("#myGroup .float-add-action").hide();
      }
    };

    self.openInvatePage = function () {
        currentTab = 'USERS';
        gotoPage({url: "invite", param: null}, {url: "myGroup", param: null});
    };

    self.settingsLinkEvent = function () {
        currentTab = 'USERS';
        gotoPage({url: "settings", param: null}, {url: "myGroup", param: null});
    };

    self.onPullDown = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            self.refreshMyGroup();
            $("#dashboard").find("input:jqmData(type='search')").val("");
        }
    };

    self.onPullUp = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).last().visible()) {
        }
    };

    self.openUser = function (userId) {
        var id = null;
        if (userId != null && userId != "" && typeof userId == "string") {
            id = userId;
        } else {
            id = $(this).attr('userid');
        }
        if (id != null) {
            if (connection) {
                ClientAPI.find({query: {'identity_id': id}, objectType: 'Person', population: 'companies.company'}, function (err, data) {
                    if (!err) {
                        if (data != null && data.length > 0) {
                            var item = PeopleController.encodeItem(data[0]);
                            gotoPage({url: "viewContact", param: {contactId: item.id.text, contactType: "Person", setProfil: false}}, {url: "myGroup", param: null});
                        }
                    }
                });
            } else {
                db.selectByQuery('SELECT * FROM people WHERE "identity_id" =?', [id], 'people', function (data) {
                    if (data != null && data.length > 0) {
                        gotoPage({url: "viewContact", param: {contactId: data[0].id.text, contactType: "Person", setProfil: false}}, {url: "myGroup", param: null});
                    }
                });
            }
            currentTab = 'USERS';
        }
    };

    self.caseLinkEvent = function () {
        gotoPage({url: "case", param: null});
    };

    self.sipMessagesLink = function () {
        gotoPage({url: "sipMessages", param: null}, {url: "myGroup", param: null});
    };

    self.callLogEvent = function () {
        gotoPage({url: "callLog", param: null});
    };

    self.refreshMyGroup = function () {
      FavoriteController.findAllMapByTypes(["User"], function(favoriteMap){
        self.favoriteMap = favoriteMap;
        self.drawUsers();
      });
    };

    self.drawUsers = function (name) {
      var html = "";
      var isFavorite = self.currentFilterType == "filter-favorite-users";
      UserController.findUserByNameOffline(name, function(users) {
            $(users).each(function (index, user) {
                user.favorite = self.favoriteMap[user.person] ? true : false;
                html += self.drawUser(user);
            });

            if (users != null && users.length >= 1) {
                $('#users-list').empty().append(html);
                $('#mygroup-empty-list-message').hide();
            } else {
                $('#users-list').empty();
                $('#mygroup-empty-list-message').show();
            }
            self.showOrHideFavoriteUser(isFavorite);
            self.drawUserCounter(users);
            self.loadSipUsers();
      });
      self.setConnectionMode();
    };

    self.drawUser = function(user){
        var html = "";
        var favoriteHtml = user.favorite ? 'class="favorite"': "";
        if (user) {
          var callOption = "";
          if (UtilController.isAndroid()) {
            callOption = '<div class="mygroup-status offline-icon-status call-sms-user" userId="' + user.id.text + '">'
             + '<span><i class="md-call md-3x"></i></span>'
             +'</div>';
          }

            html += '<li ' + favoriteHtml + '>'
                    + '<a href="#" style="width:80%" class="user list-elem" fullname="' + user.name + '" userId="' + user.id.text + '">'
                    + self.drawAvatar(user.id.text, user.favorite)
                    + '<div class="content-center" style="padding-left:75px; min-height:55px; ">'
                    + '<div class="title truncate">' + user.name + '</div>'
                    + '<div style="color:gray;">'
                    + '<span class="user-deal-number" userId="' + user.id.text + '">Deals (0)</span>'
                    + '<span class="user-case-number" userId="' + user.id.text + '">Cases (0)</span>'
                    + '<span class="user-task-number" userId="' + user.id.text + '">Tasks (0)</span>'
                    + '</div>'
                    + '</div>'
                    + '</a>'
                    + callOption
                    + '</li>';
        }
        return html;
    };

    self.drawAvatar = function(userId, favorite) {
        var html = "";
        var avatar = null;
        var user = ALL_USERS[userId];
        var starColor = favorite ? "contact-favorite-star" : "";

        if (connection && user['avatar-url'] != null) {
           avatar = window.localStorage.getItem('folderPath') + user['avatar-url'];
        }
        if (avatar) {
              var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(user.person) + '&fieldName=' + encodeURIComponent('picture');
              html += '<div class="favorite-event '+ starColor + '">'
                      + '<span class="contact-favorite-image"><i class="md-grade md-lg contact-favorite-avatar-image"></i></span>'
                      + '<div class="content-left-avatar" avatar_path="' + avatar + '" style="margin-left: 25px;padding: 10px 10px; width:42px;"><div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ')"></div></div>'
                      + '</div>';
        } else {
              html += '<div class="content-left favorite-event ' + starColor + '">'
                      + '<span class="contact-favorite-image"><i class="md-grade md-lg"></i></span>'
                      + '<span class="avatar is-contact-image" style="margin-left: 25px;"><i class="md-person md-3x"></i></span>'
                      + '</div>';
        }
        return html;
    };

    self.drawUserCounter = function(sipData){
      var caseCount = "SELECT count(*) FROM kase WHERE [owner-id] = ?";
      var dealCount = "SELECT count(*) FROM deal WHERE [owner-id] = ?";
      var taskCount = "SELECT count(*) FROM task WHERE [owner-id] = ? OR [responsible-id] = ?";
      for (var i = 0; i < sipData.length; i++) {
          (function (num) {
              db.selectByQuery(caseCount, [getTextTypeObject(sipData[num].id.text, 'integer')], "kase", function (data) {
                  sipData[num].caseNumber = data[0]["count(*)"];
                  $(".user-case-number[userId='" + sipData[num].id.text + "']").text("Cases (" + sipData[num].caseNumber + ") ");
              });

              db.selectByQuery(dealCount, [getTextTypeObject(sipData[num].id.text, 'integer')], "deal", function (data) {
                  sipData[num].dealNumber = data[0]["count(*)"];
                  $(".user-deal-number[userId='" + sipData[num].id.text + "']").text("Deals (" + sipData[num].dealNumber + ") ");
              });

              db.selectByQuery(taskCount, [getTextTypeObject(sipData[num].id.text, 'integer'), getTextTypeObject(sipData[num].id.text, 'integer')], "task", function (data) {
                  sipData[num].taskNumber = data[0]["count(*)"];
                  $(".user-task-number[userId='" + sipData[num].id.text + "']").text("Tasks (" + sipData[num].taskNumber + ") ");
              });
          })(i);
      }
    };

    self.loadSipUsers = function() {
        UserController.loadSipUserFromServer(function(data){
          var onlineUsersSip = data ? data : [];
          for (var i = 0; i < onlineUsersSip.length; i++){
              $('.mygroup-status[userId="' + onlineUsersSip[i] + '"]').addClass('online-icon-status');
          }
        });
    };

    self.searchInputEvent = function (event) {
      if (self.findTime) {
          clearTimeout(self.findTime);
     }
      self.findTime = setTimeout(function () {
        debugger;
          self.drawUsers(event.currentTarget.value);
      }, 500);
    };


    self.contains = function (data, key) {
        var temp = -1;
        $(data).each(function (index, value) {
            if (value.userid == key) {
                temp = index;
            }
        });
        return temp != -1 ? temp : -1;
    };

    self.callUser = function () {
        userIdForTasks = $(this).attr('userid');
        var deviceType = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
        if (!(deviceType == "iPhone" || deviceType == "iPad")) {
          if ($(this).hasClass( "online-icon-status" )) {
              $('#phone-popup-dialog li.call-option').show();
          } else {
            $('#phone-popup-dialog li.call-option').hide();
          }

          if (ALL_USERS[userIdForTasks] && ALL_USERS[userIdForTasks].phone) {
            $('#phone-popup-dialog li.call-option-native').show();
          } else {
            $('#phone-popup-dialog li.call-option-native').hide();
          }

          $('#phone-popup-dialog').attr('userId', userIdForTasks).popup("open");
          event.stopPropagation();
        }
    };


    self.popupDialogItem = function(event) {
        if (UtilController.isAndroid()) {
          var type = $(event.currentTarget).attr('data-type');
          var userId = $(event.currentTarget).parent().parent().attr('userId');
          if (type == "CALL") {
            document.location.href = "tel:" + ALL_USERS[userId].phone;
          } else {
            MyGroupFunctions.callUserById(userId, type);
          }
        }
    }


    self.getColorByStatus = function (status) {
        switch (status) {
            case 0:
                return "green";
            case 1:
                return "red";
            case 2:
                return "yellow";
            default:
                return undefined;
        }
        return undefined;
    };

    self.setConnectionMode = function () {
        if (connection) {
            $('#sip-messages-link', '#myGroup').show();
        } else {
            $('#sip-messages-link', '#myGroup').hide();
        }
    };

    self.menuLinkEvent = function () {
        $('html').toggleClass('sidebar-left-in');
    };

    self.dashboardLinkEvent = function () {
        gotoPage({url: "dashboard", param: null});
    };

    self.contactsLinkEvent = function () {
        gotoPage({url: "contacts", param: null});
    };

    self.callLogLinkEvent = function () {
        gotoPage({url: "callLog", param: null}, {url: "myGroup", param: null});
    };

    self.tasksLinkEvent = function () {
        gotoPage({url: "tasks", param: null});
    };

    self.dealsLinkEvent = function () {
        gotoPage({url: "deals", param: null});
    };

    self.gotoDashboardEvent = function () {
        gotoPage({url: "dashboard", param: null});
    };

    self.draftLinkEvent = function () {
        gotoPage({url: "draft", param: null}, {url: "myGroup", param: null});
    };

    self.navigateToMap = function(){
      gotoPage({url: "map", param: null}, {url: "myGroup", param: null});
    };

    self.findUserByPhone = function (phone) {
      var result = undefined;
      if (window.localStorage.getItem("sipUsername") == phone) {
          result = {
              id: window.localStorage.getItem("userId"),
              name: window.localStorage.getItem("userDataName")
          };
      }
      return result;
    };

    return self;
}(MyGroupFunctions || {}));
