$(document).on('pageinit', '#reset-password', function () {
    ResetPasswordFunctions.init();
});

$(document).on('pageshow', '#reset-password', function () {
    ResetPasswordFunctions.bindElementControls();
});

$(document).on('pagehide', '#reset-password', function () {
    ResetPasswordFunctions.unbindElementControls();
});

var ResetPasswordFunctions = (function (ResetPasswordFunctions) {
    var self = ResetPasswordFunctions;

    self.init = function () {
    };

    self.bindElementControls = function () {
        $(document).on('click', '#reset-password-back-link', goBack);
        $(document).on('click', '#reset-password-send', self.resetPasswordSaveAction);
        $(document).on('click', '#reset-password .additional-options', self.resetPasswordSaveAction);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#reset-password-back-link');
        $(document).off('click', '#reset-password-send');
        $(document).off('click', '#reset-password .additional-options');
    };

    self.clearEntry = function () {
        $("#reset-password #old-password").val("");
        $("#reset-password #new-password").val("");
    };
    
    self.validateEmail = function(email) {
        var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
    };

    self.resetPasswordSaveAction = function () {
        $(this).addClass('not-clickable');
        playSound("www/libs/blop.mp3");
        var email = $("#reset-password #email").val();
        if (email) {
            if (self.validateEmail(email)) {
//                ClientAPI.requestPasswordReset(email, function (err, data) {
//                    if (!err) {
//                        if (data) {
//                            self.clearEntry();
//                            goBack();
//                        }
//                    } else {
//                        alert("Error: #" + err.code + ",status:" + err.status);
//                    }
//                });
            } else {
                alert("Enter valid email!");
            }
        } else {
            alert("Enter email!");
        }
    };

    return self;
}(ResetPasswordFunctions || {}));			