$(document).on('pageinit', '#view-settings', function () {
    SettingsFunctions.init();
});

$(document).on('pageshow', '#view-settings', function () {
    SettingsFunctions.bindElementControls();
    if (connection) {
        $('#' + $.mobile.activePage.attr('id') + ' #sync-all-link').removeClass("ui-disabled");
    } else {
        $('#' + $.mobile.activePage.attr('id') + ' #sync-all-link').addClass("ui-disabled");
    }

    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
        $("#sip-settings-link").remove();
    }
});

$(document).on('pagehide', '#view-settings', function () {
    SettingsFunctions.unbindElementControls();
});

var SettingsFunctions = (function (SettingsFunctions)
{
    var self = SettingsFunctions;

    self.init = function () {
        //init visibility
    };

    self.bindElementControls = function () {
        $(document).on('click', '#sync-all-link', self.syncAll);
        $(document).on('click', '#domain-link', self.domain);
        $(document).on('click', '#logout-link', self.logout);
        $(document).on('click', '#offline-data-link', self.showOfflineDataEvent);
        $(document).on('click', '#sip-settings-link', self.showSipSettings);
        $(document).on('click', '#app-settings-link', self.showAppSettings);
        $(document).on('click', '#notification-settings-link', self.showNotificationSettings);
        $(document).on('click', '#about-link', self.gotoAbout);
        $(document).on('click', '#profile-link', self.gotoUserProfile);
        $(document).on('click', '#change-password-link', self.gotoChangePassword);
        $(document).on('click', '#back-link', goBack);
        $(document).on("click", ".view-item-settings-menu", self.viewItemVisibleToggle);
        $(document).on("click", ".view-item-account-settings", self.viewItemVisibleToggle);
        $(document).on("click", ".view-item-data-settings", self.viewItemVisibleToggle);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#sync-all-link');
        $(document).off('click', '#logout-link');
        $(document).off('click', '#offline-data-link');
        $(document).off('click', '#sip-settings-link');
        $(document).off('click', '#app-settings-link');
        $(document).off('click', '#notification-settings-link');
        $(document).off('click', '#about-link');
        $(document).off('click', '#profile-link');
        $(document).off('click', '#change-password-link');
        $(document).off('click', '#back-link');
        $(document).off('click', '#domain-link');
        $(document).off("click", ".view-item-settings-menu");
        $(document).off("click", ".view-item-account-settings");
        $(document).off("click", ".view-item-data-settings");
    };

    self.viewItemVisibleToggle =  function (event) {
          $('html, body').animate({scrollTop: $(document).height()}, 'slow');
          $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
          $('#' + $(this).attr('container')).toggleClass('hide');
    };

    self.gotoUserProfile = function () {
        gotoPage({url: "editProfil", param: null}, {url: "settings", param: null});
    };

    self.gotoChangePassword = function () {
        gotoPage({url: "changePassword", param: null}, {url: "settings", param: null});
    };

    self.gotoAbout = function () {
        gotoPage({url: "about", param: null}, {url: "settings", param: null});
    };

    self.showSipSettings = function () {
        gotoPage({url: "sip", param: null}, {url: "settings", param: null});
    };

    self.showAppSettings = function () {
        gotoPage({url: "appSettings", param: null}, {url: "settings", param: null});
    };

    self.showNotificationSettings = function() {
      gotoPage({url: "notificationSettings", param: null}, {url: "settings", param: null});
    };

    self.sipCallLinkEvent = function () {
        gotoPage({url: "sipCall", param: null}, {url: "settings", param: null});
    };

    self.swipeLeftEvent = function (e) {
        gotoPage({url: "dashboard", param: null}, {url: "settings", param: null});
    };

    self.swipeRightEvent = function (e) {
        gotoPage({url: "deals", param: null}, {url: "settings", param: null});
    };

    self.showOfflineDataEvent = function () {
        gotoPage({url: "offlineData", param: null}, {url: "settings", param: null});
    };

    self.dashboardLinkEvent = function () {
        gotoPage({url: "dashboard", param: null}, {url: "settings", param: null});
    };

    self.contactsLinkEvent = function () {
        gotoPage({url: "contacts", param: null}, {url: "settings", param: null});
    };

    self.tasksLinkEvent = function () {
        gotoPage({url: "tasks", param: null}, {url: "settings", param: null});
    };

    self.dealsLinkEvent = function () {
        gotoPage({url: "deals", param: null}, {url: "settings", param: null});
    };

    self.syncAll = function () {
        showActionDialog("Are you sure you want to SYNC all data?", "Yes", function () {
            if (connection) {
                showLoadingIndikator();
                OfflineController.synchronization(function () {
                    SyncController.sync(function () {
                        hideLoadingIndikator();
                    });
                });
            }
        }, "No", function () {
        });
    };

    self.logout = function () {
        showActionDialog("Are you sure you want to LOGOUT?", "Yes", function () {
            self.clearAndRemove();
            if (connection) {
                setTimeout(function () {
                    ClientAPI.logout(function (e, s) {
                        console.log("Status:" + JSON.stringify(e || s));
                        gotoPage({url: 'login', param: null});
                    });
                }, 0);
            } else {
                navigator.app.exitApp();
            }
            // window.plugins.SipPlugin.closeConnection(function() {
            // 	console.log("SIP CLOSE CONNECTION SUCCES");
            // 	if (connection) {
            // 		var objectSip  = {
            // 				userid: window.localStorage.getItem('userId'),
            // 				domain: window.localStorage.getItem('userDomain'),
            // 				status:  0
            // 		};
            // 		hclient.postSipFunction(objectSip, "UpdateStatus", function(data) {
            // 			console.log('UPDATE STATUS' + data );
            // 		});
            // 	}
            // 	self.clearAndRemove();
            // 	console.log('SIP LOG FINISH');
            // }, function() {
            // 	self.clearAndRemove();
            // 	console.log("SIP CLOSE CONNECTION ERROR");
            // });
        }, "No", function () {
        });
    };

    self.domain = function () {
        gotoPage({url: 'domain', param: null}, {url: "settings", param: null});
    };

    self.clearAndRemove = function (exclude) {
        window.localStorage.clear();
        for (var table in models) {
            if (exclude) {
                if (exclude.indexOf(table) == -1) {
                    db.deleteAllFromTable(models[table].name, function () {
                    });
                }
            } else {
                db.deleteAllFromTable(models[table].name, function () {
                });
            }
        }

        latitude = null;
        longitude = null;
        userAddress = null;

        if (sipAccountMap != null && sipAccountMap.length != null && sipAccountMap.length > 0) {
            sipAccountMap.length = 0;
        }
        if (sipAccount != null && sipAccount.length != null && sipAccount.length > 0) {
            sipAccount.length = 0;
        }
        if (PEOPLE != null && PEOPLE.length != null && PEOPLE.length > 0) {
            PEOPLE.length = 0;
        }
        if (COMPANY != null && COMPANY != null && COMPANY.length != null && COMPANY.length > 0) {
            COMPANY.length = 0;
        }
        if (ALL_USERS != null && ALL_USERS.length != null && ALL_USERS.length > 0) {
            ALL_USERS.length = 0;
        }
        if (ALL_USERS_OBJS != null && ALL_USERS_OBJS.length != null && ALL_USERS_OBJS.length > 0) {
            ALL_USERS_OBJS.length = 0;
        }
        if (taskCategories != null && taskCategories.length != null && taskCategories.length > 0) {
            taskCategories.length = 0;
        }
        if (dealCategories != null && dealCategories.length != null && dealCategories.length > 0) {
            dealCategories.length = 0;
        }
        if (UPCOMING_TASKS != null && UPCOMING_TASKS.length != null && UPCOMING_TASKS.length > 0) {
            UPCOMING_TASKS.length = 0;
        }
        if (UPCOMING_OVERDUE != null && UPCOMING_OVERDUE.length != null && UPCOMING_OVERDUE.length > 0) {
            UPCOMING_OVERDUE.length = 0;
        }
        if (ASSIGNED_TASKS != null && ASSIGNED_TASKS.length != null && ASSIGNED_TASKS.length > 0) {
            ASSIGNED_TASKS.length = 0;
        }
        if (ASSIGNED_OVERDUE != null && ASSIGNED_OVERDUE.length != null && ASSIGNED_OVERDUE.length > 0) {
            ASSIGNED_OVERDUE.length = 0;
        }
        if (COMPLETED != null && COMPLETED.length != null && COMPLETED.length > 0) {
            COMPLETED.length = 0;
        }
        if (CASES != null && CASES.length != null && CASES.length > 0) {
            CASES.length = 0;
        }
        if (GROUPS != null && GROUPS.length != null && GROUPS.length > 0) {
            GROUPS.length = 0;
        }
        if (dealsCategory != null && dealsCategory.length != null && dealsCategory.length > 0) {
            dealsCategory.length = 0;
        }
        if (taskCategory != null && taskCategory.length != null && taskCategory.length > 0) {
            taskCategory.length = 0;
        }
        if (CONTACT_MAPPING != null && CONTACT_MAPPING.length != null && CONTACT_MAPPING.length > 0) {
            CONTACT_MAPPING.length = 0;
        }

        $('#contacts').remove();
        $('#dashboard').remove();
        $('#tasks').remove();
        $('#deals').remove();
        $('#myGroup').remove();
    };

    return self;
}(SettingsFunctions || {}));
