$(document).on('pageinit', '#draft', function () {
    DraftFunctions.init();
});

$(document).on('pageshow', '#draft', function () {
    DraftFunctions.bindElementControls();
});

$(document).on('pagehide', '#draft', function () {
    DraftFunctions.unbindElementControls();
});

var DraftFunctions = (function (DraftFunctions)
{
    var self = DraftFunctions;

    self.init = function () {
        self.draftCount();
        self.drawDrafts();
    };

    self.bindElementControls = function () {
        $(document).on('click', '#draft #back-link', goBack);
        $(document).on('click', '#draft .draft-item', self.navigateDraft);
        $(document).on('click', '#draft .btn-delete-draft', self.deleteDraftEvent);
        $(document).on('click', '#draft .additional-options', self.deleteAllDraftEvent);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#draft #back-link');
        $(document).off('click', '#draft .draft-item');
        $(document).off('click', '#draft .btn-delete-draft');
        $(document).off('click', '#draft .additional-options');
    };

    self.drawDrafts = function () {
        DraftController.findAll(function(data) {
          if (data && data.length > 0) {
            var html= "";
              $("#draft #draft-list .empty-list").remove();
              for (var i = 0; i < data.length; i++) {
                  html += self.drawDraftItem(data[i]);
              }
              if (html != "") {
                  $("#draft #draft-list").append(html);
              }
          } else {
              $("#draft #draft-list").append("<li class='center empty-list' style='min-height: auto;'>Empty list</li>");
          }
        });
    };

    self.drawDraftItemAvatar = function(itemData) {
      var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(ALL_USERS[localStorage.getItem('userId')].person) + '&fieldName=' + encodeURIComponent('picture');
      var imageData = '<i class="avatar md-person  md-3x"></i>';
      if (connection && ALL_USERS[localStorage.getItem('userId')]['avatar-url'] != null) {
          imageData = '<div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ');width:40px;"></div>';
      }
      return imageData;
    }

    self.drawDraftItem = function(draft){
        var imageData = self.drawDraftItemAvatar(draft);
        var idAndType = " objectType = '" + draft.type + "'";
        if (draft.object.id) {
            idAndType= "objectId = '" + draft.object.id + "' objectType = '" + draft.type + "'";
        }

        var html = "<li>"
                + "<a draftId='" + draft.id + "' " + idAndType + " class='task-item list-item-el draft-item'>"
                + '<div class="favorite-event" style="float:left;">'
                  + '<span class="is-contact-image" style="padding: 5px 0px 10px 10px;">'
                    +  imageData
                  + '</span>'
                + '</div>'
                + '<div class="content-center" style="padding-left:60px;">'
                    + '<div>'
                        + '<span class="case-item-status-padding"><b>'+ ALL_USERS[localStorage.getItem('userId')].name + '</b></span>'
                        + '<span class="case-item-status-padding">created a draft note on </span>'
                        + '<span class="deal-item-padding">'
                            + dateFormat(new Date(draft['updated-at'])) + " " + timeFormat(new Date(draft['updated-at']))
                        + '</span>'
                    + '</div>'
                    + '<div class="title bold">'
                       + '<span>' + htmlStrip(draft.object.body) + '</span>'
                   + '</div>'
                  + '</div></a>'
                  + "<span class='btn-delete-draft' style='position:absolute; right:10px; bottom: 20px; cursor: pointer;' draftId='" + draft.id + "'><i class='md-close md-2x'></i></span>"
                + '</li>';


        return html;
    }

    // self.drawDraftItem2 = function (draft) {
    //     var html = "";
    //     var iconElement = "";
    //     var date = draft['updated-at'].split('T')[0];
    //     date = reverseDate(date);
    //     var time = draft['updated-at'].split('T')[1].split('.')[0];
    //     switch (draft.type) {
    //         case "Note":
    //             iconElement = "<i class='md-insert-drive-file md-2x'></i>";
    //             break;
    //     }
    //     html += "<li>";
    //     if (draft.object.id) {
    //         html += "<a class='draft-item' href='' draftId = '" + draft.id + "' objectId = '" + draft.object.id + "' objectType = '" + draft.type + "'>";
    //     } else {
    //         html += "<a class='draft-item' href='' draftId = '" + draft.id + "' objectType = '" + draft.type + "'>";
    //     }
    //
    //     html += "<div class='content-left'>"
    //             + "<div>" + iconElement + "</div>"
    //             + "</div>"
    //             + "<div style='padding-left:45px;'>"
    //             + "<div class='title' style='word-break: break-all; max-height: 54px;overflow: hidden; padding: 5px 0px 0px 0px; margin-right: 30px;'>" + htmlStrip(draft.object.body) + "</div>"
    //             + "<div class='fg-red'>" + date + ", " + time + " h</div>"
    //             + "</div>"
    //             + "</a>"
    //             + "<span class='btn-delete-draft' style='position:absolute; right:10px; bottom: 15px; cursor: pointer;' draftId='" + draft.id + "'><i class='md-close md-2x'></i></span>"
    //             + "</li>";
    //
    //     if (html != "") {
    //         $("#draft #draft-list").append(html);
    //     }
    // };

    self.deleteDraftEvent = function () {
        var draftId = $(this).attr('draftId');
        self.deleteDraft(draftId);
    };

    self.deleteDraft = function (draftId, callback) {
        if (draftId) {
          DraftController.deleteDraft(draftId, function(){
            $("span[draftId='" + draftId + "']").closest("li").remove();
            self.draftCount();
          });
        }
    };

    self.deleteAllDrafts = function () {
      DraftController.deleteAllDraft(function(){
        self.draftCount();
        $("#draft-list").empty();
      });
    };

    self.navigateDraft = function () {
        var draftId = $(this).attr('draftId');
        var objectId = $(this).attr('objectId');
        var draftType = $(this).attr('objectType');
        var tmp = {};

        if(objectId){
            tmp.draftObjectId = objectId;
        }
        tmp.draftId = draftId;

        switch (draftType) {
            case "Note":
                gotoPage({url: "editNote", param: tmp}, {url: "draft", param: {}});
                break;
        }
    };

    self.draftCount = function () {
        DraftController.draftCount(function(data){
            if (data && data[0]) {
                $("#draft .draft-count").text("(" + data[0]['count(*)'] + ")");
            }
        });
    };


    self.deleteAllDraftEvent = function () {
        showActionDialog("Delete all draft?", "Yes", self.deleteAllDrafts, "No", function () {});
    };

    return self;
}(DraftFunctions || {}));
