$(document).on('pageshow', '#offline-data', function () {
    OfflineDataFunctions.bindElementControls();
    OfflineDataFunctions.showOfflineData();
});

$(document).on('pagehide', '#offline-data', function () {
    OfflineDataFunctions.unbindElementControls();
});

$(document).on('pageinit', '#offline-data', function () {
    OfflineDataFunctions.init();
});


var OfflineDataFunctions = (function (OfflineDataFunctions)
{
    var self = OfflineDataFunctions;
    var xmlArray = [];

    var $offlineDataList = null;

    self.init = function () {
        $offlineDataList = $('#offline-data-list');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#offline-data-back-link', goBack);
        $(document).on('click', '#offline-data-list .delete-item', self.deleteOfflineItem);
        $(document).on('click', '#back-link', goBack);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#offline-data-back-link');
        $(document).off('click', '#offline-data-list .delete-item');
        $(document).off('click', '#back-link');
    };

    self.deleteOfflineItem = function () {
        var id = $(this).attr("xmlValue");
        showActionDialog("Delete this item?", "Yes", function () {
            db.deleteObject(models.offlineInsertDBModel.name, "id", xmlArray[id]);
            self.showOfflineData();
        }, "No", function () {
        });
    };

    self.showOfflineData = function () {
        showLoadingIndikator();
        db.selectAll(models.offlineInsertDBModel.name, function (data) {
            var html = "";
            xmlArray = [];
            $offlineDataList.empty();

            $(data).each(function (index, value) {
                var title = "";
                var header = "";
                var desc = "";
                xmlArray.push(value.offlineInsert.id);
                if (value.offlineInsert.objectType == "kase") {
                    title = "Case";
                    header = value.offlineInsert.object.projectName;
                    desc = value.offlineInsert.object.projectDescription;
                } else if (value.offlineInsert.objectType == "comment") {
                    title = "Comment";
                    desc = value.offlineInsert.object.comment;
                } else if (value.offlineInsert.objectType == "note") {
                    title = "Note";
                    desc = value.offlineInsert.object.note;
                } else if (value.offlineInsert.objectType == "task") {
                    title = "Task";
                    desc = value.offlineInsert.object.taskDescription;
                } else if (value.offlineInsert.objectType == "deal") {
                    title = "Deal";
                    header = value.offlineInsert.object.dealName;
                    desc = value.offlineInsert.object.dealInfo;
                } else if (value.offlineInsert.objectType == "company") {
                    title = "Company";
                    header = value.offlineInsert.object.companyName;
                    desc = value.offlineInsert.object.companyInfo;
                } else if (value.offlineInsert.objectType == "people") {
                    title = "Person";
                    header = value.offlineInsert.object.firstName + " " + value.offlineInsert.object.lastName;
                    desc = value.offlineInsert.object.info;
                }

                html += '<li><a href="#">'
                        + '<h1>' + title + '</h1>'
                        + '<p><strong>' + header + '</strong></p>'
                        + '<p>' + desc + '</p>'
                        + '<a class="delete-item" data-icon="false" href="#" xmlValue="' + (xmlArray.length - 1) + '">Delete</a></li>';
            });

            $offlineDataList.append(html);

            if (data.length == 0) {
                $offlineDataList.html(emptyListHtml);
            }

            $offlineDataList.listview("refresh");
            hideLoadingIndikator();
        });
    };

    return self;
}(OfflineDataFunctions || {}));