$(document).on('pageinit', '#assigned-tasks', function () {
    AssignedTasksFunctions.init();
});

$(document).on('pageshow', '#assigned-tasks', function () {
    AssignedTasksFunctions.bindElementControls();
    AssignedTasksFunctions.filterTask();
    $("#assigned-tasks #title-h1").html(ALL_USERS[sharedUserIdForAssignedTasks].name);
    AssignedTasksFunctions.setConnectionMode();
});

$(document).on('pagehide', '#assigned-tasks', function () {
    AssignedTasksFunctions.unbindElementControls();
});


var AssignedTasksFunctions = (function (AssignedTasksFunctions) {
    var self = AssignedTasksFunctions;

    var navigationOption = {
        'CURRENT_POSITION': 'assigned-to-me',
        'ASSIGNED_TO_ME': 'assigned-to-me',
        'ASSIGNED_BY_ME': 'assigned-by-me',
        'ASSIGNED_BY_OTHERS': 'assigned-by-others'
    };

    var listViewId = "assigned-tasks-list";
    var activeTab = null;
    var myId = null;
//	var tapholdActive 			= false;

    var $assignedToMe = null;
    var $assignedByMe = null;
    var $assignedByOthers = null;
    var $assignedTasksList = null;
    var $assignedTasksEmptyList = null;

    self.init = function () {
        myId = window.localStorage.getItem('userId');
        $assignedToMe = $('#assigned-to-me');
        $assignedByMe = $('#assigned-by-me');
        $assignedByOthers = $('#assigned-by-others');
        $assignedTasksList = $('#assigned-tasks-list');
        $assignedTasksEmptyList = $('#assigned-tasks-empty-list-message');
    }

    self.bindElementControls = function () {
        $(document).on('click', '#assigned-tasks #assigned-to-me', self.filterTask);
        $(document).on('click', '#assigned-tasks #assigned-by-me', self.filterTask);
        $(document).on('click', '#assigned-tasks #assigned-by-others', self.filterTask);
        $(document).on('click', '#back-link', goBack);
        $(document).on('click', '#assigned-tasks-list .upcomingTask', self.completeTaskEvent);
        $(document).on('click', '#assigned-tasks-list .assignedTask', self.completeTaskEvent);
        $(document).on('click', '#assigned-tasks-list .task-item', self.openTask);
        $("#assigned-tasks input:jqmData(type='search')").on('input', self.tasksInputEvent);
        $("#assigned-tasks").on('click', '.ui-input-clear', self.tasksInputDeleteAllEvent);
//		$(document).on('taphold', '#assigned-tasks-list .task-item', self.deleteTaskItem);

        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });
    }

    self.unbindElementControls = function () {
        $(document).off('click', '#assigned-tasks #assigned-to-me');
        $(document).off('click', '#assigned-tasks #assigned-by-me');
        $(document).off('click', '#assigned-tasks #assigned-by-others');
        $(document).off('click', '#back-link');
        $(document).off('click', '#assigned-tasks-list .upcomingTask');
        $(document).off('click', '#assigned-tasks-list .assignedTask');
        $(document).off('click', '#assigned-tasks-list .task-item');
//		$(document).off('taphold', '#assigned-tasks-list .task-item');
        $("#assigned-tasks input:jqmData(type='search')").on('input');
        $("#assigned-tasks").off('click', '.ui-input-clear');

        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
    }

    self.onPullDown = function (event, data) {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            self.refreshTasks();
            $("#assigned-tasks input:jqmData(type='search')").val('');
        }
    }

    self.onPullUp = function (event, data) {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).last().visible()) {
            self.listScrollLoadEvent();
        }
    }

    self.filterTask = function () {
        $("#assigned-tasks input:jqmData(type='search')").val('');
        if ($(this).attr("id") == null) {
            self.getTask(navigationOption['CURRENT_POSITION']);
        } else {
            if ($(this).attr("id") == navigationOption['ASSIGNED_TO_ME']) {
                navigationOption['CURRENT_POSITION'] = navigationOption['ASSIGNED_TO_ME'];
            } else if ($(this).attr("id") == navigationOption['ASSIGNED_BY_ME']) {
                navigationOption['CURRENT_POSITION'] = navigationOption['ASSIGNED_BY_ME'];
            } else {
                navigationOption['CURRENT_POSITION'] = $(this).attr("id");
            }
            self.getTask(navigationOption['CURRENT_POSITION']);
        }
    }

    self.refreshTasks = function () {
        TaskController.refresh(function () {
            self.filterTask();
        });
    }

    self.getTask = function (type) {
        activeTab = type;
        switch (type) {
            case navigationOption['ASSIGNED_TO_ME']:
                $assignedToMe.addClass("recived-tasks-icon-current").removeClass("recived-tasks-icon");
                $assignedByMe.addClass("sent-tasks-icon").removeClass("sent-tasks-icon-current");
                $assignedByOthers.addClass("recived-tasks-icon").removeClass("recived-tasks-icon-current");
                $assignedTasksList.empty();
                TaskFunctions.drawListParams[listViewId] = {
                    'start': 0,
                    'frame': "",
                    'taskType': "Completed",
                    'offset': offset
                };
                TaskFunctions.getAssignedTaskByUserId(
                        sharedUserIdForAssignedTasks, window.localStorage.getItem('userId'), null,
                        TaskFunctions.drawListParams[listViewId]['start'],
                        TaskFunctions.drawListParams[listViewId]['offset'], function (data) {
                    var tasksForDraw = [];
                    for (var i = 0; i < data.length; i++) {
                        if (data[i] != null && data[i]["owner-id"] != null && data[i]["owner-id"].text == myId) {
                            tasksForDraw.push(data[i]);
                        }
                    }
                    TaskFunctions.drawTaskListView(listViewId, tasksForDraw, "Upcoming", false);
                    self.setConnectionMode();
                });
                break;
            case navigationOption['ASSIGNED_BY_ME']:
                $assignedToMe.addClass("recived-tasks-icon").removeClass("recived-tasks-icon-current");
                $assignedByMe.addClass("sent-tasks-icon-current").removeClass("sent-tasks-icon");
                $assignedByOthers.addClass("recived-tasks-icon").removeClass("recived-tasks-icon-current");
                $assignedTasksList.empty();
                TaskFunctions.drawListParams[listViewId] = {
                    'start': 0,
                    'frame': "",
                    'taskType': "Upcoming",
                    'offset': offset
                };
                TaskFunctions.getAssignedTaskByUserId(
                        window.localStorage.getItem('userId'), sharedUserIdForAssignedTasks, null,
                        TaskFunctions.drawListParams[listViewId]['start'],
                        TaskFunctions.drawListParams[listViewId]['offset'], function (data) {
                    var tasksForDraw = [];
                    for (var i = 0; i < data.length; i++) {
                        if (data[i] != null && data[i]["author-id"] != null && data[i]["author-id"].text == myId) {
                            tasksForDraw.push(data[i]);
                        }
                    }

                    TaskFunctions.drawTaskListView(listViewId, tasksForDraw, "Upcoming", false);
                    self.setConnectionMode();
                });
                break;
            case navigationOption['ASSIGNED_BY_OTHERS']:
                $assignedToMe.addClass("recived-tasks-icon").removeClass("recived-tasks-icon-current");
                $assignedByMe.addClass("sent-tasks-icon").removeClass("sent-tasks-icon-current");
                $assignedByOthers.addClass("recived-tasks-icon-current").removeClass("recived-tasks-icon");
                $assignedTasksList.empty();
                TaskFunctions.drawListParams[listViewId] = {
                    'start': 0,
                    'frame': "",
                    'taskType': "Upcoming",
                    'offset': offset
                };
                TaskFunctions.getAssignedTaskByOther(
                        sharedUserIdForAssignedTasks, null,
                        TaskFunctions.drawListParams[listViewId]['start'],
                        TaskFunctions.drawListParams[listViewId]['offset'],
                        function (data) {
                            TaskFunctions.drawTaskListView(listViewId, data, "Upcoming", false);
                            self.setConnectionMode();
                        });
                break;
        }
    }

    self.openTask = function () {
//        if (!tapholdActive) {
        var id = null;
        var ids = [];

        id = $(this).attr('taskId');
        $(document).find("#assigned-tasks-list .task-item").each(function () {
            ids.push($(this).attr('taskId'));
        });

        gotoPage({url: "viewTask", param: {id: id, ids: ids}}, {url: "assignedTasks", param: null});
//        }
    };

    self.completeTaskEvent = function () {
        var taskId = $(this).attr('taskId');
        if (connection) {
            showActionDialog(Messages.Task.completeTaskMessage, "Yes", function () {
                showLoadingIndikator();
                TaskController.completeTask(taskId, function (item) {
                    $('[taskid=' + taskId + ']').parent().remove();
                    var liDivider = $('#' + listViewId + " li:last");
                    if (liDivider.data('role') == "list-divider") {
                        liDivider.remove();
                    }
                    if ($('#' + listViewId + ' li').length <= 1) {
                        $('#' + listViewId).append(emptyListHtml).listview('refresh');
                        ;
                    }
                    SipMessageSettingFunctions.sendInfoMessage(item["author-id"].text, {
                        taskid: item.id.text,
                        body: "Task completed!",
                        tasktext: item.body
                    }, function () {
                        $('[taskid=' + taskId + ']').parent().remove();
                        hideLoadingIndikator();
                    });
                });
            }, "No", function () {
            });
        }
    }

    self.drawTaskListPartition = function (search) {
        var searchValue = null;
        var append = false;
        if (TaskFunctions.drawListParams[listViewId]['taskType'] == "search") {
            searchValue = TaskFunctions.drawListParams[listViewId]['searchValue'];
            append = true;
        }
        if (TaskFunctions.drawListParams[listViewId]['start'] != 0) {
            append = true;
        }
        if (navigationOption['ASSIGNED_TO_ME'] == activeTab) {
            TaskFunctions.getAssignedTaskByUserId(
                    sharedUserIdForAssignedTasks, window.localStorage.getItem('userId'), searchValue,
                    TaskFunctions.drawListParams[listViewId]['start'],
                    TaskFunctions.drawListParams[listViewId]['offset'], function (data) {
                var tasksForDraw = [];
                for (var i = 0; i < data.length; i++) {
                    if (data[i] != null && data[i]["owner-id"] != null && data[i]["owner-id"].text == myId) {
                        tasksForDraw.push(data[i]);
                    }
                }
                TaskFunctions.drawTaskListView(listViewId, tasksForDraw, "Upcoming", append);
                self.setConnectionMode();
            });
        } else if (navigationOption['ASSIGNED_BY_ME'] == activeTab) {
            TaskFunctions.getAssignedTaskByUserId(
                    window.localStorage.getItem('userId'), sharedUserIdForAssignedTasks, searchValue,
                    TaskFunctions.drawListParams[listViewId]['start'],
                    TaskFunctions.drawListParams[listViewId]['offset'], function (data) {
                var tasksForDraw = [];
                for (var i = 0; i < data.length; i++) {
                    if (data[i] != null && data[i]["author-id"] != null && data[i]["author-id"].text == myId) {
                        tasksForDraw.push(data[i]);
                    }
                }

                TaskFunctions.drawTaskListView(listViewId, tasksForDraw, "Upcoming", append);
                self.setConnectionMode();
            });
        } else {
            TaskFunctions.getAssignedTaskByOther(
                    sharedUserIdForAssignedTasks, searchValue,
                    TaskFunctions.drawListParams[listViewId]['start'],
                    TaskFunctions.drawListParams[listViewId]['offset'],
                    function (data) {
                        TaskFunctions.drawTaskListView(listViewId, data, "Upcoming", append);
                        self.setConnectionMode();

                    });
        }
    }

    self.listScrollLoadEvent = function () {
//		if (($(this).scrollTop() + $(window).height()) >= ($(this).height() - 200)) {
        showLoadingIndikator();
        $(document).off('scrollstop');
        self.drawTaskListPartition();
//		}
    }

    self.tasksInputEvent = function (event) {
        if (event.currentTarget.value.length > 0) {
            TaskFunctions.drawListParams[listViewId] = {
                'start': 0,
                'frame': "",
                'taskType': "search",
                'searchValue': event.currentTarget.value,
                'offset': offset
            };
            $assignedTasksList.empty();
            self.drawTaskListPartition();
        } else {
            $assignedTasksList.empty();
            self.getTask(activeTab);
        }
    }

    self.tasksInputDeleteAllEvent = function () {
        $assignedTasksList.empty();
        self.getTask(activeTab);
    }

//	self.deleteTaskItem = function() {
//		tapholdActive = true;
//		setTimeout(function(){
//			tapholdActive = false;
//		}, 1000);
//		var taskId = $(this).attr('taskId');
//	 	if (connection) {
//	 		showActionDialog(Messages.Task.deleteTaskMessage, "Yes", function() {
//	 			showLoadingIndikator();
//	 			TaskController.findById(taskId, function(data) {
//					data = TaskController.encodeItem(data);
//					var requestObject = {
//						"taskid" : data.id.text,
//						"body" : data.body
//					}
//					TaskController.deleteTask(data.id.text, function(data){
//						if (data == 0) {
//						   	db.selectSingleRecord(models.infoMessageDBModel.name, "body", requestObject, function(data) {
//						   		if (data != null) {
//							   		var messageId = data.infoMessage._id;
//									db.deleteObject(models.infoMessageDBModel.name, "_id", messageId);
//									SipMessageSettingFunctions.setMessageStatus([{'messageid': messageId, 'status' : 5 }]);
//						   		}
//								self.filterTask();
//								hideLoadingIndikator();
//						   	});
//
//						} else {
//							hideLoadingIndikator();
//							alert(Messages.Task.deleteTaskMessageErr);
//						}
//					});
//	 			});
//	 		}, "No", function() {
//	 		});
//	 	}
//	}

    self.setConnectionMode = function () {
        if (connection) {
            $("#assigned-tasks #refresh-link").show();
            $('#assigned-tasks .upcomingTask').show();
            $('#assigned-tasks .assignedTask').show();

        } else {
            $("#assigned-tasks #refresh-link").hide();
            $('#assigned-tasks .upcomingTask').hide();
            $('#assigned-tasks .assignedTask').hide();
        }
        self.emptyList();
    }

    self.emptyList = function () {
        if ($('#assigned-tasks-list li').length == 0) {
            $assignedTasksEmptyList.show();
        } else {
            $assignedTasksEmptyList.hide();
        }
    }
    return self;
}(AssignedTasksFunctions || {}));

