currentTaskFilterType = null;
$(document).on('pageshow', '#tasks', function () {
    if (navigator.userAgent.match(/(iPad|iPhone)/)) {
        $("#call-list-link").remove();
    }

    TaskFunctions.bindElementControls();
    if (connection) {
        $('#tasks #task-list .upcomingTask').show();
        $('#tasks #all-task-list .upcomingTask').show();
        $('#tasks #task-list .assignedTask').show();
        $('#tasks #all-task-list .assignedTask').show();
    } else {
        $('#tasks #task-list .upcomingTask').hide();
        $('#tasks #all-task-list .upcomingTask').hide();
        $('#tasks #task-list .assignedTask').hide();
        $('#tasks #all-task-list .assignedTask').hide();
    }
});

$(document).on('pagehide', '#tasks', function () {
    TaskFunctions.unbindElementControls();
});


$(document).on('pageinit', '#tasks', function () {
    TaskFunctions.init();
});

var TaskFunctions = (function (TaskFunctions)
{
    var self = TaskFunctions;
    self.drawListParams = [];
    self.findTime = null;
    var TASK_TYPE = {UPCOMING: 0, ASSIGNED: 1, COMPLETED: 2, MY_UPCOMING: 3, MY_COMPLETED: 4, FAVORITES: 5, CUSTOM: 6};
    var listViewId = 'all-task-list';
    var taskId = null;
    var filterTaskTypeOption = null;
    var $filterTaskType = null;
    var $allTaskList = null;
    var $task = null;
    var $taskStatusChangeComment = null;
    var favoriteMapData = {};
//    var tapholdActive		= false;

    self.init = function () {
        //hide call list option for iOS devices
        removeCallListForIOS("main-nav-list", "tasks", "call-list-link");

        $filterTaskType = $("#filter-task-type");
        $allTaskList = $("#all-task-list");
        $task = $('#tasks');
        self.addMoreFilter('filter-task-type', function() {
          self.filterTaskTypeEvent();
        });
        self.filterTaskTypeEvent();
        NavigationController.loadUserInfo('tasks');
    };

    self.bindElementControls = function () {
        $(document).on('click', '#tasks #refresh-link', self.refreshTaskEvent);
        $(document).on('click', '#tasks #dashboard-link', self.dashboardLinkEvent);
        $(document).on('click', '#tasks #contacts-link', self.contactsLinkEvent);
        $(document).on('click', '#tasks #case-link', self.caseLinkEvent);
        $(document).on('click', '#tasks #deals-link', self.dealsLinkEvent);
        $(document).on('click', '#settings-link', self.settingsLinkEvent);
        $(document).on('click', '#tasks #tasks-link', self.tasksLinkEvent);
        $(document).on('click', '#drafts-link', self.draftLinkEvent);
        $(document).on('click', '#tasks #mygroup-link', self.myGroupLinkEvent);
        $(document).on('click', '#tasks #close-link', self.closeAplicationEvent);
        $(document).on('click', '#tasks #quit-link', self.closeAplicationEvent);
        $(document).on('click', '#tasks #menu-link', self.menuLinkEvent);
        $(document).on('click', '#tasks #all-task-list .task-item', self.allTaskItemEvent);
        $(document).on('click', '#tasks #task-count', self.allTaskItemCounterEvent);

        $(document).on('click', '#about-link', self.gotoAbout);
        $("#tasks .domain-link-info").on('click', self.gotoDomainPage);
//		$(document).on('taphold', '#tasks #all-task-list .task-item', self.deleteTaskItem);

        $(document).on('click', '#tasks #call-list-link', function () {
            gotoPage({url: "callLog", param: null}, {url: "tasks", param: null});
        });

        $("#tasks input").on('input', self.tasksInputEvent);
        $("#tasks").on('click', '.ui-input-clear', self.tasksInputDeleteAllEvent);
        $('#filter-task-type', '#tasks').on('change', self.filterTaskTypeEvent);
        $(document).on('click', '#tasks .upcomingTask', self.completeTaskEvent);
        $(document).on('click', '#tasks .assignedTask', self.completeTaskEvent);
        $(document).on('click', '#tasks .inprogressTask', self.completeTaskEvent);
        $(document).on('click', '#tasks .createdTask', self.completeTaskEvent);
        $(document).on('click', '#tasks .completedTask', self.completeTaskEvent);
        $(document).on('click', '#tasks .canceledTask', self.completeTaskEvent);
        $(document).on('click', '#tasks .float-add-action', self.addTaskLinkEvent);
        $("#tasks .app-user").on('click', self.gotoProfilPage);
        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        $(document).on('click', '#tasks .favorite-event', self.eventFavorite);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });

        $('body').on('submit', function (event) {
            event.preventDefault(); // cancel default form submit
            event.stopPropagation();
            return false;
        });

        $('.backdrop').on('click', function () {
            $('html').removeClass('sidebar-left-in');
        });

        $("body").on('swipeleft', "#tasks .sidebar", function () {
            if ($("html").hasClass("sidebar-left-in")) {
                $("html").removeClass("sidebar-left-in");
            }

        });

        $(document).on('click', '#tasks .task-list-icons', self.changeEventDueDateChildTask);

        $("body").on('swipeleft swiperight', '#all-task-list li', self.navigateToCompleteStatus);
        $(document).on('click', '#tasks .child-task-item', self.navigateToChildTask);
        $(document).on('click', '#tasks .load-task-child-btn', self.loadChildTaskEvent);
        $(document).on("click", "#tasks #app-calendar", function(){
            gotoPage({url: "calendar", param: null}, {url: "tasks", param: null});
        });
        $(document).on('click', '#overview-link', self.overviewLinkEvent);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#tasks #refresh-link');
        $(document).off('click', '#tasks #dashboard-link');
        $(document).off('click', '#tasks #contacts-link');
        $(document).off('click', '#tasks #case-link');
        $(document).off('click', '#tasks #deals-link');
        $(document).off('click', '#settings-link');
        $(document).off('click', '#drafts-link');
        $(document).off('click', '#tasks #mygroup-link');
        $(document).off('click', '#tasks #close-link');
        $(document).off('click', '#tasks #quit-link');
        $(document).off('click', '#tasks #menu-link');
        $(document).off('click', '#tasks #all-task-list div .ui-btn-text .task-item');
        $(document).off('click', '#about-link');
        $(document).off('click', '#overview-link');
        $(document).off('click', '#tasks #tasks-link');
//		$(document).off('taphold', '#tasks #all-task-list div .ui-btn-text .task-item');
        $("#tasks input").off('input');
        $("#tasks").off('click', '.ui-input-clear');
        $(document).off('click', '#tasks .upcomingTask');
        $(document).off('click', '#tasks .assignedTask');
        $(document).off('click', '#tasks .inprogressTask');
        $(document).off('click', '#tasks .createdTask');
        $(document).off('click', '#tasks .completedTask');
        $(document).off('click', '#tasks .canceledTask');
        $(document).off('click', '#tasks #all-task-list .task-item');
//		$(document).off('taphold', '#tasks #all-task-list .task-item');
        $(document).off('click', '#tasks .favorite-event');
        $(document).off('click', '#tasks #task-count');

        $(document).off('click', '#tasks .float-add-action');
        $(document).off('click', '#tasks #call-list-link');
        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
        $('.backdrop').off('click');
        $('html').removeClass('sidebar-left-in');
        $("body").off('swipeleft', "#tasks .sidebar");
        $(document).off('click', '#tasks .task-due-date-change');
        $(document).off('click', '#tasks .childTasks');
        $("body").off('swipeleft swiperight', '#all-task-list li');
        $(document).off('click', '#tasks .child-task-item');
        $(document).off('click', '#tasks .load-task-child-btn');
        $(document).off("click", "#tasks #app-calendar");
        $("#tasks .app-user").off('click');
        $("#tasks .domain-link-info").off('click');
        $(document).off('click', '#tasks .task-list-icons');
    };

    self.allTaskItemCounterEvent = function(e) {
        var id = null;
        var ids = [];
        id = $(this).parent().parent().parent().attr('taskId');
        $allTaskList.find(".task-item").each(function () {
            ids.push($(this).attr('taskId'));
        });
        gotoPage({url: "viewTask", param: {id: id, ids: ids, listParams: self.drawListParams[listViewId], selectTab:"Tasks"}}, {url: "tasks", param: null});
        e.stopPropagation();
    }

    self.changeEventDueDateChildTask = function(e) {
        var idTask = $(this).attr("taskid");
        var dueDate = $(this).attr("duedate");
        var created = $(this).attr("created");
        var displayName = $(this).attr("displayName");
        var parent = {url: "tasks", param: null, controller: TaskFunctions};
        var params = null;

        if ($(this).hasClass('md-flag')) {
            params = {
                url: "changeStatus",
                param: {
                  parentId: idTask,
                  parentType: "Task"
                }
            };
        } else if ($(this).hasClass('md-event')) {
          params = {
              url: "changeDueDate",
              param: {
                'id': idTask,
                'dueDate': dueDate
              }
          };
        } else if ($(this).hasClass('md-access-time')) {
          params = {
            url: "effort",
            param: {
              'displayName':  displayName,
              'relatedCreationDate' : created,
              'relatedType' : "Task",
              'relatedId' : idTask
            }
          };
        }
        gotoPage(params, parent);
        e.stopPropagation();
    };


    self.eventFavorite = function(e){
        var isFavorite = $(this).hasClass("contact-favorite-star");
        var taskid  = $(this).parent().attr('taskid');
        var element  = $(this);
        TaskController.findByObjectId(taskid, function(item){
            if (isFavorite) {
                 FavoriteController.findByObjectIdDB(taskid , function(data){
                    if (data[0]) {
                        FavoriteController.removeFavorite(data[0].id, function(){
                            element.toggleClass("contact-favorite-star");
                        });
                    }
                 });
            } else {
                FavoriteController.save("Task", item, function(){
                  element.toggleClass("contact-favorite-star");
                });
            }
        });
        e.stopPropagation();
    };

    self.tasksLinkEvent = function() {
        $('html').removeClass('sidebar-left-in');
    };

    self.overviewLinkEvent = function () {
        gotoPage({url: "overview", param: null});
    };

    self.gotoDomainPage = function () {
        gotoPage({url: "domain", param: null}, {url: "tasks", param: null});
    };

    self.gotoProfilPage = function(){
      gotoPage({url: "editProfil", param: null}, {url: "tasks", param: null});
    };

    self.gotoAbout = function () {
        gotoPage({url: "about", param: null}, {url: "tasks", param: null});
    };

    self.settingsLinkEvent = function () {
        gotoPage({url: "settings", param: null}, {url: "tasks", param: null});
    };

    self.onPullDown = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            self.refreshTaskEvent();
            $("input:jqmData(type='search')", '#tasks').val("");
        }
    };

    self.onPullUp = function () {
        var count = $("#all-task-list li", '#' + $.mobile.activePage.attr('id')).length;
        var bool = $($("#all-task-list li", '#' + $.mobile.activePage.attr('id'))[count - 2]).visible();

        if (bool) {
            if (self.findTime) {
                clearTimeout(self.findTime);
            }
            self.findTime = setTimeout(function () {
                var requestObject = {objectType: "Task"};
                var myTasksFilter = [{assignedTo: window.localStorage.getItem('userId')}, {
                        assignedTo: {$exists: false},
                        owner: window.localStorage.getItem('userId')
                    }, {assignedTo: {$type: 10}, owner: window.localStorage.getItem('userId')}];
                var completedTasks = ["Completed", "Canceled"];
                if (self.drawListParams[listViewId]['taskType'] != "search") {
                    if (self.drawListParams[listViewId]['taskType'] == "Upcoming") {
                        requestObject['assignedTo'] = window.localStorage.getItem('userId');
                        requestObject['status'] = {$ne: "Completed"};
                    } else if (self.drawListParams[listViewId]['taskType'] == "Assigned") {
                        requestObject['$and'] = [
                            {assignedTo: {$ne: window.localStorage.getItem('userId')}},
                            {$or: [
                                    {creator: window.localStorage.getItem('userId')},
                                    {owner: window.localStorage.getItem('userId')}
                                ]}
                        ];
                        requestObject['status'] = {$ne: "Completed"};
                    } else if (self.drawListParams[listViewId]['taskType'] == "Completed") {
                        requestObject['status'] = "Completed";
                    } else if (self.drawListParams[listViewId]['taskType'] == "MyUpcoming") {
                        requestObject.$or = myTasksFilter;
                        requestObject.status = {$nin: completedTasks};
                    } else if (self.drawListParams[listViewId]['taskType'] == "MyCompleted") {
                        requestObject.$or = myTasksFilter;
                        requestObject.status = {$in: completedTasks};
                    }
                } else {
                    requestObject['searchKeywords'] = new RegExp("^" + self.drawListParams[listViewId]['searchValue'], "i");
                }

                var dueDateSort = 1;
                if (self.drawListParams[listViewId]['taskType'] == "Completed"  || self.drawListParams[listViewId]['taskType'] == "MyCompleted") {
                    dueDateSort = -1;
                }
                var sort = [
                    ["dueDate", dueDateSort]
                ];

                self.listScrollLoad('all-task-list', requestObject, sort);
            }, 300);
        }
    };

    self.addTaskLinkEvent = function () {
        gotoPage({url: "editTask", param: null}, {url: "tasks", param: null});
    };

    self.refreshTaskEvent = function () {
        showLoadingIndikator();
        TaskController.refresh(function () {
            self.filterTaskTypeEvent();
        });
    };

    self.dashboardLinkEvent = function () {
        gotoPage({url: "dashboard", param: null});
    };

    self.contactsLinkEvent = function () {
        gotoPage({url: "contacts", param: null});
    };

    self.caseLinkEvent = function () {
        gotoPage({url: "case", param: null});
    };

    self.dealsLinkEvent = function () {
        gotoPage({url: "deals", param: null});
    };

    self.myGroupLinkEvent = function () {
        gotoPage({url: "myGroup", param: null});
    };

    self.closeAplicationEvent = function () {
        closeAplication();
    };

    self.menuLinkEvent = function () {
        $('html').addClass('sidebar-left-in');
    };

    self.allTaskItemEvent = function () {
//        if (!tapholdActive) {
        var id = null;
        var ids = [];
        id = $(this).attr('taskId');
        $allTaskList.find(".task-item").each(function () {
            ids.push($(this).attr('taskId'));
        });
        gotoPage({url: "viewTask", param: {id: id, ids: ids, listParams: self.drawListParams[listViewId]}}, {url: "tasks", param: null});
//        }
    };

    self.getTasksTaskCount = function (tasks) {
        if (tasks) {
            for (var i = 0; i < tasks.length; i++) {
                (function (num) {
                  if (connection) {
                      ClientAPI.findCount({objectType: "Task", immediateParent: new ObjectId(tasks[num].id.text)},
                        function (err, data) {
                             $("span[parentId='" + tasks[num].id.text + "']").text(data);
                     });
                  } else {
                      db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-id" = ? AND "recording-type" = ?',
                             [getTextTypeObject(tasks[num].id.text, 'integer'), "Task"],
                             models.taskDBModel.name, function (data) {
                                   $("span[parentId='" + tasks[num].id.text + "']").text(data[0]['count(*)']);
                     });
                 }
                })(i);
            }
        }
    };

    self.tasksInputEvent = function (event) {
        filterTaskTypeOption = "search";
        self.drawListParams[listViewId] = {
            'start': 0,
            'frame': "",
            'taskType': "search",
            'searchValue': event.currentTarget.value,
            'offset': offset
        };
        if (self.findTime) {
            clearTimeout(self.findTime);
        }
        self.findTime = setTimeout(function () {
            if (connection) {
                var pattern = new RegExp(event.currentTarget.value.toLowerCase().trim().replace(' ', '|'), "i");
                if (event.currentTarget.value.length > 0) {
                    var query = prepareQueryForSearch(pattern);
                    if ( $filterTaskType.val() === 'filter-custom') {
                        TaskController.findCustomTask(query, function(items){
                            self.drawTaskListView(listViewId, items, "Upcoming", false);
                        });
                    } else {
                      ClientAPI.findPaged(query, [["dueDate", 1]], 1, offset, function (err, items) {
                          if (!err) {
                              var tasks = [];
                              for (var i = 0, max = items.length; i < max; i++) {
                                  tasks.push(TaskController.encodeItem(items[i]));
                              }
                              self.drawTaskListView(listViewId, tasks, "Upcoming", false);
                          }
                      });
                    }
                } else {
                    self.filterTaskTypeEvent();
                }
            } else {
                if (event.currentTarget.value.length > 0) {
                    var queryObject = prepareQueryForSearch();
                    if (queryObject.query && queryObject.queryParams) {
                        db.selectByQuery(queryObject.query, queryObject.queryParams, 'Task', function (items) {
                            var search = [];
                            var pattern = new RegExp(event.currentTarget.value.trim().replace(' ', '|'), "i");
                            if (items != null && items.length > 0) {
                                for (var i = 0, max = items.length; i < max; i++) {
                                    for (var j = 0, len = items[i].searchKeywords.length, add = false; j < len; j++) {
                                        if (pattern.test(items[i].searchKeywords[j])) {
                                            search.push(items[i]);
                                            add = true;
                                        }
                                        if (add) {
                                            break;
                                        }
                                    }
                                }
                                search = search.splice(0, offset);
                                self.drawTaskListView(listViewId, search, "Upcoming", false);
                            } else {
                                self.filterTaskTypeEvent();
                            }
                        });
                    }
                } else {
                    self.filterTaskTypeEvent();
                }
            }
        }, 300);
    };

    var prepareQueryForSearch = function (pattern) {
        var taskType = $filterTaskType.val();
        if (connection) {
            var myTasksFilter = [{assignedTo: window.localStorage.getItem('userId')}, {
                    assignedTo: {$exists: false},
                    owner: window.localStorage.getItem('userId')
                }, {assignedTo: {$type: 10}, owner: window.localStorage.getItem('userId')}];
            var completedTasks = ["Completed", "Canceled", "Verified"];
            var query = {objectType: "Task", searchKeywords: pattern};
            switch (taskType) {
                case "filter-upcoming-tasks":
                    query.status = {$nin: completedTasks};
                    break;
                case "filter-assigned-tasks":
                    query.$and = [{owner: window.localStorage.getItem('userId')}, {assignedTo: {$ne: window.localStorage.getItem('userId')}}, {assignedTo: {$type: 2}}];
                    break;
                case "filter-completed-tasks":
                    query.status = {$in: completedTasks};
                    break;
                case "filter-my-upcoming-tasks":
                    query.$or = myTasksFilter;
                    query.status = {$nin: completedTasks};
                    break;
                case "filter-my-completed-tasks":
                    query.$or = myTasksFilter;
                    query.status = {$in: completedTasks};
                    break;
                case "filter-custom" :
                  query = JSON.parse($("#filter-task-type").find(":selected").attr('filter'));
                  query.forEach(function(element){
                    if (element.$match){
                      element.$match.searchKeywords = pattern;
                    }
                  });
                  break;
            }
            return query;
        } else {
            var query = "";
            var queryParams = [];
            switch (taskType) {
                case "filter-upcoming-tasks":
                    query = "SELECT * FROM TASK WHERE status = ? OR status = ? OR status = ? ORDER BY [due-at]";
                    queryParams = ["Created", "Assigned", "InProgress"];
                    break;
                case "filter-assigned-tasks":
                    query = 'SELECT * FROM TASK WHERE status =? AND "owner-id" = ? AND "responsible-id" != ? ORDER BY [due-at]';
                    queryParams = ["Assigned", getTextTypeObject(window.localStorage.getItem('userId'), 'integer'), getTextTypeObject(window.localStorage.getItem('userId'), 'integer')];
                    break;
                case "filter-completed-tasks":
                    query = null;
                    queryParams = null;
                    break;
                case "filter-my-upcoming-tasks":
                    query = 'SELECT * FROM TASK WHERE (status = ? OR status = ?)  AND "owner-id" = ? ORDER BY [due-at]';
                    queryParams = ["Created", "InProgress", getTextTypeObject(window.localStorage.getItem('userId'), 'integer')];
                    break;
                case "filter-my-completed-tasks":
                    query = null;
                    queryParams = null;
                    break;
            }
            return {
                query: query,
                queryParams: queryParams
            };
        }
    };

    self.tasksInputDeleteAllEvent = function () {
        $allTaskList.empty();
        self.filterTaskTypeEvent();
    };

    self.filterTaskTypeEvent = function (event) {
        var filterValue;
        if (event) {
            filterValue = $(event.currentTarget).find('option:selected').val();
        } else {
            if (currentTaskFilterType === TASK_TYPE.UPCOMING) {
                filterValue = "filter-upcoming-tasks";
            } else if (currentTaskFilterType === TASK_TYPE.ASSIGNED) {
                filterValue = "filter-assigned-tasks";
            } else if (currentTaskFilterType === TASK_TYPE.COMPLETED) {
                filterValue = "filter-completed-tasks";
            } else if (currentTaskFilterType == TASK_TYPE.MY_UPCOMING) {
                filterValue = "filter-my-upcoming-tasks";
            } else if (currentTaskFilterType == TASK_TYPE.MY_COMPLETED) {
                filterValue = "filter-my-completed-tasks";
            } else if (currentTaskFilterType == TASK_TYPE.FAVORITES) {
                filterValue = "filter-my-favorite-tasks";
            } else {
                filterValue = "filter-my-upcoming-tasks";
            }
        }
        $filterTaskType.i18n();
        $filterTaskType.val(filterValue).selectmenu('refresh');

        if (filterValue && filterValue.startsWith('filter-custom')) {
           filterValue = "filter-custom";
        }

        switch (filterValue) {
            case "filter-upcoming-tasks":
                filterTaskTypeOption = "Upcoming";
                currentTaskFilterType = TASK_TYPE.UPCOMING;
                TaskController.findUpcomingTasks(function(items){
                  self.drawListParams[listViewId] = {'start': 0, 'frame': "", 'taskType': "Upcoming", 'offset': offset};
                  self.drawTaskListView(listViewId, items, "Upcoming", false);
                });
                break;
            case "filter-assigned-tasks":
                filterTaskTypeOption = "Assigned";
                currentTaskFilterType = TASK_TYPE.ASSIGNED;
                TaskController.findAssignedTasks(function(items){
                    self.drawListParams[listViewId] = {'start': 0, 'frame': "", 'taskType': "Assigned", 'offset': offset};
                    self.drawTaskListView(listViewId, items, "Assigned", false);
                });
                break;
            case "filter-completed-tasks":
                filterTaskTypeOption = "Completed";
                currentTaskFilterType = TASK_TYPE.COMPLETED;
                TaskController.findComplitedTask(function(items){
                  self.drawListParams[listViewId] = {'start': 0, 'frame': "", 'taskType': "Completed", 'offset': offset};
                  self.drawTaskListView(listViewId, items, "Completed", false);
                });
                break;
            case "filter-my-upcoming-tasks":
                filterTaskTypeOption = "MyUpcoming";
                currentTaskFilterType = TASK_TYPE.MY_UPCOMING;
                TaskController.findMyUpcomingTask(function(items){
                  self.drawListParams[listViewId] = {'start': 0, 'frame': "", 'taskType': "MyUpcoming", 'offset': offset};
                  self.drawTaskListView(listViewId, items, "Upcoming", false);
                });
                break;
            case "filter-my-completed-tasks":
                currentTaskFilterType = TASK_TYPE.MY_COMPLETED;
                TaskController.findMyComplitedTask(function(items){
                    self.drawListParams[listViewId] = {'start': 0, 'frame': "", 'taskType': "MyCompleted", 'offset': offset};
                    self.drawTaskListView(listViewId, items, "Completed", false);
                });
                break;
            case "filter-my-favorite-tasks":
                  currentTaskFilterType = TASK_TYPE.FAVORITES;
                  TaskController.findAllFavoriteTask(function(data){
                      self.drawListParams[listViewId]["favorite"] = true;
                      self.drawListParams[listViewId] = {'start': 0, 'frame': "", 'taskType': "MyCompleted", 'offset': offset};
                      self.drawTaskListView(listViewId, data, 0, false);
                  });
                  break;
            case 'filter-custom':
                var queryData = JSON.parse($("#filter-task-type").find(":selected").attr('filter'));
                TaskController.findCustomTask(queryData, function(items) {
                  self.drawListParams[listViewId] = {'start': 0, 'frame': "", 'taskType': "MyCompleted", 'offset': offset};
                  self.drawTaskListView(listViewId, items, "Custom", false);
                });
                break;
        }
    };

    self.completeTaskEvent = function () {
        taskId = $(this).attr('taskId');
        gotoPage({
            url: "changeStatus",
            controller: ChangeStatusFunctions,
            isModal: true,
            param: {parentId: taskId, parentType: "Task"}
        }, {
            url: "tasks",
            controller: TaskFunctions,
            param: null
        });
    };

    self.listScrollLoadEvent = function () {
        if (self.findTime) {
            clearTimeout(self.findTime);
        }
        self.findTime = setTimeout(function () {
            var requestObject = {objectType: "Task"};
            if (self.drawListParams[listViewId]['taskType'] != "search") {
                if (self.drawListParams[listViewId]['taskType'] == "Upcoming") {
                    requestObject['assignedTo'] = window.localStorage.getItem('userId');
                    requestObject['status'] = {$ne: "Completed"};
                } else if (self.drawListParams[listViewId]['taskType'] == "Assigned") {
                    requestObject['$and'] = [{assignedTo: {$ne: window.localStorage.getItem('userId')}}, {$or: [{creator: window.localStorage.getItem('userId')}, {owner: window.localStorage.getItem('userId')}]}];
                    requestObject['status'] = {$ne: "Completed"};
                } else if (self.drawListParams[listViewId]['taskType'] == "Completed") {
                    requestObject['status'] = "Completed";
                }
            } else {
                requestObject['searchKeywords'] = new RegExp("^" + self.drawListParams[listViewId]['searchValue'], "i");
            }

            var dueDateSort = 1;
            if ("Completed" == self.drawListParams[listViewId]['taskType']) {
                dueDateSort = -1;
            }
            var sort = [["dueDate", dueDateSort]];

            self.listScrollLoad('all-task-list', requestObject, sort);
        }, 300);
    };

    self.listScrollLoad = function (listViewId, query, sort) {
        if (!$("html").hasClass("sidebar-left-in")) {
            if (self.findTime) {
                clearTimeout(self.findTime);
            }
            self.findTime = setTimeout(function () {
                showLoadingIndikator();
                $(document).off('scrollstop');
                if (connection) {
                    ClientAPI.findPaged(query, sort,
                            self.drawListParams[listViewId]['start'] / self.drawListParams[listViewId]['offset'] + 1,
                            self.drawListParams[listViewId]['offset'],
                            function (err, items) {
                              if (!err) {
                                  var tasks = [];
                                  for (var i = 0, max = items.length; i < max; i++) {
                                      tasks.push(TaskController.encodeItem(items[i]));
                                  }
                                  // $(document).on('scrollstop', self.listScrollLoadEvent);
                                  self.drawTaskListView(listViewId, tasks, self.drawListParams[listViewId]['taskType'], true);
                                }
                            });
                } else {
                    if (self.drawListParams[listViewId]['taskType'] != "Completed") {
                        if (filterTaskTypeOption == "MyUpcoming") {
                            db.selectByQuery('SELECT * FROM TASK WHERE (status = ? OR status = ?) AND "owner-id" = ? ORDER BY [due-at] LIMIT ?, ?', ["Created", "InProgress", getTextTypeObject(window.localStorage.getItem('userId'), 'integer'), self.drawListParams[listViewId]['start'], self.drawListParams[listViewId]['offset']], 'task', function (items) {
                                self.drawTaskListView(listViewId, items, "Upcoming", true);
                            });
                        } else if (filterTaskTypeOption == "Upcoming") {
                            db.selectByQuery('SELECT * FROM TASK WHERE status = ? OR status = ? OR status = ? ORDER BY [due-at] LIMIT ?, ?', ["Created", "Assigned", "InProgress", self.drawListParams[listViewId]['start'], self.drawListParams[listViewId]['offset']], 'task', function (items) {
                                self.drawTaskListView(listViewId, items, "Upcoming", true);
                            });
                        } else if (filterTaskTypeOption == "Assigned") {
                            db.selectByQuery('SELECT * FROM TASK WHERE status =? AND "owner-id" = ? AND "responsible-id" != ? ORDER BY [due-at] LIMIT ?, ?', ["Assigned", getTextTypeObject(window.localStorage.getItem('userId'), 'integer'), getTextTypeObject(window.localStorage.getItem('userId'), 'integer'), self.drawListParams[listViewId]['start'], self.drawListParams[listViewId]['offset']], 'task', function (items) {
                                self.drawTaskListView(listViewId, items, "Assigned", true);
                            });
                        } else if (filterTaskTypeOption == "search") {
                            db.selectByQuery('SELECT * FROM TASK ORDER BY [due-at]', [], 'Task', function (items) {
                                var searchArray = [];
                                var pattern = null;
                                if (self.drawListParams[listViewId]['searchValue'] != null && self.drawListParams[listViewId]['searchValue'] != "") {
                                    pattern = new RegExp(self.drawListParams[listViewId]['searchValue'].replace(' ', '|'), "i");
                                }

                                if (items != null && items.length > 0) {
                                    for (var i = 0, max = items.length; i < max; i++) {
                                        if (pattern) {
                                            for (var j = 0, len = items[i].searchKeywords.length, add = false; j < len; j++) {
                                                if (pattern.test(items[i].searchKeywords[j])) {
                                                    searchArray.push(items[i]);
                                                    add = true;
                                                }
                                                if (add) {
                                                    break;
                                                }
                                            }
                                        } else {
                                            searchArray.push(items[i]);
                                        }
                                    }
                                    searchArray = searchArray.splice(self.drawListParams[listViewId]['start'], self.drawListParams[listViewId]['offset']);
                                    // $(document).on('scrollstop', self.listScrollLoadEvent);
                                    self.drawTaskListView(listViewId, searchArray, self.drawListParams[listViewId]['taskType'], true);
                                } else {
                                    self.filterTaskTypeEvent();
                                }
                            });
                        }
                    } else {
                        db.selectByQuery('SELECT * FROM TASK WHERE status =? AND "owner-id" = ? ORDER BY [due-at] LIMIT ?, ?', ["Completed", getTextTypeObject(window.localStorage.getItem('userId'), 'integer'), 0, offset], 'task', function (items) {
                            self.drawTaskListView(listViewId, items, "Completed", true);
                        });
                        // $(document).on('scrollstop', self.listScrollLoadEvent);
                        hideLoadingIndikator();
                    }
                }
            }, 300);
        }
    };


    self.drawTaskListView = function (listViewId, tasks, taskType, append) {
      FavoriteController.findAllMapByTypes(["Task"], function(favoriteMap){
        favoriteMapData = favoriteMap;
          var $listView = $('#' + listViewId);
          var html = "";
          if (self.drawListParams[listViewId] == null) {
              self.drawListParams[listViewId] = {};
          }
          if (append) {
              if (tasks.length > 0) {
                  self.drawListParams[listViewId]['start'] += self.drawListParams[listViewId]['offset'];
              }
          } else {
              $listView.empty();
              self.drawListParams[listViewId]['start'] = offset;
              self.drawListParams[listViewId]['frame'] = "";
              self.drawListParams[listViewId]['offset'] = offset;
          }

            // draw tasks
            var laterTasks = [];
            for (var i = 0, max = tasks.length; i < max; i++) {
                if (tasks[i].frame != 'Later') {
                    if (self.drawListParams[listViewId]['taskType'] != "search") {
                        if (taskType != "Completed") {
                            if (self.drawListParams[listViewId]['frame'] != tasks[i].frame) {
                                self.drawListParams[listViewId]['frame'] = tasks[i].frame;
                                html += '<li data-role="list-divider" class="list-divider">' + self.drawListParams[listViewId]['frame'] + '</li>';
                            }
                        }

                        html += self.drawTaskListItem(tasks[i]);
                    } else if (self.drawListParams[listViewId]['taskType'] == "search") {
                        html += self.drawTaskListItem(tasks[i]);
                    }
                } else {
                    laterTasks.push(tasks[i]);
                }
            }

            // draw later tasks
            if (laterTasks.length > 0) {
                html += '<li data-role="list-divider" class="list-divider">Later</li>';
            }
            for (var i = 0; i < laterTasks.length; i++) {
                html += self.drawTaskListItem(laterTasks[i]);
            }

            if (html != "" || append) {
                $listView.append(html);
            } else {
                $listView.html(emptyListHtml);
            }

            hideLoadingIndikator();
            //set offline or online state for complete buttons
            self.checkOfflineState();
            $listView.i18n();
            self.getTasksTaskCount(tasks);
        });
    };

    self.addMoreFilter = function(id, callback){
      var $filterElement = $("#" + id);
      if ($filterElement) {
        TaskController.findAllFilters(function(items){
          items.forEach(function(element, index){
            $filterElement.append('<option value="filter-custom-' + index + '" filter=\''+ element.settingData.filterQuery +'\'>' + element.settingData.filterName + '</option>');
          });
          if (callback) {
            callback();
          }
        });
      }
    };

    self.checkOfflineState = function() {
      if (connection == false) {
          $('#task-list .upcomingTask', '#tasks').hide();
          $('#all-task-list .upcomingTask', '#tasks').hide();

          $('#task-list .assignedTask', '#tasks').hide();
          $('#all-task-list .assignedTask', '#tasks').hide();

          $('#task-list .createdTask', '#tasks').hide();
          $('#all-task-list .createdTask', '#tasks').hide();

          $('#task-list .inprogressTask', '#tasks').hide();
          $('#all-task-list .inprogressTask', '#tasks').hide();

          $('#task-list .completedTask', '#tasks').hide();
          $('#all-task-list .completedTask', '#tasks').hide();

          $('#task-list .canceledTask', '#tasks').hide();
          $('#all-task-list .canceledTask', '#tasks').hide();
      } else {
          $('#task-list .upcomingTask', '#tasks').show();
          $('#all-task-list .upcomingTask', '#tasks').show();

          $('#task-list .assignedTask', '#tasks').show();
          $('#all-task-list .assignedTask', '#tasks').show();

          $('#task-list .createdTask', '#tasks').show();
          $('#all-task-list .createdTask', '#tasks').show();

          $('#task-list .inprogressTask', '#tasks').show();
          $('#all-task-list .inprogressTask', '#tasks').show();

          $('#task-list .completedTask', '#tasks').show();
          $('#all-task-list .completedTask', '#tasks').show();

          $('#task-list .canceledTask', '#tasks').show();
          $('#all-task-list .canceledTask', '#tasks').show();
      }
    }

    // self.drawSimpleTaskListView = function (listViewId, tasks, append) {
    //   console.log('drawSimpleTaskListView');
    //     var $listView = $("#" + listViewId);
    //     if(!append){
    //         $listView.empty();
    //     }
    //     var html = "";
    //     for (var i = 0; i < tasks.length; i++) {
    //         html += drawSimpleTaskListItem(tasks[i]);
    //     }
    //     if (html != "") {
    //         html += "<a href='#' class='load-task-child-btn'>Load more</a>";
    //         $listView.append(html);
    //     } else {
    //         $listView.html(emptyListHtml);
    //     }
    // };

    // function drawSimpleTaskListItem(task) {
    //   console.log('drawSimpleTaskListItem- 1074');
    //     var owner = null;
    //     if (task['responsible-id'] != null && task['responsible-id'].text != null) {
    //         if (ALL_USERS[task['responsible-id'].text]) {
    //             owner = ALL_USERS[task['responsible-id'].text].name;
    //         }
    //     }
    //
    //     var statusTaskType = null;
    //     switch (task.status.toLowerCase()) {
    //         case "created":
    //             statusTaskType = "green";
    //             break;
    //         case "assigned":
    //             statusTaskType = "green";
    //             break;
    //         case "completed":
    //             statusTaskType = "orange";
    //             break;
    //         case "canceled":
    //             statusTaskType = "red";
    //             break;
    //         case "inprogress":
    //             statusTaskType = "blue";
    //             break;
    //     }
    //
    //     var html = '<li style="position:relative; border-bottom: none;">'
    //             + '<a href="#" class="child-task-item list-elem" taskId="' + task.id.text + '" >'
    //             + '<div class="content-center" style="">'
    //             + '<div class="subject truncate">' + owner + '</div>';
    //     if (task.name) {
    //         html += '<div class="title truncate" style="padding: 0px; margin:5px 0px;">' + task.name + '</div>';
    //     } else {
    //         html += '<div class="title truncate" style="padding: 0px; margin:5px 0px;">' + task.body + '</div>';
    //     }
    //
    //     html += '<div style="margin-right:80px; color:gray; margin: 5px 0px;" class="truncate"> By: ' + ALL_USERS[task['author-id'].text].name + '</div>'
    //             + '<div class="' + statusTaskType + '">' + task.status + '</div>'
    //             + '</div>'
    //             + '</a>'
    //             + '<a href="#" parentId="' + task.id.text + '" class="childTasks"><i class="md md-expand-more"></i>Tasks</a>'
    //             + '<ul id="' + task.id.text + '" data-pageCount = 1 class="list" style="display:none; margin-left:20px; width: auto;"></ul>'
    //             + '</li>';
    //     return html;
    // }


    self.drawTaskItemAvatar = function(itemData) {
      var fileUrl = ClientAPI.rootURL + '/api/db/downloadimg?objId=' + encodeURIComponent(ALL_USERS[itemData['owner-id'].text].person) + '&fieldName=' + encodeURIComponent('picture');
      var imageData = '<i class="avatar md-person  md-3x"></i>';
      if (connection && ALL_USERS[itemData['owner-id'].text]['avatar-url'] != null) {
          imageData = '<div class="content-avatar is-profile-pic" style="background-image: url(' + fileUrl + ');width:40px;"></div>';
      }
      return imageData;
    }
    self.drawTaskAssignedTo = function(itemData) {
        var html = "";

        // responsible-id;
        if (itemData.status == "Assigned" || itemData.status === "Completed") {
          if (itemData["responsible-id"]
            && itemData["responsible-id"].text
            && ALL_USERS[itemData["responsible-id"].text]
            && ALL_USERS[itemData["responsible-id"].text].name) {
              html = '<div class="deal-item-status-padding">'
                            + '<span><span data-i18n="task.assignedTo"></span>: <b>'
                            + ALL_USERS[itemData["responsible-id"].text].name + '</b></span>'
                          + '</div>';
          }
        } else {
          if (itemData["owner-id"]
            && itemData["owner-id"].text
            && ALL_USERS[itemData["owner-id"].text]
            && ALL_USERS[itemData["owner-id"].text].name) {
              html = '<div class="deal-item-status-padding">'
                            + '<span><span data-i18n="task.assignedTo"></span>: <b>'
                            + ALL_USERS[itemData["owner-id"].text].name + '</b></span>'
                          + '</div>';
          }
        }


      return html;
    }
    self.drawTaskStatusCloseDatePriority = function(itemData) {
        var statusColor = self.getStatusColor(itemData);

        var closeDate = "";
        if (itemData['alert-at'].text) {
          var dateTime = new Date(itemData['alert-at'].text);
          closeDate = '<span><span data-i18n="task.closeDate"></span>: <b>'
                + dateFormat(dateTime) + " " + timeFormat(dateTime)
                + '</b></span>' + " | ";
        }

        var priorityColor = "green";
        if (itemData['priority'] === "High") {
          priorityColor = "red";
        }
        var html = "";
        html = '<div class="deal-item-status-padding">'
                      + closeDate
                      + '<span><span data-i18n="task.status"></span>: <b class="' + statusColor + '">' + itemData['status']+ '</b></span>' + " | "
                      + '<span><span data-i18n="task.priority"></span>: <b class='+ priorityColor +'>' + itemData['priority'] + '</b></span>'
                + '</div>';
        return html;
    }

    self.drawTaskRelatedTo = function(itemData) {
        var relatedTo = "";
        if (itemData['subjectDes'] != null && itemData['subjectDes'] != "") {
            var subjectType = "";
            if ("Party" == itemData['subject-type']) {
                subjectType = "<span>" + itemData['recording-type'] + "</span>: ";
            }
            relatedTo =  '<div class="deal-item-status-padding">'
            + subjectType + '<b>' + itemData['subject-name'] + '</b></div>';
        }
        return relatedTo;
    }

    self.getStatusColor = function(itemData){
        var statusTaskType = "";
        switch (itemData.status.toLowerCase()) {
            case "created":
                statusTaskType = "green";
                break;
            case "assigned":
                statusTaskType = "green";
                break;
            case "completed":
                statusTaskType = "orange";
                break;
            case "canceled":
                statusTaskType = "red";
                break;
            case "inprogress":
                statusTaskType = "blue";
                break;
            case "verified":
                statusTaskType = "green";
                break;
        }
        return statusTaskType;
    }

    self.drawTaskCompleteDueDate = function(itemData) {
      var  html = '<div class="deal-item-status-padding">'
           + '<i class="md-flag md-2x task-list-icons" taskid="' + itemData.id.text + '" duedate="' + itemData['due-at'].text + '"></i>'
           + '<i class="md-event md-2x task-list-icons" taskid="' + itemData.id.text + '" duedate="' + itemData['due-at'].text + '"></i>'
           + '<i class="md-access-time md-2x task-list-icons" taskid="' + itemData.id.text
           + '" duedate="' + itemData['due-at'].text + '" displayName="'
           + itemData.name + '" created="'+itemData['created-at'].text +'"></i>'
           + '</div>';
        return html;
    }

    self.drawTaskListItem = function (itemData) {

      var imageData = self.drawTaskItemAvatar(itemData);
      var starColor = favoriteMapData[itemData.id.text] ? "contact-favorite-star" : "";
      var assignedTo = self.drawTaskAssignedTo(itemData);
      var status = self.drawTaskStatusCloseDatePriority(itemData);
      var relatedTo = self.drawTaskRelatedTo(itemData);
      var dueDateAndComplited = self.drawTaskCompleteDueDate(itemData);
      var html = "<li><a taskId='" + itemData.id.text + "' class='task-item list-item-el'>";
          html += '<div class="favorite-event ' + starColor + '" style="float:left;">'
                  + '<span class="is-contact-image" style="padding: 5px 0px 10px 10px;">'
                    +  imageData
                    + '</span>'
                    + '<span style="padding-left:20px">'
                        + '<i class="md-grade md-lg"></i>'
                    + '</span>'
                + '</div>'
                + '<div class="content-center" style="padding-left:60px;">'
                  + '<div class="title bold">'
                     + '<span> ('+ itemData.entityId + ') </span>'
                     + '<span>' + itemData.name + '</span>'
                 + '</div>'
                 + '<div>'
                     + '<span class="case-item-status-padding"><b>'+ ALL_USERS[itemData['owner-id'].text].name + '</b></span>'
                     + '<span class="case-item-status-padding" data-i18n="task.createdTaskOn"></span>'
                     + '<span class="deal-item-padding">'
                         + dateFormat(new Date(itemData['created-at'].text)) + " " + timeFormat(new Date(itemData['created-at'].text))
                     + '</span>'

                     + relatedTo
                     + status
                     + assignedTo
                     + '<div id="task-count" class="deal-item-status-padding">'
                       + '<span data-i18n="case.tasks"></span>:'
                       + '<span class="task-count" parentId="' + itemData.id.text + '"></span>'
                     + '</div>'
                     + dueDateAndComplited
                 + '</div>'
             + '</div>'
       html += "</a></li>"
       return html;
    }

    //refaktorisati
    self.getTaskByUserPhoneWithCharacter = function (phone, callback) {
        self.getTaskByUserPhone(phone, function (data) {
            if (data.name == "Unknown") {
                if (phone[0] != "+") {
                    var p = "+" + phone;
                    self.getTaskByUserPhone(p, function (data) {
                        if (data.name == "Unknown") {
                            if (phone[0] != "0") {
                                var p2 = "0" + phone;
                                self.getTaskByUserPhone(p2, function (data) {
                                    if (callback) {
                                        callback(data);
                                    }
                                });
                            } else {
                                var p2 = phone.substring(1, phone.length);
                                self.getTaskByUserPhone(p2, function (data) {
                                    if (callback) {
                                        callback(data);
                                    }
                                });
                            }
                        } else {
                            if (callback) {
                                callback(data);
                            }
                        }
                    });
                } else {
                    var p = phone.substring(1, phone.length);
                    self.getTaskByUserPhone(p, function (data) {
                        if (data.name == "Unknown") {
                            if (p[0] != "0") {
                                var p2 = "0" + p;
                                self.getTaskByUserPhone(p2, function (data) {
                                    if (callback) {
                                        callback(data);
                                    }
                                });
                            } else {
                                var p2 = p.substring(1, phone.length);
                                self.getTaskByUserPhone(p2, function (data) {
                                    if (callback) {
                                        callback(data);
                                    }
                                });
                            }
                        } else {
                            if (callback) {
                                callback(data);
                            }
                        }
                    });
                }
            } else {
                if (callback) {
                    callback(data);
                }
            }
        });
    };

    self.getTaskByUserPhone = function (phone, callback) {
        var userTask = [];
        var userNote = [];
        var companyName = [];

        if (phone != null) {
            var type = 'user';
            var userObject = MyGroupFunctions.findUserByPhone(phone);
            if (!userObject) {
                userObject = MyGroupFunctions.findContact(phone);
                type = 'contact';
            }
            if (userObject) {
                if (type == 'user') {
                    var id = window.localStorage.getItem('userId');
                    db.selectByQuery('SELECT * FROM TASK WHERE ("responsible-id" =? AND "author-id"=?) OR ("responsible-id" =? AND "author-id"=?)',
                            [getTextTypeObject(userObject.id, 'integer'), getTextTypeObject(id, 'integer'),
                                getTextTypeObject(id, 'integer'), getTextTypeObject(userObject.id, 'integer')],
                            'task', function (data) {
                                $(data).each(function (index, value) {
                                    if (value.status != null) {
                                        if (value.status != "completed") {
                                            var temp = value['created-at'].text.split('T');
                                            var date = temp[0];
                                            var time = temp[1].substring(0, temp[1].length - 4);
                                            userTask.push({
                                                body: value.body,
                                                author: 'Author: ' + ALL_USERS[value['author-id'].text].name,
                                                owner: 'Owner: ' + ALL_USERS[value['owner-id'].text].name,
                                                created: 'Created ' + date + ' at ' + time,
                                                category: 'Category: ',
                                                status: 'Status: ' + value.frame,
                                                type: value.status
                                            });
                                        }
                                    } else {
                                        if (value['task'].status != null) {
                                            if (value['task'].status != "completed") {
                                                var temp = value['task']['created-at'].text.split('T');
                                                var date = temp[0];
                                                var time = temp[1].substring(0, temp[1].length - 4);
                                                var taskCat = value['category-id'].text == null ? '' : taskCategory[value['category-id'].text].name;
                                                userTask.push({
                                                    body: value['task'].body,
                                                    author: 'Author: ' + ALL_USERS[value['task']['author-id'].text].name,
                                                    owner: 'Owner: ' + ALL_USERS[value['task']['owner-id'].text].name,
                                                    created: 'Created ' + date + ' at ' + time,
                                                    category: 'Category: ',
                                                    status: 'Status: ' + value['task'].frame,
                                                    type: value['task'].status
                                                });
                                            }
                                        }
                                    }
                                });
                                ClientAPI.findPaged({objectType: "Note", owner: userObject.id},
                                [['modificationDate', -1]], 1, 2, function (err, data) {

                                    $(data).each(function (index, value) {
                                        userNote.push({
                                            body: value.note,
                                            author: "Note by " + ALL_USERS[value.creator].name,
                                            date: dateFormat(new Date(value['creationDate']))
                                        });
                                    });

                                    if (callback) {
                                        callback({
                                            tasks: userTask,
                                            notes: userNote,
                                            company: 'Unknown',
                                            name: userObject.name
                                        });
                                    }
                                });
                            });
                } else {
                    db.selectByColumn(models.taskDBModel.name, "subject-id", getTextTypeObject(userObject.id, 'integer'), function (data) {
                        $(data).each(function (index, value) {
                            if (value['task'].status != "completed") {
                                var temp = value['task']['created-at'].text.split('T');
                                var date = temp[0];
                                var time = temp[1].substring(0, temp[1].length - 4);
                                userTask.push({
                                    body: value['task'].body,
                                    author: 'Author: ' + ALL_USERS[value['task']['author-id'].text].name,
                                    owner: 'Owner: ' + ALL_USERS[value['task']['owner-id'].text].name,
                                    created: 'Created ' + date + ' at ' + time,
                                    category: 'Category: ',
                                    status: 'Status: ' + value['task'].frame,
                                    type: value['task'].status
                                });
                            }
                        });

                        ClientAPI.findPaged({objectType: "Note", $or: [{immediateParent: new ObjectId(userObject.id)}, {rootObject: new ObjectId(userObject.id)}]},
                        [['modificationDate', -1]], 1, 2, function (err, data) {

                            $(data).each(function (index, value) {
                                userNote.push({
                                    body: value.note,
                                    author: "Note by " + ALL_USERS[value.creator].name,
                                    date: dateFormat(new Date(value['creationDate']))
                                });
                            });

                            if (callback) {
                                callback({
                                    tasks: userTask,
                                    notes: userNote,
                                    company: userObject.company != null ? userObject.company : 'Unknown',
                                    name: userObject.name,
                                    avatar: userObject.avatar
                                });
                            }
                        });
                    });
                }
            } else {
                if (callback) {
                    callback({
                        tasks: [],
                        notes: [],
                        company: 'Unknown',
                        name: 'Unknown'
                    });
                }
            }
        } else {
            if (callback) {
                callback({
                    tasks: [],
                    notes: [],
                    company: 'Unknown',
                    name: 'Unknown'
                });
            }
        }
    };

    self.getAssignedTaskByUserId = function (ownerId, responseId, search, start, offset, callback) {
        var result = [];
        var myId = window.localStorage.getItem('userId');

        if (self.findTime) {
            clearTimeout(self.findTime);
        }
        self.findTime = setTimeout(function () {
            if (connection) {
                var requestObject = {
                    objectType: "Task",
                    $or: [{owner: ownerId}, {creator: ownerId}],
                    assignedTo: responseId,
                    status: {$ne: "Completed"}
                };

                if (search != null) {
                    requestObject['searchKeywords'] = new RegExp("^" + search.replace(' ', '|'), "i");
                }

                ClientAPI.findPaged(requestObject, [["dueDate", 1]], start / offset + 1, offset, function (err, data) {
                    if (err == null) {
                        result = [];
                        for (var i = 0, max = data.length; i < max; i++) {
                            var item = TaskController.encodeItem(data[i]);
                            result.push(item);
                        }

                        if (callback != null && typeof callback == "function") {
                            callback(result);
                        }
                    } else {
                        if (callback != null && typeof callback == "function") {
                            callback([]);
                        }
                    }
                });
            } else {
                //TESTIRATI

                var queryDate = [];
                var query = 'SELECT * FROM TASK WHERE (("owner-id" =? OR "author-id"=?) AND "responsible-id" =?) ORDER BY [due-at]';

                queryDate.push(getTextTypeObject(ownerId, 'integer'));
                queryDate.push(getTextTypeObject(ownerId, 'integer'));
                queryDate.push(getTextTypeObject(responseId, 'integer'));

                db.selectByQuery(query, queryDate, 'Task', function (items) {
                    var searchArray = [];
                    var pattern = null;
                    if (search) {
                        pattern = new RegExp("^" + event.currentTarget.value.replace(' ', '|'), "i");
                    }
                    if (items != null && items.length > 0) {
                        for (var i = 0, max = items.length; i < max; i++) {
                            if (search) {
                                for (var j = 0, len = items[i].searchKeywords.length, add = false; j < len; j++) {
                                    if (pattern.test(items[i].searchKeywords[j])) {
                                        searchArray.push(items[i]);
                                        add = true;
                                    }
                                    if (add) {
                                        break;
                                    }
                                }
                            } else {
                                searchArray.push(items[i]);
                            }
                        }
                        searchArray = searchArray.splice(start, offset);
                        if (callback != null && typeof callback == "function") {
                            callback(searchArray);
                        }
                    } else {
                        if (callback != null && typeof callback == "function") {
                            callback([]);
                        }
                    }
                });
            }
        }, 300);
    };

    self.getAssignedTaskByOther = function (userId, search, start, offset, callback) {
        var myId = window.localStorage.getItem('userId');

        var requestObject = {
            objectType: "Task",
            status: {$ne: "Completed"},
            creator: {$ne: myId},
            assignedTo: userId
        };
        if (self.findTime) {
            clearTimeout(self.findTime);
        }
        self.findTime = setTimeout(function () {
            if (search) {
                requestObject['searchKeywords'] = new RegExp("^" + search.replace(' ', '|'), "i");
            }

            if (connection) {
                ClientAPI.findPaged(requestObject, [["dueDate", 1]],
                        start / offset + 1, offset, function (err, data) {

                            if (err == null) {
                                result = [];
                                for (var i = 0, max = data.length; i < max; i++) {
                                    var item = TaskController.encodeItem(data[i]);
                                    if (item["owner-id"] != null && item["owner-id"].text != myId &&
                                            item["author-id"] != null && item["author-id"].text != myId) {
                                        result.push(item);
                                    }
                                }
                                if (callback != null && typeof callback == "function") {
                                    callback(result);
                                }

                            } else {
                                if (callback != null && typeof callback == "function") {
                                    callback([]);
                                }
                            }
                        });
            } else {
                //TESTIRATI
                var queryDate = [];
                var query = 'SELECT * FROM TASK WHERE ("owner-id" =? AND "author-id" != ?) ORDER BY [due-at]';
                queryDate.push(getTextTypeObject(userId, 'integer'));
                queryDate.push(getTextTypeObject(myId, 'integer'));

                db.selectByQuery(query, queryDate, 'Task', function (items) {
                    var searchArray = [];
                    var pattern = null;

                    if (search) {
                        pattern = new RegExp("^" + event.currentTarget.value.replace(' ', '|'), "i");
                    }

                    if (items != null && items.length > 0) {
                        for (var i = 0, max = items.length; i < max; i++) {
                            if (items[i]["owner-id"] != null && items[i]["owner-id"].text != myId && items[i]["author-id"] != null && items[i]["author-id"].text != myId) {
                                if (search) {
                                    for (var j = 0, len = items[i].searchKeywords.length, add = false; j < len; j++) {
                                        if (pattern.test(items[i].searchKeywords[j])) {
                                            searchArray.push(items[i]);
                                            add = true;
                                        }
                                        if (add) {
                                            break;
                                        }
                                    }
                                } else {
                                    searchArray.push(items[i]);
                                }
                            }
                        }
                        searchArray = searchArray.splice(start, offset);
                        if (callback != null && typeof callback == "function") {
                            callback(searchArray);
                        }
                    } else {
                        if (callback != null && typeof callback == "function") {
                            callback([]);
                        }
                    }
                });
            }
        }, 300);
    };

    self.getChildTasks = function () {
        $("i", this).toggleClass("md-expand-more md-expand-less");
        var parentId = $(this).attr("parentId");
        $("ul[id='" + parentId + "']").attr('data-pageCount', 1);
        if (connection) {
            var request = {objectType: "Task", immediateParent: new ObjectId(parentId)};
            ClientAPI.findPaged(request, [["dueDate", 1]], 1, offset, function (err, items) {
                if (items && items.length > 0) {
                    var tasks = [];
                    for (var i = 0; i < items.length; i++) {
                        tasks.push(TaskController.encodeItem(items[i]));
                    }
                    TaskFunctions.drawSimpleTaskListView(parentId, tasks);
                    if (tasks.length < offset) {
                        $("ul[id='" + parentId + "'] .load-task-child-btn").remove();
                    }
                    // for (var i = 0; i < tasks.length; i++) {
                    //     (function (num) {
                    //         ClientAPI.findCount({
                    //             objectType: "Task",
                    //             immediateParent: new ObjectId(tasks[num].id.text)
                    //         },
                    //         function (err, data) {
                    //             if (!err) {
                    //                 if (data == 0) {
                    //                     $("a[parentId='" + tasks[num].id.text + "']").remove();
                    //                 } else {
                    //                     $("a[parentId='" + tasks[num].id.text + "']").append("(" + data + ")");
                    //                 }
                    //             }
                    //         });
                    //     })(i);
                    // }
                    // $("#tasks ul [id='" + parentId + "']").toggle();
                }
            });
        } else {
            db.selectByQuery('SELECT * FROM TASK WHERE [recording-id] = ? AND [recording-type] = ? LIMIT ?, ?', [getTextTypeObject(parentId, 'integer'), "Task", 0, offset], 'task', function (items) {
                TaskFunctions.drawSimpleTaskListView(parentId, items);
                $("ul[id='" + parentId + "'] .load-task-child-btn").remove();
                // for (var i = 0; i < items.length; i++) {
                //     (function (num) {
                //         db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-id" = ? AND "recording-type" = ?',
                //                 [getTextTypeObject(items[num].id.text, 'integer'), "Task"], models.taskDBModel.name, function (data) {
                //             if (data[0]['count(*)'] == 0) {
                //                 $("a[parentId='" + items[num].id.text + "']").remove();
                //             } else {
                //                 $("a[parentId='" + items[num].id.text + "']").append(" (" + data[0]['count(*)'] + ")");
                //             }
                //         });
                //     })(i);
                // }
                // $("#tasks ul [id='" + parentId + "']").toggle();
            });
        }
    };

    self.navigateToCompleteStatus = function (e) {
        e.stopPropagation();
        var $element = $(this).children('a');
        var taskId = $element.attr('taskId');
        if (taskId) {
            self.completeOnSwipe(taskId, function () {
                gotoPage({
                    url: "changeStatus",
                    controller: ChangeStatusFunctions,
                    isModal: true,
                    param: {parentId: taskId, parentType: "Task", toComplete: "yes"}
                }, {
                    url: "tasks",
                    controller: TaskFunctions,
                    param: null
                });
            });
        }
    };

    self.completeOnSwipe = function (id, callback) {
        if (connection) {
            ClientAPI.find({objectType: "Task", _id: new ObjectId(id)}, null, function (err, data) {
                if (!err) {
                    if (data && data.length > 0 && data[0] && data[0].status != "Completed" && data[0].status != "Canceled") {
                        callback();
                    }
                }
            });
        }
    };

    self.draftLinkEvent = function () {
        gotoPage({url: "draft", param: null}, {url: "tasks", param: null});
    };

    self.navigateToChildTask = function(){
        var id = $(this).attr('taskId');
        var taskIds = [];
        var $parent = $(this).parent().parent();
        $parent.find('.child-task-item').each(function(){
           taskIds.push($(this).attr('taskId'));
        });
        var currentPage = $parent.attr('data-pageCount');
        currentPage = parseInt(currentPage);
        if(currentPage > 1){
            gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), childPage: currentPage + 1, offset: 30}}}, {url: "tasks", param: null});
        } else {
            gotoPage({url: "viewTask", param: {id: id, ids: taskIds, listParams: {parentId: $parent.attr('id'), start: 30, offset: 30}}}, {url: "tasks", param: null});
        }
    };

    self.loadChildTaskEvent = function () {
        var taskId = $(this).parent().attr('id');
        var pageCount = $(this).parent().attr('data-pageCount');
        $(this).parent().attr('data-pageCount', ++pageCount);
        var $that = $(this);
        if (connection) {
            self.loadMoreChildTasks(taskId, pageCount, $that);
        }
    };

    self.loadMoreChildTasks = function (taskId, page, $that) {
        ClientAPI.findPaged({objectType: "Task", immediateParent: new ObjectId(taskId)}, [["dueDate", 1]], page, offset, function (err, data) {
            if (data && data.length > 0) {
                $that.remove();
                var tasks = [];
                for (var i = 0; i < data.length; i++) {
                    tasks.push(TaskController.encodeItem(data[i]));
                }
                TaskFunctions.drawSimpleTaskListView(taskId, tasks, true);
                // for (var i = 0; i < tasks.length; i++) {
                //     (function (num) {
                //         ClientAPI.findCount({
                //             objectType: "Task",
                //             immediateParent: new ObjectId(tasks[num].id.text)
                //         },
                //                 function (err, data) {
                //                     if (!err) {
                //                         if (data == 0) {
                //                             $("a[parentId='" + tasks[num].id.text + "']").remove();
                //                         } else {
                //                             $("a[parentId='" + tasks[num].id.text + "']").append("(" + data + ")");
                //                         }
                //                     }
                //                 });
                //     })(i);
                // }
            }
        });
    };

    return self;
}(TaskFunctions || {}));
