$(document).on('pageinit', '#view-task', function () {
    ViewTaskFunctions.init();
    $("#view-task-general-content").click(function () {
        $(".navigation_button").toggle("slow");
    });
});

$(document).on('pageshow', '#view-task', function () {
    ViewTaskFunctions.bindElementControls();
    ViewTaskFunctions.setConnectionMode();
    setTimeout(function () {
        $("#view-task .swipe-indicator").fadeOut("400");
    }, 1000);
});

$(document).on('pagehide', '#view-task', function () {
    ViewTaskFunctions.unbindElementControls();
});

var ViewTaskFunctions = (function (ViewTaskFunctions) {
    var self = ViewTaskFunctions;
    var task = null;
    var taskId = null;
    var taskIds = null;
    var listParams = {};
    var currentTaskIndex = null;
    var taskObject = null;
    var $generalTab = null;
    var $notesTab = null;
    var $generalContent = null;
    var $notesContent = null;
    var $parentDescription = null;
    var $parentHeading = null;
    var $authorDescription = null;
    var $ownerDescription = null;
    var $bodyBox = null;
    var $bodyDescription = null;
    var $priorityDescription = null;
    var $statusDescription = null;
    var $dueDateHeading = null;
    var $dueDateDescription = null;
    var $categoryBox = null;
    var $categoryDescription = null;
    var $viewTasksPermissionList = null;
    var $secondNavigationContainer = null;
    var $tasksMoreLink = null;
    var $taskPopup = null;
    var $title = null;
    var $notesLinkContainer = null;
    var $taskTasksText = null;
    var $taskAttachLinkText = null;
    var $attachContainer = null;
    var $attachList = null;
    var attachments = null;
    self.currentTab = null;
    var $addLink = null;
    var $attachTab = null;
    var $effortContainer = null;
    var $effortCount = null;
    var $effortTable = null;

    self.init = function () {
        showLoadingIndikator();
        self.selectElements();
        $("#view-task #filter-tasks-task-type").i18n();
        $("#view-task #filter-tasks-task-type").selectmenu('refresh', true);
        self.currentTab = "General";
        if (pageObject) {
            taskId = pageObject.id;
            taskIds = pageObject.ids;
            listParams = pageObject.listParams;
            self.currentTab = pageObject.selectTab;
            pageObject = null;
        }

        // pagination
        if (taskIds && taskIds.length > 1) {
            currentTaskIndex = taskIds.indexOf(taskId);
            $title.text("(" + (currentTaskIndex + 1) + "/" + taskIds.length + ")");
        } else {
            $title.text("");
        }
        // load task
        showLoadingIndikator();
        self.taskCounter();
        FavoriteController.findByObjectIdDB(taskId, function(data){
            if (data && data.length > 0) {
                $('.md-star').addClass('contact-favorite-star');
            }
        });
    };

    self.taskCounter = function() {
      if (connection) {
          ClientAPI.find({objectType: "Task", _id: new ObjectId(taskId)}, null, function (err, data) {
              if (data != null) {
                  task = TaskController.encodeItem(data[0]);
                  ClientAPI.getFeed(
                          [
                              {$or:
                                          [
                                              {objectId: new ObjectId(data[0]['_id'])},
                                              {immediateParent: new ObjectId(data[0]['_id'])},
                                              {rootObject: new ObjectId(data[0]['_id'])}
                                          ]
                              },
                              {visible: false}
                          ],
                          [['eventDate', -1]], 1, 100,
                          function (err, feedItems) {
                            hideLoadingIndikator();
                              if (!err) {
                                  var feedElements = feedItems.filter(function (item) {
                                      if (item.objectType != 'Note' && item.objectType != 'Comment') {

                                          if (item.eventType == 'GrantedAccess') {
                                              item.grantedTo = item.info.split('; ');
                                              item.grantedTo = item.grantedTo.slice(0, item.grantedTo.length - 1);
                                          }
                                          return true;
                                      }
                                  });
                                  self.loadElement();
                                  if (feedElements) {
                                      self.loadItemHistory(feedElements);
                                  }
                              } else {
                                  self.loadElement();
                              }

                              self.getAttachmentCount(function (count, attachment) {
                                  $taskAttachLinkText.text("(" + count + ")");
                                  attachments = attachment;
                                  if (self.currentTab == "Attachment") {
                                      self.loadAttachment();
                                  }
                              });
                          }
                  );
              }
          });

      } else {
          db.selectSingleRecord(models.taskDBModel.name, "id", getTextTypeObject(taskId, 'integer'), function (data) {
              task = data.task;
              if (self.currentTab == 'Note') {
                  self.drawNotes();
              } else if (self.currentTab == 'Tasks') {
                self.drawTaskList();
              } else {
                  self.drawGeneral();
              }
              $notesTab.text('(0)');

              db.selectByQuery('SELECT count(*) FROM ' + models.taskDBModel.name + ' WHERE "recording-type" =? AND "recording-id" = ?',
                      ['Task', getTextTypeObject(task.id.text, 'integer')], models.taskDBModel.name, function (data) {
                  $taskTasksText.text('(' + data[0]['count(*)'] + ')');
              });

              hideLoadingIndikator();
          });
      }
    }

    self.activateTab = function (tabName) {
        switch (tabName) {
            case "General":
                $notesLinkContainer.removeClass("btn-active");
                $("#view-task #view-task-tasks-link").removeClass("btn-active");
                $attachTab.removeClass("btn-active");
                $generalTab.addClass("btn-active");
                break;
            case "Note":
                $generalTab.removeClass("btn-active");
                $("#view-task #view-task-tasks-link").removeClass("btn-active");
                $attachTab.removeClass("btn-active");
                $notesLinkContainer.addClass("btn-active");
                break;
            case "Tasks":
                $generalTab.removeClass("btn-active");
                $notesLinkContainer.removeClass("btn-active");
                $attachTab.removeClass("btn-active");
                $("#view-task #view-task-tasks-link").addClass("btn-active");
                break;
            case "Attachment":
                $generalTab.removeClass("btn-active");
                $notesLinkContainer.removeClass("btn-active");
                $("#view-task #view-task-tasks-link").removeClass("btn-active");
                $attachTab.addClass("btn-active");
                break;

        }
    };

    self.selectElements = function () {
        $generalTab = $("#view-task-general-link");
        $notesTab = $("#view-task-notes-link-text");
        $notesLinkContainer = $("#view-task-notes-link");
        $generalContent = $("#view-task-general-content");
        $notesContent = $("#view-task-notes-content");
        $parentHeading = $('#view-task-parent-label');
        $parentDescription = $('#parent-info');
        $bodyBox = $("#body-info");
        $bodyDescription = $(".description", "#body-info");
        $authorDescription = $("#author-info");
        $ownerDescription = $("#owner-info");
        $priorityDescription = $("#priority-info");
        $statusDescription = $("#status-info");
        $dueDateHeading = $("#due-date-title");
        $dueDateDescription = $("#duo-date-info");
        $categoryDescription = $("#category-info");
        $viewTasksPermissionList = $("#user-task-permission-list");
        $secondNavigationContainer = $("#second-navigation-container");
        $tasksMoreLink = $("#task-more-link");
        $taskPopup = $("#view-task .advanced-menu");
        $title = $("#view-task-title");
        $taskTasksText = $("#view-task #view-task-tasks-link-text");
        $taskAttachLinkText = $("#view-task #view-task-attach-link-text");
        $attachContainer = $("#view-task #view-task-attach-content");
        $attachList = $("#view-task #view-task-attach-list");
        $addLink = $("#view-task #view-task-add-link");
        $attachTab = $("#view-task #view-task-attach-link");
        $effortContainer = $("#view-task #effort-count-container");
        $effortCount = $("#view-task #effort-count");
        $effortTable = $("#view-task .efforts-container");
    };

    self.floatButton = function() {
        var id = $(this).parent().parent().attr('id');
        if (id === "view-task-general-content") {
          self.editTask();
        } else if (id === "view-task-tasks-content" || id === "view-task-notes-content"){
          self.addLinkEvent();
        } else {
          self.openFloatButtonAttachment();
        }
    };

    self.bindElementControls = function () {
        $(document).on('click', '#view-task #back-link', self.backLinkEvent);
        $(document).on('click', '#view-task #view-task-general-link', self.drawGeneral);
        $(document).on('click', '#view-task #view-task-notes-link', self.drawNotes);
        $(document).on('click', '#view-task #view-task-tasks-list .task-item', self.gotoTask);
        $(document).on('click', "#view-task #view-task-notes-list .note", self.openNote);
        $(document).on('click', '#view-task #check-tasks', self.setStatusForTask);
        $(document).on('click', '#view-task #status-info', self.setStatusForTask);
        $(document).on('click', '#view-task #priority-info', self.setPriorityForTask);
        $(document).on('click', '#view-task #task-completion-info', self.setProgressForTask);
        $(document).on('click', '#view-task #parent-info', self.openParent);
        $(document).on('click', '#task-more-link', self.openTaskOptionsPopup);
        $(document).on('click', '#edit-tasks', self.editTask);
        $(document).on('click', '#delete-tasks', self.taskDeleteLinkEvent);
        $(document).on('click', '#view-task .float-add-action', self.floatButton);
        $(document).on('click', '#view-task .task-list-icons', TaskFunctions.changeEventDueDateChildTask);
        $(document).on('click', '#view-task #author-info', self.openAuthorEvent);


        $('#view-task .popup-menu-backdrop').on('click', function () {
            $("#view-task .advanced-menu").hide();
            $("#view-task .attach-advanced-menu").hide();
            $(this).hide();
        });

        $("body").on("swipeleft", "#view-task", self.swipeLeftEvent);
        $("body").on("swiperight", "#view-task", self.swipeRightEvent);

        $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
        $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);

        $("body").on("scrollstart", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
            $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        });

        $("body").on("scrollend", '#' + $.mobile.activePage.attr('id'), function () {
            $("body").on("swipeup", '#' + $.mobile.activePage.attr('id'), self.onPullUp);
            $("body").on("swipedown", '#' + $.mobile.activePage.attr('id'), self.onPullDown);
        });
        $(document).on('click', "#view-task #view-task-tasks-link", self.drawTaskList);
        $(document).on('change', '#view-task #filter-tasks-task-type', self.filterTasks);
        $(document).on('click', '#view-task #view-task-tasks-list .createdTask', self.completeTaskEvent);
        $(document).on('click', '#view-task #view-task-tasks-list .assignedTask', self.completeTaskEvent);
        $(document).on('click', '#view-task #view-task-tasks-list .completedTask', self.completeTaskEvent);
        $(document).on('click', '#view-task #view-task-tasks-list .inprogressTask', self.completeTaskEvent);
        $(document).on('click', '#view-task #view-task-tasks-list .canceledTask', function () {
            alert("Status change is not allowed!");
        });
        $(document).on("click", "#view-task .efforts-container", self.viewItemVisibleToggle);
        $(document).on("click", "#view-task .task-due-date-change", self.gotoDueDateChange);
        $(document).on('click', '#view-task .comment-container', self.drawNoteComments);
        $(document).on('click', '#view-task #favorite-tasks', self.setAsFavorite);
        $(document).on('click', '#view-task #favorite-tasks-mouseover', self.setAsFavorite);
        $(document).on("click", "#view-task .view-item-history", self.viewItemVisibleToggle);
        $(document).on('click', '#view-task #view-task-attach-add-link', function () {
            console.log("attach button");
        });

        $(document).on('click', '#view-task #view-task-attach-link', self.loadAttachment);
        $(document).on('click', '#view-task .delete-item', self.deleteAttachment);
        $(document).on('click', '#view-task #view-task-add-link', self.addLinkEvent);
        $(document).on('click', '#view-task #take-photo', self.takePhoto);
        $(document).on('click', '#view-task #choose-from-gallery', self.chooseFromFileSystem);
        $(document).on('click', '#view-task .attachment', self.openAttachment);
        $(document).on('click', '#view-task #task-due-date', self.navigateToDueDateChange);
        $(document).on('click', '#view-task #duo-date-info', self.navigateToDueDateChange);
        $(document).on("click", "#view-task #add-effort", self.navigateToAddEffort);
        $(document).on("click", "#view-task .view-task-permission-list", self.viewItemVisibleToggle);
        $(document).on('click', '#view-task .popup-menu-backdrop', self.closeFloatButtonAttachment);
        $(document).on('click', '#view-task #view-task-take-photo', function() {
            self.closeFloatButtonAttachment();
            self.takePhoto();
        });

        $(document).on('click', '#view-task #view-task-choose-image', function(){
            self.closeFloatButtonAttachment();
            self.chooseFromFileSystem();
        });

        $(document).on('click', '#view-task #owner-info', self.setOwnerForTask);
        $(document).on('click', '#view-task .add-new-permission-user', self.changePermission);
        $(document).on('click', '#view-task .visible-user-item', self.removePersonPermission);
    };

    self.unbindElementControls = function () {
        $(document).off('click', '#view-task #back-link');
        $(document).off('click', '#view-task #view-task-general-link');
        $(document).off('click', '#view-task #view-task-notes-link');
        $(document).off('click', '#view-task #view-task-tasks-list .task-item');
        $(document).off('click', "#view-task #view-task-notes-list .note");
        $(document).off('click', '#view-task #check-tasks');
        $(document).off('click', '#view-task #status-info');
        $(document).off('click', '#view-task .task-status-uncompleted');
        $(document).off('click', '#view-task #parent-info');
        $(document).off('click', '#task-more-link');
        $(document).off('click', '#edit-tasks');
        $(document).off('click', '#delete-tasks');
        $(document).off('click', '#view-task .float-add-action');
        $(document).off('click', '#view-task .task-list-icons');
        $(document).off('click', '#view-task #task-completion-info');
        $('#view-task .popup-menu-backdrop').off('click');
        $("body").off("swipeleft", "#view-task");
        $("body").off("swiperight", "#view-task");
        $("body").off("swipeup", '#' + $.mobile.activePage.attr('id'));
        $("body").off("swipedown", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollstart", '#' + $.mobile.activePage.attr('id'));
        $("body").off("scrollend", '#' + $.mobile.activePage.attr('id'));
        $(document).off('click', "#view-task #view-task-tasks-link");
        $(document).off('change', '#view-task #filter-tasks-task-type');
        $(document).off('click', '#view-task #view-task-tasks-list .createdTask');
        $(document).off('click', '#view-task #view-task-tasks-list .assignedTask');
        $(document).off('click', '#view-task #view-task-tasks-list .completedTask');
        $(document).off('click', '#view-task #view-task-tasks-list .canceledTask');
        $(document).off('click', '#view-task #view-task-tasks-list .inprogressTask');
        $(document).off("click", "#view-task .task-due-date-change");
        $(document).off('click', '#view-task .comment-container');
        $(document).off('click', '#view-task #favorite-tasks');
        $(document).off('click', '#view-task #favorite-tasks-mouseover');
        $(document).off("click", "#view-task .view-item-history");
        $(document).off('click', '#view-task #view-task-attach-add-link');
        $(document).off('click', '#view-task #view-task-attach-link');
        $(document).off('click', '#view-task .delete-item');
        $(document).off('click', '#view-task #view-task-add-link');
        $(document).off('click', '#view-task #take-photo');
        $(document).off('click', '#view-task #choose-from-gallery');
        $(document).off('click', '#view-task .attachment');
        $(document).off('click', '#view-task #task-due-date');
        $(document).off('click', '#view-task #duo-date-info');
        $(document).off("click", "#view-task .efforts-container");
        $(document).off("click", "#view-task #add-effort");
        $(document).off("click", "#view-task .view-task-permission-list");
        $(document).off('click', '#view-task .float-add-action');
        $(document).off('click', '#view-task .popup-menu-backdrop');
        $(document).off('click', '#view-task #view-task-take-photo');
        $(document).off('click', '#view-task #view-task-choose-image');
        $(document).off('click', '#view-task #priority-info');
        $(document).off('click', '#view-task #author-info');
        $(document).off('click', '#view-task #owner-info');
        $(document).off('click', '#view-task .add-new-permission-user');
        $(document).off('click', '#view-task .visible-user-item');
        task = null;
    };

    self.removePersonPermission = function() {
      var identity = $(this).attr('data-identity');
      task.objectType = "Task";
      PermissionController.removePermissionFromObject(identity, task, function(success){
        if (success) {
          $('.visible-user-item[data-identity=' + identity +']').remove();
          var visibleTo = [];
          for (var i = 0, max = task['visible-to'].length; i < max; i++) {
              if (task['visible-to'][i].identity != identity) {
                visibleTo.push(task['visible-to'][i]);
              }
          }
          task['visible-to'] = visibleTo;
        }
      });
    };

    self.openAuthorEvent = function () {
        var authorId = ALL_USERS[task['author-id'].text].person;
        var id = task.id.text;
        self.closeModalPanel();
        gotoPage({url: "viewContact", param: {contactId: authorId, contactType: "person"}}, {url: "viewTask", param: {'id': id, ids: taskIds, listParams: listParams}});
    };

    self.closeModalPanel = function () {
        $('#fullScreenModal').remove();
        $('body').css('overflow', 'auto');
        $('html').removeClass('modal-open');
        ViewTaskFunctions.unbindElementControls();
    };

    self.openFloatButtonAttachment = function () {
        $(this).toggleClass("rotation-event");
        $('#view-task .popup-menu-backdrop').toggle();
        $('#view-task .menu-more-option').toggle();
    };

    self.closeFloatButtonAttachment = function() {
        $('#view-task .menu-more-option').hide();
        $('#view-task .float-add-action').removeClass("rotation-event");
        $(this).hide();
        $('.float-add-action').show();
    };

    self.viewItemVisibleToggle =  function (event) {
          $('html, body').animate({scrollTop: $(document).height()}, 'slow');
          $("i", this).toggleClass("md-keyboard-arrow-up md-keyboard-arrow-down");
          $('#' + $(this).attr('container')).toggleClass('hide');
    };

    self.gotoDueDateChange = function () {
        var idTask = $(this).attr("taskid");
        var dueDate = $(this).attr("duedate");
        gotoPage({
            url: "changeDueDate",
            controller: ChangeDueDateFunctions,
            isModal: true,
            param: {id: idTask, dueDate: dueDate}
        }, {url: "viewTask", controller: ViewTaskFunctions, param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.drawTaskList = function () {
        self.currentTab = "Task";
        $("#view-task .filter-container").show();
        self.activateTab("Tasks");
        $attachContainer.hide();
        $addLink.show();
        $generalContent.hide();
        $notesContent.hide();
        $("#view-task #task-more-link").hide();
        $("#view-task #view-task-tasks-content").show();
        self.filterTasks();
    };

    self.taskCountLink = function (request) {
        if (connection) {
            request = typeof request !== 'undefined' ? request : {objectType: "Task", immediateParent: new ObjectId(taskId), status: {$nin: ["Completed", "Canceled", "Verified"]}};
            ClientAPI.findCount(request, function (err, data) {
                if (!err) {
                    $taskTasksText.html("(" + data + ")");
                }
            });
        }
    };

    self.gotoTask = function () {
        var id = null;
        var ids = [];

        id = $(this).attr('taskId');
        $(document).find("#view-task #view-task-tasks-list .task-item").each(function () {
            ids.push($(this).attr('taskId'));
        });
        taskId = id;
        taskIds = ids;
        if(!listParams){
            listParams = {};
            listParams.start = 30;
            listParams.offset = 30;
        }
        listParams.parentId = task.id.text;
        listParams.taskType = "TaskChildren";
        self.init();
    };

    self.completeTaskEvent = function () {
        var id = $(this).attr('taskId');
        gotoPage({url: "changeStatus", param: {parentId: id, parentType: "Task"}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.swipeRightEvent = function () {
        if (taskIds && taskIds.length > 1) {
            currentTaskIndex--;
            currentTaskIndex = (currentTaskIndex < 0) ? (taskIds.length - 1) : currentTaskIndex;
            taskId = taskIds[currentTaskIndex];
            self.init();
        }
    };

    self.swipeLeftEvent = function () {
        if (taskIds && taskIds.length > 1) {
            currentTaskIndex++;
//            currentTaskIndex = (currentTaskIndex > taskIds.length - 1) ? 0 : currentTaskIndex;
            if (currentTaskIndex > taskIds.length - 1) {
                var nextPage = listParams.start / listParams.offset + 1;
                if(listParams.childPage && listParams.childPage > 1){
                    nextPage = listParams.childPage;
                }
                if (connection && !listParams.favorite) {
                    var query = {objectType: "Task"};
                    var myTasksFilter = [{assignedTo: window.localStorage.getItem('userId')}, {
                            assignedTo: {$exists: false},
                            owner: window.localStorage.getItem('userId')
                        }, {assignedTo: {$type: 10}, owner: window.localStorage.getItem('userId')}];
                    var completedTasks = ["Completed", "Canceled", "Verified"];
                    if (listParams.parentId) {
                        query.immediateParent = new ObjectId(listParams.parentId);
                    }
                    if (listParams.taskType == "Upcoming") {
                        query['status'] = {$nin: completedTasks};
                    } else if (listParams.taskType == "Assigned") {
                        query['$and'] = [
                            {assignedTo: {$ne: window.localStorage.getItem('userId')}},
                            {$or: [
                                    {creator: window.localStorage.getItem('userId')},
                                    {owner: window.localStorage.getItem('userId')}
                                ]}
                        ];
                        query['status'] = {$ne: "Completed"};
                    } else if (listParams.taskType == "Completed") {
                        query['status'] = {$in: completedTasks};
                    } else if (listParams.taskType == "MyUpcoming") {
                        query.$or = myTasksFilter;
                        query.status = {$nin: completedTasks};
                    } else if (listParams.taskType == "MyCompleted") {
                        query.$or = myTasksFilter;
                        query.status = {$in: completedTasks};
                    }
                    var dueDateSort = 1;
                    if (listParams.taskType == "Completed" || listParams.taskType == "MyCompleted") {
                        dueDateSort = -1;
                    }
                    var sort = [["dueDate", dueDateSort]];
                    ClientAPI.findPaged(query, sort,
                            nextPage,
                            listParams.offset,
                            function (err, items) {
                                if (items.length == 0) {
                                    currentTaskIndex = 0;
                                }
                                for (var i = 0, max = items.length; i < max; i++) {
                                    taskIds.push(TaskController.encodeItem(items[i]).id.text);
                                }
                                if(listParams.childPage){
                                    listParams.childPage++;
                                } else {
                                    listParams.start += listParams.offset;
                                }
                                taskId = taskIds[currentTaskIndex];
                                self.init();
                            });
                } else {
                    currentTaskIndex = 0;
                    taskId = taskIds[currentTaskIndex];
                    self.init();
                }
            } else {
                taskId = taskIds[currentTaskIndex];
                self.init();
            }
        }
    };

    self.openTaskOptionsPopup = function () {
        $(".navigation_button").hide();
        $('#view-task .popup-menu-backdrop').toggle();
        $('#view-task .advanced-menu').css('z-index', '20000');
        $('#view-task .advanced-menu').slideToggle('4000', 'swing');
    };

    self.taskDeleteLinkEvent = function () {
        $("#view-task .popup-menu-backdrop").hide();
        $taskPopup.hide();
        setTimeout(function () {
            showActionDialog(Messages.Task.deleteTaskMessage, "Yes", self.deleteTask, "No", function () {
            });
        }, 100);
    };

    self.onPullDown = function () {
        if ($("ul:visible li", '#' + $.mobile.activePage.attr('id')).first().visible()) {
            if ($(".house-icon-current", '#view-task').length == 1) {
                self.init();
            } else {
                // self.drawNotes();
            }
        }
    };

    self.onPullUp = function () {
        if ($("#view-task-notes-list li", '#' + $.mobile.activePage.attr('id')).last().visible()) {
            if ($(".house-icon-current", '#view-task').length == 1) {
                self.init();
            } else {
                self.listScrollLoad();
            }
        }
    };

    self.openParent = function () {
        var parentId = $(this).attr("parentid");
        var parentType = $(this).attr("parenttype");

        if (parentType == "Person" || parentType == "Company") {
            ContactFunctions.openContact(parentId, parentType.toLowerCase());
        } else if (parentType == "Project") {
            gotoPage({url: "viewCase", param: {caseId: parentId}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
        } else if (parentType == "Deal") {
            gotoPage({url: "viewDeal", param: {id: parentId}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
        } else if (parentType == "Note") {
            gotoPage({url: "viewNote", param: {noteId: parentId}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
        } else if (parentType === "Task") {
            taskId = parentId;
            taskIds = [];
            self.init();
        }
    };

    self.drawGeneral = function () {
        $attachContainer.hide();
        $addLink.hide();
        $secondNavigationContainer.show();
        self.currentTab = 'General';
        var i, max;
        $tasksMoreLink.show();
        $generalContent.show();
        $notesContent.hide();
        $("#view-task #view-task-tasks-content").hide();
        self.activateTab("General");

        if (connection) {
            if (task["recording-id"] != null && task["recording-id"].text != null && task["recording-id"].text != "") {
                ClientAPI.find({_id: new ObjectId(task["recording-id"].text)}, null, function (err, data) {
                    if (data != null && data[0] != null) {
                        var type = data[0].objectType.toLowerCase();
                        if (data[0].objectType === "Company") {
                            title = data[0].companyName;
                        } else if (data[0].objectType === "Person") {
                            var fname = typeof data[0].firstName != 'object' ? data[0].firstName : "";
                            var lname = typeof data[0].lastName != 'object' ? data[0].lastName : "";
                            title = fname + " " + lname;
                        } else if (data[0].objectType === "Project") {
                            type = "case";
                            title = title = data[0].projectName;
                        } else if (data[0].objectType === "Deal") {
                            title = title = data[0].dealName;
                        } else if (data[0].objectType === "Note") {
                            title = title = data[0].note;
                        } else if (data[0].objectType === "Task") {
                            if (data[0].taskName) {
                                title = data[0].taskName;
                            } else {
                                title = data[0].taskDescription;
                            }
                        }
                        $parentHeading.text("Task on " + type);
                        $parentDescription.text(title);
                        $parentDescription.attr("parentid", data[0]._id);
                        $parentDescription.attr("parenttype", data[0].objectType);
                        $("#parent-info-container").show();
                    } else {
                        $("#parent-info-container").hide();
                    }
                });
            } else {
                $("#parent-info-container").hide();
            }
        } else {
            if (task['subjectDes'] && task['subject-name'] && task['recording-id'] && task['recording-type']) {
                var type = task['subjectDes'].split(":");
                $parentHeading.text("Task on " + type[0]);
                $parentDescription.text(task['subject-name']);
                $parentDescription.attr('parentid', task['recording-id'].text);
                $parentDescription.attr('parenttype', task['recording-type']);
            } else {
              $("#parent-info-container").hide();
            }
        }
        if (task.body) {
            $bodyDescription.html(task.body);
            $bodyBox.show();
        } else {
            $bodyBox.hide();
        }

        if (task.name && task.name != "") {
            var taskTile = htmlStrip(task.name);
            if (taskTile.length > 30) {
                taskTile = taskTile.substr(0, 30) + "...";;
            }
            $("#view-task #task-title").html("("+task.entityId +") " + taskTile);
        } else {
            var taskTile = htmlStrip(task.body);
            if (taskTile.length > 30) {
                taskTile = taskTile.substr(0, 30) + "...";
            }
            $("#view-task #task-title").html("("+task.entityId +") " + taskTile);
        }

        if (task["responsible-id"] != null && task["responsible-id"].text != null && task["responsible-id"].text != "") {
            //zamjena ownera
            $("#owner-info-container").show();
            if (ALL_USERS[task["responsible-id"].text]) {
                $ownerDescription.html(ALL_USERS[task["responsible-id"].text].name);
            } else {
                $ownerDescription.html("NONE");
            }
        } else {
            $("#owner-info-container").hide();
        }

        if (task["author-id"] != null && task["author-id"].text != null && task["author-id"].text != "") {
            $("#author-info-container").show();
            $authorDescription.html(ALL_USERS[task["author-id"].text].name);
        } else {
            $("#author-info-container").hide();
        }
        if (task.priority) {
          //zamjena prioriteta
            var taskPriorityClass = "green";
            if(task.priority.toLowerCase() == "high"){
                taskPriorityClass = "red";
            }
            $("#priority-info-container").show();
            $priorityDescription.addClass(taskPriorityClass);
            $priorityDescription.html(task.priority);
        } else {
            $("#priority-info-container").hide();
        }
        $statusDescription.html(task.status);

        //zamjena statusa
        if (task.status == "Completed") {
            $dueDateHeading.html("Completed");
            $dueDateDescription.html(dateFormat(new Date(task["updated-at"].text)));
        } else {
            if (task['due-at'].text != null) {
                $dueDateHeading.html("Due date");
                var dueDateText = "";
                dueDateText = dateFormat(new Date(task['due-at'].text));
                $dueDateDescription.html(dueDateText);
            } else {
                $("#due-date-container").remove();
            }
        }


        if (task["category-id"] != null && task["category-id"].text != null && task["category-id"].text != "") {
            var category = taskCategories.filter(function (o) {
                return o.id.text === task["category-id"].text;
            });
            if (category[0] != null && category[0].name) {
                $categoryDescription.html(category[0].name);
            } else {
                $("#category-info-container").remove();
            }
        } else {
            $("#category-info-container").remove();
        }

        if (task['created-at'] != null && task['created-at'].text != null &&
         task['created-at'].text != "" &&
         task.status != "Completed" &&
         task.status != "Canceled") {
            var currentDate = new Date();
            var creationDate = new Date(task['created-at'].text);
            var daysOpened = currentDate - creationDate;
            daysOpened = Math.ceil(daysOpened / (1000 * 3600 * 24));
            $("#view-task #days-opened-info").text(daysOpened);
            $("#view-task #days-opened-info-container").show();
        } else {
            $("#view-task #days-opened-info-container").hide();
        }

        $("#view-task #task-completion-info").text(task['percent-completed'] + " %");
        $("#view-task #task-completion-container").show();
        $viewTasksPermissionList.empty();
        var htmlUser = PermissionController.drawPermissionForObject(task);
        if (htmlUser != "") {
            $viewTasksPermissionList.empty().append(htmlUser);
        } else {
            $("#view-task-permission-list").remove();
        }
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');

        if (task.efforts) {
            EffortService.loadEffort(task.id.text, "Task", "view-task", null, false);
            // $effortTable.removeClass('unseen').addClass('seen');
            $effortCount.text(task.efforts + " h");
            $effortCount.addClass('margin-right-ten');
        } else {
            // $effortTable.removeClass('seen').addClass('unseen');
        }
    };


    self.drawNotes = function () {
        self.currentTab = "Note";
        $secondNavigationContainer.hide();
        $addLink.show();
        $generalContent.hide();
        $tasksMoreLink.hide();
        $attachContainer.hide();
        $("#view-task #view-task-tasks-content").hide();
        $notesContent.show();
        self.activateTab("Note");

        showLoadingIndikator();
        if (connection) {
            ViewNoteFunctions.drawListParams['view-task-notes-list'] = {
                'start': 0,
                'offset': offset
            };

            ClientAPI.findPaged({immediateParent: new ObjectId(task.id.text), objectType: "Note"},
                    [['modificationDate', -1]],
                    1, offset,
                    function (err, items) {
                        if (!err) {
                            var notes = [];
                            for (var i = 0, max = items.length; i < max; i++) {
                                notes.push(items[i]);
                            }

                            ViewNoteFunctions.drawNote('view-task-notes-list', notes, false);

                        }

                        hideLoadingIndikator();
                    });
        } else {
            $notesTab.text('(0)');
            $('#view-task-notes-list').empty();
            ViewNoteFunctions.drawNote('view-task-notes-list', [], false);
            hideLoadingIndikator();
        }
        $("[data-position='fixed']").fixedtoolbar('updatePagePadding');
    };

    self.filterTasks = function () {
        var filterValue = $("#view-task #filter-tasks-task-type").val();
        $("#view-task #view-task-tasks-list").empty();
        switch (filterValue) {
            case "filter-task-upcoming-tasks":
                if (connection) {
                    var request = {objectType: "Task", immediateParent: new ObjectId(taskId), status: {$nin: ["Completed", "Canceled", "Verified"]}};
                    self.taskCountLink(request);
                    ClientAPI.findPaged(request, [["dueDate", 1]], 1, offset, function (err, items) {
                        var tasks = [];
                        for (var i = 0; i < items.length; i++) {
                            tasks.push(TaskController.encodeItem(items[i]));
                        }
                        TaskFunctions.drawTaskListView("view-task-tasks-list", tasks, "Upcoming", false);
                        $("#view-task .childTasks").hide();
                    });
                } else {
                    db.selectByQuery('SELECT * FROM ' + models.taskDBModel.name + ' WHERE (status = ? OR status = ? OR status = ?) AND "recording-type" =? AND "recording-id" = ?',
                            ["Created", "Assigned", "InProgress", 'Task', getTextTypeObject(task.id.text, 'integer')], models.taskDBModel.name, function (items) {
                        TaskFunctions.drawTaskListView("view-task-tasks-list", items, "Upcoming", false);
                        $("#view-task .childTasks").hide();
                    });
                }
                break;
            case "filter-task-completed-tasks":
                if (connection) {
                    var request = {objectType: "Task", immediateParent: new ObjectId(taskId), status: {$in: ["Completed", "Canceled", "Verified"]}};
                    self.taskCountLink(request);
                    ClientAPI.findPaged(request, [["dueDate", 1]], 1, offset, function (err, items) {
                        var tasks = [];
                        for (var i = 0; i < items.length; i++) {
                            tasks.push(TaskController.encodeItem(items[i]));
                        }
                        TaskFunctions.drawTaskListView("view-task-tasks-list", tasks, "Completed", false);
                        $("#view-task .childTasks").hide();
                    });
                } else {
                  TaskFunctions.drawTaskListView("view-task-tasks-list", [], "Upcoming", false);
                  $("#view-task .childTasks").hide();
                }
                break;
          case "filter-task-all-tasks":
            case "filter-task-recent-tasks":
              if (connection) {
                  var request = {objectType: "Task", immediateParent: new ObjectId(taskId)};
                  self.taskCountLink(request);
                  ClientAPI.findPaged(request, [["dueDate", 1]], 1, offset, function (err, items) {
                      var tasks = [];
                      for (var i = 0; i < items.length; i++) {
                          tasks.push(TaskController.encodeItem(items[i]));
                      }
                      TaskFunctions.drawTaskListView("view-task-tasks-list", tasks, "Upcoming", false);
                      $("#view-task .childTasks").hide();
                  });
              } else {
                  db.selectByQuery('SELECT * FROM ' + models.taskDBModel.name + ' WHERE "recording-type" =? AND "recording-id" = ?',
                          ['Task', getTextTypeObject(task.id.text, 'integer')], models.taskDBModel.name, function (items) {
                      TaskFunctions.drawTaskListView("view-task-tasks-list", items, "Upcoming", false);
                      $("#view-task .childTasks").hide();
                  });
              }
              break;
        }

    };

    self.listScrollLoad = function () {
        ViewNoteFunctions.drawListParams['view-task-notes-list']['start'] = ViewNoteFunctions.drawListParams['view-task-notes-list']['start'] + 1;
        var start = parseInt(ViewNoteFunctions.drawListParams['view-task-notes-list']['start'] / offset) + 1;

        showLoadingIndikator();
        if (connection) {
            ClientAPI.findPaged({immediateParent: new ObjectId(task.id.text), objectType: "Note"},
                    [['modificationDate', -1]], start, offset, function (err, items) {
                if (!err) {
                    var notes = [];
                    for (var i = 0, max = items.length; i < max; i++) {
                        notes.push(items[i]);
                    }

                    ViewNoteFunctions.drawNote('view-task-notes-list', notes, true);
                }
                hideLoadingIndikator();
            });
        }
    };

    self.editTask = function () {
        openFrom = "tasks";
        gotoPage({url: "editTask", param: {id: taskId, ids: taskIds}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});

    };

    self.openNote = function () {
        var noteId = $(this).attr('note-id');
        gotoPage({url: "viewNote", param: {noteId: noteId}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.deleteTask = function () {
        var requestObject = {
            "taskid": task.id.text,
            "body": task.body
        };

        TaskController.deleteTask(task.id.text, function (data) {
            if (data == 0) {
                //delete task item from calendar
                var taskStartDate = new Date(task['due-at'].text);
                taskStartDate.setHours(8, 0, 0, 0);
                var taskEndDate = new Date(task['due-at'].text);
                taskEndDate.setHours(8, 15, 0, 0);
                deleteCalendarEvent(task.body, taskStartDate, taskEndDate);
                db.selectSingleRecord(models.infoMessageDBModel.name, "body", requestObject, function (data) {
                    if (data != null && data.infoMessage != null) {
                        var messageId = data.infoMessage._id;
                        db.deleteObject(models.infoMessageDBModel.name, "_id", messageId);
                        SipMessageSettingFunctions.setMessageStatus([{'messageid': messageId, 'status': 5}]);
                    }
                });
                self.syncAndGoBack();
            } else {
                alert(Messages.Task.deleteTaskMessageErr);
            }
        });
    };

    self.syncAndGoBack = function () {
        self.currentT = 'General';
        showLoadingIndikator();
        COMPLETED.length = 0;
        UPCOMING_TASKS.length = 0;
        UPCOMING_OVERDUE.length = 0;
        ASSIGNED_TASKS.length = 0;
        ASSIGNED_OVERDUE.length = 0;
        validationCheck = false;
        SyncSipController.syncSipMessage();
        self.backLinkEvent();
    };

    self.setStatusForTask = function () {
        gotoPage({url: "changeStatus", param: {parentId: taskId, parentType: "Task"}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };
    self.setProgressForTask = function () {
        gotoPage({url: "changeProgress", param: {parentId: taskId, parentType: "Task"}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.setPriorityForTask = function() {
      gotoPage({url: "changePriority", param: {parentId: taskId, parentType: "Task"}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };
    self.setOwnerForTask = function () {
        gotoPage({url: "changeOwner", param: {"id": taskId, type: "Task"}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.changePermission = function(){
        gotoPage({url: "changePermission", param: {"id": taskId, type: "Task"}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.backLinkEvent = function () {
        goBack();
    };

    self.setConnectionMode = function () {
    };

    self.drawNoteComments = function () {
        var noteId = $(this).attr('noteId');
        ViewNoteFunctions.drawCommentList(noteId, function () {
            $('#' + noteId).toggle();
        });
    };

    self.setAsFavorite = function() {
       var isFavorite = $('.md-star').hasClass('contact-favorite-star');
       TaskController.findByObjectId(taskId, function(item){
           if (isFavorite) {
                FavoriteController.findByObjectIdDB(taskId , function(data){
                   if (data[0]) {
                       FavoriteController.removeFavorite(data[0].id, function(){
                           $('.md-star').toggleClass("contact-favorite-star");
                       });
                   }
                });
           } else {
               FavoriteController.save("Task", item, function(){
                   $('.md-star').toggleClass("contact-favorite-star");
               });
           }
       });
   }

    self.loadItemHistory = function (feedItems) {
        var html = "";
        $("#view-task .history-list").empty();
        for (var i = 0; i < feedItems.length; i++) {
            var eventType = "";
            if (feedItems[i].eventType.toLowerCase() != "statustransition") {
                eventType = feedItems[i].eventType.toLowerCase();
            } else {
                eventType = " changed status of";
            }
            html += "<li>"
                    + "<div style='margin-bottom: 5px;'><b>" + feedItems[i].user_name + "</b> "
                    + eventType + " task"
                    + "</div>";

            if (feedItems[i].allChanges && feedItems[i].eventType.toLowerCase() != "create") {
                for (var key in feedItems[i].allChanges) {
                    var descText = "";
                    var entered = false;
                    switch (key) {
                        case "taskName":
                            descText = "Name";
                            entered = true;
                            break;
                        case "taskDescription":
                            descText = "Description";
                            entered = true;
                            break;
                        case "status":
                            descText = "Status ";
                            entered = true;
                            break;
                        case "immediateParentDisplay":
                            descText = "Related to";
                            entered = true;
                            break;
                        case "assignedTo":
                            descText = "Assignee";
                            entered = true;
                            break;
                        case "efforts":
                           descText = "Efforts";
                           entered = true;
                           break;
                    }
                    if (entered) {
                        if (key == "assignedTo" && feedItems[i].allChanges[key].newValue != "null" && ALL_USERS[feedItems[i].allChanges[key].newValue]) {
                            html += "<div style='margin-bottom: 5px;'>"
                                    + "<span>" + descText + "</span> changed to " + "<span style='color: #2A66D9;'>" + ALL_USERS[feedItems[i].allChanges[key].newValue].name + "</span>"
                                    + "</div>";
                        } else {
                            var showItem = htmlStrip(feedItems[i].allChanges[key].newValue);
                            html += "<div style='margin-bottom: 5px;'>"
                                    + "<span>" + descText + "</span> changed to " + "<span style='color: #2A66D9; word-break: break-all;'>" + showItem + "</span>"
                                    + "</div>";
                        }
                    }
                }
                if (feedItems[i].trackedChanges && feedItems[i].trackedChanges.assignedTo) {
                    if (feedItems[i].trackedChanges.assignedTo.oldValue) {
                        html += "<div style='margin-bottom: 5px;'> Old assignee: " + "<b>" + feedItems[i].trackedChanges.assignedTo.oldValue + "</b></div>";
                    }
                    if (feedItems[i].trackedChanges.assignedTo.newValue) {
                        html += "<div style='margin-bottom: 5px;'> New assignee: " + "<b>" + feedItems[i].trackedChanges.assignedTo.newValue + "</b></div>";
                    }

                }
            }
            html += "<div>" + dateFormat(new Date(feedItems[i].eventDate)) + ", " + timeFormat(new Date(feedItems[i].eventDate)) + "h</div>"
                    + "</li>";

        }
        if (html != "") {
            $("#view-task .history-list").append(html);
        }
    };

    self.loadElement = function () {
        if (self.currentTab == 'Note') {
            self.drawNotes();
        } else if (self.currentTab == 'Tasks') {
            self.drawTaskList();
        } else {
            self.drawGeneral();
        }

        ClientAPI.findCount({immediateParent: new ObjectId(taskId), objectType: "Note"}, function (err, data) {
            $notesTab.text('(' + data + ')');
        });

        self.taskCountLink();
        hideLoadingIndikator();
    };

    self.addLinkEvent = function () {
        switch (self.currentTab) {
            case "Task":
                gotoPage({url: "editTask", param: {parentId: task.id.text, parentType: "Task", accessList: task["visible-to"]}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
                break;
            case "Note":
                gotoPage({url: "editNote", param: {parentId: task.id.text, parentType: "task", accessList: task["visible-to"]}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
                break;
            case "Attachment":
                $('#view-task .popup-menu-backdrop').toggle();
                $('#view-task .attach-advanced-menu').css('z-index', '20000');
                $('#view-task .attach-advanced-menu').slideToggle('4000', 'swing');
                break;
        }
    };

    self.getAttachmentCount = function (callback) {
        if (connection) {
            ClientAPI.aggregate([{$match:
                            {$or:
                                        [
                                            {_id: new ObjectId(task.id.text)},
                                            {immediateParent: new ObjectId(task.id.text)}
                                        ]
                            }
                },
                {$project:
                            {
                                "fileAttachments": 1,
                                "objectType": 1,
                                "taskName": 1,
                                "note": 1,
                                "projectName": 1
                            }
                }], function (err, data) {
                if (data && data.length > 0) {
                    var attachedElem = data.filter(function (value) {
                        return value.objectType == "Task" || value.objectType == "Note";
                    });
                    var attachments = [];
                    var attachCounter = 0;
                    for (var i = 0; i < attachedElem.length; i++) {
                        if (attachedElem[i].fileAttachments && attachedElem[i].fileAttachments.length > 0) {
                            var attachObject = {};
                            attachObject.id = attachedElem[i]["_id"];
                            attachObject.files = attachedElem[i].fileAttachments;
                            attachCounter += attachedElem[i].fileAttachments.length;
                            attachments.push(attachObject);
                        }
                    }
                }
                if (callback && typeof callback == "function") {
                    callback(attachCounter, attachments);
                }

            });
        }
    };

    self.loadAttachment = function () {
        self.currentTab = "Attachment";
        $generalContent.hide();
        $notesContent.hide();
        $tasksMoreLink.hide();
        $addLink.show();
        $("#view-task #view-task-tasks-content").hide();
        $attachContainer.show();
        self.activateTab("Attachment");
        AttachmentController.drawList("#view-task-attach-list", attachments);
    };

    self.deleteAttachment = function () {
        var fileName = $(this).attr('attachmentName');
        var parentId = $(this).attr('parentId');
        AttachmentController.deleteAttachment(parentId, fileName, ViewTaskFunctions);
    };

    self.takePhoto = function () {
        AttachmentController.takePhoto("#view-task", task.id.text, "#view-task-attach-list", "#view-task-attach-link-text" , ViewTaskFunctions);
    };

    self.chooseFromFileSystem = function () {
        $("#view-task .popup-menu-backdrop").hide();
        gotoPage({url: "fileSystem", param: {parentId: task.id.text, parentType: "Task"}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.openAttachment = function () {
        var url = $(this).attr("url");
        var parentId = $(this).attr('parentId');
        var attachmentName = $(this).attr('attachmentName');
        AttachmentController.openAttachment(url, parentId, attachmentName);
    };

    self.navigateToDueDateChange = function(){
        gotoPage({url: "changeDueDate", param:{id: task.id.text, dueDate: task['due-at'].text}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    self.getCompleteEffort = function ($elem) {
        ClientAPI.getEffortCount({query: {_id: new ObjectId(task.id.text)}}, function (err, effortCount) {
            if (!err) {
                $elem.text(effortCount[0].effort + " h");
            } else {
                return;
            }
        });
    };

    self.navigateToAddEffort = function () {
        gotoPage({url: "effort", param: {relatedId: task.id.text, relatedType: "Task", displayName: task.name,relatedCreationDate: task['created-at'].text}}, {url: "viewTask", param: {id: taskId, ids: taskIds, listParams: listParams}});
    };

    return self;
}(ViewTaskFunctions || {}));
